#include <gracelib.h>
#include <stdlib.h>
static char compilerRevision[] = "fda180857cfbe794cf5b4190f62470c38dba523a";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "ast";
Object module_StandardPrelude_init();
static char *originalSourceLines[] = {
  "#pragma DefaultVisibility=public",
  "import \"util\" as util",
  "import \"mgcollections\" as collections",
  "",
  "// This module contains pseudo-classes for all the AST nodes used",
  "// in the parser. The module predates the existence of classes in the",
  "// implementation, so they are written as object literals inside methods.",
  "// Each node has a different signature according to its function, but the",
  "// common interface is:",
  "// dtype ASTNode {",
  "//   kind -> String // Used for pseudo-instanceof tests.",
  "//   register -> String // Used later on to hold the LLVM register of",
  "//                      // the resulting object.",
  "//   line -> Number // The source line the node came from.",
  "//   pretty(n:Number) -> String // Pretty-print of node at depth n,",
  "// }",
  "// Most also contain \"value\", with varied dtypes, holding the main value",
  "// in the node. Some contain other fields for their specific use: while has",
  "// both a value (the condition) and a \"body\", for example. None of the nodes",
  "// are particularly notable in any way.",
  "",
  "method listMap(l, b)before(blkBefore)after(blkAfter) {",
  "    def r = collections.list.new",
  "    for (l) do {v->",
  "        def replacement = v.map(b)before(blkBefore)after(blkAfter)",
  "        r.push(replacement)",
  "    }",
  "    r",
  "}",
  "method maybeMap(n, b, before, after) {",
  "    if (n != false) then {",
  "        return n.map(b)before(before)after(after)",
  "    }",
  "    n",
  "}",
  "",
  "class baseNode.new {",
  "    var register := \"\"",
  "    var line := util.linenum",
  "    var linePos := util.linepos",
  "    var lineLength := 0",
  "}",
  "",
  "class forNode.new(over, body') {",
  "    inherits baseNode.new",
  "    def kind = \"for\"",
  "    def value = over",
  "    def body = body'",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitFor(self)) then {",
  "            self.value.accept(visitor)",
  "            self.body.accept(visitor)",
  "        }",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"For\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth+1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ \"Do:\"",
  "        s := s ++ \"\\n\" ++ spc ++ \"  \" ++ self.body.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"for ({self.value.toGrace(0)}) do \"",
  "        s := s ++ self.body.toGrace(depth)",
  "        s",
  "    }",
  "}",
  "class whileNode.new(cond, body') {",
  "    inherits baseNode.new",
  "    def kind = \"while\"",
  "    def value = cond",
  "    def body = body'",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitWhile(self)) then {",
  "            self.value.accept(visitor)",
  "            for (self.body) do { x ->",
  "                x.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"While\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth+1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ \"Do:\"",
  "        for (self.body) do { x ->",
  "            s := s ++ \"\\n  \"++ spc ++ x.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"while \\{{self.value.toGrace(depth + 1)}\\} do \\{\"",
  "        for (self.body) do { x ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ x.toGrace(depth + 1)",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "}",
  "class ifNode.new(cond, thenblock', elseblock') {",
  "    inherits baseNode.new",
  "    def kind = \"if\"",
  "    def value = cond",
  "    def thenblock = thenblock'",
  "    def elseblock = elseblock'",
  "    var handledIdentifiers := false",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitIf(self)) then {",
  "            self.value.accept(visitor)",
  "            for (self.thenblock) do { ix ->",
  "                ix.accept(visitor)",
  "            }",
  "            for (self.elseblock) do { ix ->",
  "                ix.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        def v = self.value.map(blk)before(blkBefore)after(blkAfter)",
  "        def tb = listMap(self.thenblock, blk)before(blkBefore)after(blkAfter)",
  "        blkAfter.apply(self)",
  "        blkBefore.apply(self)",
  "        def eb = listMap(self.elseblock, blk)before(blkBefore)after(blkAfter)",
  "        var n := ifNode.new(v, tb, eb)",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"If\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth+1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ \"Then:\"",
  "        for (self.thenblock) do { ix ->",
  "            s := s ++ \"\\n  \"++ spc ++ ix.pretty(depth+2)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ \"Else:\"",
  "        for (self.elseblock) do { ix ->",
  "            s := s ++ \"\\n  \"++ spc ++ ix.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"if ({self.value.toGrace(0)}) then \\{\"",
  "        for (self.thenblock) do { ix ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ ix.toGrace(depth + 1)",
  "        }",
  "        if (self.elseblock.size > 0) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"\\} else \\{\"",
  "            for (self.elseblock) do { ix ->",
  "                s := s ++ \"\\n\" ++ spc ++ \"    \" ++ ix.toGrace(depth + 1)",
  "            }",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "}",
  "class blockNode.new(params', body') {",
  "    inherits baseNode.new",
  "    def kind = \"block\"",
  "    def value = \"block\"",
  "    def params = params'",
  "    def body = body'",
  "    def selfclosure = true",
  "    var matchingPattern := false",
  "    var extraRuntimeData := false",
  "    for (params') do {p->",
  "        p.accept(patternMarkVisitor)",
  "    }",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitBlock(self)) then {",
  "            for (self.params) do { mx ->",
  "                mx.accept(visitor)",
  "            }",
  "            for (self.body) do { mx ->",
  "                mx.accept(visitor)",
  "            }",
  "            if (self.matchingPattern != false) then {",
  "                self.matchingPattern.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := blockNode.new(listMap(params, blk)before(blkBefore)after(blkAfter),",
  "            listMap(body, blk)before(blkBefore)after(blkAfter))",
  "        if (self.matchingPattern != false) then {",
  "            n.matchingPattern := self.matchingPattern.map(blk)",
  "                before(blkBefore)after(blkAfter)",
  "        }",
  "        n := blk.apply(n)",
  "        n.extraRuntimeData := extraRuntimeData",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Block\\n\"",
  "        s := s ++ spc ++ \"Parameters:\"",
  "        for (self.params) do { mx ->",
  "            s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+2)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ \"Body:\"",
  "        for (self.body) do { mx ->",
  "            s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+2)",
  "        }",
  "        if (self.matchingPattern != false) then {",
  "            s := s ++ \"\\n\"",
  "            s := s ++ spc ++ \"Pattern:\"",
  "            s := s ++ \"\\n  \"++ spc ++ self.matchingPattern.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"\\{\"",
  "        if (self.params.size > 0) then {",
  "            s := s ++ \" \"",
  "            for (self.params.indices) do { i ->",
  "                var p := self.params[i]",
  "                if (self.matchingPattern != false) then {",
  "                    s := s ++ \"(\" ++ p.toGrace(0) ++ \")\"",
  "                } else {",
  "                    s := s ++ p.toGrace(0)",
  "                }",
  "                if (i < self.params.size) then {",
  "                    s := s ++ \", \"",
  "                } else {",
  "                    s := s ++ \" ->\"",
  "                }",
  "            }",
  "        }",
  "        for (self.body) do { mx ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ mx.toGrace(depth + 1)",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "}",
  "class catchCaseNode.new(block, cases', finally') {",
  "    inherits baseNode.new",
  "    def kind = \"catchcase\"",
  "    def value = block",
  "    def cases = cases'",
  "    def finally = finally'",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitCatchCase(self)) then {",
  "            self.value.accept(visitor)",
  "            for (self.cases) do { mx ->",
  "                mx.accept(visitor)",
  "            }",
  "            if (self.finally != false) then {",
  "                self.finally.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := catchCaseNode.new(value.map(blk)before(blkBefore)after(blkAfter),",
  "            listMap(cases, blk)before(blkBefore)after(blkAfter),",
  "            maybeMap(finally, blk, blkBefore, blkAfter))",
  "        n.line := line",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Catch\\n\"",
  "        s := s ++ spc ++ value.pretty(depth + 2)",
  "        for (self.cases) do { mx ->",
  "            s := s ++ \"\\n{spc}Case:\\n{spc}  {mx.pretty(depth+2)}\"",
  "        }",
  "        if (false != self.finally) then {",
  "            s := s ++ \"\\n{spc}Finally:\\n{spc}  {self.finally.pretty(depth+2)}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"catch \" ++ self.value.toGrace(0) ++ \" \"",
  "        for (self.cases) do { case ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"case \" ++ case.toGrace(depth + 2)",
  "        }",
  "        if (self.finally != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"finally \" ++ self.finally.toGrace(depth + 2)",
  "        }",
  "        s",
  "    }",
  "}",
  "class matchCaseNode.new(matchee, cases', elsecase') {",
  "    inherits baseNode.new",
  "    def kind = \"matchcase\"",
  "    def value = matchee",
  "    def cases = cases'",
  "    def elsecase = elsecase'",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitMatchCase(self)) then {",
  "            self.value.accept(visitor)",
  "            for (self.cases) do { mx ->",
  "                mx.accept(visitor)",
  "            }",
  "            if (self.elsecase != false) then {",
  "                self.elsecase.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        def newcases = listMap(cases, blk)before(blkBefore)after(blkAfter)",
  "        var n := matchCaseNode.new(value.map(blk)before(blkBefore)after(blkAfter),",
  "            newcases,",
  "            maybeMap(elsecase, blk, blkBefore, blkAfter))",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Match\\n\"",
  "        s := s ++ spc ++ matchee.pretty(depth + 2)",
  "        for (self.cases) do { mx ->",
  "            s := s ++ \"\\n{spc}Case:\\n{spc}  {mx.pretty(depth+2)}\"",
  "        }",
  "        if (false != self.elsecase) then {",
  "            s := s ++ \"\\n{spc}Else:\\n{spc}  {self.elsecase.pretty(depth+2)}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"match(\" ++ self.value.toGrace(0) ++ \")\"",
  "        for (self.cases) do { case ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"case \" ++ case.toGrace(depth + 2)",
  "        }",
  "        if (self.elsecase != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"else \" ++ self.elsecase.toGrace(depth + 2)",
  "        }",
  "        s",
  "    }",
  "}",
  "class methodTypeNode.new(name', signature', rtype') {",
  "    // [signature]",
  "    //     object {",
  "    //         name := \"\"",
  "    //         params := []",
  "    //         vararg := false/identifier",
  "    //     }",
  "    //     object {",
  "    //         name := \"\"",
  "    //         params := []",
  "    //         vararg := false/identifier",
  "    //     }",
  "    //     ...",
  "    //     object {",
  "    //         ...",
  "    //     }",
  "    inherits baseNode.new",
  "    def kind = \"methodtype\"",
  "    def value = name'",
  "    def signature = signature'",
  "    def rtype = rtype'",
  "    var generics := []",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitMethodType(self)) then {",
  "            if (self.rtype != false) then {",
  "                self.rtype.accept(visitor)",
  "            }",
  "            for (self.signature) do { part ->",
  "                for (part.params) do { p ->",
  "                    p.accept(visitor)",
  "                }",
  "                if (part.vararg != false) then {",
  "                    part.vararg.accept(visitor)",
  "                }",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var rt := false",
  "        if (rtype != false) then {",
  "            rt := rtype.map(blk)before(blkBefore)after(blkAfter)",
  "        }",
  "        var n := methodTypeNode.new(value, listMap(signature, blk)before(blkBefore)after(blkAfter),",
  "            rt)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"MethodType\\n\"",
  "        s := \"{s}{spc}Name: {value}\\n\"",
  "        if (rtype != false) then {",
  "            s := \"{s}{spc}Returns:\\n  {spc}{rtype.pretty(depth + 2)}\\n\"",
  "        }",
  "        s := \"{s}{spc}Signature:\"",
  "        for (signature) do { part ->",
  "            s := \"{s}\\n  {spc}Part: {part.name}\"",
  "            s := \"{s}\\n    {spc}Parameters:\"",
  "            for (part.params) do { p ->",
  "                s := \"{s}\\n      {spc}{p.pretty(depth + 4)}\"",
  "            }",
  "            if (part.vararg != false) then {",
  "                s := \"{s}\\n    {spc}Vararg: {part.vararg.pretty(depth + 3)}\"",
  "            }",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"\"",
  "        for (self.signature) do { part ->",
  "            s := s ++ part.name",
  "            if ((part.params.size > 0) || (part.vararg != false)) then {",
  "                s := s ++ \"(\"",
  "                for (part.params.indices) do { pnr ->",
  "                    var p := part.params[pnr]",
  "                    s := s ++ p.toGrace(depth + 1)",
  "                    if ((pnr < part.params.size) || (part.vararg != false)) then {",
  "                        s := s ++ \", \"",
  "                    }",
  "                }",
  "                if (part.vararg != false) then {",
  "                    s := s ++ \"*\" ++ part.vararg.value",
  "                }",
  "                s := s ++ \")\"",
  "            }",
  "        }",
  "        if (self.rtype != false) then {",
  "            s := s ++ \" -> \" ++ self.rtype.toGrace(depth + 1)",
  "        }",
  "        s",
  "    }",
  "}",
  "class typeNode.new(name', methods') {",
  "    inherits baseNode.new",
  "    def kind = \"type\"",
  "    def value = name'",
  "    def methods = methods'",
  "    def unionTypes = []",
  "    def intersectionTypes = []",
  "    def annotations = collections.list.new",
  "    var generics := []",
  "    var nominal := false",
  "    var anonymous := false",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitType(self)) then {",
  "            if (self.unionTypes.size > 0) then {",
  "                for (self.unionTypes) do { ut ->",
  "                    ut.accept(visitor)",
  "                }",
  "            }",
  "            if (self.intersectionTypes.size > 0) then {",
  "                for (self.intersectionTypes) do { it ->",
  "                    it.accept(visitor)",
  "                }",
  "            }",
  "            for (self.methods) do { mx ->",
  "                mx.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := typeNode.new(value, listMap(methods, blk)before(blkBefore)after(blkAfter))",
  "        n := blk.apply(n)",
  "        n.anonymous := self.anonymous",
  "        n.line := line",
  "        for (listMap(unionTypes, blk)before(blkBefore)after(blkAfter)) do {a->",
  "            n.unionTypes.push(a.map(blk)before(blkBefore)after(blkAfter))",
  "        }",
  "        for (listMap(intersectionTypes, blk)before(blkBefore)after(blkAfter)) do {a->",
  "            n.intersectionTypes.push(a.map(blk)before(blkBefore)after(blkAfter))",
  "        }",
  "        for (listMap(generics, blk)before(blkBefore)after(blkAfter)) do {a->",
  "            n.generics.push(a.map(blk)before(blkBefore)after(blkAfter))",
  "        }",
  "        for (listMap(annotations, blk)before(blkBefore)after(blkAfter)) do {a->",
  "            n.annotations.push(a.map(blk)before(blkBefore)after(blkAfter))",
  "        }",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Type\\n\"",
  "        s := \"{s}{spc}Name: {value}\\n\"",
  "        if (generics.size > 0) then {",
  "            s := \"{s}{spc}Generic parameters:\\n\"",
  "            for (generics) do {ut->",
  "                s := \"{s}{spc}  {ut.value}\\n\"",
  "            }",
  "        }",
  "        if (unionTypes.size > 0) then {",
  "            s := \"{s}{spc}Union of:\\n\"",
  "            for (unionTypes) do {ut->",
  "                s := \"{s}{spc}  {ut.value}\\n\"",
  "            }",
  "        }",
  "        if (intersectionTypes.size > 0) then {",
  "            s := \"{s}{spc}Intersection of:\\n\"",
  "            for (intersectionTypes) do {it->",
  "                s := \"{s}{spc}  {it.value}\\n\"",
  "            }",
  "        }",
  "        s := s ++ spc ++ \"Methods:\"",
  "        for (methods) do { mx ->",
  "            s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+2)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"\"",
  "        def isanon = self.value.substringFrom(2)to(6) == \"Anon_\"",
  "        def isadhoc = (self.value.substringFrom(1)to(6) == \"Union<\") ||",
  "                      (self.value.substringFrom(1)to(13) == \"Intersection<\")",
  "        if (!isanon && !isadhoc) then {",
  "            s := \"type {self.value}\"",
  "            if (self.generics.size > 0) then {",
  "                s := s ++ \"<\"",
  "                for (self.generics.indices) do { i ->",
  "                    s := s ++ self.generics[i].value",
  "                    if (i < self.generics.size) then {",
  "                        s := s ++ \", \"",
  "                    }",
  "                }",
  "                s := s ++ \">\"",
  "            }",
  "            s := s ++ \" = \"",
  "        }",
  "        if (!isadhoc && (self.unionTypes.size == 0) &&",
  "            (self.intersectionTypes.size == 0)) then {",
  "            s := s ++ \"\\{\"",
  "        }",
  "        // TODO: what about e.g. \"(A & B) | C\"?",
  "        if (self.unionTypes.size > 0) then {",
  "            for (self.unionTypes.indices) do { i ->",
  "                s := s ++ self.unionTypes[i].toGrace(0)",
  "                if (i < self.unionTypes.size) then {",
  "                    s := s ++ \" | \"",
  "                }",
  "            }",
  "        } elseif (self.intersectionTypes.size > 0) then {",
  "            for (self.intersectionTypes.indices) do { i ->",
  "                s := s ++ self.intersectionTypes[i].toGrace(0)",
  "                if (i < self.intersectionTypes.size) then {",
  "                    s := s ++ \" & \"",
  "                }",
  "            }",
  "        }",
  "        for (self.methods) do { mx ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ mx.toGrace(depth + 1)",
  "        }",
  "        if (!isadhoc && (self.unionTypes.size == 0) &&",
  "            (self.intersectionTypes.size == 0)) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        }",
  "        s",
  "    }",
  "}",
  "class methodNode.new(name', signature', body', dtype') {",
  "    // [signature]",
  "    //     object {",
  "    //         name := \"\"",
  "    //         params := []",
  "    //         vararg := false/identifier",
  "    //     }",
  "    //     object {",
  "    //         name := \"\"",
  "    //         params := []",
  "    //         vararg := false/identifier",
  "    //     }",
  "    //     ...",
  "    //     object {",
  "    //         ...",
  "    //     }",
  "    inherits baseNode.new",
  "    def kind = \"method\"",
  "    def value = name'",
  "    def signature = signature'",
  "    def body = body'",
  "    var dtype := dtype'",
  "    var varargs := false",
  "    var generics := []",
  "    var selfclosure := false",
  "    def annotations = collections.list.new",
  "    var properties := collections.map.new",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitMethod(self)) then {",
  "            self.value.accept(visitor)",
  "            if (self.dtype != false) then {",
  "                self.dtype.accept(visitor)",
  "            }",
  "            for (self.signature) do { part ->",
  "                for (part.params) do { p ->",
  "                    p.accept(visitor)",
  "                }",
  "                if (part.vararg != false) then {",
  "                    part.vararg.accept(visitor)",
  "                }",
  "            }",
  "            for (self.body) do { mx ->",
  "                mx.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var dt := false",
  "        if (dtype != false) then {",
  "            dt := dtype.map(blk)before(blkBefore)after(blkAfter)",
  "        }",
  "        var n := methodNode.new(name', signature, listMap(body, blk)before(blkBefore)after(blkAfter), dt)",
  "        for (listMap(annotations, blk)before(blkBefore)after(blkAfter)) do {a->",
  "            n.annotations.push(a.map(blk)before(blkBefore)after(blkAfter))",
  "        }",
  "        for (listMap(generics, blk)before(blkBefore)after(blkAfter)) do {a->",
  "            n.generics.push(a.map(blk)before(blkBefore)after(blkAfter))",
  "        }",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method eachParameter(blk) {",
  "        for (signature) do {s->",
  "            for (s.params) do {p->",
  "                blk.apply(p)",
  "            }",
  "        }",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Method\\n\"",
  "        s := s ++ spc ++ \"Name: \" ++ self.value.pretty(depth+1)",
  "        s := s ++ \"\\n\"",
  "        if (false != self.dtype) then {",
  "            s := s ++ spc ++ \"Returns:\\n\" ++ spc ++ \"  \"",
  "            s := s ++ self.dtype.pretty(depth + 2) ++ \"\\n\"",
  "        }",
  "        s := \"{s}{spc}Signature:\"",
  "        for (signature) do { part ->",
  "            s := \"{s}\\n  {spc}Part: {part.name}\"",
  "            s := \"{s}\\n    {spc}Parameters:\"",
  "            for (part.params) do { p ->",
  "                s := \"{s}\\n      {spc}{p.pretty(depth + 4)}\"",
  "            }",
  "            if (part.vararg != false) then {",
  "                s := \"{s}\\n    {spc}Vararg: {part.vararg.pretty(depth + 3)}\"",
  "            }",
  "        }",
  "        s := s ++ \"\\n\"",
  "        if (false != generics) then {",
  "            s := \"{s}{spc}Generics:\"",
  "            for (generics) do {g->",
  "                s := \"{s}\\n{spc}  {g.pretty(0)}\"",
  "            }",
  "            s := s ++ \"\\n\"",
  "        }",
  "        if (annotations.size > 0) then {",
  "            s := \"{s}{spc}Annotations:\"",
  "            for (annotations) do {an->",
  "                s := \"{s}\\n{spc}  {an.pretty(depth + 2)}\"",
  "            }",
  "            s := s ++ \"\\n\"",
  "        }",
  "        s := s ++ spc ++ \"Body:\"",
  "        for (self.body) do { mx ->",
  "            s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method decType {",
  "        if (dtype == false) then {",
  "            return identifierNode.new(\"Unknown\", false)",
  "        }",
  "        return dtype",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"method \"",
  "        for (self.signature) do { part ->",
  "            s := s ++ part.name",
  "            if ((part.params.size > 0) || (part.vararg != false)) then {",
  "                s := s ++ \"(\"",
  "                for (part.params.indices) do { pnr ->",
  "                    var p := part.params[pnr]",
  "                    s := s ++ p.toGrace(depth + 1)",
  "                    if ((pnr < part.params.size) || (part.vararg != false)) then {",
  "                        s := s ++ \", \"",
  "                    }",
  "                }",
  "                if (part.vararg != false) then {",
  "                    s := s ++ \"*\" ++ part.vararg.value",
  "                }",
  "                s := s ++ \")\"",
  "            }",
  "        }",
  "        if (self.dtype != false) then {",
  "            s := s ++ \" -> {self.dtype.toGrace(0)}\"",
  "        }",
  "        if (self.annotations.size > 0) then {",
  "            s := s ++ \" is \"",
  "            s := s ++ self.annotations.reduce(\"\", { a,b ->",
  "                if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) })",
  "        }",
  "        s := s ++ \" \\{\"",
  "        for (self.body) do { mx ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ mx.toGrace(depth + 1)",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "}",
  "class callNode.new(what, with') {",
  "    // [with]",
  "    //     object {",
  "    //         name := \"\"",
  "    //         args := []",
  "    //     }",
  "    //     object {",
  "    //         name := \"\"",
  "    //         args := []",
  "    //     }",
  "    //     ...",
  "    //     object {",
  "    //         ...",
  "    //     }",
  "    inherits baseNode.new",
  "    def kind = \"call\"",
  "    def value = what",
  "    def with = with'",
  "    var generics := false",
  "    var isPattern := false",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitCall(self)) then {",
  "            self.value.accept(visitor)",
  "            for (self.with) do { part ->",
  "                for (part.args) do { arg ->",
  "                    arg.accept(visitor)",
  "                }",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := callNode.new(value.map(blk)before(blkBefore)after(blkAfter),",
  "            listMap(with, blk)before(blkBefore)after(blkAfter))",
  "        if (generics != false) then {",
  "            n.generics := listMap(generics, blk)before(blkBefore)after(blkAfter)",
  "        }",
  "        n.isPattern := isPattern",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Call\\n\"",
  "        s := s ++ spc ++ \"Method: {self.value.pretty(depth + 1)}\"",
  "        s := s ++ \"\\n\"",
  "        if (false != generics) then {",
  "            s := s ++ spc ++ \"  Generics:\\n\"",
  "            for (generics) do {g->",
  "                s := s ++ spc ++ \"    \" ++ g.pretty(0) ++ \"\\n\"",
  "            }",
  "        }",
  "        s := s ++ spc ++ \"Arguments:\"",
  "        for (self.with) do { part ->",
  "            s := s ++ \"\\n  \" ++ spc ++ \"Part: \" ++ part.name",
  "            for (part.args) do { arg ->",
  "                s := s ++ \"\\n    \" ++ spc ++ arg.pretty(depth + 3)",
  "            }",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"\"",
  "        // only the last member is the method call we need to handle",
  "        if (self.value.kind == \"member\") then {",
  "            var member := self.value",
  "            if (member.value.substringFrom(1)to(6) == \"prefix\") then {",
  "                s := member.value.substringFrom(7)to(member.value.size)",
  "                return s ++ member.in.toGrace(0)",
  "            }",
  "            s := member.in.toGrace(0) ++ \".\"",
  "        }",
  "        for (self.with) do { part ->",
  "            s := s ++ part.name",
  "            if (part.args.size > 0) then {",
  "                s := s ++ \"(\"",
  "                for (part.args.indices) do { anr ->",
  "                    var arg := part.args[anr]",
  "                    s := s ++ arg.toGrace(depth + 1)",
  "                    if (anr < part.args.size) then {",
  "                        s := s ++ \", \"",
  "                    }",
  "                }",
  "                s := s ++ \")\"",
  "            }",
  "        }",
  "        s",
  "    }",
  "}",
  "class classNode.new(name', signature', body', superclass', constructor', dtype') {",
  "    // [signature]",
  "    //     object {",
  "    //         name := \"\"",
  "    //         params := []",
  "    //         vararg := false/identifier",
  "    //     }",
  "    //     object {",
  "    //         name := \"\"",
  "    //         params := []",
  "    //         vararg := false/identifier",
  "    //     }",
  "    //     ...",
  "    //     object {",
  "    //         ...",
  "    //     }",
  "    inherits baseNode.new",
  "    def kind = \"class\"",
  "    def value = body'",
  "    def name = name'",
  "    def constructor = constructor'",
  "    def signature = signature'",
  "    var dtype := dtype'",
  "    var generics := false",
  "    def superclass = superclass'",
  "    def annotations = collections.list.new",
  "    var instanceMethods := collections.list.new",
  "    var data := false",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitClass(self)) then {",
  "            self.name.accept(visitor)",
  "            self.constructor.accept(visitor)",
  "            if (self.superclass != false) then {",
  "                self.superclass.accept(visitor)",
  "            }",
  "            for (self.signature) do { part ->",
  "                for (part.params) do { p ->",
  "                    p.accept(visitor)",
  "                }",
  "                if (part.vararg != false) then {",
  "                    part.vararg.accept(visitor)",
  "                }",
  "            }",
  "            for (self.value) do { x ->",
  "                x.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := classNode.new(name.map(blk)before(blkBefore)after(blkAfter),",
  "            listMap(signature, blk)before(blkBefore)after(blkAfter), listMap(value, blk)before(blkBefore)after(blkAfter),",
  "            maybeMap(superclass, blk, blkBefore, blkAfter), constructor, dtype)",
  "        for (listMap(annotations, blk)before(blkBefore)after(blkAfter)) do {a->",
  "            n.annotations.push(a.map(blk)before(blkBefore)after(blkAfter))",
  "        }",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Class(\" ++ self.name.pretty(0) ++ \")\"",
  "        if (self.superclass != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Superclass:\"",
  "            s := s ++ \"\\n  \" ++ spc ++ self.superclass.pretty(depth + 2)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        s := \"{s}{spc}Constructor: {constructor.value}\\n\"",
  "        if(false != dtype) then {",
  "            s := \"{s}{spc}Returns:\\n  {spc}{dtype.pretty(depth + 2)}\\n\"",
  "        }",
  "        s := \"{s}{spc}Signature:\"",
  "        for (signature) do { part ->",
  "            s := \"{s}\\n  {spc}Part: {part.name}\"",
  "            s := \"{s}\\n    {spc}Parameters:\"",
  "            for (part.params) do { p ->",
  "                s := \"{s}\\n      {spc}{p.pretty(depth + 4)}\"",
  "            }",
  "            if (part.vararg != false) then {",
  "                s := \"{s}\\n    {spc}Vararg: {part.vararg.pretty(depth + 3)}\"",
  "            }",
  "        }",
  "        if (false != generics) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Generics:\"",
  "            for (generics) do {g->",
  "                s := s ++ \"\\n  {spc}{g.pretty(0)}\"",
  "            }",
  "        }",
  "        if (annotations.size > 0) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Annotations:\"",
  "            for (annotations) do {a->",
  "                s := s ++ \"\\n  {spc}{a.pretty(depth + 2)}\"",
  "            }",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"Body:\"",
  "        for (self.value) do { x ->",
  "            s := s ++ \"\\n  \"++ spc ++ x.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"class {self.name.toGrace(0)}\"",
  "        if (self.name.kind != \"generic\") then {",
  "            // TODO generics + new-style constructors aren't possible at the moment",
  "            s := s ++ \".\"",
  "            for (self.signature) do { part ->",
  "                s := s ++ part.name",
  "                if ((part.params.size > 0) || (part.vararg != false)) then {",
  "                    s := s ++ \"(\"",
  "                    for (part.params.indices) do { pnr ->",
  "                        var p := part.params[pnr]",
  "                        s := s ++ p.toGrace(depth + 1)",
  "                        if ((pnr < part.params.size) || (part.vararg != false)) then {",
  "                            s := s ++ \", \"",
  "                        }",
  "                    }",
  "                    if (part.vararg != false) then {",
  "                        s := s ++ \"*\" ++ part.vararg.value",
  "                    }",
  "                    s := s ++ \")\"",
  "                }",
  "            }",
  "        }",
  "        if(false != dtype) then {",
  "            s := \"{s} -> {dtype.toGrace(depth + 1)}\"",
  "        }",
  "        s := s ++ \" \\{\"",
  "        for (self.value) do { mx ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ mx.toGrace(depth + 1)",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "}",
  "class objectNode.new(body, superclass') {",
  "    inherits baseNode.new",
  "    def kind = \"object\"",
  "    def value = body",
  "    def superclass = superclass'",
  "    var otype := false",
  "    var classname := \"object\"",
  "    var data := false",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitObject(self)) then {",
  "            if (self.superclass != false) then {",
  "                self.superclass.accept(visitor)",
  "            }",
  "            for (self.value) do { x ->",
  "                x.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := objectNode.new(listMap(value,",
  "        blk)before(blkBefore)after(blkAfter), maybeMap(superclass, blk,",
  "        blkBefore, blkAfter))",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth') {",
  "        var depth := depth'",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Object\"",
  "        if (self.superclass != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Superclass:\"",
  "            s := s ++ \"\\n  \" ++ spc ++ self.superclass.pretty(depth + 1)",
  "            s := s ++ \"\\n\" ++ spc ++ \"Body:\"",
  "            depth := depth + 1",
  "        }",
  "        for (self.value) do { x ->",
  "            s := s ++ \"\\n\"++ spc ++ x.pretty(depth+1)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"object \\{\"",
  "        for (self.value) do { x ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ x.toGrace(depth + 1)",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "}",
  "class arrayNode.new(values) {",
  "    inherits baseNode.new",
  "    def kind = \"array\"",
  "    def value = values",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitArray(self)) then {",
  "            for (self.value) do { ax ->",
  "                ax.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := arrayNode.new(listMap(value, blk)before(blkBefore)after(blkAfter))",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { ai ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Array\"",
  "        for (self.value) do { ax ->",
  "            s := s ++ \"\\n\"++ spc ++ ax.pretty(depth+1)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"[\"",
  "        for (self.value.indices) do { i ->",
  "            s := s ++ self.value[i].toGrace(0)",
  "            if (i < self.value.size) then {",
  "                s := s ++ \", \"",
  "            }",
  "        }",
  "        s := s ++ \"]\"",
  "        s",
  "    }",
  "}",
  "class memberNode.new(what, in') {",
  "    inherits baseNode.new",
  "    def kind = \"member\"",
  "    var value := what",
  "    def in = in'",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitMember(self)) then {",
  "            self.in.accept(visitor)",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := memberNode.new(value, in.map(blk)before(blkBefore)after(blkAfter))",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Member(\" ++ self.value ++ \")\\n\"",
  "        s := s ++ spc ++ self.in.pretty(depth+1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"\"",
  "        if (self.value.substringFrom(1)to(6) == \"prefix\") then {",
  "            s := self.value.substringFrom(7)to(self.value.size)",
  "            s := s ++ \" \" ++ self.in.toGrace(0)",
  "        } else {",
  "            s := self.in.toGrace(depth) ++ \".\" ++ self.value",
  "        }",
  "        s",
  "    }",
  "}",
  "class genericNode.new(base, params') {",
  "    inherits baseNode.new",
  "    def kind = \"generic\"",
  "    def value = base",
  "    def params = params'",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitGeneric(self)) then {",
  "            self.value.accept(visitor)",
  "            for (self.params) do { p ->",
  "                p.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := genericNode.new(value.map(blk)before(blkBefore)after(blkAfter), listMap(params, blk)before(blkBefore)after(blkAfter))",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var s := \"Generic(\" ++ self.value.value ++ \"<\"",
  "        for (params) do {p->",
  "            s := s ++ p.pretty(0)",
  "            s := s ++ \",\"",
  "        }",
  "        s ++ \">)\"",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := self.value.value ++ \"<\"",
  "        for (self.params.indices) do { i ->",
  "            s := s ++ self.params[i].toGrace(0)",
  "            if (i < self.params.size) then {",
  "                s := s ++ \", \"",
  "            }",
  "        }",
  "        s := s ++ \">\"",
  "        s",
  "    }",
  "}",
  "class identifierNode.new(name, dtype') {",
  "    inherits baseNode.new",
  "    def kind = \"identifier\"",
  "    var value := name",
  "    var wildcard := false",
  "    var dtype := dtype'",
  "    var inBind := false",
  "    var inRequest := false",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitIdentifier(self)) then {",
  "            if (self.dtype != false) then {",
  "                self.dtype.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        util.setPosition(line, linePos)",
  "        var n := identifierNode.new(value, maybeMap(dtype, blk, blkBefore,",
  "        blkAfter))",
  "        n.wildcard := wildcard",
  "        n.inBind := inBind",
  "        n.inRequest := inRequest",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        if (n.kind == \"identifier\") then {",
  "            n.linePos := linePos",
  "            n.wildcard := wildcard",
  "            n.inBind := inBind",
  "            n.inRequest := inRequest",
  "        }",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s",
  "        if(self.wildcard) then {",
  "            s := \"WildcardIdentifier\"",
  "        } else {",
  "            s := \"Identifier(\" ++ self.value ++ \")\"",
  "        }",
  "        if (self.dtype != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Type:\"",
  "            s := s ++ \"\\n\" ++ spc ++ \"  \" ++ self.dtype.pretty(depth + 2)",
  "        }",
  "        s",
  "    }",
  "    method decType {",
  "        if (dtype == false) then {",
  "            return identifierNode.new(\"Unknown\", false)",
  "        }",
  "        return dtype",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s",
  "        if(self.wildcard) then {",
  "            s := \"_\"",
  "        } else {",
  "            s := self.value",
  "        }",
  "        if (self.dtype != false) then {",
  "            s := s ++ \" : \" ++ self.dtype.toGrace(depth + 1)",
  "        }",
  "        s",
  "    }",
  "    method asString {",
  "        \"<Identifier[{value}]>\"",
  "    }",
  "}",
  "class octetsNode.new(n) {",
  "    inherits baseNode.new",
  "    def kind = \"octets\"",
  "    def value = n",
  "    method accept(visitor : ASTVisitor) {",
  "        visitor.visitOctets(self)",
  "    }",
  "    method pretty(depth) {",
  "        \"Octets(\" ++ self.value ++ \")\"",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        self.value",
  "    }",
  "}",
  "class stringNode.new(v) {",
  "    inherits baseNode.new",
  "    def kind = \"string\"",
  "    var value := v",
  "    method accept(visitor : ASTVisitor) {",
  "        visitor.visitString(self)",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := blk.apply(self)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        \"String(\" ++ self.value ++ \")\"",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"\\\"\"",
  "        for (self.value) do { c ->",
  "            // TODO: what escapes are missing?",
  "            if (c == \"\\n\") then {",
  "                s := s ++ \"\\\\n\"",
  "            } elseif (c == \"\\t\") then {",
  "                s := s ++ \"\\\\t\"",
  "            } elseif (c == \"\\\"\") then {",
  "                s := s ++ \"\\\\\\\"\"",
  "            } elseif (c == \"\\\\\") then {",
  "                s := s ++ \"\\\\\\\\\"",
  "            } else {",
  "                s := s ++ c",
  "            }",
  "        }",
  "        s := s ++ \"\\\"\"",
  "        s",
  "    }",
  "}",
  "class numNode.new(val) {",
  "    inherits baseNode.new",
  "    def kind = \"num\"",
  "    def value = val",
  "    method accept(visitor : ASTVisitor) {",
  "        visitor.visitNum(self)",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := blk.apply(self)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        \"Num(\" ++ self.value ++ \")\"",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        self.value.asString",
  "    }",
  "}",
  "class opNode.new(op, l, r) {",
  "    inherits baseNode.new",
  "    def kind = \"op\"",
  "    def value = op",
  "    def left = l",
  "    def right = r",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitOp(self)) then {",
  "            self.left.accept(visitor)",
  "            self.right.accept(visitor)",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := opNode.new(value, left.map(blk)before(blkBefore)after(blkAfter), right.map(blk)before(blkBefore)after(blkAfter))",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Op(\" ++ self.value ++ \")\"",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.left.pretty(depth + 1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.right.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"\"",
  "        if ((self.left.kind == \"op\") && (self.left.value != self.value)) then {",
  "            s := \"(\" ++ self.left.toGrace(0) ++ \")\"",
  "        } else {",
  "            s := self.left.toGrace(0)",
  "        }",
  "        if (self.value == \"..\") then {",
  "            s := s ++ self.value",
  "        } else {",
  "            s := s ++ \" \" ++ self.value ++ \" \"",
  "        }",
  "        if ((self.right.kind == \"op\") && (self.right.value != self.value)) then {",
  "            s := s ++ \"(\" ++ self.right.toGrace(0) ++ \")\"",
  "        } else {",
  "            s := s ++ self.right.toGrace(0)",
  "        }",
  "        s",
  "    }",
  "}",
  "class indexNode.new(expr, index') {",
  "    inherits baseNode.new",
  "    def kind = \"index\"",
  "    def value = expr",
  "    def index = index'",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitIndex(self)) then {",
  "            self.value.accept(visitor)",
  "            self.index.accept(visitor)",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := indexNode.new(value.map(blk)before(blkBefore)after(blkAfter), index.map(blk)before(blkBefore)after(blkAfter))",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Index\"",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.index.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := self.value.toGrace(depth + 1)",
  "        s := s ++ \"[\" ++ self.index.toGrace(depth + 1) ++ \"]\"",
  "        s",
  "    }",
  "}",
  "class bindNode.new(dest', val') {",
  "    inherits baseNode.new",
  "    def kind = \"bind\"",
  "    def dest = dest'",
  "    def value = val'",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitBind(self)) then {",
  "            self.dest.accept(visitor)",
  "            self.value.accept(visitor)",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := bindNode.new(dest.map(blk)before(blkBefore)after(blkAfter), value.map(blk)before(blkBefore)after(blkAfter))",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Bind\"",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.dest.pretty(depth + 1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := self.dest.toGrace(depth + 1)",
  "        s := s ++ \" := \" ++ self.value.toGrace(depth + 1)",
  "        s",
  "    }",
  "}",
  "class defDecNode.new(name', val, dtype') {",
  "    inherits baseNode.new",
  "    def kind = \"defdec\"",
  "    def name = name'",
  "    def value = val",
  "    var dtype := dtype'",
  "    def annotations = collections.list.new",
  "    var data := false",
  "    var startToken := false",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitDefDec(self)) then {",
  "            self.name.accept(visitor)",
  "            if (self.dtype != false) then {",
  "                self.dtype.accept(visitor)",
  "            }",
  "            if (self.value != false) then {",
  "                self.value.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := defDecNode.new(name, value.map(blk)before(blkBefore)after(blkAfter),",
  "            maybeMap(dtype, blk, blkBefore, blkAfter))",
  "        for (listMap(annotations, blk)before(blkBefore)after(blkAfter)) do {a->",
  "            n.annotations.push(a.map(blk)before(blkBefore)after(blkAfter))",
  "        }",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"defdec\"",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.name.pretty(depth)",
  "        if (self.dtype != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Type:\"",
  "            s := s ++ \"\\n\" ++ spc ++ \"  \" ++ self.dtype.pretty(depth + 2)",
  "        }",
  "        if (false != self.value) then {",
  "            s := s ++ \"\\n\"",
  "            s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        }",
  "        s",
  "    }",
  "    method decType {",
  "        if (dtype == false) then {",
  "            return identifierNode.new(\"Unknown\", false)",
  "        }",
  "        return dtype",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"def {self.name.toGrace(0)}\"",
  "        if (self.dtype.value != \"Unknown\") then {",
  "            s := s ++ \" : \" ++ self.dtype.toGrace(0)",
  "        }",
  "        if (self.annotations.size > 0) then {",
  "            s := s ++ \" is \"",
  "            s := s ++ self.annotations.reduce(\"\", { a,b ->",
  "                if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) })",
  "        }",
  "        if (self.value != false) then {",
  "            s := s ++ \" = \" ++ self.value.toGrace(depth)",
  "        }",
  "        s",
  "    }",
  "}",
  "class varDecNode.new(name', val', dtype') {",
  "    inherits baseNode.new",
  "    def kind = \"vardec\"",
  "    def name = name'",
  "    def value = val'",
  "    var dtype := dtype'",
  "    def annotations = collections.list.new",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitVarDec(self)) then {",
  "            self.name.accept(visitor)",
  "            if (self.dtype != false) then {",
  "                self.dtype.accept(visitor)",
  "            }",
  "            if (self.value != false) then {",
  "                self.value.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := varDecNode.new(name, maybeMap(value, blk,",
  "                blkBefore, blkAfter),",
  "            maybeMap(dtype, blk, blkBefore, blkAfter))",
  "        for (listMap(annotations, blk)before(blkBefore)after(blkAfter)) do {a->",
  "            n.annotations.push(a.map(blk)before(blkBefore)after(blkAfter))",
  "        }",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for ((0..depth)) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"VarDec\"",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.name.pretty(depth + 1)",
  "        if (self.dtype != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Type:\"",
  "            s := s ++ \"\\n\" ++ spc ++ \"  \" ++ self.dtype.pretty(depth + 2)",
  "        }",
  "        if (false != self.value) then {",
  "            s := s ++ \"\\n\"",
  "            s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        }",
  "        s",
  "    }",
  "    method decType {",
  "        if (dtype == false) then {",
  "            return identifierNode.new(\"Unknown\", false)",
  "        }",
  "        return dtype",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"var {self.name.toGrace(0)}\"",
  "        if (self.dtype.value != \"Unknown\") then {",
  "            s := s ++ \" : \" ++ self.dtype.toGrace(0)",
  "        }",
  "        if (self.annotations.size > 0) then {",
  "            s := s ++ \" is \"",
  "            s := s ++ self.annotations.reduce(\"\", { a,b ->",
  "                if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) })",
  "        }",
  "        if (self.value != false) then {",
  "            s := s ++ \" := \" ++ self.value.toGrace(depth)",
  "        }",
  "        s",
  "    }",
  "}",
  "class importNode.new(path', name) {",
  "    inherits baseNode.new",
  "    def kind = \"import\"",
  "    def value = name",
  "    def path = path'",
  "    var dtype := false",
  "    def linePos = 1",
  "    method accept(visitor : ASTVisitor) {",
  "        visitor.visitImport(self)",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := blk.apply(self)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Import\"",
  "        s := s ++ \"\\n\"",
  "        s := s ++ \"{spc}Path: {self.path}\\n\"",
  "        s := s ++ \"{spc}Identifier: {self.value}\\n\"",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"import \\\"{self.path}\\\" as {self.value}\"",
  "    }",
  "}",
  "class dialectNode.new(path') {",
  "    inherits baseNode.new",
  "    def kind = \"dialect\"",
  "    def value = path'",
  "    method accept(visitor : ASTVisitor) {",
  "        visitor.visitDialect(self)",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := blk.apply(self)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Dialect\"",
  "        s := s ++ \"\\n\"",
  "        s := s ++ \"{spc}Path: {self.value}\\n\"",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"dialect \\\"{self.value}\\\"\"",
  "    }",
  "}",
  "class returnNode.new(expr) {",
  "    inherits baseNode.new",
  "    def kind = \"return\"",
  "    def value = expr",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitReturn(self)) then {",
  "            self.value.accept(visitor)",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := returnNode.new(value.map(blk)before(blkBefore)after(blkAfter))",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Return\"",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"return \" ++ self.value.toGrace(depth)",
  "    }",
  "}",
  "class inheritsNode.new(expr) {",
  "    inherits baseNode.new",
  "    def kind = \"inherits\"",
  "    def value = expr",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitInherits(self)) then {",
  "            self.value.accept(visitor)",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := inheritsNode.new(value.map(blk)before(blkBefore)after(blkAfter))",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Inherits\"",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"inherits {self.value.toGrace(0)}\"",
  "    }",
  "}",
  "class blankNode.new {",
  "    inherits baseNode.new",
  "    def kind = \"blank\"",
  "    def value = \"blank\"",
  "    method accept(visitor : ASTVisitor) {",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        self",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        \"Blank\"",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"\"",
  "    }",
  "}",
  "",
  "class signaturePart.new(*values) {",
  "    inherits baseNode.new",
  "    def kind = \"signaturepart\"",
  "    var name := \"\"",
  "    var params := []",
  "    var vararg := false",
  "    var generics := []",
  "    if (values.size > 0) then {",
  "        name := values[1]",
  "    }",
  "    if (values.size > 1) then {",
  "        params := values[2]",
  "    }",
  "    if (values.size > 2) then {",
  "        vararg := values[3]",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := signaturePart.new(name, listMap(params, blk)before(blkBefore)after(blkAfter), vararg)",
  "        n := blk.apply(n)",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "}",
  "",
  "method callWithPart {",
  "    object {",
  "        method new(*values) {",
  "            object {",
  "                inherits baseNode.new",
  "                def kind = \"callwithpart\"",
  "                var name := \"\"",
  "                var args := []",
  "                if (values.size > 0) then {",
  "                    name := values[1]",
  "                }",
  "                if (values.size > 1) then {",
  "                    args := values[2]",
  "                }",
  "                method map(blk)before(blkBefore)after(blkAfter) {",
  "                    blkBefore.apply(self)",
  "                    var n := callWithPart.new(name, listMap(args, blk)before(blkBefore)after(blkAfter))",
  "                    n := blk.apply(n)",
  "                    blkAfter.apply(n)",
  "                    n",
  "                }",
  "                method map(blk) {",
  "                    map(blk)before {} after {}",
  "                }",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "type ASTVisitor = {",
  "     visitFor(o) -> Boolean",
  "     visitWhile(o) -> Boolean",
  "     visitIf(o) -> Boolean",
  "     visitBlock(o) -> Boolean",
  "     visitMatchCase(o) -> Boolean",
  "     visitCatchCase(o) -> Boolean",
  "     visitMethodType(o) -> Boolean",
  "     visitType(o) -> Boolean",
  "     visitMethod(o) -> Boolean",
  "     visitCall(o) -> Boolean",
  "     visitClass(o) -> Boolean",
  "     visitObject(o) -> Boolean",
  "     visitArray(o) -> Boolean",
  "     visitMember(o) -> Boolean",
  "     visitGeneric(o) -> Boolean",
  "     visitIdentifier(o) -> Boolean",
  "     visitOctets(o) -> Boolean",
  "     visitString(o) -> Boolean",
  "     visitNum(o) -> Boolean",
  "     visitOp(o) -> Boolean",
  "     visitIndex(o) -> Boolean",
  "     visitBind(o) -> Boolean",
  "     visitDefDec(o) -> Boolean",
  "     visitVarDec(o) -> Boolean",
  "     visitImport(o) -> Boolean",
  "     visitReturn(o) -> Boolean",
  "     visitInherits(o) -> Boolean",
  "     visitDialect(o) -> Boolean",
  "}",
  "method baseVisitor -> ASTVisitor {",
  "    object {",
  "        method visitFor(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitWhile(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitIf(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitBlock(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitMatchCase(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitCatchCase(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitMethodType(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitType(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitMethod(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitCall(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitClass(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitObject(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitArray(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitMember(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitGeneric(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitIdentifier(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitOctets(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitString(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitNum(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitOp(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitIndex(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitBind(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitDefDec(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitVarDec(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitImport(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitReturn(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitInherits(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitDialect(o) -> Boolean {",
  "            true",
  "        }",
  "    }",
  "}",
  "def ast = self",
  "def patternMarkVisitor = object {",
  "    inherits ast.baseVisitor",
  "    method visitCall(c) {",
  "        c.isPattern := true",
  "        true",
  "    }",
  "}",
  "",
  "method findAnnotation(node, annName) {",
  "    for (node.annotations) do {ann->",
  "        if ((ann.kind == \"identifier\").andAlso {",
  "            ann.value == annName }) then {",
  "            return object {",
  "                inherits true",
  "                def value is public = ann",
  "            }",
  "        }",
  "    }",
  "    false",
  "}",
  "",
  "method isPublic(node) {",
  "    if ((node.annotations.size == 0).orElse {",
  "        findAnnotation(node, \"public\")}) then {",
  "        return true",
  "    }",
  "    false",
  "}",
  "",
  "method isWritable(node) {",
  "    if ((node.annotations.size == 0).orElse {",
  "        findAnnotation(node, \"writable\")}) then {",
  "        return true",
  "    }",
  "    false",
  "}",
  NULL
};
static Object type_ASTVisitor;
Object reader_ast_outer_24(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_27(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_28(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_29(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_29(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_args_30(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_args_30(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_99(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_181(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_value_182(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_outer_229(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_232(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_register_233(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_ast_register_233(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_ast_line_234(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_line_234(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_linePos_235(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_linePos_235(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_lineLength_236(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_lineLength_236(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_246(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_249(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_250(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_251(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_body_252(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_outer_380(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_383(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_384(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_385(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_body_386(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_outer_555(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_558(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_559(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_560(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_thenblock_561(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_elseblock_562(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_ast_handledIdentifiers_563(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_handledIdentifiers_563(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_872(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_875(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_876(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_877(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_params_878(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_body_879(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_ast_selfclosure_880(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_matchingPattern_881(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_matchingPattern_881(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_extraRuntimeData_882(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_extraRuntimeData_882(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_outer_1248(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1251(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1252(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_1253(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_cases_1254(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_finally_1255(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_ast_outer_1539(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1542(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1543(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_1544(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_cases_1545(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_elsecase_1546(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_ast_outer_1830(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1833(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1834(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_1835(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_signature_1836(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_rtype_1837(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_ast_generics_1838(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_generics_1838(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_2285(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_2288(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_2289(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_2290(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_methods_2291(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_unionTypes_2292(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_ast_intersectionTypes_2293(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_annotations_2294(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object reader_ast_generics_2295(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_generics_2295(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_nominal_2296(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_nominal_2296(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_anonymous_2297(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object writer_ast_anonymous_2297(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[9] = args[0];
  return done;
}
Object reader_ast_outer_3030(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_3033(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_3034(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_3035(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_signature_3036(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_body_3037(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_ast_dtype_3038(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_dtype_3038(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_varargs_3039(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_varargs_3039(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_generics_3040(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_generics_3040(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_selfclosure_3041(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_selfclosure_3041(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_annotations_3042(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object reader_ast_properties_3043(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[10];
}
Object writer_ast_properties_3043(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[10] = args[0];
  return done;
}
Object reader_ast_outer_3848(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_3851(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_3852(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_3853(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_with_3854(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_generics_3855(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_generics_3855(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_isPattern_3856(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_isPattern_3856(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_4224(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_4227(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_4228(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_4229(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_name_4230(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_constructor_4231(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_ast_signature_4232(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_dtype_4233(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_dtype_4233(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_generics_4234(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_generics_4234(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_superclass_4235(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object reader_ast_annotations_4236(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object reader_ast_instanceMethods_4237(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[10];
}
Object writer_ast_instanceMethods_4237(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[10] = args[0];
  return done;
}
Object reader_ast_data_4238(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[11];
}
Object writer_ast_data_4238(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[11] = args[0];
  return done;
}
Object reader_ast_outer_5034(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5037(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5038(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_5039(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_superclass_5040(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_otype_5041(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_otype_5041(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_classname_5042(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_classname_5042(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_data_5043(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_data_5043(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_5273(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5276(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5277(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_5278(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_outer_5409(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5412(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5413(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_5414(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_5414(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_in_5415(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_outer_5550(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5553(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5554(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_5555(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_params_5556(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_outer_5697(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5700(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5701(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_5702(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_5702(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_wildcard_5703(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_wildcard_5703(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_5704(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_5704(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_inBind_5705(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_inBind_5705(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_inRequest_5706(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_inRequest_5706(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_5936(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5939(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5940(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_5941(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_outer_5965(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5968(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5969(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_5970(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_5970(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_6069(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6072(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6073(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6074(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_outer_6120(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6123(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6124(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6125(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_left_6126(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_right_6127(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_ast_outer_6362(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6365(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6366(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6367(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_index_6368(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_outer_6523(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6526(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6527(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_dest_6528(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_value_6529(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_outer_6680(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6683(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6684(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_6685(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_value_6686(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_dtype_6687(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_6687(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_annotations_6688(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_data_6689(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_data_6689(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_startToken_6690(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_startToken_6690(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_outer_7021(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7024(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7025(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_7026(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_value_7027(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_dtype_7028(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_7028(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_annotations_7029(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_outer_7366(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7369(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7370(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7371(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_path_7372(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_dtype_7373(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_7373(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_linePos_7374(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_outer_7490(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7493(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7494(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7495(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_outer_7579(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7582(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7583(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7584(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_outer_7672(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7675(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7676(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7677(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_outer_7770(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7773(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7774(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7775(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_outer_7798(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7801(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7802(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_7803(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_7803(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_params_7804(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_params_7804(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_vararg_7805(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_vararg_7805(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_generics_7806(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_generics_7806(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_7881(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
static ClassData objclass23;
static ClassData objclass26;
static Object strlit68;
static Object strlit69;
static ClassData objclass98;
static Object strlit174;
static ClassData objclass180;
static Object strlit193;
static Object strlit213;
Object module_util;
Object module_util_init();
Object module_mgcollections;
Object module_mgcollections_init();
static ClassData objclass228;
static ClassData objclass231;
static Object strlit237;
static ClassData objclass245;
static ClassData objclass248;
static Object strlit266;
static Object strlit275;
static Object strlit281;
static Object strlit298;
static Object strlit303;
static Object strlit321;
static Object strlit326;
static Object strlit334;
static Object strlit347;
static Object strlit354;
static Object strlit363;
static Object strlit376;
static ClassData objclass379;
static ClassData objclass382;
static Object strlit405;
static Object strlit414;
static Object strlit420;
static Object strlit437;
static Object strlit442;
static Object strlit465;
static Object strlit474;
static Object strlit487;
static Object strlit494;
static Object strlit506;
static Object strlit523;
static Object strlit528;
static Object strlit538;
static Object strlit543;
static Object strlit551;
static ClassData objclass554;
static ClassData objclass557;
static Object strlit638;
static Object strlit647;
static Object strlit653;
static Object strlit670;
static Object strlit675;
static Object strlit698;
static Object strlit707;
static Object strlit712;
static Object strlit735;
static Object strlit744;
static Object strlit757;
static Object strlit764;
static Object strlit773;
static Object strlit790;
static Object strlit795;
static Object strlit814;
static Object strlit819;
static Object strlit839;
static Object strlit844;
static Object strlit854;
static Object strlit859;
static Object strlit867;
static ClassData objclass871;
static ClassData objclass874;
static Object strlit973;
static Object strlit982;
static Object strlit988;
static Object strlit990;
static Object strlit1013;
static Object strlit1022;
static Object strlit1027;
static Object strlit1050;
static Object strlit1066;
static Object strlit1071;
static Object strlit1091;
static Object strlit1098;
static Object strlit1111;
static Object strlit1117;
static Object strlit1128;
static Object strlit1150;
static Object strlit1158;
static Object strlit1180;
static Object strlit1185;
static Object strlit1205;
static Object strlit1210;
static Object strlit1220;
static Object strlit1225;
static Object strlit1233;
static Object strlit1234;
static ClassData objclass1247;
static ClassData objclass1250;
static Object strlit1323;
static Object strlit1332;
static Object strlit1338;
static Object strlit1361;
static Object strlit1372;
static Object strlit1377;
static Object strlit1381;
static Object strlit1402;
static Object strlit1415;
static Object strlit1420;
static Object strlit1424;
static Object strlit1435;
static Object strlit1448;
static Object strlit1455;
static Object strlit1464;
static Object strlit1481;
static Object strlit1484;
static Object strlit1489;
static Object strlit1517;
static Object strlit1520;
static Object strlit1525;
static Object strlit1535;
static ClassData objclass1538;
static ClassData objclass1541;
static Object strlit1616;
static Object strlit1625;
static Object strlit1631;
static Object strlit1652;
static Object strlit1663;
static Object strlit1668;
static Object strlit1672;
static Object strlit1693;
static Object strlit1706;
static Object strlit1711;
static Object strlit1715;
static Object strlit1726;
static Object strlit1739;
static Object strlit1746;
static Object strlit1755;
static Object strlit1772;
static Object strlit1775;
static Object strlit1780;
static Object strlit1808;
static Object strlit1811;
static Object strlit1816;
static Object strlit1826;
static ClassData objclass1829;
static ClassData objclass1832;
static Object strlit1925;
static Object strlit1934;
static Object strlit1940;
static Object strlit1942;
static Object strlit1949;
static Object strlit1954;
static Object strlit1958;
static Object strlit1974;
static Object strlit1987;
static Object strlit1992;
static Object strlit1997;
static Object strlit2001;
static Object strlit2012;
static Object strlit2017;
static Object strlit2021;
static Object strlit2033;
static Object strlit2040;
static Object strlit2045;
static Object strlit2049;
static Object strlit2058;
static Object strlit2063;
static Object strlit2067;
static Object strlit2079;
static Object strlit2090;
static Object strlit2095;
static Object strlit2099;
static Object strlit2117;
static Object strlit2130;
static Object strlit2135;
static Object strlit2139;
static Object strlit2150;
static Object strlit2181;
static Object strlit2223;
static Object strlit2243;
static Object strlit2249;
static Object strlit2273;
static Object strlit2280;
static ClassData objclass2284;
static ClassData objclass2287;
static Object strlit2461;
static Object strlit2470;
static Object strlit2476;
static Object strlit2478;
static Object strlit2485;
static Object strlit2490;
static Object strlit2494;
static Object strlit2512;
static Object strlit2517;
static Object strlit2521;
static Object strlit2533;
static Object strlit2540;
static Object strlit2545;
static Object strlit2549;
static Object strlit2569;
static Object strlit2574;
static Object strlit2578;
static Object strlit2590;
static Object strlit2597;
static Object strlit2602;
static Object strlit2606;
static Object strlit2626;
static Object strlit2631;
static Object strlit2635;
static Object strlit2647;
static Object strlit2654;
static Object strlit2659;
static Object strlit2663;
static Object strlit2674;
static Object strlit2697;
static Object strlit2706;
static Object strlit2711;
static Object strlit2724;
static Object strlit2730;
static Object strlit2732;
static Object strlit2743;
static Object strlit2754;
static Object strlit2773;
static Object strlit2779;
static Object strlit2793;
static Object strlit2822;
static Object strlit2829;
static Object strlit2834;
static Object strlit2864;
static Object strlit2903;
static Object strlit2944;
static Object strlit2964;
static Object strlit2969;
static Object strlit3004;
static Object strlit3009;
static Object strlit3017;
static ClassData objclass3029;
static ClassData objclass3032;
static Object strlit3201;
static Object strlit3210;
static Object strlit3216;
static Object strlit3228;
static Object strlit3237;
static Object strlit3249;
static Object strlit3254;
static Object strlit3264;
static Object strlit3280;
static Object strlit3285;
static Object strlit3289;
static Object strlit3301;
static Object strlit3308;
static Object strlit3313;
static Object strlit3317;
static Object strlit3326;
static Object strlit3331;
static Object strlit3335;
static Object strlit3347;
static Object strlit3358;
static Object strlit3363;
static Object strlit3367;
static Object strlit3385;
static Object strlit3398;
static Object strlit3403;
static Object strlit3407;
static Object strlit3418;
static Object strlit3430;
static Object strlit3435;
static Object strlit3439;
static Object strlit3451;
static Object strlit3459;
static Object strlit3464;
static Object strlit3468;
static Object strlit3479;
static Object strlit3493;
static Object strlit3498;
static Object strlit3502;
static Object strlit3514;
static Object strlit3525;
static Object strlit3530;
static Object strlit3534;
static Object strlit3545;
static Object strlit3550;
static Object strlit3573;
static Object strlit3590;
static Object strlit3596;
static Object strlit3609;
static Object strlit3615;
static Object strlit3646;
static Object strlit3688;
static Object strlit3708;
static Object strlit3714;
static Object strlit3729;
static Object strlit3738;
static Object strlit3754;
static Object strlit3760;
static Object strlit3770;
static Object strlit3774;
static Object strlit3777;
static Object strlit3787;
static Object strlit3805;
static Object strlit3810;
static Object strlit3820;
static Object strlit3825;
static Object strlit3833;
static ClassData objclass3847;
static ClassData objclass3850;
static Object strlit3938;
static Object strlit3947;
static Object strlit3953;
static Object strlit3956;
static Object strlit3968;
static Object strlit3978;
static Object strlit3990;
static Object strlit4003;
static Object strlit4011;
static Object strlit4023;
static Object strlit4040;
static Object strlit4045;
static Object strlit4068;
static Object strlit4079;
static Object strlit4092;
static Object strlit4098;
static Object strlit4101;
static Object strlit4112;
static Object strlit4140;
static Object strlit4170;
static Object strlit4203;
static Object strlit4210;
static Object strlit4218;
static ClassData objclass4223;
static ClassData objclass4226;
static Object strlit4373;
static Object strlit4382;
static Object strlit4389;
static Object strlit4398;
static Object strlit4409;
static Object strlit4414;
static Object strlit4433;
static Object strlit4440;
static Object strlit4445;
static Object strlit4454;
static Object strlit4459;
static Object strlit4463;
static Object strlit4479;
static Object strlit4492;
static Object strlit4497;
static Object strlit4502;
static Object strlit4506;
static Object strlit4517;
static Object strlit4522;
static Object strlit4526;
static Object strlit4538;
static Object strlit4545;
static Object strlit4550;
static Object strlit4554;
static Object strlit4563;
static Object strlit4568;
static Object strlit4572;
static Object strlit4584;
static Object strlit4595;
static Object strlit4600;
static Object strlit4604;
static Object strlit4622;
static Object strlit4635;
static Object strlit4640;
static Object strlit4644;
static Object strlit4662;
static Object strlit4667;
static Object strlit4680;
static Object strlit4688;
static Object strlit4692;
static Object strlit4712;
static Object strlit4717;
static Object strlit4730;
static Object strlit4741;
static Object strlit4745;
static Object strlit4756;
static Object strlit4761;
static Object strlit4783;
static Object strlit4792;
static Object strlit4805;
static Object strlit4812;
static Object strlit4821;
static Object strlit4826;
static Object strlit4834;
static Object strlit4868;
static Object strlit4910;
static Object strlit4930;
static Object strlit4936;
static Object strlit4950;
static Object strlit4963;
static Object strlit4967;
static Object strlit4974;
static Object strlit4992;
static Object strlit4997;
static Object strlit5007;
static Object strlit5012;
static Object strlit5020;
static ClassData objclass5033;
static ClassData objclass5036;
static Object strlit5108;
static Object strlit5117;
static Object strlit5123;
static Object strlit5132;
static Object strlit5137;
static Object strlit5156;
static Object strlit5163;
static Object strlit5168;
static Object strlit5195;
static Object strlit5204;
static Object strlit5217;
static Object strlit5223;
static Object strlit5238;
static Object strlit5243;
static Object strlit5253;
static Object strlit5258;
static Object strlit5266;
static Object strlit5268;
static ClassData objclass5272;
static ClassData objclass5275;
static Object strlit5324;
static Object strlit5333;
static Object strlit5339;
static Object strlit5356;
static Object strlit5365;
static Object strlit5392;
static Object strlit5399;
static Object strlit5405;
static ClassData objclass5408;
static ClassData objclass5411;
static Object strlit5454;
static Object strlit5463;
static Object strlit5470;
static Object strlit5476;
static Object strlit5495;
static Object strlit5498;
static Object strlit5525;
static Object strlit5535;
static Object strlit5546;
static ClassData objclass5549;
static ClassData objclass5552;
static Object strlit5611;
static Object strlit5619;
static Object strlit5635;
static Object strlit5642;
static Object strlit5647;
static Object strlit5680;
static Object strlit5687;
static Object strlit5693;
static ClassData objclass5696;
static ClassData objclass5699;
static Object strlit5764;
static Object strlit5797;
static Object strlit5806;
static Object strlit5815;
static Object strlit5818;
static Object strlit5824;
static Object strlit5836;
static Object strlit5841;
static Object strlit5858;
static Object strlit5863;
static Object strlit5879;
static Object strlit5888;
static Object strlit5911;
static Object strlit5918;
static Object strlit5924;
static Object strlit5929;
static ClassData objclass5935;
static ClassData objclass5938;
static Object strlit5947;
static Object strlit5953;
static Object strlit5961;
static ClassData objclass5964;
static ClassData objclass5967;
static Object strlit5996;
static Object strlit6002;
static Object strlit6006;
static Object strlit6014;
static Object strlit6018;
static Object strlit6024;
static Object strlit6028;
static Object strlit6034;
static Object strlit6038;
static Object strlit6044;
static Object strlit6048;
static Object strlit6059;
static Object strlit6065;
static ClassData objclass6068;
static ClassData objclass6071;
static Object strlit6100;
static Object strlit6106;
static Object strlit6116;
static ClassData objclass6119;
static ClassData objclass6122;
static Object strlit6174;
static Object strlit6183;
static Object strlit6190;
static Object strlit6196;
static Object strlit6200;
static Object strlit6220;
static Object strlit6240;
static Object strlit6254;
static Object strlit6263;
static Object strlit6272;
static Object strlit6284;
static Object strlit6296;
static Object strlit6303;
static Object strlit6322;
static Object strlit6331;
static Object strlit6341;
static Object strlit6358;
static ClassData objclass6361;
static ClassData objclass6364;
static Object strlit6413;
static Object strlit6422;
static Object strlit6428;
static Object strlit6430;
static Object strlit6450;
static Object strlit6470;
static Object strlit6483;
static Object strlit6498;
static Object strlit6511;
static Object strlit6519;
static ClassData objclass6522;
static ClassData objclass6525;
static Object strlit6574;
static Object strlit6583;
static Object strlit6589;
static Object strlit6591;
static Object strlit6611;
static Object strlit6631;
static Object strlit6644;
static Object strlit6669;
static Object strlit6676;
static ClassData objclass6679;
static ClassData objclass6682;
static Object strlit6778;
static Object strlit6787;
static Object strlit6793;
static Object strlit6795;
static Object strlit6818;
static Object strlit6823;
static Object strlit6840;
static Object strlit6845;
static Object strlit6860;
static Object strlit6888;
static Object strlit6894;
static Object strlit6907;
static Object strlit6914;
static Object strlit6923;
static Object strlit6928;
static Object strlit6943;
static Object strlit6958;
static Object strlit6964;
static Object strlit6974;
static Object strlit6978;
static Object strlit6981;
static Object strlit7004;
static Object strlit7011;
static ClassData objclass7020;
static ClassData objclass7023;
static Object strlit7121;
static Object strlit7130;
static Object strlit7136;
static Object strlit7138;
static Object strlit7165;
static Object strlit7170;
static Object strlit7187;
static Object strlit7192;
static Object strlit7207;
static Object strlit7235;
static Object strlit7241;
static Object strlit7254;
static Object strlit7261;
static Object strlit7270;
static Object strlit7275;
static Object strlit7290;
static Object strlit7305;
static Object strlit7311;
static Object strlit7321;
static Object strlit7325;
static Object strlit7328;
static Object strlit7351;
static Object strlit7358;
static ClassData objclass7365;
static ClassData objclass7368;
static Object strlit7399;
static Object strlit7408;
static Object strlit7414;
static Object strlit7416;
static Object strlit7422;
static Object strlit7429;
static Object strlit7433;
static Object strlit7443;
static Object strlit7450;
static Object strlit7454;
static Object strlit7464;
static Object strlit7471;
static Object strlit7477;
static Object strlit7484;
static ClassData objclass7489;
static ClassData objclass7492;
static Object strlit7520;
static Object strlit7529;
static Object strlit7535;
static Object strlit7537;
static Object strlit7543;
static Object strlit7550;
static Object strlit7554;
static Object strlit7564;
static Object strlit7570;
static Object strlit7575;
static ClassData objclass7578;
static ClassData objclass7581;
static Object strlit7621;
static Object strlit7630;
static Object strlit7636;
static Object strlit7638;
static Object strlit7664;
static Object strlit7668;
static ClassData objclass7671;
static ClassData objclass7674;
static Object strlit7714;
static Object strlit7723;
static Object strlit7729;
static Object strlit7731;
static Object strlit7752;
static Object strlit7761;
static Object strlit7766;
static ClassData objclass7769;
static ClassData objclass7772;
static Object strlit7788;
static Object strlit7790;
static Object strlit7793;
static Object strlit7794;
static ClassData objclass7797;
static ClassData objclass7800;
static Object strlit7840;
static Object strlit7841;
static ClassData objclass7880;
Object meth_ast__apply7(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_b = getfromclosure(closure, 0);
  Object *var_blkBefore = getfromclosure(closure, 1);
  Object *var_blkAfter = getfromclosure(closure, 2);
  Object *var_r = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_replacement = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "replacement");
// Begin line 25
  setline(25);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8 = gc_frame_new();
// compilenode returning *var_b
  gc_frame_newslot(*var_b);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// compilenode returning *var_v
  params[0] = *var_b;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9 = callmethod(*var_v, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe8);
// compilenode returning call9
  *var_replacement = call9;
  if (call9 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10 = gc_frame_new();
// compilenode returning *var_replacement
  gc_frame_newslot(*var_replacement);
// compilenode returning *var_r
  params[0] = *var_replacement;
  partcv[0] = 1;
  Object call11 = callmethod(*var_r, "push",
    1, partcv, params);
  gc_frame_end(callframe10);
// compilenode returning call11
  gc_frame_end(frame);
  return call11;
}
Object meth_ast_listMap_40__41_before_40__41_after0(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "listMap()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_collections = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for listMap()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for listMap");
  Object *var_blkBefore = &(stackframe->slots[2]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[3]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_r = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "r");
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1 = gc_frame_new();
  int callframe2 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call3 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe2);
// compilenode returning call3
// compilenode returning call3
  partcv[0] = 0;
  Object call4 = callmethod(call3, "new",
    1, partcv, params);
  gc_frame_end(callframe1);
// compilenode returning call4
// compilenode returning call4
  *var_r = call4;
  if (call4 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5 = gc_frame_new();
// compilenode returning *var_l
  gc_frame_newslot(*var_l);
  Object block6 = alloc_Block(NULL, NULL, "ast", 24);
  gc_frame_newslot(block6);
  block_savedest(block6);
  Object closure7 = createclosure(5, "_apply");
setclosureframe(closure7, stackframe);
  addtoclosure(closure7, var_b);
  addtoclosure(closure7, var_blkBefore);
  addtoclosure(closure7, var_blkAfter);
  addtoclosure(closure7, var_r);
  addtoclosure(closure7, selfslot);
  struct UserObject *uo7 = (struct UserObject*)block6;
  uo7->data[0] = (Object)closure7;
  Method *meth_meth_ast__apply7 = addmethod2pos(block6, "_apply", &meth_ast__apply7, 0);
int argcv_meth_ast__apply7[] = {1};
meth_meth_ast__apply7->type = alloc_MethodType(1, argcv_meth_ast__apply7);
  meth_meth_ast__apply7->definitionModule = modulename;
  meth_meth_ast__apply7->definitionLine = 23;
// compilenode returning block6
  gc_frame_newslot(block6);
  params[0] = *var_l;
  params[1] = block6;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call13 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5);
// compilenode returning call13
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_r
  gc_frame_end(frame);
  return *var_r;
}
Object meth_ast_maybeMap14(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "maybeMap");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 4)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for maybeMap (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *var_before = &(stackframe->slots[2]);
  *var_before = args[curarg];
  curarg++;
  Object *var_after = &(stackframe->slots[3]);
  *var_after = args[curarg];
  curarg++;
if (argcv && argcv[0] > 4)
  gracedie("too many arguments for maybeMap");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 34
  setline(34);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool17 = alloc_Boolean(0);
// compilenode returning bool17
  int op_slot_right_16 = gc_frame_newslot(bool17);
// compilenode returning *var_n
  int op_slot_left_16 = gc_frame_newslot(*var_n);
  params[0] = bool17;
  partcv[0] = 1;
  Object opresult19 = callmethod(*var_n, "!=", 1, partcv, params);
// compilenode returning opresult19
  Object if15 = done;
  if (istrue(opresult19)) {
// Begin line 32
  setline(32);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe20 = gc_frame_new();
// compilenode returning *var_b
  gc_frame_newslot(*var_b);
// compilenode returning *var_before
  gc_frame_newslot(*var_before);
// compilenode returning *var_after
  gc_frame_newslot(*var_after);
// compilenode returning *var_n
  params[0] = *var_b;
  params[1] = *var_before;
  params[2] = *var_after;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call21 = callmethod(*var_n, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe20);
// compilenode returning call21
  return call21;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if15 = undefined;
  } else {
  }
// compilenode returning if15
// Begin line 34
  setline(34);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast_map_40__41_before_40__41_after31(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1890
  setline(1890);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe32 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call33 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe32);
// compilenode returning call33
// Begin line 1891
  setline(1891);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe34 = gc_frame_new();
  int callframe35 = gc_frame_new();
  partcv[0] = 0;
  Object call36 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe35);
// compilenode returning call36
  gc_frame_newslot(call36);
  int callframe37 = gc_frame_new();
  int callframe38 = gc_frame_new();
  partcv[0] = 0;
  Object call39 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe38);
// compilenode returning call39
  gc_frame_newslot(call39);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe40 = gc_frame_new();
  int callframe41 = gc_frame_new();
  Object call42 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe41);
// compilenode returning call42
// compilenode returning call42
  partcv[0] = 0;
  Object call43 = callmethodflags(call42, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe40);
// compilenode returning call43
// compilenode returning call43
  params[0] = call39;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call44 = callmethodflags(call43, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe37);
// compilenode returning call44
  gc_frame_newslot(call44);
  int callframe45 = gc_frame_new();
  int callframe46 = gc_frame_new();
  int callframe47 = gc_frame_new();
  Object call48 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe47);
// compilenode returning call48
// compilenode returning call48
  partcv[0] = 0;
  Object call49 = callmethodflags(call48, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe46);
// compilenode returning call49
// compilenode returning call49
  partcv[0] = 0;
  Object call50 = callmethodflags(call49, "callWithPart", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe45);
// compilenode returning call50
  params[0] = call36;
  params[1] = call44;
  partcv[0] = 2;
  Object call51 = callmethod(call50, "new",
    1, partcv, params);
  gc_frame_end(callframe34);
// compilenode returning call51
  *var_n = call51;
  if (call51 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1892
  setline(1892);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe52 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call53 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe52);
// compilenode returning call53
  *var_n = call53;
  if (call53 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1893
  setline(1893);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe55 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call56 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe55);
// compilenode returning call56
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply60(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply63(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map57(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1897
  setline(1897);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe58 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block59 = alloc_Block(NULL, NULL, "ast", 1897);
  gc_frame_newslot(block59);
  block_savedest(block59);
  Object closure60 = createclosure(1, "_apply");
setclosureframe(closure60, stackframe);
  addtoclosure(closure60, selfslot);
  struct UserObject *uo60 = (struct UserObject*)block59;
  uo60->data[0] = (Object)closure60;
  Method *meth_meth_ast__apply60 = addmethod2pos(block59, "_apply", &meth_ast__apply60, 0);
int argcv_meth_ast__apply60[] = {0};
meth_meth_ast__apply60->type = alloc_MethodType(1, argcv_meth_ast__apply60);
  meth_meth_ast__apply60->definitionModule = modulename;
  meth_meth_ast__apply60->definitionLine = 1891;
// compilenode returning block59
  gc_frame_newslot(block59);
  Object block62 = alloc_Block(NULL, NULL, "ast", 1897);
  gc_frame_newslot(block62);
  block_savedest(block62);
  Object closure63 = createclosure(1, "_apply");
setclosureframe(closure63, stackframe);
  addtoclosure(closure63, selfslot);
  struct UserObject *uo63 = (struct UserObject*)block62;
  uo63->data[0] = (Object)closure63;
  Method *meth_meth_ast__apply63 = addmethod2pos(block62, "_apply", &meth_ast__apply63, 0);
int argcv_meth_ast__apply63[] = {0};
meth_meth_ast__apply63->type = alloc_MethodType(1, argcv_meth_ast__apply63);
  meth_meth_ast__apply63->definitionModule = modulename;
  meth_meth_ast__apply63->definitionLine = 1891;
// compilenode returning block62
  gc_frame_newslot(block62);
  params[0] = *var_blk;
  params[1] = block59;
  params[2] = block62;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call65 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe58);
// compilenode returning call65
  gc_frame_end(frame);
  return call65;
}
Object meth_ast_new25(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_values = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_values, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_values = &(stackframe->slots[0]);
  *var_values = var_init_values;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject26 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj26 = alloc_userobj2(10,9, objclass26);
  gc_frame_newslot(obj26);
// OBJECT OUTER DEC outer
  adddatum2(obj26, self, 0);
  addmethodreal(obj26,"outer", &reader_ast_outer_27);
  Object oldself26 = self;
  struct StackFrameObject *oldstackframe26 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe26);
  gc_frame_newslot((Object)stackframe);
  self = obj26;
  Object *oldselfslot26 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter26 = (*(struct UserObject *)self).data[0], lowerouter26 = thisouter26;
  if (inheritingObject26) {
    struct UserObject *inho26 = (struct UserObject *)inheritingObject26;
    while (inho26->super != GraceDefaultObject) inho26 = (struct UserObject *)inho26->super;
    inho26->super = obj26;
    self = inheritingObject26;
    *selfslot = self;
    lowerouter26 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter26;
  }
if (objclass26 == NULL) {
  Method *reader28 = addmethodrealflags(obj26, "kind",&reader_ast_kind_28, MFLAG_DEF);
  reader28->definitionModule = modulename;
  reader28->definitionLine = 1881;
}
adddatum2(obj26, alloc_Undefined(), 1);
if (objclass26 == NULL) {
  Method *reader29 = addmethodrealflags(obj26, "name",&reader_ast_name_29, 0);
  Method *writer29 = addmethodrealflags(obj26, "name:=",&writer_ast_name_29, 0);
  reader29->definitionModule = modulename;
  writer29->definitionModule = modulename;
  reader29->definitionLine = 1882;
  writer29->definitionLine = 1882;
}
obj26->flags |= OFLAG_MUTABLE;
adddatum2(obj26, alloc_Undefined(), 2);
if (objclass26 == NULL) {
  Method *reader30 = addmethodrealflags(obj26, "args",&reader_ast_args_30, 0);
  Method *writer30 = addmethodrealflags(obj26, "args:=",&writer_ast_args_30, 0);
  reader30->definitionModule = modulename;
  writer30->definitionModule = modulename;
  reader30->definitionLine = 1883;
  writer30->definitionLine = 1883;
}
obj26->flags |= OFLAG_MUTABLE;
adddatum2(obj26, alloc_Undefined(), 3);
  struct UserObject *uo31 = (struct UserObject*)obj26;
  uo31->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_before_40__41_after31 = addmethod2pos(obj26, "map()before()after", &meth_ast_map_40__41_before_40__41_after31, 4);
int argcv_meth_ast_map_40__41_before_40__41_after31[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after31->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after31);
  meth_meth_ast_map_40__41_before_40__41_after31->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after31->definitionLine = 1889;
  struct UserObject *uo57 = (struct UserObject*)obj26;
  uo57->data[5] = emptyclosure;
  Method *meth_meth_ast_map57 = addmethod2pos(obj26, "map", &meth_ast_map57, 5);
int argcv_meth_ast_map57[] = {1};
meth_meth_ast_map57->type = alloc_MethodType(1, argcv_meth_ast_map57);
  meth_meth_ast_map57->definitionModule = modulename;
  meth_meth_ast_map57->definitionLine = 1896;
  sourceObject = obj26;
// Begin line 1879
  setline(1879);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe66 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call67 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe66);
// compilenode returning call67
  struct UserObject *obj26_uo = (struct UserObject *)obj26;
  obj26_uo->super = call67;
  sourceObject = obj26;
// Begin line 1880
  setline(1880);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit68 == NULL) {
    strlit68 = alloc_String("callwithpart");
    gc_root(strlit68);
  }
// compilenode returning strlit68
  adddatum2(obj26, strlit68, 1);
  sourceObject = obj26;
// Begin line 1881
  setline(1881);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit69 == NULL) {
    strlit69 = alloc_String("");
    gc_root(strlit69);
  }
// compilenode returning strlit69
  adddatum2(obj26, strlit69, 2);
  sourceObject = obj26;
// Begin line 1882
  setline(1882);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array70 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array70
  adddatum2(obj26, array70, 3);
  sourceObject = obj26;
// Begin line 1886
  setline(1886);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1883
  setline(1883);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num73 = alloc_Float64(0);
// compilenode returning num73
  int op_slot_right_72 = gc_frame_newslot(num73);
  int callframe75 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call76 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe75);
// compilenode returning call76
// compilenode returning call76
  int op_slot_left_72 = gc_frame_newslot(call76);
  params[0] = num73;
  partcv[0] = 1;
  Object opresult77 = callmethod(call76, ">", 1, partcv, params);
// compilenode returning opresult77
  Object if71 = done;
struct StackFrameObject *iftmpstackframe71 = stackframe;
  if (istrue(opresult77)) {
stackframe = alloc_StackFrame(0, iftmpstackframe71);
gc_frame_newslot((Object)stackframe);
// Begin line 1885
  setline(1885);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1883
  setline(1883);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe78 = gc_frame_new();
// Begin line 1885
  setline(1885);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1884
  setline(1884);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  Object num79 = alloc_Float64(1);
// compilenode returning num79
  params[0] = num79;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres80 = callmethod(*var_values, "[]", 1, partcv, params);
// compilenode returning idxres80
  gc_frame_newslot(idxres80);
  params[0] = idxres80;
  partcv[0] = 1;
  Object call81 = callmethodflags(self, "name:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe78);
// compilenode returning call81
// compilenode returning done
    gc_frame_newslot(done);
    if71 = done;
  } else {
  }
stackframe = iftmpstackframe71;
// compilenode returning if71
  sourceObject = obj26;
// Begin line 1889
  setline(1889);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1886
  setline(1886);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num84 = alloc_Float64(1);
// compilenode returning num84
  int op_slot_right_83 = gc_frame_newslot(num84);
  int callframe86 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call87 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe86);
// compilenode returning call87
// compilenode returning call87
  int op_slot_left_83 = gc_frame_newslot(call87);
  params[0] = num84;
  partcv[0] = 1;
  Object opresult88 = callmethod(call87, ">", 1, partcv, params);
// compilenode returning opresult88
  Object if82 = done;
struct StackFrameObject *iftmpstackframe82 = stackframe;
  if (istrue(opresult88)) {
stackframe = alloc_StackFrame(0, iftmpstackframe82);
gc_frame_newslot((Object)stackframe);
// Begin line 1888
  setline(1888);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1886
  setline(1886);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe89 = gc_frame_new();
// Begin line 1888
  setline(1888);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1887
  setline(1887);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  Object num90 = alloc_Float64(2);
// compilenode returning num90
  params[0] = num90;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres91 = callmethod(*var_values, "[]", 1, partcv, params);
// compilenode returning idxres91
  gc_frame_newslot(idxres91);
  params[0] = idxres91;
  partcv[0] = 1;
  Object call92 = callmethodflags(self, "args:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe89);
// compilenode returning call92
// compilenode returning done
    gc_frame_newslot(done);
    if82 = done;
  } else {
  }
stackframe = iftmpstackframe82;
// compilenode returning if82
  sourceObject = obj26;
  sourceObject = obj26;
objclass26 = obj26->class;
  objclass26->definitionModule = modulename;
  objclass26->definitionLine = 1878;
  (*(struct UserObject *)self).data[0] = lowerouter26;
  self = oldself26;
  selfslot = oldselfslot26;
  stackframe = oldstackframe26;
  gc_frame_end(frame);
  return obj26;
}
Object meth_ast_new25_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_values = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_values, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_values = &(stackframe->slots[0]);
  *var_values = var_init_values;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject26 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj26 = alloc_userobj2(10,9, objclass26);
  gc_frame_newslot(obj26);
// OBJECT OUTER DEC outer
  adddatum2(obj26, self, 0);
  addmethodreal(obj26,"outer", &reader_ast_outer_27);
  Object oldself26 = self;
  struct StackFrameObject *oldstackframe26 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe26);
  gc_frame_newslot((Object)stackframe);
  self = obj26;
  Object *oldselfslot26 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter26 = (*(struct UserObject *)self).data[0], lowerouter26 = thisouter26;
  if (inheritingObject26) {
    struct UserObject *inho26 = (struct UserObject *)inheritingObject26;
    while (inho26->super != GraceDefaultObject) inho26 = (struct UserObject *)inho26->super;
    inho26->super = obj26;
    self = inheritingObject26;
    *selfslot = self;
    lowerouter26 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter26;
  }
if (objclass26 == NULL) {
  Method *reader28 = addmethodrealflags(obj26, "kind",&reader_ast_kind_28, MFLAG_DEF);
  reader28->definitionModule = modulename;
  reader28->definitionLine = 1881;
}
adddatum2(obj26, alloc_Undefined(), 1);
if (objclass26 == NULL) {
  Method *reader29 = addmethodrealflags(obj26, "name",&reader_ast_name_29, 0);
  Method *writer29 = addmethodrealflags(obj26, "name:=",&writer_ast_name_29, 0);
  reader29->definitionModule = modulename;
  writer29->definitionModule = modulename;
  reader29->definitionLine = 1882;
  writer29->definitionLine = 1882;
}
obj26->flags |= OFLAG_MUTABLE;
adddatum2(obj26, alloc_Undefined(), 2);
if (objclass26 == NULL) {
  Method *reader30 = addmethodrealflags(obj26, "args",&reader_ast_args_30, 0);
  Method *writer30 = addmethodrealflags(obj26, "args:=",&writer_ast_args_30, 0);
  reader30->definitionModule = modulename;
  writer30->definitionModule = modulename;
  reader30->definitionLine = 1883;
  writer30->definitionLine = 1883;
}
obj26->flags |= OFLAG_MUTABLE;
adddatum2(obj26, alloc_Undefined(), 3);
  struct UserObject *uo31 = (struct UserObject*)obj26;
  uo31->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_before_40__41_after31 = addmethod2pos(obj26, "map()before()after", &meth_ast_map_40__41_before_40__41_after31, 4);
int argcv_meth_ast_map_40__41_before_40__41_after31[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after31->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after31);
  meth_meth_ast_map_40__41_before_40__41_after31->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after31->definitionLine = 1889;
  struct UserObject *uo57 = (struct UserObject*)obj26;
  uo57->data[5] = emptyclosure;
  Method *meth_meth_ast_map57 = addmethod2pos(obj26, "map", &meth_ast_map57, 5);
int argcv_meth_ast_map57[] = {1};
meth_meth_ast_map57->type = alloc_MethodType(1, argcv_meth_ast_map57);
  meth_meth_ast_map57->definitionModule = modulename;
  meth_meth_ast_map57->definitionLine = 1896;
  sourceObject = obj26;
// Begin line 1879
  setline(1879);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe66 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call67 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe66);
// compilenode returning call67
  struct UserObject *obj26_uo = (struct UserObject *)obj26;
  obj26_uo->super = call67;
  sourceObject = obj26;
// Begin line 1880
  setline(1880);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit68 == NULL) {
    strlit68 = alloc_String("callwithpart");
    gc_root(strlit68);
  }
// compilenode returning strlit68
  adddatum2(obj26, strlit68, 1);
  sourceObject = obj26;
// Begin line 1881
  setline(1881);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit69 == NULL) {
    strlit69 = alloc_String("");
    gc_root(strlit69);
  }
// compilenode returning strlit69
  adddatum2(obj26, strlit69, 2);
  sourceObject = obj26;
// Begin line 1882
  setline(1882);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array70 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array70
  adddatum2(obj26, array70, 3);
  sourceObject = obj26;
// Begin line 1886
  setline(1886);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1883
  setline(1883);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num73 = alloc_Float64(0);
// compilenode returning num73
  int op_slot_right_72 = gc_frame_newslot(num73);
  int callframe75 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call76 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe75);
// compilenode returning call76
// compilenode returning call76
  int op_slot_left_72 = gc_frame_newslot(call76);
  params[0] = num73;
  partcv[0] = 1;
  Object opresult77 = callmethod(call76, ">", 1, partcv, params);
// compilenode returning opresult77
  Object if71 = done;
struct StackFrameObject *iftmpstackframe71 = stackframe;
  if (istrue(opresult77)) {
stackframe = alloc_StackFrame(0, iftmpstackframe71);
gc_frame_newslot((Object)stackframe);
// Begin line 1885
  setline(1885);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1883
  setline(1883);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe78 = gc_frame_new();
// Begin line 1885
  setline(1885);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1884
  setline(1884);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  Object num79 = alloc_Float64(1);
// compilenode returning num79
  params[0] = num79;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres80 = callmethod(*var_values, "[]", 1, partcv, params);
// compilenode returning idxres80
  gc_frame_newslot(idxres80);
  params[0] = idxres80;
  partcv[0] = 1;
  Object call81 = callmethodflags(self, "name:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe78);
// compilenode returning call81
// compilenode returning done
    gc_frame_newslot(done);
    if71 = done;
  } else {
  }
stackframe = iftmpstackframe71;
// compilenode returning if71
  sourceObject = obj26;
// Begin line 1889
  setline(1889);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1886
  setline(1886);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num84 = alloc_Float64(1);
// compilenode returning num84
  int op_slot_right_83 = gc_frame_newslot(num84);
  int callframe86 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call87 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe86);
// compilenode returning call87
// compilenode returning call87
  int op_slot_left_83 = gc_frame_newslot(call87);
  params[0] = num84;
  partcv[0] = 1;
  Object opresult88 = callmethod(call87, ">", 1, partcv, params);
// compilenode returning opresult88
  Object if82 = done;
struct StackFrameObject *iftmpstackframe82 = stackframe;
  if (istrue(opresult88)) {
stackframe = alloc_StackFrame(0, iftmpstackframe82);
gc_frame_newslot((Object)stackframe);
// Begin line 1888
  setline(1888);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1886
  setline(1886);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe89 = gc_frame_new();
// Begin line 1888
  setline(1888);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1887
  setline(1887);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  Object num90 = alloc_Float64(2);
// compilenode returning num90
  params[0] = num90;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres91 = callmethod(*var_values, "[]", 1, partcv, params);
// compilenode returning idxres91
  gc_frame_newslot(idxres91);
  params[0] = idxres91;
  partcv[0] = 1;
  Object call92 = callmethodflags(self, "args:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe89);
// compilenode returning call92
// compilenode returning done
    gc_frame_newslot(done);
    if82 = done;
  } else {
  }
stackframe = iftmpstackframe82;
// compilenode returning if82
  sourceObject = obj26;
  sourceObject = obj26;
objclass26 = obj26->class;
  objclass26->definitionModule = modulename;
  objclass26->definitionLine = 1878;
  (*(struct UserObject *)self).data[0] = lowerouter26;
  self = oldself26;
  selfslot = oldselfslot26;
  stackframe = oldstackframe26;
  gc_frame_end(frame);
  return obj26;
}
Object meth_ast_callWithPart22(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callWithPart");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for callWithPart (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for callWithPart");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject23 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj23 = alloc_userobj2(2,4, objclass23);
  gc_frame_newslot(obj23);
// OBJECT OUTER DEC outer
  adddatum2(obj23, self, 0);
  addmethodreal(obj23,"outer", &reader_ast_outer_24);
  Object oldself23 = self;
  struct StackFrameObject *oldstackframe23 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe23);
  gc_frame_newslot((Object)stackframe);
  self = obj23;
  Object *oldselfslot23 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter23 = (*(struct UserObject *)self).data[0], lowerouter23 = thisouter23;
  if (inheritingObject23) {
    struct UserObject *inho23 = (struct UserObject *)inheritingObject23;
    while (inho23->super != GraceDefaultObject) inho23 = (struct UserObject *)inho23->super;
    inho23->super = obj23;
    self = inheritingObject23;
    *selfslot = self;
    lowerouter23 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter23;
  }
  block_savedest(obj23);
  Object closure25 = createclosure(1, "new");
setclosureframe(closure25, stackframe);
  addtoclosure(closure25, var_baseNode);
  struct UserObject *uo25 = (struct UserObject*)obj23;
  uo25->data[1] = (Object)closure25;
  Method *meth_meth_ast_new25 = addmethod2pos(obj23, "new", &meth_ast_new25, 1);
int argcv_meth_ast_new25[] = {0};
meth_meth_ast_new25->type = alloc_MethodType(1, argcv_meth_ast_new25);
  meth_meth_ast_new25->definitionModule = modulename;
  meth_meth_ast_new25->definitionLine = 1877;
  block_savedest(obj23);
  Object closure93 = createclosure(1, "new()object");
setclosureframe(closure93, stackframe);
  addtoclosure(closure93, var_baseNode);
  Method *meth_meth_ast_new25_object = addmethod2pos(obj23, "new()object", &meth_ast_new25_object, 1);
  meth_meth_ast_new25_object->definitionModule = modulename;
  meth_meth_ast_new25_object->definitionLine = 1877;
  sourceObject = obj23;
objclass23 = obj23->class;
  objclass23->definitionModule = modulename;
  objclass23->definitionLine = 1876;
  (*(struct UserObject *)self).data[0] = lowerouter23;
  self = oldself23;
  selfslot = oldselfslot23;
  stackframe = oldstackframe23;
  gc_frame_end(frame);
  return obj23;
}
Object meth_ast_callWithPart22_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callWithPart()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for callWithPart (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for callWithPart");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject23 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj23 = alloc_userobj2(2,4, objclass23);
  gc_frame_newslot(obj23);
// OBJECT OUTER DEC outer
  adddatum2(obj23, self, 0);
  addmethodreal(obj23,"outer", &reader_ast_outer_24);
  Object oldself23 = self;
  struct StackFrameObject *oldstackframe23 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe23);
  gc_frame_newslot((Object)stackframe);
  self = obj23;
  Object *oldselfslot23 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter23 = (*(struct UserObject *)self).data[0], lowerouter23 = thisouter23;
  if (inheritingObject23) {
    struct UserObject *inho23 = (struct UserObject *)inheritingObject23;
    while (inho23->super != GraceDefaultObject) inho23 = (struct UserObject *)inho23->super;
    inho23->super = obj23;
    self = inheritingObject23;
    *selfslot = self;
    lowerouter23 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter23;
  }
  block_savedest(obj23);
  Object closure25 = createclosure(1, "new");
setclosureframe(closure25, stackframe);
  addtoclosure(closure25, var_baseNode);
  struct UserObject *uo25 = (struct UserObject*)obj23;
  uo25->data[1] = (Object)closure25;
  Method *meth_meth_ast_new25 = addmethod2pos(obj23, "new", &meth_ast_new25, 1);
int argcv_meth_ast_new25[] = {0};
meth_meth_ast_new25->type = alloc_MethodType(1, argcv_meth_ast_new25);
  meth_meth_ast_new25->definitionModule = modulename;
  meth_meth_ast_new25->definitionLine = 1877;
  block_savedest(obj23);
  Object closure93 = createclosure(1, "new()object");
setclosureframe(closure93, stackframe);
  addtoclosure(closure93, var_baseNode);
  Method *meth_meth_ast_new25_object = addmethod2pos(obj23, "new()object", &meth_ast_new25_object, 1);
  meth_meth_ast_new25_object->definitionModule = modulename;
  meth_meth_ast_new25_object->definitionLine = 1877;
  sourceObject = obj23;
objclass23 = obj23->class;
  objclass23->definitionModule = modulename;
  objclass23->definitionLine = 1876;
  (*(struct UserObject *)self).data[0] = lowerouter23;
  self = oldself23;
  selfslot = oldselfslot23;
  stackframe = oldstackframe23;
  gc_frame_end(frame);
  return obj23;
}
Object meth_ast_ASTVisitor96(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ASTVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ASTVisitor = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for ASTVisitor (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for ASTVisitor");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// compilenode returning *var_ASTVisitor
  gc_frame_end(frame);
  return *var_ASTVisitor;
}
Object meth_ast_visitFor100(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitFor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitFor (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitFor");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1937
  setline(1937);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool101 = alloc_Boolean(1);
// compilenode returning bool101
  gc_frame_end(frame);
  return bool101;
}
Object meth_ast_visitWhile102(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitWhile");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitWhile (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitWhile");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool103 = alloc_Boolean(1);
// compilenode returning bool103
  gc_frame_end(frame);
  return bool103;
}
Object meth_ast_visitIf104(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitIf (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitIf");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1943
  setline(1943);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool105 = alloc_Boolean(1);
// compilenode returning bool105
  gc_frame_end(frame);
  return bool105;
}
Object meth_ast_visitBlock106(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitBlock (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitBlock");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1946
  setline(1946);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool107 = alloc_Boolean(1);
// compilenode returning bool107
  gc_frame_end(frame);
  return bool107;
}
Object meth_ast_visitMatchCase108(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMatchCase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitMatchCase (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitMatchCase");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1949
  setline(1949);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool109 = alloc_Boolean(1);
// compilenode returning bool109
  gc_frame_end(frame);
  return bool109;
}
Object meth_ast_visitCatchCase110(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCatchCase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitCatchCase (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitCatchCase");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1952
  setline(1952);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool111 = alloc_Boolean(1);
// compilenode returning bool111
  gc_frame_end(frame);
  return bool111;
}
Object meth_ast_visitMethodType112(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethodType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitMethodType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitMethodType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1955
  setline(1955);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool113 = alloc_Boolean(1);
// compilenode returning bool113
  gc_frame_end(frame);
  return bool113;
}
Object meth_ast_visitType114(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1958
  setline(1958);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool115 = alloc_Boolean(1);
// compilenode returning bool115
  gc_frame_end(frame);
  return bool115;
}
Object meth_ast_visitMethod116(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethod");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitMethod (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitMethod");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1961
  setline(1961);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool117 = alloc_Boolean(1);
// compilenode returning bool117
  gc_frame_end(frame);
  return bool117;
}
Object meth_ast_visitCall118(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitCall (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitCall");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1964
  setline(1964);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool119 = alloc_Boolean(1);
// compilenode returning bool119
  gc_frame_end(frame);
  return bool119;
}
Object meth_ast_visitClass120(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitClass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitClass (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitClass");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1967
  setline(1967);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool121 = alloc_Boolean(1);
// compilenode returning bool121
  gc_frame_end(frame);
  return bool121;
}
Object meth_ast_visitObject122(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitObject (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitObject");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1970
  setline(1970);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool123 = alloc_Boolean(1);
// compilenode returning bool123
  gc_frame_end(frame);
  return bool123;
}
Object meth_ast_visitArray124(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitArray");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitArray (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitArray");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1973
  setline(1973);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool125 = alloc_Boolean(1);
// compilenode returning bool125
  gc_frame_end(frame);
  return bool125;
}
Object meth_ast_visitMember126(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitMember (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitMember");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1976
  setline(1976);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool127 = alloc_Boolean(1);
// compilenode returning bool127
  gc_frame_end(frame);
  return bool127;
}
Object meth_ast_visitGeneric128(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitGeneric");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitGeneric (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitGeneric");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1979
  setline(1979);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool129 = alloc_Boolean(1);
// compilenode returning bool129
  gc_frame_end(frame);
  return bool129;
}
Object meth_ast_visitIdentifier130(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitIdentifier");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1982
  setline(1982);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool131 = alloc_Boolean(1);
// compilenode returning bool131
  gc_frame_end(frame);
  return bool131;
}
Object meth_ast_visitOctets132(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitOctets");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitOctets (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitOctets");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1985
  setline(1985);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool133 = alloc_Boolean(1);
// compilenode returning bool133
  gc_frame_end(frame);
  return bool133;
}
Object meth_ast_visitString134(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitString (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitString");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1988
  setline(1988);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool135 = alloc_Boolean(1);
// compilenode returning bool135
  gc_frame_end(frame);
  return bool135;
}
Object meth_ast_visitNum136(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitNum");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitNum (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitNum");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool137 = alloc_Boolean(1);
// compilenode returning bool137
  gc_frame_end(frame);
  return bool137;
}
Object meth_ast_visitOp138(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitOp");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitOp (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitOp");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1994
  setline(1994);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool139 = alloc_Boolean(1);
// compilenode returning bool139
  gc_frame_end(frame);
  return bool139;
}
Object meth_ast_visitIndex140(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIndex");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitIndex (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitIndex");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1997
  setline(1997);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool141 = alloc_Boolean(1);
// compilenode returning bool141
  gc_frame_end(frame);
  return bool141;
}
Object meth_ast_visitBind142(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitBind (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitBind");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2000
  setline(2000);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool143 = alloc_Boolean(1);
// compilenode returning bool143
  gc_frame_end(frame);
  return bool143;
}
Object meth_ast_visitDefDec144(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDefDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitDefDec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitDefDec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2003
  setline(2003);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool145 = alloc_Boolean(1);
// compilenode returning bool145
  gc_frame_end(frame);
  return bool145;
}
Object meth_ast_visitVarDec146(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitVarDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitVarDec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitVarDec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2006
  setline(2006);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool147 = alloc_Boolean(1);
// compilenode returning bool147
  gc_frame_end(frame);
  return bool147;
}
Object meth_ast_visitImport148(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitImport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitImport (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitImport");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2009
  setline(2009);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool149 = alloc_Boolean(1);
// compilenode returning bool149
  gc_frame_end(frame);
  return bool149;
}
Object meth_ast_visitReturn150(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitReturn");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitReturn (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitReturn");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2012
  setline(2012);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool151 = alloc_Boolean(1);
// compilenode returning bool151
  gc_frame_end(frame);
  return bool151;
}
Object meth_ast_visitInherits152(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitInherits");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitInherits (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitInherits");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2015
  setline(2015);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool153 = alloc_Boolean(1);
// compilenode returning bool153
  gc_frame_end(frame);
  return bool153;
}
Object meth_ast_visitDialect154(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitDialect (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitDialect");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2018
  setline(2018);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool155 = alloc_Boolean(1);
// compilenode returning bool155
  gc_frame_end(frame);
  return bool155;
}
Object meth_ast_baseVisitor97(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "baseVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for baseVisitor (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for baseVisitor");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject98 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj98 = alloc_userobj2(28,29, objclass98);
  gc_frame_newslot(obj98);
// OBJECT OUTER DEC outer
  adddatum2(obj98, self, 0);
  addmethodreal(obj98,"outer", &reader_ast_outer_99);
  Object oldself98 = self;
  struct StackFrameObject *oldstackframe98 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe98);
  gc_frame_newslot((Object)stackframe);
  self = obj98;
  Object *oldselfslot98 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter98 = (*(struct UserObject *)self).data[0], lowerouter98 = thisouter98;
  if (inheritingObject98) {
    struct UserObject *inho98 = (struct UserObject *)inheritingObject98;
    while (inho98->super != GraceDefaultObject) inho98 = (struct UserObject *)inho98->super;
    inho98->super = obj98;
    self = inheritingObject98;
    *selfslot = self;
    lowerouter98 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter98;
  }
  struct UserObject *uo100 = (struct UserObject*)obj98;
  uo100->data[1] = emptyclosure;
  Method *meth_meth_ast_visitFor100 = addmethod2pos(obj98, "visitFor", &meth_ast_visitFor100, 1);
int argcv_meth_ast_visitFor100[] = {1};
meth_meth_ast_visitFor100->type = alloc_MethodType(1, argcv_meth_ast_visitFor100);
  meth_meth_ast_visitFor100->definitionModule = modulename;
  meth_meth_ast_visitFor100->definitionLine = 1936;
  struct UserObject *uo102 = (struct UserObject*)obj98;
  uo102->data[2] = emptyclosure;
  Method *meth_meth_ast_visitWhile102 = addmethod2pos(obj98, "visitWhile", &meth_ast_visitWhile102, 2);
int argcv_meth_ast_visitWhile102[] = {1};
meth_meth_ast_visitWhile102->type = alloc_MethodType(1, argcv_meth_ast_visitWhile102);
  meth_meth_ast_visitWhile102->definitionModule = modulename;
  meth_meth_ast_visitWhile102->definitionLine = 1939;
  struct UserObject *uo104 = (struct UserObject*)obj98;
  uo104->data[3] = emptyclosure;
  Method *meth_meth_ast_visitIf104 = addmethod2pos(obj98, "visitIf", &meth_ast_visitIf104, 3);
int argcv_meth_ast_visitIf104[] = {1};
meth_meth_ast_visitIf104->type = alloc_MethodType(1, argcv_meth_ast_visitIf104);
  meth_meth_ast_visitIf104->definitionModule = modulename;
  meth_meth_ast_visitIf104->definitionLine = 1942;
  struct UserObject *uo106 = (struct UserObject*)obj98;
  uo106->data[4] = emptyclosure;
  Method *meth_meth_ast_visitBlock106 = addmethod2pos(obj98, "visitBlock", &meth_ast_visitBlock106, 4);
int argcv_meth_ast_visitBlock106[] = {1};
meth_meth_ast_visitBlock106->type = alloc_MethodType(1, argcv_meth_ast_visitBlock106);
  meth_meth_ast_visitBlock106->definitionModule = modulename;
  meth_meth_ast_visitBlock106->definitionLine = 1945;
  struct UserObject *uo108 = (struct UserObject*)obj98;
  uo108->data[5] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase108 = addmethod2pos(obj98, "visitMatchCase", &meth_ast_visitMatchCase108, 5);
int argcv_meth_ast_visitMatchCase108[] = {1};
meth_meth_ast_visitMatchCase108->type = alloc_MethodType(1, argcv_meth_ast_visitMatchCase108);
  meth_meth_ast_visitMatchCase108->definitionModule = modulename;
  meth_meth_ast_visitMatchCase108->definitionLine = 1948;
  struct UserObject *uo110 = (struct UserObject*)obj98;
  uo110->data[6] = emptyclosure;
  Method *meth_meth_ast_visitCatchCase110 = addmethod2pos(obj98, "visitCatchCase", &meth_ast_visitCatchCase110, 6);
int argcv_meth_ast_visitCatchCase110[] = {1};
meth_meth_ast_visitCatchCase110->type = alloc_MethodType(1, argcv_meth_ast_visitCatchCase110);
  meth_meth_ast_visitCatchCase110->definitionModule = modulename;
  meth_meth_ast_visitCatchCase110->definitionLine = 1951;
  struct UserObject *uo112 = (struct UserObject*)obj98;
  uo112->data[7] = emptyclosure;
  Method *meth_meth_ast_visitMethodType112 = addmethod2pos(obj98, "visitMethodType", &meth_ast_visitMethodType112, 7);
int argcv_meth_ast_visitMethodType112[] = {1};
meth_meth_ast_visitMethodType112->type = alloc_MethodType(1, argcv_meth_ast_visitMethodType112);
  meth_meth_ast_visitMethodType112->definitionModule = modulename;
  meth_meth_ast_visitMethodType112->definitionLine = 1954;
  struct UserObject *uo114 = (struct UserObject*)obj98;
  uo114->data[8] = emptyclosure;
  Method *meth_meth_ast_visitType114 = addmethod2pos(obj98, "visitType", &meth_ast_visitType114, 8);
int argcv_meth_ast_visitType114[] = {1};
meth_meth_ast_visitType114->type = alloc_MethodType(1, argcv_meth_ast_visitType114);
  meth_meth_ast_visitType114->definitionModule = modulename;
  meth_meth_ast_visitType114->definitionLine = 1957;
  struct UserObject *uo116 = (struct UserObject*)obj98;
  uo116->data[9] = emptyclosure;
  Method *meth_meth_ast_visitMethod116 = addmethod2pos(obj98, "visitMethod", &meth_ast_visitMethod116, 9);
int argcv_meth_ast_visitMethod116[] = {1};
meth_meth_ast_visitMethod116->type = alloc_MethodType(1, argcv_meth_ast_visitMethod116);
  meth_meth_ast_visitMethod116->definitionModule = modulename;
  meth_meth_ast_visitMethod116->definitionLine = 1960;
  struct UserObject *uo118 = (struct UserObject*)obj98;
  uo118->data[10] = emptyclosure;
  Method *meth_meth_ast_visitCall118 = addmethod2pos(obj98, "visitCall", &meth_ast_visitCall118, 10);
int argcv_meth_ast_visitCall118[] = {1};
meth_meth_ast_visitCall118->type = alloc_MethodType(1, argcv_meth_ast_visitCall118);
  meth_meth_ast_visitCall118->definitionModule = modulename;
  meth_meth_ast_visitCall118->definitionLine = 1963;
  struct UserObject *uo120 = (struct UserObject*)obj98;
  uo120->data[11] = emptyclosure;
  Method *meth_meth_ast_visitClass120 = addmethod2pos(obj98, "visitClass", &meth_ast_visitClass120, 11);
int argcv_meth_ast_visitClass120[] = {1};
meth_meth_ast_visitClass120->type = alloc_MethodType(1, argcv_meth_ast_visitClass120);
  meth_meth_ast_visitClass120->definitionModule = modulename;
  meth_meth_ast_visitClass120->definitionLine = 1966;
  struct UserObject *uo122 = (struct UserObject*)obj98;
  uo122->data[12] = emptyclosure;
  Method *meth_meth_ast_visitObject122 = addmethod2pos(obj98, "visitObject", &meth_ast_visitObject122, 12);
int argcv_meth_ast_visitObject122[] = {1};
meth_meth_ast_visitObject122->type = alloc_MethodType(1, argcv_meth_ast_visitObject122);
  meth_meth_ast_visitObject122->definitionModule = modulename;
  meth_meth_ast_visitObject122->definitionLine = 1969;
  struct UserObject *uo124 = (struct UserObject*)obj98;
  uo124->data[13] = emptyclosure;
  Method *meth_meth_ast_visitArray124 = addmethod2pos(obj98, "visitArray", &meth_ast_visitArray124, 13);
int argcv_meth_ast_visitArray124[] = {1};
meth_meth_ast_visitArray124->type = alloc_MethodType(1, argcv_meth_ast_visitArray124);
  meth_meth_ast_visitArray124->definitionModule = modulename;
  meth_meth_ast_visitArray124->definitionLine = 1972;
  struct UserObject *uo126 = (struct UserObject*)obj98;
  uo126->data[14] = emptyclosure;
  Method *meth_meth_ast_visitMember126 = addmethod2pos(obj98, "visitMember", &meth_ast_visitMember126, 14);
int argcv_meth_ast_visitMember126[] = {1};
meth_meth_ast_visitMember126->type = alloc_MethodType(1, argcv_meth_ast_visitMember126);
  meth_meth_ast_visitMember126->definitionModule = modulename;
  meth_meth_ast_visitMember126->definitionLine = 1975;
  struct UserObject *uo128 = (struct UserObject*)obj98;
  uo128->data[15] = emptyclosure;
  Method *meth_meth_ast_visitGeneric128 = addmethod2pos(obj98, "visitGeneric", &meth_ast_visitGeneric128, 15);
int argcv_meth_ast_visitGeneric128[] = {1};
meth_meth_ast_visitGeneric128->type = alloc_MethodType(1, argcv_meth_ast_visitGeneric128);
  meth_meth_ast_visitGeneric128->definitionModule = modulename;
  meth_meth_ast_visitGeneric128->definitionLine = 1978;
  struct UserObject *uo130 = (struct UserObject*)obj98;
  uo130->data[16] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier130 = addmethod2pos(obj98, "visitIdentifier", &meth_ast_visitIdentifier130, 16);
int argcv_meth_ast_visitIdentifier130[] = {1};
meth_meth_ast_visitIdentifier130->type = alloc_MethodType(1, argcv_meth_ast_visitIdentifier130);
  meth_meth_ast_visitIdentifier130->definitionModule = modulename;
  meth_meth_ast_visitIdentifier130->definitionLine = 1981;
  struct UserObject *uo132 = (struct UserObject*)obj98;
  uo132->data[17] = emptyclosure;
  Method *meth_meth_ast_visitOctets132 = addmethod2pos(obj98, "visitOctets", &meth_ast_visitOctets132, 17);
int argcv_meth_ast_visitOctets132[] = {1};
meth_meth_ast_visitOctets132->type = alloc_MethodType(1, argcv_meth_ast_visitOctets132);
  meth_meth_ast_visitOctets132->definitionModule = modulename;
  meth_meth_ast_visitOctets132->definitionLine = 1984;
  struct UserObject *uo134 = (struct UserObject*)obj98;
  uo134->data[18] = emptyclosure;
  Method *meth_meth_ast_visitString134 = addmethod2pos(obj98, "visitString", &meth_ast_visitString134, 18);
int argcv_meth_ast_visitString134[] = {1};
meth_meth_ast_visitString134->type = alloc_MethodType(1, argcv_meth_ast_visitString134);
  meth_meth_ast_visitString134->definitionModule = modulename;
  meth_meth_ast_visitString134->definitionLine = 1987;
  struct UserObject *uo136 = (struct UserObject*)obj98;
  uo136->data[19] = emptyclosure;
  Method *meth_meth_ast_visitNum136 = addmethod2pos(obj98, "visitNum", &meth_ast_visitNum136, 19);
int argcv_meth_ast_visitNum136[] = {1};
meth_meth_ast_visitNum136->type = alloc_MethodType(1, argcv_meth_ast_visitNum136);
  meth_meth_ast_visitNum136->definitionModule = modulename;
  meth_meth_ast_visitNum136->definitionLine = 1990;
  struct UserObject *uo138 = (struct UserObject*)obj98;
  uo138->data[20] = emptyclosure;
  Method *meth_meth_ast_visitOp138 = addmethod2pos(obj98, "visitOp", &meth_ast_visitOp138, 20);
int argcv_meth_ast_visitOp138[] = {1};
meth_meth_ast_visitOp138->type = alloc_MethodType(1, argcv_meth_ast_visitOp138);
  meth_meth_ast_visitOp138->definitionModule = modulename;
  meth_meth_ast_visitOp138->definitionLine = 1993;
  struct UserObject *uo140 = (struct UserObject*)obj98;
  uo140->data[21] = emptyclosure;
  Method *meth_meth_ast_visitIndex140 = addmethod2pos(obj98, "visitIndex", &meth_ast_visitIndex140, 21);
int argcv_meth_ast_visitIndex140[] = {1};
meth_meth_ast_visitIndex140->type = alloc_MethodType(1, argcv_meth_ast_visitIndex140);
  meth_meth_ast_visitIndex140->definitionModule = modulename;
  meth_meth_ast_visitIndex140->definitionLine = 1996;
  struct UserObject *uo142 = (struct UserObject*)obj98;
  uo142->data[22] = emptyclosure;
  Method *meth_meth_ast_visitBind142 = addmethod2pos(obj98, "visitBind", &meth_ast_visitBind142, 22);
int argcv_meth_ast_visitBind142[] = {1};
meth_meth_ast_visitBind142->type = alloc_MethodType(1, argcv_meth_ast_visitBind142);
  meth_meth_ast_visitBind142->definitionModule = modulename;
  meth_meth_ast_visitBind142->definitionLine = 1999;
  struct UserObject *uo144 = (struct UserObject*)obj98;
  uo144->data[23] = emptyclosure;
  Method *meth_meth_ast_visitDefDec144 = addmethod2pos(obj98, "visitDefDec", &meth_ast_visitDefDec144, 23);
int argcv_meth_ast_visitDefDec144[] = {1};
meth_meth_ast_visitDefDec144->type = alloc_MethodType(1, argcv_meth_ast_visitDefDec144);
  meth_meth_ast_visitDefDec144->definitionModule = modulename;
  meth_meth_ast_visitDefDec144->definitionLine = 2002;
  struct UserObject *uo146 = (struct UserObject*)obj98;
  uo146->data[24] = emptyclosure;
  Method *meth_meth_ast_visitVarDec146 = addmethod2pos(obj98, "visitVarDec", &meth_ast_visitVarDec146, 24);
int argcv_meth_ast_visitVarDec146[] = {1};
meth_meth_ast_visitVarDec146->type = alloc_MethodType(1, argcv_meth_ast_visitVarDec146);
  meth_meth_ast_visitVarDec146->definitionModule = modulename;
  meth_meth_ast_visitVarDec146->definitionLine = 2005;
  struct UserObject *uo148 = (struct UserObject*)obj98;
  uo148->data[25] = emptyclosure;
  Method *meth_meth_ast_visitImport148 = addmethod2pos(obj98, "visitImport", &meth_ast_visitImport148, 25);
int argcv_meth_ast_visitImport148[] = {1};
meth_meth_ast_visitImport148->type = alloc_MethodType(1, argcv_meth_ast_visitImport148);
  meth_meth_ast_visitImport148->definitionModule = modulename;
  meth_meth_ast_visitImport148->definitionLine = 2008;
  struct UserObject *uo150 = (struct UserObject*)obj98;
  uo150->data[26] = emptyclosure;
  Method *meth_meth_ast_visitReturn150 = addmethod2pos(obj98, "visitReturn", &meth_ast_visitReturn150, 26);
int argcv_meth_ast_visitReturn150[] = {1};
meth_meth_ast_visitReturn150->type = alloc_MethodType(1, argcv_meth_ast_visitReturn150);
  meth_meth_ast_visitReturn150->definitionModule = modulename;
  meth_meth_ast_visitReturn150->definitionLine = 2011;
  struct UserObject *uo152 = (struct UserObject*)obj98;
  uo152->data[27] = emptyclosure;
  Method *meth_meth_ast_visitInherits152 = addmethod2pos(obj98, "visitInherits", &meth_ast_visitInherits152, 27);
int argcv_meth_ast_visitInherits152[] = {1};
meth_meth_ast_visitInherits152->type = alloc_MethodType(1, argcv_meth_ast_visitInherits152);
  meth_meth_ast_visitInherits152->definitionModule = modulename;
  meth_meth_ast_visitInherits152->definitionLine = 2014;
  struct UserObject *uo154 = (struct UserObject*)obj98;
  uo154->data[28] = emptyclosure;
  Method *meth_meth_ast_visitDialect154 = addmethod2pos(obj98, "visitDialect", &meth_ast_visitDialect154, 28);
int argcv_meth_ast_visitDialect154[] = {1};
meth_meth_ast_visitDialect154->type = alloc_MethodType(1, argcv_meth_ast_visitDialect154);
  meth_meth_ast_visitDialect154->definitionModule = modulename;
  meth_meth_ast_visitDialect154->definitionLine = 2017;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
objclass98 = obj98->class;
  objclass98->definitionModule = modulename;
  objclass98->definitionLine = 1935;
  (*(struct UserObject *)self).data[0] = lowerouter98;
  self = oldself98;
  selfslot = oldselfslot98;
  stackframe = oldstackframe98;
  gc_frame_end(frame);
  return obj98;
}
Object meth_ast_baseVisitor97_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "baseVisitor()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for baseVisitor (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for baseVisitor");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject98 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj98 = alloc_userobj2(28,29, objclass98);
  gc_frame_newslot(obj98);
// OBJECT OUTER DEC outer
  adddatum2(obj98, self, 0);
  addmethodreal(obj98,"outer", &reader_ast_outer_99);
  Object oldself98 = self;
  struct StackFrameObject *oldstackframe98 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe98);
  gc_frame_newslot((Object)stackframe);
  self = obj98;
  Object *oldselfslot98 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter98 = (*(struct UserObject *)self).data[0], lowerouter98 = thisouter98;
  if (inheritingObject98) {
    struct UserObject *inho98 = (struct UserObject *)inheritingObject98;
    while (inho98->super != GraceDefaultObject) inho98 = (struct UserObject *)inho98->super;
    inho98->super = obj98;
    self = inheritingObject98;
    *selfslot = self;
    lowerouter98 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter98;
  }
  struct UserObject *uo100 = (struct UserObject*)obj98;
  uo100->data[1] = emptyclosure;
  Method *meth_meth_ast_visitFor100 = addmethod2pos(obj98, "visitFor", &meth_ast_visitFor100, 1);
int argcv_meth_ast_visitFor100[] = {1};
meth_meth_ast_visitFor100->type = alloc_MethodType(1, argcv_meth_ast_visitFor100);
  meth_meth_ast_visitFor100->definitionModule = modulename;
  meth_meth_ast_visitFor100->definitionLine = 1936;
  struct UserObject *uo102 = (struct UserObject*)obj98;
  uo102->data[2] = emptyclosure;
  Method *meth_meth_ast_visitWhile102 = addmethod2pos(obj98, "visitWhile", &meth_ast_visitWhile102, 2);
int argcv_meth_ast_visitWhile102[] = {1};
meth_meth_ast_visitWhile102->type = alloc_MethodType(1, argcv_meth_ast_visitWhile102);
  meth_meth_ast_visitWhile102->definitionModule = modulename;
  meth_meth_ast_visitWhile102->definitionLine = 1939;
  struct UserObject *uo104 = (struct UserObject*)obj98;
  uo104->data[3] = emptyclosure;
  Method *meth_meth_ast_visitIf104 = addmethod2pos(obj98, "visitIf", &meth_ast_visitIf104, 3);
int argcv_meth_ast_visitIf104[] = {1};
meth_meth_ast_visitIf104->type = alloc_MethodType(1, argcv_meth_ast_visitIf104);
  meth_meth_ast_visitIf104->definitionModule = modulename;
  meth_meth_ast_visitIf104->definitionLine = 1942;
  struct UserObject *uo106 = (struct UserObject*)obj98;
  uo106->data[4] = emptyclosure;
  Method *meth_meth_ast_visitBlock106 = addmethod2pos(obj98, "visitBlock", &meth_ast_visitBlock106, 4);
int argcv_meth_ast_visitBlock106[] = {1};
meth_meth_ast_visitBlock106->type = alloc_MethodType(1, argcv_meth_ast_visitBlock106);
  meth_meth_ast_visitBlock106->definitionModule = modulename;
  meth_meth_ast_visitBlock106->definitionLine = 1945;
  struct UserObject *uo108 = (struct UserObject*)obj98;
  uo108->data[5] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase108 = addmethod2pos(obj98, "visitMatchCase", &meth_ast_visitMatchCase108, 5);
int argcv_meth_ast_visitMatchCase108[] = {1};
meth_meth_ast_visitMatchCase108->type = alloc_MethodType(1, argcv_meth_ast_visitMatchCase108);
  meth_meth_ast_visitMatchCase108->definitionModule = modulename;
  meth_meth_ast_visitMatchCase108->definitionLine = 1948;
  struct UserObject *uo110 = (struct UserObject*)obj98;
  uo110->data[6] = emptyclosure;
  Method *meth_meth_ast_visitCatchCase110 = addmethod2pos(obj98, "visitCatchCase", &meth_ast_visitCatchCase110, 6);
int argcv_meth_ast_visitCatchCase110[] = {1};
meth_meth_ast_visitCatchCase110->type = alloc_MethodType(1, argcv_meth_ast_visitCatchCase110);
  meth_meth_ast_visitCatchCase110->definitionModule = modulename;
  meth_meth_ast_visitCatchCase110->definitionLine = 1951;
  struct UserObject *uo112 = (struct UserObject*)obj98;
  uo112->data[7] = emptyclosure;
  Method *meth_meth_ast_visitMethodType112 = addmethod2pos(obj98, "visitMethodType", &meth_ast_visitMethodType112, 7);
int argcv_meth_ast_visitMethodType112[] = {1};
meth_meth_ast_visitMethodType112->type = alloc_MethodType(1, argcv_meth_ast_visitMethodType112);
  meth_meth_ast_visitMethodType112->definitionModule = modulename;
  meth_meth_ast_visitMethodType112->definitionLine = 1954;
  struct UserObject *uo114 = (struct UserObject*)obj98;
  uo114->data[8] = emptyclosure;
  Method *meth_meth_ast_visitType114 = addmethod2pos(obj98, "visitType", &meth_ast_visitType114, 8);
int argcv_meth_ast_visitType114[] = {1};
meth_meth_ast_visitType114->type = alloc_MethodType(1, argcv_meth_ast_visitType114);
  meth_meth_ast_visitType114->definitionModule = modulename;
  meth_meth_ast_visitType114->definitionLine = 1957;
  struct UserObject *uo116 = (struct UserObject*)obj98;
  uo116->data[9] = emptyclosure;
  Method *meth_meth_ast_visitMethod116 = addmethod2pos(obj98, "visitMethod", &meth_ast_visitMethod116, 9);
int argcv_meth_ast_visitMethod116[] = {1};
meth_meth_ast_visitMethod116->type = alloc_MethodType(1, argcv_meth_ast_visitMethod116);
  meth_meth_ast_visitMethod116->definitionModule = modulename;
  meth_meth_ast_visitMethod116->definitionLine = 1960;
  struct UserObject *uo118 = (struct UserObject*)obj98;
  uo118->data[10] = emptyclosure;
  Method *meth_meth_ast_visitCall118 = addmethod2pos(obj98, "visitCall", &meth_ast_visitCall118, 10);
int argcv_meth_ast_visitCall118[] = {1};
meth_meth_ast_visitCall118->type = alloc_MethodType(1, argcv_meth_ast_visitCall118);
  meth_meth_ast_visitCall118->definitionModule = modulename;
  meth_meth_ast_visitCall118->definitionLine = 1963;
  struct UserObject *uo120 = (struct UserObject*)obj98;
  uo120->data[11] = emptyclosure;
  Method *meth_meth_ast_visitClass120 = addmethod2pos(obj98, "visitClass", &meth_ast_visitClass120, 11);
int argcv_meth_ast_visitClass120[] = {1};
meth_meth_ast_visitClass120->type = alloc_MethodType(1, argcv_meth_ast_visitClass120);
  meth_meth_ast_visitClass120->definitionModule = modulename;
  meth_meth_ast_visitClass120->definitionLine = 1966;
  struct UserObject *uo122 = (struct UserObject*)obj98;
  uo122->data[12] = emptyclosure;
  Method *meth_meth_ast_visitObject122 = addmethod2pos(obj98, "visitObject", &meth_ast_visitObject122, 12);
int argcv_meth_ast_visitObject122[] = {1};
meth_meth_ast_visitObject122->type = alloc_MethodType(1, argcv_meth_ast_visitObject122);
  meth_meth_ast_visitObject122->definitionModule = modulename;
  meth_meth_ast_visitObject122->definitionLine = 1969;
  struct UserObject *uo124 = (struct UserObject*)obj98;
  uo124->data[13] = emptyclosure;
  Method *meth_meth_ast_visitArray124 = addmethod2pos(obj98, "visitArray", &meth_ast_visitArray124, 13);
int argcv_meth_ast_visitArray124[] = {1};
meth_meth_ast_visitArray124->type = alloc_MethodType(1, argcv_meth_ast_visitArray124);
  meth_meth_ast_visitArray124->definitionModule = modulename;
  meth_meth_ast_visitArray124->definitionLine = 1972;
  struct UserObject *uo126 = (struct UserObject*)obj98;
  uo126->data[14] = emptyclosure;
  Method *meth_meth_ast_visitMember126 = addmethod2pos(obj98, "visitMember", &meth_ast_visitMember126, 14);
int argcv_meth_ast_visitMember126[] = {1};
meth_meth_ast_visitMember126->type = alloc_MethodType(1, argcv_meth_ast_visitMember126);
  meth_meth_ast_visitMember126->definitionModule = modulename;
  meth_meth_ast_visitMember126->definitionLine = 1975;
  struct UserObject *uo128 = (struct UserObject*)obj98;
  uo128->data[15] = emptyclosure;
  Method *meth_meth_ast_visitGeneric128 = addmethod2pos(obj98, "visitGeneric", &meth_ast_visitGeneric128, 15);
int argcv_meth_ast_visitGeneric128[] = {1};
meth_meth_ast_visitGeneric128->type = alloc_MethodType(1, argcv_meth_ast_visitGeneric128);
  meth_meth_ast_visitGeneric128->definitionModule = modulename;
  meth_meth_ast_visitGeneric128->definitionLine = 1978;
  struct UserObject *uo130 = (struct UserObject*)obj98;
  uo130->data[16] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier130 = addmethod2pos(obj98, "visitIdentifier", &meth_ast_visitIdentifier130, 16);
int argcv_meth_ast_visitIdentifier130[] = {1};
meth_meth_ast_visitIdentifier130->type = alloc_MethodType(1, argcv_meth_ast_visitIdentifier130);
  meth_meth_ast_visitIdentifier130->definitionModule = modulename;
  meth_meth_ast_visitIdentifier130->definitionLine = 1981;
  struct UserObject *uo132 = (struct UserObject*)obj98;
  uo132->data[17] = emptyclosure;
  Method *meth_meth_ast_visitOctets132 = addmethod2pos(obj98, "visitOctets", &meth_ast_visitOctets132, 17);
int argcv_meth_ast_visitOctets132[] = {1};
meth_meth_ast_visitOctets132->type = alloc_MethodType(1, argcv_meth_ast_visitOctets132);
  meth_meth_ast_visitOctets132->definitionModule = modulename;
  meth_meth_ast_visitOctets132->definitionLine = 1984;
  struct UserObject *uo134 = (struct UserObject*)obj98;
  uo134->data[18] = emptyclosure;
  Method *meth_meth_ast_visitString134 = addmethod2pos(obj98, "visitString", &meth_ast_visitString134, 18);
int argcv_meth_ast_visitString134[] = {1};
meth_meth_ast_visitString134->type = alloc_MethodType(1, argcv_meth_ast_visitString134);
  meth_meth_ast_visitString134->definitionModule = modulename;
  meth_meth_ast_visitString134->definitionLine = 1987;
  struct UserObject *uo136 = (struct UserObject*)obj98;
  uo136->data[19] = emptyclosure;
  Method *meth_meth_ast_visitNum136 = addmethod2pos(obj98, "visitNum", &meth_ast_visitNum136, 19);
int argcv_meth_ast_visitNum136[] = {1};
meth_meth_ast_visitNum136->type = alloc_MethodType(1, argcv_meth_ast_visitNum136);
  meth_meth_ast_visitNum136->definitionModule = modulename;
  meth_meth_ast_visitNum136->definitionLine = 1990;
  struct UserObject *uo138 = (struct UserObject*)obj98;
  uo138->data[20] = emptyclosure;
  Method *meth_meth_ast_visitOp138 = addmethod2pos(obj98, "visitOp", &meth_ast_visitOp138, 20);
int argcv_meth_ast_visitOp138[] = {1};
meth_meth_ast_visitOp138->type = alloc_MethodType(1, argcv_meth_ast_visitOp138);
  meth_meth_ast_visitOp138->definitionModule = modulename;
  meth_meth_ast_visitOp138->definitionLine = 1993;
  struct UserObject *uo140 = (struct UserObject*)obj98;
  uo140->data[21] = emptyclosure;
  Method *meth_meth_ast_visitIndex140 = addmethod2pos(obj98, "visitIndex", &meth_ast_visitIndex140, 21);
int argcv_meth_ast_visitIndex140[] = {1};
meth_meth_ast_visitIndex140->type = alloc_MethodType(1, argcv_meth_ast_visitIndex140);
  meth_meth_ast_visitIndex140->definitionModule = modulename;
  meth_meth_ast_visitIndex140->definitionLine = 1996;
  struct UserObject *uo142 = (struct UserObject*)obj98;
  uo142->data[22] = emptyclosure;
  Method *meth_meth_ast_visitBind142 = addmethod2pos(obj98, "visitBind", &meth_ast_visitBind142, 22);
int argcv_meth_ast_visitBind142[] = {1};
meth_meth_ast_visitBind142->type = alloc_MethodType(1, argcv_meth_ast_visitBind142);
  meth_meth_ast_visitBind142->definitionModule = modulename;
  meth_meth_ast_visitBind142->definitionLine = 1999;
  struct UserObject *uo144 = (struct UserObject*)obj98;
  uo144->data[23] = emptyclosure;
  Method *meth_meth_ast_visitDefDec144 = addmethod2pos(obj98, "visitDefDec", &meth_ast_visitDefDec144, 23);
int argcv_meth_ast_visitDefDec144[] = {1};
meth_meth_ast_visitDefDec144->type = alloc_MethodType(1, argcv_meth_ast_visitDefDec144);
  meth_meth_ast_visitDefDec144->definitionModule = modulename;
  meth_meth_ast_visitDefDec144->definitionLine = 2002;
  struct UserObject *uo146 = (struct UserObject*)obj98;
  uo146->data[24] = emptyclosure;
  Method *meth_meth_ast_visitVarDec146 = addmethod2pos(obj98, "visitVarDec", &meth_ast_visitVarDec146, 24);
int argcv_meth_ast_visitVarDec146[] = {1};
meth_meth_ast_visitVarDec146->type = alloc_MethodType(1, argcv_meth_ast_visitVarDec146);
  meth_meth_ast_visitVarDec146->definitionModule = modulename;
  meth_meth_ast_visitVarDec146->definitionLine = 2005;
  struct UserObject *uo148 = (struct UserObject*)obj98;
  uo148->data[25] = emptyclosure;
  Method *meth_meth_ast_visitImport148 = addmethod2pos(obj98, "visitImport", &meth_ast_visitImport148, 25);
int argcv_meth_ast_visitImport148[] = {1};
meth_meth_ast_visitImport148->type = alloc_MethodType(1, argcv_meth_ast_visitImport148);
  meth_meth_ast_visitImport148->definitionModule = modulename;
  meth_meth_ast_visitImport148->definitionLine = 2008;
  struct UserObject *uo150 = (struct UserObject*)obj98;
  uo150->data[26] = emptyclosure;
  Method *meth_meth_ast_visitReturn150 = addmethod2pos(obj98, "visitReturn", &meth_ast_visitReturn150, 26);
int argcv_meth_ast_visitReturn150[] = {1};
meth_meth_ast_visitReturn150->type = alloc_MethodType(1, argcv_meth_ast_visitReturn150);
  meth_meth_ast_visitReturn150->definitionModule = modulename;
  meth_meth_ast_visitReturn150->definitionLine = 2011;
  struct UserObject *uo152 = (struct UserObject*)obj98;
  uo152->data[27] = emptyclosure;
  Method *meth_meth_ast_visitInherits152 = addmethod2pos(obj98, "visitInherits", &meth_ast_visitInherits152, 27);
int argcv_meth_ast_visitInherits152[] = {1};
meth_meth_ast_visitInherits152->type = alloc_MethodType(1, argcv_meth_ast_visitInherits152);
  meth_meth_ast_visitInherits152->definitionModule = modulename;
  meth_meth_ast_visitInherits152->definitionLine = 2014;
  struct UserObject *uo154 = (struct UserObject*)obj98;
  uo154->data[28] = emptyclosure;
  Method *meth_meth_ast_visitDialect154 = addmethod2pos(obj98, "visitDialect", &meth_ast_visitDialect154, 28);
int argcv_meth_ast_visitDialect154[] = {1};
meth_meth_ast_visitDialect154->type = alloc_MethodType(1, argcv_meth_ast_visitDialect154);
  meth_meth_ast_visitDialect154->definitionModule = modulename;
  meth_meth_ast_visitDialect154->definitionLine = 2017;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
objclass98 = obj98->class;
  objclass98->definitionModule = modulename;
  objclass98->definitionLine = 1935;
  (*(struct UserObject *)self).data[0] = lowerouter98;
  self = oldself98;
  selfslot = oldselfslot98;
  stackframe = oldstackframe98;
  gc_frame_end(frame);
  return obj98;
}
Object meth_ast__apply166(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_annName = getfromclosure(closure, 0);
  Object *var_ann = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2034
  setline(2034);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_annName
  int op_slot_right_167 = gc_frame_newslot(*var_annName);
  int callframe169 = gc_frame_new();
// compilenode returning *var_ann
  partcv[0] = 0;
  Object call170 = callmethod(*var_ann, "value",
    1, partcv, params);
  gc_frame_end(callframe169);
// compilenode returning call170
// compilenode returning call170
  int op_slot_left_167 = gc_frame_newslot(call170);
  params[0] = *var_annName;
  partcv[0] = 1;
  Object opresult171 = callmethod(call170, "==", 1, partcv, params);
// compilenode returning opresult171
  gc_frame_end(frame);
  return opresult171;
}
Object meth_ast__apply162(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_annName = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2040
  setline(2040);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2033
  setline(2033);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe164 = gc_frame_new();
  Object block165 = alloc_Block(NULL, NULL, "ast", 2033);
  gc_frame_newslot(block165);
  block_savedest(block165);
  Object closure166 = createclosure(3, "_apply");
setclosureframe(closure166, stackframe);
  addtoclosure(closure166, var_annName);
  addtoclosure(closure166, var_ann);
  addtoclosure(closure166, selfslot);
  struct UserObject *uo166 = (struct UserObject*)block165;
  uo166->data[0] = (Object)closure166;
  Method *meth_meth_ast__apply166 = addmethod2pos(block165, "_apply", &meth_ast__apply166, 0);
int argcv_meth_ast__apply166[] = {0};
meth_meth_ast__apply166->type = alloc_MethodType(1, argcv_meth_ast__apply166);
  meth_meth_ast__apply166->definitionModule = modulename;
  meth_meth_ast__apply166->definitionLine = 2032;
// compilenode returning block165
  gc_frame_newslot(block165);
// Begin line 2033
  setline(2033);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit174 == NULL) {
    strlit174 = alloc_String("identifier");
    gc_root(strlit174);
  }
// compilenode returning strlit174
  int op_slot_right_173 = gc_frame_newslot(strlit174);
  int callframe176 = gc_frame_new();
// compilenode returning *var_ann
  partcv[0] = 0;
  Object call177 = callmethod(*var_ann, "kind",
    1, partcv, params);
  gc_frame_end(callframe176);
// compilenode returning call177
// compilenode returning call177
  int op_slot_left_173 = gc_frame_newslot(call177);
  params[0] = strlit174;
  partcv[0] = 1;
  Object opresult178 = callmethod(call177, "==", 1, partcv, params);
// compilenode returning opresult178
  params[0] = block165;
  partcv[0] = 1;
  Object call179 = callmethod(opresult178, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe164);
// compilenode returning call179
  Object if163 = done;
  if (istrue(call179)) {
// Begin line 2035
  setline(2035);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject180 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj180 = alloc_userobj2(2,4, objclass180);
  gc_frame_newslot(obj180);
// OBJECT OUTER DEC outer
  adddatum2(obj180, self, 0);
  addmethodreal(obj180,"outer", &reader_ast_outer_181);
  Object oldself180 = self;
  struct StackFrameObject *oldstackframe180 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe180);
  gc_frame_newslot((Object)stackframe);
  self = obj180;
  Object *oldselfslot180 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter180 = (*(struct UserObject *)self).data[0], lowerouter180 = thisouter180;
  if (inheritingObject180) {
    struct UserObject *inho180 = (struct UserObject *)inheritingObject180;
    while (inho180->super != GraceDefaultObject) inho180 = (struct UserObject *)inho180->super;
    inho180->super = obj180;
    self = inheritingObject180;
    *selfslot = self;
    lowerouter180 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter180;
  }
if (objclass180 == NULL) {
  Method *reader182 = addmethodrealflags(obj180, "value",&reader_ast_value_182, MFLAG_DEF);
  reader182->definitionModule = modulename;
  reader182->definitionLine = 2038;
}
adddatum2(obj180, alloc_Undefined(), 1);
  sourceObject = obj180;
// Begin line 2036
  setline(2036);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool183 = alloc_Boolean(1);
// compilenode returning bool183
  struct UserObject *obj180_uo = (struct UserObject *)obj180;
  obj180_uo->super = bool183;
  sourceObject = obj180;
// Begin line 2037
  setline(2037);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_ann
  adddatum2(obj180, *var_ann, 1);
objclass180 = obj180->class;
  objclass180->definitionModule = modulename;
  objclass180->definitionLine = 2035;
  (*(struct UserObject *)self).data[0] = lowerouter180;
  self = oldself180;
  selfslot = oldselfslot180;
  stackframe = oldstackframe180;
// compilenode returning obj180
  block_return(realself, obj180);
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if163 = undefined;
  } else {
  }
// compilenode returning if163
  gc_frame_end(frame);
  return if163;
}
Object meth_ast_findAnnotation157(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "findAnnotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for findAnnotation (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  Object *var_annName = &(stackframe->slots[1]);
  *var_annName = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for findAnnotation");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2032
  setline(2032);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe158 = gc_frame_new();
  int callframe159 = gc_frame_new();
// compilenode returning *var_node
  partcv[0] = 0;
  Object call160 = callmethod(*var_node, "annotations",
    1, partcv, params);
  gc_frame_end(callframe159);
// compilenode returning call160
// compilenode returning call160
  gc_frame_newslot(call160);
  Object block161 = alloc_Block(NULL, NULL, "ast", 2032);
  gc_frame_newslot(block161);
  block_savedest(block161);
  Object closure162 = createclosure(2, "_apply");
setclosureframe(closure162, stackframe);
  addtoclosure(closure162, var_annName);
  addtoclosure(closure162, selfslot);
  struct UserObject *uo162 = (struct UserObject*)block161;
  uo162->data[0] = (Object)closure162;
  Method *meth_meth_ast__apply162 = addmethod2pos(block161, "_apply", &meth_ast__apply162, 0);
int argcv_meth_ast__apply162[] = {1};
meth_meth_ast__apply162->type = alloc_MethodType(1, argcv_meth_ast__apply162);
  meth_meth_ast__apply162->definitionModule = modulename;
  meth_meth_ast__apply162->definitionLine = 2032;
// compilenode returning block161
  gc_frame_newslot(block161);
  params[0] = call160;
  params[1] = block161;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call185 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe158);
// compilenode returning call185
// Begin line 2041
  setline(2041);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool186 = alloc_Boolean(0);
// compilenode returning bool186
  gc_frame_end(frame);
  return bool186;
}
Object meth_ast__apply191(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_node = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2046
  setline(2046);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe192 = gc_frame_new();
// compilenode returning *var_node
  gc_frame_newslot(*var_node);
  if (strlit193 == NULL) {
    strlit193 = alloc_String("public");
    gc_root(strlit193);
  }
// compilenode returning strlit193
  gc_frame_newslot(strlit193);
  params[0] = *var_node;
  params[1] = strlit193;
  partcv[0] = 2;
  Object call194 = callmethodflags(self, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe192);
// compilenode returning call194
  gc_frame_end(frame);
  return call194;
}
Object meth_ast_isPublic187(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for isPublic");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2049
  setline(2049);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2045
  setline(2045);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe189 = gc_frame_new();
  Object block190 = alloc_Block(NULL, NULL, "ast", 2045);
  gc_frame_newslot(block190);
  block_savedest(block190);
  Object closure191 = createclosure(2, "_apply");
setclosureframe(closure191, stackframe);
  addtoclosure(closure191, var_node);
  addtoclosure(closure191, selfslot);
  struct UserObject *uo191 = (struct UserObject*)block190;
  uo191->data[0] = (Object)closure191;
  Method *meth_meth_ast__apply191 = addmethod2pos(block190, "_apply", &meth_ast__apply191, 0);
int argcv_meth_ast__apply191[] = {0};
meth_meth_ast__apply191->type = alloc_MethodType(1, argcv_meth_ast__apply191);
  meth_meth_ast__apply191->definitionModule = modulename;
  meth_meth_ast__apply191->definitionLine = 2033;
// compilenode returning block190
  gc_frame_newslot(block190);
// Begin line 2045
  setline(2045);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num197 = alloc_Float64(0);
// compilenode returning num197
  int op_slot_right_196 = gc_frame_newslot(num197);
  int callframe199 = gc_frame_new();
  int callframe200 = gc_frame_new();
// compilenode returning *var_node
  partcv[0] = 0;
  Object call201 = callmethod(*var_node, "annotations",
    1, partcv, params);
  gc_frame_end(callframe200);
// compilenode returning call201
// compilenode returning call201
  partcv[0] = 0;
  Object call202 = callmethod(call201, "size",
    1, partcv, params);
  gc_frame_end(callframe199);
// compilenode returning call202
// compilenode returning call202
  int op_slot_left_196 = gc_frame_newslot(call202);
  params[0] = num197;
  partcv[0] = 1;
  Object opresult203 = callmethod(call202, "==", 1, partcv, params);
// compilenode returning opresult203
  params[0] = block190;
  partcv[0] = 1;
  Object call204 = callmethod(opresult203, "orElse",
    1, partcv, params);
  gc_frame_end(callframe189);
// compilenode returning call204
  Object if188 = done;
  if (istrue(call204)) {
// Begin line 2048
  setline(2048);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2047
  setline(2047);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool205 = alloc_Boolean(1);
// compilenode returning bool205
  return bool205;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if188 = undefined;
  } else {
  }
// compilenode returning if188
// Begin line 2049
  setline(2049);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool206 = alloc_Boolean(0);
// compilenode returning bool206
  gc_frame_end(frame);
  return bool206;
}
Object meth_ast__apply211(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_node = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2054
  setline(2054);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe212 = gc_frame_new();
// compilenode returning *var_node
  gc_frame_newslot(*var_node);
  if (strlit213 == NULL) {
    strlit213 = alloc_String("writable");
    gc_root(strlit213);
  }
// compilenode returning strlit213
  gc_frame_newslot(strlit213);
  params[0] = *var_node;
  params[1] = strlit213;
  partcv[0] = 2;
  Object call214 = callmethodflags(self, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe212);
// compilenode returning call214
  gc_frame_end(frame);
  return call214;
}
Object meth_ast_isWritable207(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for isWritable");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2057
  setline(2057);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2053
  setline(2053);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe209 = gc_frame_new();
  Object block210 = alloc_Block(NULL, NULL, "ast", 2053);
  gc_frame_newslot(block210);
  block_savedest(block210);
  Object closure211 = createclosure(2, "_apply");
setclosureframe(closure211, stackframe);
  addtoclosure(closure211, var_node);
  addtoclosure(closure211, selfslot);
  struct UserObject *uo211 = (struct UserObject*)block210;
  uo211->data[0] = (Object)closure211;
  Method *meth_meth_ast__apply211 = addmethod2pos(block210, "_apply", &meth_ast__apply211, 0);
int argcv_meth_ast__apply211[] = {0};
meth_meth_ast__apply211->type = alloc_MethodType(1, argcv_meth_ast__apply211);
  meth_meth_ast__apply211->definitionModule = modulename;
  meth_meth_ast__apply211->definitionLine = 2045;
// compilenode returning block210
  gc_frame_newslot(block210);
// Begin line 2053
  setline(2053);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num217 = alloc_Float64(0);
// compilenode returning num217
  int op_slot_right_216 = gc_frame_newslot(num217);
  int callframe219 = gc_frame_new();
  int callframe220 = gc_frame_new();
// compilenode returning *var_node
  partcv[0] = 0;
  Object call221 = callmethod(*var_node, "annotations",
    1, partcv, params);
  gc_frame_end(callframe220);
// compilenode returning call221
// compilenode returning call221
  partcv[0] = 0;
  Object call222 = callmethod(call221, "size",
    1, partcv, params);
  gc_frame_end(callframe219);
// compilenode returning call222
// compilenode returning call222
  int op_slot_left_216 = gc_frame_newslot(call222);
  params[0] = num217;
  partcv[0] = 1;
  Object opresult223 = callmethod(call222, "==", 1, partcv, params);
// compilenode returning opresult223
  params[0] = block210;
  partcv[0] = 1;
  Object call224 = callmethod(opresult223, "orElse",
    1, partcv, params);
  gc_frame_end(callframe209);
// compilenode returning call224
  Object if208 = done;
  if (istrue(call224)) {
// Begin line 2056
  setline(2056);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2055
  setline(2055);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool225 = alloc_Boolean(1);
// compilenode returning bool225
  return bool225;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if208 = undefined;
  } else {
  }
// compilenode returning if208
// Begin line 2057
  setline(2057);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool226 = alloc_Boolean(0);
// compilenode returning bool226
  gc_frame_end(frame);
  return bool226;
}
Object meth_ast_baseNode227(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "baseNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for baseNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for baseNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_baseNode
  gc_frame_end(frame);
  return *var_baseNode;
}
Object meth_ast_new230(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject231 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj231 = alloc_userobj2(8,5, objclass231);
  gc_frame_newslot(obj231);
if (objclass231 == NULL) {
  glfree(obj231->class->name);
  obj231->class->name = "baseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj231, self, 0);
  addmethodreal(obj231,"outer", &reader_ast_outer_232);
  Object oldself231 = self;
  struct StackFrameObject *oldstackframe231 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe231);
  gc_frame_newslot((Object)stackframe);
  self = obj231;
  Object *oldselfslot231 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter231 = (*(struct UserObject *)self).data[0], lowerouter231 = thisouter231;
  if (inheritingObject231) {
    struct UserObject *inho231 = (struct UserObject *)inheritingObject231;
    while (inho231->super != GraceDefaultObject) inho231 = (struct UserObject *)inho231->super;
    inho231->super = obj231;
    self = inheritingObject231;
    *selfslot = self;
    lowerouter231 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter231;
  }
if (objclass231 == NULL) {
  Method *reader233 = addmethodrealflags(obj231, "register",&reader_ast_register_233, 0);
  Method *writer233 = addmethodrealflags(obj231, "register:=",&writer_ast_register_233, 0);
  reader233->definitionModule = modulename;
  writer233->definitionModule = modulename;
  reader233->definitionLine = 39;
  writer233->definitionLine = 39;
}
obj231->flags |= OFLAG_MUTABLE;
adddatum2(obj231, alloc_Undefined(), 1);
if (objclass231 == NULL) {
  Method *reader234 = addmethodrealflags(obj231, "line",&reader_ast_line_234, 0);
  Method *writer234 = addmethodrealflags(obj231, "line:=",&writer_ast_line_234, 0);
  reader234->definitionModule = modulename;
  writer234->definitionModule = modulename;
  reader234->definitionLine = 40;
  writer234->definitionLine = 40;
}
obj231->flags |= OFLAG_MUTABLE;
adddatum2(obj231, alloc_Undefined(), 2);
if (objclass231 == NULL) {
  Method *reader235 = addmethodrealflags(obj231, "linePos",&reader_ast_linePos_235, 0);
  Method *writer235 = addmethodrealflags(obj231, "linePos:=",&writer_ast_linePos_235, 0);
  reader235->definitionModule = modulename;
  writer235->definitionModule = modulename;
  reader235->definitionLine = 41;
  writer235->definitionLine = 41;
}
obj231->flags |= OFLAG_MUTABLE;
adddatum2(obj231, alloc_Undefined(), 3);
if (objclass231 == NULL) {
  Method *reader236 = addmethodrealflags(obj231, "lineLength",&reader_ast_lineLength_236, 0);
  Method *writer236 = addmethodrealflags(obj231, "lineLength:=",&writer_ast_lineLength_236, 0);
  reader236->definitionModule = modulename;
  writer236->definitionModule = modulename;
  reader236->definitionLine = 42;
  writer236->definitionLine = 42;
}
obj231->flags |= OFLAG_MUTABLE;
adddatum2(obj231, alloc_Undefined(), 4);
  sourceObject = obj231;
// Begin line 38
  setline(38);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit237 == NULL) {
    strlit237 = alloc_String("");
    gc_root(strlit237);
  }
// compilenode returning strlit237
  adddatum2(obj231, strlit237, 1);
  sourceObject = obj231;
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe238 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call239 = callmethod(*var_util, "linenum",
    1, partcv, params);
  gc_frame_end(callframe238);
// compilenode returning call239
// compilenode returning call239
  adddatum2(obj231, call239, 2);
  sourceObject = obj231;
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe240 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call241 = callmethod(*var_util, "linepos",
    1, partcv, params);
  gc_frame_end(callframe240);
// compilenode returning call241
// compilenode returning call241
  adddatum2(obj231, call241, 3);
  sourceObject = obj231;
// Begin line 41
  setline(41);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num242 = alloc_Float64(0);
// compilenode returning num242
  adddatum2(obj231, num242, 4);
objclass231 = obj231->class;
  objclass231->definitionModule = modulename;
  objclass231->definitionLine = 2053;
  (*(struct UserObject *)self).data[0] = lowerouter231;
  self = oldself231;
  selfslot = oldselfslot231;
  stackframe = oldstackframe231;
  gc_frame_end(frame);
  return obj231;
}
Object meth_ast_new230_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject231 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj231 = alloc_userobj2(8,5, objclass231);
  gc_frame_newslot(obj231);
if (objclass231 == NULL) {
  glfree(obj231->class->name);
  obj231->class->name = "baseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj231, self, 0);
  addmethodreal(obj231,"outer", &reader_ast_outer_232);
  Object oldself231 = self;
  struct StackFrameObject *oldstackframe231 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe231);
  gc_frame_newslot((Object)stackframe);
  self = obj231;
  Object *oldselfslot231 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter231 = (*(struct UserObject *)self).data[0], lowerouter231 = thisouter231;
  if (inheritingObject231) {
    struct UserObject *inho231 = (struct UserObject *)inheritingObject231;
    while (inho231->super != GraceDefaultObject) inho231 = (struct UserObject *)inho231->super;
    inho231->super = obj231;
    self = inheritingObject231;
    *selfslot = self;
    lowerouter231 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter231;
  }
if (objclass231 == NULL) {
  Method *reader233 = addmethodrealflags(obj231, "register",&reader_ast_register_233, 0);
  Method *writer233 = addmethodrealflags(obj231, "register:=",&writer_ast_register_233, 0);
  reader233->definitionModule = modulename;
  writer233->definitionModule = modulename;
  reader233->definitionLine = 39;
  writer233->definitionLine = 39;
}
obj231->flags |= OFLAG_MUTABLE;
adddatum2(obj231, alloc_Undefined(), 1);
if (objclass231 == NULL) {
  Method *reader234 = addmethodrealflags(obj231, "line",&reader_ast_line_234, 0);
  Method *writer234 = addmethodrealflags(obj231, "line:=",&writer_ast_line_234, 0);
  reader234->definitionModule = modulename;
  writer234->definitionModule = modulename;
  reader234->definitionLine = 40;
  writer234->definitionLine = 40;
}
obj231->flags |= OFLAG_MUTABLE;
adddatum2(obj231, alloc_Undefined(), 2);
if (objclass231 == NULL) {
  Method *reader235 = addmethodrealflags(obj231, "linePos",&reader_ast_linePos_235, 0);
  Method *writer235 = addmethodrealflags(obj231, "linePos:=",&writer_ast_linePos_235, 0);
  reader235->definitionModule = modulename;
  writer235->definitionModule = modulename;
  reader235->definitionLine = 41;
  writer235->definitionLine = 41;
}
obj231->flags |= OFLAG_MUTABLE;
adddatum2(obj231, alloc_Undefined(), 3);
if (objclass231 == NULL) {
  Method *reader236 = addmethodrealflags(obj231, "lineLength",&reader_ast_lineLength_236, 0);
  Method *writer236 = addmethodrealflags(obj231, "lineLength:=",&writer_ast_lineLength_236, 0);
  reader236->definitionModule = modulename;
  writer236->definitionModule = modulename;
  reader236->definitionLine = 42;
  writer236->definitionLine = 42;
}
obj231->flags |= OFLAG_MUTABLE;
adddatum2(obj231, alloc_Undefined(), 4);
  sourceObject = obj231;
// Begin line 38
  setline(38);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit237 == NULL) {
    strlit237 = alloc_String("");
    gc_root(strlit237);
  }
// compilenode returning strlit237
  adddatum2(obj231, strlit237, 1);
  sourceObject = obj231;
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe238 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call239 = callmethod(*var_util, "linenum",
    1, partcv, params);
  gc_frame_end(callframe238);
// compilenode returning call239
// compilenode returning call239
  adddatum2(obj231, call239, 2);
  sourceObject = obj231;
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe240 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call241 = callmethod(*var_util, "linepos",
    1, partcv, params);
  gc_frame_end(callframe240);
// compilenode returning call241
// compilenode returning call241
  adddatum2(obj231, call241, 3);
  sourceObject = obj231;
// Begin line 41
  setline(41);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num242 = alloc_Float64(0);
// compilenode returning num242
  adddatum2(obj231, num242, 4);
objclass231 = obj231->class;
  objclass231->definitionModule = modulename;
  objclass231->definitionLine = 2053;
  (*(struct UserObject *)self).data[0] = lowerouter231;
  self = oldself231;
  selfslot = oldselfslot231;
  stackframe = oldstackframe231;
  gc_frame_end(frame);
  return obj231;
}
Object meth_ast_forNode244(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "forNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_forNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for forNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for forNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 44
  setline(44);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_forNode
  gc_frame_end(frame);
  return *var_forNode;
}
Object meth_ast_accept253(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 50
  setline(50);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe255 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call256 = callmethod(*var_visitor, "visitFor",
    1, partcv, params);
  gc_frame_end(callframe255);
// compilenode returning call256
  Object if254 = done;
  if (istrue(call256)) {
// Begin line 51
  setline(51);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe257 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe258 = gc_frame_new();
  partcv[0] = 0;
  Object call259 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe258);
// compilenode returning call259
// compilenode returning call259
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call260 = callmethod(call259, "accept",
    1, partcv, params);
  gc_frame_end(callframe257);
// compilenode returning call260
// Begin line 52
  setline(52);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe261 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe262 = gc_frame_new();
  partcv[0] = 0;
  Object call263 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe262);
// compilenode returning call263
// compilenode returning call263
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call264 = callmethod(call263, "accept",
    1, partcv, params);
  gc_frame_end(callframe261);
// compilenode returning call264
    gc_frame_newslot(call264);
    if254 = call264;
  } else {
  }
// compilenode returning if254
  gc_frame_end(frame);
  return if254;
}
Object meth_ast__apply273(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 58
  setline(58);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit275 == NULL) {
    strlit275 = alloc_String("  ");
    gc_root(strlit275);
  }
// compilenode returning strlit275
  int op_slot_right_274 = gc_frame_newslot(strlit275);
// compilenode returning *var_spc
  int op_slot_left_274 = gc_frame_newslot(*var_spc);
  params[0] = strlit275;
  partcv[0] = 1;
  Object opresult277 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult277
  *var_spc = opresult277;
  if (opresult277 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty265(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit266 == NULL) {
    strlit266 = alloc_String("");
    gc_root(strlit266);
  }
// compilenode returning strlit266
  *var_spc = strlit266;
  if (strlit266 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe267 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_268 = gc_frame_newslot(*var_depth);
  Object num270 = alloc_Float64(0);
// compilenode returning num270
  int op_slot_left_268 = gc_frame_newslot(num270);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult271 = callmethod(num270, "..", 1, partcv, params);
// compilenode returning opresult271
  gc_frame_newslot(opresult271);
  Object block272 = alloc_Block(NULL, NULL, "ast", 57);
  gc_frame_newslot(block272);
  block_savedest(block272);
  Object closure273 = createclosure(2, "_apply");
setclosureframe(closure273, stackframe);
  addtoclosure(closure273, var_spc);
  addtoclosure(closure273, selfslot);
  struct UserObject *uo273 = (struct UserObject*)block272;
  uo273->data[0] = (Object)closure273;
  Method *meth_meth_ast__apply273 = addmethod2pos(block272, "_apply", &meth_ast__apply273, 0);
int argcv_meth_ast__apply273[] = {1};
meth_meth_ast__apply273->type = alloc_MethodType(1, argcv_meth_ast__apply273);
  meth_meth_ast__apply273->definitionModule = modulename;
  meth_meth_ast__apply273->definitionLine = 52;
// compilenode returning block272
  gc_frame_newslot(block272);
  params[0] = opresult271;
  params[1] = block272;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call280 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe267);
// compilenode returning call280
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit281 == NULL) {
    strlit281 = alloc_String("For""\x0a""");
    gc_root(strlit281);
  }
// compilenode returning strlit281
  *var_s = strlit281;
  if (strlit281 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe283 = gc_frame_new();
  Object num285 = alloc_Float64(1);
// compilenode returning num285
  int op_slot_right_284 = gc_frame_newslot(num285);
// compilenode returning *var_depth
  int op_slot_left_284 = gc_frame_newslot(*var_depth);
  params[0] = num285;
  partcv[0] = 1;
  Object sum287 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum287
  gc_frame_newslot(sum287);
  int callframe288 = gc_frame_new();
  partcv[0] = 0;
  Object call289 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe288);
// compilenode returning call289
// compilenode returning call289
  params[0] = sum287;
  partcv[0] = 1;
  Object call290 = callmethod(call289, "pretty",
    1, partcv, params);
  gc_frame_end(callframe283);
// compilenode returning call290
  int op_slot_right_282 = gc_frame_newslot(call290);
// compilenode returning *var_spc
  int op_slot_right_292 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_292 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult294 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult294
  int op_slot_left_282 = gc_frame_newslot(opresult294);
  params[0] = call290;
  partcv[0] = 1;
  Object opresult295 = callmethod(opresult294, "++", 1, partcv, params);
// compilenode returning opresult295
  *var_s = opresult295;
  if (opresult295 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 62
  setline(62);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit298 == NULL) {
    strlit298 = alloc_String("""\x0a""");
    gc_root(strlit298);
  }
// compilenode returning strlit298
  int op_slot_right_297 = gc_frame_newslot(strlit298);
// compilenode returning *var_s
  int op_slot_left_297 = gc_frame_newslot(*var_s);
  params[0] = strlit298;
  partcv[0] = 1;
  Object opresult300 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult300
  *var_s = opresult300;
  if (opresult300 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit303 == NULL) {
    strlit303 = alloc_String("Do:");
    gc_root(strlit303);
  }
// compilenode returning strlit303
  int op_slot_right_302 = gc_frame_newslot(strlit303);
// compilenode returning *var_spc
  int op_slot_right_305 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_305 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult307 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult307
  int op_slot_left_302 = gc_frame_newslot(opresult307);
  params[0] = strlit303;
  partcv[0] = 1;
  Object opresult308 = callmethod(opresult307, "++", 1, partcv, params);
// compilenode returning opresult308
  *var_s = opresult308;
  if (opresult308 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe311 = gc_frame_new();
  Object num313 = alloc_Float64(1);
// compilenode returning num313
  int op_slot_right_312 = gc_frame_newslot(num313);
// compilenode returning *var_depth
  int op_slot_left_312 = gc_frame_newslot(*var_depth);
  params[0] = num313;
  partcv[0] = 1;
  Object sum315 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum315
  gc_frame_newslot(sum315);
  int callframe316 = gc_frame_new();
  partcv[0] = 0;
  Object call317 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe316);
// compilenode returning call317
// compilenode returning call317
  params[0] = sum315;
  partcv[0] = 1;
  Object call318 = callmethod(call317, "pretty",
    1, partcv, params);
  gc_frame_end(callframe311);
// compilenode returning call318
  int op_slot_right_310 = gc_frame_newslot(call318);
  if (strlit321 == NULL) {
    strlit321 = alloc_String("  ");
    gc_root(strlit321);
  }
// compilenode returning strlit321
  int op_slot_right_320 = gc_frame_newslot(strlit321);
// compilenode returning *var_spc
  int op_slot_right_323 = gc_frame_newslot(*var_spc);
  if (strlit326 == NULL) {
    strlit326 = alloc_String("""\x0a""");
    gc_root(strlit326);
  }
// compilenode returning strlit326
  int op_slot_right_325 = gc_frame_newslot(strlit326);
// compilenode returning *var_s
  int op_slot_left_325 = gc_frame_newslot(*var_s);
  params[0] = strlit326;
  partcv[0] = 1;
  Object opresult328 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult328
  int op_slot_left_323 = gc_frame_newslot(opresult328);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult329 = callmethod(opresult328, "++", 1, partcv, params);
// compilenode returning opresult329
  int op_slot_left_320 = gc_frame_newslot(opresult329);
  params[0] = strlit321;
  partcv[0] = 1;
  Object opresult330 = callmethod(opresult329, "++", 1, partcv, params);
// compilenode returning opresult330
  int op_slot_left_310 = gc_frame_newslot(opresult330);
  params[0] = call318;
  partcv[0] = 1;
  Object opresult331 = callmethod(opresult330, "++", 1, partcv, params);
// compilenode returning opresult331
  *var_s = opresult331;
  if (opresult331 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply345(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 71
  setline(71);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 70
  setline(70);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit347 == NULL) {
    strlit347 = alloc_String("    ");
    gc_root(strlit347);
  }
// compilenode returning strlit347
  int op_slot_right_346 = gc_frame_newslot(strlit347);
// compilenode returning *var_spc
  int op_slot_left_346 = gc_frame_newslot(*var_spc);
  params[0] = strlit347;
  partcv[0] = 1;
  Object opresult349 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult349
  *var_spc = opresult349;
  if (opresult349 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace333(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 69
  setline(69);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 68
  setline(68);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit334 == NULL) {
    strlit334 = alloc_String("");
    gc_root(strlit334);
  }
// compilenode returning strlit334
  *var_spc = strlit334;
  if (strlit334 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 69
  setline(69);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe335 = gc_frame_new();
  Object num338 = alloc_Float64(1);
// compilenode returning num338
  int op_slot_right_337 = gc_frame_newslot(num338);
// compilenode returning *var_depth
  int op_slot_left_337 = gc_frame_newslot(*var_depth);
  params[0] = num338;
  partcv[0] = 1;
  Object diff340 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff340
  int op_slot_right_336 = gc_frame_newslot(diff340);
  Object num342 = alloc_Float64(0);
// compilenode returning num342
  int op_slot_left_336 = gc_frame_newslot(num342);
  params[0] = diff340;
  partcv[0] = 1;
  Object opresult343 = callmethod(num342, "..", 1, partcv, params);
// compilenode returning opresult343
  gc_frame_newslot(opresult343);
  Object block344 = alloc_Block(NULL, NULL, "ast", 69);
  gc_frame_newslot(block344);
  block_savedest(block344);
  Object closure345 = createclosure(2, "_apply");
setclosureframe(closure345, stackframe);
  addtoclosure(closure345, var_spc);
  addtoclosure(closure345, selfslot);
  struct UserObject *uo345 = (struct UserObject*)block344;
  uo345->data[0] = (Object)closure345;
  Method *meth_meth_ast__apply345 = addmethod2pos(block344, "_apply", &meth_ast__apply345, 0);
int argcv_meth_ast__apply345[] = {1};
meth_meth_ast__apply345->type = alloc_MethodType(1, argcv_meth_ast__apply345);
  meth_meth_ast__apply345->definitionModule = modulename;
  meth_meth_ast__apply345->definitionLine = 64;
// compilenode returning block344
  gc_frame_newslot(block344);
  params[0] = opresult343;
  params[1] = block344;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call352 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe335);
// compilenode returning call352
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 72
  setline(72);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit354 == NULL) {
    strlit354 = alloc_String(") do ");
    gc_root(strlit354);
  }
// compilenode returning strlit354
  int op_slot_right_353 = gc_frame_newslot(strlit354);
  int callframe357 = gc_frame_new();
  Object num358 = alloc_Float64(0);
// compilenode returning num358
  gc_frame_newslot(num358);
  int callframe359 = gc_frame_new();
  partcv[0] = 0;
  Object call360 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe359);
// compilenode returning call360
// compilenode returning call360
  params[0] = num358;
  partcv[0] = 1;
  Object call361 = callmethod(call360, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe357);
// compilenode returning call361
  int op_slot_right_356 = gc_frame_newslot(call361);
  if (strlit363 == NULL) {
    strlit363 = alloc_String("for (");
    gc_root(strlit363);
  }
// compilenode returning strlit363
  int op_slot_left_356 = gc_frame_newslot(strlit363);
  params[0] = call361;
  partcv[0] = 1;
  Object opresult364 = callmethod(strlit363, "++", 1, partcv, params);
// compilenode returning opresult364
  int op_slot_left_353 = gc_frame_newslot(opresult364);
  params[0] = strlit354;
  partcv[0] = 1;
  Object opresult365 = callmethod(opresult364, "++", 1, partcv, params);
// compilenode returning opresult365
  *var_s = opresult365;
  if (opresult365 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe367 = gc_frame_new();
// compilenode returning *var_depth
  gc_frame_newslot(*var_depth);
  int callframe368 = gc_frame_new();
  partcv[0] = 0;
  Object call369 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe368);
// compilenode returning call369
// compilenode returning call369
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call370 = callmethod(call369, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe367);
// compilenode returning call370
  int op_slot_right_366 = gc_frame_newslot(call370);
// compilenode returning *var_s
  int op_slot_left_366 = gc_frame_newslot(*var_s);
  params[0] = call370;
  partcv[0] = 1;
  Object opresult372 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult372
  *var_s = opresult372;
  if (opresult372 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 74
  setline(74);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new247(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_over = &(stackframe->slots[0]);
  *var_over = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject248 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj248 = alloc_userobj2(7,8, objclass248);
  gc_frame_newslot(obj248);
if (objclass248 == NULL) {
  glfree(obj248->class->name);
  obj248->class->name = "forNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj248, self, 0);
  addmethodreal(obj248,"outer", &reader_ast_outer_249);
  Object oldself248 = self;
  struct StackFrameObject *oldstackframe248 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe248);
  gc_frame_newslot((Object)stackframe);
  self = obj248;
  Object *oldselfslot248 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter248 = (*(struct UserObject *)self).data[0], lowerouter248 = thisouter248;
  if (inheritingObject248) {
    struct UserObject *inho248 = (struct UserObject *)inheritingObject248;
    while (inho248->super != GraceDefaultObject) inho248 = (struct UserObject *)inho248->super;
    inho248->super = obj248;
    self = inheritingObject248;
    *selfslot = self;
    lowerouter248 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter248;
  }
if (objclass248 == NULL) {
  Method *reader250 = addmethodrealflags(obj248, "kind",&reader_ast_kind_250, MFLAG_DEF);
  reader250->definitionModule = modulename;
  reader250->definitionLine = 47;
}
adddatum2(obj248, alloc_Undefined(), 1);
if (objclass248 == NULL) {
  Method *reader251 = addmethodrealflags(obj248, "value",&reader_ast_value_251, MFLAG_DEF);
  reader251->definitionModule = modulename;
  reader251->definitionLine = 48;
}
adddatum2(obj248, alloc_Undefined(), 2);
if (objclass248 == NULL) {
  Method *reader252 = addmethodrealflags(obj248, "body",&reader_ast_body_252, MFLAG_DEF);
  reader252->definitionModule = modulename;
  reader252->definitionLine = 49;
}
adddatum2(obj248, alloc_Undefined(), 3);
  struct UserObject *uo253 = (struct UserObject*)obj248;
  uo253->data[4] = emptyclosure;
  Method *meth_meth_ast_accept253 = addmethod2pos(obj248, "accept", &meth_ast_accept253, 4);
int argcv_meth_ast_accept253[] = {1};
meth_meth_ast_accept253->type = alloc_MethodType(1, argcv_meth_ast_accept253);
meth_meth_ast_accept253->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept253->type->names[0] = "visitor";
  meth_meth_ast_accept253->definitionModule = modulename;
  meth_meth_ast_accept253->definitionLine = 49;
  struct UserObject *uo265 = (struct UserObject*)obj248;
  uo265->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty265 = addmethod2pos(obj248, "pretty", &meth_ast_pretty265, 5);
int argcv_meth_ast_pretty265[] = {1};
meth_meth_ast_pretty265->type = alloc_MethodType(1, argcv_meth_ast_pretty265);
  meth_meth_ast_pretty265->definitionModule = modulename;
  meth_meth_ast_pretty265->definitionLine = 55;
  struct UserObject *uo333 = (struct UserObject*)obj248;
  uo333->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace333 = addmethod2pos(obj248, "toGrace", &meth_ast_toGrace333, 6);
int argcv_meth_ast_toGrace333[] = {1};
meth_meth_ast_toGrace333->type = alloc_MethodType(1, argcv_meth_ast_toGrace333);
meth_meth_ast_toGrace333->type->types[0] = type_Number;
meth_meth_ast_toGrace333->type->names[0] = "depth";
  meth_meth_ast_toGrace333->definitionModule = modulename;
  meth_meth_ast_toGrace333->definitionLine = 67;
  sourceObject = obj248;
// Begin line 45
  setline(45);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe374 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call375 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe374);
// compilenode returning call375
  struct UserObject *obj248_uo = (struct UserObject *)obj248;
  obj248_uo->super = call375;
  sourceObject = obj248;
// Begin line 46
  setline(46);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit376 == NULL) {
    strlit376 = alloc_String("for");
    gc_root(strlit376);
  }
// compilenode returning strlit376
  adddatum2(obj248, strlit376, 1);
  sourceObject = obj248;
// Begin line 47
  setline(47);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_over
  adddatum2(obj248, *var_over, 2);
  sourceObject = obj248;
// Begin line 48
  setline(48);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_body_39_
  adddatum2(obj248, *var_body_39_, 3);
  sourceObject = obj248;
  sourceObject = obj248;
  sourceObject = obj248;
objclass248 = obj248->class;
  objclass248->definitionModule = modulename;
  objclass248->definitionLine = 40;
  (*(struct UserObject *)self).data[0] = lowerouter248;
  self = oldself248;
  selfslot = oldselfslot248;
  stackframe = oldstackframe248;
  gc_frame_end(frame);
  return obj248;
}
Object meth_ast_new247_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_over = &(stackframe->slots[0]);
  *var_over = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject248 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj248 = alloc_userobj2(7,8, objclass248);
  gc_frame_newslot(obj248);
if (objclass248 == NULL) {
  glfree(obj248->class->name);
  obj248->class->name = "forNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj248, self, 0);
  addmethodreal(obj248,"outer", &reader_ast_outer_249);
  Object oldself248 = self;
  struct StackFrameObject *oldstackframe248 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe248);
  gc_frame_newslot((Object)stackframe);
  self = obj248;
  Object *oldselfslot248 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter248 = (*(struct UserObject *)self).data[0], lowerouter248 = thisouter248;
  if (inheritingObject248) {
    struct UserObject *inho248 = (struct UserObject *)inheritingObject248;
    while (inho248->super != GraceDefaultObject) inho248 = (struct UserObject *)inho248->super;
    inho248->super = obj248;
    self = inheritingObject248;
    *selfslot = self;
    lowerouter248 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter248;
  }
if (objclass248 == NULL) {
  Method *reader250 = addmethodrealflags(obj248, "kind",&reader_ast_kind_250, MFLAG_DEF);
  reader250->definitionModule = modulename;
  reader250->definitionLine = 47;
}
adddatum2(obj248, alloc_Undefined(), 1);
if (objclass248 == NULL) {
  Method *reader251 = addmethodrealflags(obj248, "value",&reader_ast_value_251, MFLAG_DEF);
  reader251->definitionModule = modulename;
  reader251->definitionLine = 48;
}
adddatum2(obj248, alloc_Undefined(), 2);
if (objclass248 == NULL) {
  Method *reader252 = addmethodrealflags(obj248, "body",&reader_ast_body_252, MFLAG_DEF);
  reader252->definitionModule = modulename;
  reader252->definitionLine = 49;
}
adddatum2(obj248, alloc_Undefined(), 3);
  struct UserObject *uo253 = (struct UserObject*)obj248;
  uo253->data[4] = emptyclosure;
  Method *meth_meth_ast_accept253 = addmethod2pos(obj248, "accept", &meth_ast_accept253, 4);
int argcv_meth_ast_accept253[] = {1};
meth_meth_ast_accept253->type = alloc_MethodType(1, argcv_meth_ast_accept253);
meth_meth_ast_accept253->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept253->type->names[0] = "visitor";
  meth_meth_ast_accept253->definitionModule = modulename;
  meth_meth_ast_accept253->definitionLine = 49;
  struct UserObject *uo265 = (struct UserObject*)obj248;
  uo265->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty265 = addmethod2pos(obj248, "pretty", &meth_ast_pretty265, 5);
int argcv_meth_ast_pretty265[] = {1};
meth_meth_ast_pretty265->type = alloc_MethodType(1, argcv_meth_ast_pretty265);
  meth_meth_ast_pretty265->definitionModule = modulename;
  meth_meth_ast_pretty265->definitionLine = 55;
  struct UserObject *uo333 = (struct UserObject*)obj248;
  uo333->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace333 = addmethod2pos(obj248, "toGrace", &meth_ast_toGrace333, 6);
int argcv_meth_ast_toGrace333[] = {1};
meth_meth_ast_toGrace333->type = alloc_MethodType(1, argcv_meth_ast_toGrace333);
meth_meth_ast_toGrace333->type->types[0] = type_Number;
meth_meth_ast_toGrace333->type->names[0] = "depth";
  meth_meth_ast_toGrace333->definitionModule = modulename;
  meth_meth_ast_toGrace333->definitionLine = 67;
  sourceObject = obj248;
// Begin line 45
  setline(45);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe374 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call375 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe374);
// compilenode returning call375
  struct UserObject *obj248_uo = (struct UserObject *)obj248;
  obj248_uo->super = call375;
  sourceObject = obj248;
// Begin line 46
  setline(46);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit376 == NULL) {
    strlit376 = alloc_String("for");
    gc_root(strlit376);
  }
// compilenode returning strlit376
  adddatum2(obj248, strlit376, 1);
  sourceObject = obj248;
// Begin line 47
  setline(47);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_over
  adddatum2(obj248, *var_over, 2);
  sourceObject = obj248;
// Begin line 48
  setline(48);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_body_39_
  adddatum2(obj248, *var_body_39_, 3);
  sourceObject = obj248;
  sourceObject = obj248;
  sourceObject = obj248;
objclass248 = obj248->class;
  objclass248->definitionModule = modulename;
  objclass248->definitionLine = 40;
  (*(struct UserObject *)self).data[0] = lowerouter248;
  self = oldself248;
  selfslot = oldselfslot248;
  stackframe = oldstackframe248;
  gc_frame_end(frame);
  return obj248;
}
Object meth_ast_whileNode378(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "whileNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_whileNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for whileNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for whileNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 77
  setline(77);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_whileNode
  gc_frame_end(frame);
  return *var_whileNode;
}
Object meth_ast__apply399(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 86
  setline(86);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe400 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_x
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call401 = callmethod(*var_x, "accept",
    1, partcv, params);
  gc_frame_end(callframe400);
// compilenode returning call401
  gc_frame_end(frame);
  return call401;
}
Object meth_ast_accept387(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 83
  setline(83);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe389 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call390 = callmethod(*var_visitor, "visitWhile",
    1, partcv, params);
  gc_frame_end(callframe389);
// compilenode returning call390
  Object if388 = done;
  if (istrue(call390)) {
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe391 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe392 = gc_frame_new();
  partcv[0] = 0;
  Object call393 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe392);
// compilenode returning call393
// compilenode returning call393
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call394 = callmethod(call393, "accept",
    1, partcv, params);
  gc_frame_end(callframe391);
// compilenode returning call394
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe395 = gc_frame_new();
  int callframe396 = gc_frame_new();
  partcv[0] = 0;
  Object call397 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe396);
// compilenode returning call397
// compilenode returning call397
  gc_frame_newslot(call397);
  Object block398 = alloc_Block(NULL, NULL, "ast", 85);
  gc_frame_newslot(block398);
  block_savedest(block398);
  Object closure399 = createclosure(2, "_apply");
setclosureframe(closure399, stackframe);
  addtoclosure(closure399, var_visitor);
  addtoclosure(closure399, selfslot);
  struct UserObject *uo399 = (struct UserObject*)block398;
  uo399->data[0] = (Object)closure399;
  Method *meth_meth_ast__apply399 = addmethod2pos(block398, "_apply", &meth_ast__apply399, 0);
int argcv_meth_ast__apply399[] = {1};
meth_meth_ast__apply399->type = alloc_MethodType(1, argcv_meth_ast__apply399);
  meth_meth_ast__apply399->definitionModule = modulename;
  meth_meth_ast__apply399->definitionLine = 85;
// compilenode returning block398
  gc_frame_newslot(block398);
  params[0] = call397;
  params[1] = block398;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call403 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe395);
// compilenode returning call403
    gc_frame_newslot(call403);
    if388 = call403;
  } else {
  }
// compilenode returning if388
  gc_frame_end(frame);
  return if388;
}
Object meth_ast__apply412(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 94
  setline(94);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit414 == NULL) {
    strlit414 = alloc_String("  ");
    gc_root(strlit414);
  }
// compilenode returning strlit414
  int op_slot_right_413 = gc_frame_newslot(strlit414);
// compilenode returning *var_spc
  int op_slot_left_413 = gc_frame_newslot(*var_spc);
  params[0] = strlit414;
  partcv[0] = 1;
  Object opresult416 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult416
  *var_spc = opresult416;
  if (opresult416 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply453(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 100
  setline(100);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe455 = gc_frame_new();
  Object num457 = alloc_Float64(2);
// compilenode returning num457
  int op_slot_right_456 = gc_frame_newslot(num457);
// compilenode returning *var_depth
  int op_slot_left_456 = gc_frame_newslot(*var_depth);
  params[0] = num457;
  partcv[0] = 1;
  Object sum459 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum459
  gc_frame_newslot(sum459);
// compilenode returning *var_x
  params[0] = sum459;
  partcv[0] = 1;
  Object call460 = callmethod(*var_x, "pretty",
    1, partcv, params);
  gc_frame_end(callframe455);
// compilenode returning call460
  int op_slot_right_454 = gc_frame_newslot(call460);
// compilenode returning *var_spc
  int op_slot_right_462 = gc_frame_newslot(*var_spc);
  if (strlit465 == NULL) {
    strlit465 = alloc_String("""\x0a""  ");
    gc_root(strlit465);
  }
// compilenode returning strlit465
  int op_slot_right_464 = gc_frame_newslot(strlit465);
// compilenode returning *var_s
  int op_slot_left_464 = gc_frame_newslot(*var_s);
  params[0] = strlit465;
  partcv[0] = 1;
  Object opresult467 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult467
  int op_slot_left_462 = gc_frame_newslot(opresult467);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult468 = callmethod(opresult467, "++", 1, partcv, params);
// compilenode returning opresult468
  int op_slot_left_454 = gc_frame_newslot(opresult468);
  params[0] = call460;
  partcv[0] = 1;
  Object opresult469 = callmethod(opresult468, "++", 1, partcv, params);
// compilenode returning opresult469
  *var_s = opresult469;
  if (opresult469 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty404(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit405 == NULL) {
    strlit405 = alloc_String("");
    gc_root(strlit405);
  }
// compilenode returning strlit405
  *var_spc = strlit405;
  if (strlit405 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe406 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_407 = gc_frame_newslot(*var_depth);
  Object num409 = alloc_Float64(0);
// compilenode returning num409
  int op_slot_left_407 = gc_frame_newslot(num409);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult410 = callmethod(num409, "..", 1, partcv, params);
// compilenode returning opresult410
  gc_frame_newslot(opresult410);
  Object block411 = alloc_Block(NULL, NULL, "ast", 92);
  gc_frame_newslot(block411);
  block_savedest(block411);
  Object closure412 = createclosure(2, "_apply");
setclosureframe(closure412, stackframe);
  addtoclosure(closure412, var_spc);
  addtoclosure(closure412, selfslot);
  struct UserObject *uo412 = (struct UserObject*)block411;
  uo412->data[0] = (Object)closure412;
  Method *meth_meth_ast__apply412 = addmethod2pos(block411, "_apply", &meth_ast__apply412, 0);
int argcv_meth_ast__apply412[] = {1};
meth_meth_ast__apply412->type = alloc_MethodType(1, argcv_meth_ast__apply412);
  meth_meth_ast__apply412->definitionModule = modulename;
  meth_meth_ast__apply412->definitionLine = 85;
// compilenode returning block411
  gc_frame_newslot(block411);
  params[0] = opresult410;
  params[1] = block411;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call419 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe406);
// compilenode returning call419
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit420 == NULL) {
    strlit420 = alloc_String("While""\x0a""");
    gc_root(strlit420);
  }
// compilenode returning strlit420
  *var_s = strlit420;
  if (strlit420 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe422 = gc_frame_new();
  Object num424 = alloc_Float64(1);
// compilenode returning num424
  int op_slot_right_423 = gc_frame_newslot(num424);
// compilenode returning *var_depth
  int op_slot_left_423 = gc_frame_newslot(*var_depth);
  params[0] = num424;
  partcv[0] = 1;
  Object sum426 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum426
  gc_frame_newslot(sum426);
  int callframe427 = gc_frame_new();
  partcv[0] = 0;
  Object call428 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe427);
// compilenode returning call428
// compilenode returning call428
  params[0] = sum426;
  partcv[0] = 1;
  Object call429 = callmethod(call428, "pretty",
    1, partcv, params);
  gc_frame_end(callframe422);
// compilenode returning call429
  int op_slot_right_421 = gc_frame_newslot(call429);
// compilenode returning *var_spc
  int op_slot_right_431 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_431 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult433 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult433
  int op_slot_left_421 = gc_frame_newslot(opresult433);
  params[0] = call429;
  partcv[0] = 1;
  Object opresult434 = callmethod(opresult433, "++", 1, partcv, params);
// compilenode returning opresult434
  *var_s = opresult434;
  if (opresult434 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit437 == NULL) {
    strlit437 = alloc_String("""\x0a""");
    gc_root(strlit437);
  }
// compilenode returning strlit437
  int op_slot_right_436 = gc_frame_newslot(strlit437);
// compilenode returning *var_s
  int op_slot_left_436 = gc_frame_newslot(*var_s);
  params[0] = strlit437;
  partcv[0] = 1;
  Object opresult439 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult439
  *var_s = opresult439;
  if (opresult439 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit442 == NULL) {
    strlit442 = alloc_String("Do:");
    gc_root(strlit442);
  }
// compilenode returning strlit442
  int op_slot_right_441 = gc_frame_newslot(strlit442);
// compilenode returning *var_spc
  int op_slot_right_444 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_444 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult446 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult446
  int op_slot_left_441 = gc_frame_newslot(opresult446);
  params[0] = strlit442;
  partcv[0] = 1;
  Object opresult447 = callmethod(opresult446, "++", 1, partcv, params);
// compilenode returning opresult447
  *var_s = opresult447;
  if (opresult447 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe449 = gc_frame_new();
  int callframe450 = gc_frame_new();
  partcv[0] = 0;
  Object call451 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe450);
// compilenode returning call451
// compilenode returning call451
  gc_frame_newslot(call451);
  Object block452 = alloc_Block(NULL, NULL, "ast", 99);
  gc_frame_newslot(block452);
  block_savedest(block452);
  Object closure453 = createclosure(4, "_apply");
setclosureframe(closure453, stackframe);
  addtoclosure(closure453, var_depth);
  addtoclosure(closure453, var_spc);
  addtoclosure(closure453, var_s);
  addtoclosure(closure453, selfslot);
  struct UserObject *uo453 = (struct UserObject*)block452;
  uo453->data[0] = (Object)closure453;
  Method *meth_meth_ast__apply453 = addmethod2pos(block452, "_apply", &meth_ast__apply453, 0);
int argcv_meth_ast__apply453[] = {1};
meth_meth_ast__apply453->type = alloc_MethodType(1, argcv_meth_ast__apply453);
  meth_meth_ast__apply453->definitionModule = modulename;
  meth_meth_ast__apply453->definitionLine = 99;
// compilenode returning block452
  gc_frame_newslot(block452);
  params[0] = call451;
  params[1] = block452;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call472 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe449);
// compilenode returning call472
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply485(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 108
  setline(108);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 107
  setline(107);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit487 == NULL) {
    strlit487 = alloc_String("    ");
    gc_root(strlit487);
  }
// compilenode returning strlit487
  int op_slot_right_486 = gc_frame_newslot(strlit487);
// compilenode returning *var_spc
  int op_slot_left_486 = gc_frame_newslot(*var_spc);
  params[0] = strlit487;
  partcv[0] = 1;
  Object opresult489 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult489
  *var_spc = opresult489;
  if (opresult489 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply513(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe515 = gc_frame_new();
  Object num517 = alloc_Float64(1);
// compilenode returning num517
  int op_slot_right_516 = gc_frame_newslot(num517);
// compilenode returning *var_depth
  int op_slot_left_516 = gc_frame_newslot(*var_depth);
  params[0] = num517;
  partcv[0] = 1;
  Object sum519 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum519
  gc_frame_newslot(sum519);
// compilenode returning *var_x
  params[0] = sum519;
  partcv[0] = 1;
  Object call520 = callmethod(*var_x, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe515);
// compilenode returning call520
  int op_slot_right_514 = gc_frame_newslot(call520);
  if (strlit523 == NULL) {
    strlit523 = alloc_String("    ");
    gc_root(strlit523);
  }
// compilenode returning strlit523
  int op_slot_right_522 = gc_frame_newslot(strlit523);
// compilenode returning *var_spc
  int op_slot_right_525 = gc_frame_newslot(*var_spc);
  if (strlit528 == NULL) {
    strlit528 = alloc_String("""\x0a""");
    gc_root(strlit528);
  }
// compilenode returning strlit528
  int op_slot_right_527 = gc_frame_newslot(strlit528);
// compilenode returning *var_s
  int op_slot_left_527 = gc_frame_newslot(*var_s);
  params[0] = strlit528;
  partcv[0] = 1;
  Object opresult530 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult530
  int op_slot_left_525 = gc_frame_newslot(opresult530);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult531 = callmethod(opresult530, "++", 1, partcv, params);
// compilenode returning opresult531
  int op_slot_left_522 = gc_frame_newslot(opresult531);
  params[0] = strlit523;
  partcv[0] = 1;
  Object opresult532 = callmethod(opresult531, "++", 1, partcv, params);
// compilenode returning opresult532
  int op_slot_left_514 = gc_frame_newslot(opresult532);
  params[0] = call520;
  partcv[0] = 1;
  Object opresult533 = callmethod(opresult532, "++", 1, partcv, params);
// compilenode returning opresult533
  *var_s = opresult533;
  if (opresult533 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace473(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 106
  setline(106);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 105
  setline(105);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit474 == NULL) {
    strlit474 = alloc_String("");
    gc_root(strlit474);
  }
// compilenode returning strlit474
  *var_spc = strlit474;
  if (strlit474 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 106
  setline(106);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe475 = gc_frame_new();
  Object num478 = alloc_Float64(1);
// compilenode returning num478
  int op_slot_right_477 = gc_frame_newslot(num478);
// compilenode returning *var_depth
  int op_slot_left_477 = gc_frame_newslot(*var_depth);
  params[0] = num478;
  partcv[0] = 1;
  Object diff480 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff480
  int op_slot_right_476 = gc_frame_newslot(diff480);
  Object num482 = alloc_Float64(0);
// compilenode returning num482
  int op_slot_left_476 = gc_frame_newslot(num482);
  params[0] = diff480;
  partcv[0] = 1;
  Object opresult483 = callmethod(num482, "..", 1, partcv, params);
// compilenode returning opresult483
  gc_frame_newslot(opresult483);
  Object block484 = alloc_Block(NULL, NULL, "ast", 106);
  gc_frame_newslot(block484);
  block_savedest(block484);
  Object closure485 = createclosure(2, "_apply");
setclosureframe(closure485, stackframe);
  addtoclosure(closure485, var_spc);
  addtoclosure(closure485, selfslot);
  struct UserObject *uo485 = (struct UserObject*)block484;
  uo485->data[0] = (Object)closure485;
  Method *meth_meth_ast__apply485 = addmethod2pos(block484, "_apply", &meth_ast__apply485, 0);
int argcv_meth_ast__apply485[] = {1};
meth_meth_ast__apply485->type = alloc_MethodType(1, argcv_meth_ast__apply485);
  meth_meth_ast__apply485->definitionModule = modulename;
  meth_meth_ast__apply485->definitionLine = 99;
// compilenode returning block484
  gc_frame_newslot(block484);
  params[0] = opresult483;
  params[1] = block484;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call492 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe475);
// compilenode returning call492
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 109
  setline(109);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit494 == NULL) {
    strlit494 = alloc_String("} do {");
    gc_root(strlit494);
  }
// compilenode returning strlit494
  int op_slot_right_493 = gc_frame_newslot(strlit494);
  int callframe497 = gc_frame_new();
  Object num499 = alloc_Float64(1);
// compilenode returning num499
  int op_slot_right_498 = gc_frame_newslot(num499);
// compilenode returning *var_depth
  int op_slot_left_498 = gc_frame_newslot(*var_depth);
  params[0] = num499;
  partcv[0] = 1;
  Object sum501 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum501
  gc_frame_newslot(sum501);
  int callframe502 = gc_frame_new();
  partcv[0] = 0;
  Object call503 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe502);
// compilenode returning call503
// compilenode returning call503
  params[0] = sum501;
  partcv[0] = 1;
  Object call504 = callmethod(call503, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe497);
// compilenode returning call504
  int op_slot_right_496 = gc_frame_newslot(call504);
  if (strlit506 == NULL) {
    strlit506 = alloc_String("while {");
    gc_root(strlit506);
  }
// compilenode returning strlit506
  int op_slot_left_496 = gc_frame_newslot(strlit506);
  params[0] = call504;
  partcv[0] = 1;
  Object opresult507 = callmethod(strlit506, "++", 1, partcv, params);
// compilenode returning opresult507
  int op_slot_left_493 = gc_frame_newslot(opresult507);
  params[0] = strlit494;
  partcv[0] = 1;
  Object opresult508 = callmethod(opresult507, "++", 1, partcv, params);
// compilenode returning opresult508
  *var_s = opresult508;
  if (opresult508 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe509 = gc_frame_new();
  int callframe510 = gc_frame_new();
  partcv[0] = 0;
  Object call511 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe510);
// compilenode returning call511
// compilenode returning call511
  gc_frame_newslot(call511);
  Object block512 = alloc_Block(NULL, NULL, "ast", 110);
  gc_frame_newslot(block512);
  block_savedest(block512);
  Object closure513 = createclosure(4, "_apply");
setclosureframe(closure513, stackframe);
  addtoclosure(closure513, var_depth);
  addtoclosure(closure513, var_spc);
  addtoclosure(closure513, var_s);
  addtoclosure(closure513, selfslot);
  struct UserObject *uo513 = (struct UserObject*)block512;
  uo513->data[0] = (Object)closure513;
  Method *meth_meth_ast__apply513 = addmethod2pos(block512, "_apply", &meth_ast__apply513, 0);
int argcv_meth_ast__apply513[] = {1};
meth_meth_ast__apply513->type = alloc_MethodType(1, argcv_meth_ast__apply513);
  meth_meth_ast__apply513->definitionModule = modulename;
  meth_meth_ast__apply513->definitionLine = 110;
// compilenode returning block512
  gc_frame_newslot(block512);
  params[0] = call511;
  params[1] = block512;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call536 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe509);
// compilenode returning call536
// Begin line 114
  setline(114);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 113
  setline(113);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit538 == NULL) {
    strlit538 = alloc_String("}");
    gc_root(strlit538);
  }
// compilenode returning strlit538
  int op_slot_right_537 = gc_frame_newslot(strlit538);
// compilenode returning *var_spc
  int op_slot_right_540 = gc_frame_newslot(*var_spc);
  if (strlit543 == NULL) {
    strlit543 = alloc_String("""\x0a""");
    gc_root(strlit543);
  }
// compilenode returning strlit543
  int op_slot_right_542 = gc_frame_newslot(strlit543);
// compilenode returning *var_s
  int op_slot_left_542 = gc_frame_newslot(*var_s);
  params[0] = strlit543;
  partcv[0] = 1;
  Object opresult545 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult545
  int op_slot_left_540 = gc_frame_newslot(opresult545);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult546 = callmethod(opresult545, "++", 1, partcv, params);
// compilenode returning opresult546
  int op_slot_left_537 = gc_frame_newslot(opresult546);
  params[0] = strlit538;
  partcv[0] = 1;
  Object opresult547 = callmethod(opresult546, "++", 1, partcv, params);
// compilenode returning opresult547
  *var_s = opresult547;
  if (opresult547 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 114
  setline(114);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new381(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject382 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj382 = alloc_userobj2(7,8, objclass382);
  gc_frame_newslot(obj382);
if (objclass382 == NULL) {
  glfree(obj382->class->name);
  obj382->class->name = "whileNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj382, self, 0);
  addmethodreal(obj382,"outer", &reader_ast_outer_383);
  Object oldself382 = self;
  struct StackFrameObject *oldstackframe382 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe382);
  gc_frame_newslot((Object)stackframe);
  self = obj382;
  Object *oldselfslot382 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter382 = (*(struct UserObject *)self).data[0], lowerouter382 = thisouter382;
  if (inheritingObject382) {
    struct UserObject *inho382 = (struct UserObject *)inheritingObject382;
    while (inho382->super != GraceDefaultObject) inho382 = (struct UserObject *)inho382->super;
    inho382->super = obj382;
    self = inheritingObject382;
    *selfslot = self;
    lowerouter382 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter382;
  }
if (objclass382 == NULL) {
  Method *reader384 = addmethodrealflags(obj382, "kind",&reader_ast_kind_384, MFLAG_DEF);
  reader384->definitionModule = modulename;
  reader384->definitionLine = 80;
}
adddatum2(obj382, alloc_Undefined(), 1);
if (objclass382 == NULL) {
  Method *reader385 = addmethodrealflags(obj382, "value",&reader_ast_value_385, MFLAG_DEF);
  reader385->definitionModule = modulename;
  reader385->definitionLine = 81;
}
adddatum2(obj382, alloc_Undefined(), 2);
if (objclass382 == NULL) {
  Method *reader386 = addmethodrealflags(obj382, "body",&reader_ast_body_386, MFLAG_DEF);
  reader386->definitionModule = modulename;
  reader386->definitionLine = 82;
}
adddatum2(obj382, alloc_Undefined(), 3);
  struct UserObject *uo387 = (struct UserObject*)obj382;
  uo387->data[4] = emptyclosure;
  Method *meth_meth_ast_accept387 = addmethod2pos(obj382, "accept", &meth_ast_accept387, 4);
int argcv_meth_ast_accept387[] = {1};
meth_meth_ast_accept387->type = alloc_MethodType(1, argcv_meth_ast_accept387);
meth_meth_ast_accept387->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept387->type->names[0] = "visitor";
  meth_meth_ast_accept387->definitionModule = modulename;
  meth_meth_ast_accept387->definitionLine = 82;
  struct UserObject *uo404 = (struct UserObject*)obj382;
  uo404->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty404 = addmethod2pos(obj382, "pretty", &meth_ast_pretty404, 5);
int argcv_meth_ast_pretty404[] = {1};
meth_meth_ast_pretty404->type = alloc_MethodType(1, argcv_meth_ast_pretty404);
  meth_meth_ast_pretty404->definitionModule = modulename;
  meth_meth_ast_pretty404->definitionLine = 90;
  struct UserObject *uo473 = (struct UserObject*)obj382;
  uo473->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace473 = addmethod2pos(obj382, "toGrace", &meth_ast_toGrace473, 6);
int argcv_meth_ast_toGrace473[] = {1};
meth_meth_ast_toGrace473->type = alloc_MethodType(1, argcv_meth_ast_toGrace473);
meth_meth_ast_toGrace473->type->types[0] = type_Number;
meth_meth_ast_toGrace473->type->names[0] = "depth";
  meth_meth_ast_toGrace473->definitionModule = modulename;
  meth_meth_ast_toGrace473->definitionLine = 104;
  sourceObject = obj382;
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe549 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call550 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe549);
// compilenode returning call550
  struct UserObject *obj382_uo = (struct UserObject *)obj382;
  obj382_uo->super = call550;
  sourceObject = obj382;
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit551 == NULL) {
    strlit551 = alloc_String("while");
    gc_root(strlit551);
  }
// compilenode returning strlit551
  adddatum2(obj382, strlit551, 1);
  sourceObject = obj382;
// Begin line 80
  setline(80);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_cond
  adddatum2(obj382, *var_cond, 2);
  sourceObject = obj382;
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_body_39_
  adddatum2(obj382, *var_body_39_, 3);
  sourceObject = obj382;
  sourceObject = obj382;
  sourceObject = obj382;
objclass382 = obj382->class;
  objclass382->definitionModule = modulename;
  objclass382->definitionLine = 73;
  (*(struct UserObject *)self).data[0] = lowerouter382;
  self = oldself382;
  selfslot = oldselfslot382;
  stackframe = oldstackframe382;
  gc_frame_end(frame);
  return obj382;
}
Object meth_ast_new381_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject382 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj382 = alloc_userobj2(7,8, objclass382);
  gc_frame_newslot(obj382);
if (objclass382 == NULL) {
  glfree(obj382->class->name);
  obj382->class->name = "whileNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj382, self, 0);
  addmethodreal(obj382,"outer", &reader_ast_outer_383);
  Object oldself382 = self;
  struct StackFrameObject *oldstackframe382 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe382);
  gc_frame_newslot((Object)stackframe);
  self = obj382;
  Object *oldselfslot382 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter382 = (*(struct UserObject *)self).data[0], lowerouter382 = thisouter382;
  if (inheritingObject382) {
    struct UserObject *inho382 = (struct UserObject *)inheritingObject382;
    while (inho382->super != GraceDefaultObject) inho382 = (struct UserObject *)inho382->super;
    inho382->super = obj382;
    self = inheritingObject382;
    *selfslot = self;
    lowerouter382 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter382;
  }
if (objclass382 == NULL) {
  Method *reader384 = addmethodrealflags(obj382, "kind",&reader_ast_kind_384, MFLAG_DEF);
  reader384->definitionModule = modulename;
  reader384->definitionLine = 80;
}
adddatum2(obj382, alloc_Undefined(), 1);
if (objclass382 == NULL) {
  Method *reader385 = addmethodrealflags(obj382, "value",&reader_ast_value_385, MFLAG_DEF);
  reader385->definitionModule = modulename;
  reader385->definitionLine = 81;
}
adddatum2(obj382, alloc_Undefined(), 2);
if (objclass382 == NULL) {
  Method *reader386 = addmethodrealflags(obj382, "body",&reader_ast_body_386, MFLAG_DEF);
  reader386->definitionModule = modulename;
  reader386->definitionLine = 82;
}
adddatum2(obj382, alloc_Undefined(), 3);
  struct UserObject *uo387 = (struct UserObject*)obj382;
  uo387->data[4] = emptyclosure;
  Method *meth_meth_ast_accept387 = addmethod2pos(obj382, "accept", &meth_ast_accept387, 4);
int argcv_meth_ast_accept387[] = {1};
meth_meth_ast_accept387->type = alloc_MethodType(1, argcv_meth_ast_accept387);
meth_meth_ast_accept387->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept387->type->names[0] = "visitor";
  meth_meth_ast_accept387->definitionModule = modulename;
  meth_meth_ast_accept387->definitionLine = 82;
  struct UserObject *uo404 = (struct UserObject*)obj382;
  uo404->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty404 = addmethod2pos(obj382, "pretty", &meth_ast_pretty404, 5);
int argcv_meth_ast_pretty404[] = {1};
meth_meth_ast_pretty404->type = alloc_MethodType(1, argcv_meth_ast_pretty404);
  meth_meth_ast_pretty404->definitionModule = modulename;
  meth_meth_ast_pretty404->definitionLine = 90;
  struct UserObject *uo473 = (struct UserObject*)obj382;
  uo473->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace473 = addmethod2pos(obj382, "toGrace", &meth_ast_toGrace473, 6);
int argcv_meth_ast_toGrace473[] = {1};
meth_meth_ast_toGrace473->type = alloc_MethodType(1, argcv_meth_ast_toGrace473);
meth_meth_ast_toGrace473->type->types[0] = type_Number;
meth_meth_ast_toGrace473->type->names[0] = "depth";
  meth_meth_ast_toGrace473->definitionModule = modulename;
  meth_meth_ast_toGrace473->definitionLine = 104;
  sourceObject = obj382;
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe549 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call550 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe549);
// compilenode returning call550
  struct UserObject *obj382_uo = (struct UserObject *)obj382;
  obj382_uo->super = call550;
  sourceObject = obj382;
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit551 == NULL) {
    strlit551 = alloc_String("while");
    gc_root(strlit551);
  }
// compilenode returning strlit551
  adddatum2(obj382, strlit551, 1);
  sourceObject = obj382;
// Begin line 80
  setline(80);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_cond
  adddatum2(obj382, *var_cond, 2);
  sourceObject = obj382;
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_body_39_
  adddatum2(obj382, *var_body_39_, 3);
  sourceObject = obj382;
  sourceObject = obj382;
  sourceObject = obj382;
objclass382 = obj382->class;
  objclass382->definitionModule = modulename;
  objclass382->definitionLine = 73;
  (*(struct UserObject *)self).data[0] = lowerouter382;
  self = oldself382;
  selfslot = oldselfslot382;
  stackframe = oldstackframe382;
  gc_frame_end(frame);
  return obj382;
}
Object meth_ast_ifNode553(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ifNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ifNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for ifNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for ifNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_ifNode
  gc_frame_end(frame);
  return *var_ifNode;
}
Object meth_ast__apply576(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 128
  setline(128);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe577 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_ix
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call578 = callmethod(*var_ix, "accept",
    1, partcv, params);
  gc_frame_end(callframe577);
// compilenode returning call578
  gc_frame_end(frame);
  return call578;
}
Object meth_ast__apply585(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 131
  setline(131);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe586 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_ix
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call587 = callmethod(*var_ix, "accept",
    1, partcv, params);
  gc_frame_end(callframe586);
// compilenode returning call587
  gc_frame_end(frame);
  return call587;
}
Object meth_ast_accept564(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 134
  setline(134);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 125
  setline(125);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe566 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call567 = callmethod(*var_visitor, "visitIf",
    1, partcv, params);
  gc_frame_end(callframe566);
// compilenode returning call567
  Object if565 = done;
  if (istrue(call567)) {
// Begin line 126
  setline(126);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe568 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe569 = gc_frame_new();
  partcv[0] = 0;
  Object call570 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe569);
// compilenode returning call570
// compilenode returning call570
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call571 = callmethod(call570, "accept",
    1, partcv, params);
  gc_frame_end(callframe568);
// compilenode returning call571
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe572 = gc_frame_new();
  int callframe573 = gc_frame_new();
  partcv[0] = 0;
  Object call574 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe573);
// compilenode returning call574
// compilenode returning call574
  gc_frame_newslot(call574);
  Object block575 = alloc_Block(NULL, NULL, "ast", 127);
  gc_frame_newslot(block575);
  block_savedest(block575);
  Object closure576 = createclosure(2, "_apply");
setclosureframe(closure576, stackframe);
  addtoclosure(closure576, var_visitor);
  addtoclosure(closure576, selfslot);
  struct UserObject *uo576 = (struct UserObject*)block575;
  uo576->data[0] = (Object)closure576;
  Method *meth_meth_ast__apply576 = addmethod2pos(block575, "_apply", &meth_ast__apply576, 0);
int argcv_meth_ast__apply576[] = {1};
meth_meth_ast__apply576->type = alloc_MethodType(1, argcv_meth_ast__apply576);
  meth_meth_ast__apply576->definitionModule = modulename;
  meth_meth_ast__apply576->definitionLine = 127;
// compilenode returning block575
  gc_frame_newslot(block575);
  params[0] = call574;
  params[1] = block575;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call580 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe572);
// compilenode returning call580
// Begin line 130
  setline(130);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe581 = gc_frame_new();
  int callframe582 = gc_frame_new();
  partcv[0] = 0;
  Object call583 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe582);
// compilenode returning call583
// compilenode returning call583
  gc_frame_newslot(call583);
  Object block584 = alloc_Block(NULL, NULL, "ast", 130);
  gc_frame_newslot(block584);
  block_savedest(block584);
  Object closure585 = createclosure(2, "_apply");
setclosureframe(closure585, stackframe);
  addtoclosure(closure585, var_visitor);
  addtoclosure(closure585, selfslot);
  struct UserObject *uo585 = (struct UserObject*)block584;
  uo585->data[0] = (Object)closure585;
  Method *meth_meth_ast__apply585 = addmethod2pos(block584, "_apply", &meth_ast__apply585, 0);
int argcv_meth_ast__apply585[] = {1};
meth_meth_ast__apply585->type = alloc_MethodType(1, argcv_meth_ast__apply585);
  meth_meth_ast__apply585->definitionModule = modulename;
  meth_meth_ast__apply585->definitionLine = 130;
// compilenode returning block584
  gc_frame_newslot(block584);
  params[0] = call583;
  params[1] = block584;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call589 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe581);
// compilenode returning call589
    gc_frame_newslot(call589);
    if565 = call589;
  } else {
  }
// compilenode returning if565
  gc_frame_end(frame);
  return if565;
}
Object meth_ast_map_40__41_before_40__41_after590(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_ifNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_v = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "v");
  Object *var_tb = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "tb");
  Object *var_eb = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "eb");
  Object *var_n = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "n");
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe591 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call592 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe591);
// compilenode returning call592
// Begin line 137
  setline(137);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe593 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe594 = gc_frame_new();
  partcv[0] = 0;
  Object call595 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe594);
// compilenode returning call595
// compilenode returning call595
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call596 = callmethod(call595, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe593);
// compilenode returning call596
  *var_v = call596;
  if (call596 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 138
  setline(138);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe597 = gc_frame_new();
  int callframe598 = gc_frame_new();
  partcv[0] = 0;
  Object call599 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe598);
// compilenode returning call599
// compilenode returning call599
  gc_frame_newslot(call599);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe600 = gc_frame_new();
  int callframe601 = gc_frame_new();
  Object call602 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe601);
// compilenode returning call602
// compilenode returning call602
  partcv[0] = 0;
  Object call603 = callmethodflags(call602, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe600);
// compilenode returning call603
// compilenode returning call603
  params[0] = call599;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call604 = callmethodflags(call603, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe597);
// compilenode returning call604
  *var_tb = call604;
  if (call604 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe605 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkAfter
  params[0] = self;
  partcv[0] = 1;
  Object call606 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe605);
// compilenode returning call606
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe607 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call608 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe607);
// compilenode returning call608
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe609 = gc_frame_new();
  int callframe610 = gc_frame_new();
  partcv[0] = 0;
  Object call611 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe610);
// compilenode returning call611
// compilenode returning call611
  gc_frame_newslot(call611);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe612 = gc_frame_new();
  int callframe613 = gc_frame_new();
  Object call614 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe613);
// compilenode returning call614
// compilenode returning call614
  partcv[0] = 0;
  Object call615 = callmethodflags(call614, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe612);
// compilenode returning call615
// compilenode returning call615
  params[0] = call611;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call616 = callmethodflags(call615, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe609);
// compilenode returning call616
  *var_eb = call616;
  if (call616 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe617 = gc_frame_new();
// compilenode returning *var_v
  gc_frame_newslot(*var_v);
// compilenode returning *var_tb
  gc_frame_newslot(*var_tb);
// compilenode returning *var_eb
  gc_frame_newslot(*var_eb);
// compilenode returning *var_ifNode
  params[0] = *var_v;
  params[1] = *var_tb;
  params[2] = *var_eb;
  partcv[0] = 3;
  Object call618 = callmethod(*var_ifNode, "new",
    1, partcv, params);
  gc_frame_end(callframe617);
// compilenode returning call618
  *var_n = call618;
  if (call618 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe619 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call620 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe619);
// compilenode returning call620
  *var_n = call620;
  if (call620 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe622 = gc_frame_new();
// Begin line 144
  setline(144);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe623 = gc_frame_new();
  partcv[0] = 0;
  Object call624 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe623);
// compilenode returning call624
  gc_frame_newslot(call624);
// compilenode returning *var_n
  params[0] = call624;
  partcv[0] = 1;
  Object call625 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe622);
// compilenode returning call625
// compilenode returning done
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe626 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call627 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe626);
// compilenode returning call627
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply631(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply634(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map628(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe629 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block630 = alloc_Block(NULL, NULL, "ast", 149);
  gc_frame_newslot(block630);
  block_savedest(block630);
  Object closure631 = createclosure(1, "_apply");
setclosureframe(closure631, stackframe);
  addtoclosure(closure631, selfslot);
  struct UserObject *uo631 = (struct UserObject*)block630;
  uo631->data[0] = (Object)closure631;
  Method *meth_meth_ast__apply631 = addmethod2pos(block630, "_apply", &meth_ast__apply631, 0);
int argcv_meth_ast__apply631[] = {0};
meth_meth_ast__apply631->type = alloc_MethodType(1, argcv_meth_ast__apply631);
  meth_meth_ast__apply631->definitionModule = modulename;
  meth_meth_ast__apply631->definitionLine = 141;
// compilenode returning block630
  gc_frame_newslot(block630);
  Object block633 = alloc_Block(NULL, NULL, "ast", 149);
  gc_frame_newslot(block633);
  block_savedest(block633);
  Object closure634 = createclosure(1, "_apply");
setclosureframe(closure634, stackframe);
  addtoclosure(closure634, selfslot);
  struct UserObject *uo634 = (struct UserObject*)block633;
  uo634->data[0] = (Object)closure634;
  Method *meth_meth_ast__apply634 = addmethod2pos(block633, "_apply", &meth_ast__apply634, 0);
int argcv_meth_ast__apply634[] = {0};
meth_meth_ast__apply634->type = alloc_MethodType(1, argcv_meth_ast__apply634);
  meth_meth_ast__apply634->definitionModule = modulename;
  meth_meth_ast__apply634->definitionLine = 141;
// compilenode returning block633
  gc_frame_newslot(block633);
  params[0] = *var_blk;
  params[1] = block630;
  params[2] = block633;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call636 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe629);
// compilenode returning call636
  gc_frame_end(frame);
  return call636;
}
Object meth_ast__apply645(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 155
  setline(155);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit647 == NULL) {
    strlit647 = alloc_String("  ");
    gc_root(strlit647);
  }
// compilenode returning strlit647
  int op_slot_right_646 = gc_frame_newslot(strlit647);
// compilenode returning *var_spc
  int op_slot_left_646 = gc_frame_newslot(*var_spc);
  params[0] = strlit647;
  partcv[0] = 1;
  Object opresult649 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult649
  *var_spc = opresult649;
  if (opresult649 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply686(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 161
  setline(161);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe688 = gc_frame_new();
  Object num690 = alloc_Float64(2);
// compilenode returning num690
  int op_slot_right_689 = gc_frame_newslot(num690);
// compilenode returning *var_depth
  int op_slot_left_689 = gc_frame_newslot(*var_depth);
  params[0] = num690;
  partcv[0] = 1;
  Object sum692 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum692
  gc_frame_newslot(sum692);
// compilenode returning *var_ix
  params[0] = sum692;
  partcv[0] = 1;
  Object call693 = callmethod(*var_ix, "pretty",
    1, partcv, params);
  gc_frame_end(callframe688);
// compilenode returning call693
  int op_slot_right_687 = gc_frame_newslot(call693);
// compilenode returning *var_spc
  int op_slot_right_695 = gc_frame_newslot(*var_spc);
  if (strlit698 == NULL) {
    strlit698 = alloc_String("""\x0a""  ");
    gc_root(strlit698);
  }
// compilenode returning strlit698
  int op_slot_right_697 = gc_frame_newslot(strlit698);
// compilenode returning *var_s
  int op_slot_left_697 = gc_frame_newslot(*var_s);
  params[0] = strlit698;
  partcv[0] = 1;
  Object opresult700 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult700
  int op_slot_left_695 = gc_frame_newslot(opresult700);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult701 = callmethod(opresult700, "++", 1, partcv, params);
// compilenode returning opresult701
  int op_slot_left_687 = gc_frame_newslot(opresult701);
  params[0] = call693;
  partcv[0] = 1;
  Object opresult702 = callmethod(opresult701, "++", 1, partcv, params);
// compilenode returning opresult702
  *var_s = opresult702;
  if (opresult702 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply723(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 166
  setline(166);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe725 = gc_frame_new();
  Object num727 = alloc_Float64(2);
// compilenode returning num727
  int op_slot_right_726 = gc_frame_newslot(num727);
// compilenode returning *var_depth
  int op_slot_left_726 = gc_frame_newslot(*var_depth);
  params[0] = num727;
  partcv[0] = 1;
  Object sum729 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum729
  gc_frame_newslot(sum729);
// compilenode returning *var_ix
  params[0] = sum729;
  partcv[0] = 1;
  Object call730 = callmethod(*var_ix, "pretty",
    1, partcv, params);
  gc_frame_end(callframe725);
// compilenode returning call730
  int op_slot_right_724 = gc_frame_newslot(call730);
// compilenode returning *var_spc
  int op_slot_right_732 = gc_frame_newslot(*var_spc);
  if (strlit735 == NULL) {
    strlit735 = alloc_String("""\x0a""  ");
    gc_root(strlit735);
  }
// compilenode returning strlit735
  int op_slot_right_734 = gc_frame_newslot(strlit735);
// compilenode returning *var_s
  int op_slot_left_734 = gc_frame_newslot(*var_s);
  params[0] = strlit735;
  partcv[0] = 1;
  Object opresult737 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult737
  int op_slot_left_732 = gc_frame_newslot(opresult737);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult738 = callmethod(opresult737, "++", 1, partcv, params);
// compilenode returning opresult738
  int op_slot_left_724 = gc_frame_newslot(opresult738);
  params[0] = call730;
  partcv[0] = 1;
  Object opresult739 = callmethod(opresult738, "++", 1, partcv, params);
// compilenode returning opresult739
  *var_s = opresult739;
  if (opresult739 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty637(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit638 == NULL) {
    strlit638 = alloc_String("");
    gc_root(strlit638);
  }
// compilenode returning strlit638
  *var_spc = strlit638;
  if (strlit638 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe639 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_640 = gc_frame_newslot(*var_depth);
  Object num642 = alloc_Float64(0);
// compilenode returning num642
  int op_slot_left_640 = gc_frame_newslot(num642);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult643 = callmethod(num642, "..", 1, partcv, params);
// compilenode returning opresult643
  gc_frame_newslot(opresult643);
  Object block644 = alloc_Block(NULL, NULL, "ast", 153);
  gc_frame_newslot(block644);
  block_savedest(block644);
  Object closure645 = createclosure(2, "_apply");
setclosureframe(closure645, stackframe);
  addtoclosure(closure645, var_spc);
  addtoclosure(closure645, selfslot);
  struct UserObject *uo645 = (struct UserObject*)block644;
  uo645->data[0] = (Object)closure645;
  Method *meth_meth_ast__apply645 = addmethod2pos(block644, "_apply", &meth_ast__apply645, 0);
int argcv_meth_ast__apply645[] = {1};
meth_meth_ast__apply645->type = alloc_MethodType(1, argcv_meth_ast__apply645);
  meth_meth_ast__apply645->definitionModule = modulename;
  meth_meth_ast__apply645->definitionLine = 141;
// compilenode returning block644
  gc_frame_newslot(block644);
  params[0] = opresult643;
  params[1] = block644;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call652 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe639);
// compilenode returning call652
// Begin line 157
  setline(157);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 156
  setline(156);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit653 == NULL) {
    strlit653 = alloc_String("If""\x0a""");
    gc_root(strlit653);
  }
// compilenode returning strlit653
  *var_s = strlit653;
  if (strlit653 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 157
  setline(157);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe655 = gc_frame_new();
  Object num657 = alloc_Float64(1);
// compilenode returning num657
  int op_slot_right_656 = gc_frame_newslot(num657);
// compilenode returning *var_depth
  int op_slot_left_656 = gc_frame_newslot(*var_depth);
  params[0] = num657;
  partcv[0] = 1;
  Object sum659 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum659
  gc_frame_newslot(sum659);
  int callframe660 = gc_frame_new();
  partcv[0] = 0;
  Object call661 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe660);
// compilenode returning call661
// compilenode returning call661
  params[0] = sum659;
  partcv[0] = 1;
  Object call662 = callmethod(call661, "pretty",
    1, partcv, params);
  gc_frame_end(callframe655);
// compilenode returning call662
  int op_slot_right_654 = gc_frame_newslot(call662);
// compilenode returning *var_spc
  int op_slot_right_664 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_664 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult666 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult666
  int op_slot_left_654 = gc_frame_newslot(opresult666);
  params[0] = call662;
  partcv[0] = 1;
  Object opresult667 = callmethod(opresult666, "++", 1, partcv, params);
// compilenode returning opresult667
  *var_s = opresult667;
  if (opresult667 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 159
  setline(159);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 158
  setline(158);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit670 == NULL) {
    strlit670 = alloc_String("""\x0a""");
    gc_root(strlit670);
  }
// compilenode returning strlit670
  int op_slot_right_669 = gc_frame_newslot(strlit670);
// compilenode returning *var_s
  int op_slot_left_669 = gc_frame_newslot(*var_s);
  params[0] = strlit670;
  partcv[0] = 1;
  Object opresult672 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult672
  *var_s = opresult672;
  if (opresult672 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 160
  setline(160);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 159
  setline(159);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit675 == NULL) {
    strlit675 = alloc_String("Then:");
    gc_root(strlit675);
  }
// compilenode returning strlit675
  int op_slot_right_674 = gc_frame_newslot(strlit675);
// compilenode returning *var_spc
  int op_slot_right_677 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_677 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult679 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult679
  int op_slot_left_674 = gc_frame_newslot(opresult679);
  params[0] = strlit675;
  partcv[0] = 1;
  Object opresult680 = callmethod(opresult679, "++", 1, partcv, params);
// compilenode returning opresult680
  *var_s = opresult680;
  if (opresult680 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 160
  setline(160);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe682 = gc_frame_new();
  int callframe683 = gc_frame_new();
  partcv[0] = 0;
  Object call684 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe683);
// compilenode returning call684
// compilenode returning call684
  gc_frame_newslot(call684);
  Object block685 = alloc_Block(NULL, NULL, "ast", 160);
  gc_frame_newslot(block685);
  block_savedest(block685);
  Object closure686 = createclosure(4, "_apply");
setclosureframe(closure686, stackframe);
  addtoclosure(closure686, var_depth);
  addtoclosure(closure686, var_spc);
  addtoclosure(closure686, var_s);
  addtoclosure(closure686, selfslot);
  struct UserObject *uo686 = (struct UserObject*)block685;
  uo686->data[0] = (Object)closure686;
  Method *meth_meth_ast__apply686 = addmethod2pos(block685, "_apply", &meth_ast__apply686, 0);
int argcv_meth_ast__apply686[] = {1};
meth_meth_ast__apply686->type = alloc_MethodType(1, argcv_meth_ast__apply686);
  meth_meth_ast__apply686->definitionModule = modulename;
  meth_meth_ast__apply686->definitionLine = 160;
// compilenode returning block685
  gc_frame_newslot(block685);
  params[0] = call684;
  params[1] = block685;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call705 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe682);
// compilenode returning call705
// Begin line 164
  setline(164);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 163
  setline(163);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit707 == NULL) {
    strlit707 = alloc_String("""\x0a""");
    gc_root(strlit707);
  }
// compilenode returning strlit707
  int op_slot_right_706 = gc_frame_newslot(strlit707);
// compilenode returning *var_s
  int op_slot_left_706 = gc_frame_newslot(*var_s);
  params[0] = strlit707;
  partcv[0] = 1;
  Object opresult709 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult709
  *var_s = opresult709;
  if (opresult709 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 165
  setline(165);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 164
  setline(164);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit712 == NULL) {
    strlit712 = alloc_String("Else:");
    gc_root(strlit712);
  }
// compilenode returning strlit712
  int op_slot_right_711 = gc_frame_newslot(strlit712);
// compilenode returning *var_spc
  int op_slot_right_714 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_714 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult716 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult716
  int op_slot_left_711 = gc_frame_newslot(opresult716);
  params[0] = strlit712;
  partcv[0] = 1;
  Object opresult717 = callmethod(opresult716, "++", 1, partcv, params);
// compilenode returning opresult717
  *var_s = opresult717;
  if (opresult717 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 165
  setline(165);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe719 = gc_frame_new();
  int callframe720 = gc_frame_new();
  partcv[0] = 0;
  Object call721 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe720);
// compilenode returning call721
// compilenode returning call721
  gc_frame_newslot(call721);
  Object block722 = alloc_Block(NULL, NULL, "ast", 165);
  gc_frame_newslot(block722);
  block_savedest(block722);
  Object closure723 = createclosure(4, "_apply");
setclosureframe(closure723, stackframe);
  addtoclosure(closure723, var_depth);
  addtoclosure(closure723, var_spc);
  addtoclosure(closure723, var_s);
  addtoclosure(closure723, selfslot);
  struct UserObject *uo723 = (struct UserObject*)block722;
  uo723->data[0] = (Object)closure723;
  Method *meth_meth_ast__apply723 = addmethod2pos(block722, "_apply", &meth_ast__apply723, 0);
int argcv_meth_ast__apply723[] = {1};
meth_meth_ast__apply723->type = alloc_MethodType(1, argcv_meth_ast__apply723);
  meth_meth_ast__apply723->definitionModule = modulename;
  meth_meth_ast__apply723->definitionLine = 165;
// compilenode returning block722
  gc_frame_newslot(block722);
  params[0] = call721;
  params[1] = block722;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call742 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe719);
// compilenode returning call742
// Begin line 168
  setline(168);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply755(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 174
  setline(174);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit757 == NULL) {
    strlit757 = alloc_String("    ");
    gc_root(strlit757);
  }
// compilenode returning strlit757
  int op_slot_right_756 = gc_frame_newslot(strlit757);
// compilenode returning *var_spc
  int op_slot_left_756 = gc_frame_newslot(*var_spc);
  params[0] = strlit757;
  partcv[0] = 1;
  Object opresult759 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult759
  *var_spc = opresult759;
  if (opresult759 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply780(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 177
  setline(177);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe782 = gc_frame_new();
  Object num784 = alloc_Float64(1);
// compilenode returning num784
  int op_slot_right_783 = gc_frame_newslot(num784);
// compilenode returning *var_depth
  int op_slot_left_783 = gc_frame_newslot(*var_depth);
  params[0] = num784;
  partcv[0] = 1;
  Object sum786 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum786
  gc_frame_newslot(sum786);
// compilenode returning *var_ix
  params[0] = sum786;
  partcv[0] = 1;
  Object call787 = callmethod(*var_ix, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe782);
// compilenode returning call787
  int op_slot_right_781 = gc_frame_newslot(call787);
  if (strlit790 == NULL) {
    strlit790 = alloc_String("    ");
    gc_root(strlit790);
  }
// compilenode returning strlit790
  int op_slot_right_789 = gc_frame_newslot(strlit790);
// compilenode returning *var_spc
  int op_slot_right_792 = gc_frame_newslot(*var_spc);
  if (strlit795 == NULL) {
    strlit795 = alloc_String("""\x0a""");
    gc_root(strlit795);
  }
// compilenode returning strlit795
  int op_slot_right_794 = gc_frame_newslot(strlit795);
// compilenode returning *var_s
  int op_slot_left_794 = gc_frame_newslot(*var_s);
  params[0] = strlit795;
  partcv[0] = 1;
  Object opresult797 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult797
  int op_slot_left_792 = gc_frame_newslot(opresult797);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult798 = callmethod(opresult797, "++", 1, partcv, params);
// compilenode returning opresult798
  int op_slot_left_789 = gc_frame_newslot(opresult798);
  params[0] = strlit790;
  partcv[0] = 1;
  Object opresult799 = callmethod(opresult798, "++", 1, partcv, params);
// compilenode returning opresult799
  int op_slot_left_781 = gc_frame_newslot(opresult799);
  params[0] = call787;
  partcv[0] = 1;
  Object opresult800 = callmethod(opresult799, "++", 1, partcv, params);
// compilenode returning opresult800
  *var_s = opresult800;
  if (opresult800 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply829(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 182
  setline(182);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe831 = gc_frame_new();
  Object num833 = alloc_Float64(1);
// compilenode returning num833
  int op_slot_right_832 = gc_frame_newslot(num833);
// compilenode returning *var_depth
  int op_slot_left_832 = gc_frame_newslot(*var_depth);
  params[0] = num833;
  partcv[0] = 1;
  Object sum835 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum835
  gc_frame_newslot(sum835);
// compilenode returning *var_ix
  params[0] = sum835;
  partcv[0] = 1;
  Object call836 = callmethod(*var_ix, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe831);
// compilenode returning call836
  int op_slot_right_830 = gc_frame_newslot(call836);
  if (strlit839 == NULL) {
    strlit839 = alloc_String("    ");
    gc_root(strlit839);
  }
// compilenode returning strlit839
  int op_slot_right_838 = gc_frame_newslot(strlit839);
// compilenode returning *var_spc
  int op_slot_right_841 = gc_frame_newslot(*var_spc);
  if (strlit844 == NULL) {
    strlit844 = alloc_String("""\x0a""");
    gc_root(strlit844);
  }
// compilenode returning strlit844
  int op_slot_right_843 = gc_frame_newslot(strlit844);
// compilenode returning *var_s
  int op_slot_left_843 = gc_frame_newslot(*var_s);
  params[0] = strlit844;
  partcv[0] = 1;
  Object opresult846 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult846
  int op_slot_left_841 = gc_frame_newslot(opresult846);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult847 = callmethod(opresult846, "++", 1, partcv, params);
// compilenode returning opresult847
  int op_slot_left_838 = gc_frame_newslot(opresult847);
  params[0] = strlit839;
  partcv[0] = 1;
  Object opresult848 = callmethod(opresult847, "++", 1, partcv, params);
// compilenode returning opresult848
  int op_slot_left_830 = gc_frame_newslot(opresult848);
  params[0] = call836;
  partcv[0] = 1;
  Object opresult849 = callmethod(opresult848, "++", 1, partcv, params);
// compilenode returning opresult849
  *var_s = opresult849;
  if (opresult849 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace743(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 172
  setline(172);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 171
  setline(171);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit744 == NULL) {
    strlit744 = alloc_String("");
    gc_root(strlit744);
  }
// compilenode returning strlit744
  *var_spc = strlit744;
  if (strlit744 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 172
  setline(172);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe745 = gc_frame_new();
  Object num748 = alloc_Float64(1);
// compilenode returning num748
  int op_slot_right_747 = gc_frame_newslot(num748);
// compilenode returning *var_depth
  int op_slot_left_747 = gc_frame_newslot(*var_depth);
  params[0] = num748;
  partcv[0] = 1;
  Object diff750 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff750
  int op_slot_right_746 = gc_frame_newslot(diff750);
  Object num752 = alloc_Float64(0);
// compilenode returning num752
  int op_slot_left_746 = gc_frame_newslot(num752);
  params[0] = diff750;
  partcv[0] = 1;
  Object opresult753 = callmethod(num752, "..", 1, partcv, params);
// compilenode returning opresult753
  gc_frame_newslot(opresult753);
  Object block754 = alloc_Block(NULL, NULL, "ast", 172);
  gc_frame_newslot(block754);
  block_savedest(block754);
  Object closure755 = createclosure(2, "_apply");
setclosureframe(closure755, stackframe);
  addtoclosure(closure755, var_spc);
  addtoclosure(closure755, selfslot);
  struct UserObject *uo755 = (struct UserObject*)block754;
  uo755->data[0] = (Object)closure755;
  Method *meth_meth_ast__apply755 = addmethod2pos(block754, "_apply", &meth_ast__apply755, 0);
int argcv_meth_ast__apply755[] = {1};
meth_meth_ast__apply755->type = alloc_MethodType(1, argcv_meth_ast__apply755);
  meth_meth_ast__apply755->definitionModule = modulename;
  meth_meth_ast__apply755->definitionLine = 165;
// compilenode returning block754
  gc_frame_newslot(block754);
  params[0] = opresult753;
  params[1] = block754;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call762 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe745);
// compilenode returning call762
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 175
  setline(175);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit764 == NULL) {
    strlit764 = alloc_String(") then {");
    gc_root(strlit764);
  }
// compilenode returning strlit764
  int op_slot_right_763 = gc_frame_newslot(strlit764);
  int callframe767 = gc_frame_new();
  Object num768 = alloc_Float64(0);
// compilenode returning num768
  gc_frame_newslot(num768);
  int callframe769 = gc_frame_new();
  partcv[0] = 0;
  Object call770 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe769);
// compilenode returning call770
// compilenode returning call770
  params[0] = num768;
  partcv[0] = 1;
  Object call771 = callmethod(call770, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe767);
// compilenode returning call771
  int op_slot_right_766 = gc_frame_newslot(call771);
  if (strlit773 == NULL) {
    strlit773 = alloc_String("if (");
    gc_root(strlit773);
  }
// compilenode returning strlit773
  int op_slot_left_766 = gc_frame_newslot(strlit773);
  params[0] = call771;
  partcv[0] = 1;
  Object opresult774 = callmethod(strlit773, "++", 1, partcv, params);
// compilenode returning opresult774
  int op_slot_left_763 = gc_frame_newslot(opresult774);
  params[0] = strlit764;
  partcv[0] = 1;
  Object opresult775 = callmethod(opresult774, "++", 1, partcv, params);
// compilenode returning opresult775
  *var_s = opresult775;
  if (opresult775 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe776 = gc_frame_new();
  int callframe777 = gc_frame_new();
  partcv[0] = 0;
  Object call778 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe777);
// compilenode returning call778
// compilenode returning call778
  gc_frame_newslot(call778);
  Object block779 = alloc_Block(NULL, NULL, "ast", 176);
  gc_frame_newslot(block779);
  block_savedest(block779);
  Object closure780 = createclosure(4, "_apply");
setclosureframe(closure780, stackframe);
  addtoclosure(closure780, var_depth);
  addtoclosure(closure780, var_spc);
  addtoclosure(closure780, var_s);
  addtoclosure(closure780, selfslot);
  struct UserObject *uo780 = (struct UserObject*)block779;
  uo780->data[0] = (Object)closure780;
  Method *meth_meth_ast__apply780 = addmethod2pos(block779, "_apply", &meth_ast__apply780, 0);
int argcv_meth_ast__apply780[] = {1};
meth_meth_ast__apply780->type = alloc_MethodType(1, argcv_meth_ast__apply780);
  meth_meth_ast__apply780->definitionModule = modulename;
  meth_meth_ast__apply780->definitionLine = 176;
// compilenode returning block779
  gc_frame_newslot(block779);
  params[0] = call778;
  params[1] = block779;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call803 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe776);
// compilenode returning call803
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 179
  setline(179);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num806 = alloc_Float64(0);
// compilenode returning num806
  int op_slot_right_805 = gc_frame_newslot(num806);
  int callframe808 = gc_frame_new();
  int callframe809 = gc_frame_new();
  partcv[0] = 0;
  Object call810 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe809);
// compilenode returning call810
// compilenode returning call810
  partcv[0] = 0;
  Object call811 = callmethod(call810, "size",
    1, partcv, params);
  gc_frame_end(callframe808);
// compilenode returning call811
// compilenode returning call811
  int op_slot_left_805 = gc_frame_newslot(call811);
  params[0] = num806;
  partcv[0] = 1;
  Object opresult812 = callmethod(call811, ">", 1, partcv, params);
// compilenode returning opresult812
  Object if804 = done;
  if (istrue(opresult812)) {
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 180
  setline(180);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit814 == NULL) {
    strlit814 = alloc_String("} else {");
    gc_root(strlit814);
  }
// compilenode returning strlit814
  int op_slot_right_813 = gc_frame_newslot(strlit814);
// compilenode returning *var_spc
  int op_slot_right_816 = gc_frame_newslot(*var_spc);
  if (strlit819 == NULL) {
    strlit819 = alloc_String("""\x0a""");
    gc_root(strlit819);
  }
// compilenode returning strlit819
  int op_slot_right_818 = gc_frame_newslot(strlit819);
// compilenode returning *var_s
  int op_slot_left_818 = gc_frame_newslot(*var_s);
  params[0] = strlit819;
  partcv[0] = 1;
  Object opresult821 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult821
  int op_slot_left_816 = gc_frame_newslot(opresult821);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult822 = callmethod(opresult821, "++", 1, partcv, params);
// compilenode returning opresult822
  int op_slot_left_813 = gc_frame_newslot(opresult822);
  params[0] = strlit814;
  partcv[0] = 1;
  Object opresult823 = callmethod(opresult822, "++", 1, partcv, params);
// compilenode returning opresult823
  *var_s = opresult823;
  if (opresult823 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe825 = gc_frame_new();
  int callframe826 = gc_frame_new();
  partcv[0] = 0;
  Object call827 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe826);
// compilenode returning call827
// compilenode returning call827
  gc_frame_newslot(call827);
  Object block828 = alloc_Block(NULL, NULL, "ast", 181);
  gc_frame_newslot(block828);
  block_savedest(block828);
  Object closure829 = createclosure(4, "_apply");
setclosureframe(closure829, stackframe);
  addtoclosure(closure829, var_depth);
  addtoclosure(closure829, var_spc);
  addtoclosure(closure829, var_s);
  addtoclosure(closure829, selfslot);
  struct UserObject *uo829 = (struct UserObject*)block828;
  uo829->data[0] = (Object)closure829;
  Method *meth_meth_ast__apply829 = addmethod2pos(block828, "_apply", &meth_ast__apply829, 0);
int argcv_meth_ast__apply829[] = {1};
meth_meth_ast__apply829->type = alloc_MethodType(1, argcv_meth_ast__apply829);
  meth_meth_ast__apply829->definitionModule = modulename;
  meth_meth_ast__apply829->definitionLine = 181;
// compilenode returning block828
  gc_frame_newslot(block828);
  params[0] = call827;
  params[1] = block828;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call852 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe825);
// compilenode returning call852
    gc_frame_newslot(call852);
    if804 = call852;
  } else {
  }
// compilenode returning if804
// Begin line 186
  setline(186);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit854 == NULL) {
    strlit854 = alloc_String("}");
    gc_root(strlit854);
  }
// compilenode returning strlit854
  int op_slot_right_853 = gc_frame_newslot(strlit854);
// compilenode returning *var_spc
  int op_slot_right_856 = gc_frame_newslot(*var_spc);
  if (strlit859 == NULL) {
    strlit859 = alloc_String("""\x0a""");
    gc_root(strlit859);
  }
// compilenode returning strlit859
  int op_slot_right_858 = gc_frame_newslot(strlit859);
// compilenode returning *var_s
  int op_slot_left_858 = gc_frame_newslot(*var_s);
  params[0] = strlit859;
  partcv[0] = 1;
  Object opresult861 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult861
  int op_slot_left_856 = gc_frame_newslot(opresult861);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult862 = callmethod(opresult861, "++", 1, partcv, params);
// compilenode returning opresult862
  int op_slot_left_853 = gc_frame_newslot(opresult862);
  params[0] = strlit854;
  partcv[0] = 1;
  Object opresult863 = callmethod(opresult862, "++", 1, partcv, params);
// compilenode returning opresult863
  *var_s = opresult863;
  if (opresult863 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 186
  setline(186);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new556(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_ifNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_thenblock_39_ = &(stackframe->slots[1]);
  *var_thenblock_39_ = args[curarg];
  curarg++;
  Object *var_elseblock_39_ = &(stackframe->slots[2]);
  *var_elseblock_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject557 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj557 = alloc_userobj2(12,12, objclass557);
  gc_frame_newslot(obj557);
if (objclass557 == NULL) {
  glfree(obj557->class->name);
  obj557->class->name = "ifNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj557, self, 0);
  addmethodreal(obj557,"outer", &reader_ast_outer_558);
  Object oldself557 = self;
  struct StackFrameObject *oldstackframe557 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe557);
  gc_frame_newslot((Object)stackframe);
  self = obj557;
  Object *oldselfslot557 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter557 = (*(struct UserObject *)self).data[0], lowerouter557 = thisouter557;
  if (inheritingObject557) {
    struct UserObject *inho557 = (struct UserObject *)inheritingObject557;
    while (inho557->super != GraceDefaultObject) inho557 = (struct UserObject *)inho557->super;
    inho557->super = obj557;
    self = inheritingObject557;
    *selfslot = self;
    lowerouter557 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter557;
  }
if (objclass557 == NULL) {
  Method *reader559 = addmethodrealflags(obj557, "kind",&reader_ast_kind_559, MFLAG_DEF);
  reader559->definitionModule = modulename;
  reader559->definitionLine = 120;
}
adddatum2(obj557, alloc_Undefined(), 1);
if (objclass557 == NULL) {
  Method *reader560 = addmethodrealflags(obj557, "value",&reader_ast_value_560, MFLAG_DEF);
  reader560->definitionModule = modulename;
  reader560->definitionLine = 121;
}
adddatum2(obj557, alloc_Undefined(), 2);
if (objclass557 == NULL) {
  Method *reader561 = addmethodrealflags(obj557, "thenblock",&reader_ast_thenblock_561, MFLAG_DEF);
  reader561->definitionModule = modulename;
  reader561->definitionLine = 122;
}
adddatum2(obj557, alloc_Undefined(), 3);
if (objclass557 == NULL) {
  Method *reader562 = addmethodrealflags(obj557, "elseblock",&reader_ast_elseblock_562, MFLAG_DEF);
  reader562->definitionModule = modulename;
  reader562->definitionLine = 123;
}
adddatum2(obj557, alloc_Undefined(), 4);
if (objclass557 == NULL) {
  Method *reader563 = addmethodrealflags(obj557, "handledIdentifiers",&reader_ast_handledIdentifiers_563, 0);
  Method *writer563 = addmethodrealflags(obj557, "handledIdentifiers:=",&writer_ast_handledIdentifiers_563, 0);
  reader563->definitionModule = modulename;
  writer563->definitionModule = modulename;
  reader563->definitionLine = 124;
  writer563->definitionLine = 124;
}
obj557->flags |= OFLAG_MUTABLE;
adddatum2(obj557, alloc_Undefined(), 5);
  struct UserObject *uo564 = (struct UserObject*)obj557;
  uo564->data[6] = emptyclosure;
  Method *meth_meth_ast_accept564 = addmethod2pos(obj557, "accept", &meth_ast_accept564, 6);
int argcv_meth_ast_accept564[] = {1};
meth_meth_ast_accept564->type = alloc_MethodType(1, argcv_meth_ast_accept564);
meth_meth_ast_accept564->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept564->type->names[0] = "visitor";
  meth_meth_ast_accept564->definitionModule = modulename;
  meth_meth_ast_accept564->definitionLine = 124;
  block_savedest(obj557);
  Object closure590 = createclosure(1, "map()before()after");
setclosureframe(closure590, stackframe);
  addtoclosure(closure590, var_ifNode);
  struct UserObject *uo590 = (struct UserObject*)obj557;
  uo590->data[7] = (Object)closure590;
  Method *meth_meth_ast_map_40__41_before_40__41_after590 = addmethod2pos(obj557, "map()before()after", &meth_ast_map_40__41_before_40__41_after590, 7);
int argcv_meth_ast_map_40__41_before_40__41_after590[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after590->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after590);
  meth_meth_ast_map_40__41_before_40__41_after590->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after590->definitionLine = 135;
  struct UserObject *uo628 = (struct UserObject*)obj557;
  uo628->data[8] = emptyclosure;
  Method *meth_meth_ast_map628 = addmethod2pos(obj557, "map", &meth_ast_map628, 8);
int argcv_meth_ast_map628[] = {1};
meth_meth_ast_map628->type = alloc_MethodType(1, argcv_meth_ast_map628);
  meth_meth_ast_map628->definitionModule = modulename;
  meth_meth_ast_map628->definitionLine = 148;
  struct UserObject *uo637 = (struct UserObject*)obj557;
  uo637->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty637 = addmethod2pos(obj557, "pretty", &meth_ast_pretty637, 9);
int argcv_meth_ast_pretty637[] = {1};
meth_meth_ast_pretty637->type = alloc_MethodType(1, argcv_meth_ast_pretty637);
  meth_meth_ast_pretty637->definitionModule = modulename;
  meth_meth_ast_pretty637->definitionLine = 151;
  struct UserObject *uo743 = (struct UserObject*)obj557;
  uo743->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace743 = addmethod2pos(obj557, "toGrace", &meth_ast_toGrace743, 10);
int argcv_meth_ast_toGrace743[] = {1};
meth_meth_ast_toGrace743->type = alloc_MethodType(1, argcv_meth_ast_toGrace743);
meth_meth_ast_toGrace743->type->types[0] = type_Number;
meth_meth_ast_toGrace743->type->names[0] = "depth";
  meth_meth_ast_toGrace743->definitionModule = modulename;
  meth_meth_ast_toGrace743->definitionLine = 170;
  sourceObject = obj557;
// Begin line 118
  setline(118);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe865 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call866 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe865);
// compilenode returning call866
  struct UserObject *obj557_uo = (struct UserObject *)obj557;
  obj557_uo->super = call866;
  sourceObject = obj557;
// Begin line 119
  setline(119);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit867 == NULL) {
    strlit867 = alloc_String("if");
    gc_root(strlit867);
  }
// compilenode returning strlit867
  adddatum2(obj557, strlit867, 1);
  sourceObject = obj557;
// Begin line 120
  setline(120);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_cond
  adddatum2(obj557, *var_cond, 2);
  sourceObject = obj557;
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_thenblock_39_
  adddatum2(obj557, *var_thenblock_39_, 3);
  sourceObject = obj557;
// Begin line 122
  setline(122);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_elseblock_39_
  adddatum2(obj557, *var_elseblock_39_, 4);
  sourceObject = obj557;
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool868 = alloc_Boolean(0);
// compilenode returning bool868
  adddatum2(obj557, bool868, 5);
  sourceObject = obj557;
  sourceObject = obj557;
  sourceObject = obj557;
  sourceObject = obj557;
  sourceObject = obj557;
objclass557 = obj557->class;
  objclass557->definitionModule = modulename;
  objclass557->definitionLine = 110;
  (*(struct UserObject *)self).data[0] = lowerouter557;
  self = oldself557;
  selfslot = oldselfslot557;
  stackframe = oldstackframe557;
  gc_frame_end(frame);
  return obj557;
}
Object meth_ast_new556_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_ifNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_thenblock_39_ = &(stackframe->slots[1]);
  *var_thenblock_39_ = args[curarg];
  curarg++;
  Object *var_elseblock_39_ = &(stackframe->slots[2]);
  *var_elseblock_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject557 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj557 = alloc_userobj2(12,12, objclass557);
  gc_frame_newslot(obj557);
if (objclass557 == NULL) {
  glfree(obj557->class->name);
  obj557->class->name = "ifNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj557, self, 0);
  addmethodreal(obj557,"outer", &reader_ast_outer_558);
  Object oldself557 = self;
  struct StackFrameObject *oldstackframe557 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe557);
  gc_frame_newslot((Object)stackframe);
  self = obj557;
  Object *oldselfslot557 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter557 = (*(struct UserObject *)self).data[0], lowerouter557 = thisouter557;
  if (inheritingObject557) {
    struct UserObject *inho557 = (struct UserObject *)inheritingObject557;
    while (inho557->super != GraceDefaultObject) inho557 = (struct UserObject *)inho557->super;
    inho557->super = obj557;
    self = inheritingObject557;
    *selfslot = self;
    lowerouter557 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter557;
  }
if (objclass557 == NULL) {
  Method *reader559 = addmethodrealflags(obj557, "kind",&reader_ast_kind_559, MFLAG_DEF);
  reader559->definitionModule = modulename;
  reader559->definitionLine = 120;
}
adddatum2(obj557, alloc_Undefined(), 1);
if (objclass557 == NULL) {
  Method *reader560 = addmethodrealflags(obj557, "value",&reader_ast_value_560, MFLAG_DEF);
  reader560->definitionModule = modulename;
  reader560->definitionLine = 121;
}
adddatum2(obj557, alloc_Undefined(), 2);
if (objclass557 == NULL) {
  Method *reader561 = addmethodrealflags(obj557, "thenblock",&reader_ast_thenblock_561, MFLAG_DEF);
  reader561->definitionModule = modulename;
  reader561->definitionLine = 122;
}
adddatum2(obj557, alloc_Undefined(), 3);
if (objclass557 == NULL) {
  Method *reader562 = addmethodrealflags(obj557, "elseblock",&reader_ast_elseblock_562, MFLAG_DEF);
  reader562->definitionModule = modulename;
  reader562->definitionLine = 123;
}
adddatum2(obj557, alloc_Undefined(), 4);
if (objclass557 == NULL) {
  Method *reader563 = addmethodrealflags(obj557, "handledIdentifiers",&reader_ast_handledIdentifiers_563, 0);
  Method *writer563 = addmethodrealflags(obj557, "handledIdentifiers:=",&writer_ast_handledIdentifiers_563, 0);
  reader563->definitionModule = modulename;
  writer563->definitionModule = modulename;
  reader563->definitionLine = 124;
  writer563->definitionLine = 124;
}
obj557->flags |= OFLAG_MUTABLE;
adddatum2(obj557, alloc_Undefined(), 5);
  struct UserObject *uo564 = (struct UserObject*)obj557;
  uo564->data[6] = emptyclosure;
  Method *meth_meth_ast_accept564 = addmethod2pos(obj557, "accept", &meth_ast_accept564, 6);
int argcv_meth_ast_accept564[] = {1};
meth_meth_ast_accept564->type = alloc_MethodType(1, argcv_meth_ast_accept564);
meth_meth_ast_accept564->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept564->type->names[0] = "visitor";
  meth_meth_ast_accept564->definitionModule = modulename;
  meth_meth_ast_accept564->definitionLine = 124;
  block_savedest(obj557);
  Object closure590 = createclosure(1, "map()before()after");
setclosureframe(closure590, stackframe);
  addtoclosure(closure590, var_ifNode);
  struct UserObject *uo590 = (struct UserObject*)obj557;
  uo590->data[7] = (Object)closure590;
  Method *meth_meth_ast_map_40__41_before_40__41_after590 = addmethod2pos(obj557, "map()before()after", &meth_ast_map_40__41_before_40__41_after590, 7);
int argcv_meth_ast_map_40__41_before_40__41_after590[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after590->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after590);
  meth_meth_ast_map_40__41_before_40__41_after590->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after590->definitionLine = 135;
  struct UserObject *uo628 = (struct UserObject*)obj557;
  uo628->data[8] = emptyclosure;
  Method *meth_meth_ast_map628 = addmethod2pos(obj557, "map", &meth_ast_map628, 8);
int argcv_meth_ast_map628[] = {1};
meth_meth_ast_map628->type = alloc_MethodType(1, argcv_meth_ast_map628);
  meth_meth_ast_map628->definitionModule = modulename;
  meth_meth_ast_map628->definitionLine = 148;
  struct UserObject *uo637 = (struct UserObject*)obj557;
  uo637->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty637 = addmethod2pos(obj557, "pretty", &meth_ast_pretty637, 9);
int argcv_meth_ast_pretty637[] = {1};
meth_meth_ast_pretty637->type = alloc_MethodType(1, argcv_meth_ast_pretty637);
  meth_meth_ast_pretty637->definitionModule = modulename;
  meth_meth_ast_pretty637->definitionLine = 151;
  struct UserObject *uo743 = (struct UserObject*)obj557;
  uo743->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace743 = addmethod2pos(obj557, "toGrace", &meth_ast_toGrace743, 10);
int argcv_meth_ast_toGrace743[] = {1};
meth_meth_ast_toGrace743->type = alloc_MethodType(1, argcv_meth_ast_toGrace743);
meth_meth_ast_toGrace743->type->types[0] = type_Number;
meth_meth_ast_toGrace743->type->names[0] = "depth";
  meth_meth_ast_toGrace743->definitionModule = modulename;
  meth_meth_ast_toGrace743->definitionLine = 170;
  sourceObject = obj557;
// Begin line 118
  setline(118);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe865 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call866 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe865);
// compilenode returning call866
  struct UserObject *obj557_uo = (struct UserObject *)obj557;
  obj557_uo->super = call866;
  sourceObject = obj557;
// Begin line 119
  setline(119);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit867 == NULL) {
    strlit867 = alloc_String("if");
    gc_root(strlit867);
  }
// compilenode returning strlit867
  adddatum2(obj557, strlit867, 1);
  sourceObject = obj557;
// Begin line 120
  setline(120);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_cond
  adddatum2(obj557, *var_cond, 2);
  sourceObject = obj557;
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_thenblock_39_
  adddatum2(obj557, *var_thenblock_39_, 3);
  sourceObject = obj557;
// Begin line 122
  setline(122);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_elseblock_39_
  adddatum2(obj557, *var_elseblock_39_, 4);
  sourceObject = obj557;
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool868 = alloc_Boolean(0);
// compilenode returning bool868
  adddatum2(obj557, bool868, 5);
  sourceObject = obj557;
  sourceObject = obj557;
  sourceObject = obj557;
  sourceObject = obj557;
  sourceObject = obj557;
objclass557 = obj557->class;
  objclass557->definitionModule = modulename;
  objclass557->definitionLine = 110;
  (*(struct UserObject *)self).data[0] = lowerouter557;
  self = oldself557;
  selfslot = oldselfslot557;
  stackframe = oldstackframe557;
  gc_frame_end(frame);
  return obj557;
}
Object meth_ast_blockNode870(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blockNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blockNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for blockNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for blockNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 189
  setline(189);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_blockNode
  gc_frame_end(frame);
  return *var_blockNode;
}
Object meth_ast__apply891(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 204
  setline(204);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe892 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_mx
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call893 = callmethod(*var_mx, "accept",
    1, partcv, params);
  gc_frame_end(callframe892);
// compilenode returning call893
  gc_frame_end(frame);
  return call893;
}
Object meth_ast__apply900(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 207
  setline(207);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe901 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_mx
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call902 = callmethod(*var_mx, "accept",
    1, partcv, params);
  gc_frame_end(callframe901);
// compilenode returning call902
  gc_frame_end(frame);
  return call902;
}
Object meth_ast_accept883(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 213
  setline(213);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 202
  setline(202);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe885 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call886 = callmethod(*var_visitor, "visitBlock",
    1, partcv, params);
  gc_frame_end(callframe885);
// compilenode returning call886
  Object if884 = done;
  if (istrue(call886)) {
// Begin line 203
  setline(203);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe887 = gc_frame_new();
  int callframe888 = gc_frame_new();
  partcv[0] = 0;
  Object call889 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe888);
// compilenode returning call889
// compilenode returning call889
  gc_frame_newslot(call889);
  Object block890 = alloc_Block(NULL, NULL, "ast", 203);
  gc_frame_newslot(block890);
  block_savedest(block890);
  Object closure891 = createclosure(2, "_apply");
setclosureframe(closure891, stackframe);
  addtoclosure(closure891, var_visitor);
  addtoclosure(closure891, selfslot);
  struct UserObject *uo891 = (struct UserObject*)block890;
  uo891->data[0] = (Object)closure891;
  Method *meth_meth_ast__apply891 = addmethod2pos(block890, "_apply", &meth_ast__apply891, 0);
int argcv_meth_ast__apply891[] = {1};
meth_meth_ast__apply891->type = alloc_MethodType(1, argcv_meth_ast__apply891);
  meth_meth_ast__apply891->definitionModule = modulename;
  meth_meth_ast__apply891->definitionLine = 203;
// compilenode returning block890
  gc_frame_newslot(block890);
  params[0] = call889;
  params[1] = block890;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call895 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe887);
// compilenode returning call895
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe896 = gc_frame_new();
  int callframe897 = gc_frame_new();
  partcv[0] = 0;
  Object call898 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe897);
// compilenode returning call898
// compilenode returning call898
  gc_frame_newslot(call898);
  Object block899 = alloc_Block(NULL, NULL, "ast", 206);
  gc_frame_newslot(block899);
  block_savedest(block899);
  Object closure900 = createclosure(2, "_apply");
setclosureframe(closure900, stackframe);
  addtoclosure(closure900, var_visitor);
  addtoclosure(closure900, selfslot);
  struct UserObject *uo900 = (struct UserObject*)block899;
  uo900->data[0] = (Object)closure900;
  Method *meth_meth_ast__apply900 = addmethod2pos(block899, "_apply", &meth_ast__apply900, 0);
int argcv_meth_ast__apply900[] = {1};
meth_meth_ast__apply900->type = alloc_MethodType(1, argcv_meth_ast__apply900);
  meth_meth_ast__apply900->definitionModule = modulename;
  meth_meth_ast__apply900->definitionLine = 206;
// compilenode returning block899
  gc_frame_newslot(block899);
  params[0] = call898;
  params[1] = block899;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call904 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe896);
// compilenode returning call904
// Begin line 212
  setline(212);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 209
  setline(209);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool907 = alloc_Boolean(0);
// compilenode returning bool907
  int op_slot_right_906 = gc_frame_newslot(bool907);
  int callframe909 = gc_frame_new();
  partcv[0] = 0;
  Object call910 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe909);
// compilenode returning call910
// compilenode returning call910
  int op_slot_left_906 = gc_frame_newslot(call910);
  params[0] = bool907;
  partcv[0] = 1;
  Object opresult911 = callmethod(call910, "!=", 1, partcv, params);
// compilenode returning opresult911
  Object if905 = done;
  if (istrue(opresult911)) {
// Begin line 210
  setline(210);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe912 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe913 = gc_frame_new();
  partcv[0] = 0;
  Object call914 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe913);
// compilenode returning call914
// compilenode returning call914
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call915 = callmethod(call914, "accept",
    1, partcv, params);
  gc_frame_end(callframe912);
// compilenode returning call915
    gc_frame_newslot(call915);
    if905 = call915;
  } else {
  }
// compilenode returning if905
    gc_frame_newslot(if905);
    if884 = if905;
  } else {
  }
// compilenode returning if884
  gc_frame_end(frame);
  return if884;
}
Object meth_ast_map_40__41_before_40__41_after916(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_blockNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 215
  setline(215);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe917 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call918 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe917);
// compilenode returning call918
// Begin line 216
  setline(216);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe919 = gc_frame_new();
  int callframe920 = gc_frame_new();
  int callframe921 = gc_frame_new();
  partcv[0] = 0;
  Object call922 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe921);
// compilenode returning call922
  gc_frame_newslot(call922);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe923 = gc_frame_new();
  int callframe924 = gc_frame_new();
  Object call925 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe924);
// compilenode returning call925
// compilenode returning call925
  partcv[0] = 0;
  Object call926 = callmethodflags(call925, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe923);
// compilenode returning call926
// compilenode returning call926
  params[0] = call922;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call927 = callmethodflags(call926, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe920);
// compilenode returning call927
  gc_frame_newslot(call927);
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe928 = gc_frame_new();
  int callframe929 = gc_frame_new();
  partcv[0] = 0;
  Object call930 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe929);
// compilenode returning call930
  gc_frame_newslot(call930);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe931 = gc_frame_new();
  int callframe932 = gc_frame_new();
  Object call933 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe932);
// compilenode returning call933
// compilenode returning call933
  partcv[0] = 0;
  Object call934 = callmethodflags(call933, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe931);
// compilenode returning call934
// compilenode returning call934
  params[0] = call930;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call935 = callmethodflags(call934, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe928);
// compilenode returning call935
  gc_frame_newslot(call935);
// Begin line 216
  setline(216);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_blockNode
  params[0] = call927;
  params[1] = call935;
  partcv[0] = 2;
  Object call936 = callmethod(*var_blockNode, "new",
    1, partcv, params);
  gc_frame_end(callframe919);
// compilenode returning call936
  *var_n = call936;
  if (call936 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool939 = alloc_Boolean(0);
// compilenode returning bool939
  int op_slot_right_938 = gc_frame_newslot(bool939);
  int callframe941 = gc_frame_new();
  partcv[0] = 0;
  Object call942 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe941);
// compilenode returning call942
// compilenode returning call942
  int op_slot_left_938 = gc_frame_newslot(call942);
  params[0] = bool939;
  partcv[0] = 1;
  Object opresult943 = callmethod(call942, "!=", 1, partcv, params);
// compilenode returning opresult943
  Object if937 = done;
  if (istrue(opresult943)) {
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe944 = gc_frame_new();
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe945 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// Begin line 220
  setline(220);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe946 = gc_frame_new();
  partcv[0] = 0;
  Object call947 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe946);
// compilenode returning call947
// compilenode returning call947
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call948 = callmethod(call947, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe945);
// compilenode returning call948
  gc_frame_newslot(call948);
// compilenode returning *var_n
  params[0] = call948;
  partcv[0] = 1;
  Object call949 = callmethod(*var_n, "matchingPattern:=",
    1, partcv, params);
  gc_frame_end(callframe944);
// compilenode returning call949
// compilenode returning done
    gc_frame_newslot(done);
    if937 = done;
  } else {
  }
// compilenode returning if937
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe950 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call951 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe950);
// compilenode returning call951
  *var_n = call951;
  if (call951 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 224
  setline(224);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe953 = gc_frame_new();
// Begin line 223
  setline(223);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe954 = gc_frame_new();
  partcv[0] = 0;
  Object call955 = callmethodflags(self, "extraRuntimeData", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe954);
// compilenode returning call955
  gc_frame_newslot(call955);
// compilenode returning *var_n
  params[0] = call955;
  partcv[0] = 1;
  Object call956 = callmethod(*var_n, "extraRuntimeData:=",
    1, partcv, params);
  gc_frame_end(callframe953);
// compilenode returning call956
// compilenode returning done
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe957 = gc_frame_new();
// Begin line 224
  setline(224);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe958 = gc_frame_new();
  partcv[0] = 0;
  Object call959 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe958);
// compilenode returning call959
  gc_frame_newslot(call959);
// compilenode returning *var_n
  params[0] = call959;
  partcv[0] = 1;
  Object call960 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe957);
// compilenode returning call960
// compilenode returning done
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe961 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call962 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe961);
// compilenode returning call962
// Begin line 226
  setline(226);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply966(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply969(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map963(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe964 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block965 = alloc_Block(NULL, NULL, "ast", 229);
  gc_frame_newslot(block965);
  block_savedest(block965);
  Object closure966 = createclosure(1, "_apply");
setclosureframe(closure966, stackframe);
  addtoclosure(closure966, selfslot);
  struct UserObject *uo966 = (struct UserObject*)block965;
  uo966->data[0] = (Object)closure966;
  Method *meth_meth_ast__apply966 = addmethod2pos(block965, "_apply", &meth_ast__apply966, 0);
int argcv_meth_ast__apply966[] = {0};
meth_meth_ast__apply966->type = alloc_MethodType(1, argcv_meth_ast__apply966);
  meth_meth_ast__apply966->definitionModule = modulename;
  meth_meth_ast__apply966->definitionLine = 219;
// compilenode returning block965
  gc_frame_newslot(block965);
  Object block968 = alloc_Block(NULL, NULL, "ast", 229);
  gc_frame_newslot(block968);
  block_savedest(block968);
  Object closure969 = createclosure(1, "_apply");
setclosureframe(closure969, stackframe);
  addtoclosure(closure969, selfslot);
  struct UserObject *uo969 = (struct UserObject*)block968;
  uo969->data[0] = (Object)closure969;
  Method *meth_meth_ast__apply969 = addmethod2pos(block968, "_apply", &meth_ast__apply969, 0);
int argcv_meth_ast__apply969[] = {0};
meth_meth_ast__apply969->type = alloc_MethodType(1, argcv_meth_ast__apply969);
  meth_meth_ast__apply969->definitionModule = modulename;
  meth_meth_ast__apply969->definitionLine = 219;
// compilenode returning block968
  gc_frame_newslot(block968);
  params[0] = *var_blk;
  params[1] = block965;
  params[2] = block968;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call971 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe964);
// compilenode returning call971
  gc_frame_end(frame);
  return call971;
}
Object meth_ast__apply980(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 235
  setline(235);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 234
  setline(234);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit982 == NULL) {
    strlit982 = alloc_String("  ");
    gc_root(strlit982);
  }
// compilenode returning strlit982
  int op_slot_right_981 = gc_frame_newslot(strlit982);
// compilenode returning *var_spc
  int op_slot_left_981 = gc_frame_newslot(*var_spc);
  params[0] = strlit982;
  partcv[0] = 1;
  Object opresult984 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult984
  *var_spc = opresult984;
  if (opresult984 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1001(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 239
  setline(239);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1003 = gc_frame_new();
  Object num1005 = alloc_Float64(2);
// compilenode returning num1005
  int op_slot_right_1004 = gc_frame_newslot(num1005);
// compilenode returning *var_depth
  int op_slot_left_1004 = gc_frame_newslot(*var_depth);
  params[0] = num1005;
  partcv[0] = 1;
  Object sum1007 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1007
  gc_frame_newslot(sum1007);
// compilenode returning *var_mx
  params[0] = sum1007;
  partcv[0] = 1;
  Object call1008 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1003);
// compilenode returning call1008
  int op_slot_right_1002 = gc_frame_newslot(call1008);
// compilenode returning *var_spc
  int op_slot_right_1010 = gc_frame_newslot(*var_spc);
  if (strlit1013 == NULL) {
    strlit1013 = alloc_String("""\x0a""  ");
    gc_root(strlit1013);
  }
// compilenode returning strlit1013
  int op_slot_right_1012 = gc_frame_newslot(strlit1013);
// compilenode returning *var_s
  int op_slot_left_1012 = gc_frame_newslot(*var_s);
  params[0] = strlit1013;
  partcv[0] = 1;
  Object opresult1015 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1015
  int op_slot_left_1010 = gc_frame_newslot(opresult1015);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1016 = callmethod(opresult1015, "++", 1, partcv, params);
// compilenode returning opresult1016
  int op_slot_left_1002 = gc_frame_newslot(opresult1016);
  params[0] = call1008;
  partcv[0] = 1;
  Object opresult1017 = callmethod(opresult1016, "++", 1, partcv, params);
// compilenode returning opresult1017
  *var_s = opresult1017;
  if (opresult1017 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1038(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 244
  setline(244);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1040 = gc_frame_new();
  Object num1042 = alloc_Float64(2);
// compilenode returning num1042
  int op_slot_right_1041 = gc_frame_newslot(num1042);
// compilenode returning *var_depth
  int op_slot_left_1041 = gc_frame_newslot(*var_depth);
  params[0] = num1042;
  partcv[0] = 1;
  Object sum1044 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1044
  gc_frame_newslot(sum1044);
// compilenode returning *var_mx
  params[0] = sum1044;
  partcv[0] = 1;
  Object call1045 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1040);
// compilenode returning call1045
  int op_slot_right_1039 = gc_frame_newslot(call1045);
// compilenode returning *var_spc
  int op_slot_right_1047 = gc_frame_newslot(*var_spc);
  if (strlit1050 == NULL) {
    strlit1050 = alloc_String("""\x0a""  ");
    gc_root(strlit1050);
  }
// compilenode returning strlit1050
  int op_slot_right_1049 = gc_frame_newslot(strlit1050);
// compilenode returning *var_s
  int op_slot_left_1049 = gc_frame_newslot(*var_s);
  params[0] = strlit1050;
  partcv[0] = 1;
  Object opresult1052 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1052
  int op_slot_left_1047 = gc_frame_newslot(opresult1052);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1053 = callmethod(opresult1052, "++", 1, partcv, params);
// compilenode returning opresult1053
  int op_slot_left_1039 = gc_frame_newslot(opresult1053);
  params[0] = call1045;
  partcv[0] = 1;
  Object opresult1054 = callmethod(opresult1053, "++", 1, partcv, params);
// compilenode returning opresult1054
  *var_s = opresult1054;
  if (opresult1054 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty972(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit973 == NULL) {
    strlit973 = alloc_String("");
    gc_root(strlit973);
  }
// compilenode returning strlit973
  *var_spc = strlit973;
  if (strlit973 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe974 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_975 = gc_frame_newslot(*var_depth);
  Object num977 = alloc_Float64(0);
// compilenode returning num977
  int op_slot_left_975 = gc_frame_newslot(num977);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult978 = callmethod(num977, "..", 1, partcv, params);
// compilenode returning opresult978
  gc_frame_newslot(opresult978);
  Object block979 = alloc_Block(NULL, NULL, "ast", 233);
  gc_frame_newslot(block979);
  block_savedest(block979);
  Object closure980 = createclosure(2, "_apply");
setclosureframe(closure980, stackframe);
  addtoclosure(closure980, var_spc);
  addtoclosure(closure980, selfslot);
  struct UserObject *uo980 = (struct UserObject*)block979;
  uo980->data[0] = (Object)closure980;
  Method *meth_meth_ast__apply980 = addmethod2pos(block979, "_apply", &meth_ast__apply980, 0);
int argcv_meth_ast__apply980[] = {1};
meth_meth_ast__apply980->type = alloc_MethodType(1, argcv_meth_ast__apply980);
  meth_meth_ast__apply980->definitionModule = modulename;
  meth_meth_ast__apply980->definitionLine = 219;
// compilenode returning block979
  gc_frame_newslot(block979);
  params[0] = opresult978;
  params[1] = block979;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call987 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe974);
// compilenode returning call987
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 236
  setline(236);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit988 == NULL) {
    strlit988 = alloc_String("Block""\x0a""");
    gc_root(strlit988);
  }
// compilenode returning strlit988
  *var_s = strlit988;
  if (strlit988 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 238
  setline(238);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit990 == NULL) {
    strlit990 = alloc_String("Parameters:");
    gc_root(strlit990);
  }
// compilenode returning strlit990
  int op_slot_right_989 = gc_frame_newslot(strlit990);
// compilenode returning *var_spc
  int op_slot_right_992 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_992 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult994 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult994
  int op_slot_left_989 = gc_frame_newslot(opresult994);
  params[0] = strlit990;
  partcv[0] = 1;
  Object opresult995 = callmethod(opresult994, "++", 1, partcv, params);
// compilenode returning opresult995
  *var_s = opresult995;
  if (opresult995 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 238
  setline(238);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe997 = gc_frame_new();
  int callframe998 = gc_frame_new();
  partcv[0] = 0;
  Object call999 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe998);
// compilenode returning call999
// compilenode returning call999
  gc_frame_newslot(call999);
  Object block1000 = alloc_Block(NULL, NULL, "ast", 238);
  gc_frame_newslot(block1000);
  block_savedest(block1000);
  Object closure1001 = createclosure(4, "_apply");
setclosureframe(closure1001, stackframe);
  addtoclosure(closure1001, var_depth);
  addtoclosure(closure1001, var_spc);
  addtoclosure(closure1001, var_s);
  addtoclosure(closure1001, selfslot);
  struct UserObject *uo1001 = (struct UserObject*)block1000;
  uo1001->data[0] = (Object)closure1001;
  Method *meth_meth_ast__apply1001 = addmethod2pos(block1000, "_apply", &meth_ast__apply1001, 0);
int argcv_meth_ast__apply1001[] = {1};
meth_meth_ast__apply1001->type = alloc_MethodType(1, argcv_meth_ast__apply1001);
  meth_meth_ast__apply1001->definitionModule = modulename;
  meth_meth_ast__apply1001->definitionLine = 238;
// compilenode returning block1000
  gc_frame_newslot(block1000);
  params[0] = call999;
  params[1] = block1000;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1020 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe997);
// compilenode returning call1020
// Begin line 242
  setline(242);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1022 == NULL) {
    strlit1022 = alloc_String("""\x0a""");
    gc_root(strlit1022);
  }
// compilenode returning strlit1022
  int op_slot_right_1021 = gc_frame_newslot(strlit1022);
// compilenode returning *var_s
  int op_slot_left_1021 = gc_frame_newslot(*var_s);
  params[0] = strlit1022;
  partcv[0] = 1;
  Object opresult1024 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1024
  *var_s = opresult1024;
  if (opresult1024 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 242
  setline(242);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1027 == NULL) {
    strlit1027 = alloc_String("Body:");
    gc_root(strlit1027);
  }
// compilenode returning strlit1027
  int op_slot_right_1026 = gc_frame_newslot(strlit1027);
// compilenode returning *var_spc
  int op_slot_right_1029 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_1029 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1031 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1031
  int op_slot_left_1026 = gc_frame_newslot(opresult1031);
  params[0] = strlit1027;
  partcv[0] = 1;
  Object opresult1032 = callmethod(opresult1031, "++", 1, partcv, params);
// compilenode returning opresult1032
  *var_s = opresult1032;
  if (opresult1032 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1034 = gc_frame_new();
  int callframe1035 = gc_frame_new();
  partcv[0] = 0;
  Object call1036 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1035);
// compilenode returning call1036
// compilenode returning call1036
  gc_frame_newslot(call1036);
  Object block1037 = alloc_Block(NULL, NULL, "ast", 243);
  gc_frame_newslot(block1037);
  block_savedest(block1037);
  Object closure1038 = createclosure(4, "_apply");
setclosureframe(closure1038, stackframe);
  addtoclosure(closure1038, var_depth);
  addtoclosure(closure1038, var_spc);
  addtoclosure(closure1038, var_s);
  addtoclosure(closure1038, selfslot);
  struct UserObject *uo1038 = (struct UserObject*)block1037;
  uo1038->data[0] = (Object)closure1038;
  Method *meth_meth_ast__apply1038 = addmethod2pos(block1037, "_apply", &meth_ast__apply1038, 0);
int argcv_meth_ast__apply1038[] = {1};
meth_meth_ast__apply1038->type = alloc_MethodType(1, argcv_meth_ast__apply1038);
  meth_meth_ast__apply1038->definitionModule = modulename;
  meth_meth_ast__apply1038->definitionLine = 243;
// compilenode returning block1037
  gc_frame_newslot(block1037);
  params[0] = call1036;
  params[1] = block1037;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1057 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1034);
// compilenode returning call1057
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1060 = alloc_Boolean(0);
// compilenode returning bool1060
  int op_slot_right_1059 = gc_frame_newslot(bool1060);
  int callframe1062 = gc_frame_new();
  partcv[0] = 0;
  Object call1063 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1062);
// compilenode returning call1063
// compilenode returning call1063
  int op_slot_left_1059 = gc_frame_newslot(call1063);
  params[0] = bool1060;
  partcv[0] = 1;
  Object opresult1064 = callmethod(call1063, "!=", 1, partcv, params);
// compilenode returning opresult1064
  Object if1058 = done;
  if (istrue(opresult1064)) {
// Begin line 248
  setline(248);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 247
  setline(247);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1066 == NULL) {
    strlit1066 = alloc_String("""\x0a""");
    gc_root(strlit1066);
  }
// compilenode returning strlit1066
  int op_slot_right_1065 = gc_frame_newslot(strlit1066);
// compilenode returning *var_s
  int op_slot_left_1065 = gc_frame_newslot(*var_s);
  params[0] = strlit1066;
  partcv[0] = 1;
  Object opresult1068 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1068
  *var_s = opresult1068;
  if (opresult1068 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 248
  setline(248);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1071 == NULL) {
    strlit1071 = alloc_String("Pattern:");
    gc_root(strlit1071);
  }
// compilenode returning strlit1071
  int op_slot_right_1070 = gc_frame_newslot(strlit1071);
// compilenode returning *var_spc
  int op_slot_right_1073 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_1073 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1075 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1075
  int op_slot_left_1070 = gc_frame_newslot(opresult1075);
  params[0] = strlit1071;
  partcv[0] = 1;
  Object opresult1076 = callmethod(opresult1075, "++", 1, partcv, params);
// compilenode returning opresult1076
  *var_s = opresult1076;
  if (opresult1076 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1079 = gc_frame_new();
  Object num1081 = alloc_Float64(2);
// compilenode returning num1081
  int op_slot_right_1080 = gc_frame_newslot(num1081);
// compilenode returning *var_depth
  int op_slot_left_1080 = gc_frame_newslot(*var_depth);
  params[0] = num1081;
  partcv[0] = 1;
  Object sum1083 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1083
  gc_frame_newslot(sum1083);
  int callframe1084 = gc_frame_new();
  partcv[0] = 0;
  Object call1085 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1084);
// compilenode returning call1085
// compilenode returning call1085
  params[0] = sum1083;
  partcv[0] = 1;
  Object call1086 = callmethod(call1085, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1079);
// compilenode returning call1086
  int op_slot_right_1078 = gc_frame_newslot(call1086);
// compilenode returning *var_spc
  int op_slot_right_1088 = gc_frame_newslot(*var_spc);
  if (strlit1091 == NULL) {
    strlit1091 = alloc_String("""\x0a""  ");
    gc_root(strlit1091);
  }
// compilenode returning strlit1091
  int op_slot_right_1090 = gc_frame_newslot(strlit1091);
// compilenode returning *var_s
  int op_slot_left_1090 = gc_frame_newslot(*var_s);
  params[0] = strlit1091;
  partcv[0] = 1;
  Object opresult1093 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1093
  int op_slot_left_1088 = gc_frame_newslot(opresult1093);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1094 = callmethod(opresult1093, "++", 1, partcv, params);
// compilenode returning opresult1094
  int op_slot_left_1078 = gc_frame_newslot(opresult1094);
  params[0] = call1086;
  partcv[0] = 1;
  Object opresult1095 = callmethod(opresult1094, "++", 1, partcv, params);
// compilenode returning opresult1095
  *var_s = opresult1095;
  if (opresult1095 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1058 = done;
  } else {
  }
// compilenode returning if1058
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply1109(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 257
  setline(257);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 256
  setline(256);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1111 == NULL) {
    strlit1111 = alloc_String("    ");
    gc_root(strlit1111);
  }
// compilenode returning strlit1111
  int op_slot_right_1110 = gc_frame_newslot(strlit1111);
// compilenode returning *var_spc
  int op_slot_left_1110 = gc_frame_newslot(*var_spc);
  params[0] = strlit1111;
  partcv[0] = 1;
  Object opresult1113 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult1113
  *var_spc = opresult1113;
  if (opresult1113 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1138(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1139 = gc_frame_new();
  partcv[0] = 0;
  Object call1140 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1139);
// compilenode returning call1140
// compilenode returning call1140
// compilenode returning *var_i
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres1141 = callmethod(call1140, "[]", 1, partcv, params);
// compilenode returning idxres1141
  *var_p = idxres1141;
  if (idxres1141 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 268
  setline(268);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1144 = alloc_Boolean(0);
// compilenode returning bool1144
  int op_slot_right_1143 = gc_frame_newslot(bool1144);
  int callframe1146 = gc_frame_new();
  partcv[0] = 0;
  Object call1147 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1146);
// compilenode returning call1147
// compilenode returning call1147
  int op_slot_left_1143 = gc_frame_newslot(call1147);
  params[0] = bool1144;
  partcv[0] = 1;
  Object opresult1148 = callmethod(call1147, "!=", 1, partcv, params);
// compilenode returning opresult1148
  Object if1142 = done;
  if (istrue(opresult1148)) {
// Begin line 265
  setline(265);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 264
  setline(264);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1150 == NULL) {
    strlit1150 = alloc_String(")");
    gc_root(strlit1150);
  }
// compilenode returning strlit1150
  int op_slot_right_1149 = gc_frame_newslot(strlit1150);
  int callframe1153 = gc_frame_new();
  Object num1154 = alloc_Float64(0);
// compilenode returning num1154
  gc_frame_newslot(num1154);
// compilenode returning *var_p
  params[0] = num1154;
  partcv[0] = 1;
  Object call1155 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1153);
// compilenode returning call1155
  int op_slot_right_1152 = gc_frame_newslot(call1155);
  if (strlit1158 == NULL) {
    strlit1158 = alloc_String("(");
    gc_root(strlit1158);
  }
// compilenode returning strlit1158
  int op_slot_right_1157 = gc_frame_newslot(strlit1158);
// compilenode returning *var_s
  int op_slot_left_1157 = gc_frame_newslot(*var_s);
  params[0] = strlit1158;
  partcv[0] = 1;
  Object opresult1160 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1160
  int op_slot_left_1152 = gc_frame_newslot(opresult1160);
  params[0] = call1155;
  partcv[0] = 1;
  Object opresult1161 = callmethod(opresult1160, "++", 1, partcv, params);
// compilenode returning opresult1161
  int op_slot_left_1149 = gc_frame_newslot(opresult1161);
  params[0] = strlit1150;
  partcv[0] = 1;
  Object opresult1162 = callmethod(opresult1161, "++", 1, partcv, params);
// compilenode returning opresult1162
  *var_s = opresult1162;
  if (opresult1162 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1142 = done;
  } else {
// Begin line 266
  setline(266);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1165 = gc_frame_new();
  Object num1166 = alloc_Float64(0);
// compilenode returning num1166
  gc_frame_newslot(num1166);
// compilenode returning *var_p
  params[0] = num1166;
  partcv[0] = 1;
  Object call1167 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1165);
// compilenode returning call1167
  int op_slot_right_1164 = gc_frame_newslot(call1167);
// compilenode returning *var_s
  int op_slot_left_1164 = gc_frame_newslot(*var_s);
  params[0] = call1167;
  partcv[0] = 1;
  Object opresult1169 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1169
  *var_s = opresult1169;
  if (opresult1169 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1142 = done;
  }
// compilenode returning if1142
// Begin line 273
  setline(273);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 268
  setline(268);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1173 = gc_frame_new();
  int callframe1174 = gc_frame_new();
  partcv[0] = 0;
  Object call1175 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1174);
// compilenode returning call1175
// compilenode returning call1175
  partcv[0] = 0;
  Object call1176 = callmethod(call1175, "size",
    1, partcv, params);
  gc_frame_end(callframe1173);
// compilenode returning call1176
// compilenode returning call1176
  int op_slot_right_1172 = gc_frame_newslot(call1176);
// compilenode returning *var_i
  int op_slot_left_1172 = gc_frame_newslot(*var_i);
  params[0] = call1176;
  partcv[0] = 1;
  Object opresult1178 = callmethod(*var_i, "<", 1, partcv, params);
// compilenode returning opresult1178
  Object if1171 = done;
  if (istrue(opresult1178)) {
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 269
  setline(269);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1180 == NULL) {
    strlit1180 = alloc_String(", ");
    gc_root(strlit1180);
  }
// compilenode returning strlit1180
  int op_slot_right_1179 = gc_frame_newslot(strlit1180);
// compilenode returning *var_s
  int op_slot_left_1179 = gc_frame_newslot(*var_s);
  params[0] = strlit1180;
  partcv[0] = 1;
  Object opresult1182 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1182
  *var_s = opresult1182;
  if (opresult1182 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1171 = done;
  } else {
// Begin line 272
  setline(272);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 271
  setline(271);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1185 == NULL) {
    strlit1185 = alloc_String(" ->");
    gc_root(strlit1185);
  }
// compilenode returning strlit1185
  int op_slot_right_1184 = gc_frame_newslot(strlit1185);
// compilenode returning *var_s
  int op_slot_left_1184 = gc_frame_newslot(*var_s);
  params[0] = strlit1185;
  partcv[0] = 1;
  Object opresult1187 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1187
  *var_s = opresult1187;
  if (opresult1187 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1171 = done;
  }
// compilenode returning if1171
  gc_frame_end(frame);
  return if1171;
}
Object meth_ast__apply1195(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 276
  setline(276);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1197 = gc_frame_new();
  Object num1199 = alloc_Float64(1);
// compilenode returning num1199
  int op_slot_right_1198 = gc_frame_newslot(num1199);
// compilenode returning *var_depth
  int op_slot_left_1198 = gc_frame_newslot(*var_depth);
  params[0] = num1199;
  partcv[0] = 1;
  Object sum1201 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1201
  gc_frame_newslot(sum1201);
// compilenode returning *var_mx
  params[0] = sum1201;
  partcv[0] = 1;
  Object call1202 = callmethod(*var_mx, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1197);
// compilenode returning call1202
  int op_slot_right_1196 = gc_frame_newslot(call1202);
  if (strlit1205 == NULL) {
    strlit1205 = alloc_String("    ");
    gc_root(strlit1205);
  }
// compilenode returning strlit1205
  int op_slot_right_1204 = gc_frame_newslot(strlit1205);
// compilenode returning *var_spc
  int op_slot_right_1207 = gc_frame_newslot(*var_spc);
  if (strlit1210 == NULL) {
    strlit1210 = alloc_String("""\x0a""");
    gc_root(strlit1210);
  }
// compilenode returning strlit1210
  int op_slot_right_1209 = gc_frame_newslot(strlit1210);
// compilenode returning *var_s
  int op_slot_left_1209 = gc_frame_newslot(*var_s);
  params[0] = strlit1210;
  partcv[0] = 1;
  Object opresult1212 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1212
  int op_slot_left_1207 = gc_frame_newslot(opresult1212);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1213 = callmethod(opresult1212, "++", 1, partcv, params);
// compilenode returning opresult1213
  int op_slot_left_1204 = gc_frame_newslot(opresult1213);
  params[0] = strlit1205;
  partcv[0] = 1;
  Object opresult1214 = callmethod(opresult1213, "++", 1, partcv, params);
// compilenode returning opresult1214
  int op_slot_left_1196 = gc_frame_newslot(opresult1214);
  params[0] = call1202;
  partcv[0] = 1;
  Object opresult1215 = callmethod(opresult1214, "++", 1, partcv, params);
// compilenode returning opresult1215
  *var_s = opresult1215;
  if (opresult1215 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace1097(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 255
  setline(255);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1098 == NULL) {
    strlit1098 = alloc_String("");
    gc_root(strlit1098);
  }
// compilenode returning strlit1098
  *var_spc = strlit1098;
  if (strlit1098 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 255
  setline(255);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1099 = gc_frame_new();
  Object num1102 = alloc_Float64(1);
// compilenode returning num1102
  int op_slot_right_1101 = gc_frame_newslot(num1102);
// compilenode returning *var_depth
  int op_slot_left_1101 = gc_frame_newslot(*var_depth);
  params[0] = num1102;
  partcv[0] = 1;
  Object diff1104 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff1104
  int op_slot_right_1100 = gc_frame_newslot(diff1104);
  Object num1106 = alloc_Float64(0);
// compilenode returning num1106
  int op_slot_left_1100 = gc_frame_newslot(num1106);
  params[0] = diff1104;
  partcv[0] = 1;
  Object opresult1107 = callmethod(num1106, "..", 1, partcv, params);
// compilenode returning opresult1107
  gc_frame_newslot(opresult1107);
  Object block1108 = alloc_Block(NULL, NULL, "ast", 255);
  gc_frame_newslot(block1108);
  block_savedest(block1108);
  Object closure1109 = createclosure(2, "_apply");
setclosureframe(closure1109, stackframe);
  addtoclosure(closure1109, var_spc);
  addtoclosure(closure1109, selfslot);
  struct UserObject *uo1109 = (struct UserObject*)block1108;
  uo1109->data[0] = (Object)closure1109;
  Method *meth_meth_ast__apply1109 = addmethod2pos(block1108, "_apply", &meth_ast__apply1109, 0);
int argcv_meth_ast__apply1109[] = {1};
meth_meth_ast__apply1109->type = alloc_MethodType(1, argcv_meth_ast__apply1109);
  meth_meth_ast__apply1109->definitionModule = modulename;
  meth_meth_ast__apply1109->definitionLine = 249;
// compilenode returning block1108
  gc_frame_newslot(block1108);
  params[0] = opresult1107;
  params[1] = block1108;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1116 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1099);
// compilenode returning call1116
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 258
  setline(258);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1117 == NULL) {
    strlit1117 = alloc_String("{");
    gc_root(strlit1117);
  }
// compilenode returning strlit1117
  *var_s = strlit1117;
  if (strlit1117 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num1120 = alloc_Float64(0);
// compilenode returning num1120
  int op_slot_right_1119 = gc_frame_newslot(num1120);
  int callframe1122 = gc_frame_new();
  int callframe1123 = gc_frame_new();
  partcv[0] = 0;
  Object call1124 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1123);
// compilenode returning call1124
// compilenode returning call1124
  partcv[0] = 0;
  Object call1125 = callmethod(call1124, "size",
    1, partcv, params);
  gc_frame_end(callframe1122);
// compilenode returning call1125
// compilenode returning call1125
  int op_slot_left_1119 = gc_frame_newslot(call1125);
  params[0] = num1120;
  partcv[0] = 1;
  Object opresult1126 = callmethod(call1125, ">", 1, partcv, params);
// compilenode returning opresult1126
  Object if1118 = done;
  if (istrue(opresult1126)) {
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 260
  setline(260);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1128 == NULL) {
    strlit1128 = alloc_String(" ");
    gc_root(strlit1128);
  }
// compilenode returning strlit1128
  int op_slot_right_1127 = gc_frame_newslot(strlit1128);
// compilenode returning *var_s
  int op_slot_left_1127 = gc_frame_newslot(*var_s);
  params[0] = strlit1128;
  partcv[0] = 1;
  Object opresult1130 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1130
  *var_s = opresult1130;
  if (opresult1130 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1132 = gc_frame_new();
  int callframe1133 = gc_frame_new();
  int callframe1134 = gc_frame_new();
  partcv[0] = 0;
  Object call1135 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1134);
// compilenode returning call1135
// compilenode returning call1135
  partcv[0] = 0;
  Object call1136 = callmethod(call1135, "indices",
    1, partcv, params);
  gc_frame_end(callframe1133);
// compilenode returning call1136
// compilenode returning call1136
  gc_frame_newslot(call1136);
  Object block1137 = alloc_Block(NULL, NULL, "ast", 261);
  gc_frame_newslot(block1137);
  block_savedest(block1137);
  Object closure1138 = createclosure(2, "_apply");
setclosureframe(closure1138, stackframe);
  addtoclosure(closure1138, var_s);
  addtoclosure(closure1138, selfslot);
  struct UserObject *uo1138 = (struct UserObject*)block1137;
  uo1138->data[0] = (Object)closure1138;
  Method *meth_meth_ast__apply1138 = addmethod2pos(block1137, "_apply", &meth_ast__apply1138, 0);
int argcv_meth_ast__apply1138[] = {1};
meth_meth_ast__apply1138->type = alloc_MethodType(1, argcv_meth_ast__apply1138);
  meth_meth_ast__apply1138->definitionModule = modulename;
  meth_meth_ast__apply1138->definitionLine = 261;
// compilenode returning block1137
  gc_frame_newslot(block1137);
  params[0] = call1136;
  params[1] = block1137;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1190 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1132);
// compilenode returning call1190
    gc_frame_newslot(call1190);
    if1118 = call1190;
  } else {
  }
// compilenode returning if1118
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1191 = gc_frame_new();
  int callframe1192 = gc_frame_new();
  partcv[0] = 0;
  Object call1193 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1192);
// compilenode returning call1193
// compilenode returning call1193
  gc_frame_newslot(call1193);
  Object block1194 = alloc_Block(NULL, NULL, "ast", 275);
  gc_frame_newslot(block1194);
  block_savedest(block1194);
  Object closure1195 = createclosure(4, "_apply");
setclosureframe(closure1195, stackframe);
  addtoclosure(closure1195, var_depth);
  addtoclosure(closure1195, var_spc);
  addtoclosure(closure1195, var_s);
  addtoclosure(closure1195, selfslot);
  struct UserObject *uo1195 = (struct UserObject*)block1194;
  uo1195->data[0] = (Object)closure1195;
  Method *meth_meth_ast__apply1195 = addmethod2pos(block1194, "_apply", &meth_ast__apply1195, 0);
int argcv_meth_ast__apply1195[] = {1};
meth_meth_ast__apply1195->type = alloc_MethodType(1, argcv_meth_ast__apply1195);
  meth_meth_ast__apply1195->definitionModule = modulename;
  meth_meth_ast__apply1195->definitionLine = 275;
// compilenode returning block1194
  gc_frame_newslot(block1194);
  params[0] = call1193;
  params[1] = block1194;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1218 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1191);
// compilenode returning call1218
// Begin line 279
  setline(279);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 278
  setline(278);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1220 == NULL) {
    strlit1220 = alloc_String("}");
    gc_root(strlit1220);
  }
// compilenode returning strlit1220
  int op_slot_right_1219 = gc_frame_newslot(strlit1220);
// compilenode returning *var_spc
  int op_slot_right_1222 = gc_frame_newslot(*var_spc);
  if (strlit1225 == NULL) {
    strlit1225 = alloc_String("""\x0a""");
    gc_root(strlit1225);
  }
// compilenode returning strlit1225
  int op_slot_right_1224 = gc_frame_newslot(strlit1225);
// compilenode returning *var_s
  int op_slot_left_1224 = gc_frame_newslot(*var_s);
  params[0] = strlit1225;
  partcv[0] = 1;
  Object opresult1227 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1227
  int op_slot_left_1222 = gc_frame_newslot(opresult1227);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1228 = callmethod(opresult1227, "++", 1, partcv, params);
// compilenode returning opresult1228
  int op_slot_left_1219 = gc_frame_newslot(opresult1228);
  params[0] = strlit1220;
  partcv[0] = 1;
  Object opresult1229 = callmethod(opresult1228, "++", 1, partcv, params);
// compilenode returning opresult1229
  *var_s = opresult1229;
  if (opresult1229 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 279
  setline(279);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply1240(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_patternMarkVisitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 199
  setline(199);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1241 = gc_frame_new();
// compilenode returning *var_patternMarkVisitor
  gc_frame_newslot(*var_patternMarkVisitor);
// compilenode returning *var_p
  params[0] = *var_patternMarkVisitor;
  partcv[0] = 1;
  Object call1242 = callmethod(*var_p, "accept",
    1, partcv, params);
  gc_frame_end(callframe1241);
// compilenode returning call1242
  gc_frame_end(frame);
  return call1242;
}
Object meth_ast_new873(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_blockNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  Object *var_patternMarkVisitor = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject874 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj874 = alloc_userobj2(16,15, objclass874);
  gc_frame_newslot(obj874);
if (objclass874 == NULL) {
  glfree(obj874->class->name);
  obj874->class->name = "blockNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj874, self, 0);
  addmethodreal(obj874,"outer", &reader_ast_outer_875);
  Object oldself874 = self;
  struct StackFrameObject *oldstackframe874 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe874);
  gc_frame_newslot((Object)stackframe);
  self = obj874;
  Object *oldselfslot874 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter874 = (*(struct UserObject *)self).data[0], lowerouter874 = thisouter874;
  if (inheritingObject874) {
    struct UserObject *inho874 = (struct UserObject *)inheritingObject874;
    while (inho874->super != GraceDefaultObject) inho874 = (struct UserObject *)inho874->super;
    inho874->super = obj874;
    self = inheritingObject874;
    *selfslot = self;
    lowerouter874 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter874;
  }
if (objclass874 == NULL) {
  Method *reader876 = addmethodrealflags(obj874, "kind",&reader_ast_kind_876, MFLAG_DEF);
  reader876->definitionModule = modulename;
  reader876->definitionLine = 192;
}
adddatum2(obj874, alloc_Undefined(), 1);
if (objclass874 == NULL) {
  Method *reader877 = addmethodrealflags(obj874, "value",&reader_ast_value_877, MFLAG_DEF);
  reader877->definitionModule = modulename;
  reader877->definitionLine = 193;
}
adddatum2(obj874, alloc_Undefined(), 2);
if (objclass874 == NULL) {
  Method *reader878 = addmethodrealflags(obj874, "params",&reader_ast_params_878, MFLAG_DEF);
  reader878->definitionModule = modulename;
  reader878->definitionLine = 194;
}
adddatum2(obj874, alloc_Undefined(), 3);
if (objclass874 == NULL) {
  Method *reader879 = addmethodrealflags(obj874, "body",&reader_ast_body_879, MFLAG_DEF);
  reader879->definitionModule = modulename;
  reader879->definitionLine = 195;
}
adddatum2(obj874, alloc_Undefined(), 4);
if (objclass874 == NULL) {
  Method *reader880 = addmethodrealflags(obj874, "selfclosure",&reader_ast_selfclosure_880, MFLAG_DEF);
  reader880->definitionModule = modulename;
  reader880->definitionLine = 196;
}
adddatum2(obj874, alloc_Undefined(), 5);
if (objclass874 == NULL) {
  Method *reader881 = addmethodrealflags(obj874, "matchingPattern",&reader_ast_matchingPattern_881, 0);
  Method *writer881 = addmethodrealflags(obj874, "matchingPattern:=",&writer_ast_matchingPattern_881, 0);
  reader881->definitionModule = modulename;
  writer881->definitionModule = modulename;
  reader881->definitionLine = 197;
  writer881->definitionLine = 197;
}
obj874->flags |= OFLAG_MUTABLE;
adddatum2(obj874, alloc_Undefined(), 6);
if (objclass874 == NULL) {
  Method *reader882 = addmethodrealflags(obj874, "extraRuntimeData",&reader_ast_extraRuntimeData_882, 0);
  Method *writer882 = addmethodrealflags(obj874, "extraRuntimeData:=",&writer_ast_extraRuntimeData_882, 0);
  reader882->definitionModule = modulename;
  writer882->definitionModule = modulename;
  reader882->definitionLine = 198;
  writer882->definitionLine = 198;
}
obj874->flags |= OFLAG_MUTABLE;
adddatum2(obj874, alloc_Undefined(), 7);
  struct UserObject *uo883 = (struct UserObject*)obj874;
  uo883->data[8] = emptyclosure;
  Method *meth_meth_ast_accept883 = addmethod2pos(obj874, "accept", &meth_ast_accept883, 8);
int argcv_meth_ast_accept883[] = {1};
meth_meth_ast_accept883->type = alloc_MethodType(1, argcv_meth_ast_accept883);
meth_meth_ast_accept883->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept883->type->names[0] = "visitor";
  meth_meth_ast_accept883->definitionModule = modulename;
  meth_meth_ast_accept883->definitionLine = 201;
  block_savedest(obj874);
  Object closure916 = createclosure(1, "map()before()after");
setclosureframe(closure916, stackframe);
  addtoclosure(closure916, var_blockNode);
  struct UserObject *uo916 = (struct UserObject*)obj874;
  uo916->data[9] = (Object)closure916;
  Method *meth_meth_ast_map_40__41_before_40__41_after916 = addmethod2pos(obj874, "map()before()after", &meth_ast_map_40__41_before_40__41_after916, 9);
int argcv_meth_ast_map_40__41_before_40__41_after916[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after916->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after916);
  meth_meth_ast_map_40__41_before_40__41_after916->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after916->definitionLine = 214;
  struct UserObject *uo963 = (struct UserObject*)obj874;
  uo963->data[10] = emptyclosure;
  Method *meth_meth_ast_map963 = addmethod2pos(obj874, "map", &meth_ast_map963, 10);
int argcv_meth_ast_map963[] = {1};
meth_meth_ast_map963->type = alloc_MethodType(1, argcv_meth_ast_map963);
  meth_meth_ast_map963->definitionModule = modulename;
  meth_meth_ast_map963->definitionLine = 228;
  struct UserObject *uo972 = (struct UserObject*)obj874;
  uo972->data[11] = emptyclosure;
  Method *meth_meth_ast_pretty972 = addmethod2pos(obj874, "pretty", &meth_ast_pretty972, 11);
int argcv_meth_ast_pretty972[] = {1};
meth_meth_ast_pretty972->type = alloc_MethodType(1, argcv_meth_ast_pretty972);
  meth_meth_ast_pretty972->definitionModule = modulename;
  meth_meth_ast_pretty972->definitionLine = 231;
  struct UserObject *uo1097 = (struct UserObject*)obj874;
  uo1097->data[12] = emptyclosure;
  Method *meth_meth_ast_toGrace1097 = addmethod2pos(obj874, "toGrace", &meth_ast_toGrace1097, 12);
int argcv_meth_ast_toGrace1097[] = {1};
meth_meth_ast_toGrace1097->type = alloc_MethodType(1, argcv_meth_ast_toGrace1097);
meth_meth_ast_toGrace1097->type->types[0] = type_Number;
meth_meth_ast_toGrace1097->type->names[0] = "depth";
  meth_meth_ast_toGrace1097->definitionModule = modulename;
  meth_meth_ast_toGrace1097->definitionLine = 253;
  sourceObject = obj874;
// Begin line 190
  setline(190);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1231 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1232 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe1231);
// compilenode returning call1232
  struct UserObject *obj874_uo = (struct UserObject *)obj874;
  obj874_uo->super = call1232;
  sourceObject = obj874;
// Begin line 191
  setline(191);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1233 == NULL) {
    strlit1233 = alloc_String("block");
    gc_root(strlit1233);
  }
// compilenode returning strlit1233
  adddatum2(obj874, strlit1233, 1);
  sourceObject = obj874;
// Begin line 192
  setline(192);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1234 == NULL) {
    strlit1234 = alloc_String("block");
    gc_root(strlit1234);
  }
// compilenode returning strlit1234
  adddatum2(obj874, strlit1234, 2);
  sourceObject = obj874;
// Begin line 193
  setline(193);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_params_39_
  adddatum2(obj874, *var_params_39_, 3);
  sourceObject = obj874;
// Begin line 194
  setline(194);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_body_39_
  adddatum2(obj874, *var_body_39_, 4);
  sourceObject = obj874;
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1235 = alloc_Boolean(1);
// compilenode returning bool1235
  adddatum2(obj874, bool1235, 5);
  sourceObject = obj874;
// Begin line 196
  setline(196);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1236 = alloc_Boolean(0);
// compilenode returning bool1236
  adddatum2(obj874, bool1236, 6);
  sourceObject = obj874;
// Begin line 197
  setline(197);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1237 = alloc_Boolean(0);
// compilenode returning bool1237
  adddatum2(obj874, bool1237, 7);
  sourceObject = obj874;
// Begin line 198
  setline(198);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1238 = gc_frame_new();
// compilenode returning *var_params_39_
  gc_frame_newslot(*var_params_39_);
  Object block1239 = alloc_Block(NULL, NULL, "ast", 198);
  gc_frame_newslot(block1239);
  block_savedest(block1239);
  Object closure1240 = createclosure(2, "_apply");
setclosureframe(closure1240, stackframe);
  addtoclosure(closure1240, var_patternMarkVisitor);
  addtoclosure(closure1240, selfslot);
  struct UserObject *uo1240 = (struct UserObject*)block1239;
  uo1240->data[0] = (Object)closure1240;
  Method *meth_meth_ast__apply1240 = addmethod2pos(block1239, "_apply", &meth_ast__apply1240, 0);
int argcv_meth_ast__apply1240[] = {1};
meth_meth_ast__apply1240->type = alloc_MethodType(1, argcv_meth_ast__apply1240);
  meth_meth_ast__apply1240->definitionModule = modulename;
  meth_meth_ast__apply1240->definitionLine = 275;
// compilenode returning block1239
  gc_frame_newslot(block1239);
  params[0] = *var_params_39_;
  params[1] = block1239;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1244 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1238);
// compilenode returning call1244
  sourceObject = obj874;
  sourceObject = obj874;
  sourceObject = obj874;
  sourceObject = obj874;
  sourceObject = obj874;
objclass874 = obj874->class;
  objclass874->definitionModule = modulename;
  objclass874->definitionLine = 181;
  (*(struct UserObject *)self).data[0] = lowerouter874;
  self = oldself874;
  selfslot = oldselfslot874;
  stackframe = oldstackframe874;
  gc_frame_end(frame);
  return obj874;
}
Object meth_ast_new873_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_blockNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  Object *var_patternMarkVisitor = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject874 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj874 = alloc_userobj2(16,15, objclass874);
  gc_frame_newslot(obj874);
if (objclass874 == NULL) {
  glfree(obj874->class->name);
  obj874->class->name = "blockNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj874, self, 0);
  addmethodreal(obj874,"outer", &reader_ast_outer_875);
  Object oldself874 = self;
  struct StackFrameObject *oldstackframe874 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe874);
  gc_frame_newslot((Object)stackframe);
  self = obj874;
  Object *oldselfslot874 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter874 = (*(struct UserObject *)self).data[0], lowerouter874 = thisouter874;
  if (inheritingObject874) {
    struct UserObject *inho874 = (struct UserObject *)inheritingObject874;
    while (inho874->super != GraceDefaultObject) inho874 = (struct UserObject *)inho874->super;
    inho874->super = obj874;
    self = inheritingObject874;
    *selfslot = self;
    lowerouter874 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter874;
  }
if (objclass874 == NULL) {
  Method *reader876 = addmethodrealflags(obj874, "kind",&reader_ast_kind_876, MFLAG_DEF);
  reader876->definitionModule = modulename;
  reader876->definitionLine = 192;
}
adddatum2(obj874, alloc_Undefined(), 1);
if (objclass874 == NULL) {
  Method *reader877 = addmethodrealflags(obj874, "value",&reader_ast_value_877, MFLAG_DEF);
  reader877->definitionModule = modulename;
  reader877->definitionLine = 193;
}
adddatum2(obj874, alloc_Undefined(), 2);
if (objclass874 == NULL) {
  Method *reader878 = addmethodrealflags(obj874, "params",&reader_ast_params_878, MFLAG_DEF);
  reader878->definitionModule = modulename;
  reader878->definitionLine = 194;
}
adddatum2(obj874, alloc_Undefined(), 3);
if (objclass874 == NULL) {
  Method *reader879 = addmethodrealflags(obj874, "body",&reader_ast_body_879, MFLAG_DEF);
  reader879->definitionModule = modulename;
  reader879->definitionLine = 195;
}
adddatum2(obj874, alloc_Undefined(), 4);
if (objclass874 == NULL) {
  Method *reader880 = addmethodrealflags(obj874, "selfclosure",&reader_ast_selfclosure_880, MFLAG_DEF);
  reader880->definitionModule = modulename;
  reader880->definitionLine = 196;
}
adddatum2(obj874, alloc_Undefined(), 5);
if (objclass874 == NULL) {
  Method *reader881 = addmethodrealflags(obj874, "matchingPattern",&reader_ast_matchingPattern_881, 0);
  Method *writer881 = addmethodrealflags(obj874, "matchingPattern:=",&writer_ast_matchingPattern_881, 0);
  reader881->definitionModule = modulename;
  writer881->definitionModule = modulename;
  reader881->definitionLine = 197;
  writer881->definitionLine = 197;
}
obj874->flags |= OFLAG_MUTABLE;
adddatum2(obj874, alloc_Undefined(), 6);
if (objclass874 == NULL) {
  Method *reader882 = addmethodrealflags(obj874, "extraRuntimeData",&reader_ast_extraRuntimeData_882, 0);
  Method *writer882 = addmethodrealflags(obj874, "extraRuntimeData:=",&writer_ast_extraRuntimeData_882, 0);
  reader882->definitionModule = modulename;
  writer882->definitionModule = modulename;
  reader882->definitionLine = 198;
  writer882->definitionLine = 198;
}
obj874->flags |= OFLAG_MUTABLE;
adddatum2(obj874, alloc_Undefined(), 7);
  struct UserObject *uo883 = (struct UserObject*)obj874;
  uo883->data[8] = emptyclosure;
  Method *meth_meth_ast_accept883 = addmethod2pos(obj874, "accept", &meth_ast_accept883, 8);
int argcv_meth_ast_accept883[] = {1};
meth_meth_ast_accept883->type = alloc_MethodType(1, argcv_meth_ast_accept883);
meth_meth_ast_accept883->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept883->type->names[0] = "visitor";
  meth_meth_ast_accept883->definitionModule = modulename;
  meth_meth_ast_accept883->definitionLine = 201;
  block_savedest(obj874);
  Object closure916 = createclosure(1, "map()before()after");
setclosureframe(closure916, stackframe);
  addtoclosure(closure916, var_blockNode);
  struct UserObject *uo916 = (struct UserObject*)obj874;
  uo916->data[9] = (Object)closure916;
  Method *meth_meth_ast_map_40__41_before_40__41_after916 = addmethod2pos(obj874, "map()before()after", &meth_ast_map_40__41_before_40__41_after916, 9);
int argcv_meth_ast_map_40__41_before_40__41_after916[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after916->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after916);
  meth_meth_ast_map_40__41_before_40__41_after916->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after916->definitionLine = 214;
  struct UserObject *uo963 = (struct UserObject*)obj874;
  uo963->data[10] = emptyclosure;
  Method *meth_meth_ast_map963 = addmethod2pos(obj874, "map", &meth_ast_map963, 10);
int argcv_meth_ast_map963[] = {1};
meth_meth_ast_map963->type = alloc_MethodType(1, argcv_meth_ast_map963);
  meth_meth_ast_map963->definitionModule = modulename;
  meth_meth_ast_map963->definitionLine = 228;
  struct UserObject *uo972 = (struct UserObject*)obj874;
  uo972->data[11] = emptyclosure;
  Method *meth_meth_ast_pretty972 = addmethod2pos(obj874, "pretty", &meth_ast_pretty972, 11);
int argcv_meth_ast_pretty972[] = {1};
meth_meth_ast_pretty972->type = alloc_MethodType(1, argcv_meth_ast_pretty972);
  meth_meth_ast_pretty972->definitionModule = modulename;
  meth_meth_ast_pretty972->definitionLine = 231;
  struct UserObject *uo1097 = (struct UserObject*)obj874;
  uo1097->data[12] = emptyclosure;
  Method *meth_meth_ast_toGrace1097 = addmethod2pos(obj874, "toGrace", &meth_ast_toGrace1097, 12);
int argcv_meth_ast_toGrace1097[] = {1};
meth_meth_ast_toGrace1097->type = alloc_MethodType(1, argcv_meth_ast_toGrace1097);
meth_meth_ast_toGrace1097->type->types[0] = type_Number;
meth_meth_ast_toGrace1097->type->names[0] = "depth";
  meth_meth_ast_toGrace1097->definitionModule = modulename;
  meth_meth_ast_toGrace1097->definitionLine = 253;
  sourceObject = obj874;
// Begin line 190
  setline(190);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1231 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1232 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe1231);
// compilenode returning call1232
  struct UserObject *obj874_uo = (struct UserObject *)obj874;
  obj874_uo->super = call1232;
  sourceObject = obj874;
// Begin line 191
  setline(191);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1233 == NULL) {
    strlit1233 = alloc_String("block");
    gc_root(strlit1233);
  }
// compilenode returning strlit1233
  adddatum2(obj874, strlit1233, 1);
  sourceObject = obj874;
// Begin line 192
  setline(192);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1234 == NULL) {
    strlit1234 = alloc_String("block");
    gc_root(strlit1234);
  }
// compilenode returning strlit1234
  adddatum2(obj874, strlit1234, 2);
  sourceObject = obj874;
// Begin line 193
  setline(193);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_params_39_
  adddatum2(obj874, *var_params_39_, 3);
  sourceObject = obj874;
// Begin line 194
  setline(194);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_body_39_
  adddatum2(obj874, *var_body_39_, 4);
  sourceObject = obj874;
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1235 = alloc_Boolean(1);
// compilenode returning bool1235
  adddatum2(obj874, bool1235, 5);
  sourceObject = obj874;
// Begin line 196
  setline(196);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1236 = alloc_Boolean(0);
// compilenode returning bool1236
  adddatum2(obj874, bool1236, 6);
  sourceObject = obj874;
// Begin line 197
  setline(197);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1237 = alloc_Boolean(0);
// compilenode returning bool1237
  adddatum2(obj874, bool1237, 7);
  sourceObject = obj874;
// Begin line 198
  setline(198);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1238 = gc_frame_new();
// compilenode returning *var_params_39_
  gc_frame_newslot(*var_params_39_);
  Object block1239 = alloc_Block(NULL, NULL, "ast", 198);
  gc_frame_newslot(block1239);
  block_savedest(block1239);
  Object closure1240 = createclosure(2, "_apply");
setclosureframe(closure1240, stackframe);
  addtoclosure(closure1240, var_patternMarkVisitor);
  addtoclosure(closure1240, selfslot);
  struct UserObject *uo1240 = (struct UserObject*)block1239;
  uo1240->data[0] = (Object)closure1240;
  Method *meth_meth_ast__apply1240 = addmethod2pos(block1239, "_apply", &meth_ast__apply1240, 0);
int argcv_meth_ast__apply1240[] = {1};
meth_meth_ast__apply1240->type = alloc_MethodType(1, argcv_meth_ast__apply1240);
  meth_meth_ast__apply1240->definitionModule = modulename;
  meth_meth_ast__apply1240->definitionLine = 275;
// compilenode returning block1239
  gc_frame_newslot(block1239);
  params[0] = *var_params_39_;
  params[1] = block1239;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1244 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1238);
// compilenode returning call1244
  sourceObject = obj874;
  sourceObject = obj874;
  sourceObject = obj874;
  sourceObject = obj874;
  sourceObject = obj874;
objclass874 = obj874->class;
  objclass874->definitionModule = modulename;
  objclass874->definitionLine = 181;
  (*(struct UserObject *)self).data[0] = lowerouter874;
  self = oldself874;
  selfslot = oldselfslot874;
  stackframe = oldstackframe874;
  gc_frame_end(frame);
  return obj874;
}
Object meth_ast_catchCaseNode1246(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "catchCaseNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_catchCaseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for catchCaseNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for catchCaseNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_catchCaseNode
  gc_frame_end(frame);
  return *var_catchCaseNode;
}
Object meth_ast__apply1268(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 292
  setline(292);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1269 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_mx
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call1270 = callmethod(*var_mx, "accept",
    1, partcv, params);
  gc_frame_end(callframe1269);
// compilenode returning call1270
  gc_frame_end(frame);
  return call1270;
}
Object meth_ast_accept1256(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1258 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call1259 = callmethod(*var_visitor, "visitCatchCase",
    1, partcv, params);
  gc_frame_end(callframe1258);
// compilenode returning call1259
  Object if1257 = done;
  if (istrue(call1259)) {
// Begin line 290
  setline(290);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1260 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe1261 = gc_frame_new();
  partcv[0] = 0;
  Object call1262 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1261);
// compilenode returning call1262
// compilenode returning call1262
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call1263 = callmethod(call1262, "accept",
    1, partcv, params);
  gc_frame_end(callframe1260);
// compilenode returning call1263
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1264 = gc_frame_new();
  int callframe1265 = gc_frame_new();
  partcv[0] = 0;
  Object call1266 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1265);
// compilenode returning call1266
// compilenode returning call1266
  gc_frame_newslot(call1266);
  Object block1267 = alloc_Block(NULL, NULL, "ast", 291);
  gc_frame_newslot(block1267);
  block_savedest(block1267);
  Object closure1268 = createclosure(2, "_apply");
setclosureframe(closure1268, stackframe);
  addtoclosure(closure1268, var_visitor);
  addtoclosure(closure1268, selfslot);
  struct UserObject *uo1268 = (struct UserObject*)block1267;
  uo1268->data[0] = (Object)closure1268;
  Method *meth_meth_ast__apply1268 = addmethod2pos(block1267, "_apply", &meth_ast__apply1268, 0);
int argcv_meth_ast__apply1268[] = {1};
meth_meth_ast__apply1268->type = alloc_MethodType(1, argcv_meth_ast__apply1268);
  meth_meth_ast__apply1268->definitionModule = modulename;
  meth_meth_ast__apply1268->definitionLine = 291;
// compilenode returning block1267
  gc_frame_newslot(block1267);
  params[0] = call1266;
  params[1] = block1267;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1272 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1264);
// compilenode returning call1272
// Begin line 297
  setline(297);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 294
  setline(294);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1275 = alloc_Boolean(0);
// compilenode returning bool1275
  int op_slot_right_1274 = gc_frame_newslot(bool1275);
  int callframe1277 = gc_frame_new();
  partcv[0] = 0;
  Object call1278 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1277);
// compilenode returning call1278
// compilenode returning call1278
  int op_slot_left_1274 = gc_frame_newslot(call1278);
  params[0] = bool1275;
  partcv[0] = 1;
  Object opresult1279 = callmethod(call1278, "!=", 1, partcv, params);
// compilenode returning opresult1279
  Object if1273 = done;
  if (istrue(opresult1279)) {
// Begin line 295
  setline(295);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1280 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe1281 = gc_frame_new();
  partcv[0] = 0;
  Object call1282 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1281);
// compilenode returning call1282
// compilenode returning call1282
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call1283 = callmethod(call1282, "accept",
    1, partcv, params);
  gc_frame_end(callframe1280);
// compilenode returning call1283
    gc_frame_newslot(call1283);
    if1273 = call1283;
  } else {
  }
// compilenode returning if1273
    gc_frame_newslot(if1273);
    if1257 = if1273;
  } else {
  }
// compilenode returning if1257
  gc_frame_end(frame);
  return if1257;
}
Object meth_ast_map_40__41_before_40__41_after1284(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_catchCaseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 300
  setline(300);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1285 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call1286 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe1285);
// compilenode returning call1286
// Begin line 301
  setline(301);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1287 = gc_frame_new();
  int callframe1288 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe1289 = gc_frame_new();
  partcv[0] = 0;
  Object call1290 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1289);
// compilenode returning call1290
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1291 = callmethod(call1290, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe1288);
// compilenode returning call1291
  gc_frame_newslot(call1291);
// Begin line 302
  setline(302);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1292 = gc_frame_new();
  int callframe1293 = gc_frame_new();
  partcv[0] = 0;
  Object call1294 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1293);
// compilenode returning call1294
  gc_frame_newslot(call1294);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe1295 = gc_frame_new();
  int callframe1296 = gc_frame_new();
  Object call1297 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1296);
// compilenode returning call1297
// compilenode returning call1297
  partcv[0] = 0;
  Object call1298 = callmethodflags(call1297, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1295);
// compilenode returning call1298
// compilenode returning call1298
  params[0] = call1294;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1299 = callmethodflags(call1298, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1292);
// compilenode returning call1299
  gc_frame_newslot(call1299);
// Begin line 303
  setline(303);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1300 = gc_frame_new();
  int callframe1301 = gc_frame_new();
  partcv[0] = 0;
  Object call1302 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1301);
// compilenode returning call1302
  gc_frame_newslot(call1302);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe1303 = gc_frame_new();
  int callframe1304 = gc_frame_new();
  Object call1305 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1304);
// compilenode returning call1305
// compilenode returning call1305
  partcv[0] = 0;
  Object call1306 = callmethodflags(call1305, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1303);
// compilenode returning call1306
// compilenode returning call1306
  params[0] = call1302;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 4;
  Object call1307 = callmethodflags(call1306, "maybeMap", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1300);
// compilenode returning call1307
  gc_frame_newslot(call1307);
// Begin line 301
  setline(301);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_catchCaseNode
  params[0] = call1291;
  params[1] = call1299;
  params[2] = call1307;
  partcv[0] = 3;
  Object call1308 = callmethod(*var_catchCaseNode, "new",
    1, partcv, params);
  gc_frame_end(callframe1287);
// compilenode returning call1308
  *var_n = call1308;
  if (call1308 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 303
  setline(303);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1309 = gc_frame_new();
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1310 = gc_frame_new();
  partcv[0] = 0;
  Object call1311 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1310);
// compilenode returning call1311
  gc_frame_newslot(call1311);
// compilenode returning *var_n
  params[0] = call1311;
  partcv[0] = 1;
  Object call1312 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe1309);
// compilenode returning call1312
// compilenode returning done
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply1316(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1319(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map1313(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 308
  setline(308);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1314 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block1315 = alloc_Block(NULL, NULL, "ast", 308);
  gc_frame_newslot(block1315);
  block_savedest(block1315);
  Object closure1316 = createclosure(1, "_apply");
setclosureframe(closure1316, stackframe);
  addtoclosure(closure1316, selfslot);
  struct UserObject *uo1316 = (struct UserObject*)block1315;
  uo1316->data[0] = (Object)closure1316;
  Method *meth_meth_ast__apply1316 = addmethod2pos(block1315, "_apply", &meth_ast__apply1316, 0);
int argcv_meth_ast__apply1316[] = {0};
meth_meth_ast__apply1316->type = alloc_MethodType(1, argcv_meth_ast__apply1316);
  meth_meth_ast__apply1316->definitionModule = modulename;
  meth_meth_ast__apply1316->definitionLine = 303;
// compilenode returning block1315
  gc_frame_newslot(block1315);
  Object block1318 = alloc_Block(NULL, NULL, "ast", 308);
  gc_frame_newslot(block1318);
  block_savedest(block1318);
  Object closure1319 = createclosure(1, "_apply");
setclosureframe(closure1319, stackframe);
  addtoclosure(closure1319, selfslot);
  struct UserObject *uo1319 = (struct UserObject*)block1318;
  uo1319->data[0] = (Object)closure1319;
  Method *meth_meth_ast__apply1319 = addmethod2pos(block1318, "_apply", &meth_ast__apply1319, 0);
int argcv_meth_ast__apply1319[] = {0};
meth_meth_ast__apply1319->type = alloc_MethodType(1, argcv_meth_ast__apply1319);
  meth_meth_ast__apply1319->definitionModule = modulename;
  meth_meth_ast__apply1319->definitionLine = 303;
// compilenode returning block1318
  gc_frame_newslot(block1318);
  params[0] = *var_blk;
  params[1] = block1315;
  params[2] = block1318;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1321 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1314);
// compilenode returning call1321
  gc_frame_end(frame);
  return call1321;
}
Object meth_ast__apply1330(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 314
  setline(314);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1332 == NULL) {
    strlit1332 = alloc_String("  ");
    gc_root(strlit1332);
  }
// compilenode returning strlit1332
  int op_slot_right_1331 = gc_frame_newslot(strlit1332);
// compilenode returning *var_spc
  int op_slot_left_1331 = gc_frame_newslot(*var_spc);
  params[0] = strlit1332;
  partcv[0] = 1;
  Object opresult1334 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult1334
  *var_spc = opresult1334;
  if (opresult1334 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1358(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 319
  setline(319);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 318
  setline(318);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1361 == NULL) {
    strlit1361 = alloc_String("");
    gc_root(strlit1361);
  }
// compilenode returning strlit1361
  int op_slot_right_1360 = gc_frame_newslot(strlit1361);
  int callframe1364 = gc_frame_new();
  Object num1366 = alloc_Float64(2);
// compilenode returning num1366
  int op_slot_right_1365 = gc_frame_newslot(num1366);
// compilenode returning *var_depth
  int op_slot_left_1365 = gc_frame_newslot(*var_depth);
  params[0] = num1366;
  partcv[0] = 1;
  Object sum1368 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1368
  gc_frame_newslot(sum1368);
// compilenode returning *var_mx
  params[0] = sum1368;
  partcv[0] = 1;
  Object call1369 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1364);
// compilenode returning call1369
  int op_slot_right_1363 = gc_frame_newslot(call1369);
  if (strlit1372 == NULL) {
    strlit1372 = alloc_String("  ");
    gc_root(strlit1372);
  }
// compilenode returning strlit1372
  int op_slot_right_1371 = gc_frame_newslot(strlit1372);
// compilenode returning *var_spc
  int op_slot_right_1374 = gc_frame_newslot(*var_spc);
  if (strlit1377 == NULL) {
    strlit1377 = alloc_String("Case:""\x0a""");
    gc_root(strlit1377);
  }
// compilenode returning strlit1377
  int op_slot_right_1376 = gc_frame_newslot(strlit1377);
// compilenode returning *var_spc
  int op_slot_right_1379 = gc_frame_newslot(*var_spc);
  if (strlit1381 == NULL) {
    strlit1381 = alloc_String("""\x0a""");
    gc_root(strlit1381);
  }
// compilenode returning strlit1381
  int op_slot_left_1379 = gc_frame_newslot(strlit1381);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1382 = callmethod(strlit1381, "++", 1, partcv, params);
// compilenode returning opresult1382
  int op_slot_left_1376 = gc_frame_newslot(opresult1382);
  params[0] = strlit1377;
  partcv[0] = 1;
  Object opresult1383 = callmethod(opresult1382, "++", 1, partcv, params);
// compilenode returning opresult1383
  int op_slot_left_1374 = gc_frame_newslot(opresult1383);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1384 = callmethod(opresult1383, "++", 1, partcv, params);
// compilenode returning opresult1384
  int op_slot_left_1371 = gc_frame_newslot(opresult1384);
  params[0] = strlit1372;
  partcv[0] = 1;
  Object opresult1385 = callmethod(opresult1384, "++", 1, partcv, params);
// compilenode returning opresult1385
  int op_slot_left_1363 = gc_frame_newslot(opresult1385);
  params[0] = call1369;
  partcv[0] = 1;
  Object opresult1386 = callmethod(opresult1385, "++", 1, partcv, params);
// compilenode returning opresult1386
  int op_slot_left_1360 = gc_frame_newslot(opresult1386);
  params[0] = strlit1361;
  partcv[0] = 1;
  Object opresult1387 = callmethod(opresult1386, "++", 1, partcv, params);
// compilenode returning opresult1387
  int op_slot_right_1359 = gc_frame_newslot(opresult1387);
// compilenode returning *var_s
  int op_slot_left_1359 = gc_frame_newslot(*var_s);
  params[0] = opresult1387;
  partcv[0] = 1;
  Object opresult1389 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1389
  *var_s = opresult1389;
  if (opresult1389 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty1322(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 312
  setline(312);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 311
  setline(311);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1323 == NULL) {
    strlit1323 = alloc_String("");
    gc_root(strlit1323);
  }
// compilenode returning strlit1323
  *var_spc = strlit1323;
  if (strlit1323 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 312
  setline(312);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1324 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_1325 = gc_frame_newslot(*var_depth);
  Object num1327 = alloc_Float64(0);
// compilenode returning num1327
  int op_slot_left_1325 = gc_frame_newslot(num1327);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult1328 = callmethod(num1327, "..", 1, partcv, params);
// compilenode returning opresult1328
  gc_frame_newslot(opresult1328);
  Object block1329 = alloc_Block(NULL, NULL, "ast", 312);
  gc_frame_newslot(block1329);
  block_savedest(block1329);
  Object closure1330 = createclosure(2, "_apply");
setclosureframe(closure1330, stackframe);
  addtoclosure(closure1330, var_spc);
  addtoclosure(closure1330, selfslot);
  struct UserObject *uo1330 = (struct UserObject*)block1329;
  uo1330->data[0] = (Object)closure1330;
  Method *meth_meth_ast__apply1330 = addmethod2pos(block1329, "_apply", &meth_ast__apply1330, 0);
int argcv_meth_ast__apply1330[] = {1};
meth_meth_ast__apply1330->type = alloc_MethodType(1, argcv_meth_ast__apply1330);
  meth_meth_ast__apply1330->definitionModule = modulename;
  meth_meth_ast__apply1330->definitionLine = 303;
// compilenode returning block1329
  gc_frame_newslot(block1329);
  params[0] = opresult1328;
  params[1] = block1329;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1337 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1324);
// compilenode returning call1337
// Begin line 316
  setline(316);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 315
  setline(315);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1338 == NULL) {
    strlit1338 = alloc_String("Catch""\x0a""");
    gc_root(strlit1338);
  }
// compilenode returning strlit1338
  *var_s = strlit1338;
  if (strlit1338 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 316
  setline(316);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1340 = gc_frame_new();
  Object num1342 = alloc_Float64(2);
// compilenode returning num1342
  int op_slot_right_1341 = gc_frame_newslot(num1342);
// compilenode returning *var_depth
  int op_slot_left_1341 = gc_frame_newslot(*var_depth);
  params[0] = num1342;
  partcv[0] = 1;
  Object sum1344 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1344
  gc_frame_newslot(sum1344);
  int callframe1345 = gc_frame_new();
  partcv[0] = 0;
  Object call1346 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1345);
// compilenode returning call1346
  params[0] = sum1344;
  partcv[0] = 1;
  Object call1347 = callmethod(call1346, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1340);
// compilenode returning call1347
  int op_slot_right_1339 = gc_frame_newslot(call1347);
// compilenode returning *var_spc
  int op_slot_right_1349 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_1349 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1351 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1351
  int op_slot_left_1339 = gc_frame_newslot(opresult1351);
  params[0] = call1347;
  partcv[0] = 1;
  Object opresult1352 = callmethod(opresult1351, "++", 1, partcv, params);
// compilenode returning opresult1352
  *var_s = opresult1352;
  if (opresult1352 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 317
  setline(317);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1354 = gc_frame_new();
  int callframe1355 = gc_frame_new();
  partcv[0] = 0;
  Object call1356 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1355);
// compilenode returning call1356
// compilenode returning call1356
  gc_frame_newslot(call1356);
  Object block1357 = alloc_Block(NULL, NULL, "ast", 317);
  gc_frame_newslot(block1357);
  block_savedest(block1357);
  Object closure1358 = createclosure(4, "_apply");
setclosureframe(closure1358, stackframe);
  addtoclosure(closure1358, var_depth);
  addtoclosure(closure1358, var_spc);
  addtoclosure(closure1358, var_s);
  addtoclosure(closure1358, selfslot);
  struct UserObject *uo1358 = (struct UserObject*)block1357;
  uo1358->data[0] = (Object)closure1358;
  Method *meth_meth_ast__apply1358 = addmethod2pos(block1357, "_apply", &meth_ast__apply1358, 0);
int argcv_meth_ast__apply1358[] = {1};
meth_meth_ast__apply1358->type = alloc_MethodType(1, argcv_meth_ast__apply1358);
  meth_meth_ast__apply1358->definitionModule = modulename;
  meth_meth_ast__apply1358->definitionLine = 317;
// compilenode returning block1357
  gc_frame_newslot(block1357);
  params[0] = call1356;
  params[1] = block1357;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1392 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1354);
// compilenode returning call1392
// Begin line 323
  setline(323);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 320
  setline(320);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1395 = gc_frame_new();
  partcv[0] = 0;
  Object call1396 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1395);
// compilenode returning call1396
// compilenode returning call1396
  int op_slot_right_1394 = gc_frame_newslot(call1396);
  Object bool1398 = alloc_Boolean(0);
// compilenode returning bool1398
  int op_slot_left_1394 = gc_frame_newslot(bool1398);
  params[0] = call1396;
  partcv[0] = 1;
  Object opresult1399 = callmethod(bool1398, "!=", 1, partcv, params);
// compilenode returning opresult1399
  Object if1393 = done;
  if (istrue(opresult1399)) {
// Begin line 322
  setline(322);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 321
  setline(321);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1402 == NULL) {
    strlit1402 = alloc_String("");
    gc_root(strlit1402);
  }
// compilenode returning strlit1402
  int op_slot_right_1401 = gc_frame_newslot(strlit1402);
  int callframe1405 = gc_frame_new();
  Object num1407 = alloc_Float64(2);
// compilenode returning num1407
  int op_slot_right_1406 = gc_frame_newslot(num1407);
// compilenode returning *var_depth
  int op_slot_left_1406 = gc_frame_newslot(*var_depth);
  params[0] = num1407;
  partcv[0] = 1;
  Object sum1409 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1409
  gc_frame_newslot(sum1409);
  int callframe1410 = gc_frame_new();
  partcv[0] = 0;
  Object call1411 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1410);
// compilenode returning call1411
// compilenode returning call1411
  params[0] = sum1409;
  partcv[0] = 1;
  Object call1412 = callmethod(call1411, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1405);
// compilenode returning call1412
  int op_slot_right_1404 = gc_frame_newslot(call1412);
  if (strlit1415 == NULL) {
    strlit1415 = alloc_String("  ");
    gc_root(strlit1415);
  }
// compilenode returning strlit1415
  int op_slot_right_1414 = gc_frame_newslot(strlit1415);
// compilenode returning *var_spc
  int op_slot_right_1417 = gc_frame_newslot(*var_spc);
  if (strlit1420 == NULL) {
    strlit1420 = alloc_String("Finally:""\x0a""");
    gc_root(strlit1420);
  }
// compilenode returning strlit1420
  int op_slot_right_1419 = gc_frame_newslot(strlit1420);
// compilenode returning *var_spc
  int op_slot_right_1422 = gc_frame_newslot(*var_spc);
  if (strlit1424 == NULL) {
    strlit1424 = alloc_String("""\x0a""");
    gc_root(strlit1424);
  }
// compilenode returning strlit1424
  int op_slot_left_1422 = gc_frame_newslot(strlit1424);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1425 = callmethod(strlit1424, "++", 1, partcv, params);
// compilenode returning opresult1425
  int op_slot_left_1419 = gc_frame_newslot(opresult1425);
  params[0] = strlit1420;
  partcv[0] = 1;
  Object opresult1426 = callmethod(opresult1425, "++", 1, partcv, params);
// compilenode returning opresult1426
  int op_slot_left_1417 = gc_frame_newslot(opresult1426);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1427 = callmethod(opresult1426, "++", 1, partcv, params);
// compilenode returning opresult1427
  int op_slot_left_1414 = gc_frame_newslot(opresult1427);
  params[0] = strlit1415;
  partcv[0] = 1;
  Object opresult1428 = callmethod(opresult1427, "++", 1, partcv, params);
// compilenode returning opresult1428
  int op_slot_left_1404 = gc_frame_newslot(opresult1428);
  params[0] = call1412;
  partcv[0] = 1;
  Object opresult1429 = callmethod(opresult1428, "++", 1, partcv, params);
// compilenode returning opresult1429
  int op_slot_left_1401 = gc_frame_newslot(opresult1429);
  params[0] = strlit1402;
  partcv[0] = 1;
  Object opresult1430 = callmethod(opresult1429, "++", 1, partcv, params);
// compilenode returning opresult1430
  int op_slot_right_1400 = gc_frame_newslot(opresult1430);
// compilenode returning *var_s
  int op_slot_left_1400 = gc_frame_newslot(*var_s);
  params[0] = opresult1430;
  partcv[0] = 1;
  Object opresult1432 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1432
  *var_s = opresult1432;
  if (opresult1432 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1393 = done;
  } else {
  }
// compilenode returning if1393
// Begin line 323
  setline(323);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply1446(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1448 == NULL) {
    strlit1448 = alloc_String("    ");
    gc_root(strlit1448);
  }
// compilenode returning strlit1448
  int op_slot_right_1447 = gc_frame_newslot(strlit1448);
// compilenode returning *var_spc
  int op_slot_left_1447 = gc_frame_newslot(*var_spc);
  params[0] = strlit1448;
  partcv[0] = 1;
  Object opresult1450 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult1450
  *var_spc = opresult1450;
  if (opresult1450 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1471(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_case = &(stackframe->slots[0]);
  *var_case = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 332
  setline(332);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1473 = gc_frame_new();
  Object num1475 = alloc_Float64(2);
// compilenode returning num1475
  int op_slot_right_1474 = gc_frame_newslot(num1475);
// compilenode returning *var_depth
  int op_slot_left_1474 = gc_frame_newslot(*var_depth);
  params[0] = num1475;
  partcv[0] = 1;
  Object sum1477 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1477
  gc_frame_newslot(sum1477);
// compilenode returning *var_case
  params[0] = sum1477;
  partcv[0] = 1;
  Object call1478 = callmethod(*var_case, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1473);
// compilenode returning call1478
  int op_slot_right_1472 = gc_frame_newslot(call1478);
  if (strlit1481 == NULL) {
    strlit1481 = alloc_String("case ");
    gc_root(strlit1481);
  }
// compilenode returning strlit1481
  int op_slot_right_1480 = gc_frame_newslot(strlit1481);
  if (strlit1484 == NULL) {
    strlit1484 = alloc_String("    ");
    gc_root(strlit1484);
  }
// compilenode returning strlit1484
  int op_slot_right_1483 = gc_frame_newslot(strlit1484);
// compilenode returning *var_spc
  int op_slot_right_1486 = gc_frame_newslot(*var_spc);
  if (strlit1489 == NULL) {
    strlit1489 = alloc_String("""\x0a""");
    gc_root(strlit1489);
  }
// compilenode returning strlit1489
  int op_slot_right_1488 = gc_frame_newslot(strlit1489);
// compilenode returning *var_s
  int op_slot_left_1488 = gc_frame_newslot(*var_s);
  params[0] = strlit1489;
  partcv[0] = 1;
  Object opresult1491 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1491
  int op_slot_left_1486 = gc_frame_newslot(opresult1491);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1492 = callmethod(opresult1491, "++", 1, partcv, params);
// compilenode returning opresult1492
  int op_slot_left_1483 = gc_frame_newslot(opresult1492);
  params[0] = strlit1484;
  partcv[0] = 1;
  Object opresult1493 = callmethod(opresult1492, "++", 1, partcv, params);
// compilenode returning opresult1493
  int op_slot_left_1480 = gc_frame_newslot(opresult1493);
  params[0] = strlit1481;
  partcv[0] = 1;
  Object opresult1494 = callmethod(opresult1493, "++", 1, partcv, params);
// compilenode returning opresult1494
  int op_slot_left_1472 = gc_frame_newslot(opresult1494);
  params[0] = call1478;
  partcv[0] = 1;
  Object opresult1495 = callmethod(opresult1494, "++", 1, partcv, params);
// compilenode returning opresult1495
  *var_s = opresult1495;
  if (opresult1495 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace1434(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 326
  setline(326);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1435 == NULL) {
    strlit1435 = alloc_String("");
    gc_root(strlit1435);
  }
// compilenode returning strlit1435
  *var_spc = strlit1435;
  if (strlit1435 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1436 = gc_frame_new();
  Object num1439 = alloc_Float64(1);
// compilenode returning num1439
  int op_slot_right_1438 = gc_frame_newslot(num1439);
// compilenode returning *var_depth
  int op_slot_left_1438 = gc_frame_newslot(*var_depth);
  params[0] = num1439;
  partcv[0] = 1;
  Object diff1441 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff1441
  int op_slot_right_1437 = gc_frame_newslot(diff1441);
  Object num1443 = alloc_Float64(0);
// compilenode returning num1443
  int op_slot_left_1437 = gc_frame_newslot(num1443);
  params[0] = diff1441;
  partcv[0] = 1;
  Object opresult1444 = callmethod(num1443, "..", 1, partcv, params);
// compilenode returning opresult1444
  gc_frame_newslot(opresult1444);
  Object block1445 = alloc_Block(NULL, NULL, "ast", 327);
  gc_frame_newslot(block1445);
  block_savedest(block1445);
  Object closure1446 = createclosure(2, "_apply");
setclosureframe(closure1446, stackframe);
  addtoclosure(closure1446, var_spc);
  addtoclosure(closure1446, selfslot);
  struct UserObject *uo1446 = (struct UserObject*)block1445;
  uo1446->data[0] = (Object)closure1446;
  Method *meth_meth_ast__apply1446 = addmethod2pos(block1445, "_apply", &meth_ast__apply1446, 0);
int argcv_meth_ast__apply1446[] = {1};
meth_meth_ast__apply1446->type = alloc_MethodType(1, argcv_meth_ast__apply1446);
  meth_meth_ast__apply1446->definitionModule = modulename;
  meth_meth_ast__apply1446->definitionLine = 321;
// compilenode returning block1445
  gc_frame_newslot(block1445);
  params[0] = opresult1444;
  params[1] = block1445;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1453 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1436);
// compilenode returning call1453
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 330
  setline(330);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1455 == NULL) {
    strlit1455 = alloc_String(" ");
    gc_root(strlit1455);
  }
// compilenode returning strlit1455
  int op_slot_right_1454 = gc_frame_newslot(strlit1455);
  int callframe1458 = gc_frame_new();
  Object num1459 = alloc_Float64(0);
// compilenode returning num1459
  gc_frame_newslot(num1459);
  int callframe1460 = gc_frame_new();
  partcv[0] = 0;
  Object call1461 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1460);
// compilenode returning call1461
// compilenode returning call1461
  params[0] = num1459;
  partcv[0] = 1;
  Object call1462 = callmethod(call1461, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1458);
// compilenode returning call1462
  int op_slot_right_1457 = gc_frame_newslot(call1462);
  if (strlit1464 == NULL) {
    strlit1464 = alloc_String("catch ");
    gc_root(strlit1464);
  }
// compilenode returning strlit1464
  int op_slot_left_1457 = gc_frame_newslot(strlit1464);
  params[0] = call1462;
  partcv[0] = 1;
  Object opresult1465 = callmethod(strlit1464, "++", 1, partcv, params);
// compilenode returning opresult1465
  int op_slot_left_1454 = gc_frame_newslot(opresult1465);
  params[0] = strlit1455;
  partcv[0] = 1;
  Object opresult1466 = callmethod(opresult1465, "++", 1, partcv, params);
// compilenode returning opresult1466
  *var_s = opresult1466;
  if (opresult1466 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1467 = gc_frame_new();
  int callframe1468 = gc_frame_new();
  partcv[0] = 0;
  Object call1469 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1468);
// compilenode returning call1469
// compilenode returning call1469
  gc_frame_newslot(call1469);
  Object block1470 = alloc_Block(NULL, NULL, "ast", 331);
  gc_frame_newslot(block1470);
  block_savedest(block1470);
  Object closure1471 = createclosure(4, "_apply");
setclosureframe(closure1471, stackframe);
  addtoclosure(closure1471, var_depth);
  addtoclosure(closure1471, var_spc);
  addtoclosure(closure1471, var_s);
  addtoclosure(closure1471, selfslot);
  struct UserObject *uo1471 = (struct UserObject*)block1470;
  uo1471->data[0] = (Object)closure1471;
  Method *meth_meth_ast__apply1471 = addmethod2pos(block1470, "_apply", &meth_ast__apply1471, 0);
int argcv_meth_ast__apply1471[] = {1};
meth_meth_ast__apply1471->type = alloc_MethodType(1, argcv_meth_ast__apply1471);
  meth_meth_ast__apply1471->definitionModule = modulename;
  meth_meth_ast__apply1471->definitionLine = 331;
// compilenode returning block1470
  gc_frame_newslot(block1470);
  params[0] = call1469;
  params[1] = block1470;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1498 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1467);
// compilenode returning call1498
// Begin line 337
  setline(337);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1501 = alloc_Boolean(0);
// compilenode returning bool1501
  int op_slot_right_1500 = gc_frame_newslot(bool1501);
  int callframe1503 = gc_frame_new();
  partcv[0] = 0;
  Object call1504 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1503);
// compilenode returning call1504
// compilenode returning call1504
  int op_slot_left_1500 = gc_frame_newslot(call1504);
  params[0] = bool1501;
  partcv[0] = 1;
  Object opresult1505 = callmethod(call1504, "!=", 1, partcv, params);
// compilenode returning opresult1505
  Object if1499 = done;
  if (istrue(opresult1505)) {
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1507 = gc_frame_new();
  Object num1509 = alloc_Float64(2);
// compilenode returning num1509
  int op_slot_right_1508 = gc_frame_newslot(num1509);
// compilenode returning *var_depth
  int op_slot_left_1508 = gc_frame_newslot(*var_depth);
  params[0] = num1509;
  partcv[0] = 1;
  Object sum1511 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1511
  gc_frame_newslot(sum1511);
  int callframe1512 = gc_frame_new();
  partcv[0] = 0;
  Object call1513 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1512);
// compilenode returning call1513
// compilenode returning call1513
  params[0] = sum1511;
  partcv[0] = 1;
  Object call1514 = callmethod(call1513, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1507);
// compilenode returning call1514
  int op_slot_right_1506 = gc_frame_newslot(call1514);
  if (strlit1517 == NULL) {
    strlit1517 = alloc_String("finally ");
    gc_root(strlit1517);
  }
// compilenode returning strlit1517
  int op_slot_right_1516 = gc_frame_newslot(strlit1517);
  if (strlit1520 == NULL) {
    strlit1520 = alloc_String("    ");
    gc_root(strlit1520);
  }
// compilenode returning strlit1520
  int op_slot_right_1519 = gc_frame_newslot(strlit1520);
// compilenode returning *var_spc
  int op_slot_right_1522 = gc_frame_newslot(*var_spc);
  if (strlit1525 == NULL) {
    strlit1525 = alloc_String("""\x0a""");
    gc_root(strlit1525);
  }
// compilenode returning strlit1525
  int op_slot_right_1524 = gc_frame_newslot(strlit1525);
// compilenode returning *var_s
  int op_slot_left_1524 = gc_frame_newslot(*var_s);
  params[0] = strlit1525;
  partcv[0] = 1;
  Object opresult1527 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1527
  int op_slot_left_1522 = gc_frame_newslot(opresult1527);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1528 = callmethod(opresult1527, "++", 1, partcv, params);
// compilenode returning opresult1528
  int op_slot_left_1519 = gc_frame_newslot(opresult1528);
  params[0] = strlit1520;
  partcv[0] = 1;
  Object opresult1529 = callmethod(opresult1528, "++", 1, partcv, params);
// compilenode returning opresult1529
  int op_slot_left_1516 = gc_frame_newslot(opresult1529);
  params[0] = strlit1517;
  partcv[0] = 1;
  Object opresult1530 = callmethod(opresult1529, "++", 1, partcv, params);
// compilenode returning opresult1530
  int op_slot_left_1506 = gc_frame_newslot(opresult1530);
  params[0] = call1514;
  partcv[0] = 1;
  Object opresult1531 = callmethod(opresult1530, "++", 1, partcv, params);
// compilenode returning opresult1531
  *var_s = opresult1531;
  if (opresult1531 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1499 = done;
  } else {
  }
// compilenode returning if1499
// Begin line 337
  setline(337);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new1249(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_catchCaseNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block = &(stackframe->slots[0]);
  *var_block = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_finally_39_ = &(stackframe->slots[2]);
  *var_finally_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1250 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1250 = alloc_userobj2(10,11, objclass1250);
  gc_frame_newslot(obj1250);
if (objclass1250 == NULL) {
  glfree(obj1250->class->name);
  obj1250->class->name = "catchCaseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1250, self, 0);
  addmethodreal(obj1250,"outer", &reader_ast_outer_1251);
  Object oldself1250 = self;
  struct StackFrameObject *oldstackframe1250 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1250);
  gc_frame_newslot((Object)stackframe);
  self = obj1250;
  Object *oldselfslot1250 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1250 = (*(struct UserObject *)self).data[0], lowerouter1250 = thisouter1250;
  if (inheritingObject1250) {
    struct UserObject *inho1250 = (struct UserObject *)inheritingObject1250;
    while (inho1250->super != GraceDefaultObject) inho1250 = (struct UserObject *)inho1250->super;
    inho1250->super = obj1250;
    self = inheritingObject1250;
    *selfslot = self;
    lowerouter1250 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1250;
  }
if (objclass1250 == NULL) {
  Method *reader1252 = addmethodrealflags(obj1250, "kind",&reader_ast_kind_1252, MFLAG_DEF);
  reader1252->definitionModule = modulename;
  reader1252->definitionLine = 285;
}
adddatum2(obj1250, alloc_Undefined(), 1);
if (objclass1250 == NULL) {
  Method *reader1253 = addmethodrealflags(obj1250, "value",&reader_ast_value_1253, MFLAG_DEF);
  reader1253->definitionModule = modulename;
  reader1253->definitionLine = 286;
}
adddatum2(obj1250, alloc_Undefined(), 2);
if (objclass1250 == NULL) {
  Method *reader1254 = addmethodrealflags(obj1250, "cases",&reader_ast_cases_1254, MFLAG_DEF);
  reader1254->definitionModule = modulename;
  reader1254->definitionLine = 287;
}
adddatum2(obj1250, alloc_Undefined(), 3);
if (objclass1250 == NULL) {
  Method *reader1255 = addmethodrealflags(obj1250, "finally",&reader_ast_finally_1255, MFLAG_DEF);
  reader1255->definitionModule = modulename;
  reader1255->definitionLine = 288;
}
adddatum2(obj1250, alloc_Undefined(), 4);
  struct UserObject *uo1256 = (struct UserObject*)obj1250;
  uo1256->data[5] = emptyclosure;
  Method *meth_meth_ast_accept1256 = addmethod2pos(obj1250, "accept", &meth_ast_accept1256, 5);
int argcv_meth_ast_accept1256[] = {1};
meth_meth_ast_accept1256->type = alloc_MethodType(1, argcv_meth_ast_accept1256);
meth_meth_ast_accept1256->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept1256->type->names[0] = "visitor";
  meth_meth_ast_accept1256->definitionModule = modulename;
  meth_meth_ast_accept1256->definitionLine = 288;
  block_savedest(obj1250);
  Object closure1284 = createclosure(1, "map()before()after");
setclosureframe(closure1284, stackframe);
  addtoclosure(closure1284, var_catchCaseNode);
  struct UserObject *uo1284 = (struct UserObject*)obj1250;
  uo1284->data[6] = (Object)closure1284;
  Method *meth_meth_ast_map_40__41_before_40__41_after1284 = addmethod2pos(obj1250, "map()before()after", &meth_ast_map_40__41_before_40__41_after1284, 6);
int argcv_meth_ast_map_40__41_before_40__41_after1284[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after1284->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after1284);
  meth_meth_ast_map_40__41_before_40__41_after1284->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after1284->definitionLine = 299;
  struct UserObject *uo1313 = (struct UserObject*)obj1250;
  uo1313->data[7] = emptyclosure;
  Method *meth_meth_ast_map1313 = addmethod2pos(obj1250, "map", &meth_ast_map1313, 7);
int argcv_meth_ast_map1313[] = {1};
meth_meth_ast_map1313->type = alloc_MethodType(1, argcv_meth_ast_map1313);
  meth_meth_ast_map1313->definitionModule = modulename;
  meth_meth_ast_map1313->definitionLine = 307;
  struct UserObject *uo1322 = (struct UserObject*)obj1250;
  uo1322->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty1322 = addmethod2pos(obj1250, "pretty", &meth_ast_pretty1322, 8);
int argcv_meth_ast_pretty1322[] = {1};
meth_meth_ast_pretty1322->type = alloc_MethodType(1, argcv_meth_ast_pretty1322);
  meth_meth_ast_pretty1322->definitionModule = modulename;
  meth_meth_ast_pretty1322->definitionLine = 310;
  struct UserObject *uo1434 = (struct UserObject*)obj1250;
  uo1434->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace1434 = addmethod2pos(obj1250, "toGrace", &meth_ast_toGrace1434, 9);
int argcv_meth_ast_toGrace1434[] = {1};
meth_meth_ast_toGrace1434->type = alloc_MethodType(1, argcv_meth_ast_toGrace1434);
meth_meth_ast_toGrace1434->type->types[0] = type_Number;
meth_meth_ast_toGrace1434->type->names[0] = "depth";
  meth_meth_ast_toGrace1434->definitionModule = modulename;
  meth_meth_ast_toGrace1434->definitionLine = 325;
  sourceObject = obj1250;
// Begin line 283
  setline(283);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1533 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1534 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe1533);
// compilenode returning call1534
  struct UserObject *obj1250_uo = (struct UserObject *)obj1250;
  obj1250_uo->super = call1534;
  sourceObject = obj1250;
// Begin line 284
  setline(284);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1535 == NULL) {
    strlit1535 = alloc_String("catchcase");
    gc_root(strlit1535);
  }
// compilenode returning strlit1535
  adddatum2(obj1250, strlit1535, 1);
  sourceObject = obj1250;
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_block
  adddatum2(obj1250, *var_block, 2);
  sourceObject = obj1250;
// Begin line 286
  setline(286);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_cases_39_
  adddatum2(obj1250, *var_cases_39_, 3);
  sourceObject = obj1250;
// Begin line 287
  setline(287);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_finally_39_
  adddatum2(obj1250, *var_finally_39_, 4);
  sourceObject = obj1250;
  sourceObject = obj1250;
  sourceObject = obj1250;
  sourceObject = obj1250;
  sourceObject = obj1250;
objclass1250 = obj1250->class;
  objclass1250->definitionModule = modulename;
  objclass1250->definitionLine = 275;
  (*(struct UserObject *)self).data[0] = lowerouter1250;
  self = oldself1250;
  selfslot = oldselfslot1250;
  stackframe = oldstackframe1250;
  gc_frame_end(frame);
  return obj1250;
}
Object meth_ast_new1249_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_catchCaseNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block = &(stackframe->slots[0]);
  *var_block = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_finally_39_ = &(stackframe->slots[2]);
  *var_finally_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1250 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1250 = alloc_userobj2(10,11, objclass1250);
  gc_frame_newslot(obj1250);
if (objclass1250 == NULL) {
  glfree(obj1250->class->name);
  obj1250->class->name = "catchCaseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1250, self, 0);
  addmethodreal(obj1250,"outer", &reader_ast_outer_1251);
  Object oldself1250 = self;
  struct StackFrameObject *oldstackframe1250 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1250);
  gc_frame_newslot((Object)stackframe);
  self = obj1250;
  Object *oldselfslot1250 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1250 = (*(struct UserObject *)self).data[0], lowerouter1250 = thisouter1250;
  if (inheritingObject1250) {
    struct UserObject *inho1250 = (struct UserObject *)inheritingObject1250;
    while (inho1250->super != GraceDefaultObject) inho1250 = (struct UserObject *)inho1250->super;
    inho1250->super = obj1250;
    self = inheritingObject1250;
    *selfslot = self;
    lowerouter1250 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1250;
  }
if (objclass1250 == NULL) {
  Method *reader1252 = addmethodrealflags(obj1250, "kind",&reader_ast_kind_1252, MFLAG_DEF);
  reader1252->definitionModule = modulename;
  reader1252->definitionLine = 285;
}
adddatum2(obj1250, alloc_Undefined(), 1);
if (objclass1250 == NULL) {
  Method *reader1253 = addmethodrealflags(obj1250, "value",&reader_ast_value_1253, MFLAG_DEF);
  reader1253->definitionModule = modulename;
  reader1253->definitionLine = 286;
}
adddatum2(obj1250, alloc_Undefined(), 2);
if (objclass1250 == NULL) {
  Method *reader1254 = addmethodrealflags(obj1250, "cases",&reader_ast_cases_1254, MFLAG_DEF);
  reader1254->definitionModule = modulename;
  reader1254->definitionLine = 287;
}
adddatum2(obj1250, alloc_Undefined(), 3);
if (objclass1250 == NULL) {
  Method *reader1255 = addmethodrealflags(obj1250, "finally",&reader_ast_finally_1255, MFLAG_DEF);
  reader1255->definitionModule = modulename;
  reader1255->definitionLine = 288;
}
adddatum2(obj1250, alloc_Undefined(), 4);
  struct UserObject *uo1256 = (struct UserObject*)obj1250;
  uo1256->data[5] = emptyclosure;
  Method *meth_meth_ast_accept1256 = addmethod2pos(obj1250, "accept", &meth_ast_accept1256, 5);
int argcv_meth_ast_accept1256[] = {1};
meth_meth_ast_accept1256->type = alloc_MethodType(1, argcv_meth_ast_accept1256);
meth_meth_ast_accept1256->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept1256->type->names[0] = "visitor";
  meth_meth_ast_accept1256->definitionModule = modulename;
  meth_meth_ast_accept1256->definitionLine = 288;
  block_savedest(obj1250);
  Object closure1284 = createclosure(1, "map()before()after");
setclosureframe(closure1284, stackframe);
  addtoclosure(closure1284, var_catchCaseNode);
  struct UserObject *uo1284 = (struct UserObject*)obj1250;
  uo1284->data[6] = (Object)closure1284;
  Method *meth_meth_ast_map_40__41_before_40__41_after1284 = addmethod2pos(obj1250, "map()before()after", &meth_ast_map_40__41_before_40__41_after1284, 6);
int argcv_meth_ast_map_40__41_before_40__41_after1284[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after1284->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after1284);
  meth_meth_ast_map_40__41_before_40__41_after1284->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after1284->definitionLine = 299;
  struct UserObject *uo1313 = (struct UserObject*)obj1250;
  uo1313->data[7] = emptyclosure;
  Method *meth_meth_ast_map1313 = addmethod2pos(obj1250, "map", &meth_ast_map1313, 7);
int argcv_meth_ast_map1313[] = {1};
meth_meth_ast_map1313->type = alloc_MethodType(1, argcv_meth_ast_map1313);
  meth_meth_ast_map1313->definitionModule = modulename;
  meth_meth_ast_map1313->definitionLine = 307;
  struct UserObject *uo1322 = (struct UserObject*)obj1250;
  uo1322->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty1322 = addmethod2pos(obj1250, "pretty", &meth_ast_pretty1322, 8);
int argcv_meth_ast_pretty1322[] = {1};
meth_meth_ast_pretty1322->type = alloc_MethodType(1, argcv_meth_ast_pretty1322);
  meth_meth_ast_pretty1322->definitionModule = modulename;
  meth_meth_ast_pretty1322->definitionLine = 310;
  struct UserObject *uo1434 = (struct UserObject*)obj1250;
  uo1434->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace1434 = addmethod2pos(obj1250, "toGrace", &meth_ast_toGrace1434, 9);
int argcv_meth_ast_toGrace1434[] = {1};
meth_meth_ast_toGrace1434->type = alloc_MethodType(1, argcv_meth_ast_toGrace1434);
meth_meth_ast_toGrace1434->type->types[0] = type_Number;
meth_meth_ast_toGrace1434->type->names[0] = "depth";
  meth_meth_ast_toGrace1434->definitionModule = modulename;
  meth_meth_ast_toGrace1434->definitionLine = 325;
  sourceObject = obj1250;
// Begin line 283
  setline(283);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1533 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1534 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe1533);
// compilenode returning call1534
  struct UserObject *obj1250_uo = (struct UserObject *)obj1250;
  obj1250_uo->super = call1534;
  sourceObject = obj1250;
// Begin line 284
  setline(284);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1535 == NULL) {
    strlit1535 = alloc_String("catchcase");
    gc_root(strlit1535);
  }
// compilenode returning strlit1535
  adddatum2(obj1250, strlit1535, 1);
  sourceObject = obj1250;
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_block
  adddatum2(obj1250, *var_block, 2);
  sourceObject = obj1250;
// Begin line 286
  setline(286);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_cases_39_
  adddatum2(obj1250, *var_cases_39_, 3);
  sourceObject = obj1250;
// Begin line 287
  setline(287);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_finally_39_
  adddatum2(obj1250, *var_finally_39_, 4);
  sourceObject = obj1250;
  sourceObject = obj1250;
  sourceObject = obj1250;
  sourceObject = obj1250;
  sourceObject = obj1250;
objclass1250 = obj1250->class;
  objclass1250->definitionModule = modulename;
  objclass1250->definitionLine = 275;
  (*(struct UserObject *)self).data[0] = lowerouter1250;
  self = oldself1250;
  selfslot = oldselfslot1250;
  stackframe = oldstackframe1250;
  gc_frame_end(frame);
  return obj1250;
}
Object meth_ast_matchCaseNode1537(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "matchCaseNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_matchCaseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for matchCaseNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for matchCaseNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 340
  setline(340);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_matchCaseNode
  gc_frame_end(frame);
  return *var_matchCaseNode;
}
Object meth_ast__apply1559(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1560 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_mx
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call1561 = callmethod(*var_mx, "accept",
    1, partcv, params);
  gc_frame_end(callframe1560);
// compilenode returning call1561
  gc_frame_end(frame);
  return call1561;
}
Object meth_ast_accept1547(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 356
  setline(356);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1549 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call1550 = callmethod(*var_visitor, "visitMatchCase",
    1, partcv, params);
  gc_frame_end(callframe1549);
// compilenode returning call1550
  Object if1548 = done;
  if (istrue(call1550)) {
// Begin line 348
  setline(348);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1551 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe1552 = gc_frame_new();
  partcv[0] = 0;
  Object call1553 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1552);
// compilenode returning call1553
// compilenode returning call1553
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call1554 = callmethod(call1553, "accept",
    1, partcv, params);
  gc_frame_end(callframe1551);
// compilenode returning call1554
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1555 = gc_frame_new();
  int callframe1556 = gc_frame_new();
  partcv[0] = 0;
  Object call1557 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1556);
// compilenode returning call1557
// compilenode returning call1557
  gc_frame_newslot(call1557);
  Object block1558 = alloc_Block(NULL, NULL, "ast", 349);
  gc_frame_newslot(block1558);
  block_savedest(block1558);
  Object closure1559 = createclosure(2, "_apply");
setclosureframe(closure1559, stackframe);
  addtoclosure(closure1559, var_visitor);
  addtoclosure(closure1559, selfslot);
  struct UserObject *uo1559 = (struct UserObject*)block1558;
  uo1559->data[0] = (Object)closure1559;
  Method *meth_meth_ast__apply1559 = addmethod2pos(block1558, "_apply", &meth_ast__apply1559, 0);
int argcv_meth_ast__apply1559[] = {1};
meth_meth_ast__apply1559->type = alloc_MethodType(1, argcv_meth_ast__apply1559);
  meth_meth_ast__apply1559->definitionModule = modulename;
  meth_meth_ast__apply1559->definitionLine = 349;
// compilenode returning block1558
  gc_frame_newslot(block1558);
  params[0] = call1557;
  params[1] = block1558;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1563 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1555);
// compilenode returning call1563
// Begin line 355
  setline(355);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1566 = alloc_Boolean(0);
// compilenode returning bool1566
  int op_slot_right_1565 = gc_frame_newslot(bool1566);
  int callframe1568 = gc_frame_new();
  partcv[0] = 0;
  Object call1569 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1568);
// compilenode returning call1569
// compilenode returning call1569
  int op_slot_left_1565 = gc_frame_newslot(call1569);
  params[0] = bool1566;
  partcv[0] = 1;
  Object opresult1570 = callmethod(call1569, "!=", 1, partcv, params);
// compilenode returning opresult1570
  Object if1564 = done;
  if (istrue(opresult1570)) {
// Begin line 353
  setline(353);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1571 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe1572 = gc_frame_new();
  partcv[0] = 0;
  Object call1573 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1572);
// compilenode returning call1573
// compilenode returning call1573
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call1574 = callmethod(call1573, "accept",
    1, partcv, params);
  gc_frame_end(callframe1571);
// compilenode returning call1574
    gc_frame_newslot(call1574);
    if1564 = call1574;
  } else {
  }
// compilenode returning if1564
    gc_frame_newslot(if1564);
    if1548 = if1564;
  } else {
  }
// compilenode returning if1548
  gc_frame_end(frame);
  return if1548;
}
Object meth_ast_map_40__41_before_40__41_after1575(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_matchCaseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newcases = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newcases");
  Object *var_n = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "n");
// Begin line 358
  setline(358);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1576 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call1577 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe1576);
// compilenode returning call1577
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1578 = gc_frame_new();
  int callframe1579 = gc_frame_new();
  partcv[0] = 0;
  Object call1580 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1579);
// compilenode returning call1580
  gc_frame_newslot(call1580);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe1581 = gc_frame_new();
  int callframe1582 = gc_frame_new();
  Object call1583 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1582);
// compilenode returning call1583
// compilenode returning call1583
  partcv[0] = 0;
  Object call1584 = callmethodflags(call1583, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1581);
// compilenode returning call1584
// compilenode returning call1584
  params[0] = call1580;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1585 = callmethodflags(call1584, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1578);
// compilenode returning call1585
  *var_newcases = call1585;
  if (call1585 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1586 = gc_frame_new();
  int callframe1587 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe1588 = gc_frame_new();
  partcv[0] = 0;
  Object call1589 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1588);
// compilenode returning call1589
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1590 = callmethod(call1589, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe1587);
// compilenode returning call1590
  gc_frame_newslot(call1590);
// Begin line 361
  setline(361);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_newcases
  gc_frame_newslot(*var_newcases);
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1591 = gc_frame_new();
  int callframe1592 = gc_frame_new();
  partcv[0] = 0;
  Object call1593 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1592);
// compilenode returning call1593
  gc_frame_newslot(call1593);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe1594 = gc_frame_new();
  int callframe1595 = gc_frame_new();
  Object call1596 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1595);
// compilenode returning call1596
// compilenode returning call1596
  partcv[0] = 0;
  Object call1597 = callmethodflags(call1596, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1594);
// compilenode returning call1597
// compilenode returning call1597
  params[0] = call1593;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 4;
  Object call1598 = callmethodflags(call1597, "maybeMap", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1591);
// compilenode returning call1598
  gc_frame_newslot(call1598);
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_matchCaseNode
  params[0] = call1590;
  params[1] = *var_newcases;
  params[2] = call1598;
  partcv[0] = 3;
  Object call1599 = callmethod(*var_matchCaseNode, "new",
    1, partcv, params);
  gc_frame_end(callframe1586);
// compilenode returning call1599
  *var_n = call1599;
  if (call1599 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1600 = gc_frame_new();
// Begin line 363
  setline(363);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1601 = gc_frame_new();
  partcv[0] = 0;
  Object call1602 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1601);
// compilenode returning call1602
  gc_frame_newslot(call1602);
// compilenode returning *var_n
  params[0] = call1602;
  partcv[0] = 1;
  Object call1603 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe1600);
// compilenode returning call1603
// compilenode returning done
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1604 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1605 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe1604);
// compilenode returning call1605
// Begin line 365
  setline(365);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply1609(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1612(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map1606(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 368
  setline(368);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1607 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block1608 = alloc_Block(NULL, NULL, "ast", 368);
  gc_frame_newslot(block1608);
  block_savedest(block1608);
  Object closure1609 = createclosure(1, "_apply");
setclosureframe(closure1609, stackframe);
  addtoclosure(closure1609, selfslot);
  struct UserObject *uo1609 = (struct UserObject*)block1608;
  uo1609->data[0] = (Object)closure1609;
  Method *meth_meth_ast__apply1609 = addmethod2pos(block1608, "_apply", &meth_ast__apply1609, 0);
int argcv_meth_ast__apply1609[] = {0};
meth_meth_ast__apply1609->type = alloc_MethodType(1, argcv_meth_ast__apply1609);
  meth_meth_ast__apply1609->definitionModule = modulename;
  meth_meth_ast__apply1609->definitionLine = 362;
// compilenode returning block1608
  gc_frame_newslot(block1608);
  Object block1611 = alloc_Block(NULL, NULL, "ast", 368);
  gc_frame_newslot(block1611);
  block_savedest(block1611);
  Object closure1612 = createclosure(1, "_apply");
setclosureframe(closure1612, stackframe);
  addtoclosure(closure1612, selfslot);
  struct UserObject *uo1612 = (struct UserObject*)block1611;
  uo1612->data[0] = (Object)closure1612;
  Method *meth_meth_ast__apply1612 = addmethod2pos(block1611, "_apply", &meth_ast__apply1612, 0);
int argcv_meth_ast__apply1612[] = {0};
meth_meth_ast__apply1612->type = alloc_MethodType(1, argcv_meth_ast__apply1612);
  meth_meth_ast__apply1612->definitionModule = modulename;
  meth_meth_ast__apply1612->definitionLine = 362;
// compilenode returning block1611
  gc_frame_newslot(block1611);
  params[0] = *var_blk;
  params[1] = block1608;
  params[2] = block1611;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1614 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1607);
// compilenode returning call1614
  gc_frame_end(frame);
  return call1614;
}
Object meth_ast__apply1623(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 373
  setline(373);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1625 == NULL) {
    strlit1625 = alloc_String("  ");
    gc_root(strlit1625);
  }
// compilenode returning strlit1625
  int op_slot_right_1624 = gc_frame_newslot(strlit1625);
// compilenode returning *var_spc
  int op_slot_left_1624 = gc_frame_newslot(*var_spc);
  params[0] = strlit1625;
  partcv[0] = 1;
  Object opresult1627 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult1627
  *var_spc = opresult1627;
  if (opresult1627 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1649(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1652 == NULL) {
    strlit1652 = alloc_String("");
    gc_root(strlit1652);
  }
// compilenode returning strlit1652
  int op_slot_right_1651 = gc_frame_newslot(strlit1652);
  int callframe1655 = gc_frame_new();
  Object num1657 = alloc_Float64(2);
// compilenode returning num1657
  int op_slot_right_1656 = gc_frame_newslot(num1657);
// compilenode returning *var_depth
  int op_slot_left_1656 = gc_frame_newslot(*var_depth);
  params[0] = num1657;
  partcv[0] = 1;
  Object sum1659 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1659
  gc_frame_newslot(sum1659);
// compilenode returning *var_mx
  params[0] = sum1659;
  partcv[0] = 1;
  Object call1660 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1655);
// compilenode returning call1660
  int op_slot_right_1654 = gc_frame_newslot(call1660);
  if (strlit1663 == NULL) {
    strlit1663 = alloc_String("  ");
    gc_root(strlit1663);
  }
// compilenode returning strlit1663
  int op_slot_right_1662 = gc_frame_newslot(strlit1663);
// compilenode returning *var_spc
  int op_slot_right_1665 = gc_frame_newslot(*var_spc);
  if (strlit1668 == NULL) {
    strlit1668 = alloc_String("Case:""\x0a""");
    gc_root(strlit1668);
  }
// compilenode returning strlit1668
  int op_slot_right_1667 = gc_frame_newslot(strlit1668);
// compilenode returning *var_spc
  int op_slot_right_1670 = gc_frame_newslot(*var_spc);
  if (strlit1672 == NULL) {
    strlit1672 = alloc_String("""\x0a""");
    gc_root(strlit1672);
  }
// compilenode returning strlit1672
  int op_slot_left_1670 = gc_frame_newslot(strlit1672);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1673 = callmethod(strlit1672, "++", 1, partcv, params);
// compilenode returning opresult1673
  int op_slot_left_1667 = gc_frame_newslot(opresult1673);
  params[0] = strlit1668;
  partcv[0] = 1;
  Object opresult1674 = callmethod(opresult1673, "++", 1, partcv, params);
// compilenode returning opresult1674
  int op_slot_left_1665 = gc_frame_newslot(opresult1674);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1675 = callmethod(opresult1674, "++", 1, partcv, params);
// compilenode returning opresult1675
  int op_slot_left_1662 = gc_frame_newslot(opresult1675);
  params[0] = strlit1663;
  partcv[0] = 1;
  Object opresult1676 = callmethod(opresult1675, "++", 1, partcv, params);
// compilenode returning opresult1676
  int op_slot_left_1654 = gc_frame_newslot(opresult1676);
  params[0] = call1660;
  partcv[0] = 1;
  Object opresult1677 = callmethod(opresult1676, "++", 1, partcv, params);
// compilenode returning opresult1677
  int op_slot_left_1651 = gc_frame_newslot(opresult1677);
  params[0] = strlit1652;
  partcv[0] = 1;
  Object opresult1678 = callmethod(opresult1677, "++", 1, partcv, params);
// compilenode returning opresult1678
  int op_slot_right_1650 = gc_frame_newslot(opresult1678);
// compilenode returning *var_s
  int op_slot_left_1650 = gc_frame_newslot(*var_s);
  params[0] = opresult1678;
  partcv[0] = 1;
  Object opresult1680 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1680
  *var_s = opresult1680;
  if (opresult1680 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty1615(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_matchee = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 372
  setline(372);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 371
  setline(371);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1616 == NULL) {
    strlit1616 = alloc_String("");
    gc_root(strlit1616);
  }
// compilenode returning strlit1616
  *var_spc = strlit1616;
  if (strlit1616 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 372
  setline(372);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1617 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_1618 = gc_frame_newslot(*var_depth);
  Object num1620 = alloc_Float64(0);
// compilenode returning num1620
  int op_slot_left_1618 = gc_frame_newslot(num1620);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult1621 = callmethod(num1620, "..", 1, partcv, params);
// compilenode returning opresult1621
  gc_frame_newslot(opresult1621);
  Object block1622 = alloc_Block(NULL, NULL, "ast", 372);
  gc_frame_newslot(block1622);
  block_savedest(block1622);
  Object closure1623 = createclosure(2, "_apply");
setclosureframe(closure1623, stackframe);
  addtoclosure(closure1623, var_spc);
  addtoclosure(closure1623, selfslot);
  struct UserObject *uo1623 = (struct UserObject*)block1622;
  uo1623->data[0] = (Object)closure1623;
  Method *meth_meth_ast__apply1623 = addmethod2pos(block1622, "_apply", &meth_ast__apply1623, 0);
int argcv_meth_ast__apply1623[] = {1};
meth_meth_ast__apply1623->type = alloc_MethodType(1, argcv_meth_ast__apply1623);
  meth_meth_ast__apply1623->definitionModule = modulename;
  meth_meth_ast__apply1623->definitionLine = 362;
// compilenode returning block1622
  gc_frame_newslot(block1622);
  params[0] = opresult1621;
  params[1] = block1622;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1630 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1617);
// compilenode returning call1630
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 375
  setline(375);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1631 == NULL) {
    strlit1631 = alloc_String("Match""\x0a""");
    gc_root(strlit1631);
  }
// compilenode returning strlit1631
  *var_s = strlit1631;
  if (strlit1631 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1633 = gc_frame_new();
  Object num1635 = alloc_Float64(2);
// compilenode returning num1635
  int op_slot_right_1634 = gc_frame_newslot(num1635);
// compilenode returning *var_depth
  int op_slot_left_1634 = gc_frame_newslot(*var_depth);
  params[0] = num1635;
  partcv[0] = 1;
  Object sum1637 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1637
  gc_frame_newslot(sum1637);
// compilenode returning *var_matchee
  params[0] = sum1637;
  partcv[0] = 1;
  Object call1638 = callmethod(*var_matchee, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1633);
// compilenode returning call1638
  int op_slot_right_1632 = gc_frame_newslot(call1638);
// compilenode returning *var_spc
  int op_slot_right_1640 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_1640 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1642 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1642
  int op_slot_left_1632 = gc_frame_newslot(opresult1642);
  params[0] = call1638;
  partcv[0] = 1;
  Object opresult1643 = callmethod(opresult1642, "++", 1, partcv, params);
// compilenode returning opresult1643
  *var_s = opresult1643;
  if (opresult1643 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 377
  setline(377);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1645 = gc_frame_new();
  int callframe1646 = gc_frame_new();
  partcv[0] = 0;
  Object call1647 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1646);
// compilenode returning call1647
// compilenode returning call1647
  gc_frame_newslot(call1647);
  Object block1648 = alloc_Block(NULL, NULL, "ast", 377);
  gc_frame_newslot(block1648);
  block_savedest(block1648);
  Object closure1649 = createclosure(4, "_apply");
setclosureframe(closure1649, stackframe);
  addtoclosure(closure1649, var_depth);
  addtoclosure(closure1649, var_spc);
  addtoclosure(closure1649, var_s);
  addtoclosure(closure1649, selfslot);
  struct UserObject *uo1649 = (struct UserObject*)block1648;
  uo1649->data[0] = (Object)closure1649;
  Method *meth_meth_ast__apply1649 = addmethod2pos(block1648, "_apply", &meth_ast__apply1649, 0);
int argcv_meth_ast__apply1649[] = {1};
meth_meth_ast__apply1649->type = alloc_MethodType(1, argcv_meth_ast__apply1649);
  meth_meth_ast__apply1649->definitionModule = modulename;
  meth_meth_ast__apply1649->definitionLine = 377;
// compilenode returning block1648
  gc_frame_newslot(block1648);
  params[0] = call1647;
  params[1] = block1648;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1683 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1645);
// compilenode returning call1683
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1686 = gc_frame_new();
  partcv[0] = 0;
  Object call1687 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1686);
// compilenode returning call1687
// compilenode returning call1687
  int op_slot_right_1685 = gc_frame_newslot(call1687);
  Object bool1689 = alloc_Boolean(0);
// compilenode returning bool1689
  int op_slot_left_1685 = gc_frame_newslot(bool1689);
  params[0] = call1687;
  partcv[0] = 1;
  Object opresult1690 = callmethod(bool1689, "!=", 1, partcv, params);
// compilenode returning opresult1690
  Object if1684 = done;
  if (istrue(opresult1690)) {
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 381
  setline(381);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1693 == NULL) {
    strlit1693 = alloc_String("");
    gc_root(strlit1693);
  }
// compilenode returning strlit1693
  int op_slot_right_1692 = gc_frame_newslot(strlit1693);
  int callframe1696 = gc_frame_new();
  Object num1698 = alloc_Float64(2);
// compilenode returning num1698
  int op_slot_right_1697 = gc_frame_newslot(num1698);
// compilenode returning *var_depth
  int op_slot_left_1697 = gc_frame_newslot(*var_depth);
  params[0] = num1698;
  partcv[0] = 1;
  Object sum1700 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1700
  gc_frame_newslot(sum1700);
  int callframe1701 = gc_frame_new();
  partcv[0] = 0;
  Object call1702 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1701);
// compilenode returning call1702
// compilenode returning call1702
  params[0] = sum1700;
  partcv[0] = 1;
  Object call1703 = callmethod(call1702, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1696);
// compilenode returning call1703
  int op_slot_right_1695 = gc_frame_newslot(call1703);
  if (strlit1706 == NULL) {
    strlit1706 = alloc_String("  ");
    gc_root(strlit1706);
  }
// compilenode returning strlit1706
  int op_slot_right_1705 = gc_frame_newslot(strlit1706);
// compilenode returning *var_spc
  int op_slot_right_1708 = gc_frame_newslot(*var_spc);
  if (strlit1711 == NULL) {
    strlit1711 = alloc_String("Else:""\x0a""");
    gc_root(strlit1711);
  }
// compilenode returning strlit1711
  int op_slot_right_1710 = gc_frame_newslot(strlit1711);
// compilenode returning *var_spc
  int op_slot_right_1713 = gc_frame_newslot(*var_spc);
  if (strlit1715 == NULL) {
    strlit1715 = alloc_String("""\x0a""");
    gc_root(strlit1715);
  }
// compilenode returning strlit1715
  int op_slot_left_1713 = gc_frame_newslot(strlit1715);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1716 = callmethod(strlit1715, "++", 1, partcv, params);
// compilenode returning opresult1716
  int op_slot_left_1710 = gc_frame_newslot(opresult1716);
  params[0] = strlit1711;
  partcv[0] = 1;
  Object opresult1717 = callmethod(opresult1716, "++", 1, partcv, params);
// compilenode returning opresult1717
  int op_slot_left_1708 = gc_frame_newslot(opresult1717);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1718 = callmethod(opresult1717, "++", 1, partcv, params);
// compilenode returning opresult1718
  int op_slot_left_1705 = gc_frame_newslot(opresult1718);
  params[0] = strlit1706;
  partcv[0] = 1;
  Object opresult1719 = callmethod(opresult1718, "++", 1, partcv, params);
// compilenode returning opresult1719
  int op_slot_left_1695 = gc_frame_newslot(opresult1719);
  params[0] = call1703;
  partcv[0] = 1;
  Object opresult1720 = callmethod(opresult1719, "++", 1, partcv, params);
// compilenode returning opresult1720
  int op_slot_left_1692 = gc_frame_newslot(opresult1720);
  params[0] = strlit1693;
  partcv[0] = 1;
  Object opresult1721 = callmethod(opresult1720, "++", 1, partcv, params);
// compilenode returning opresult1721
  int op_slot_right_1691 = gc_frame_newslot(opresult1721);
// compilenode returning *var_s
  int op_slot_left_1691 = gc_frame_newslot(*var_s);
  params[0] = opresult1721;
  partcv[0] = 1;
  Object opresult1723 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1723
  *var_s = opresult1723;
  if (opresult1723 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1684 = done;
  } else {
  }
// compilenode returning if1684
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply1737(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 388
  setline(388);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1739 == NULL) {
    strlit1739 = alloc_String("    ");
    gc_root(strlit1739);
  }
// compilenode returning strlit1739
  int op_slot_right_1738 = gc_frame_newslot(strlit1739);
// compilenode returning *var_spc
  int op_slot_left_1738 = gc_frame_newslot(*var_spc);
  params[0] = strlit1739;
  partcv[0] = 1;
  Object opresult1741 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult1741
  *var_spc = opresult1741;
  if (opresult1741 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1762(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_case = &(stackframe->slots[0]);
  *var_case = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1764 = gc_frame_new();
  Object num1766 = alloc_Float64(2);
// compilenode returning num1766
  int op_slot_right_1765 = gc_frame_newslot(num1766);
// compilenode returning *var_depth
  int op_slot_left_1765 = gc_frame_newslot(*var_depth);
  params[0] = num1766;
  partcv[0] = 1;
  Object sum1768 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1768
  gc_frame_newslot(sum1768);
// compilenode returning *var_case
  params[0] = sum1768;
  partcv[0] = 1;
  Object call1769 = callmethod(*var_case, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1764);
// compilenode returning call1769
  int op_slot_right_1763 = gc_frame_newslot(call1769);
  if (strlit1772 == NULL) {
    strlit1772 = alloc_String("case ");
    gc_root(strlit1772);
  }
// compilenode returning strlit1772
  int op_slot_right_1771 = gc_frame_newslot(strlit1772);
  if (strlit1775 == NULL) {
    strlit1775 = alloc_String("    ");
    gc_root(strlit1775);
  }
// compilenode returning strlit1775
  int op_slot_right_1774 = gc_frame_newslot(strlit1775);
// compilenode returning *var_spc
  int op_slot_right_1777 = gc_frame_newslot(*var_spc);
  if (strlit1780 == NULL) {
    strlit1780 = alloc_String("""\x0a""");
    gc_root(strlit1780);
  }
// compilenode returning strlit1780
  int op_slot_right_1779 = gc_frame_newslot(strlit1780);
// compilenode returning *var_s
  int op_slot_left_1779 = gc_frame_newslot(*var_s);
  params[0] = strlit1780;
  partcv[0] = 1;
  Object opresult1782 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1782
  int op_slot_left_1777 = gc_frame_newslot(opresult1782);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1783 = callmethod(opresult1782, "++", 1, partcv, params);
// compilenode returning opresult1783
  int op_slot_left_1774 = gc_frame_newslot(opresult1783);
  params[0] = strlit1775;
  partcv[0] = 1;
  Object opresult1784 = callmethod(opresult1783, "++", 1, partcv, params);
// compilenode returning opresult1784
  int op_slot_left_1771 = gc_frame_newslot(opresult1784);
  params[0] = strlit1772;
  partcv[0] = 1;
  Object opresult1785 = callmethod(opresult1784, "++", 1, partcv, params);
// compilenode returning opresult1785
  int op_slot_left_1763 = gc_frame_newslot(opresult1785);
  params[0] = call1769;
  partcv[0] = 1;
  Object opresult1786 = callmethod(opresult1785, "++", 1, partcv, params);
// compilenode returning opresult1786
  *var_s = opresult1786;
  if (opresult1786 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace1725(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1726 == NULL) {
    strlit1726 = alloc_String("");
    gc_root(strlit1726);
  }
// compilenode returning strlit1726
  *var_spc = strlit1726;
  if (strlit1726 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1727 = gc_frame_new();
  Object num1730 = alloc_Float64(1);
// compilenode returning num1730
  int op_slot_right_1729 = gc_frame_newslot(num1730);
// compilenode returning *var_depth
  int op_slot_left_1729 = gc_frame_newslot(*var_depth);
  params[0] = num1730;
  partcv[0] = 1;
  Object diff1732 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff1732
  int op_slot_right_1728 = gc_frame_newslot(diff1732);
  Object num1734 = alloc_Float64(0);
// compilenode returning num1734
  int op_slot_left_1728 = gc_frame_newslot(num1734);
  params[0] = diff1732;
  partcv[0] = 1;
  Object opresult1735 = callmethod(num1734, "..", 1, partcv, params);
// compilenode returning opresult1735
  gc_frame_newslot(opresult1735);
  Object block1736 = alloc_Block(NULL, NULL, "ast", 387);
  gc_frame_newslot(block1736);
  block_savedest(block1736);
  Object closure1737 = createclosure(2, "_apply");
setclosureframe(closure1737, stackframe);
  addtoclosure(closure1737, var_spc);
  addtoclosure(closure1737, selfslot);
  struct UserObject *uo1737 = (struct UserObject*)block1736;
  uo1737->data[0] = (Object)closure1737;
  Method *meth_meth_ast__apply1737 = addmethod2pos(block1736, "_apply", &meth_ast__apply1737, 0);
int argcv_meth_ast__apply1737[] = {1};
meth_meth_ast__apply1737->type = alloc_MethodType(1, argcv_meth_ast__apply1737);
  meth_meth_ast__apply1737->definitionModule = modulename;
  meth_meth_ast__apply1737->definitionLine = 381;
// compilenode returning block1736
  gc_frame_newslot(block1736);
  params[0] = opresult1735;
  params[1] = block1736;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1744 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1727);
// compilenode returning call1744
// Begin line 391
  setline(391);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1746 == NULL) {
    strlit1746 = alloc_String(")");
    gc_root(strlit1746);
  }
// compilenode returning strlit1746
  int op_slot_right_1745 = gc_frame_newslot(strlit1746);
  int callframe1749 = gc_frame_new();
  Object num1750 = alloc_Float64(0);
// compilenode returning num1750
  gc_frame_newslot(num1750);
  int callframe1751 = gc_frame_new();
  partcv[0] = 0;
  Object call1752 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1751);
// compilenode returning call1752
// compilenode returning call1752
  params[0] = num1750;
  partcv[0] = 1;
  Object call1753 = callmethod(call1752, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1749);
// compilenode returning call1753
  int op_slot_right_1748 = gc_frame_newslot(call1753);
  if (strlit1755 == NULL) {
    strlit1755 = alloc_String("match(");
    gc_root(strlit1755);
  }
// compilenode returning strlit1755
  int op_slot_left_1748 = gc_frame_newslot(strlit1755);
  params[0] = call1753;
  partcv[0] = 1;
  Object opresult1756 = callmethod(strlit1755, "++", 1, partcv, params);
// compilenode returning opresult1756
  int op_slot_left_1745 = gc_frame_newslot(opresult1756);
  params[0] = strlit1746;
  partcv[0] = 1;
  Object opresult1757 = callmethod(opresult1756, "++", 1, partcv, params);
// compilenode returning opresult1757
  *var_s = opresult1757;
  if (opresult1757 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 391
  setline(391);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1758 = gc_frame_new();
  int callframe1759 = gc_frame_new();
  partcv[0] = 0;
  Object call1760 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1759);
// compilenode returning call1760
// compilenode returning call1760
  gc_frame_newslot(call1760);
  Object block1761 = alloc_Block(NULL, NULL, "ast", 391);
  gc_frame_newslot(block1761);
  block_savedest(block1761);
  Object closure1762 = createclosure(4, "_apply");
setclosureframe(closure1762, stackframe);
  addtoclosure(closure1762, var_depth);
  addtoclosure(closure1762, var_spc);
  addtoclosure(closure1762, var_s);
  addtoclosure(closure1762, selfslot);
  struct UserObject *uo1762 = (struct UserObject*)block1761;
  uo1762->data[0] = (Object)closure1762;
  Method *meth_meth_ast__apply1762 = addmethod2pos(block1761, "_apply", &meth_ast__apply1762, 0);
int argcv_meth_ast__apply1762[] = {1};
meth_meth_ast__apply1762->type = alloc_MethodType(1, argcv_meth_ast__apply1762);
  meth_meth_ast__apply1762->definitionModule = modulename;
  meth_meth_ast__apply1762->definitionLine = 391;
// compilenode returning block1761
  gc_frame_newslot(block1761);
  params[0] = call1760;
  params[1] = block1761;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1789 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1758);
// compilenode returning call1789
// Begin line 397
  setline(397);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1792 = alloc_Boolean(0);
// compilenode returning bool1792
  int op_slot_right_1791 = gc_frame_newslot(bool1792);
  int callframe1794 = gc_frame_new();
  partcv[0] = 0;
  Object call1795 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1794);
// compilenode returning call1795
// compilenode returning call1795
  int op_slot_left_1791 = gc_frame_newslot(call1795);
  params[0] = bool1792;
  partcv[0] = 1;
  Object opresult1796 = callmethod(call1795, "!=", 1, partcv, params);
// compilenode returning opresult1796
  Object if1790 = done;
  if (istrue(opresult1796)) {
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1798 = gc_frame_new();
  Object num1800 = alloc_Float64(2);
// compilenode returning num1800
  int op_slot_right_1799 = gc_frame_newslot(num1800);
// compilenode returning *var_depth
  int op_slot_left_1799 = gc_frame_newslot(*var_depth);
  params[0] = num1800;
  partcv[0] = 1;
  Object sum1802 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1802
  gc_frame_newslot(sum1802);
  int callframe1803 = gc_frame_new();
  partcv[0] = 0;
  Object call1804 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1803);
// compilenode returning call1804
// compilenode returning call1804
  params[0] = sum1802;
  partcv[0] = 1;
  Object call1805 = callmethod(call1804, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1798);
// compilenode returning call1805
  int op_slot_right_1797 = gc_frame_newslot(call1805);
  if (strlit1808 == NULL) {
    strlit1808 = alloc_String("else ");
    gc_root(strlit1808);
  }
// compilenode returning strlit1808
  int op_slot_right_1807 = gc_frame_newslot(strlit1808);
  if (strlit1811 == NULL) {
    strlit1811 = alloc_String("    ");
    gc_root(strlit1811);
  }
// compilenode returning strlit1811
  int op_slot_right_1810 = gc_frame_newslot(strlit1811);
// compilenode returning *var_spc
  int op_slot_right_1813 = gc_frame_newslot(*var_spc);
  if (strlit1816 == NULL) {
    strlit1816 = alloc_String("""\x0a""");
    gc_root(strlit1816);
  }
// compilenode returning strlit1816
  int op_slot_right_1815 = gc_frame_newslot(strlit1816);
// compilenode returning *var_s
  int op_slot_left_1815 = gc_frame_newslot(*var_s);
  params[0] = strlit1816;
  partcv[0] = 1;
  Object opresult1818 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1818
  int op_slot_left_1813 = gc_frame_newslot(opresult1818);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1819 = callmethod(opresult1818, "++", 1, partcv, params);
// compilenode returning opresult1819
  int op_slot_left_1810 = gc_frame_newslot(opresult1819);
  params[0] = strlit1811;
  partcv[0] = 1;
  Object opresult1820 = callmethod(opresult1819, "++", 1, partcv, params);
// compilenode returning opresult1820
  int op_slot_left_1807 = gc_frame_newslot(opresult1820);
  params[0] = strlit1808;
  partcv[0] = 1;
  Object opresult1821 = callmethod(opresult1820, "++", 1, partcv, params);
// compilenode returning opresult1821
  int op_slot_left_1797 = gc_frame_newslot(opresult1821);
  params[0] = call1805;
  partcv[0] = 1;
  Object opresult1822 = callmethod(opresult1821, "++", 1, partcv, params);
// compilenode returning opresult1822
  *var_s = opresult1822;
  if (opresult1822 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1790 = done;
  } else {
  }
// compilenode returning if1790
// Begin line 397
  setline(397);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new1540(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_matchCaseNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_matchee = &(stackframe->slots[0]);
  *var_matchee = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_elsecase_39_ = &(stackframe->slots[2]);
  *var_elsecase_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1541 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1541 = alloc_userobj2(10,11, objclass1541);
  gc_frame_newslot(obj1541);
if (objclass1541 == NULL) {
  glfree(obj1541->class->name);
  obj1541->class->name = "matchCaseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1541, self, 0);
  addmethodreal(obj1541,"outer", &reader_ast_outer_1542);
  Object oldself1541 = self;
  struct StackFrameObject *oldstackframe1541 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1541);
  gc_frame_newslot((Object)stackframe);
  self = obj1541;
  Object *oldselfslot1541 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1541 = (*(struct UserObject *)self).data[0], lowerouter1541 = thisouter1541;
  if (inheritingObject1541) {
    struct UserObject *inho1541 = (struct UserObject *)inheritingObject1541;
    while (inho1541->super != GraceDefaultObject) inho1541 = (struct UserObject *)inho1541->super;
    inho1541->super = obj1541;
    self = inheritingObject1541;
    *selfslot = self;
    lowerouter1541 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1541;
  }
if (objclass1541 == NULL) {
  Method *reader1543 = addmethodrealflags(obj1541, "kind",&reader_ast_kind_1543, MFLAG_DEF);
  reader1543->definitionModule = modulename;
  reader1543->definitionLine = 343;
}
adddatum2(obj1541, alloc_Undefined(), 1);
if (objclass1541 == NULL) {
  Method *reader1544 = addmethodrealflags(obj1541, "value",&reader_ast_value_1544, MFLAG_DEF);
  reader1544->definitionModule = modulename;
  reader1544->definitionLine = 344;
}
adddatum2(obj1541, alloc_Undefined(), 2);
if (objclass1541 == NULL) {
  Method *reader1545 = addmethodrealflags(obj1541, "cases",&reader_ast_cases_1545, MFLAG_DEF);
  reader1545->definitionModule = modulename;
  reader1545->definitionLine = 345;
}
adddatum2(obj1541, alloc_Undefined(), 3);
if (objclass1541 == NULL) {
  Method *reader1546 = addmethodrealflags(obj1541, "elsecase",&reader_ast_elsecase_1546, MFLAG_DEF);
  reader1546->definitionModule = modulename;
  reader1546->definitionLine = 346;
}
adddatum2(obj1541, alloc_Undefined(), 4);
  struct UserObject *uo1547 = (struct UserObject*)obj1541;
  uo1547->data[5] = emptyclosure;
  Method *meth_meth_ast_accept1547 = addmethod2pos(obj1541, "accept", &meth_ast_accept1547, 5);
int argcv_meth_ast_accept1547[] = {1};
meth_meth_ast_accept1547->type = alloc_MethodType(1, argcv_meth_ast_accept1547);
meth_meth_ast_accept1547->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept1547->type->names[0] = "visitor";
  meth_meth_ast_accept1547->definitionModule = modulename;
  meth_meth_ast_accept1547->definitionLine = 346;
  block_savedest(obj1541);
  Object closure1575 = createclosure(1, "map()before()after");
setclosureframe(closure1575, stackframe);
  addtoclosure(closure1575, var_matchCaseNode);
  struct UserObject *uo1575 = (struct UserObject*)obj1541;
  uo1575->data[6] = (Object)closure1575;
  Method *meth_meth_ast_map_40__41_before_40__41_after1575 = addmethod2pos(obj1541, "map()before()after", &meth_ast_map_40__41_before_40__41_after1575, 6);
int argcv_meth_ast_map_40__41_before_40__41_after1575[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after1575->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after1575);
  meth_meth_ast_map_40__41_before_40__41_after1575->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after1575->definitionLine = 357;
  struct UserObject *uo1606 = (struct UserObject*)obj1541;
  uo1606->data[7] = emptyclosure;
  Method *meth_meth_ast_map1606 = addmethod2pos(obj1541, "map", &meth_ast_map1606, 7);
int argcv_meth_ast_map1606[] = {1};
meth_meth_ast_map1606->type = alloc_MethodType(1, argcv_meth_ast_map1606);
  meth_meth_ast_map1606->definitionModule = modulename;
  meth_meth_ast_map1606->definitionLine = 367;
  block_savedest(obj1541);
  Object closure1615 = createclosure(1, "pretty");
setclosureframe(closure1615, stackframe);
  addtoclosure(closure1615, var_matchee);
  struct UserObject *uo1615 = (struct UserObject*)obj1541;
  uo1615->data[8] = (Object)closure1615;
  Method *meth_meth_ast_pretty1615 = addmethod2pos(obj1541, "pretty", &meth_ast_pretty1615, 8);
int argcv_meth_ast_pretty1615[] = {1};
meth_meth_ast_pretty1615->type = alloc_MethodType(1, argcv_meth_ast_pretty1615);
  meth_meth_ast_pretty1615->definitionModule = modulename;
  meth_meth_ast_pretty1615->definitionLine = 370;
  struct UserObject *uo1725 = (struct UserObject*)obj1541;
  uo1725->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace1725 = addmethod2pos(obj1541, "toGrace", &meth_ast_toGrace1725, 9);
int argcv_meth_ast_toGrace1725[] = {1};
meth_meth_ast_toGrace1725->type = alloc_MethodType(1, argcv_meth_ast_toGrace1725);
meth_meth_ast_toGrace1725->type->types[0] = type_Number;
meth_meth_ast_toGrace1725->type->names[0] = "depth";
  meth_meth_ast_toGrace1725->definitionModule = modulename;
  meth_meth_ast_toGrace1725->definitionLine = 385;
  sourceObject = obj1541;
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1824 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1825 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe1824);
// compilenode returning call1825
  struct UserObject *obj1541_uo = (struct UserObject *)obj1541;
  obj1541_uo->super = call1825;
  sourceObject = obj1541;
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1826 == NULL) {
    strlit1826 = alloc_String("matchcase");
    gc_root(strlit1826);
  }
// compilenode returning strlit1826
  adddatum2(obj1541, strlit1826, 1);
  sourceObject = obj1541;
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_matchee
  adddatum2(obj1541, *var_matchee, 2);
  sourceObject = obj1541;
// Begin line 344
  setline(344);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_cases_39_
  adddatum2(obj1541, *var_cases_39_, 3);
  sourceObject = obj1541;
// Begin line 345
  setline(345);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_elsecase_39_
  adddatum2(obj1541, *var_elsecase_39_, 4);
  sourceObject = obj1541;
  sourceObject = obj1541;
  sourceObject = obj1541;
  sourceObject = obj1541;
  sourceObject = obj1541;
objclass1541 = obj1541->class;
  objclass1541->definitionModule = modulename;
  objclass1541->definitionLine = 335;
  (*(struct UserObject *)self).data[0] = lowerouter1541;
  self = oldself1541;
  selfslot = oldselfslot1541;
  stackframe = oldstackframe1541;
  gc_frame_end(frame);
  return obj1541;
}
Object meth_ast_new1540_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_matchCaseNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_matchee = &(stackframe->slots[0]);
  *var_matchee = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_elsecase_39_ = &(stackframe->slots[2]);
  *var_elsecase_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1541 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1541 = alloc_userobj2(10,11, objclass1541);
  gc_frame_newslot(obj1541);
if (objclass1541 == NULL) {
  glfree(obj1541->class->name);
  obj1541->class->name = "matchCaseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1541, self, 0);
  addmethodreal(obj1541,"outer", &reader_ast_outer_1542);
  Object oldself1541 = self;
  struct StackFrameObject *oldstackframe1541 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1541);
  gc_frame_newslot((Object)stackframe);
  self = obj1541;
  Object *oldselfslot1541 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1541 = (*(struct UserObject *)self).data[0], lowerouter1541 = thisouter1541;
  if (inheritingObject1541) {
    struct UserObject *inho1541 = (struct UserObject *)inheritingObject1541;
    while (inho1541->super != GraceDefaultObject) inho1541 = (struct UserObject *)inho1541->super;
    inho1541->super = obj1541;
    self = inheritingObject1541;
    *selfslot = self;
    lowerouter1541 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1541;
  }
if (objclass1541 == NULL) {
  Method *reader1543 = addmethodrealflags(obj1541, "kind",&reader_ast_kind_1543, MFLAG_DEF);
  reader1543->definitionModule = modulename;
  reader1543->definitionLine = 343;
}
adddatum2(obj1541, alloc_Undefined(), 1);
if (objclass1541 == NULL) {
  Method *reader1544 = addmethodrealflags(obj1541, "value",&reader_ast_value_1544, MFLAG_DEF);
  reader1544->definitionModule = modulename;
  reader1544->definitionLine = 344;
}
adddatum2(obj1541, alloc_Undefined(), 2);
if (objclass1541 == NULL) {
  Method *reader1545 = addmethodrealflags(obj1541, "cases",&reader_ast_cases_1545, MFLAG_DEF);
  reader1545->definitionModule = modulename;
  reader1545->definitionLine = 345;
}
adddatum2(obj1541, alloc_Undefined(), 3);
if (objclass1541 == NULL) {
  Method *reader1546 = addmethodrealflags(obj1541, "elsecase",&reader_ast_elsecase_1546, MFLAG_DEF);
  reader1546->definitionModule = modulename;
  reader1546->definitionLine = 346;
}
adddatum2(obj1541, alloc_Undefined(), 4);
  struct UserObject *uo1547 = (struct UserObject*)obj1541;
  uo1547->data[5] = emptyclosure;
  Method *meth_meth_ast_accept1547 = addmethod2pos(obj1541, "accept", &meth_ast_accept1547, 5);
int argcv_meth_ast_accept1547[] = {1};
meth_meth_ast_accept1547->type = alloc_MethodType(1, argcv_meth_ast_accept1547);
meth_meth_ast_accept1547->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept1547->type->names[0] = "visitor";
  meth_meth_ast_accept1547->definitionModule = modulename;
  meth_meth_ast_accept1547->definitionLine = 346;
  block_savedest(obj1541);
  Object closure1575 = createclosure(1, "map()before()after");
setclosureframe(closure1575, stackframe);
  addtoclosure(closure1575, var_matchCaseNode);
  struct UserObject *uo1575 = (struct UserObject*)obj1541;
  uo1575->data[6] = (Object)closure1575;
  Method *meth_meth_ast_map_40__41_before_40__41_after1575 = addmethod2pos(obj1541, "map()before()after", &meth_ast_map_40__41_before_40__41_after1575, 6);
int argcv_meth_ast_map_40__41_before_40__41_after1575[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after1575->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after1575);
  meth_meth_ast_map_40__41_before_40__41_after1575->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after1575->definitionLine = 357;
  struct UserObject *uo1606 = (struct UserObject*)obj1541;
  uo1606->data[7] = emptyclosure;
  Method *meth_meth_ast_map1606 = addmethod2pos(obj1541, "map", &meth_ast_map1606, 7);
int argcv_meth_ast_map1606[] = {1};
meth_meth_ast_map1606->type = alloc_MethodType(1, argcv_meth_ast_map1606);
  meth_meth_ast_map1606->definitionModule = modulename;
  meth_meth_ast_map1606->definitionLine = 367;
  block_savedest(obj1541);
  Object closure1615 = createclosure(1, "pretty");
setclosureframe(closure1615, stackframe);
  addtoclosure(closure1615, var_matchee);
  struct UserObject *uo1615 = (struct UserObject*)obj1541;
  uo1615->data[8] = (Object)closure1615;
  Method *meth_meth_ast_pretty1615 = addmethod2pos(obj1541, "pretty", &meth_ast_pretty1615, 8);
int argcv_meth_ast_pretty1615[] = {1};
meth_meth_ast_pretty1615->type = alloc_MethodType(1, argcv_meth_ast_pretty1615);
  meth_meth_ast_pretty1615->definitionModule = modulename;
  meth_meth_ast_pretty1615->definitionLine = 370;
  struct UserObject *uo1725 = (struct UserObject*)obj1541;
  uo1725->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace1725 = addmethod2pos(obj1541, "toGrace", &meth_ast_toGrace1725, 9);
int argcv_meth_ast_toGrace1725[] = {1};
meth_meth_ast_toGrace1725->type = alloc_MethodType(1, argcv_meth_ast_toGrace1725);
meth_meth_ast_toGrace1725->type->types[0] = type_Number;
meth_meth_ast_toGrace1725->type->names[0] = "depth";
  meth_meth_ast_toGrace1725->definitionModule = modulename;
  meth_meth_ast_toGrace1725->definitionLine = 385;
  sourceObject = obj1541;
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1824 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1825 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe1824);
// compilenode returning call1825
  struct UserObject *obj1541_uo = (struct UserObject *)obj1541;
  obj1541_uo->super = call1825;
  sourceObject = obj1541;
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1826 == NULL) {
    strlit1826 = alloc_String("matchcase");
    gc_root(strlit1826);
  }
// compilenode returning strlit1826
  adddatum2(obj1541, strlit1826, 1);
  sourceObject = obj1541;
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_matchee
  adddatum2(obj1541, *var_matchee, 2);
  sourceObject = obj1541;
// Begin line 344
  setline(344);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_cases_39_
  adddatum2(obj1541, *var_cases_39_, 3);
  sourceObject = obj1541;
// Begin line 345
  setline(345);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_elsecase_39_
  adddatum2(obj1541, *var_elsecase_39_, 4);
  sourceObject = obj1541;
  sourceObject = obj1541;
  sourceObject = obj1541;
  sourceObject = obj1541;
  sourceObject = obj1541;
objclass1541 = obj1541->class;
  objclass1541->definitionModule = modulename;
  objclass1541->definitionLine = 335;
  (*(struct UserObject *)self).data[0] = lowerouter1541;
  self = oldself1541;
  selfslot = oldselfslot1541;
  stackframe = oldstackframe1541;
  gc_frame_end(frame);
  return obj1541;
}
Object meth_ast_methodTypeNode1828(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodTypeNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_methodTypeNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for methodTypeNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for methodTypeNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_methodTypeNode
  gc_frame_end(frame);
  return *var_methodTypeNode;
}
Object meth_ast__apply1863(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 429
  setline(429);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1864 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_p
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call1865 = callmethod(*var_p, "accept",
    1, partcv, params);
  gc_frame_end(callframe1864);
// compilenode returning call1865
  gc_frame_end(frame);
  return call1865;
}
Object meth_ast__apply1858(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 428
  setline(428);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1859 = gc_frame_new();
  int callframe1860 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call1861 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe1860);
// compilenode returning call1861
// compilenode returning call1861
  gc_frame_newslot(call1861);
  Object block1862 = alloc_Block(NULL, NULL, "ast", 428);
  gc_frame_newslot(block1862);
  block_savedest(block1862);
  Object closure1863 = createclosure(2, "_apply");
setclosureframe(closure1863, stackframe);
  addtoclosure(closure1863, var_visitor);
  addtoclosure(closure1863, selfslot);
  struct UserObject *uo1863 = (struct UserObject*)block1862;
  uo1863->data[0] = (Object)closure1863;
  Method *meth_meth_ast__apply1863 = addmethod2pos(block1862, "_apply", &meth_ast__apply1863, 0);
int argcv_meth_ast__apply1863[] = {1};
meth_meth_ast__apply1863->type = alloc_MethodType(1, argcv_meth_ast__apply1863);
  meth_meth_ast__apply1863->definitionModule = modulename;
  meth_meth_ast__apply1863->definitionLine = 428;
// compilenode returning block1862
  gc_frame_newslot(block1862);
  params[0] = call1861;
  params[1] = block1862;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1867 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1859);
// compilenode returning call1867
// Begin line 434
  setline(434);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 431
  setline(431);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1870 = alloc_Boolean(0);
// compilenode returning bool1870
  int op_slot_right_1869 = gc_frame_newslot(bool1870);
  int callframe1872 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call1873 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe1872);
// compilenode returning call1873
// compilenode returning call1873
  int op_slot_left_1869 = gc_frame_newslot(call1873);
  params[0] = bool1870;
  partcv[0] = 1;
  Object opresult1874 = callmethod(call1873, "!=", 1, partcv, params);
// compilenode returning opresult1874
  Object if1868 = done;
  if (istrue(opresult1874)) {
// Begin line 432
  setline(432);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1875 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe1876 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call1877 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe1876);
// compilenode returning call1877
// compilenode returning call1877
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call1878 = callmethod(call1877, "accept",
    1, partcv, params);
  gc_frame_end(callframe1875);
// compilenode returning call1878
    gc_frame_newslot(call1878);
    if1868 = call1878;
  } else {
  }
// compilenode returning if1868
  gc_frame_end(frame);
  return if1868;
}
Object meth_ast_accept1839(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 436
  setline(436);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 423
  setline(423);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1841 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call1842 = callmethod(*var_visitor, "visitMethodType",
    1, partcv, params);
  gc_frame_end(callframe1841);
// compilenode returning call1842
  Object if1840 = done;
  if (istrue(call1842)) {
// Begin line 427
  setline(427);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 424
  setline(424);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1845 = alloc_Boolean(0);
// compilenode returning bool1845
  int op_slot_right_1844 = gc_frame_newslot(bool1845);
  int callframe1847 = gc_frame_new();
  partcv[0] = 0;
  Object call1848 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1847);
// compilenode returning call1848
// compilenode returning call1848
  int op_slot_left_1844 = gc_frame_newslot(call1848);
  params[0] = bool1845;
  partcv[0] = 1;
  Object opresult1849 = callmethod(call1848, "!=", 1, partcv, params);
// compilenode returning opresult1849
  Object if1843 = done;
  if (istrue(opresult1849)) {
// Begin line 425
  setline(425);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1850 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe1851 = gc_frame_new();
  partcv[0] = 0;
  Object call1852 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1851);
// compilenode returning call1852
// compilenode returning call1852
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call1853 = callmethod(call1852, "accept",
    1, partcv, params);
  gc_frame_end(callframe1850);
// compilenode returning call1853
    gc_frame_newslot(call1853);
    if1843 = call1853;
  } else {
  }
// compilenode returning if1843
// Begin line 427
  setline(427);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1854 = gc_frame_new();
  int callframe1855 = gc_frame_new();
  partcv[0] = 0;
  Object call1856 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1855);
// compilenode returning call1856
// compilenode returning call1856
  gc_frame_newslot(call1856);
  Object block1857 = alloc_Block(NULL, NULL, "ast", 427);
  gc_frame_newslot(block1857);
  block_savedest(block1857);
  Object closure1858 = createclosure(2, "_apply");
setclosureframe(closure1858, stackframe);
  addtoclosure(closure1858, var_visitor);
  addtoclosure(closure1858, selfslot);
  struct UserObject *uo1858 = (struct UserObject*)block1857;
  uo1858->data[0] = (Object)closure1858;
  Method *meth_meth_ast__apply1858 = addmethod2pos(block1857, "_apply", &meth_ast__apply1858, 0);
int argcv_meth_ast__apply1858[] = {1};
meth_meth_ast__apply1858->type = alloc_MethodType(1, argcv_meth_ast__apply1858);
  meth_meth_ast__apply1858->definitionModule = modulename;
  meth_meth_ast__apply1858->definitionLine = 427;
// compilenode returning block1857
  gc_frame_newslot(block1857);
  params[0] = call1856;
  params[1] = block1857;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1880 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1854);
// compilenode returning call1880
    gc_frame_newslot(call1880);
    if1840 = call1880;
  } else {
  }
// compilenode returning if1840
  gc_frame_end(frame);
  return if1840;
}
Object meth_ast_map_40__41_before_40__41_after1881(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_methodTypeNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_rt = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "rt");
  Object *var_n = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "n");
// Begin line 438
  setline(438);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1882 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call1883 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe1882);
// compilenode returning call1883
// Begin line 440
  setline(440);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 439
  setline(439);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1884 = alloc_Boolean(0);
// compilenode returning bool1884
  *var_rt = bool1884;
  if (bool1884 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 440
  setline(440);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1887 = alloc_Boolean(0);
// compilenode returning bool1887
  int op_slot_right_1886 = gc_frame_newslot(bool1887);
  int callframe1889 = gc_frame_new();
  partcv[0] = 0;
  Object call1890 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1889);
// compilenode returning call1890
  int op_slot_left_1886 = gc_frame_newslot(call1890);
  params[0] = bool1887;
  partcv[0] = 1;
  Object opresult1891 = callmethod(call1890, "!=", 1, partcv, params);
// compilenode returning opresult1891
  Object if1885 = done;
  if (istrue(opresult1891)) {
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1892 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe1893 = gc_frame_new();
  partcv[0] = 0;
  Object call1894 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1893);
// compilenode returning call1894
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1895 = callmethod(call1894, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe1892);
// compilenode returning call1895
  *var_rt = call1895;
  if (call1895 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1885 = done;
  } else {
  }
// compilenode returning if1885
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1897 = gc_frame_new();
  int callframe1898 = gc_frame_new();
  partcv[0] = 0;
  Object call1899 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1898);
// compilenode returning call1899
  gc_frame_newslot(call1899);
  int callframe1900 = gc_frame_new();
  int callframe1901 = gc_frame_new();
  partcv[0] = 0;
  Object call1902 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1901);
// compilenode returning call1902
  gc_frame_newslot(call1902);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe1903 = gc_frame_new();
  int callframe1904 = gc_frame_new();
  Object call1905 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1904);
// compilenode returning call1905
// compilenode returning call1905
  partcv[0] = 0;
  Object call1906 = callmethodflags(call1905, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1903);
// compilenode returning call1906
// compilenode returning call1906
  params[0] = call1902;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1907 = callmethodflags(call1906, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1900);
// compilenode returning call1907
  gc_frame_newslot(call1907);
// Begin line 444
  setline(444);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_rt
  gc_frame_newslot(*var_rt);
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_methodTypeNode
  params[0] = call1899;
  params[1] = call1907;
  params[2] = *var_rt;
  partcv[0] = 3;
  Object call1908 = callmethod(*var_methodTypeNode, "new",
    1, partcv, params);
  gc_frame_end(callframe1897);
// compilenode returning call1908
  *var_n = call1908;
  if (call1908 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 446
  setline(446);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1909 = gc_frame_new();
// Begin line 445
  setline(445);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1910 = gc_frame_new();
  partcv[0] = 0;
  Object call1911 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1910);
// compilenode returning call1911
  gc_frame_newslot(call1911);
// compilenode returning *var_n
  params[0] = call1911;
  partcv[0] = 1;
  Object call1912 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe1909);
// compilenode returning call1912
// compilenode returning done
// Begin line 446
  setline(446);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1913 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1914 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe1913);
// compilenode returning call1914
// Begin line 447
  setline(447);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply1918(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1921(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map1915(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1916 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block1917 = alloc_Block(NULL, NULL, "ast", 450);
  gc_frame_newslot(block1917);
  block_savedest(block1917);
  Object closure1918 = createclosure(1, "_apply");
setclosureframe(closure1918, stackframe);
  addtoclosure(closure1918, selfslot);
  struct UserObject *uo1918 = (struct UserObject*)block1917;
  uo1918->data[0] = (Object)closure1918;
  Method *meth_meth_ast__apply1918 = addmethod2pos(block1917, "_apply", &meth_ast__apply1918, 0);
int argcv_meth_ast__apply1918[] = {0};
meth_meth_ast__apply1918->type = alloc_MethodType(1, argcv_meth_ast__apply1918);
  meth_meth_ast__apply1918->definitionModule = modulename;
  meth_meth_ast__apply1918->definitionLine = 443;
// compilenode returning block1917
  gc_frame_newslot(block1917);
  Object block1920 = alloc_Block(NULL, NULL, "ast", 450);
  gc_frame_newslot(block1920);
  block_savedest(block1920);
  Object closure1921 = createclosure(1, "_apply");
setclosureframe(closure1921, stackframe);
  addtoclosure(closure1921, selfslot);
  struct UserObject *uo1921 = (struct UserObject*)block1920;
  uo1921->data[0] = (Object)closure1921;
  Method *meth_meth_ast__apply1921 = addmethod2pos(block1920, "_apply", &meth_ast__apply1921, 0);
int argcv_meth_ast__apply1921[] = {0};
meth_meth_ast__apply1921->type = alloc_MethodType(1, argcv_meth_ast__apply1921);
  meth_meth_ast__apply1921->definitionModule = modulename;
  meth_meth_ast__apply1921->definitionLine = 443;
// compilenode returning block1920
  gc_frame_newslot(block1920);
  params[0] = *var_blk;
  params[1] = block1917;
  params[2] = block1920;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1923 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1916);
// compilenode returning call1923
  gc_frame_end(frame);
  return call1923;
}
Object meth_ast__apply1932(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 456
  setline(456);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1934 == NULL) {
    strlit1934 = alloc_String("  ");
    gc_root(strlit1934);
  }
// compilenode returning strlit1934
  int op_slot_right_1933 = gc_frame_newslot(strlit1934);
// compilenode returning *var_spc
  int op_slot_left_1933 = gc_frame_newslot(*var_spc);
  params[0] = strlit1934;
  partcv[0] = 1;
  Object opresult1936 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult1936
  *var_spc = opresult1936;
  if (opresult1936 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2077(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 468
  setline(468);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 467
  setline(467);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2079 == NULL) {
    strlit2079 = alloc_String("");
    gc_root(strlit2079);
  }
// compilenode returning strlit2079
  int op_slot_right_2078 = gc_frame_newslot(strlit2079);
  int callframe2082 = gc_frame_new();
  Object num2084 = alloc_Float64(4);
// compilenode returning num2084
  int op_slot_right_2083 = gc_frame_newslot(num2084);
// compilenode returning *var_depth
  int op_slot_left_2083 = gc_frame_newslot(*var_depth);
  params[0] = num2084;
  partcv[0] = 1;
  Object sum2086 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum2086
  gc_frame_newslot(sum2086);
// compilenode returning *var_p
  params[0] = sum2086;
  partcv[0] = 1;
  Object call2087 = callmethod(*var_p, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2082);
// compilenode returning call2087
  int op_slot_right_2081 = gc_frame_newslot(call2087);
  if (strlit2090 == NULL) {
    strlit2090 = alloc_String("");
    gc_root(strlit2090);
  }
// compilenode returning strlit2090
  int op_slot_right_2089 = gc_frame_newslot(strlit2090);
// compilenode returning *var_spc
  int op_slot_right_2092 = gc_frame_newslot(*var_spc);
  if (strlit2095 == NULL) {
    strlit2095 = alloc_String("""\x0a""      ");
    gc_root(strlit2095);
  }
// compilenode returning strlit2095
  int op_slot_right_2094 = gc_frame_newslot(strlit2095);
// compilenode returning *var_s
  int op_slot_right_2097 = gc_frame_newslot(*var_s);
  if (strlit2099 == NULL) {
    strlit2099 = alloc_String("");
    gc_root(strlit2099);
  }
// compilenode returning strlit2099
  int op_slot_left_2097 = gc_frame_newslot(strlit2099);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2100 = callmethod(strlit2099, "++", 1, partcv, params);
// compilenode returning opresult2100
  int op_slot_left_2094 = gc_frame_newslot(opresult2100);
  params[0] = strlit2095;
  partcv[0] = 1;
  Object opresult2101 = callmethod(opresult2100, "++", 1, partcv, params);
// compilenode returning opresult2101
  int op_slot_left_2092 = gc_frame_newslot(opresult2101);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2102 = callmethod(opresult2101, "++", 1, partcv, params);
// compilenode returning opresult2102
  int op_slot_left_2089 = gc_frame_newslot(opresult2102);
  params[0] = strlit2090;
  partcv[0] = 1;
  Object opresult2103 = callmethod(opresult2102, "++", 1, partcv, params);
// compilenode returning opresult2103
  int op_slot_left_2081 = gc_frame_newslot(opresult2103);
  params[0] = call2087;
  partcv[0] = 1;
  Object opresult2104 = callmethod(opresult2103, "++", 1, partcv, params);
// compilenode returning opresult2104
  int op_slot_left_2078 = gc_frame_newslot(opresult2104);
  params[0] = strlit2079;
  partcv[0] = 1;
  Object opresult2105 = callmethod(opresult2104, "++", 1, partcv, params);
// compilenode returning opresult2105
  *var_s = opresult2105;
  if (opresult2105 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2031(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 465
  setline(465);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 464
  setline(464);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2033 == NULL) {
    strlit2033 = alloc_String("");
    gc_root(strlit2033);
  }
// compilenode returning strlit2033
  int op_slot_right_2032 = gc_frame_newslot(strlit2033);
  int callframe2036 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2037 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe2036);
// compilenode returning call2037
// compilenode returning call2037
  int op_slot_right_2035 = gc_frame_newslot(call2037);
  if (strlit2040 == NULL) {
    strlit2040 = alloc_String("Part: ");
    gc_root(strlit2040);
  }
// compilenode returning strlit2040
  int op_slot_right_2039 = gc_frame_newslot(strlit2040);
// compilenode returning *var_spc
  int op_slot_right_2042 = gc_frame_newslot(*var_spc);
  if (strlit2045 == NULL) {
    strlit2045 = alloc_String("""\x0a""  ");
    gc_root(strlit2045);
  }
// compilenode returning strlit2045
  int op_slot_right_2044 = gc_frame_newslot(strlit2045);
// compilenode returning *var_s
  int op_slot_right_2047 = gc_frame_newslot(*var_s);
  if (strlit2049 == NULL) {
    strlit2049 = alloc_String("");
    gc_root(strlit2049);
  }
// compilenode returning strlit2049
  int op_slot_left_2047 = gc_frame_newslot(strlit2049);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2050 = callmethod(strlit2049, "++", 1, partcv, params);
// compilenode returning opresult2050
  int op_slot_left_2044 = gc_frame_newslot(opresult2050);
  params[0] = strlit2045;
  partcv[0] = 1;
  Object opresult2051 = callmethod(opresult2050, "++", 1, partcv, params);
// compilenode returning opresult2051
  int op_slot_left_2042 = gc_frame_newslot(opresult2051);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2052 = callmethod(opresult2051, "++", 1, partcv, params);
// compilenode returning opresult2052
  int op_slot_left_2039 = gc_frame_newslot(opresult2052);
  params[0] = strlit2040;
  partcv[0] = 1;
  Object opresult2053 = callmethod(opresult2052, "++", 1, partcv, params);
// compilenode returning opresult2053
  int op_slot_left_2035 = gc_frame_newslot(opresult2053);
  params[0] = call2037;
  partcv[0] = 1;
  Object opresult2054 = callmethod(opresult2053, "++", 1, partcv, params);
// compilenode returning opresult2054
  int op_slot_left_2032 = gc_frame_newslot(opresult2054);
  params[0] = strlit2033;
  partcv[0] = 1;
  Object opresult2055 = callmethod(opresult2054, "++", 1, partcv, params);
// compilenode returning opresult2055
  *var_s = opresult2055;
  if (opresult2055 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 466
  setline(466);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 465
  setline(465);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2058 == NULL) {
    strlit2058 = alloc_String("Parameters:");
    gc_root(strlit2058);
  }
// compilenode returning strlit2058
  int op_slot_right_2057 = gc_frame_newslot(strlit2058);
// compilenode returning *var_spc
  int op_slot_right_2060 = gc_frame_newslot(*var_spc);
  if (strlit2063 == NULL) {
    strlit2063 = alloc_String("""\x0a""    ");
    gc_root(strlit2063);
  }
// compilenode returning strlit2063
  int op_slot_right_2062 = gc_frame_newslot(strlit2063);
// compilenode returning *var_s
  int op_slot_right_2065 = gc_frame_newslot(*var_s);
  if (strlit2067 == NULL) {
    strlit2067 = alloc_String("");
    gc_root(strlit2067);
  }
// compilenode returning strlit2067
  int op_slot_left_2065 = gc_frame_newslot(strlit2067);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2068 = callmethod(strlit2067, "++", 1, partcv, params);
// compilenode returning opresult2068
  int op_slot_left_2062 = gc_frame_newslot(opresult2068);
  params[0] = strlit2063;
  partcv[0] = 1;
  Object opresult2069 = callmethod(opresult2068, "++", 1, partcv, params);
// compilenode returning opresult2069
  int op_slot_left_2060 = gc_frame_newslot(opresult2069);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2070 = callmethod(opresult2069, "++", 1, partcv, params);
// compilenode returning opresult2070
  int op_slot_left_2057 = gc_frame_newslot(opresult2070);
  params[0] = strlit2058;
  partcv[0] = 1;
  Object opresult2071 = callmethod(opresult2070, "++", 1, partcv, params);
// compilenode returning opresult2071
  *var_s = opresult2071;
  if (opresult2071 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 466
  setline(466);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2073 = gc_frame_new();
  int callframe2074 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2075 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2074);
// compilenode returning call2075
// compilenode returning call2075
  gc_frame_newslot(call2075);
  Object block2076 = alloc_Block(NULL, NULL, "ast", 466);
  gc_frame_newslot(block2076);
  block_savedest(block2076);
  Object closure2077 = createclosure(4, "_apply");
setclosureframe(closure2077, stackframe);
  addtoclosure(closure2077, var_depth);
  addtoclosure(closure2077, var_spc);
  addtoclosure(closure2077, var_s);
  addtoclosure(closure2077, selfslot);
  struct UserObject *uo2077 = (struct UserObject*)block2076;
  uo2077->data[0] = (Object)closure2077;
  Method *meth_meth_ast__apply2077 = addmethod2pos(block2076, "_apply", &meth_ast__apply2077, 0);
int argcv_meth_ast__apply2077[] = {1};
meth_meth_ast__apply2077->type = alloc_MethodType(1, argcv_meth_ast__apply2077);
  meth_meth_ast__apply2077->definitionModule = modulename;
  meth_meth_ast__apply2077->definitionLine = 466;
// compilenode returning block2076
  gc_frame_newslot(block2076);
  params[0] = call2075;
  params[1] = block2076;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2108 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2073);
// compilenode returning call2108
// Begin line 472
  setline(472);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 469
  setline(469);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool2111 = alloc_Boolean(0);
// compilenode returning bool2111
  int op_slot_right_2110 = gc_frame_newslot(bool2111);
  int callframe2113 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2114 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe2113);
// compilenode returning call2114
// compilenode returning call2114
  int op_slot_left_2110 = gc_frame_newslot(call2114);
  params[0] = bool2111;
  partcv[0] = 1;
  Object opresult2115 = callmethod(call2114, "!=", 1, partcv, params);
// compilenode returning opresult2115
  Object if2109 = done;
  if (istrue(opresult2115)) {
// Begin line 471
  setline(471);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2117 == NULL) {
    strlit2117 = alloc_String("");
    gc_root(strlit2117);
  }
// compilenode returning strlit2117
  int op_slot_right_2116 = gc_frame_newslot(strlit2117);
  int callframe2120 = gc_frame_new();
  Object num2122 = alloc_Float64(3);
// compilenode returning num2122
  int op_slot_right_2121 = gc_frame_newslot(num2122);
// compilenode returning *var_depth
  int op_slot_left_2121 = gc_frame_newslot(*var_depth);
  params[0] = num2122;
  partcv[0] = 1;
  Object sum2124 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum2124
  gc_frame_newslot(sum2124);
  int callframe2125 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2126 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe2125);
// compilenode returning call2126
// compilenode returning call2126
  params[0] = sum2124;
  partcv[0] = 1;
  Object call2127 = callmethod(call2126, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2120);
// compilenode returning call2127
  int op_slot_right_2119 = gc_frame_newslot(call2127);
  if (strlit2130 == NULL) {
    strlit2130 = alloc_String("Vararg: ");
    gc_root(strlit2130);
  }
// compilenode returning strlit2130
  int op_slot_right_2129 = gc_frame_newslot(strlit2130);
// compilenode returning *var_spc
  int op_slot_right_2132 = gc_frame_newslot(*var_spc);
  if (strlit2135 == NULL) {
    strlit2135 = alloc_String("""\x0a""    ");
    gc_root(strlit2135);
  }
// compilenode returning strlit2135
  int op_slot_right_2134 = gc_frame_newslot(strlit2135);
// compilenode returning *var_s
  int op_slot_right_2137 = gc_frame_newslot(*var_s);
  if (strlit2139 == NULL) {
    strlit2139 = alloc_String("");
    gc_root(strlit2139);
  }
// compilenode returning strlit2139
  int op_slot_left_2137 = gc_frame_newslot(strlit2139);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2140 = callmethod(strlit2139, "++", 1, partcv, params);
// compilenode returning opresult2140
  int op_slot_left_2134 = gc_frame_newslot(opresult2140);
  params[0] = strlit2135;
  partcv[0] = 1;
  Object opresult2141 = callmethod(opresult2140, "++", 1, partcv, params);
// compilenode returning opresult2141
  int op_slot_left_2132 = gc_frame_newslot(opresult2141);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2142 = callmethod(opresult2141, "++", 1, partcv, params);
// compilenode returning opresult2142
  int op_slot_left_2129 = gc_frame_newslot(opresult2142);
  params[0] = strlit2130;
  partcv[0] = 1;
  Object opresult2143 = callmethod(opresult2142, "++", 1, partcv, params);
// compilenode returning opresult2143
  int op_slot_left_2119 = gc_frame_newslot(opresult2143);
  params[0] = call2127;
  partcv[0] = 1;
  Object opresult2144 = callmethod(opresult2143, "++", 1, partcv, params);
// compilenode returning opresult2144
  int op_slot_left_2116 = gc_frame_newslot(opresult2144);
  params[0] = strlit2117;
  partcv[0] = 1;
  Object opresult2145 = callmethod(opresult2144, "++", 1, partcv, params);
// compilenode returning opresult2145
  *var_s = opresult2145;
  if (opresult2145 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2109 = done;
  } else {
  }
// compilenode returning if2109
  gc_frame_end(frame);
  return if2109;
}
Object meth_ast_pretty1924(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1925 == NULL) {
    strlit1925 = alloc_String("");
    gc_root(strlit1925);
  }
// compilenode returning strlit1925
  *var_spc = strlit1925;
  if (strlit1925 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1926 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_1927 = gc_frame_newslot(*var_depth);
  Object num1929 = alloc_Float64(0);
// compilenode returning num1929
  int op_slot_left_1927 = gc_frame_newslot(num1929);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult1930 = callmethod(num1929, "..", 1, partcv, params);
// compilenode returning opresult1930
  gc_frame_newslot(opresult1930);
  Object block1931 = alloc_Block(NULL, NULL, "ast", 454);
  gc_frame_newslot(block1931);
  block_savedest(block1931);
  Object closure1932 = createclosure(2, "_apply");
setclosureframe(closure1932, stackframe);
  addtoclosure(closure1932, var_spc);
  addtoclosure(closure1932, selfslot);
  struct UserObject *uo1932 = (struct UserObject*)block1931;
  uo1932->data[0] = (Object)closure1932;
  Method *meth_meth_ast__apply1932 = addmethod2pos(block1931, "_apply", &meth_ast__apply1932, 0);
int argcv_meth_ast__apply1932[] = {1};
meth_meth_ast__apply1932->type = alloc_MethodType(1, argcv_meth_ast__apply1932);
  meth_meth_ast__apply1932->definitionModule = modulename;
  meth_meth_ast__apply1932->definitionLine = 443;
// compilenode returning block1931
  gc_frame_newslot(block1931);
  params[0] = opresult1930;
  params[1] = block1931;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1939 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1926);
// compilenode returning call1939
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 457
  setline(457);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1940 == NULL) {
    strlit1940 = alloc_String("MethodType""\x0a""");
    gc_root(strlit1940);
  }
// compilenode returning strlit1940
  *var_s = strlit1940;
  if (strlit1940 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 459
  setline(459);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1942 == NULL) {
    strlit1942 = alloc_String("""\x0a""");
    gc_root(strlit1942);
  }
// compilenode returning strlit1942
  int op_slot_right_1941 = gc_frame_newslot(strlit1942);
  int callframe1945 = gc_frame_new();
  partcv[0] = 0;
  Object call1946 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1945);
// compilenode returning call1946
  int op_slot_right_1944 = gc_frame_newslot(call1946);
  if (strlit1949 == NULL) {
    strlit1949 = alloc_String("Name: ");
    gc_root(strlit1949);
  }
// compilenode returning strlit1949
  int op_slot_right_1948 = gc_frame_newslot(strlit1949);
// compilenode returning *var_spc
  int op_slot_right_1951 = gc_frame_newslot(*var_spc);
  if (strlit1954 == NULL) {
    strlit1954 = alloc_String("");
    gc_root(strlit1954);
  }
// compilenode returning strlit1954
  int op_slot_right_1953 = gc_frame_newslot(strlit1954);
// compilenode returning *var_s
  int op_slot_right_1956 = gc_frame_newslot(*var_s);
  if (strlit1958 == NULL) {
    strlit1958 = alloc_String("");
    gc_root(strlit1958);
  }
// compilenode returning strlit1958
  int op_slot_left_1956 = gc_frame_newslot(strlit1958);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult1959 = callmethod(strlit1958, "++", 1, partcv, params);
// compilenode returning opresult1959
  int op_slot_left_1953 = gc_frame_newslot(opresult1959);
  params[0] = strlit1954;
  partcv[0] = 1;
  Object opresult1960 = callmethod(opresult1959, "++", 1, partcv, params);
// compilenode returning opresult1960
  int op_slot_left_1951 = gc_frame_newslot(opresult1960);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1961 = callmethod(opresult1960, "++", 1, partcv, params);
// compilenode returning opresult1961
  int op_slot_left_1948 = gc_frame_newslot(opresult1961);
  params[0] = strlit1949;
  partcv[0] = 1;
  Object opresult1962 = callmethod(opresult1961, "++", 1, partcv, params);
// compilenode returning opresult1962
  int op_slot_left_1944 = gc_frame_newslot(opresult1962);
  params[0] = call1946;
  partcv[0] = 1;
  Object opresult1963 = callmethod(opresult1962, "++", 1, partcv, params);
// compilenode returning opresult1963
  int op_slot_left_1941 = gc_frame_newslot(opresult1963);
  params[0] = strlit1942;
  partcv[0] = 1;
  Object opresult1964 = callmethod(opresult1963, "++", 1, partcv, params);
// compilenode returning opresult1964
  *var_s = opresult1964;
  if (opresult1964 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 462
  setline(462);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 459
  setline(459);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1968 = alloc_Boolean(0);
// compilenode returning bool1968
  int op_slot_right_1967 = gc_frame_newslot(bool1968);
  int callframe1970 = gc_frame_new();
  partcv[0] = 0;
  Object call1971 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1970);
// compilenode returning call1971
  int op_slot_left_1967 = gc_frame_newslot(call1971);
  params[0] = bool1968;
  partcv[0] = 1;
  Object opresult1972 = callmethod(call1971, "!=", 1, partcv, params);
// compilenode returning opresult1972
  Object if1966 = done;
  if (istrue(opresult1972)) {
// Begin line 461
  setline(461);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 460
  setline(460);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1974 == NULL) {
    strlit1974 = alloc_String("""\x0a""");
    gc_root(strlit1974);
  }
// compilenode returning strlit1974
  int op_slot_right_1973 = gc_frame_newslot(strlit1974);
  int callframe1977 = gc_frame_new();
  Object num1979 = alloc_Float64(2);
// compilenode returning num1979
  int op_slot_right_1978 = gc_frame_newslot(num1979);
// compilenode returning *var_depth
  int op_slot_left_1978 = gc_frame_newslot(*var_depth);
  params[0] = num1979;
  partcv[0] = 1;
  Object sum1981 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1981
  gc_frame_newslot(sum1981);
  int callframe1982 = gc_frame_new();
  partcv[0] = 0;
  Object call1983 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1982);
// compilenode returning call1983
  params[0] = sum1981;
  partcv[0] = 1;
  Object call1984 = callmethod(call1983, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1977);
// compilenode returning call1984
  int op_slot_right_1976 = gc_frame_newslot(call1984);
  if (strlit1987 == NULL) {
    strlit1987 = alloc_String("");
    gc_root(strlit1987);
  }
// compilenode returning strlit1987
  int op_slot_right_1986 = gc_frame_newslot(strlit1987);
// compilenode returning *var_spc
  int op_slot_right_1989 = gc_frame_newslot(*var_spc);
  if (strlit1992 == NULL) {
    strlit1992 = alloc_String("Returns:""\x0a""  ");
    gc_root(strlit1992);
  }
// compilenode returning strlit1992
  int op_slot_right_1991 = gc_frame_newslot(strlit1992);
// compilenode returning *var_spc
  int op_slot_right_1994 = gc_frame_newslot(*var_spc);
  if (strlit1997 == NULL) {
    strlit1997 = alloc_String("");
    gc_root(strlit1997);
  }
// compilenode returning strlit1997
  int op_slot_right_1996 = gc_frame_newslot(strlit1997);
// compilenode returning *var_s
  int op_slot_right_1999 = gc_frame_newslot(*var_s);
  if (strlit2001 == NULL) {
    strlit2001 = alloc_String("");
    gc_root(strlit2001);
  }
// compilenode returning strlit2001
  int op_slot_left_1999 = gc_frame_newslot(strlit2001);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2002 = callmethod(strlit2001, "++", 1, partcv, params);
// compilenode returning opresult2002
  int op_slot_left_1996 = gc_frame_newslot(opresult2002);
  params[0] = strlit1997;
  partcv[0] = 1;
  Object opresult2003 = callmethod(opresult2002, "++", 1, partcv, params);
// compilenode returning opresult2003
  int op_slot_left_1994 = gc_frame_newslot(opresult2003);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2004 = callmethod(opresult2003, "++", 1, partcv, params);
// compilenode returning opresult2004
  int op_slot_left_1991 = gc_frame_newslot(opresult2004);
  params[0] = strlit1992;
  partcv[0] = 1;
  Object opresult2005 = callmethod(opresult2004, "++", 1, partcv, params);
// compilenode returning opresult2005
  int op_slot_left_1989 = gc_frame_newslot(opresult2005);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2006 = callmethod(opresult2005, "++", 1, partcv, params);
// compilenode returning opresult2006
  int op_slot_left_1986 = gc_frame_newslot(opresult2006);
  params[0] = strlit1987;
  partcv[0] = 1;
  Object opresult2007 = callmethod(opresult2006, "++", 1, partcv, params);
// compilenode returning opresult2007
  int op_slot_left_1976 = gc_frame_newslot(opresult2007);
  params[0] = call1984;
  partcv[0] = 1;
  Object opresult2008 = callmethod(opresult2007, "++", 1, partcv, params);
// compilenode returning opresult2008
  int op_slot_left_1973 = gc_frame_newslot(opresult2008);
  params[0] = strlit1974;
  partcv[0] = 1;
  Object opresult2009 = callmethod(opresult2008, "++", 1, partcv, params);
// compilenode returning opresult2009
  *var_s = opresult2009;
  if (opresult2009 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1966 = done;
  } else {
  }
// compilenode returning if1966
// Begin line 463
  setline(463);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 462
  setline(462);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2012 == NULL) {
    strlit2012 = alloc_String("Signature:");
    gc_root(strlit2012);
  }
// compilenode returning strlit2012
  int op_slot_right_2011 = gc_frame_newslot(strlit2012);
// compilenode returning *var_spc
  int op_slot_right_2014 = gc_frame_newslot(*var_spc);
  if (strlit2017 == NULL) {
    strlit2017 = alloc_String("");
    gc_root(strlit2017);
  }
// compilenode returning strlit2017
  int op_slot_right_2016 = gc_frame_newslot(strlit2017);
// compilenode returning *var_s
  int op_slot_right_2019 = gc_frame_newslot(*var_s);
  if (strlit2021 == NULL) {
    strlit2021 = alloc_String("");
    gc_root(strlit2021);
  }
// compilenode returning strlit2021
  int op_slot_left_2019 = gc_frame_newslot(strlit2021);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2022 = callmethod(strlit2021, "++", 1, partcv, params);
// compilenode returning opresult2022
  int op_slot_left_2016 = gc_frame_newslot(opresult2022);
  params[0] = strlit2017;
  partcv[0] = 1;
  Object opresult2023 = callmethod(opresult2022, "++", 1, partcv, params);
// compilenode returning opresult2023
  int op_slot_left_2014 = gc_frame_newslot(opresult2023);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2024 = callmethod(opresult2023, "++", 1, partcv, params);
// compilenode returning opresult2024
  int op_slot_left_2011 = gc_frame_newslot(opresult2024);
  params[0] = strlit2012;
  partcv[0] = 1;
  Object opresult2025 = callmethod(opresult2024, "++", 1, partcv, params);
// compilenode returning opresult2025
  *var_s = opresult2025;
  if (opresult2025 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 463
  setline(463);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2027 = gc_frame_new();
  int callframe2028 = gc_frame_new();
  partcv[0] = 0;
  Object call2029 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2028);
// compilenode returning call2029
  gc_frame_newslot(call2029);
  Object block2030 = alloc_Block(NULL, NULL, "ast", 463);
  gc_frame_newslot(block2030);
  block_savedest(block2030);
  Object closure2031 = createclosure(4, "_apply");
setclosureframe(closure2031, stackframe);
  addtoclosure(closure2031, var_spc);
  addtoclosure(closure2031, var_s);
  addtoclosure(closure2031, var_depth);
  addtoclosure(closure2031, selfslot);
  struct UserObject *uo2031 = (struct UserObject*)block2030;
  uo2031->data[0] = (Object)closure2031;
  Method *meth_meth_ast__apply2031 = addmethod2pos(block2030, "_apply", &meth_ast__apply2031, 0);
int argcv_meth_ast__apply2031[] = {1};
meth_meth_ast__apply2031->type = alloc_MethodType(1, argcv_meth_ast__apply2031);
  meth_meth_ast__apply2031->definitionModule = modulename;
  meth_meth_ast__apply2031->definitionLine = 443;
// compilenode returning block2030
  gc_frame_newslot(block2030);
  params[0] = call2029;
  params[1] = block2030;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2148 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2027);
// compilenode returning call2148
// Begin line 473
  setline(473);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply2191(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_part = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_pnr = &(stackframe->slots[0]);
  *var_pnr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 482
  setline(482);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2192 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2193 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2192);
// compilenode returning call2193
// compilenode returning call2193
// compilenode returning *var_pnr
  params[0] = *var_pnr;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres2194 = callmethod(call2193, "[]", 1, partcv, params);
// compilenode returning idxres2194
  *var_p = idxres2194;
  if (idxres2194 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2196 = gc_frame_new();
  Object num2198 = alloc_Float64(1);
// compilenode returning num2198
  int op_slot_right_2197 = gc_frame_newslot(num2198);
// compilenode returning *var_depth
  int op_slot_left_2197 = gc_frame_newslot(*var_depth);
  params[0] = num2198;
  partcv[0] = 1;
  Object sum2200 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum2200
  gc_frame_newslot(sum2200);
// compilenode returning *var_p
  params[0] = sum2200;
  partcv[0] = 1;
  Object call2201 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2196);
// compilenode returning call2201
  int op_slot_right_2195 = gc_frame_newslot(call2201);
// compilenode returning *var_s
  int op_slot_left_2195 = gc_frame_newslot(*var_s);
  params[0] = call2201;
  partcv[0] = 1;
  Object opresult2203 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2203
  *var_s = opresult2203;
  if (opresult2203 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 487
  setline(487);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 484
  setline(484);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool2208 = alloc_Boolean(0);
// compilenode returning bool2208
  int op_slot_right_2207 = gc_frame_newslot(bool2208);
  int callframe2210 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2211 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe2210);
// compilenode returning call2211
// compilenode returning call2211
  int op_slot_left_2207 = gc_frame_newslot(call2211);
  params[0] = bool2208;
  partcv[0] = 1;
  Object opresult2212 = callmethod(call2211, "!=", 1, partcv, params);
// compilenode returning opresult2212
  int op_slot_right_2206 = gc_frame_newslot(opresult2212);
  int callframe2215 = gc_frame_new();
  int callframe2216 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2217 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2216);
// compilenode returning call2217
// compilenode returning call2217
  partcv[0] = 0;
  Object call2218 = callmethod(call2217, "size",
    1, partcv, params);
  gc_frame_end(callframe2215);
// compilenode returning call2218
// compilenode returning call2218
  int op_slot_right_2214 = gc_frame_newslot(call2218);
// compilenode returning *var_pnr
  int op_slot_left_2214 = gc_frame_newslot(*var_pnr);
  params[0] = call2218;
  partcv[0] = 1;
  Object opresult2220 = callmethod(*var_pnr, "<", 1, partcv, params);
// compilenode returning opresult2220
  int op_slot_left_2206 = gc_frame_newslot(opresult2220);
  params[0] = opresult2212;
  partcv[0] = 1;
  Object opresult2221 = callmethod(opresult2220, "||", 1, partcv, params);
// compilenode returning opresult2221
  Object if2205 = done;
  if (istrue(opresult2221)) {
// Begin line 486
  setline(486);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 485
  setline(485);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2223 == NULL) {
    strlit2223 = alloc_String(", ");
    gc_root(strlit2223);
  }
// compilenode returning strlit2223
  int op_slot_right_2222 = gc_frame_newslot(strlit2223);
// compilenode returning *var_s
  int op_slot_left_2222 = gc_frame_newslot(*var_s);
  params[0] = strlit2223;
  partcv[0] = 1;
  Object opresult2225 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2225
  *var_s = opresult2225;
  if (opresult2225 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2205 = done;
  } else {
  }
// compilenode returning if2205
  gc_frame_end(frame);
  return if2205;
}
Object meth_ast__apply2155(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 479
  setline(479);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 478
  setline(478);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2157 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2158 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe2157);
// compilenode returning call2158
// compilenode returning call2158
  int op_slot_right_2156 = gc_frame_newslot(call2158);
// compilenode returning *var_s
  int op_slot_left_2156 = gc_frame_newslot(*var_s);
  params[0] = call2158;
  partcv[0] = 1;
  Object opresult2160 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2160
  *var_s = opresult2160;
  if (opresult2160 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 493
  setline(493);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 479
  setline(479);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool2165 = alloc_Boolean(0);
// compilenode returning bool2165
  int op_slot_right_2164 = gc_frame_newslot(bool2165);
  int callframe2167 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2168 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe2167);
// compilenode returning call2168
// compilenode returning call2168
  int op_slot_left_2164 = gc_frame_newslot(call2168);
  params[0] = bool2165;
  partcv[0] = 1;
  Object opresult2169 = callmethod(call2168, "!=", 1, partcv, params);
// compilenode returning opresult2169
  int op_slot_right_2163 = gc_frame_newslot(opresult2169);
  Object num2172 = alloc_Float64(0);
// compilenode returning num2172
  int op_slot_right_2171 = gc_frame_newslot(num2172);
  int callframe2174 = gc_frame_new();
  int callframe2175 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2176 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2175);
// compilenode returning call2176
// compilenode returning call2176
  partcv[0] = 0;
  Object call2177 = callmethod(call2176, "size",
    1, partcv, params);
  gc_frame_end(callframe2174);
// compilenode returning call2177
// compilenode returning call2177
  int op_slot_left_2171 = gc_frame_newslot(call2177);
  params[0] = num2172;
  partcv[0] = 1;
  Object opresult2178 = callmethod(call2177, ">", 1, partcv, params);
// compilenode returning opresult2178
  int op_slot_left_2163 = gc_frame_newslot(opresult2178);
  params[0] = opresult2169;
  partcv[0] = 1;
  Object opresult2179 = callmethod(opresult2178, "||", 1, partcv, params);
// compilenode returning opresult2179
  Object if2162 = done;
  if (istrue(opresult2179)) {
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 480
  setline(480);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2181 == NULL) {
    strlit2181 = alloc_String("(");
    gc_root(strlit2181);
  }
// compilenode returning strlit2181
  int op_slot_right_2180 = gc_frame_newslot(strlit2181);
// compilenode returning *var_s
  int op_slot_left_2180 = gc_frame_newslot(*var_s);
  params[0] = strlit2181;
  partcv[0] = 1;
  Object opresult2183 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2183
  *var_s = opresult2183;
  if (opresult2183 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2185 = gc_frame_new();
  int callframe2186 = gc_frame_new();
  int callframe2187 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2188 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2187);
// compilenode returning call2188
// compilenode returning call2188
  partcv[0] = 0;
  Object call2189 = callmethod(call2188, "indices",
    1, partcv, params);
  gc_frame_end(callframe2186);
// compilenode returning call2189
// compilenode returning call2189
  gc_frame_newslot(call2189);
  Object block2190 = alloc_Block(NULL, NULL, "ast", 481);
  gc_frame_newslot(block2190);
  block_savedest(block2190);
  Object closure2191 = createclosure(4, "_apply");
setclosureframe(closure2191, stackframe);
  addtoclosure(closure2191, var_part);
  addtoclosure(closure2191, var_depth);
  addtoclosure(closure2191, var_s);
  addtoclosure(closure2191, selfslot);
  struct UserObject *uo2191 = (struct UserObject*)block2190;
  uo2191->data[0] = (Object)closure2191;
  Method *meth_meth_ast__apply2191 = addmethod2pos(block2190, "_apply", &meth_ast__apply2191, 0);
int argcv_meth_ast__apply2191[] = {1};
meth_meth_ast__apply2191->type = alloc_MethodType(1, argcv_meth_ast__apply2191);
  meth_meth_ast__apply2191->definitionModule = modulename;
  meth_meth_ast__apply2191->definitionLine = 481;
// compilenode returning block2190
  gc_frame_newslot(block2190);
  params[0] = call2189;
  params[1] = block2190;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2228 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2185);
// compilenode returning call2228
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 488
  setline(488);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool2231 = alloc_Boolean(0);
// compilenode returning bool2231
  int op_slot_right_2230 = gc_frame_newslot(bool2231);
  int callframe2233 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2234 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe2233);
// compilenode returning call2234
// compilenode returning call2234
  int op_slot_left_2230 = gc_frame_newslot(call2234);
  params[0] = bool2231;
  partcv[0] = 1;
  Object opresult2235 = callmethod(call2234, "!=", 1, partcv, params);
// compilenode returning opresult2235
  Object if2229 = done;
  if (istrue(opresult2235)) {
// Begin line 490
  setline(490);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 489
  setline(489);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2237 = gc_frame_new();
  int callframe2238 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2239 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe2238);
// compilenode returning call2239
// compilenode returning call2239
  partcv[0] = 0;
  Object call2240 = callmethod(call2239, "value",
    1, partcv, params);
  gc_frame_end(callframe2237);
// compilenode returning call2240
// compilenode returning call2240
  int op_slot_right_2236 = gc_frame_newslot(call2240);
  if (strlit2243 == NULL) {
    strlit2243 = alloc_String("*");
    gc_root(strlit2243);
  }
// compilenode returning strlit2243
  int op_slot_right_2242 = gc_frame_newslot(strlit2243);
// compilenode returning *var_s
  int op_slot_left_2242 = gc_frame_newslot(*var_s);
  params[0] = strlit2243;
  partcv[0] = 1;
  Object opresult2245 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2245
  int op_slot_left_2236 = gc_frame_newslot(opresult2245);
  params[0] = call2240;
  partcv[0] = 1;
  Object opresult2246 = callmethod(opresult2245, "++", 1, partcv, params);
// compilenode returning opresult2246
  *var_s = opresult2246;
  if (opresult2246 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2229 = done;
  } else {
  }
// compilenode returning if2229
// Begin line 492
  setline(492);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2249 == NULL) {
    strlit2249 = alloc_String(")");
    gc_root(strlit2249);
  }
// compilenode returning strlit2249
  int op_slot_right_2248 = gc_frame_newslot(strlit2249);
// compilenode returning *var_s
  int op_slot_left_2248 = gc_frame_newslot(*var_s);
  params[0] = strlit2249;
  partcv[0] = 1;
  Object opresult2251 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2251
  *var_s = opresult2251;
  if (opresult2251 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2162 = done;
  } else {
  }
// compilenode returning if2162
  gc_frame_end(frame);
  return if2162;
}
Object meth_ast_toGrace2149(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 476
  setline(476);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2150 == NULL) {
    strlit2150 = alloc_String("");
    gc_root(strlit2150);
  }
// compilenode returning strlit2150
  *var_s = strlit2150;
  if (strlit2150 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2151 = gc_frame_new();
  int callframe2152 = gc_frame_new();
  partcv[0] = 0;
  Object call2153 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2152);
// compilenode returning call2153
// compilenode returning call2153
  gc_frame_newslot(call2153);
  Object block2154 = alloc_Block(NULL, NULL, "ast", 477);
  gc_frame_newslot(block2154);
  block_savedest(block2154);
  Object closure2155 = createclosure(3, "_apply");
setclosureframe(closure2155, stackframe);
  addtoclosure(closure2155, var_s);
  addtoclosure(closure2155, var_depth);
  addtoclosure(closure2155, selfslot);
  struct UserObject *uo2155 = (struct UserObject*)block2154;
  uo2155->data[0] = (Object)closure2155;
  Method *meth_meth_ast__apply2155 = addmethod2pos(block2154, "_apply", &meth_ast__apply2155, 0);
int argcv_meth_ast__apply2155[] = {1};
meth_meth_ast__apply2155->type = alloc_MethodType(1, argcv_meth_ast__apply2155);
  meth_meth_ast__apply2155->definitionModule = modulename;
  meth_meth_ast__apply2155->definitionLine = 477;
// compilenode returning block2154
  gc_frame_newslot(block2154);
  params[0] = call2153;
  params[1] = block2154;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2254 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2151);
// compilenode returning call2254
// Begin line 497
  setline(497);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 494
  setline(494);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool2257 = alloc_Boolean(0);
// compilenode returning bool2257
  int op_slot_right_2256 = gc_frame_newslot(bool2257);
  int callframe2259 = gc_frame_new();
  partcv[0] = 0;
  Object call2260 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2259);
// compilenode returning call2260
// compilenode returning call2260
  int op_slot_left_2256 = gc_frame_newslot(call2260);
  params[0] = bool2257;
  partcv[0] = 1;
  Object opresult2261 = callmethod(call2260, "!=", 1, partcv, params);
// compilenode returning opresult2261
  Object if2255 = done;
  if (istrue(opresult2261)) {
// Begin line 495
  setline(495);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2263 = gc_frame_new();
  Object num2265 = alloc_Float64(1);
// compilenode returning num2265
  int op_slot_right_2264 = gc_frame_newslot(num2265);
// compilenode returning *var_depth
  int op_slot_left_2264 = gc_frame_newslot(*var_depth);
  params[0] = num2265;
  partcv[0] = 1;
  Object sum2267 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum2267
  gc_frame_newslot(sum2267);
  int callframe2268 = gc_frame_new();
  partcv[0] = 0;
  Object call2269 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2268);
// compilenode returning call2269
// compilenode returning call2269
  params[0] = sum2267;
  partcv[0] = 1;
  Object call2270 = callmethod(call2269, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2263);
// compilenode returning call2270
  int op_slot_right_2262 = gc_frame_newslot(call2270);
  if (strlit2273 == NULL) {
    strlit2273 = alloc_String(" -> ");
    gc_root(strlit2273);
  }
// compilenode returning strlit2273
  int op_slot_right_2272 = gc_frame_newslot(strlit2273);
// compilenode returning *var_s
  int op_slot_left_2272 = gc_frame_newslot(*var_s);
  params[0] = strlit2273;
  partcv[0] = 1;
  Object opresult2275 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2275
  int op_slot_left_2262 = gc_frame_newslot(opresult2275);
  params[0] = call2270;
  partcv[0] = 1;
  Object opresult2276 = callmethod(opresult2275, "++", 1, partcv, params);
// compilenode returning opresult2276
  *var_s = opresult2276;
  if (opresult2276 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2255 = done;
  } else {
  }
// compilenode returning if2255
// Begin line 497
  setline(497);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new1831(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_methodTypeNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_rtype_39_ = &(stackframe->slots[2]);
  *var_rtype_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1832 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1832 = alloc_userobj2(12,12, objclass1832);
  gc_frame_newslot(obj1832);
if (objclass1832 == NULL) {
  glfree(obj1832->class->name);
  obj1832->class->name = "methodTypeNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1832, self, 0);
  addmethodreal(obj1832,"outer", &reader_ast_outer_1833);
  Object oldself1832 = self;
  struct StackFrameObject *oldstackframe1832 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1832);
  gc_frame_newslot((Object)stackframe);
  self = obj1832;
  Object *oldselfslot1832 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1832 = (*(struct UserObject *)self).data[0], lowerouter1832 = thisouter1832;
  if (inheritingObject1832) {
    struct UserObject *inho1832 = (struct UserObject *)inheritingObject1832;
    while (inho1832->super != GraceDefaultObject) inho1832 = (struct UserObject *)inho1832->super;
    inho1832->super = obj1832;
    self = inheritingObject1832;
    *selfslot = self;
    lowerouter1832 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1832;
  }
if (objclass1832 == NULL) {
  Method *reader1834 = addmethodrealflags(obj1832, "kind",&reader_ast_kind_1834, MFLAG_DEF);
  reader1834->definitionModule = modulename;
  reader1834->definitionLine = 418;
}
adddatum2(obj1832, alloc_Undefined(), 1);
if (objclass1832 == NULL) {
  Method *reader1835 = addmethodrealflags(obj1832, "value",&reader_ast_value_1835, MFLAG_DEF);
  reader1835->definitionModule = modulename;
  reader1835->definitionLine = 419;
}
adddatum2(obj1832, alloc_Undefined(), 2);
if (objclass1832 == NULL) {
  Method *reader1836 = addmethodrealflags(obj1832, "signature",&reader_ast_signature_1836, MFLAG_DEF);
  reader1836->definitionModule = modulename;
  reader1836->definitionLine = 420;
}
adddatum2(obj1832, alloc_Undefined(), 3);
if (objclass1832 == NULL) {
  Method *reader1837 = addmethodrealflags(obj1832, "rtype",&reader_ast_rtype_1837, MFLAG_DEF);
  reader1837->definitionModule = modulename;
  reader1837->definitionLine = 421;
}
adddatum2(obj1832, alloc_Undefined(), 4);
if (objclass1832 == NULL) {
  Method *reader1838 = addmethodrealflags(obj1832, "generics",&reader_ast_generics_1838, 0);
  Method *writer1838 = addmethodrealflags(obj1832, "generics:=",&writer_ast_generics_1838, 0);
  reader1838->definitionModule = modulename;
  writer1838->definitionModule = modulename;
  reader1838->definitionLine = 422;
  writer1838->definitionLine = 422;
}
obj1832->flags |= OFLAG_MUTABLE;
adddatum2(obj1832, alloc_Undefined(), 5);
  struct UserObject *uo1839 = (struct UserObject*)obj1832;
  uo1839->data[6] = emptyclosure;
  Method *meth_meth_ast_accept1839 = addmethod2pos(obj1832, "accept", &meth_ast_accept1839, 6);
int argcv_meth_ast_accept1839[] = {1};
meth_meth_ast_accept1839->type = alloc_MethodType(1, argcv_meth_ast_accept1839);
meth_meth_ast_accept1839->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept1839->type->names[0] = "visitor";
  meth_meth_ast_accept1839->definitionModule = modulename;
  meth_meth_ast_accept1839->definitionLine = 422;
  block_savedest(obj1832);
  Object closure1881 = createclosure(1, "map()before()after");
setclosureframe(closure1881, stackframe);
  addtoclosure(closure1881, var_methodTypeNode);
  struct UserObject *uo1881 = (struct UserObject*)obj1832;
  uo1881->data[7] = (Object)closure1881;
  Method *meth_meth_ast_map_40__41_before_40__41_after1881 = addmethod2pos(obj1832, "map()before()after", &meth_ast_map_40__41_before_40__41_after1881, 7);
int argcv_meth_ast_map_40__41_before_40__41_after1881[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after1881->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after1881);
  meth_meth_ast_map_40__41_before_40__41_after1881->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after1881->definitionLine = 437;
  struct UserObject *uo1915 = (struct UserObject*)obj1832;
  uo1915->data[8] = emptyclosure;
  Method *meth_meth_ast_map1915 = addmethod2pos(obj1832, "map", &meth_ast_map1915, 8);
int argcv_meth_ast_map1915[] = {1};
meth_meth_ast_map1915->type = alloc_MethodType(1, argcv_meth_ast_map1915);
  meth_meth_ast_map1915->definitionModule = modulename;
  meth_meth_ast_map1915->definitionLine = 449;
  struct UserObject *uo1924 = (struct UserObject*)obj1832;
  uo1924->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty1924 = addmethod2pos(obj1832, "pretty", &meth_ast_pretty1924, 9);
int argcv_meth_ast_pretty1924[] = {1};
meth_meth_ast_pretty1924->type = alloc_MethodType(1, argcv_meth_ast_pretty1924);
  meth_meth_ast_pretty1924->definitionModule = modulename;
  meth_meth_ast_pretty1924->definitionLine = 452;
  struct UserObject *uo2149 = (struct UserObject*)obj1832;
  uo2149->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace2149 = addmethod2pos(obj1832, "toGrace", &meth_ast_toGrace2149, 10);
int argcv_meth_ast_toGrace2149[] = {1};
meth_meth_ast_toGrace2149->type = alloc_MethodType(1, argcv_meth_ast_toGrace2149);
meth_meth_ast_toGrace2149->type->types[0] = type_Number;
meth_meth_ast_toGrace2149->type->names[0] = "depth";
  meth_meth_ast_toGrace2149->definitionModule = modulename;
  meth_meth_ast_toGrace2149->definitionLine = 475;
  sourceObject = obj1832;
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2278 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2279 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe2278);
// compilenode returning call2279
  struct UserObject *obj1832_uo = (struct UserObject *)obj1832;
  obj1832_uo->super = call2279;
  sourceObject = obj1832;
// Begin line 417
  setline(417);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2280 == NULL) {
    strlit2280 = alloc_String("methodtype");
    gc_root(strlit2280);
  }
// compilenode returning strlit2280
  adddatum2(obj1832, strlit2280, 1);
  sourceObject = obj1832;
// Begin line 418
  setline(418);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name_39_
  adddatum2(obj1832, *var_name_39_, 2);
  sourceObject = obj1832;
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_signature_39_
  adddatum2(obj1832, *var_signature_39_, 3);
  sourceObject = obj1832;
// Begin line 420
  setline(420);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_rtype_39_
  adddatum2(obj1832, *var_rtype_39_, 4);
  sourceObject = obj1832;
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array2281 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array2281
  adddatum2(obj1832, array2281, 5);
  sourceObject = obj1832;
  sourceObject = obj1832;
  sourceObject = obj1832;
  sourceObject = obj1832;
  sourceObject = obj1832;
objclass1832 = obj1832->class;
  objclass1832->definitionModule = modulename;
  objclass1832->definitionLine = 395;
  (*(struct UserObject *)self).data[0] = lowerouter1832;
  self = oldself1832;
  selfslot = oldselfslot1832;
  stackframe = oldstackframe1832;
  gc_frame_end(frame);
  return obj1832;
}
Object meth_ast_new1831_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_methodTypeNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_rtype_39_ = &(stackframe->slots[2]);
  *var_rtype_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1832 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1832 = alloc_userobj2(12,12, objclass1832);
  gc_frame_newslot(obj1832);
if (objclass1832 == NULL) {
  glfree(obj1832->class->name);
  obj1832->class->name = "methodTypeNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1832, self, 0);
  addmethodreal(obj1832,"outer", &reader_ast_outer_1833);
  Object oldself1832 = self;
  struct StackFrameObject *oldstackframe1832 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1832);
  gc_frame_newslot((Object)stackframe);
  self = obj1832;
  Object *oldselfslot1832 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1832 = (*(struct UserObject *)self).data[0], lowerouter1832 = thisouter1832;
  if (inheritingObject1832) {
    struct UserObject *inho1832 = (struct UserObject *)inheritingObject1832;
    while (inho1832->super != GraceDefaultObject) inho1832 = (struct UserObject *)inho1832->super;
    inho1832->super = obj1832;
    self = inheritingObject1832;
    *selfslot = self;
    lowerouter1832 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1832;
  }
if (objclass1832 == NULL) {
  Method *reader1834 = addmethodrealflags(obj1832, "kind",&reader_ast_kind_1834, MFLAG_DEF);
  reader1834->definitionModule = modulename;
  reader1834->definitionLine = 418;
}
adddatum2(obj1832, alloc_Undefined(), 1);
if (objclass1832 == NULL) {
  Method *reader1835 = addmethodrealflags(obj1832, "value",&reader_ast_value_1835, MFLAG_DEF);
  reader1835->definitionModule = modulename;
  reader1835->definitionLine = 419;
}
adddatum2(obj1832, alloc_Undefined(), 2);
if (objclass1832 == NULL) {
  Method *reader1836 = addmethodrealflags(obj1832, "signature",&reader_ast_signature_1836, MFLAG_DEF);
  reader1836->definitionModule = modulename;
  reader1836->definitionLine = 420;
}
adddatum2(obj1832, alloc_Undefined(), 3);
if (objclass1832 == NULL) {
  Method *reader1837 = addmethodrealflags(obj1832, "rtype",&reader_ast_rtype_1837, MFLAG_DEF);
  reader1837->definitionModule = modulename;
  reader1837->definitionLine = 421;
}
adddatum2(obj1832, alloc_Undefined(), 4);
if (objclass1832 == NULL) {
  Method *reader1838 = addmethodrealflags(obj1832, "generics",&reader_ast_generics_1838, 0);
  Method *writer1838 = addmethodrealflags(obj1832, "generics:=",&writer_ast_generics_1838, 0);
  reader1838->definitionModule = modulename;
  writer1838->definitionModule = modulename;
  reader1838->definitionLine = 422;
  writer1838->definitionLine = 422;
}
obj1832->flags |= OFLAG_MUTABLE;
adddatum2(obj1832, alloc_Undefined(), 5);
  struct UserObject *uo1839 = (struct UserObject*)obj1832;
  uo1839->data[6] = emptyclosure;
  Method *meth_meth_ast_accept1839 = addmethod2pos(obj1832, "accept", &meth_ast_accept1839, 6);
int argcv_meth_ast_accept1839[] = {1};
meth_meth_ast_accept1839->type = alloc_MethodType(1, argcv_meth_ast_accept1839);
meth_meth_ast_accept1839->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept1839->type->names[0] = "visitor";
  meth_meth_ast_accept1839->definitionModule = modulename;
  meth_meth_ast_accept1839->definitionLine = 422;
  block_savedest(obj1832);
  Object closure1881 = createclosure(1, "map()before()after");
setclosureframe(closure1881, stackframe);
  addtoclosure(closure1881, var_methodTypeNode);
  struct UserObject *uo1881 = (struct UserObject*)obj1832;
  uo1881->data[7] = (Object)closure1881;
  Method *meth_meth_ast_map_40__41_before_40__41_after1881 = addmethod2pos(obj1832, "map()before()after", &meth_ast_map_40__41_before_40__41_after1881, 7);
int argcv_meth_ast_map_40__41_before_40__41_after1881[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after1881->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after1881);
  meth_meth_ast_map_40__41_before_40__41_after1881->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after1881->definitionLine = 437;
  struct UserObject *uo1915 = (struct UserObject*)obj1832;
  uo1915->data[8] = emptyclosure;
  Method *meth_meth_ast_map1915 = addmethod2pos(obj1832, "map", &meth_ast_map1915, 8);
int argcv_meth_ast_map1915[] = {1};
meth_meth_ast_map1915->type = alloc_MethodType(1, argcv_meth_ast_map1915);
  meth_meth_ast_map1915->definitionModule = modulename;
  meth_meth_ast_map1915->definitionLine = 449;
  struct UserObject *uo1924 = (struct UserObject*)obj1832;
  uo1924->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty1924 = addmethod2pos(obj1832, "pretty", &meth_ast_pretty1924, 9);
int argcv_meth_ast_pretty1924[] = {1};
meth_meth_ast_pretty1924->type = alloc_MethodType(1, argcv_meth_ast_pretty1924);
  meth_meth_ast_pretty1924->definitionModule = modulename;
  meth_meth_ast_pretty1924->definitionLine = 452;
  struct UserObject *uo2149 = (struct UserObject*)obj1832;
  uo2149->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace2149 = addmethod2pos(obj1832, "toGrace", &meth_ast_toGrace2149, 10);
int argcv_meth_ast_toGrace2149[] = {1};
meth_meth_ast_toGrace2149->type = alloc_MethodType(1, argcv_meth_ast_toGrace2149);
meth_meth_ast_toGrace2149->type->types[0] = type_Number;
meth_meth_ast_toGrace2149->type->names[0] = "depth";
  meth_meth_ast_toGrace2149->definitionModule = modulename;
  meth_meth_ast_toGrace2149->definitionLine = 475;
  sourceObject = obj1832;
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2278 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2279 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe2278);
// compilenode returning call2279
  struct UserObject *obj1832_uo = (struct UserObject *)obj1832;
  obj1832_uo->super = call2279;
  sourceObject = obj1832;
// Begin line 417
  setline(417);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2280 == NULL) {
    strlit2280 = alloc_String("methodtype");
    gc_root(strlit2280);
  }
// compilenode returning strlit2280
  adddatum2(obj1832, strlit2280, 1);
  sourceObject = obj1832;
// Begin line 418
  setline(418);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name_39_
  adddatum2(obj1832, *var_name_39_, 2);
  sourceObject = obj1832;
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_signature_39_
  adddatum2(obj1832, *var_signature_39_, 3);
  sourceObject = obj1832;
// Begin line 420
  setline(420);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_rtype_39_
  adddatum2(obj1832, *var_rtype_39_, 4);
  sourceObject = obj1832;
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array2281 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array2281
  adddatum2(obj1832, array2281, 5);
  sourceObject = obj1832;
  sourceObject = obj1832;
  sourceObject = obj1832;
  sourceObject = obj1832;
  sourceObject = obj1832;
objclass1832 = obj1832->class;
  objclass1832->definitionModule = modulename;
  objclass1832->definitionLine = 395;
  (*(struct UserObject *)self).data[0] = lowerouter1832;
  self = oldself1832;
  selfslot = oldselfslot1832;
  stackframe = oldstackframe1832;
  gc_frame_end(frame);
  return obj1832;
}
Object meth_ast_typeNode2283(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for typeNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for typeNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_typeNode
  gc_frame_end(frame);
  return *var_typeNode;
}
Object meth_ast__apply2315(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ut = &(stackframe->slots[0]);
  *var_ut = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 515
  setline(515);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2316 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_ut
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call2317 = callmethod(*var_ut, "accept",
    1, partcv, params);
  gc_frame_end(callframe2316);
// compilenode returning call2317
  gc_frame_end(frame);
  return call2317;
}
Object meth_ast__apply2333(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_it = &(stackframe->slots[0]);
  *var_it = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2334 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_it
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call2335 = callmethod(*var_it, "accept",
    1, partcv, params);
  gc_frame_end(callframe2334);
// compilenode returning call2335
  gc_frame_end(frame);
  return call2335;
}
Object meth_ast__apply2342(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 524
  setline(524);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2343 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_mx
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call2344 = callmethod(*var_mx, "accept",
    1, partcv, params);
  gc_frame_end(callframe2343);
// compilenode returning call2344
  gc_frame_end(frame);
  return call2344;
}
Object meth_ast_accept2298(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 527
  setline(527);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 512
  setline(512);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2300 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call2301 = callmethod(*var_visitor, "visitType",
    1, partcv, params);
  gc_frame_end(callframe2300);
// compilenode returning call2301
  Object if2299 = done;
  if (istrue(call2301)) {
// Begin line 518
  setline(518);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2304 = alloc_Float64(0);
// compilenode returning num2304
  int op_slot_right_2303 = gc_frame_newslot(num2304);
  int callframe2306 = gc_frame_new();
  int callframe2307 = gc_frame_new();
  partcv[0] = 0;
  Object call2308 = callmethodflags(self, "unionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2307);
// compilenode returning call2308
// compilenode returning call2308
  partcv[0] = 0;
  Object call2309 = callmethod(call2308, "size",
    1, partcv, params);
  gc_frame_end(callframe2306);
// compilenode returning call2309
// compilenode returning call2309
  int op_slot_left_2303 = gc_frame_newslot(call2309);
  params[0] = num2304;
  partcv[0] = 1;
  Object opresult2310 = callmethod(call2309, ">", 1, partcv, params);
// compilenode returning opresult2310
  Object if2302 = done;
  if (istrue(opresult2310)) {
// Begin line 514
  setline(514);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2311 = gc_frame_new();
  int callframe2312 = gc_frame_new();
  partcv[0] = 0;
  Object call2313 = callmethodflags(self, "unionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2312);
// compilenode returning call2313
// compilenode returning call2313
  gc_frame_newslot(call2313);
  Object block2314 = alloc_Block(NULL, NULL, "ast", 514);
  gc_frame_newslot(block2314);
  block_savedest(block2314);
  Object closure2315 = createclosure(2, "_apply");
setclosureframe(closure2315, stackframe);
  addtoclosure(closure2315, var_visitor);
  addtoclosure(closure2315, selfslot);
  struct UserObject *uo2315 = (struct UserObject*)block2314;
  uo2315->data[0] = (Object)closure2315;
  Method *meth_meth_ast__apply2315 = addmethod2pos(block2314, "_apply", &meth_ast__apply2315, 0);
int argcv_meth_ast__apply2315[] = {1};
meth_meth_ast__apply2315->type = alloc_MethodType(1, argcv_meth_ast__apply2315);
  meth_meth_ast__apply2315->definitionModule = modulename;
  meth_meth_ast__apply2315->definitionLine = 514;
// compilenode returning block2314
  gc_frame_newslot(block2314);
  params[0] = call2313;
  params[1] = block2314;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2319 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2311);
// compilenode returning call2319
    gc_frame_newslot(call2319);
    if2302 = call2319;
  } else {
  }
// compilenode returning if2302
// Begin line 523
  setline(523);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 518
  setline(518);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2322 = alloc_Float64(0);
// compilenode returning num2322
  int op_slot_right_2321 = gc_frame_newslot(num2322);
  int callframe2324 = gc_frame_new();
  int callframe2325 = gc_frame_new();
  partcv[0] = 0;
  Object call2326 = callmethodflags(self, "intersectionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2325);
// compilenode returning call2326
// compilenode returning call2326
  partcv[0] = 0;
  Object call2327 = callmethod(call2326, "size",
    1, partcv, params);
  gc_frame_end(callframe2324);
// compilenode returning call2327
// compilenode returning call2327
  int op_slot_left_2321 = gc_frame_newslot(call2327);
  params[0] = num2322;
  partcv[0] = 1;
  Object opresult2328 = callmethod(call2327, ">", 1, partcv, params);
// compilenode returning opresult2328
  Object if2320 = done;
  if (istrue(opresult2328)) {
// Begin line 519
  setline(519);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2329 = gc_frame_new();
  int callframe2330 = gc_frame_new();
  partcv[0] = 0;
  Object call2331 = callmethodflags(self, "intersectionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2330);
// compilenode returning call2331
// compilenode returning call2331
  gc_frame_newslot(call2331);
  Object block2332 = alloc_Block(NULL, NULL, "ast", 519);
  gc_frame_newslot(block2332);
  block_savedest(block2332);
  Object closure2333 = createclosure(2, "_apply");
setclosureframe(closure2333, stackframe);
  addtoclosure(closure2333, var_visitor);
  addtoclosure(closure2333, selfslot);
  struct UserObject *uo2333 = (struct UserObject*)block2332;
  uo2333->data[0] = (Object)closure2333;
  Method *meth_meth_ast__apply2333 = addmethod2pos(block2332, "_apply", &meth_ast__apply2333, 0);
int argcv_meth_ast__apply2333[] = {1};
meth_meth_ast__apply2333->type = alloc_MethodType(1, argcv_meth_ast__apply2333);
  meth_meth_ast__apply2333->definitionModule = modulename;
  meth_meth_ast__apply2333->definitionLine = 519;
// compilenode returning block2332
  gc_frame_newslot(block2332);
  params[0] = call2331;
  params[1] = block2332;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2337 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2329);
// compilenode returning call2337
    gc_frame_newslot(call2337);
    if2320 = call2337;
  } else {
  }
// compilenode returning if2320
// Begin line 523
  setline(523);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2338 = gc_frame_new();
  int callframe2339 = gc_frame_new();
  partcv[0] = 0;
  Object call2340 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2339);
// compilenode returning call2340
// compilenode returning call2340
  gc_frame_newslot(call2340);
  Object block2341 = alloc_Block(NULL, NULL, "ast", 523);
  gc_frame_newslot(block2341);
  block_savedest(block2341);
  Object closure2342 = createclosure(2, "_apply");
setclosureframe(closure2342, stackframe);
  addtoclosure(closure2342, var_visitor);
  addtoclosure(closure2342, selfslot);
  struct UserObject *uo2342 = (struct UserObject*)block2341;
  uo2342->data[0] = (Object)closure2342;
  Method *meth_meth_ast__apply2342 = addmethod2pos(block2341, "_apply", &meth_ast__apply2342, 0);
int argcv_meth_ast__apply2342[] = {1};
meth_meth_ast__apply2342->type = alloc_MethodType(1, argcv_meth_ast__apply2342);
  meth_meth_ast__apply2342->definitionModule = modulename;
  meth_meth_ast__apply2342->definitionLine = 523;
// compilenode returning block2341
  gc_frame_newslot(block2341);
  params[0] = call2340;
  params[1] = block2341;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2346 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2338);
// compilenode returning call2346
    gc_frame_newslot(call2346);
    if2299 = call2346;
  } else {
  }
// compilenode returning if2299
  gc_frame_end(frame);
  return if2299;
}
Object meth_ast__apply2383(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_blk = getfromclosure(closure, 0);
  Object *var_blkBefore = getfromclosure(closure, 1);
  Object *var_blkAfter = getfromclosure(closure, 2);
  Object *var_n = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 535
  setline(535);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2384 = gc_frame_new();
  int callframe2385 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// compilenode returning *var_a
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2386 = callmethod(*var_a, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe2385);
// compilenode returning call2386
  gc_frame_newslot(call2386);
  int callframe2387 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call2388 = callmethod(*var_n, "unionTypes",
    1, partcv, params);
  gc_frame_end(callframe2387);
// compilenode returning call2388
// compilenode returning call2388
  params[0] = call2386;
  partcv[0] = 1;
  Object call2389 = callmethod(call2388, "push",
    1, partcv, params);
  gc_frame_end(callframe2384);
// compilenode returning call2389
  gc_frame_end(frame);
  return call2389;
}
Object meth_ast__apply2402(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_blk = getfromclosure(closure, 0);
  Object *var_blkBefore = getfromclosure(closure, 1);
  Object *var_blkAfter = getfromclosure(closure, 2);
  Object *var_n = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 538
  setline(538);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2403 = gc_frame_new();
  int callframe2404 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// compilenode returning *var_a
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2405 = callmethod(*var_a, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe2404);
// compilenode returning call2405
  gc_frame_newslot(call2405);
  int callframe2406 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call2407 = callmethod(*var_n, "intersectionTypes",
    1, partcv, params);
  gc_frame_end(callframe2406);
// compilenode returning call2407
// compilenode returning call2407
  params[0] = call2405;
  partcv[0] = 1;
  Object call2408 = callmethod(call2407, "push",
    1, partcv, params);
  gc_frame_end(callframe2403);
// compilenode returning call2408
  gc_frame_end(frame);
  return call2408;
}
Object meth_ast__apply2421(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_blk = getfromclosure(closure, 0);
  Object *var_blkBefore = getfromclosure(closure, 1);
  Object *var_blkAfter = getfromclosure(closure, 2);
  Object *var_n = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2422 = gc_frame_new();
  int callframe2423 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// compilenode returning *var_a
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2424 = callmethod(*var_a, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe2423);
// compilenode returning call2424
  gc_frame_newslot(call2424);
  int callframe2425 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call2426 = callmethod(*var_n, "generics",
    1, partcv, params);
  gc_frame_end(callframe2425);
// compilenode returning call2426
// compilenode returning call2426
  params[0] = call2424;
  partcv[0] = 1;
  Object call2427 = callmethod(call2426, "push",
    1, partcv, params);
  gc_frame_end(callframe2422);
// compilenode returning call2427
  gc_frame_end(frame);
  return call2427;
}
Object meth_ast__apply2440(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_blk = getfromclosure(closure, 0);
  Object *var_blkBefore = getfromclosure(closure, 1);
  Object *var_blkAfter = getfromclosure(closure, 2);
  Object *var_n = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 544
  setline(544);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2441 = gc_frame_new();
  int callframe2442 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// compilenode returning *var_a
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2443 = callmethod(*var_a, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe2442);
// compilenode returning call2443
  gc_frame_newslot(call2443);
  int callframe2444 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call2445 = callmethod(*var_n, "annotations",
    1, partcv, params);
  gc_frame_end(callframe2444);
// compilenode returning call2445
// compilenode returning call2445
  params[0] = call2443;
  partcv[0] = 1;
  Object call2446 = callmethod(call2445, "push",
    1, partcv, params);
  gc_frame_end(callframe2441);
// compilenode returning call2446
  gc_frame_end(frame);
  return call2446;
}
Object meth_ast_map_40__41_before_40__41_after2347(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_typeNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 529
  setline(529);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2348 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call2349 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe2348);
// compilenode returning call2349
// Begin line 530
  setline(530);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2350 = gc_frame_new();
  int callframe2351 = gc_frame_new();
  partcv[0] = 0;
  Object call2352 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2351);
// compilenode returning call2352
  gc_frame_newslot(call2352);
  int callframe2353 = gc_frame_new();
  int callframe2354 = gc_frame_new();
  partcv[0] = 0;
  Object call2355 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2354);
// compilenode returning call2355
  gc_frame_newslot(call2355);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe2356 = gc_frame_new();
  int callframe2357 = gc_frame_new();
  Object call2358 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2357);
// compilenode returning call2358
// compilenode returning call2358
  partcv[0] = 0;
  Object call2359 = callmethodflags(call2358, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2356);
// compilenode returning call2359
// compilenode returning call2359
  params[0] = call2355;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2360 = callmethodflags(call2359, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2353);
// compilenode returning call2360
  gc_frame_newslot(call2360);
// compilenode returning *var_typeNode
  params[0] = call2352;
  params[1] = call2360;
  partcv[0] = 2;
  Object call2361 = callmethod(*var_typeNode, "new",
    1, partcv, params);
  gc_frame_end(callframe2350);
// compilenode returning call2361
  *var_n = call2361;
  if (call2361 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 531
  setline(531);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2362 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2363 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe2362);
// compilenode returning call2363
  *var_n = call2363;
  if (call2363 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 530
  setline(530);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2365 = gc_frame_new();
// Begin line 532
  setline(532);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2366 = gc_frame_new();
  partcv[0] = 0;
  Object call2367 = callmethodflags(self, "anonymous", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2366);
// compilenode returning call2367
// compilenode returning call2367
  gc_frame_newslot(call2367);
// compilenode returning *var_n
  params[0] = call2367;
  partcv[0] = 1;
  Object call2368 = callmethod(*var_n, "anonymous:=",
    1, partcv, params);
  gc_frame_end(callframe2365);
// compilenode returning call2368
// compilenode returning done
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 532
  setline(532);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2369 = gc_frame_new();
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2370 = gc_frame_new();
  partcv[0] = 0;
  Object call2371 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2370);
// compilenode returning call2371
  gc_frame_newslot(call2371);
// compilenode returning *var_n
  params[0] = call2371;
  partcv[0] = 1;
  Object call2372 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe2369);
// compilenode returning call2372
// compilenode returning done
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2373 = gc_frame_new();
  int callframe2374 = gc_frame_new();
  int callframe2375 = gc_frame_new();
  partcv[0] = 0;
  Object call2376 = callmethodflags(self, "unionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2375);
// compilenode returning call2376
  gc_frame_newslot(call2376);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe2377 = gc_frame_new();
  int callframe2378 = gc_frame_new();
  Object call2379 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2378);
// compilenode returning call2379
// compilenode returning call2379
  partcv[0] = 0;
  Object call2380 = callmethodflags(call2379, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2377);
// compilenode returning call2380
// compilenode returning call2380
  params[0] = call2376;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2381 = callmethodflags(call2380, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2374);
// compilenode returning call2381
  gc_frame_newslot(call2381);
  Object block2382 = alloc_Block(NULL, NULL, "ast", 534);
  gc_frame_newslot(block2382);
  block_savedest(block2382);
  Object closure2383 = createclosure(5, "_apply");
setclosureframe(closure2383, stackframe);
  addtoclosure(closure2383, var_blk);
  addtoclosure(closure2383, var_blkBefore);
  addtoclosure(closure2383, var_blkAfter);
  addtoclosure(closure2383, var_n);
  addtoclosure(closure2383, selfslot);
  struct UserObject *uo2383 = (struct UserObject*)block2382;
  uo2383->data[0] = (Object)closure2383;
  Method *meth_meth_ast__apply2383 = addmethod2pos(block2382, "_apply", &meth_ast__apply2383, 0);
int argcv_meth_ast__apply2383[] = {1};
meth_meth_ast__apply2383->type = alloc_MethodType(1, argcv_meth_ast__apply2383);
  meth_meth_ast__apply2383->definitionModule = modulename;
  meth_meth_ast__apply2383->definitionLine = 534;
// compilenode returning block2382
  gc_frame_newslot(block2382);
  params[0] = call2381;
  params[1] = block2382;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2391 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2373);
// compilenode returning call2391
// Begin line 537
  setline(537);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2392 = gc_frame_new();
  int callframe2393 = gc_frame_new();
  int callframe2394 = gc_frame_new();
  partcv[0] = 0;
  Object call2395 = callmethodflags(self, "intersectionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2394);
// compilenode returning call2395
  gc_frame_newslot(call2395);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe2396 = gc_frame_new();
  int callframe2397 = gc_frame_new();
  Object call2398 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2397);
// compilenode returning call2398
// compilenode returning call2398
  partcv[0] = 0;
  Object call2399 = callmethodflags(call2398, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2396);
// compilenode returning call2399
// compilenode returning call2399
  params[0] = call2395;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2400 = callmethodflags(call2399, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2393);
// compilenode returning call2400
  gc_frame_newslot(call2400);
  Object block2401 = alloc_Block(NULL, NULL, "ast", 537);
  gc_frame_newslot(block2401);
  block_savedest(block2401);
  Object closure2402 = createclosure(5, "_apply");
setclosureframe(closure2402, stackframe);
  addtoclosure(closure2402, var_blk);
  addtoclosure(closure2402, var_blkBefore);
  addtoclosure(closure2402, var_blkAfter);
  addtoclosure(closure2402, var_n);
  addtoclosure(closure2402, selfslot);
  struct UserObject *uo2402 = (struct UserObject*)block2401;
  uo2402->data[0] = (Object)closure2402;
  Method *meth_meth_ast__apply2402 = addmethod2pos(block2401, "_apply", &meth_ast__apply2402, 0);
int argcv_meth_ast__apply2402[] = {1};
meth_meth_ast__apply2402->type = alloc_MethodType(1, argcv_meth_ast__apply2402);
  meth_meth_ast__apply2402->definitionModule = modulename;
  meth_meth_ast__apply2402->definitionLine = 537;
// compilenode returning block2401
  gc_frame_newslot(block2401);
  params[0] = call2400;
  params[1] = block2401;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2410 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2392);
// compilenode returning call2410
// Begin line 540
  setline(540);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2411 = gc_frame_new();
  int callframe2412 = gc_frame_new();
  int callframe2413 = gc_frame_new();
  partcv[0] = 0;
  Object call2414 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2413);
// compilenode returning call2414
  gc_frame_newslot(call2414);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe2415 = gc_frame_new();
  int callframe2416 = gc_frame_new();
  Object call2417 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2416);
// compilenode returning call2417
// compilenode returning call2417
  partcv[0] = 0;
  Object call2418 = callmethodflags(call2417, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2415);
// compilenode returning call2418
// compilenode returning call2418
  params[0] = call2414;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2419 = callmethodflags(call2418, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2412);
// compilenode returning call2419
  gc_frame_newslot(call2419);
  Object block2420 = alloc_Block(NULL, NULL, "ast", 540);
  gc_frame_newslot(block2420);
  block_savedest(block2420);
  Object closure2421 = createclosure(5, "_apply");
setclosureframe(closure2421, stackframe);
  addtoclosure(closure2421, var_blk);
  addtoclosure(closure2421, var_blkBefore);
  addtoclosure(closure2421, var_blkAfter);
  addtoclosure(closure2421, var_n);
  addtoclosure(closure2421, selfslot);
  struct UserObject *uo2421 = (struct UserObject*)block2420;
  uo2421->data[0] = (Object)closure2421;
  Method *meth_meth_ast__apply2421 = addmethod2pos(block2420, "_apply", &meth_ast__apply2421, 0);
int argcv_meth_ast__apply2421[] = {1};
meth_meth_ast__apply2421->type = alloc_MethodType(1, argcv_meth_ast__apply2421);
  meth_meth_ast__apply2421->definitionModule = modulename;
  meth_meth_ast__apply2421->definitionLine = 540;
// compilenode returning block2420
  gc_frame_newslot(block2420);
  params[0] = call2419;
  params[1] = block2420;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2429 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2411);
// compilenode returning call2429
// Begin line 543
  setline(543);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2430 = gc_frame_new();
  int callframe2431 = gc_frame_new();
  int callframe2432 = gc_frame_new();
  partcv[0] = 0;
  Object call2433 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2432);
// compilenode returning call2433
  gc_frame_newslot(call2433);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe2434 = gc_frame_new();
  int callframe2435 = gc_frame_new();
  Object call2436 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2435);
// compilenode returning call2436
// compilenode returning call2436
  partcv[0] = 0;
  Object call2437 = callmethodflags(call2436, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2434);
// compilenode returning call2437
// compilenode returning call2437
  params[0] = call2433;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2438 = callmethodflags(call2437, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2431);
// compilenode returning call2438
  gc_frame_newslot(call2438);
  Object block2439 = alloc_Block(NULL, NULL, "ast", 543);
  gc_frame_newslot(block2439);
  block_savedest(block2439);
  Object closure2440 = createclosure(5, "_apply");
setclosureframe(closure2440, stackframe);
  addtoclosure(closure2440, var_blk);
  addtoclosure(closure2440, var_blkBefore);
  addtoclosure(closure2440, var_blkAfter);
  addtoclosure(closure2440, var_n);
  addtoclosure(closure2440, selfslot);
  struct UserObject *uo2440 = (struct UserObject*)block2439;
  uo2440->data[0] = (Object)closure2440;
  Method *meth_meth_ast__apply2440 = addmethod2pos(block2439, "_apply", &meth_ast__apply2440, 0);
int argcv_meth_ast__apply2440[] = {1};
meth_meth_ast__apply2440->type = alloc_MethodType(1, argcv_meth_ast__apply2440);
  meth_meth_ast__apply2440->definitionModule = modulename;
  meth_meth_ast__apply2440->definitionLine = 543;
// compilenode returning block2439
  gc_frame_newslot(block2439);
  params[0] = call2438;
  params[1] = block2439;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2448 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2430);
// compilenode returning call2448
// Begin line 546
  setline(546);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2449 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2450 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe2449);
// compilenode returning call2450
// Begin line 547
  setline(547);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply2454(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2457(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map2451(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 550
  setline(550);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2452 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block2453 = alloc_Block(NULL, NULL, "ast", 550);
  gc_frame_newslot(block2453);
  block_savedest(block2453);
  Object closure2454 = createclosure(1, "_apply");
setclosureframe(closure2454, stackframe);
  addtoclosure(closure2454, selfslot);
  struct UserObject *uo2454 = (struct UserObject*)block2453;
  uo2454->data[0] = (Object)closure2454;
  Method *meth_meth_ast__apply2454 = addmethod2pos(block2453, "_apply", &meth_ast__apply2454, 0);
int argcv_meth_ast__apply2454[] = {0};
meth_meth_ast__apply2454->type = alloc_MethodType(1, argcv_meth_ast__apply2454);
  meth_meth_ast__apply2454->definitionModule = modulename;
  meth_meth_ast__apply2454->definitionLine = 544;
// compilenode returning block2453
  gc_frame_newslot(block2453);
  Object block2456 = alloc_Block(NULL, NULL, "ast", 550);
  gc_frame_newslot(block2456);
  block_savedest(block2456);
  Object closure2457 = createclosure(1, "_apply");
setclosureframe(closure2457, stackframe);
  addtoclosure(closure2457, selfslot);
  struct UserObject *uo2457 = (struct UserObject*)block2456;
  uo2457->data[0] = (Object)closure2457;
  Method *meth_meth_ast__apply2457 = addmethod2pos(block2456, "_apply", &meth_ast__apply2457, 0);
int argcv_meth_ast__apply2457[] = {0};
meth_meth_ast__apply2457->type = alloc_MethodType(1, argcv_meth_ast__apply2457);
  meth_meth_ast__apply2457->definitionModule = modulename;
  meth_meth_ast__apply2457->definitionLine = 544;
// compilenode returning block2456
  gc_frame_newslot(block2456);
  params[0] = *var_blk;
  params[1] = block2453;
  params[2] = block2456;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2459 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2452);
// compilenode returning call2459
  gc_frame_end(frame);
  return call2459;
}
Object meth_ast__apply2468(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 556
  setline(556);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 555
  setline(555);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2470 == NULL) {
    strlit2470 = alloc_String("  ");
    gc_root(strlit2470);
  }
// compilenode returning strlit2470
  int op_slot_right_2469 = gc_frame_newslot(strlit2470);
// compilenode returning *var_spc
  int op_slot_left_2469 = gc_frame_newslot(*var_spc);
  params[0] = strlit2470;
  partcv[0] = 1;
  Object opresult2472 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult2472
  *var_spc = opresult2472;
  if (opresult2472 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2531(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ut = &(stackframe->slots[0]);
  *var_ut = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 563
  setline(563);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 562
  setline(562);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2533 == NULL) {
    strlit2533 = alloc_String("""\x0a""");
    gc_root(strlit2533);
  }
// compilenode returning strlit2533
  int op_slot_right_2532 = gc_frame_newslot(strlit2533);
  int callframe2536 = gc_frame_new();
// compilenode returning *var_ut
  partcv[0] = 0;
  Object call2537 = callmethod(*var_ut, "value",
    1, partcv, params);
  gc_frame_end(callframe2536);
// compilenode returning call2537
// compilenode returning call2537
  int op_slot_right_2535 = gc_frame_newslot(call2537);
  if (strlit2540 == NULL) {
    strlit2540 = alloc_String("  ");
    gc_root(strlit2540);
  }
// compilenode returning strlit2540
  int op_slot_right_2539 = gc_frame_newslot(strlit2540);
// compilenode returning *var_spc
  int op_slot_right_2542 = gc_frame_newslot(*var_spc);
  if (strlit2545 == NULL) {
    strlit2545 = alloc_String("");
    gc_root(strlit2545);
  }
// compilenode returning strlit2545
  int op_slot_right_2544 = gc_frame_newslot(strlit2545);
// compilenode returning *var_s
  int op_slot_right_2547 = gc_frame_newslot(*var_s);
  if (strlit2549 == NULL) {
    strlit2549 = alloc_String("");
    gc_root(strlit2549);
  }
// compilenode returning strlit2549
  int op_slot_left_2547 = gc_frame_newslot(strlit2549);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2550 = callmethod(strlit2549, "++", 1, partcv, params);
// compilenode returning opresult2550
  int op_slot_left_2544 = gc_frame_newslot(opresult2550);
  params[0] = strlit2545;
  partcv[0] = 1;
  Object opresult2551 = callmethod(opresult2550, "++", 1, partcv, params);
// compilenode returning opresult2551
  int op_slot_left_2542 = gc_frame_newslot(opresult2551);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2552 = callmethod(opresult2551, "++", 1, partcv, params);
// compilenode returning opresult2552
  int op_slot_left_2539 = gc_frame_newslot(opresult2552);
  params[0] = strlit2540;
  partcv[0] = 1;
  Object opresult2553 = callmethod(opresult2552, "++", 1, partcv, params);
// compilenode returning opresult2553
  int op_slot_left_2535 = gc_frame_newslot(opresult2553);
  params[0] = call2537;
  partcv[0] = 1;
  Object opresult2554 = callmethod(opresult2553, "++", 1, partcv, params);
// compilenode returning opresult2554
  int op_slot_left_2532 = gc_frame_newslot(opresult2554);
  params[0] = strlit2533;
  partcv[0] = 1;
  Object opresult2555 = callmethod(opresult2554, "++", 1, partcv, params);
// compilenode returning opresult2555
  *var_s = opresult2555;
  if (opresult2555 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2588(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ut = &(stackframe->slots[0]);
  *var_ut = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 568
  setline(568);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2590 == NULL) {
    strlit2590 = alloc_String("""\x0a""");
    gc_root(strlit2590);
  }
// compilenode returning strlit2590
  int op_slot_right_2589 = gc_frame_newslot(strlit2590);
  int callframe2593 = gc_frame_new();
// compilenode returning *var_ut
  partcv[0] = 0;
  Object call2594 = callmethod(*var_ut, "value",
    1, partcv, params);
  gc_frame_end(callframe2593);
// compilenode returning call2594
// compilenode returning call2594
  int op_slot_right_2592 = gc_frame_newslot(call2594);
  if (strlit2597 == NULL) {
    strlit2597 = alloc_String("  ");
    gc_root(strlit2597);
  }
// compilenode returning strlit2597
  int op_slot_right_2596 = gc_frame_newslot(strlit2597);
// compilenode returning *var_spc
  int op_slot_right_2599 = gc_frame_newslot(*var_spc);
  if (strlit2602 == NULL) {
    strlit2602 = alloc_String("");
    gc_root(strlit2602);
  }
// compilenode returning strlit2602
  int op_slot_right_2601 = gc_frame_newslot(strlit2602);
// compilenode returning *var_s
  int op_slot_right_2604 = gc_frame_newslot(*var_s);
  if (strlit2606 == NULL) {
    strlit2606 = alloc_String("");
    gc_root(strlit2606);
  }
// compilenode returning strlit2606
  int op_slot_left_2604 = gc_frame_newslot(strlit2606);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2607 = callmethod(strlit2606, "++", 1, partcv, params);
// compilenode returning opresult2607
  int op_slot_left_2601 = gc_frame_newslot(opresult2607);
  params[0] = strlit2602;
  partcv[0] = 1;
  Object opresult2608 = callmethod(opresult2607, "++", 1, partcv, params);
// compilenode returning opresult2608
  int op_slot_left_2599 = gc_frame_newslot(opresult2608);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2609 = callmethod(opresult2608, "++", 1, partcv, params);
// compilenode returning opresult2609
  int op_slot_left_2596 = gc_frame_newslot(opresult2609);
  params[0] = strlit2597;
  partcv[0] = 1;
  Object opresult2610 = callmethod(opresult2609, "++", 1, partcv, params);
// compilenode returning opresult2610
  int op_slot_left_2592 = gc_frame_newslot(opresult2610);
  params[0] = call2594;
  partcv[0] = 1;
  Object opresult2611 = callmethod(opresult2610, "++", 1, partcv, params);
// compilenode returning opresult2611
  int op_slot_left_2589 = gc_frame_newslot(opresult2611);
  params[0] = strlit2590;
  partcv[0] = 1;
  Object opresult2612 = callmethod(opresult2611, "++", 1, partcv, params);
// compilenode returning opresult2612
  *var_s = opresult2612;
  if (opresult2612 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2645(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_it = &(stackframe->slots[0]);
  *var_it = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 575
  setline(575);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 574
  setline(574);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2647 == NULL) {
    strlit2647 = alloc_String("""\x0a""");
    gc_root(strlit2647);
  }
// compilenode returning strlit2647
  int op_slot_right_2646 = gc_frame_newslot(strlit2647);
  int callframe2650 = gc_frame_new();
// compilenode returning *var_it
  partcv[0] = 0;
  Object call2651 = callmethod(*var_it, "value",
    1, partcv, params);
  gc_frame_end(callframe2650);
// compilenode returning call2651
// compilenode returning call2651
  int op_slot_right_2649 = gc_frame_newslot(call2651);
  if (strlit2654 == NULL) {
    strlit2654 = alloc_String("  ");
    gc_root(strlit2654);
  }
// compilenode returning strlit2654
  int op_slot_right_2653 = gc_frame_newslot(strlit2654);
// compilenode returning *var_spc
  int op_slot_right_2656 = gc_frame_newslot(*var_spc);
  if (strlit2659 == NULL) {
    strlit2659 = alloc_String("");
    gc_root(strlit2659);
  }
// compilenode returning strlit2659
  int op_slot_right_2658 = gc_frame_newslot(strlit2659);
// compilenode returning *var_s
  int op_slot_right_2661 = gc_frame_newslot(*var_s);
  if (strlit2663 == NULL) {
    strlit2663 = alloc_String("");
    gc_root(strlit2663);
  }
// compilenode returning strlit2663
  int op_slot_left_2661 = gc_frame_newslot(strlit2663);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2664 = callmethod(strlit2663, "++", 1, partcv, params);
// compilenode returning opresult2664
  int op_slot_left_2658 = gc_frame_newslot(opresult2664);
  params[0] = strlit2659;
  partcv[0] = 1;
  Object opresult2665 = callmethod(opresult2664, "++", 1, partcv, params);
// compilenode returning opresult2665
  int op_slot_left_2656 = gc_frame_newslot(opresult2665);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2666 = callmethod(opresult2665, "++", 1, partcv, params);
// compilenode returning opresult2666
  int op_slot_left_2653 = gc_frame_newslot(opresult2666);
  params[0] = strlit2654;
  partcv[0] = 1;
  Object opresult2667 = callmethod(opresult2666, "++", 1, partcv, params);
// compilenode returning opresult2667
  int op_slot_left_2649 = gc_frame_newslot(opresult2667);
  params[0] = call2651;
  partcv[0] = 1;
  Object opresult2668 = callmethod(opresult2667, "++", 1, partcv, params);
// compilenode returning opresult2668
  int op_slot_left_2646 = gc_frame_newslot(opresult2668);
  params[0] = strlit2647;
  partcv[0] = 1;
  Object opresult2669 = callmethod(opresult2668, "++", 1, partcv, params);
// compilenode returning opresult2669
  *var_s = opresult2669;
  if (opresult2669 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2685(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 579
  setline(579);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2687 = gc_frame_new();
  Object num2689 = alloc_Float64(2);
// compilenode returning num2689
  int op_slot_right_2688 = gc_frame_newslot(num2689);
// compilenode returning *var_depth
  int op_slot_left_2688 = gc_frame_newslot(*var_depth);
  params[0] = num2689;
  partcv[0] = 1;
  Object sum2691 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum2691
  gc_frame_newslot(sum2691);
// compilenode returning *var_mx
  params[0] = sum2691;
  partcv[0] = 1;
  Object call2692 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2687);
// compilenode returning call2692
  int op_slot_right_2686 = gc_frame_newslot(call2692);
// compilenode returning *var_spc
  int op_slot_right_2694 = gc_frame_newslot(*var_spc);
  if (strlit2697 == NULL) {
    strlit2697 = alloc_String("""\x0a""  ");
    gc_root(strlit2697);
  }
// compilenode returning strlit2697
  int op_slot_right_2696 = gc_frame_newslot(strlit2697);
// compilenode returning *var_s
  int op_slot_left_2696 = gc_frame_newslot(*var_s);
  params[0] = strlit2697;
  partcv[0] = 1;
  Object opresult2699 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2699
  int op_slot_left_2694 = gc_frame_newslot(opresult2699);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2700 = callmethod(opresult2699, "++", 1, partcv, params);
// compilenode returning opresult2700
  int op_slot_left_2686 = gc_frame_newslot(opresult2700);
  params[0] = call2692;
  partcv[0] = 1;
  Object opresult2701 = callmethod(opresult2700, "++", 1, partcv, params);
// compilenode returning opresult2701
  *var_s = opresult2701;
  if (opresult2701 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty2460(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 553
  setline(553);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2461 == NULL) {
    strlit2461 = alloc_String("");
    gc_root(strlit2461);
  }
// compilenode returning strlit2461
  *var_spc = strlit2461;
  if (strlit2461 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2462 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_2463 = gc_frame_newslot(*var_depth);
  Object num2465 = alloc_Float64(0);
// compilenode returning num2465
  int op_slot_left_2463 = gc_frame_newslot(num2465);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult2466 = callmethod(num2465, "..", 1, partcv, params);
// compilenode returning opresult2466
  gc_frame_newslot(opresult2466);
  Object block2467 = alloc_Block(NULL, NULL, "ast", 554);
  gc_frame_newslot(block2467);
  block_savedest(block2467);
  Object closure2468 = createclosure(2, "_apply");
setclosureframe(closure2468, stackframe);
  addtoclosure(closure2468, var_spc);
  addtoclosure(closure2468, selfslot);
  struct UserObject *uo2468 = (struct UserObject*)block2467;
  uo2468->data[0] = (Object)closure2468;
  Method *meth_meth_ast__apply2468 = addmethod2pos(block2467, "_apply", &meth_ast__apply2468, 0);
int argcv_meth_ast__apply2468[] = {1};
meth_meth_ast__apply2468->type = alloc_MethodType(1, argcv_meth_ast__apply2468);
  meth_meth_ast__apply2468->definitionModule = modulename;
  meth_meth_ast__apply2468->definitionLine = 544;
// compilenode returning block2467
  gc_frame_newslot(block2467);
  params[0] = opresult2466;
  params[1] = block2467;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2475 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2462);
// compilenode returning call2475
// Begin line 558
  setline(558);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 557
  setline(557);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2476 == NULL) {
    strlit2476 = alloc_String("Type""\x0a""");
    gc_root(strlit2476);
  }
// compilenode returning strlit2476
  *var_s = strlit2476;
  if (strlit2476 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 559
  setline(559);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 558
  setline(558);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2478 == NULL) {
    strlit2478 = alloc_String("""\x0a""");
    gc_root(strlit2478);
  }
// compilenode returning strlit2478
  int op_slot_right_2477 = gc_frame_newslot(strlit2478);
  int callframe2481 = gc_frame_new();
  partcv[0] = 0;
  Object call2482 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2481);
// compilenode returning call2482
  int op_slot_right_2480 = gc_frame_newslot(call2482);
  if (strlit2485 == NULL) {
    strlit2485 = alloc_String("Name: ");
    gc_root(strlit2485);
  }
// compilenode returning strlit2485
  int op_slot_right_2484 = gc_frame_newslot(strlit2485);
// compilenode returning *var_spc
  int op_slot_right_2487 = gc_frame_newslot(*var_spc);
  if (strlit2490 == NULL) {
    strlit2490 = alloc_String("");
    gc_root(strlit2490);
  }
// compilenode returning strlit2490
  int op_slot_right_2489 = gc_frame_newslot(strlit2490);
// compilenode returning *var_s
  int op_slot_right_2492 = gc_frame_newslot(*var_s);
  if (strlit2494 == NULL) {
    strlit2494 = alloc_String("");
    gc_root(strlit2494);
  }
// compilenode returning strlit2494
  int op_slot_left_2492 = gc_frame_newslot(strlit2494);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2495 = callmethod(strlit2494, "++", 1, partcv, params);
// compilenode returning opresult2495
  int op_slot_left_2489 = gc_frame_newslot(opresult2495);
  params[0] = strlit2490;
  partcv[0] = 1;
  Object opresult2496 = callmethod(opresult2495, "++", 1, partcv, params);
// compilenode returning opresult2496
  int op_slot_left_2487 = gc_frame_newslot(opresult2496);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2497 = callmethod(opresult2496, "++", 1, partcv, params);
// compilenode returning opresult2497
  int op_slot_left_2484 = gc_frame_newslot(opresult2497);
  params[0] = strlit2485;
  partcv[0] = 1;
  Object opresult2498 = callmethod(opresult2497, "++", 1, partcv, params);
// compilenode returning opresult2498
  int op_slot_left_2480 = gc_frame_newslot(opresult2498);
  params[0] = call2482;
  partcv[0] = 1;
  Object opresult2499 = callmethod(opresult2498, "++", 1, partcv, params);
// compilenode returning opresult2499
  int op_slot_left_2477 = gc_frame_newslot(opresult2499);
  params[0] = strlit2478;
  partcv[0] = 1;
  Object opresult2500 = callmethod(opresult2499, "++", 1, partcv, params);
// compilenode returning opresult2500
  *var_s = opresult2500;
  if (opresult2500 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 565
  setline(565);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 559
  setline(559);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2504 = alloc_Float64(0);
// compilenode returning num2504
  int op_slot_right_2503 = gc_frame_newslot(num2504);
  int callframe2506 = gc_frame_new();
  int callframe2507 = gc_frame_new();
  partcv[0] = 0;
  Object call2508 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2507);
// compilenode returning call2508
  partcv[0] = 0;
  Object call2509 = callmethod(call2508, "size",
    1, partcv, params);
  gc_frame_end(callframe2506);
// compilenode returning call2509
// compilenode returning call2509
  int op_slot_left_2503 = gc_frame_newslot(call2509);
  params[0] = num2504;
  partcv[0] = 1;
  Object opresult2510 = callmethod(call2509, ">", 1, partcv, params);
// compilenode returning opresult2510
  Object if2502 = done;
  if (istrue(opresult2510)) {
// Begin line 561
  setline(561);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 560
  setline(560);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2512 == NULL) {
    strlit2512 = alloc_String("Generic parameters:""\x0a""");
    gc_root(strlit2512);
  }
// compilenode returning strlit2512
  int op_slot_right_2511 = gc_frame_newslot(strlit2512);
// compilenode returning *var_spc
  int op_slot_right_2514 = gc_frame_newslot(*var_spc);
  if (strlit2517 == NULL) {
    strlit2517 = alloc_String("");
    gc_root(strlit2517);
  }
// compilenode returning strlit2517
  int op_slot_right_2516 = gc_frame_newslot(strlit2517);
// compilenode returning *var_s
  int op_slot_right_2519 = gc_frame_newslot(*var_s);
  if (strlit2521 == NULL) {
    strlit2521 = alloc_String("");
    gc_root(strlit2521);
  }
// compilenode returning strlit2521
  int op_slot_left_2519 = gc_frame_newslot(strlit2521);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2522 = callmethod(strlit2521, "++", 1, partcv, params);
// compilenode returning opresult2522
  int op_slot_left_2516 = gc_frame_newslot(opresult2522);
  params[0] = strlit2517;
  partcv[0] = 1;
  Object opresult2523 = callmethod(opresult2522, "++", 1, partcv, params);
// compilenode returning opresult2523
  int op_slot_left_2514 = gc_frame_newslot(opresult2523);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2524 = callmethod(opresult2523, "++", 1, partcv, params);
// compilenode returning opresult2524
  int op_slot_left_2511 = gc_frame_newslot(opresult2524);
  params[0] = strlit2512;
  partcv[0] = 1;
  Object opresult2525 = callmethod(opresult2524, "++", 1, partcv, params);
// compilenode returning opresult2525
  *var_s = opresult2525;
  if (opresult2525 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 561
  setline(561);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2527 = gc_frame_new();
  int callframe2528 = gc_frame_new();
  partcv[0] = 0;
  Object call2529 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2528);
// compilenode returning call2529
  gc_frame_newslot(call2529);
  Object block2530 = alloc_Block(NULL, NULL, "ast", 561);
  gc_frame_newslot(block2530);
  block_savedest(block2530);
  Object closure2531 = createclosure(3, "_apply");
setclosureframe(closure2531, stackframe);
  addtoclosure(closure2531, var_spc);
  addtoclosure(closure2531, var_s);
  addtoclosure(closure2531, selfslot);
  struct UserObject *uo2531 = (struct UserObject*)block2530;
  uo2531->data[0] = (Object)closure2531;
  Method *meth_meth_ast__apply2531 = addmethod2pos(block2530, "_apply", &meth_ast__apply2531, 0);
int argcv_meth_ast__apply2531[] = {1};
meth_meth_ast__apply2531->type = alloc_MethodType(1, argcv_meth_ast__apply2531);
  meth_meth_ast__apply2531->definitionModule = modulename;
  meth_meth_ast__apply2531->definitionLine = 559;
// compilenode returning block2530
  gc_frame_newslot(block2530);
  params[0] = call2529;
  params[1] = block2530;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2558 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2527);
// compilenode returning call2558
    gc_frame_newslot(call2558);
    if2502 = call2558;
  } else {
  }
// compilenode returning if2502
// Begin line 571
  setline(571);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 565
  setline(565);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2561 = alloc_Float64(0);
// compilenode returning num2561
  int op_slot_right_2560 = gc_frame_newslot(num2561);
  int callframe2563 = gc_frame_new();
  int callframe2564 = gc_frame_new();
  partcv[0] = 0;
  Object call2565 = callmethodflags(self, "unionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2564);
// compilenode returning call2565
  partcv[0] = 0;
  Object call2566 = callmethod(call2565, "size",
    1, partcv, params);
  gc_frame_end(callframe2563);
// compilenode returning call2566
// compilenode returning call2566
  int op_slot_left_2560 = gc_frame_newslot(call2566);
  params[0] = num2561;
  partcv[0] = 1;
  Object opresult2567 = callmethod(call2566, ">", 1, partcv, params);
// compilenode returning opresult2567
  Object if2559 = done;
  if (istrue(opresult2567)) {
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 566
  setline(566);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2569 == NULL) {
    strlit2569 = alloc_String("Union of:""\x0a""");
    gc_root(strlit2569);
  }
// compilenode returning strlit2569
  int op_slot_right_2568 = gc_frame_newslot(strlit2569);
// compilenode returning *var_spc
  int op_slot_right_2571 = gc_frame_newslot(*var_spc);
  if (strlit2574 == NULL) {
    strlit2574 = alloc_String("");
    gc_root(strlit2574);
  }
// compilenode returning strlit2574
  int op_slot_right_2573 = gc_frame_newslot(strlit2574);
// compilenode returning *var_s
  int op_slot_right_2576 = gc_frame_newslot(*var_s);
  if (strlit2578 == NULL) {
    strlit2578 = alloc_String("");
    gc_root(strlit2578);
  }
// compilenode returning strlit2578
  int op_slot_left_2576 = gc_frame_newslot(strlit2578);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2579 = callmethod(strlit2578, "++", 1, partcv, params);
// compilenode returning opresult2579
  int op_slot_left_2573 = gc_frame_newslot(opresult2579);
  params[0] = strlit2574;
  partcv[0] = 1;
  Object opresult2580 = callmethod(opresult2579, "++", 1, partcv, params);
// compilenode returning opresult2580
  int op_slot_left_2571 = gc_frame_newslot(opresult2580);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2581 = callmethod(opresult2580, "++", 1, partcv, params);
// compilenode returning opresult2581
  int op_slot_left_2568 = gc_frame_newslot(opresult2581);
  params[0] = strlit2569;
  partcv[0] = 1;
  Object opresult2582 = callmethod(opresult2581, "++", 1, partcv, params);
// compilenode returning opresult2582
  *var_s = opresult2582;
  if (opresult2582 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2584 = gc_frame_new();
  int callframe2585 = gc_frame_new();
  partcv[0] = 0;
  Object call2586 = callmethodflags(self, "unionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2585);
// compilenode returning call2586
  gc_frame_newslot(call2586);
  Object block2587 = alloc_Block(NULL, NULL, "ast", 567);
  gc_frame_newslot(block2587);
  block_savedest(block2587);
  Object closure2588 = createclosure(3, "_apply");
setclosureframe(closure2588, stackframe);
  addtoclosure(closure2588, var_spc);
  addtoclosure(closure2588, var_s);
  addtoclosure(closure2588, selfslot);
  struct UserObject *uo2588 = (struct UserObject*)block2587;
  uo2588->data[0] = (Object)closure2588;
  Method *meth_meth_ast__apply2588 = addmethod2pos(block2587, "_apply", &meth_ast__apply2588, 0);
int argcv_meth_ast__apply2588[] = {1};
meth_meth_ast__apply2588->type = alloc_MethodType(1, argcv_meth_ast__apply2588);
  meth_meth_ast__apply2588->definitionModule = modulename;
  meth_meth_ast__apply2588->definitionLine = 565;
// compilenode returning block2587
  gc_frame_newslot(block2587);
  params[0] = call2586;
  params[1] = block2587;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2615 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2584);
// compilenode returning call2615
    gc_frame_newslot(call2615);
    if2559 = call2615;
  } else {
  }
// compilenode returning if2559
// Begin line 577
  setline(577);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 571
  setline(571);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2618 = alloc_Float64(0);
// compilenode returning num2618
  int op_slot_right_2617 = gc_frame_newslot(num2618);
  int callframe2620 = gc_frame_new();
  int callframe2621 = gc_frame_new();
  partcv[0] = 0;
  Object call2622 = callmethodflags(self, "intersectionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2621);
// compilenode returning call2622
  partcv[0] = 0;
  Object call2623 = callmethod(call2622, "size",
    1, partcv, params);
  gc_frame_end(callframe2620);
// compilenode returning call2623
// compilenode returning call2623
  int op_slot_left_2617 = gc_frame_newslot(call2623);
  params[0] = num2618;
  partcv[0] = 1;
  Object opresult2624 = callmethod(call2623, ">", 1, partcv, params);
// compilenode returning opresult2624
  Object if2616 = done;
  if (istrue(opresult2624)) {
// Begin line 573
  setline(573);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 572
  setline(572);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2626 == NULL) {
    strlit2626 = alloc_String("Intersection of:""\x0a""");
    gc_root(strlit2626);
  }
// compilenode returning strlit2626
  int op_slot_right_2625 = gc_frame_newslot(strlit2626);
// compilenode returning *var_spc
  int op_slot_right_2628 = gc_frame_newslot(*var_spc);
  if (strlit2631 == NULL) {
    strlit2631 = alloc_String("");
    gc_root(strlit2631);
  }
// compilenode returning strlit2631
  int op_slot_right_2630 = gc_frame_newslot(strlit2631);
// compilenode returning *var_s
  int op_slot_right_2633 = gc_frame_newslot(*var_s);
  if (strlit2635 == NULL) {
    strlit2635 = alloc_String("");
    gc_root(strlit2635);
  }
// compilenode returning strlit2635
  int op_slot_left_2633 = gc_frame_newslot(strlit2635);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2636 = callmethod(strlit2635, "++", 1, partcv, params);
// compilenode returning opresult2636
  int op_slot_left_2630 = gc_frame_newslot(opresult2636);
  params[0] = strlit2631;
  partcv[0] = 1;
  Object opresult2637 = callmethod(opresult2636, "++", 1, partcv, params);
// compilenode returning opresult2637
  int op_slot_left_2628 = gc_frame_newslot(opresult2637);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2638 = callmethod(opresult2637, "++", 1, partcv, params);
// compilenode returning opresult2638
  int op_slot_left_2625 = gc_frame_newslot(opresult2638);
  params[0] = strlit2626;
  partcv[0] = 1;
  Object opresult2639 = callmethod(opresult2638, "++", 1, partcv, params);
// compilenode returning opresult2639
  *var_s = opresult2639;
  if (opresult2639 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 573
  setline(573);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2641 = gc_frame_new();
  int callframe2642 = gc_frame_new();
  partcv[0] = 0;
  Object call2643 = callmethodflags(self, "intersectionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2642);
// compilenode returning call2643
  gc_frame_newslot(call2643);
  Object block2644 = alloc_Block(NULL, NULL, "ast", 573);
  gc_frame_newslot(block2644);
  block_savedest(block2644);
  Object closure2645 = createclosure(3, "_apply");
setclosureframe(closure2645, stackframe);
  addtoclosure(closure2645, var_spc);
  addtoclosure(closure2645, var_s);
  addtoclosure(closure2645, selfslot);
  struct UserObject *uo2645 = (struct UserObject*)block2644;
  uo2645->data[0] = (Object)closure2645;
  Method *meth_meth_ast__apply2645 = addmethod2pos(block2644, "_apply", &meth_ast__apply2645, 0);
int argcv_meth_ast__apply2645[] = {1};
meth_meth_ast__apply2645->type = alloc_MethodType(1, argcv_meth_ast__apply2645);
  meth_meth_ast__apply2645->definitionModule = modulename;
  meth_meth_ast__apply2645->definitionLine = 571;
// compilenode returning block2644
  gc_frame_newslot(block2644);
  params[0] = call2643;
  params[1] = block2644;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2672 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2641);
// compilenode returning call2672
    gc_frame_newslot(call2672);
    if2616 = call2672;
  } else {
  }
// compilenode returning if2616
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 577
  setline(577);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2674 == NULL) {
    strlit2674 = alloc_String("Methods:");
    gc_root(strlit2674);
  }
// compilenode returning strlit2674
  int op_slot_right_2673 = gc_frame_newslot(strlit2674);
// compilenode returning *var_spc
  int op_slot_right_2676 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_2676 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2678 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2678
  int op_slot_left_2673 = gc_frame_newslot(opresult2678);
  params[0] = strlit2674;
  partcv[0] = 1;
  Object opresult2679 = callmethod(opresult2678, "++", 1, partcv, params);
// compilenode returning opresult2679
  *var_s = opresult2679;
  if (opresult2679 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2681 = gc_frame_new();
  int callframe2682 = gc_frame_new();
  partcv[0] = 0;
  Object call2683 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2682);
// compilenode returning call2683
  gc_frame_newslot(call2683);
  Object block2684 = alloc_Block(NULL, NULL, "ast", 578);
  gc_frame_newslot(block2684);
  block_savedest(block2684);
  Object closure2685 = createclosure(4, "_apply");
setclosureframe(closure2685, stackframe);
  addtoclosure(closure2685, var_depth);
  addtoclosure(closure2685, var_spc);
  addtoclosure(closure2685, var_s);
  addtoclosure(closure2685, selfslot);
  struct UserObject *uo2685 = (struct UserObject*)block2684;
  uo2685->data[0] = (Object)closure2685;
  Method *meth_meth_ast__apply2685 = addmethod2pos(block2684, "_apply", &meth_ast__apply2685, 0);
int argcv_meth_ast__apply2685[] = {1};
meth_meth_ast__apply2685->type = alloc_MethodType(1, argcv_meth_ast__apply2685);
  meth_meth_ast__apply2685->definitionModule = modulename;
  meth_meth_ast__apply2685->definitionLine = 574;
// compilenode returning block2684
  gc_frame_newslot(block2684);
  params[0] = call2683;
  params[1] = block2684;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2704 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2681);
// compilenode returning call2704
// Begin line 582
  setline(582);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2706 == NULL) {
    strlit2706 = alloc_String("""\x0a""");
    gc_root(strlit2706);
  }
// compilenode returning strlit2706
  int op_slot_right_2705 = gc_frame_newslot(strlit2706);
// compilenode returning *var_s
  int op_slot_left_2705 = gc_frame_newslot(*var_s);
  params[0] = strlit2706;
  partcv[0] = 1;
  Object opresult2708 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2708
  *var_s = opresult2708;
  if (opresult2708 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 582
  setline(582);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply2722(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 587
  setline(587);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2724 == NULL) {
    strlit2724 = alloc_String("    ");
    gc_root(strlit2724);
  }
// compilenode returning strlit2724
  int op_slot_right_2723 = gc_frame_newslot(strlit2724);
// compilenode returning *var_spc
  int op_slot_left_2723 = gc_frame_newslot(*var_spc);
  params[0] = strlit2724;
  partcv[0] = 1;
  Object opresult2726 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult2726
  *var_spc = opresult2726;
  if (opresult2726 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2803(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 599
  setline(599);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 598
  setline(598);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2805 = gc_frame_new();
  int callframe2806 = gc_frame_new();
  partcv[0] = 0;
  Object call2807 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2806);
// compilenode returning call2807
// compilenode returning call2807
// compilenode returning *var_i
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres2808 = callmethod(call2807, "[]", 1, partcv, params);
// compilenode returning idxres2808
  partcv[0] = 0;
  Object call2809 = callmethod(idxres2808, "value",
    1, partcv, params);
  gc_frame_end(callframe2805);
// compilenode returning call2809
// compilenode returning call2809
  int op_slot_right_2804 = gc_frame_newslot(call2809);
// compilenode returning *var_s
  int op_slot_left_2804 = gc_frame_newslot(*var_s);
  params[0] = call2809;
  partcv[0] = 1;
  Object opresult2811 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2811
  *var_s = opresult2811;
  if (opresult2811 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 602
  setline(602);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 599
  setline(599);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2815 = gc_frame_new();
  int callframe2816 = gc_frame_new();
  partcv[0] = 0;
  Object call2817 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2816);
// compilenode returning call2817
// compilenode returning call2817
  partcv[0] = 0;
  Object call2818 = callmethod(call2817, "size",
    1, partcv, params);
  gc_frame_end(callframe2815);
// compilenode returning call2818
// compilenode returning call2818
  int op_slot_right_2814 = gc_frame_newslot(call2818);
// compilenode returning *var_i
  int op_slot_left_2814 = gc_frame_newslot(*var_i);
  params[0] = call2818;
  partcv[0] = 1;
  Object opresult2820 = callmethod(*var_i, "<", 1, partcv, params);
// compilenode returning opresult2820
  Object if2813 = done;
  if (istrue(opresult2820)) {
// Begin line 601
  setline(601);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 600
  setline(600);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2822 == NULL) {
    strlit2822 = alloc_String(", ");
    gc_root(strlit2822);
  }
// compilenode returning strlit2822
  int op_slot_right_2821 = gc_frame_newslot(strlit2822);
// compilenode returning *var_s
  int op_slot_left_2821 = gc_frame_newslot(*var_s);
  params[0] = strlit2822;
  partcv[0] = 1;
  Object opresult2824 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2824
  *var_s = opresult2824;
  if (opresult2824 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2813 = done;
  } else {
  }
// compilenode returning if2813
  gc_frame_end(frame);
  return if2813;
}
Object meth_ast__apply2883(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 614
  setline(614);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2885 = gc_frame_new();
  Object num2886 = alloc_Float64(0);
// compilenode returning num2886
  gc_frame_newslot(num2886);
  int callframe2887 = gc_frame_new();
  partcv[0] = 0;
  Object call2888 = callmethodflags(self, "unionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2887);
// compilenode returning call2888
// compilenode returning call2888
// compilenode returning *var_i
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres2889 = callmethod(call2888, "[]", 1, partcv, params);
// compilenode returning idxres2889
  params[0] = num2886;
  partcv[0] = 1;
  Object call2890 = callmethod(idxres2889, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2885);
// compilenode returning call2890
  int op_slot_right_2884 = gc_frame_newslot(call2890);
// compilenode returning *var_s
  int op_slot_left_2884 = gc_frame_newslot(*var_s);
  params[0] = call2890;
  partcv[0] = 1;
  Object opresult2892 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2892
  *var_s = opresult2892;
  if (opresult2892 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 618
  setline(618);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 615
  setline(615);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2896 = gc_frame_new();
  int callframe2897 = gc_frame_new();
  partcv[0] = 0;
  Object call2898 = callmethodflags(self, "unionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2897);
// compilenode returning call2898
// compilenode returning call2898
  partcv[0] = 0;
  Object call2899 = callmethod(call2898, "size",
    1, partcv, params);
  gc_frame_end(callframe2896);
// compilenode returning call2899
// compilenode returning call2899
  int op_slot_right_2895 = gc_frame_newslot(call2899);
// compilenode returning *var_i
  int op_slot_left_2895 = gc_frame_newslot(*var_i);
  params[0] = call2899;
  partcv[0] = 1;
  Object opresult2901 = callmethod(*var_i, "<", 1, partcv, params);
// compilenode returning opresult2901
  Object if2894 = done;
  if (istrue(opresult2901)) {
// Begin line 617
  setline(617);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 616
  setline(616);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2903 == NULL) {
    strlit2903 = alloc_String(" | ");
    gc_root(strlit2903);
  }
// compilenode returning strlit2903
  int op_slot_right_2902 = gc_frame_newslot(strlit2903);
// compilenode returning *var_s
  int op_slot_left_2902 = gc_frame_newslot(*var_s);
  params[0] = strlit2903;
  partcv[0] = 1;
  Object opresult2905 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2905
  *var_s = opresult2905;
  if (opresult2905 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2894 = done;
  } else {
  }
// compilenode returning if2894
  gc_frame_end(frame);
  return if2894;
}
Object meth_ast__apply2924(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 621
  setline(621);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2926 = gc_frame_new();
  Object num2927 = alloc_Float64(0);
// compilenode returning num2927
  gc_frame_newslot(num2927);
  int callframe2928 = gc_frame_new();
  partcv[0] = 0;
  Object call2929 = callmethodflags(self, "intersectionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2928);
// compilenode returning call2929
// compilenode returning call2929
// compilenode returning *var_i
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres2930 = callmethod(call2929, "[]", 1, partcv, params);
// compilenode returning idxres2930
  params[0] = num2927;
  partcv[0] = 1;
  Object call2931 = callmethod(idxres2930, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2926);
// compilenode returning call2931
  int op_slot_right_2925 = gc_frame_newslot(call2931);
// compilenode returning *var_s
  int op_slot_left_2925 = gc_frame_newslot(*var_s);
  params[0] = call2931;
  partcv[0] = 1;
  Object opresult2933 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2933
  *var_s = opresult2933;
  if (opresult2933 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 622
  setline(622);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2937 = gc_frame_new();
  int callframe2938 = gc_frame_new();
  partcv[0] = 0;
  Object call2939 = callmethodflags(self, "intersectionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2938);
// compilenode returning call2939
// compilenode returning call2939
  partcv[0] = 0;
  Object call2940 = callmethod(call2939, "size",
    1, partcv, params);
  gc_frame_end(callframe2937);
// compilenode returning call2940
// compilenode returning call2940
  int op_slot_right_2936 = gc_frame_newslot(call2940);
// compilenode returning *var_i
  int op_slot_left_2936 = gc_frame_newslot(*var_i);
  params[0] = call2940;
  partcv[0] = 1;
  Object opresult2942 = callmethod(*var_i, "<", 1, partcv, params);
// compilenode returning opresult2942
  Object if2935 = done;
  if (istrue(opresult2942)) {
// Begin line 624
  setline(624);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 623
  setline(623);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2944 == NULL) {
    strlit2944 = alloc_String(" & ");
    gc_root(strlit2944);
  }
// compilenode returning strlit2944
  int op_slot_right_2943 = gc_frame_newslot(strlit2944);
// compilenode returning *var_s
  int op_slot_left_2943 = gc_frame_newslot(*var_s);
  params[0] = strlit2944;
  partcv[0] = 1;
  Object opresult2946 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2946
  *var_s = opresult2946;
  if (opresult2946 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2935 = done;
  } else {
  }
// compilenode returning if2935
  gc_frame_end(frame);
  return if2935;
}
Object meth_ast__apply2954(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 628
  setline(628);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2956 = gc_frame_new();
  Object num2958 = alloc_Float64(1);
// compilenode returning num2958
  int op_slot_right_2957 = gc_frame_newslot(num2958);
// compilenode returning *var_depth
  int op_slot_left_2957 = gc_frame_newslot(*var_depth);
  params[0] = num2958;
  partcv[0] = 1;
  Object sum2960 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum2960
  gc_frame_newslot(sum2960);
// compilenode returning *var_mx
  params[0] = sum2960;
  partcv[0] = 1;
  Object call2961 = callmethod(*var_mx, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2956);
// compilenode returning call2961
  int op_slot_right_2955 = gc_frame_newslot(call2961);
  if (strlit2964 == NULL) {
    strlit2964 = alloc_String("    ");
    gc_root(strlit2964);
  }
// compilenode returning strlit2964
  int op_slot_right_2963 = gc_frame_newslot(strlit2964);
// compilenode returning *var_spc
  int op_slot_right_2966 = gc_frame_newslot(*var_spc);
  if (strlit2969 == NULL) {
    strlit2969 = alloc_String("""\x0a""");
    gc_root(strlit2969);
  }
// compilenode returning strlit2969
  int op_slot_right_2968 = gc_frame_newslot(strlit2969);
// compilenode returning *var_s
  int op_slot_left_2968 = gc_frame_newslot(*var_s);
  params[0] = strlit2969;
  partcv[0] = 1;
  Object opresult2971 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2971
  int op_slot_left_2966 = gc_frame_newslot(opresult2971);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2972 = callmethod(opresult2971, "++", 1, partcv, params);
// compilenode returning opresult2972
  int op_slot_left_2963 = gc_frame_newslot(opresult2972);
  params[0] = strlit2964;
  partcv[0] = 1;
  Object opresult2973 = callmethod(opresult2972, "++", 1, partcv, params);
// compilenode returning opresult2973
  int op_slot_left_2955 = gc_frame_newslot(opresult2973);
  params[0] = call2961;
  partcv[0] = 1;
  Object opresult2974 = callmethod(opresult2973, "++", 1, partcv, params);
// compilenode returning opresult2974
  *var_s = opresult2974;
  if (opresult2974 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace2710(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_isanon = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "isanon");
  Object *var_isadhoc = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "isadhoc");
// Begin line 586
  setline(586);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 585
  setline(585);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2711 == NULL) {
    strlit2711 = alloc_String("");
    gc_root(strlit2711);
  }
// compilenode returning strlit2711
  *var_spc = strlit2711;
  if (strlit2711 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 586
  setline(586);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2712 = gc_frame_new();
  Object num2715 = alloc_Float64(1);
// compilenode returning num2715
  int op_slot_right_2714 = gc_frame_newslot(num2715);
// compilenode returning *var_depth
  int op_slot_left_2714 = gc_frame_newslot(*var_depth);
  params[0] = num2715;
  partcv[0] = 1;
  Object diff2717 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff2717
  int op_slot_right_2713 = gc_frame_newslot(diff2717);
  Object num2719 = alloc_Float64(0);
// compilenode returning num2719
  int op_slot_left_2713 = gc_frame_newslot(num2719);
  params[0] = diff2717;
  partcv[0] = 1;
  Object opresult2720 = callmethod(num2719, "..", 1, partcv, params);
// compilenode returning opresult2720
  gc_frame_newslot(opresult2720);
  Object block2721 = alloc_Block(NULL, NULL, "ast", 586);
  gc_frame_newslot(block2721);
  block_savedest(block2721);
  Object closure2722 = createclosure(2, "_apply");
setclosureframe(closure2722, stackframe);
  addtoclosure(closure2722, var_spc);
  addtoclosure(closure2722, selfslot);
  struct UserObject *uo2722 = (struct UserObject*)block2721;
  uo2722->data[0] = (Object)closure2722;
  Method *meth_meth_ast__apply2722 = addmethod2pos(block2721, "_apply", &meth_ast__apply2722, 0);
int argcv_meth_ast__apply2722[] = {1};
meth_meth_ast__apply2722->type = alloc_MethodType(1, argcv_meth_ast__apply2722);
  meth_meth_ast__apply2722->definitionModule = modulename;
  meth_meth_ast__apply2722->definitionLine = 574;
// compilenode returning block2721
  gc_frame_newslot(block2721);
  params[0] = opresult2720;
  params[1] = block2721;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2729 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2712);
// compilenode returning call2729
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 589
  setline(589);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2730 == NULL) {
    strlit2730 = alloc_String("");
    gc_root(strlit2730);
  }
// compilenode returning strlit2730
  *var_s = strlit2730;
  if (strlit2730 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 591
  setline(591);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2732 == NULL) {
    strlit2732 = alloc_String("Anon_");
    gc_root(strlit2732);
  }
// compilenode returning strlit2732
  int op_slot_right_2731 = gc_frame_newslot(strlit2732);
  int callframe2734 = gc_frame_new();
  Object num2735 = alloc_Float64(2);
// compilenode returning num2735
  gc_frame_newslot(num2735);
  Object num2736 = alloc_Float64(6);
// compilenode returning num2736
  gc_frame_newslot(num2736);
  int callframe2737 = gc_frame_new();
  partcv[0] = 0;
  Object call2738 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2737);
// compilenode returning call2738
// compilenode returning call2738
  params[0] = num2735;
  params[1] = num2736;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2739 = callmethod(call2738, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe2734);
// compilenode returning call2739
  int op_slot_left_2731 = gc_frame_newslot(call2739);
  params[0] = strlit2732;
  partcv[0] = 1;
  Object opresult2740 = callmethod(call2739, "==", 1, partcv, params);
// compilenode returning opresult2740
  *var_isanon = opresult2740;
  if (opresult2740 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 593
  setline(593);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 592
  setline(592);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2743 == NULL) {
    strlit2743 = alloc_String("Intersection<");
    gc_root(strlit2743);
  }
// compilenode returning strlit2743
  int op_slot_right_2742 = gc_frame_newslot(strlit2743);
  int callframe2745 = gc_frame_new();
  Object num2746 = alloc_Float64(1);
// compilenode returning num2746
  gc_frame_newslot(num2746);
  Object num2747 = alloc_Float64(13);
// compilenode returning num2747
  gc_frame_newslot(num2747);
  int callframe2748 = gc_frame_new();
  partcv[0] = 0;
  Object call2749 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2748);
// compilenode returning call2749
// compilenode returning call2749
  params[0] = num2746;
  params[1] = num2747;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2750 = callmethod(call2749, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe2745);
// compilenode returning call2750
  int op_slot_left_2742 = gc_frame_newslot(call2750);
  params[0] = strlit2743;
  partcv[0] = 1;
  Object opresult2751 = callmethod(call2750, "==", 1, partcv, params);
// compilenode returning opresult2751
  int op_slot_right_2741 = gc_frame_newslot(opresult2751);
// Begin line 591
  setline(591);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2754 == NULL) {
    strlit2754 = alloc_String("Union<");
    gc_root(strlit2754);
  }
// compilenode returning strlit2754
  int op_slot_right_2753 = gc_frame_newslot(strlit2754);
  int callframe2756 = gc_frame_new();
  Object num2757 = alloc_Float64(1);
// compilenode returning num2757
  gc_frame_newslot(num2757);
  Object num2758 = alloc_Float64(6);
// compilenode returning num2758
  gc_frame_newslot(num2758);
  int callframe2759 = gc_frame_new();
  partcv[0] = 0;
  Object call2760 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2759);
// compilenode returning call2760
// compilenode returning call2760
  params[0] = num2757;
  params[1] = num2758;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2761 = callmethod(call2760, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe2756);
// compilenode returning call2761
  int op_slot_left_2753 = gc_frame_newslot(call2761);
  params[0] = strlit2754;
  partcv[0] = 1;
  Object opresult2762 = callmethod(call2761, "==", 1, partcv, params);
// compilenode returning opresult2762
  int op_slot_left_2741 = gc_frame_newslot(opresult2762);
  params[0] = opresult2751;
  partcv[0] = 1;
  Object opresult2763 = callmethod(opresult2762, "||", 1, partcv, params);
// compilenode returning opresult2763
  *var_isadhoc = opresult2763;
  if (opresult2763 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 607
  setline(607);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 593
  setline(593);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2766 = gc_frame_new();
// compilenode returning *var_isadhoc
  partcv[0] = 0;
  Object call2767 = callmethod(*var_isadhoc, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe2766);
// compilenode returning call2767
  int op_slot_right_2765 = gc_frame_newslot(call2767);
  int callframe2769 = gc_frame_new();
// compilenode returning *var_isanon
  partcv[0] = 0;
  Object call2770 = callmethod(*var_isanon, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe2769);
// compilenode returning call2770
  int op_slot_left_2765 = gc_frame_newslot(call2770);
  params[0] = call2767;
  partcv[0] = 1;
  Object opresult2771 = callmethod(call2770, "&&", 1, partcv, params);
// compilenode returning opresult2771
  Object if2764 = done;
  if (istrue(opresult2771)) {
// Begin line 595
  setline(595);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 594
  setline(594);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2773 == NULL) {
    strlit2773 = alloc_String("");
    gc_root(strlit2773);
  }
// compilenode returning strlit2773
  int op_slot_right_2772 = gc_frame_newslot(strlit2773);
  int callframe2776 = gc_frame_new();
  partcv[0] = 0;
  Object call2777 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2776);
// compilenode returning call2777
// compilenode returning call2777
  int op_slot_right_2775 = gc_frame_newslot(call2777);
  if (strlit2779 == NULL) {
    strlit2779 = alloc_String("type ");
    gc_root(strlit2779);
  }
// compilenode returning strlit2779
  int op_slot_left_2775 = gc_frame_newslot(strlit2779);
  params[0] = call2777;
  partcv[0] = 1;
  Object opresult2780 = callmethod(strlit2779, "++", 1, partcv, params);
// compilenode returning opresult2780
  int op_slot_left_2772 = gc_frame_newslot(opresult2780);
  params[0] = strlit2773;
  partcv[0] = 1;
  Object opresult2781 = callmethod(opresult2780, "++", 1, partcv, params);
// compilenode returning opresult2781
  *var_s = opresult2781;
  if (opresult2781 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 605
  setline(605);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 595
  setline(595);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2785 = alloc_Float64(0);
// compilenode returning num2785
  int op_slot_right_2784 = gc_frame_newslot(num2785);
  int callframe2787 = gc_frame_new();
  int callframe2788 = gc_frame_new();
  partcv[0] = 0;
  Object call2789 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2788);
// compilenode returning call2789
// compilenode returning call2789
  partcv[0] = 0;
  Object call2790 = callmethod(call2789, "size",
    1, partcv, params);
  gc_frame_end(callframe2787);
// compilenode returning call2790
// compilenode returning call2790
  int op_slot_left_2784 = gc_frame_newslot(call2790);
  params[0] = num2785;
  partcv[0] = 1;
  Object opresult2791 = callmethod(call2790, ">", 1, partcv, params);
// compilenode returning opresult2791
  Object if2783 = done;
  if (istrue(opresult2791)) {
// Begin line 597
  setline(597);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 596
  setline(596);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2793 == NULL) {
    strlit2793 = alloc_String("<");
    gc_root(strlit2793);
  }
// compilenode returning strlit2793
  int op_slot_right_2792 = gc_frame_newslot(strlit2793);
// compilenode returning *var_s
  int op_slot_left_2792 = gc_frame_newslot(*var_s);
  params[0] = strlit2793;
  partcv[0] = 1;
  Object opresult2795 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2795
  *var_s = opresult2795;
  if (opresult2795 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 597
  setline(597);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2797 = gc_frame_new();
  int callframe2798 = gc_frame_new();
  int callframe2799 = gc_frame_new();
  partcv[0] = 0;
  Object call2800 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2799);
// compilenode returning call2800
// compilenode returning call2800
  partcv[0] = 0;
  Object call2801 = callmethod(call2800, "indices",
    1, partcv, params);
  gc_frame_end(callframe2798);
// compilenode returning call2801
// compilenode returning call2801
  gc_frame_newslot(call2801);
  Object block2802 = alloc_Block(NULL, NULL, "ast", 597);
  gc_frame_newslot(block2802);
  block_savedest(block2802);
  Object closure2803 = createclosure(2, "_apply");
setclosureframe(closure2803, stackframe);
  addtoclosure(closure2803, var_s);
  addtoclosure(closure2803, selfslot);
  struct UserObject *uo2803 = (struct UserObject*)block2802;
  uo2803->data[0] = (Object)closure2803;
  Method *meth_meth_ast__apply2803 = addmethod2pos(block2802, "_apply", &meth_ast__apply2803, 0);
int argcv_meth_ast__apply2803[] = {1};
meth_meth_ast__apply2803->type = alloc_MethodType(1, argcv_meth_ast__apply2803);
  meth_meth_ast__apply2803->definitionModule = modulename;
  meth_meth_ast__apply2803->definitionLine = 597;
// compilenode returning block2802
  gc_frame_newslot(block2802);
  params[0] = call2801;
  params[1] = block2802;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2827 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2797);
// compilenode returning call2827
// Begin line 604
  setline(604);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 603
  setline(603);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2829 == NULL) {
    strlit2829 = alloc_String(">");
    gc_root(strlit2829);
  }
// compilenode returning strlit2829
  int op_slot_right_2828 = gc_frame_newslot(strlit2829);
// compilenode returning *var_s
  int op_slot_left_2828 = gc_frame_newslot(*var_s);
  params[0] = strlit2829;
  partcv[0] = 1;
  Object opresult2831 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2831
  *var_s = opresult2831;
  if (opresult2831 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2783 = done;
  } else {
  }
// compilenode returning if2783
// Begin line 606
  setline(606);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 605
  setline(605);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2834 == NULL) {
    strlit2834 = alloc_String(" = ");
    gc_root(strlit2834);
  }
// compilenode returning strlit2834
  int op_slot_right_2833 = gc_frame_newslot(strlit2834);
// compilenode returning *var_s
  int op_slot_left_2833 = gc_frame_newslot(*var_s);
  params[0] = strlit2834;
  partcv[0] = 1;
  Object opresult2836 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2836
  *var_s = opresult2836;
  if (opresult2836 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2764 = done;
  } else {
  }
// compilenode returning if2764
// Begin line 612
  setline(612);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 608
  setline(608);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2841 = alloc_Float64(0);
// compilenode returning num2841
  int op_slot_right_2840 = gc_frame_newslot(num2841);
  int callframe2843 = gc_frame_new();
  int callframe2844 = gc_frame_new();
  partcv[0] = 0;
  Object call2845 = callmethodflags(self, "intersectionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2844);
// compilenode returning call2845
// compilenode returning call2845
  partcv[0] = 0;
  Object call2846 = callmethod(call2845, "size",
    1, partcv, params);
  gc_frame_end(callframe2843);
// compilenode returning call2846
// compilenode returning call2846
  int op_slot_left_2840 = gc_frame_newslot(call2846);
  params[0] = num2841;
  partcv[0] = 1;
  Object opresult2847 = callmethod(call2846, "==", 1, partcv, params);
// compilenode returning opresult2847
  int op_slot_right_2839 = gc_frame_newslot(opresult2847);
// Begin line 607
  setline(607);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2851 = alloc_Float64(0);
// compilenode returning num2851
  int op_slot_right_2850 = gc_frame_newslot(num2851);
  int callframe2853 = gc_frame_new();
  int callframe2854 = gc_frame_new();
  partcv[0] = 0;
  Object call2855 = callmethodflags(self, "unionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2854);
// compilenode returning call2855
// compilenode returning call2855
  partcv[0] = 0;
  Object call2856 = callmethod(call2855, "size",
    1, partcv, params);
  gc_frame_end(callframe2853);
// compilenode returning call2856
// compilenode returning call2856
  int op_slot_left_2850 = gc_frame_newslot(call2856);
  params[0] = num2851;
  partcv[0] = 1;
  Object opresult2857 = callmethod(call2856, "==", 1, partcv, params);
// compilenode returning opresult2857
  int op_slot_right_2849 = gc_frame_newslot(opresult2857);
  int callframe2859 = gc_frame_new();
// compilenode returning *var_isadhoc
  partcv[0] = 0;
  Object call2860 = callmethod(*var_isadhoc, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe2859);
// compilenode returning call2860
  int op_slot_left_2849 = gc_frame_newslot(call2860);
  params[0] = opresult2857;
  partcv[0] = 1;
  Object opresult2861 = callmethod(call2860, "&&", 1, partcv, params);
// compilenode returning opresult2861
  int op_slot_left_2839 = gc_frame_newslot(opresult2861);
  params[0] = opresult2847;
  partcv[0] = 1;
  Object opresult2862 = callmethod(opresult2861, "&&", 1, partcv, params);
// compilenode returning opresult2862
  Object if2838 = done;
  if (istrue(opresult2862)) {
// Begin line 610
  setline(610);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 609
  setline(609);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2864 == NULL) {
    strlit2864 = alloc_String("{");
    gc_root(strlit2864);
  }
// compilenode returning strlit2864
  int op_slot_right_2863 = gc_frame_newslot(strlit2864);
// compilenode returning *var_s
  int op_slot_left_2863 = gc_frame_newslot(*var_s);
  params[0] = strlit2864;
  partcv[0] = 1;
  Object opresult2866 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2866
  *var_s = opresult2866;
  if (opresult2866 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2838 = done;
  } else {
  }
// compilenode returning if2838
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 612
  setline(612);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2870 = alloc_Float64(0);
// compilenode returning num2870
  int op_slot_right_2869 = gc_frame_newslot(num2870);
  int callframe2872 = gc_frame_new();
  int callframe2873 = gc_frame_new();
  partcv[0] = 0;
  Object call2874 = callmethodflags(self, "unionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2873);
// compilenode returning call2874
// compilenode returning call2874
  partcv[0] = 0;
  Object call2875 = callmethod(call2874, "size",
    1, partcv, params);
  gc_frame_end(callframe2872);
// compilenode returning call2875
// compilenode returning call2875
  int op_slot_left_2869 = gc_frame_newslot(call2875);
  params[0] = num2870;
  partcv[0] = 1;
  Object opresult2876 = callmethod(call2875, ">", 1, partcv, params);
// compilenode returning opresult2876
  Object if2868 = done;
  if (istrue(opresult2876)) {
// Begin line 613
  setline(613);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2877 = gc_frame_new();
  int callframe2878 = gc_frame_new();
  int callframe2879 = gc_frame_new();
  partcv[0] = 0;
  Object call2880 = callmethodflags(self, "unionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2879);
// compilenode returning call2880
// compilenode returning call2880
  partcv[0] = 0;
  Object call2881 = callmethod(call2880, "indices",
    1, partcv, params);
  gc_frame_end(callframe2878);
// compilenode returning call2881
// compilenode returning call2881
  gc_frame_newslot(call2881);
  Object block2882 = alloc_Block(NULL, NULL, "ast", 613);
  gc_frame_newslot(block2882);
  block_savedest(block2882);
  Object closure2883 = createclosure(2, "_apply");
setclosureframe(closure2883, stackframe);
  addtoclosure(closure2883, var_s);
  addtoclosure(closure2883, selfslot);
  struct UserObject *uo2883 = (struct UserObject*)block2882;
  uo2883->data[0] = (Object)closure2883;
  Method *meth_meth_ast__apply2883 = addmethod2pos(block2882, "_apply", &meth_ast__apply2883, 0);
int argcv_meth_ast__apply2883[] = {1};
meth_meth_ast__apply2883->type = alloc_MethodType(1, argcv_meth_ast__apply2883);
  meth_meth_ast__apply2883->definitionModule = modulename;
  meth_meth_ast__apply2883->definitionLine = 613;
// compilenode returning block2882
  gc_frame_newslot(block2882);
  params[0] = call2881;
  params[1] = block2882;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2908 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2877);
// compilenode returning call2908
    gc_frame_newslot(call2908);
    if2868 = call2908;
  } else {
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 619
  setline(619);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2911 = alloc_Float64(0);
// compilenode returning num2911
  int op_slot_right_2910 = gc_frame_newslot(num2911);
  int callframe2913 = gc_frame_new();
  int callframe2914 = gc_frame_new();
  partcv[0] = 0;
  Object call2915 = callmethodflags(self, "intersectionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2914);
// compilenode returning call2915
// compilenode returning call2915
  partcv[0] = 0;
  Object call2916 = callmethod(call2915, "size",
    1, partcv, params);
  gc_frame_end(callframe2913);
// compilenode returning call2916
// compilenode returning call2916
  int op_slot_left_2910 = gc_frame_newslot(call2916);
  params[0] = num2911;
  partcv[0] = 1;
  Object opresult2917 = callmethod(call2916, ">", 1, partcv, params);
// compilenode returning opresult2917
  Object if2909 = done;
  if (istrue(opresult2917)) {
// Begin line 620
  setline(620);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2918 = gc_frame_new();
  int callframe2919 = gc_frame_new();
  int callframe2920 = gc_frame_new();
  partcv[0] = 0;
  Object call2921 = callmethodflags(self, "intersectionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2920);
// compilenode returning call2921
// compilenode returning call2921
  partcv[0] = 0;
  Object call2922 = callmethod(call2921, "indices",
    1, partcv, params);
  gc_frame_end(callframe2919);
// compilenode returning call2922
// compilenode returning call2922
  gc_frame_newslot(call2922);
  Object block2923 = alloc_Block(NULL, NULL, "ast", 620);
  gc_frame_newslot(block2923);
  block_savedest(block2923);
  Object closure2924 = createclosure(2, "_apply");
setclosureframe(closure2924, stackframe);
  addtoclosure(closure2924, var_s);
  addtoclosure(closure2924, selfslot);
  struct UserObject *uo2924 = (struct UserObject*)block2923;
  uo2924->data[0] = (Object)closure2924;
  Method *meth_meth_ast__apply2924 = addmethod2pos(block2923, "_apply", &meth_ast__apply2924, 0);
int argcv_meth_ast__apply2924[] = {1};
meth_meth_ast__apply2924->type = alloc_MethodType(1, argcv_meth_ast__apply2924);
  meth_meth_ast__apply2924->definitionModule = modulename;
  meth_meth_ast__apply2924->definitionLine = 620;
// compilenode returning block2923
  gc_frame_newslot(block2923);
  params[0] = call2922;
  params[1] = block2923;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2949 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2918);
// compilenode returning call2949
    gc_frame_newslot(call2949);
    if2909 = call2949;
  } else {
  }
// compilenode returning if2909
    gc_frame_newslot(if2909);
    if2868 = if2909;
  }
// compilenode returning if2868
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2950 = gc_frame_new();
  int callframe2951 = gc_frame_new();
  partcv[0] = 0;
  Object call2952 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2951);
// compilenode returning call2952
// compilenode returning call2952
  gc_frame_newslot(call2952);
  Object block2953 = alloc_Block(NULL, NULL, "ast", 627);
  gc_frame_newslot(block2953);
  block_savedest(block2953);
  Object closure2954 = createclosure(4, "_apply");
setclosureframe(closure2954, stackframe);
  addtoclosure(closure2954, var_depth);
  addtoclosure(closure2954, var_spc);
  addtoclosure(closure2954, var_s);
  addtoclosure(closure2954, selfslot);
  struct UserObject *uo2954 = (struct UserObject*)block2953;
  uo2954->data[0] = (Object)closure2954;
  Method *meth_meth_ast__apply2954 = addmethod2pos(block2953, "_apply", &meth_ast__apply2954, 0);
int argcv_meth_ast__apply2954[] = {1};
meth_meth_ast__apply2954->type = alloc_MethodType(1, argcv_meth_ast__apply2954);
  meth_meth_ast__apply2954->definitionModule = modulename;
  meth_meth_ast__apply2954->definitionLine = 627;
// compilenode returning block2953
  gc_frame_newslot(block2953);
  params[0] = call2952;
  params[1] = block2953;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2977 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2950);
// compilenode returning call2977
// Begin line 634
  setline(634);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2981 = alloc_Float64(0);
// compilenode returning num2981
  int op_slot_right_2980 = gc_frame_newslot(num2981);
  int callframe2983 = gc_frame_new();
  int callframe2984 = gc_frame_new();
  partcv[0] = 0;
  Object call2985 = callmethodflags(self, "intersectionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2984);
// compilenode returning call2985
// compilenode returning call2985
  partcv[0] = 0;
  Object call2986 = callmethod(call2985, "size",
    1, partcv, params);
  gc_frame_end(callframe2983);
// compilenode returning call2986
// compilenode returning call2986
  int op_slot_left_2980 = gc_frame_newslot(call2986);
  params[0] = num2981;
  partcv[0] = 1;
  Object opresult2987 = callmethod(call2986, "==", 1, partcv, params);
// compilenode returning opresult2987
  int op_slot_right_2979 = gc_frame_newslot(opresult2987);
// Begin line 630
  setline(630);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2991 = alloc_Float64(0);
// compilenode returning num2991
  int op_slot_right_2990 = gc_frame_newslot(num2991);
  int callframe2993 = gc_frame_new();
  int callframe2994 = gc_frame_new();
  partcv[0] = 0;
  Object call2995 = callmethodflags(self, "unionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2994);
// compilenode returning call2995
// compilenode returning call2995
  partcv[0] = 0;
  Object call2996 = callmethod(call2995, "size",
    1, partcv, params);
  gc_frame_end(callframe2993);
// compilenode returning call2996
// compilenode returning call2996
  int op_slot_left_2990 = gc_frame_newslot(call2996);
  params[0] = num2991;
  partcv[0] = 1;
  Object opresult2997 = callmethod(call2996, "==", 1, partcv, params);
// compilenode returning opresult2997
  int op_slot_right_2989 = gc_frame_newslot(opresult2997);
  int callframe2999 = gc_frame_new();
// compilenode returning *var_isadhoc
  partcv[0] = 0;
  Object call3000 = callmethod(*var_isadhoc, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe2999);
// compilenode returning call3000
  int op_slot_left_2989 = gc_frame_newslot(call3000);
  params[0] = opresult2997;
  partcv[0] = 1;
  Object opresult3001 = callmethod(call3000, "&&", 1, partcv, params);
// compilenode returning opresult3001
  int op_slot_left_2979 = gc_frame_newslot(opresult3001);
  params[0] = opresult2987;
  partcv[0] = 1;
  Object opresult3002 = callmethod(opresult3001, "&&", 1, partcv, params);
// compilenode returning opresult3002
  Object if2978 = done;
  if (istrue(opresult3002)) {
// Begin line 633
  setline(633);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 632
  setline(632);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3004 == NULL) {
    strlit3004 = alloc_String("}");
    gc_root(strlit3004);
  }
// compilenode returning strlit3004
  int op_slot_right_3003 = gc_frame_newslot(strlit3004);
// compilenode returning *var_spc
  int op_slot_right_3006 = gc_frame_newslot(*var_spc);
  if (strlit3009 == NULL) {
    strlit3009 = alloc_String("""\x0a""");
    gc_root(strlit3009);
  }
// compilenode returning strlit3009
  int op_slot_right_3008 = gc_frame_newslot(strlit3009);
// compilenode returning *var_s
  int op_slot_left_3008 = gc_frame_newslot(*var_s);
  params[0] = strlit3009;
  partcv[0] = 1;
  Object opresult3011 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3011
  int op_slot_left_3006 = gc_frame_newslot(opresult3011);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3012 = callmethod(opresult3011, "++", 1, partcv, params);
// compilenode returning opresult3012
  int op_slot_left_3003 = gc_frame_newslot(opresult3012);
  params[0] = strlit3004;
  partcv[0] = 1;
  Object opresult3013 = callmethod(opresult3012, "++", 1, partcv, params);
// compilenode returning opresult3013
  *var_s = opresult3013;
  if (opresult3013 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2978 = done;
  } else {
  }
// compilenode returning if2978
// Begin line 634
  setline(634);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new2286(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_typeNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  Object *var_collections = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_methods_39_ = &(stackframe->slots[1]);
  *var_methods_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2287 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2287 = alloc_userobj2(18,16, objclass2287);
  gc_frame_newslot(obj2287);
if (objclass2287 == NULL) {
  glfree(obj2287->class->name);
  obj2287->class->name = "typeNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2287, self, 0);
  addmethodreal(obj2287,"outer", &reader_ast_outer_2288);
  Object oldself2287 = self;
  struct StackFrameObject *oldstackframe2287 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2287);
  gc_frame_newslot((Object)stackframe);
  self = obj2287;
  Object *oldselfslot2287 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2287 = (*(struct UserObject *)self).data[0], lowerouter2287 = thisouter2287;
  if (inheritingObject2287) {
    struct UserObject *inho2287 = (struct UserObject *)inheritingObject2287;
    while (inho2287->super != GraceDefaultObject) inho2287 = (struct UserObject *)inho2287->super;
    inho2287->super = obj2287;
    self = inheritingObject2287;
    *selfslot = self;
    lowerouter2287 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2287;
  }
if (objclass2287 == NULL) {
  Method *reader2289 = addmethodrealflags(obj2287, "kind",&reader_ast_kind_2289, MFLAG_DEF);
  reader2289->definitionModule = modulename;
  reader2289->definitionLine = 503;
}
adddatum2(obj2287, alloc_Undefined(), 1);
if (objclass2287 == NULL) {
  Method *reader2290 = addmethodrealflags(obj2287, "value",&reader_ast_value_2290, MFLAG_DEF);
  reader2290->definitionModule = modulename;
  reader2290->definitionLine = 504;
}
adddatum2(obj2287, alloc_Undefined(), 2);
if (objclass2287 == NULL) {
  Method *reader2291 = addmethodrealflags(obj2287, "methods",&reader_ast_methods_2291, MFLAG_DEF);
  reader2291->definitionModule = modulename;
  reader2291->definitionLine = 505;
}
adddatum2(obj2287, alloc_Undefined(), 3);
if (objclass2287 == NULL) {
  Method *reader2292 = addmethodrealflags(obj2287, "unionTypes",&reader_ast_unionTypes_2292, MFLAG_DEF);
  reader2292->definitionModule = modulename;
  reader2292->definitionLine = 506;
}
adddatum2(obj2287, alloc_Undefined(), 4);
if (objclass2287 == NULL) {
  Method *reader2293 = addmethodrealflags(obj2287, "intersectionTypes",&reader_ast_intersectionTypes_2293, MFLAG_DEF);
  reader2293->definitionModule = modulename;
  reader2293->definitionLine = 507;
}
adddatum2(obj2287, alloc_Undefined(), 5);
if (objclass2287 == NULL) {
  Method *reader2294 = addmethodrealflags(obj2287, "annotations",&reader_ast_annotations_2294, MFLAG_DEF);
  reader2294->definitionModule = modulename;
  reader2294->definitionLine = 508;
}
adddatum2(obj2287, alloc_Undefined(), 6);
if (objclass2287 == NULL) {
  Method *reader2295 = addmethodrealflags(obj2287, "generics",&reader_ast_generics_2295, 0);
  Method *writer2295 = addmethodrealflags(obj2287, "generics:=",&writer_ast_generics_2295, 0);
  reader2295->definitionModule = modulename;
  writer2295->definitionModule = modulename;
  reader2295->definitionLine = 509;
  writer2295->definitionLine = 509;
}
obj2287->flags |= OFLAG_MUTABLE;
adddatum2(obj2287, alloc_Undefined(), 7);
if (objclass2287 == NULL) {
  Method *reader2296 = addmethodrealflags(obj2287, "nominal",&reader_ast_nominal_2296, 0);
  Method *writer2296 = addmethodrealflags(obj2287, "nominal:=",&writer_ast_nominal_2296, 0);
  reader2296->definitionModule = modulename;
  writer2296->definitionModule = modulename;
  reader2296->definitionLine = 510;
  writer2296->definitionLine = 510;
}
obj2287->flags |= OFLAG_MUTABLE;
adddatum2(obj2287, alloc_Undefined(), 8);
if (objclass2287 == NULL) {
  Method *reader2297 = addmethodrealflags(obj2287, "anonymous",&reader_ast_anonymous_2297, 0);
  Method *writer2297 = addmethodrealflags(obj2287, "anonymous:=",&writer_ast_anonymous_2297, 0);
  reader2297->definitionModule = modulename;
  writer2297->definitionModule = modulename;
  reader2297->definitionLine = 511;
  writer2297->definitionLine = 511;
}
obj2287->flags |= OFLAG_MUTABLE;
adddatum2(obj2287, alloc_Undefined(), 9);
  struct UserObject *uo2298 = (struct UserObject*)obj2287;
  uo2298->data[10] = emptyclosure;
  Method *meth_meth_ast_accept2298 = addmethod2pos(obj2287, "accept", &meth_ast_accept2298, 10);
int argcv_meth_ast_accept2298[] = {1};
meth_meth_ast_accept2298->type = alloc_MethodType(1, argcv_meth_ast_accept2298);
meth_meth_ast_accept2298->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept2298->type->names[0] = "visitor";
  meth_meth_ast_accept2298->definitionModule = modulename;
  meth_meth_ast_accept2298->definitionLine = 511;
  block_savedest(obj2287);
  Object closure2347 = createclosure(1, "map()before()after");
setclosureframe(closure2347, stackframe);
  addtoclosure(closure2347, var_typeNode);
  struct UserObject *uo2347 = (struct UserObject*)obj2287;
  uo2347->data[11] = (Object)closure2347;
  Method *meth_meth_ast_map_40__41_before_40__41_after2347 = addmethod2pos(obj2287, "map()before()after", &meth_ast_map_40__41_before_40__41_after2347, 11);
int argcv_meth_ast_map_40__41_before_40__41_after2347[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after2347->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after2347);
  meth_meth_ast_map_40__41_before_40__41_after2347->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after2347->definitionLine = 528;
  struct UserObject *uo2451 = (struct UserObject*)obj2287;
  uo2451->data[12] = emptyclosure;
  Method *meth_meth_ast_map2451 = addmethod2pos(obj2287, "map", &meth_ast_map2451, 12);
int argcv_meth_ast_map2451[] = {1};
meth_meth_ast_map2451->type = alloc_MethodType(1, argcv_meth_ast_map2451);
  meth_meth_ast_map2451->definitionModule = modulename;
  meth_meth_ast_map2451->definitionLine = 549;
  struct UserObject *uo2460 = (struct UserObject*)obj2287;
  uo2460->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty2460 = addmethod2pos(obj2287, "pretty", &meth_ast_pretty2460, 13);
int argcv_meth_ast_pretty2460[] = {1};
meth_meth_ast_pretty2460->type = alloc_MethodType(1, argcv_meth_ast_pretty2460);
  meth_meth_ast_pretty2460->definitionModule = modulename;
  meth_meth_ast_pretty2460->definitionLine = 552;
  struct UserObject *uo2710 = (struct UserObject*)obj2287;
  uo2710->data[14] = emptyclosure;
  Method *meth_meth_ast_toGrace2710 = addmethod2pos(obj2287, "toGrace", &meth_ast_toGrace2710, 14);
int argcv_meth_ast_toGrace2710[] = {1};
meth_meth_ast_toGrace2710->type = alloc_MethodType(1, argcv_meth_ast_toGrace2710);
meth_meth_ast_toGrace2710->type->types[0] = type_Number;
meth_meth_ast_toGrace2710->type->names[0] = "depth";
  meth_meth_ast_toGrace2710->definitionModule = modulename;
  meth_meth_ast_toGrace2710->definitionLine = 584;
  sourceObject = obj2287;
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3015 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3016 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe3015);
// compilenode returning call3016
  struct UserObject *obj2287_uo = (struct UserObject *)obj2287;
  obj2287_uo->super = call3016;
  sourceObject = obj2287;
// Begin line 502
  setline(502);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3017 == NULL) {
    strlit3017 = alloc_String("type");
    gc_root(strlit3017);
  }
// compilenode returning strlit3017
  adddatum2(obj2287, strlit3017, 1);
  sourceObject = obj2287;
// Begin line 503
  setline(503);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name_39_
  adddatum2(obj2287, *var_name_39_, 2);
  sourceObject = obj2287;
// Begin line 504
  setline(504);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_methods_39_
  adddatum2(obj2287, *var_methods_39_, 3);
  sourceObject = obj2287;
// Begin line 505
  setline(505);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array3018 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array3018
  adddatum2(obj2287, array3018, 4);
  sourceObject = obj2287;
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array3019 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array3019
  adddatum2(obj2287, array3019, 5);
  sourceObject = obj2287;
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3020 = gc_frame_new();
  int callframe3021 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call3022 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe3021);
// compilenode returning call3022
// compilenode returning call3022
  partcv[0] = 0;
  Object call3023 = callmethod(call3022, "new",
    1, partcv, params);
  gc_frame_end(callframe3020);
// compilenode returning call3023
// compilenode returning call3023
  adddatum2(obj2287, call3023, 6);
  sourceObject = obj2287;
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array3024 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array3024
  adddatum2(obj2287, array3024, 7);
  sourceObject = obj2287;
// Begin line 509
  setline(509);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3025 = alloc_Boolean(0);
// compilenode returning bool3025
  adddatum2(obj2287, bool3025, 8);
  sourceObject = obj2287;
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3026 = alloc_Boolean(0);
// compilenode returning bool3026
  adddatum2(obj2287, bool3026, 9);
  sourceObject = obj2287;
  sourceObject = obj2287;
  sourceObject = obj2287;
  sourceObject = obj2287;
  sourceObject = obj2287;
objclass2287 = obj2287->class;
  objclass2287->definitionModule = modulename;
  objclass2287->definitionLine = 495;
  (*(struct UserObject *)self).data[0] = lowerouter2287;
  self = oldself2287;
  selfslot = oldselfslot2287;
  stackframe = oldstackframe2287;
  gc_frame_end(frame);
  return obj2287;
}
Object meth_ast_new2286_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_typeNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  Object *var_collections = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_methods_39_ = &(stackframe->slots[1]);
  *var_methods_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2287 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2287 = alloc_userobj2(18,16, objclass2287);
  gc_frame_newslot(obj2287);
if (objclass2287 == NULL) {
  glfree(obj2287->class->name);
  obj2287->class->name = "typeNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2287, self, 0);
  addmethodreal(obj2287,"outer", &reader_ast_outer_2288);
  Object oldself2287 = self;
  struct StackFrameObject *oldstackframe2287 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2287);
  gc_frame_newslot((Object)stackframe);
  self = obj2287;
  Object *oldselfslot2287 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2287 = (*(struct UserObject *)self).data[0], lowerouter2287 = thisouter2287;
  if (inheritingObject2287) {
    struct UserObject *inho2287 = (struct UserObject *)inheritingObject2287;
    while (inho2287->super != GraceDefaultObject) inho2287 = (struct UserObject *)inho2287->super;
    inho2287->super = obj2287;
    self = inheritingObject2287;
    *selfslot = self;
    lowerouter2287 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2287;
  }
if (objclass2287 == NULL) {
  Method *reader2289 = addmethodrealflags(obj2287, "kind",&reader_ast_kind_2289, MFLAG_DEF);
  reader2289->definitionModule = modulename;
  reader2289->definitionLine = 503;
}
adddatum2(obj2287, alloc_Undefined(), 1);
if (objclass2287 == NULL) {
  Method *reader2290 = addmethodrealflags(obj2287, "value",&reader_ast_value_2290, MFLAG_DEF);
  reader2290->definitionModule = modulename;
  reader2290->definitionLine = 504;
}
adddatum2(obj2287, alloc_Undefined(), 2);
if (objclass2287 == NULL) {
  Method *reader2291 = addmethodrealflags(obj2287, "methods",&reader_ast_methods_2291, MFLAG_DEF);
  reader2291->definitionModule = modulename;
  reader2291->definitionLine = 505;
}
adddatum2(obj2287, alloc_Undefined(), 3);
if (objclass2287 == NULL) {
  Method *reader2292 = addmethodrealflags(obj2287, "unionTypes",&reader_ast_unionTypes_2292, MFLAG_DEF);
  reader2292->definitionModule = modulename;
  reader2292->definitionLine = 506;
}
adddatum2(obj2287, alloc_Undefined(), 4);
if (objclass2287 == NULL) {
  Method *reader2293 = addmethodrealflags(obj2287, "intersectionTypes",&reader_ast_intersectionTypes_2293, MFLAG_DEF);
  reader2293->definitionModule = modulename;
  reader2293->definitionLine = 507;
}
adddatum2(obj2287, alloc_Undefined(), 5);
if (objclass2287 == NULL) {
  Method *reader2294 = addmethodrealflags(obj2287, "annotations",&reader_ast_annotations_2294, MFLAG_DEF);
  reader2294->definitionModule = modulename;
  reader2294->definitionLine = 508;
}
adddatum2(obj2287, alloc_Undefined(), 6);
if (objclass2287 == NULL) {
  Method *reader2295 = addmethodrealflags(obj2287, "generics",&reader_ast_generics_2295, 0);
  Method *writer2295 = addmethodrealflags(obj2287, "generics:=",&writer_ast_generics_2295, 0);
  reader2295->definitionModule = modulename;
  writer2295->definitionModule = modulename;
  reader2295->definitionLine = 509;
  writer2295->definitionLine = 509;
}
obj2287->flags |= OFLAG_MUTABLE;
adddatum2(obj2287, alloc_Undefined(), 7);
if (objclass2287 == NULL) {
  Method *reader2296 = addmethodrealflags(obj2287, "nominal",&reader_ast_nominal_2296, 0);
  Method *writer2296 = addmethodrealflags(obj2287, "nominal:=",&writer_ast_nominal_2296, 0);
  reader2296->definitionModule = modulename;
  writer2296->definitionModule = modulename;
  reader2296->definitionLine = 510;
  writer2296->definitionLine = 510;
}
obj2287->flags |= OFLAG_MUTABLE;
adddatum2(obj2287, alloc_Undefined(), 8);
if (objclass2287 == NULL) {
  Method *reader2297 = addmethodrealflags(obj2287, "anonymous",&reader_ast_anonymous_2297, 0);
  Method *writer2297 = addmethodrealflags(obj2287, "anonymous:=",&writer_ast_anonymous_2297, 0);
  reader2297->definitionModule = modulename;
  writer2297->definitionModule = modulename;
  reader2297->definitionLine = 511;
  writer2297->definitionLine = 511;
}
obj2287->flags |= OFLAG_MUTABLE;
adddatum2(obj2287, alloc_Undefined(), 9);
  struct UserObject *uo2298 = (struct UserObject*)obj2287;
  uo2298->data[10] = emptyclosure;
  Method *meth_meth_ast_accept2298 = addmethod2pos(obj2287, "accept", &meth_ast_accept2298, 10);
int argcv_meth_ast_accept2298[] = {1};
meth_meth_ast_accept2298->type = alloc_MethodType(1, argcv_meth_ast_accept2298);
meth_meth_ast_accept2298->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept2298->type->names[0] = "visitor";
  meth_meth_ast_accept2298->definitionModule = modulename;
  meth_meth_ast_accept2298->definitionLine = 511;
  block_savedest(obj2287);
  Object closure2347 = createclosure(1, "map()before()after");
setclosureframe(closure2347, stackframe);
  addtoclosure(closure2347, var_typeNode);
  struct UserObject *uo2347 = (struct UserObject*)obj2287;
  uo2347->data[11] = (Object)closure2347;
  Method *meth_meth_ast_map_40__41_before_40__41_after2347 = addmethod2pos(obj2287, "map()before()after", &meth_ast_map_40__41_before_40__41_after2347, 11);
int argcv_meth_ast_map_40__41_before_40__41_after2347[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after2347->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after2347);
  meth_meth_ast_map_40__41_before_40__41_after2347->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after2347->definitionLine = 528;
  struct UserObject *uo2451 = (struct UserObject*)obj2287;
  uo2451->data[12] = emptyclosure;
  Method *meth_meth_ast_map2451 = addmethod2pos(obj2287, "map", &meth_ast_map2451, 12);
int argcv_meth_ast_map2451[] = {1};
meth_meth_ast_map2451->type = alloc_MethodType(1, argcv_meth_ast_map2451);
  meth_meth_ast_map2451->definitionModule = modulename;
  meth_meth_ast_map2451->definitionLine = 549;
  struct UserObject *uo2460 = (struct UserObject*)obj2287;
  uo2460->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty2460 = addmethod2pos(obj2287, "pretty", &meth_ast_pretty2460, 13);
int argcv_meth_ast_pretty2460[] = {1};
meth_meth_ast_pretty2460->type = alloc_MethodType(1, argcv_meth_ast_pretty2460);
  meth_meth_ast_pretty2460->definitionModule = modulename;
  meth_meth_ast_pretty2460->definitionLine = 552;
  struct UserObject *uo2710 = (struct UserObject*)obj2287;
  uo2710->data[14] = emptyclosure;
  Method *meth_meth_ast_toGrace2710 = addmethod2pos(obj2287, "toGrace", &meth_ast_toGrace2710, 14);
int argcv_meth_ast_toGrace2710[] = {1};
meth_meth_ast_toGrace2710->type = alloc_MethodType(1, argcv_meth_ast_toGrace2710);
meth_meth_ast_toGrace2710->type->types[0] = type_Number;
meth_meth_ast_toGrace2710->type->names[0] = "depth";
  meth_meth_ast_toGrace2710->definitionModule = modulename;
  meth_meth_ast_toGrace2710->definitionLine = 584;
  sourceObject = obj2287;
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3015 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3016 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe3015);
// compilenode returning call3016
  struct UserObject *obj2287_uo = (struct UserObject *)obj2287;
  obj2287_uo->super = call3016;
  sourceObject = obj2287;
// Begin line 502
  setline(502);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3017 == NULL) {
    strlit3017 = alloc_String("type");
    gc_root(strlit3017);
  }
// compilenode returning strlit3017
  adddatum2(obj2287, strlit3017, 1);
  sourceObject = obj2287;
// Begin line 503
  setline(503);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name_39_
  adddatum2(obj2287, *var_name_39_, 2);
  sourceObject = obj2287;
// Begin line 504
  setline(504);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_methods_39_
  adddatum2(obj2287, *var_methods_39_, 3);
  sourceObject = obj2287;
// Begin line 505
  setline(505);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array3018 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array3018
  adddatum2(obj2287, array3018, 4);
  sourceObject = obj2287;
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array3019 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array3019
  adddatum2(obj2287, array3019, 5);
  sourceObject = obj2287;
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3020 = gc_frame_new();
  int callframe3021 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call3022 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe3021);
// compilenode returning call3022
// compilenode returning call3022
  partcv[0] = 0;
  Object call3023 = callmethod(call3022, "new",
    1, partcv, params);
  gc_frame_end(callframe3020);
// compilenode returning call3023
// compilenode returning call3023
  adddatum2(obj2287, call3023, 6);
  sourceObject = obj2287;
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array3024 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array3024
  adddatum2(obj2287, array3024, 7);
  sourceObject = obj2287;
// Begin line 509
  setline(509);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3025 = alloc_Boolean(0);
// compilenode returning bool3025
  adddatum2(obj2287, bool3025, 8);
  sourceObject = obj2287;
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3026 = alloc_Boolean(0);
// compilenode returning bool3026
  adddatum2(obj2287, bool3026, 9);
  sourceObject = obj2287;
  sourceObject = obj2287;
  sourceObject = obj2287;
  sourceObject = obj2287;
  sourceObject = obj2287;
objclass2287 = obj2287->class;
  objclass2287->definitionModule = modulename;
  objclass2287->definitionLine = 495;
  (*(struct UserObject *)self).data[0] = lowerouter2287;
  self = oldself2287;
  selfslot = oldselfslot2287;
  stackframe = oldstackframe2287;
  gc_frame_end(frame);
  return obj2287;
}
Object meth_ast_methodNode3028(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_methodNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for methodNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for methodNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 637
  setline(637);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_methodNode
  gc_frame_end(frame);
  return *var_methodNode;
}
Object meth_ast__apply3072(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 672
  setline(672);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3073 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_p
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call3074 = callmethod(*var_p, "accept",
    1, partcv, params);
  gc_frame_end(callframe3073);
// compilenode returning call3074
  gc_frame_end(frame);
  return call3074;
}
Object meth_ast__apply3067(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3068 = gc_frame_new();
  int callframe3069 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3070 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe3069);
// compilenode returning call3070
// compilenode returning call3070
  gc_frame_newslot(call3070);
  Object block3071 = alloc_Block(NULL, NULL, "ast", 671);
  gc_frame_newslot(block3071);
  block_savedest(block3071);
  Object closure3072 = createclosure(2, "_apply");
setclosureframe(closure3072, stackframe);
  addtoclosure(closure3072, var_visitor);
  addtoclosure(closure3072, selfslot);
  struct UserObject *uo3072 = (struct UserObject*)block3071;
  uo3072->data[0] = (Object)closure3072;
  Method *meth_meth_ast__apply3072 = addmethod2pos(block3071, "_apply", &meth_ast__apply3072, 0);
int argcv_meth_ast__apply3072[] = {1};
meth_meth_ast__apply3072->type = alloc_MethodType(1, argcv_meth_ast__apply3072);
  meth_meth_ast__apply3072->definitionModule = modulename;
  meth_meth_ast__apply3072->definitionLine = 671;
// compilenode returning block3071
  gc_frame_newslot(block3071);
  params[0] = call3070;
  params[1] = block3071;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3076 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3068);
// compilenode returning call3076
// Begin line 677
  setline(677);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 674
  setline(674);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3079 = alloc_Boolean(0);
// compilenode returning bool3079
  int op_slot_right_3078 = gc_frame_newslot(bool3079);
  int callframe3081 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3082 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3081);
// compilenode returning call3082
// compilenode returning call3082
  int op_slot_left_3078 = gc_frame_newslot(call3082);
  params[0] = bool3079;
  partcv[0] = 1;
  Object opresult3083 = callmethod(call3082, "!=", 1, partcv, params);
// compilenode returning opresult3083
  Object if3077 = done;
  if (istrue(opresult3083)) {
// Begin line 675
  setline(675);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3084 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe3085 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3086 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3085);
// compilenode returning call3086
// compilenode returning call3086
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call3087 = callmethod(call3086, "accept",
    1, partcv, params);
  gc_frame_end(callframe3084);
// compilenode returning call3087
    gc_frame_newslot(call3087);
    if3077 = call3087;
  } else {
  }
// compilenode returning if3077
  gc_frame_end(frame);
  return if3077;
}
Object meth_ast__apply3094(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 679
  setline(679);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3095 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_mx
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call3096 = callmethod(*var_mx, "accept",
    1, partcv, params);
  gc_frame_end(callframe3095);
// compilenode returning call3096
  gc_frame_end(frame);
  return call3096;
}
Object meth_ast_accept3044(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 682
  setline(682);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 665
  setline(665);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3046 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call3047 = callmethod(*var_visitor, "visitMethod",
    1, partcv, params);
  gc_frame_end(callframe3046);
// compilenode returning call3047
  Object if3045 = done;
  if (istrue(call3047)) {
// Begin line 666
  setline(666);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3048 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe3049 = gc_frame_new();
  partcv[0] = 0;
  Object call3050 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3049);
// compilenode returning call3050
// compilenode returning call3050
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call3051 = callmethod(call3050, "accept",
    1, partcv, params);
  gc_frame_end(callframe3048);
// compilenode returning call3051
// Begin line 670
  setline(670);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3054 = alloc_Boolean(0);
// compilenode returning bool3054
  int op_slot_right_3053 = gc_frame_newslot(bool3054);
  int callframe3056 = gc_frame_new();
  partcv[0] = 0;
  Object call3057 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3056);
// compilenode returning call3057
// compilenode returning call3057
  int op_slot_left_3053 = gc_frame_newslot(call3057);
  params[0] = bool3054;
  partcv[0] = 1;
  Object opresult3058 = callmethod(call3057, "!=", 1, partcv, params);
// compilenode returning opresult3058
  Object if3052 = done;
  if (istrue(opresult3058)) {
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3059 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe3060 = gc_frame_new();
  partcv[0] = 0;
  Object call3061 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3060);
// compilenode returning call3061
// compilenode returning call3061
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call3062 = callmethod(call3061, "accept",
    1, partcv, params);
  gc_frame_end(callframe3059);
// compilenode returning call3062
    gc_frame_newslot(call3062);
    if3052 = call3062;
  } else {
  }
// compilenode returning if3052
// Begin line 670
  setline(670);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3063 = gc_frame_new();
  int callframe3064 = gc_frame_new();
  partcv[0] = 0;
  Object call3065 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3064);
// compilenode returning call3065
// compilenode returning call3065
  gc_frame_newslot(call3065);
  Object block3066 = alloc_Block(NULL, NULL, "ast", 670);
  gc_frame_newslot(block3066);
  block_savedest(block3066);
  Object closure3067 = createclosure(2, "_apply");
setclosureframe(closure3067, stackframe);
  addtoclosure(closure3067, var_visitor);
  addtoclosure(closure3067, selfslot);
  struct UserObject *uo3067 = (struct UserObject*)block3066;
  uo3067->data[0] = (Object)closure3067;
  Method *meth_meth_ast__apply3067 = addmethod2pos(block3066, "_apply", &meth_ast__apply3067, 0);
int argcv_meth_ast__apply3067[] = {1};
meth_meth_ast__apply3067->type = alloc_MethodType(1, argcv_meth_ast__apply3067);
  meth_meth_ast__apply3067->definitionModule = modulename;
  meth_meth_ast__apply3067->definitionLine = 670;
// compilenode returning block3066
  gc_frame_newslot(block3066);
  params[0] = call3065;
  params[1] = block3066;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3089 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3063);
// compilenode returning call3089
// Begin line 678
  setline(678);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3090 = gc_frame_new();
  int callframe3091 = gc_frame_new();
  partcv[0] = 0;
  Object call3092 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3091);
// compilenode returning call3092
// compilenode returning call3092
  gc_frame_newslot(call3092);
  Object block3093 = alloc_Block(NULL, NULL, "ast", 678);
  gc_frame_newslot(block3093);
  block_savedest(block3093);
  Object closure3094 = createclosure(2, "_apply");
setclosureframe(closure3094, stackframe);
  addtoclosure(closure3094, var_visitor);
  addtoclosure(closure3094, selfslot);
  struct UserObject *uo3094 = (struct UserObject*)block3093;
  uo3094->data[0] = (Object)closure3094;
  Method *meth_meth_ast__apply3094 = addmethod2pos(block3093, "_apply", &meth_ast__apply3094, 0);
int argcv_meth_ast__apply3094[] = {1};
meth_meth_ast__apply3094->type = alloc_MethodType(1, argcv_meth_ast__apply3094);
  meth_meth_ast__apply3094->definitionModule = modulename;
  meth_meth_ast__apply3094->definitionLine = 678;
// compilenode returning block3093
  gc_frame_newslot(block3093);
  params[0] = call3092;
  params[1] = block3093;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3098 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3090);
// compilenode returning call3098
    gc_frame_newslot(call3098);
    if3045 = call3098;
  } else {
  }
// compilenode returning if3045
  gc_frame_end(frame);
  return if3045;
}
Object meth_ast__apply3137(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_blk = getfromclosure(closure, 0);
  Object *var_blkBefore = getfromclosure(closure, 1);
  Object *var_blkAfter = getfromclosure(closure, 2);
  Object *var_n = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 691
  setline(691);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3138 = gc_frame_new();
  int callframe3139 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// compilenode returning *var_a
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3140 = callmethod(*var_a, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe3139);
// compilenode returning call3140
  gc_frame_newslot(call3140);
  int callframe3141 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call3142 = callmethod(*var_n, "annotations",
    1, partcv, params);
  gc_frame_end(callframe3141);
// compilenode returning call3142
// compilenode returning call3142
  params[0] = call3140;
  partcv[0] = 1;
  Object call3143 = callmethod(call3142, "push",
    1, partcv, params);
  gc_frame_end(callframe3138);
// compilenode returning call3143
  gc_frame_end(frame);
  return call3143;
}
Object meth_ast__apply3156(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_blk = getfromclosure(closure, 0);
  Object *var_blkBefore = getfromclosure(closure, 1);
  Object *var_blkAfter = getfromclosure(closure, 2);
  Object *var_n = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3157 = gc_frame_new();
  int callframe3158 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// compilenode returning *var_a
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3159 = callmethod(*var_a, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe3158);
// compilenode returning call3159
  gc_frame_newslot(call3159);
  int callframe3160 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call3161 = callmethod(*var_n, "generics",
    1, partcv, params);
  gc_frame_end(callframe3160);
// compilenode returning call3161
// compilenode returning call3161
  params[0] = call3159;
  partcv[0] = 1;
  Object call3162 = callmethod(call3161, "push",
    1, partcv, params);
  gc_frame_end(callframe3157);
// compilenode returning call3162
  gc_frame_end(frame);
  return call3162;
}
Object meth_ast_map_40__41_before_40__41_after3099(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_name_39_ = getfromclosure(closure, 0);
  Object *var_methodNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_dt = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "dt");
  Object *var_n = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "n");
// Begin line 684
  setline(684);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3100 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call3101 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe3100);
// compilenode returning call3101
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 685
  setline(685);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3102 = alloc_Boolean(0);
// compilenode returning bool3102
  *var_dt = bool3102;
  if (bool3102 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3105 = alloc_Boolean(0);
// compilenode returning bool3105
  int op_slot_right_3104 = gc_frame_newslot(bool3105);
  int callframe3107 = gc_frame_new();
  partcv[0] = 0;
  Object call3108 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3107);
// compilenode returning call3108
  int op_slot_left_3104 = gc_frame_newslot(call3108);
  params[0] = bool3105;
  partcv[0] = 1;
  Object opresult3109 = callmethod(call3108, "!=", 1, partcv, params);
// compilenode returning opresult3109
  Object if3103 = done;
  if (istrue(opresult3109)) {
// Begin line 687
  setline(687);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3110 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe3111 = gc_frame_new();
  partcv[0] = 0;
  Object call3112 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3111);
// compilenode returning call3112
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3113 = callmethod(call3112, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe3110);
// compilenode returning call3113
  *var_dt = call3113;
  if (call3113 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if3103 = done;
  } else {
  }
// compilenode returning if3103
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3115 = gc_frame_new();
// compilenode returning *var_name_39_
  gc_frame_newslot(*var_name_39_);
  int callframe3116 = gc_frame_new();
  partcv[0] = 0;
  Object call3117 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3116);
// compilenode returning call3117
  gc_frame_newslot(call3117);
  int callframe3118 = gc_frame_new();
  int callframe3119 = gc_frame_new();
  partcv[0] = 0;
  Object call3120 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3119);
// compilenode returning call3120
  gc_frame_newslot(call3120);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe3121 = gc_frame_new();
  int callframe3122 = gc_frame_new();
  Object call3123 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3122);
// compilenode returning call3123
// compilenode returning call3123
  partcv[0] = 0;
  Object call3124 = callmethodflags(call3123, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3121);
// compilenode returning call3124
// compilenode returning call3124
  params[0] = call3120;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3125 = callmethodflags(call3124, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3118);
// compilenode returning call3125
  gc_frame_newslot(call3125);
// compilenode returning *var_dt
  gc_frame_newslot(*var_dt);
// compilenode returning *var_methodNode
  params[0] = *var_name_39_;
  params[1] = call3117;
  params[2] = call3125;
  params[3] = *var_dt;
  partcv[0] = 4;
  Object call3126 = callmethod(*var_methodNode, "new",
    1, partcv, params);
  gc_frame_end(callframe3115);
// compilenode returning call3126
  *var_n = call3126;
  if (call3126 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 690
  setline(690);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3127 = gc_frame_new();
  int callframe3128 = gc_frame_new();
  int callframe3129 = gc_frame_new();
  partcv[0] = 0;
  Object call3130 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3129);
// compilenode returning call3130
  gc_frame_newslot(call3130);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe3131 = gc_frame_new();
  int callframe3132 = gc_frame_new();
  Object call3133 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3132);
// compilenode returning call3133
// compilenode returning call3133
  partcv[0] = 0;
  Object call3134 = callmethodflags(call3133, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3131);
// compilenode returning call3134
// compilenode returning call3134
  params[0] = call3130;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3135 = callmethodflags(call3134, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3128);
// compilenode returning call3135
  gc_frame_newslot(call3135);
  Object block3136 = alloc_Block(NULL, NULL, "ast", 690);
  gc_frame_newslot(block3136);
  block_savedest(block3136);
  Object closure3137 = createclosure(5, "_apply");
setclosureframe(closure3137, stackframe);
  addtoclosure(closure3137, var_blk);
  addtoclosure(closure3137, var_blkBefore);
  addtoclosure(closure3137, var_blkAfter);
  addtoclosure(closure3137, var_n);
  addtoclosure(closure3137, selfslot);
  struct UserObject *uo3137 = (struct UserObject*)block3136;
  uo3137->data[0] = (Object)closure3137;
  Method *meth_meth_ast__apply3137 = addmethod2pos(block3136, "_apply", &meth_ast__apply3137, 0);
int argcv_meth_ast__apply3137[] = {1};
meth_meth_ast__apply3137->type = alloc_MethodType(1, argcv_meth_ast__apply3137);
  meth_meth_ast__apply3137->definitionModule = modulename;
  meth_meth_ast__apply3137->definitionLine = 690;
// compilenode returning block3136
  gc_frame_newslot(block3136);
  params[0] = call3135;
  params[1] = block3136;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3145 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3127);
// compilenode returning call3145
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3146 = gc_frame_new();
  int callframe3147 = gc_frame_new();
  int callframe3148 = gc_frame_new();
  partcv[0] = 0;
  Object call3149 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3148);
// compilenode returning call3149
  gc_frame_newslot(call3149);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe3150 = gc_frame_new();
  int callframe3151 = gc_frame_new();
  Object call3152 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3151);
// compilenode returning call3152
// compilenode returning call3152
  partcv[0] = 0;
  Object call3153 = callmethodflags(call3152, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3150);
// compilenode returning call3153
// compilenode returning call3153
  params[0] = call3149;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3154 = callmethodflags(call3153, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3147);
// compilenode returning call3154
  gc_frame_newslot(call3154);
  Object block3155 = alloc_Block(NULL, NULL, "ast", 693);
  gc_frame_newslot(block3155);
  block_savedest(block3155);
  Object closure3156 = createclosure(5, "_apply");
setclosureframe(closure3156, stackframe);
  addtoclosure(closure3156, var_blk);
  addtoclosure(closure3156, var_blkBefore);
  addtoclosure(closure3156, var_blkAfter);
  addtoclosure(closure3156, var_n);
  addtoclosure(closure3156, selfslot);
  struct UserObject *uo3156 = (struct UserObject*)block3155;
  uo3156->data[0] = (Object)closure3156;
  Method *meth_meth_ast__apply3156 = addmethod2pos(block3155, "_apply", &meth_ast__apply3156, 0);
int argcv_meth_ast__apply3156[] = {1};
meth_meth_ast__apply3156->type = alloc_MethodType(1, argcv_meth_ast__apply3156);
  meth_meth_ast__apply3156->definitionModule = modulename;
  meth_meth_ast__apply3156->definitionLine = 693;
// compilenode returning block3155
  gc_frame_newslot(block3155);
  params[0] = call3154;
  params[1] = block3155;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3164 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3146);
// compilenode returning call3164
// Begin line 696
  setline(696);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3165 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3166 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe3165);
// compilenode returning call3166
  *var_n = call3166;
  if (call3166 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 698
  setline(698);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3168 = gc_frame_new();
// Begin line 697
  setline(697);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3169 = gc_frame_new();
  partcv[0] = 0;
  Object call3170 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3169);
// compilenode returning call3170
  gc_frame_newslot(call3170);
// compilenode returning *var_n
  params[0] = call3170;
  partcv[0] = 1;
  Object call3171 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe3168);
// compilenode returning call3171
// compilenode returning done
// Begin line 698
  setline(698);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3172 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3173 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe3172);
// compilenode returning call3173
// Begin line 699
  setline(699);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply3177(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3180(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map3174(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 702
  setline(702);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3175 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block3176 = alloc_Block(NULL, NULL, "ast", 702);
  gc_frame_newslot(block3176);
  block_savedest(block3176);
  Object closure3177 = createclosure(1, "_apply");
setclosureframe(closure3177, stackframe);
  addtoclosure(closure3177, selfslot);
  struct UserObject *uo3177 = (struct UserObject*)block3176;
  uo3177->data[0] = (Object)closure3177;
  Method *meth_meth_ast__apply3177 = addmethod2pos(block3176, "_apply", &meth_ast__apply3177, 0);
int argcv_meth_ast__apply3177[] = {0};
meth_meth_ast__apply3177->type = alloc_MethodType(1, argcv_meth_ast__apply3177);
  meth_meth_ast__apply3177->definitionModule = modulename;
  meth_meth_ast__apply3177->definitionLine = 694;
// compilenode returning block3176
  gc_frame_newslot(block3176);
  Object block3179 = alloc_Block(NULL, NULL, "ast", 702);
  gc_frame_newslot(block3179);
  block_savedest(block3179);
  Object closure3180 = createclosure(1, "_apply");
setclosureframe(closure3180, stackframe);
  addtoclosure(closure3180, selfslot);
  struct UserObject *uo3180 = (struct UserObject*)block3179;
  uo3180->data[0] = (Object)closure3180;
  Method *meth_meth_ast__apply3180 = addmethod2pos(block3179, "_apply", &meth_ast__apply3180, 0);
int argcv_meth_ast__apply3180[] = {0};
meth_meth_ast__apply3180->type = alloc_MethodType(1, argcv_meth_ast__apply3180);
  meth_meth_ast__apply3180->definitionModule = modulename;
  meth_meth_ast__apply3180->definitionLine = 694;
// compilenode returning block3179
  gc_frame_newslot(block3179);
  params[0] = *var_blk;
  params[1] = block3176;
  params[2] = block3179;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3182 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3175);
// compilenode returning call3182
  gc_frame_end(frame);
  return call3182;
}
Object meth_ast__apply3193(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_blk = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3194 = gc_frame_new();
// compilenode returning *var_p
  gc_frame_newslot(*var_p);
// compilenode returning *var_blk
  params[0] = *var_p;
  partcv[0] = 1;
  Object call3195 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe3194);
// compilenode returning call3195
  gc_frame_end(frame);
  return call3195;
}
Object meth_ast__apply3188(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_blk = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 706
  setline(706);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3189 = gc_frame_new();
  int callframe3190 = gc_frame_new();
// compilenode returning *var_s
  partcv[0] = 0;
  Object call3191 = callmethod(*var_s, "params",
    1, partcv, params);
  gc_frame_end(callframe3190);
// compilenode returning call3191
// compilenode returning call3191
  gc_frame_newslot(call3191);
  Object block3192 = alloc_Block(NULL, NULL, "ast", 706);
  gc_frame_newslot(block3192);
  block_savedest(block3192);
  Object closure3193 = createclosure(2, "_apply");
setclosureframe(closure3193, stackframe);
  addtoclosure(closure3193, var_blk);
  addtoclosure(closure3193, selfslot);
  struct UserObject *uo3193 = (struct UserObject*)block3192;
  uo3193->data[0] = (Object)closure3193;
  Method *meth_meth_ast__apply3193 = addmethod2pos(block3192, "_apply", &meth_ast__apply3193, 0);
int argcv_meth_ast__apply3193[] = {1};
meth_meth_ast__apply3193->type = alloc_MethodType(1, argcv_meth_ast__apply3193);
  meth_meth_ast__apply3193->definitionModule = modulename;
  meth_meth_ast__apply3193->definitionLine = 706;
// compilenode returning block3192
  gc_frame_newslot(block3192);
  params[0] = call3191;
  params[1] = block3192;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3197 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3189);
// compilenode returning call3197
  gc_frame_end(frame);
  return call3197;
}
Object meth_ast_eachParameter3183(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "eachParameter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for eachParameter (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for eachParameter");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 705
  setline(705);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3184 = gc_frame_new();
  int callframe3185 = gc_frame_new();
  partcv[0] = 0;
  Object call3186 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3185);
// compilenode returning call3186
  gc_frame_newslot(call3186);
  Object block3187 = alloc_Block(NULL, NULL, "ast", 705);
  gc_frame_newslot(block3187);
  block_savedest(block3187);
  Object closure3188 = createclosure(2, "_apply");
setclosureframe(closure3188, stackframe);
  addtoclosure(closure3188, var_blk);
  addtoclosure(closure3188, selfslot);
  struct UserObject *uo3188 = (struct UserObject*)block3187;
  uo3188->data[0] = (Object)closure3188;
  Method *meth_meth_ast__apply3188 = addmethod2pos(block3187, "_apply", &meth_ast__apply3188, 0);
int argcv_meth_ast__apply3188[] = {1};
meth_meth_ast__apply3188->type = alloc_MethodType(1, argcv_meth_ast__apply3188);
  meth_meth_ast__apply3188->definitionModule = modulename;
  meth_meth_ast__apply3188->definitionLine = 694;
// compilenode returning block3187
  gc_frame_newslot(block3187);
  params[0] = call3186;
  params[1] = block3187;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3199 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3184);
// compilenode returning call3199
  gc_frame_end(frame);
  return call3199;
}
Object meth_ast__apply3208(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 715
  setline(715);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 714
  setline(714);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3210 == NULL) {
    strlit3210 = alloc_String("  ");
    gc_root(strlit3210);
  }
// compilenode returning strlit3210
  int op_slot_right_3209 = gc_frame_newslot(strlit3210);
// compilenode returning *var_spc
  int op_slot_left_3209 = gc_frame_newslot(*var_spc);
  params[0] = strlit3210;
  partcv[0] = 1;
  Object opresult3212 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult3212
  *var_spc = opresult3212;
  if (opresult3212 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3345(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 729
  setline(729);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3347 == NULL) {
    strlit3347 = alloc_String("");
    gc_root(strlit3347);
  }
// compilenode returning strlit3347
  int op_slot_right_3346 = gc_frame_newslot(strlit3347);
  int callframe3350 = gc_frame_new();
  Object num3352 = alloc_Float64(4);
// compilenode returning num3352
  int op_slot_right_3351 = gc_frame_newslot(num3352);
// compilenode returning *var_depth
  int op_slot_left_3351 = gc_frame_newslot(*var_depth);
  params[0] = num3352;
  partcv[0] = 1;
  Object sum3354 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum3354
  gc_frame_newslot(sum3354);
// compilenode returning *var_p
  params[0] = sum3354;
  partcv[0] = 1;
  Object call3355 = callmethod(*var_p, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3350);
// compilenode returning call3355
  int op_slot_right_3349 = gc_frame_newslot(call3355);
  if (strlit3358 == NULL) {
    strlit3358 = alloc_String("");
    gc_root(strlit3358);
  }
// compilenode returning strlit3358
  int op_slot_right_3357 = gc_frame_newslot(strlit3358);
// compilenode returning *var_spc
  int op_slot_right_3360 = gc_frame_newslot(*var_spc);
  if (strlit3363 == NULL) {
    strlit3363 = alloc_String("""\x0a""      ");
    gc_root(strlit3363);
  }
// compilenode returning strlit3363
  int op_slot_right_3362 = gc_frame_newslot(strlit3363);
// compilenode returning *var_s
  int op_slot_right_3365 = gc_frame_newslot(*var_s);
  if (strlit3367 == NULL) {
    strlit3367 = alloc_String("");
    gc_root(strlit3367);
  }
// compilenode returning strlit3367
  int op_slot_left_3365 = gc_frame_newslot(strlit3367);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3368 = callmethod(strlit3367, "++", 1, partcv, params);
// compilenode returning opresult3368
  int op_slot_left_3362 = gc_frame_newslot(opresult3368);
  params[0] = strlit3363;
  partcv[0] = 1;
  Object opresult3369 = callmethod(opresult3368, "++", 1, partcv, params);
// compilenode returning opresult3369
  int op_slot_left_3360 = gc_frame_newslot(opresult3369);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3370 = callmethod(opresult3369, "++", 1, partcv, params);
// compilenode returning opresult3370
  int op_slot_left_3357 = gc_frame_newslot(opresult3370);
  params[0] = strlit3358;
  partcv[0] = 1;
  Object opresult3371 = callmethod(opresult3370, "++", 1, partcv, params);
// compilenode returning opresult3371
  int op_slot_left_3349 = gc_frame_newslot(opresult3371);
  params[0] = call3355;
  partcv[0] = 1;
  Object opresult3372 = callmethod(opresult3371, "++", 1, partcv, params);
// compilenode returning opresult3372
  int op_slot_left_3346 = gc_frame_newslot(opresult3372);
  params[0] = strlit3347;
  partcv[0] = 1;
  Object opresult3373 = callmethod(opresult3372, "++", 1, partcv, params);
// compilenode returning opresult3373
  *var_s = opresult3373;
  if (opresult3373 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3299(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 725
  setline(725);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3301 == NULL) {
    strlit3301 = alloc_String("");
    gc_root(strlit3301);
  }
// compilenode returning strlit3301
  int op_slot_right_3300 = gc_frame_newslot(strlit3301);
  int callframe3304 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3305 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe3304);
// compilenode returning call3305
// compilenode returning call3305
  int op_slot_right_3303 = gc_frame_newslot(call3305);
  if (strlit3308 == NULL) {
    strlit3308 = alloc_String("Part: ");
    gc_root(strlit3308);
  }
// compilenode returning strlit3308
  int op_slot_right_3307 = gc_frame_newslot(strlit3308);
// compilenode returning *var_spc
  int op_slot_right_3310 = gc_frame_newslot(*var_spc);
  if (strlit3313 == NULL) {
    strlit3313 = alloc_String("""\x0a""  ");
    gc_root(strlit3313);
  }
// compilenode returning strlit3313
  int op_slot_right_3312 = gc_frame_newslot(strlit3313);
// compilenode returning *var_s
  int op_slot_right_3315 = gc_frame_newslot(*var_s);
  if (strlit3317 == NULL) {
    strlit3317 = alloc_String("");
    gc_root(strlit3317);
  }
// compilenode returning strlit3317
  int op_slot_left_3315 = gc_frame_newslot(strlit3317);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3318 = callmethod(strlit3317, "++", 1, partcv, params);
// compilenode returning opresult3318
  int op_slot_left_3312 = gc_frame_newslot(opresult3318);
  params[0] = strlit3313;
  partcv[0] = 1;
  Object opresult3319 = callmethod(opresult3318, "++", 1, partcv, params);
// compilenode returning opresult3319
  int op_slot_left_3310 = gc_frame_newslot(opresult3319);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3320 = callmethod(opresult3319, "++", 1, partcv, params);
// compilenode returning opresult3320
  int op_slot_left_3307 = gc_frame_newslot(opresult3320);
  params[0] = strlit3308;
  partcv[0] = 1;
  Object opresult3321 = callmethod(opresult3320, "++", 1, partcv, params);
// compilenode returning opresult3321
  int op_slot_left_3303 = gc_frame_newslot(opresult3321);
  params[0] = call3305;
  partcv[0] = 1;
  Object opresult3322 = callmethod(opresult3321, "++", 1, partcv, params);
// compilenode returning opresult3322
  int op_slot_left_3300 = gc_frame_newslot(opresult3322);
  params[0] = strlit3301;
  partcv[0] = 1;
  Object opresult3323 = callmethod(opresult3322, "++", 1, partcv, params);
// compilenode returning opresult3323
  *var_s = opresult3323;
  if (opresult3323 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 727
  setline(727);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3326 == NULL) {
    strlit3326 = alloc_String("Parameters:");
    gc_root(strlit3326);
  }
// compilenode returning strlit3326
  int op_slot_right_3325 = gc_frame_newslot(strlit3326);
// compilenode returning *var_spc
  int op_slot_right_3328 = gc_frame_newslot(*var_spc);
  if (strlit3331 == NULL) {
    strlit3331 = alloc_String("""\x0a""    ");
    gc_root(strlit3331);
  }
// compilenode returning strlit3331
  int op_slot_right_3330 = gc_frame_newslot(strlit3331);
// compilenode returning *var_s
  int op_slot_right_3333 = gc_frame_newslot(*var_s);
  if (strlit3335 == NULL) {
    strlit3335 = alloc_String("");
    gc_root(strlit3335);
  }
// compilenode returning strlit3335
  int op_slot_left_3333 = gc_frame_newslot(strlit3335);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3336 = callmethod(strlit3335, "++", 1, partcv, params);
// compilenode returning opresult3336
  int op_slot_left_3330 = gc_frame_newslot(opresult3336);
  params[0] = strlit3331;
  partcv[0] = 1;
  Object opresult3337 = callmethod(opresult3336, "++", 1, partcv, params);
// compilenode returning opresult3337
  int op_slot_left_3328 = gc_frame_newslot(opresult3337);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3338 = callmethod(opresult3337, "++", 1, partcv, params);
// compilenode returning opresult3338
  int op_slot_left_3325 = gc_frame_newslot(opresult3338);
  params[0] = strlit3326;
  partcv[0] = 1;
  Object opresult3339 = callmethod(opresult3338, "++", 1, partcv, params);
// compilenode returning opresult3339
  *var_s = opresult3339;
  if (opresult3339 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 727
  setline(727);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3341 = gc_frame_new();
  int callframe3342 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3343 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe3342);
// compilenode returning call3343
// compilenode returning call3343
  gc_frame_newslot(call3343);
  Object block3344 = alloc_Block(NULL, NULL, "ast", 727);
  gc_frame_newslot(block3344);
  block_savedest(block3344);
  Object closure3345 = createclosure(4, "_apply");
setclosureframe(closure3345, stackframe);
  addtoclosure(closure3345, var_depth);
  addtoclosure(closure3345, var_spc);
  addtoclosure(closure3345, var_s);
  addtoclosure(closure3345, selfslot);
  struct UserObject *uo3345 = (struct UserObject*)block3344;
  uo3345->data[0] = (Object)closure3345;
  Method *meth_meth_ast__apply3345 = addmethod2pos(block3344, "_apply", &meth_ast__apply3345, 0);
int argcv_meth_ast__apply3345[] = {1};
meth_meth_ast__apply3345->type = alloc_MethodType(1, argcv_meth_ast__apply3345);
  meth_meth_ast__apply3345->definitionModule = modulename;
  meth_meth_ast__apply3345->definitionLine = 727;
// compilenode returning block3344
  gc_frame_newslot(block3344);
  params[0] = call3343;
  params[1] = block3344;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3376 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3341);
// compilenode returning call3376
// Begin line 733
  setline(733);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 730
  setline(730);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3379 = alloc_Boolean(0);
// compilenode returning bool3379
  int op_slot_right_3378 = gc_frame_newslot(bool3379);
  int callframe3381 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3382 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3381);
// compilenode returning call3382
// compilenode returning call3382
  int op_slot_left_3378 = gc_frame_newslot(call3382);
  params[0] = bool3379;
  partcv[0] = 1;
  Object opresult3383 = callmethod(call3382, "!=", 1, partcv, params);
// compilenode returning opresult3383
  Object if3377 = done;
  if (istrue(opresult3383)) {
// Begin line 732
  setline(732);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 731
  setline(731);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3385 == NULL) {
    strlit3385 = alloc_String("");
    gc_root(strlit3385);
  }
// compilenode returning strlit3385
  int op_slot_right_3384 = gc_frame_newslot(strlit3385);
  int callframe3388 = gc_frame_new();
  Object num3390 = alloc_Float64(3);
// compilenode returning num3390
  int op_slot_right_3389 = gc_frame_newslot(num3390);
// compilenode returning *var_depth
  int op_slot_left_3389 = gc_frame_newslot(*var_depth);
  params[0] = num3390;
  partcv[0] = 1;
  Object sum3392 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum3392
  gc_frame_newslot(sum3392);
  int callframe3393 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3394 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3393);
// compilenode returning call3394
// compilenode returning call3394
  params[0] = sum3392;
  partcv[0] = 1;
  Object call3395 = callmethod(call3394, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3388);
// compilenode returning call3395
  int op_slot_right_3387 = gc_frame_newslot(call3395);
  if (strlit3398 == NULL) {
    strlit3398 = alloc_String("Vararg: ");
    gc_root(strlit3398);
  }
// compilenode returning strlit3398
  int op_slot_right_3397 = gc_frame_newslot(strlit3398);
// compilenode returning *var_spc
  int op_slot_right_3400 = gc_frame_newslot(*var_spc);
  if (strlit3403 == NULL) {
    strlit3403 = alloc_String("""\x0a""    ");
    gc_root(strlit3403);
  }
// compilenode returning strlit3403
  int op_slot_right_3402 = gc_frame_newslot(strlit3403);
// compilenode returning *var_s
  int op_slot_right_3405 = gc_frame_newslot(*var_s);
  if (strlit3407 == NULL) {
    strlit3407 = alloc_String("");
    gc_root(strlit3407);
  }
// compilenode returning strlit3407
  int op_slot_left_3405 = gc_frame_newslot(strlit3407);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3408 = callmethod(strlit3407, "++", 1, partcv, params);
// compilenode returning opresult3408
  int op_slot_left_3402 = gc_frame_newslot(opresult3408);
  params[0] = strlit3403;
  partcv[0] = 1;
  Object opresult3409 = callmethod(opresult3408, "++", 1, partcv, params);
// compilenode returning opresult3409
  int op_slot_left_3400 = gc_frame_newslot(opresult3409);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3410 = callmethod(opresult3409, "++", 1, partcv, params);
// compilenode returning opresult3410
  int op_slot_left_3397 = gc_frame_newslot(opresult3410);
  params[0] = strlit3398;
  partcv[0] = 1;
  Object opresult3411 = callmethod(opresult3410, "++", 1, partcv, params);
// compilenode returning opresult3411
  int op_slot_left_3387 = gc_frame_newslot(opresult3411);
  params[0] = call3395;
  partcv[0] = 1;
  Object opresult3412 = callmethod(opresult3411, "++", 1, partcv, params);
// compilenode returning opresult3412
  int op_slot_left_3384 = gc_frame_newslot(opresult3412);
  params[0] = strlit3385;
  partcv[0] = 1;
  Object opresult3413 = callmethod(opresult3412, "++", 1, partcv, params);
// compilenode returning opresult3413
  *var_s = opresult3413;
  if (opresult3413 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if3377 = done;
  } else {
  }
// compilenode returning if3377
  gc_frame_end(frame);
  return if3377;
}
Object meth_ast__apply3449(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 739
  setline(739);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 738
  setline(738);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3451 == NULL) {
    strlit3451 = alloc_String("");
    gc_root(strlit3451);
  }
// compilenode returning strlit3451
  int op_slot_right_3450 = gc_frame_newslot(strlit3451);
  int callframe3454 = gc_frame_new();
  Object num3455 = alloc_Float64(0);
// compilenode returning num3455
  gc_frame_newslot(num3455);
// compilenode returning *var_g
  params[0] = num3455;
  partcv[0] = 1;
  Object call3456 = callmethod(*var_g, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3454);
// compilenode returning call3456
  int op_slot_right_3453 = gc_frame_newslot(call3456);
  if (strlit3459 == NULL) {
    strlit3459 = alloc_String("  ");
    gc_root(strlit3459);
  }
// compilenode returning strlit3459
  int op_slot_right_3458 = gc_frame_newslot(strlit3459);
// compilenode returning *var_spc
  int op_slot_right_3461 = gc_frame_newslot(*var_spc);
  if (strlit3464 == NULL) {
    strlit3464 = alloc_String("""\x0a""");
    gc_root(strlit3464);
  }
// compilenode returning strlit3464
  int op_slot_right_3463 = gc_frame_newslot(strlit3464);
// compilenode returning *var_s
  int op_slot_right_3466 = gc_frame_newslot(*var_s);
  if (strlit3468 == NULL) {
    strlit3468 = alloc_String("");
    gc_root(strlit3468);
  }
// compilenode returning strlit3468
  int op_slot_left_3466 = gc_frame_newslot(strlit3468);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3469 = callmethod(strlit3468, "++", 1, partcv, params);
// compilenode returning opresult3469
  int op_slot_left_3463 = gc_frame_newslot(opresult3469);
  params[0] = strlit3464;
  partcv[0] = 1;
  Object opresult3470 = callmethod(opresult3469, "++", 1, partcv, params);
// compilenode returning opresult3470
  int op_slot_left_3461 = gc_frame_newslot(opresult3470);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3471 = callmethod(opresult3470, "++", 1, partcv, params);
// compilenode returning opresult3471
  int op_slot_left_3458 = gc_frame_newslot(opresult3471);
  params[0] = strlit3459;
  partcv[0] = 1;
  Object opresult3472 = callmethod(opresult3471, "++", 1, partcv, params);
// compilenode returning opresult3472
  int op_slot_left_3453 = gc_frame_newslot(opresult3472);
  params[0] = call3456;
  partcv[0] = 1;
  Object opresult3473 = callmethod(opresult3472, "++", 1, partcv, params);
// compilenode returning opresult3473
  int op_slot_left_3450 = gc_frame_newslot(opresult3473);
  params[0] = strlit3451;
  partcv[0] = 1;
  Object opresult3474 = callmethod(opresult3473, "++", 1, partcv, params);
// compilenode returning opresult3474
  *var_s = opresult3474;
  if (opresult3474 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3512(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_an = &(stackframe->slots[0]);
  *var_an = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 746
  setline(746);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 745
  setline(745);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3514 == NULL) {
    strlit3514 = alloc_String("");
    gc_root(strlit3514);
  }
// compilenode returning strlit3514
  int op_slot_right_3513 = gc_frame_newslot(strlit3514);
  int callframe3517 = gc_frame_new();
  Object num3519 = alloc_Float64(2);
// compilenode returning num3519
  int op_slot_right_3518 = gc_frame_newslot(num3519);
// compilenode returning *var_depth
  int op_slot_left_3518 = gc_frame_newslot(*var_depth);
  params[0] = num3519;
  partcv[0] = 1;
  Object sum3521 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum3521
  gc_frame_newslot(sum3521);
// compilenode returning *var_an
  params[0] = sum3521;
  partcv[0] = 1;
  Object call3522 = callmethod(*var_an, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3517);
// compilenode returning call3522
  int op_slot_right_3516 = gc_frame_newslot(call3522);
  if (strlit3525 == NULL) {
    strlit3525 = alloc_String("  ");
    gc_root(strlit3525);
  }
// compilenode returning strlit3525
  int op_slot_right_3524 = gc_frame_newslot(strlit3525);
// compilenode returning *var_spc
  int op_slot_right_3527 = gc_frame_newslot(*var_spc);
  if (strlit3530 == NULL) {
    strlit3530 = alloc_String("""\x0a""");
    gc_root(strlit3530);
  }
// compilenode returning strlit3530
  int op_slot_right_3529 = gc_frame_newslot(strlit3530);
// compilenode returning *var_s
  int op_slot_right_3532 = gc_frame_newslot(*var_s);
  if (strlit3534 == NULL) {
    strlit3534 = alloc_String("");
    gc_root(strlit3534);
  }
// compilenode returning strlit3534
  int op_slot_left_3532 = gc_frame_newslot(strlit3534);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3535 = callmethod(strlit3534, "++", 1, partcv, params);
// compilenode returning opresult3535
  int op_slot_left_3529 = gc_frame_newslot(opresult3535);
  params[0] = strlit3530;
  partcv[0] = 1;
  Object opresult3536 = callmethod(opresult3535, "++", 1, partcv, params);
// compilenode returning opresult3536
  int op_slot_left_3527 = gc_frame_newslot(opresult3536);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3537 = callmethod(opresult3536, "++", 1, partcv, params);
// compilenode returning opresult3537
  int op_slot_left_3524 = gc_frame_newslot(opresult3537);
  params[0] = strlit3525;
  partcv[0] = 1;
  Object opresult3538 = callmethod(opresult3537, "++", 1, partcv, params);
// compilenode returning opresult3538
  int op_slot_left_3516 = gc_frame_newslot(opresult3538);
  params[0] = call3522;
  partcv[0] = 1;
  Object opresult3539 = callmethod(opresult3538, "++", 1, partcv, params);
// compilenode returning opresult3539
  int op_slot_left_3513 = gc_frame_newslot(opresult3539);
  params[0] = strlit3514;
  partcv[0] = 1;
  Object opresult3540 = callmethod(opresult3539, "++", 1, partcv, params);
// compilenode returning opresult3540
  *var_s = opresult3540;
  if (opresult3540 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3561(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 751
  setline(751);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3563 = gc_frame_new();
  Object num3565 = alloc_Float64(2);
// compilenode returning num3565
  int op_slot_right_3564 = gc_frame_newslot(num3565);
// compilenode returning *var_depth
  int op_slot_left_3564 = gc_frame_newslot(*var_depth);
  params[0] = num3565;
  partcv[0] = 1;
  Object sum3567 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum3567
  gc_frame_newslot(sum3567);
// compilenode returning *var_mx
  params[0] = sum3567;
  partcv[0] = 1;
  Object call3568 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3563);
// compilenode returning call3568
  int op_slot_right_3562 = gc_frame_newslot(call3568);
// compilenode returning *var_spc
  int op_slot_right_3570 = gc_frame_newslot(*var_spc);
  if (strlit3573 == NULL) {
    strlit3573 = alloc_String("""\x0a""  ");
    gc_root(strlit3573);
  }
// compilenode returning strlit3573
  int op_slot_right_3572 = gc_frame_newslot(strlit3573);
// compilenode returning *var_s
  int op_slot_left_3572 = gc_frame_newslot(*var_s);
  params[0] = strlit3573;
  partcv[0] = 1;
  Object opresult3575 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3575
  int op_slot_left_3570 = gc_frame_newslot(opresult3575);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3576 = callmethod(opresult3575, "++", 1, partcv, params);
// compilenode returning opresult3576
  int op_slot_left_3562 = gc_frame_newslot(opresult3576);
  params[0] = call3568;
  partcv[0] = 1;
  Object opresult3577 = callmethod(opresult3576, "++", 1, partcv, params);
// compilenode returning opresult3577
  *var_s = opresult3577;
  if (opresult3577 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty3200(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 713
  setline(713);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 712
  setline(712);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3201 == NULL) {
    strlit3201 = alloc_String("");
    gc_root(strlit3201);
  }
// compilenode returning strlit3201
  *var_spc = strlit3201;
  if (strlit3201 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 713
  setline(713);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3202 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_3203 = gc_frame_newslot(*var_depth);
  Object num3205 = alloc_Float64(0);
// compilenode returning num3205
  int op_slot_left_3203 = gc_frame_newslot(num3205);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult3206 = callmethod(num3205, "..", 1, partcv, params);
// compilenode returning opresult3206
  gc_frame_newslot(opresult3206);
  Object block3207 = alloc_Block(NULL, NULL, "ast", 713);
  gc_frame_newslot(block3207);
  block_savedest(block3207);
  Object closure3208 = createclosure(2, "_apply");
setclosureframe(closure3208, stackframe);
  addtoclosure(closure3208, var_spc);
  addtoclosure(closure3208, selfslot);
  struct UserObject *uo3208 = (struct UserObject*)block3207;
  uo3208->data[0] = (Object)closure3208;
  Method *meth_meth_ast__apply3208 = addmethod2pos(block3207, "_apply", &meth_ast__apply3208, 0);
int argcv_meth_ast__apply3208[] = {1};
meth_meth_ast__apply3208->type = alloc_MethodType(1, argcv_meth_ast__apply3208);
  meth_meth_ast__apply3208->definitionModule = modulename;
  meth_meth_ast__apply3208->definitionLine = 706;
// compilenode returning block3207
  gc_frame_newslot(block3207);
  params[0] = opresult3206;
  params[1] = block3207;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3215 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3202);
// compilenode returning call3215
// Begin line 717
  setline(717);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 716
  setline(716);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3216 == NULL) {
    strlit3216 = alloc_String("Method""\x0a""");
    gc_root(strlit3216);
  }
// compilenode returning strlit3216
  *var_s = strlit3216;
  if (strlit3216 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 717
  setline(717);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3218 = gc_frame_new();
  Object num3220 = alloc_Float64(1);
// compilenode returning num3220
  int op_slot_right_3219 = gc_frame_newslot(num3220);
// compilenode returning *var_depth
  int op_slot_left_3219 = gc_frame_newslot(*var_depth);
  params[0] = num3220;
  partcv[0] = 1;
  Object sum3222 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum3222
  gc_frame_newslot(sum3222);
  int callframe3223 = gc_frame_new();
  partcv[0] = 0;
  Object call3224 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3223);
// compilenode returning call3224
// compilenode returning call3224
  params[0] = sum3222;
  partcv[0] = 1;
  Object call3225 = callmethod(call3224, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3218);
// compilenode returning call3225
  int op_slot_right_3217 = gc_frame_newslot(call3225);
  if (strlit3228 == NULL) {
    strlit3228 = alloc_String("Name: ");
    gc_root(strlit3228);
  }
// compilenode returning strlit3228
  int op_slot_right_3227 = gc_frame_newslot(strlit3228);
// compilenode returning *var_spc
  int op_slot_right_3230 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_3230 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3232 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3232
  int op_slot_left_3227 = gc_frame_newslot(opresult3232);
  params[0] = strlit3228;
  partcv[0] = 1;
  Object opresult3233 = callmethod(opresult3232, "++", 1, partcv, params);
// compilenode returning opresult3233
  int op_slot_left_3217 = gc_frame_newslot(opresult3233);
  params[0] = call3225;
  partcv[0] = 1;
  Object opresult3234 = callmethod(opresult3233, "++", 1, partcv, params);
// compilenode returning opresult3234
  *var_s = opresult3234;
  if (opresult3234 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 719
  setline(719);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 718
  setline(718);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3237 == NULL) {
    strlit3237 = alloc_String("""\x0a""");
    gc_root(strlit3237);
  }
// compilenode returning strlit3237
  int op_slot_right_3236 = gc_frame_newslot(strlit3237);
// compilenode returning *var_s
  int op_slot_left_3236 = gc_frame_newslot(*var_s);
  params[0] = strlit3237;
  partcv[0] = 1;
  Object opresult3239 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3239
  *var_s = opresult3239;
  if (opresult3239 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 719
  setline(719);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3243 = gc_frame_new();
  partcv[0] = 0;
  Object call3244 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3243);
// compilenode returning call3244
// compilenode returning call3244
  int op_slot_right_3242 = gc_frame_newslot(call3244);
  Object bool3246 = alloc_Boolean(0);
// compilenode returning bool3246
  int op_slot_left_3242 = gc_frame_newslot(bool3246);
  params[0] = call3244;
  partcv[0] = 1;
  Object opresult3247 = callmethod(bool3246, "!=", 1, partcv, params);
// compilenode returning opresult3247
  Object if3241 = done;
  if (istrue(opresult3247)) {
// Begin line 721
  setline(721);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 720
  setline(720);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3249 == NULL) {
    strlit3249 = alloc_String("  ");
    gc_root(strlit3249);
  }
// compilenode returning strlit3249
  int op_slot_right_3248 = gc_frame_newslot(strlit3249);
// compilenode returning *var_spc
  int op_slot_right_3251 = gc_frame_newslot(*var_spc);
  if (strlit3254 == NULL) {
    strlit3254 = alloc_String("Returns:""\x0a""");
    gc_root(strlit3254);
  }
// compilenode returning strlit3254
  int op_slot_right_3253 = gc_frame_newslot(strlit3254);
// compilenode returning *var_spc
  int op_slot_right_3256 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_3256 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3258 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3258
  int op_slot_left_3253 = gc_frame_newslot(opresult3258);
  params[0] = strlit3254;
  partcv[0] = 1;
  Object opresult3259 = callmethod(opresult3258, "++", 1, partcv, params);
// compilenode returning opresult3259
  int op_slot_left_3251 = gc_frame_newslot(opresult3259);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3260 = callmethod(opresult3259, "++", 1, partcv, params);
// compilenode returning opresult3260
  int op_slot_left_3248 = gc_frame_newslot(opresult3260);
  params[0] = strlit3249;
  partcv[0] = 1;
  Object opresult3261 = callmethod(opresult3260, "++", 1, partcv, params);
// compilenode returning opresult3261
  *var_s = opresult3261;
  if (opresult3261 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 722
  setline(722);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 721
  setline(721);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3264 == NULL) {
    strlit3264 = alloc_String("""\x0a""");
    gc_root(strlit3264);
  }
// compilenode returning strlit3264
  int op_slot_right_3263 = gc_frame_newslot(strlit3264);
  int callframe3267 = gc_frame_new();
  Object num3269 = alloc_Float64(2);
// compilenode returning num3269
  int op_slot_right_3268 = gc_frame_newslot(num3269);
// compilenode returning *var_depth
  int op_slot_left_3268 = gc_frame_newslot(*var_depth);
  params[0] = num3269;
  partcv[0] = 1;
  Object sum3271 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum3271
  gc_frame_newslot(sum3271);
  int callframe3272 = gc_frame_new();
  partcv[0] = 0;
  Object call3273 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3272);
// compilenode returning call3273
// compilenode returning call3273
  params[0] = sum3271;
  partcv[0] = 1;
  Object call3274 = callmethod(call3273, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3267);
// compilenode returning call3274
  int op_slot_right_3266 = gc_frame_newslot(call3274);
// compilenode returning *var_s
  int op_slot_left_3266 = gc_frame_newslot(*var_s);
  params[0] = call3274;
  partcv[0] = 1;
  Object opresult3276 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3276
  int op_slot_left_3263 = gc_frame_newslot(opresult3276);
  params[0] = strlit3264;
  partcv[0] = 1;
  Object opresult3277 = callmethod(opresult3276, "++", 1, partcv, params);
// compilenode returning opresult3277
  *var_s = opresult3277;
  if (opresult3277 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if3241 = done;
  } else {
  }
// compilenode returning if3241
// Begin line 724
  setline(724);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3280 == NULL) {
    strlit3280 = alloc_String("Signature:");
    gc_root(strlit3280);
  }
// compilenode returning strlit3280
  int op_slot_right_3279 = gc_frame_newslot(strlit3280);
// compilenode returning *var_spc
  int op_slot_right_3282 = gc_frame_newslot(*var_spc);
  if (strlit3285 == NULL) {
    strlit3285 = alloc_String("");
    gc_root(strlit3285);
  }
// compilenode returning strlit3285
  int op_slot_right_3284 = gc_frame_newslot(strlit3285);
// compilenode returning *var_s
  int op_slot_right_3287 = gc_frame_newslot(*var_s);
  if (strlit3289 == NULL) {
    strlit3289 = alloc_String("");
    gc_root(strlit3289);
  }
// compilenode returning strlit3289
  int op_slot_left_3287 = gc_frame_newslot(strlit3289);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3290 = callmethod(strlit3289, "++", 1, partcv, params);
// compilenode returning opresult3290
  int op_slot_left_3284 = gc_frame_newslot(opresult3290);
  params[0] = strlit3285;
  partcv[0] = 1;
  Object opresult3291 = callmethod(opresult3290, "++", 1, partcv, params);
// compilenode returning opresult3291
  int op_slot_left_3282 = gc_frame_newslot(opresult3291);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3292 = callmethod(opresult3291, "++", 1, partcv, params);
// compilenode returning opresult3292
  int op_slot_left_3279 = gc_frame_newslot(opresult3292);
  params[0] = strlit3280;
  partcv[0] = 1;
  Object opresult3293 = callmethod(opresult3292, "++", 1, partcv, params);
// compilenode returning opresult3293
  *var_s = opresult3293;
  if (opresult3293 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 724
  setline(724);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3295 = gc_frame_new();
  int callframe3296 = gc_frame_new();
  partcv[0] = 0;
  Object call3297 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3296);
// compilenode returning call3297
  gc_frame_newslot(call3297);
  Object block3298 = alloc_Block(NULL, NULL, "ast", 724);
  gc_frame_newslot(block3298);
  block_savedest(block3298);
  Object closure3299 = createclosure(4, "_apply");
setclosureframe(closure3299, stackframe);
  addtoclosure(closure3299, var_spc);
  addtoclosure(closure3299, var_s);
  addtoclosure(closure3299, var_depth);
  addtoclosure(closure3299, selfslot);
  struct UserObject *uo3299 = (struct UserObject*)block3298;
  uo3299->data[0] = (Object)closure3299;
  Method *meth_meth_ast__apply3299 = addmethod2pos(block3298, "_apply", &meth_ast__apply3299, 0);
int argcv_meth_ast__apply3299[] = {1};
meth_meth_ast__apply3299->type = alloc_MethodType(1, argcv_meth_ast__apply3299);
  meth_meth_ast__apply3299->definitionModule = modulename;
  meth_meth_ast__apply3299->definitionLine = 721;
// compilenode returning block3298
  gc_frame_newslot(block3298);
  params[0] = call3297;
  params[1] = block3298;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3416 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3295);
// compilenode returning call3416
// Begin line 735
  setline(735);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 734
  setline(734);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3418 == NULL) {
    strlit3418 = alloc_String("""\x0a""");
    gc_root(strlit3418);
  }
// compilenode returning strlit3418
  int op_slot_right_3417 = gc_frame_newslot(strlit3418);
// compilenode returning *var_s
  int op_slot_left_3417 = gc_frame_newslot(*var_s);
  params[0] = strlit3418;
  partcv[0] = 1;
  Object opresult3420 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3420
  *var_s = opresult3420;
  if (opresult3420 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 742
  setline(742);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 735
  setline(735);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3424 = gc_frame_new();
  partcv[0] = 0;
  Object call3425 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3424);
// compilenode returning call3425
  int op_slot_right_3423 = gc_frame_newslot(call3425);
  Object bool3427 = alloc_Boolean(0);
// compilenode returning bool3427
  int op_slot_left_3423 = gc_frame_newslot(bool3427);
  params[0] = call3425;
  partcv[0] = 1;
  Object opresult3428 = callmethod(bool3427, "!=", 1, partcv, params);
// compilenode returning opresult3428
  Object if3422 = done;
  if (istrue(opresult3428)) {
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 736
  setline(736);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3430 == NULL) {
    strlit3430 = alloc_String("Generics:");
    gc_root(strlit3430);
  }
// compilenode returning strlit3430
  int op_slot_right_3429 = gc_frame_newslot(strlit3430);
// compilenode returning *var_spc
  int op_slot_right_3432 = gc_frame_newslot(*var_spc);
  if (strlit3435 == NULL) {
    strlit3435 = alloc_String("");
    gc_root(strlit3435);
  }
// compilenode returning strlit3435
  int op_slot_right_3434 = gc_frame_newslot(strlit3435);
// compilenode returning *var_s
  int op_slot_right_3437 = gc_frame_newslot(*var_s);
  if (strlit3439 == NULL) {
    strlit3439 = alloc_String("");
    gc_root(strlit3439);
  }
// compilenode returning strlit3439
  int op_slot_left_3437 = gc_frame_newslot(strlit3439);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3440 = callmethod(strlit3439, "++", 1, partcv, params);
// compilenode returning opresult3440
  int op_slot_left_3434 = gc_frame_newslot(opresult3440);
  params[0] = strlit3435;
  partcv[0] = 1;
  Object opresult3441 = callmethod(opresult3440, "++", 1, partcv, params);
// compilenode returning opresult3441
  int op_slot_left_3432 = gc_frame_newslot(opresult3441);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3442 = callmethod(opresult3441, "++", 1, partcv, params);
// compilenode returning opresult3442
  int op_slot_left_3429 = gc_frame_newslot(opresult3442);
  params[0] = strlit3430;
  partcv[0] = 1;
  Object opresult3443 = callmethod(opresult3442, "++", 1, partcv, params);
// compilenode returning opresult3443
  *var_s = opresult3443;
  if (opresult3443 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3445 = gc_frame_new();
  int callframe3446 = gc_frame_new();
  partcv[0] = 0;
  Object call3447 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3446);
// compilenode returning call3447
  gc_frame_newslot(call3447);
  Object block3448 = alloc_Block(NULL, NULL, "ast", 737);
  gc_frame_newslot(block3448);
  block_savedest(block3448);
  Object closure3449 = createclosure(3, "_apply");
setclosureframe(closure3449, stackframe);
  addtoclosure(closure3449, var_spc);
  addtoclosure(closure3449, var_s);
  addtoclosure(closure3449, selfslot);
  struct UserObject *uo3449 = (struct UserObject*)block3448;
  uo3449->data[0] = (Object)closure3449;
  Method *meth_meth_ast__apply3449 = addmethod2pos(block3448, "_apply", &meth_ast__apply3449, 0);
int argcv_meth_ast__apply3449[] = {1};
meth_meth_ast__apply3449->type = alloc_MethodType(1, argcv_meth_ast__apply3449);
  meth_meth_ast__apply3449->definitionModule = modulename;
  meth_meth_ast__apply3449->definitionLine = 731;
// compilenode returning block3448
  gc_frame_newslot(block3448);
  params[0] = call3447;
  params[1] = block3448;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3477 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3445);
// compilenode returning call3477
// Begin line 741
  setline(741);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 740
  setline(740);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3479 == NULL) {
    strlit3479 = alloc_String("""\x0a""");
    gc_root(strlit3479);
  }
// compilenode returning strlit3479
  int op_slot_right_3478 = gc_frame_newslot(strlit3479);
// compilenode returning *var_s
  int op_slot_left_3478 = gc_frame_newslot(*var_s);
  params[0] = strlit3479;
  partcv[0] = 1;
  Object opresult3481 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3481
  *var_s = opresult3481;
  if (opresult3481 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if3422 = done;
  } else {
  }
// compilenode returning if3422
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 742
  setline(742);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num3485 = alloc_Float64(0);
// compilenode returning num3485
  int op_slot_right_3484 = gc_frame_newslot(num3485);
  int callframe3487 = gc_frame_new();
  int callframe3488 = gc_frame_new();
  partcv[0] = 0;
  Object call3489 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3488);
// compilenode returning call3489
  partcv[0] = 0;
  Object call3490 = callmethod(call3489, "size",
    1, partcv, params);
  gc_frame_end(callframe3487);
// compilenode returning call3490
// compilenode returning call3490
  int op_slot_left_3484 = gc_frame_newslot(call3490);
  params[0] = num3485;
  partcv[0] = 1;
  Object opresult3491 = callmethod(call3490, ">", 1, partcv, params);
// compilenode returning opresult3491
  Object if3483 = done;
  if (istrue(opresult3491)) {
// Begin line 744
  setline(744);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 743
  setline(743);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3493 == NULL) {
    strlit3493 = alloc_String("Annotations:");
    gc_root(strlit3493);
  }
// compilenode returning strlit3493
  int op_slot_right_3492 = gc_frame_newslot(strlit3493);
// compilenode returning *var_spc
  int op_slot_right_3495 = gc_frame_newslot(*var_spc);
  if (strlit3498 == NULL) {
    strlit3498 = alloc_String("");
    gc_root(strlit3498);
  }
// compilenode returning strlit3498
  int op_slot_right_3497 = gc_frame_newslot(strlit3498);
// compilenode returning *var_s
  int op_slot_right_3500 = gc_frame_newslot(*var_s);
  if (strlit3502 == NULL) {
    strlit3502 = alloc_String("");
    gc_root(strlit3502);
  }
// compilenode returning strlit3502
  int op_slot_left_3500 = gc_frame_newslot(strlit3502);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3503 = callmethod(strlit3502, "++", 1, partcv, params);
// compilenode returning opresult3503
  int op_slot_left_3497 = gc_frame_newslot(opresult3503);
  params[0] = strlit3498;
  partcv[0] = 1;
  Object opresult3504 = callmethod(opresult3503, "++", 1, partcv, params);
// compilenode returning opresult3504
  int op_slot_left_3495 = gc_frame_newslot(opresult3504);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3505 = callmethod(opresult3504, "++", 1, partcv, params);
// compilenode returning opresult3505
  int op_slot_left_3492 = gc_frame_newslot(opresult3505);
  params[0] = strlit3493;
  partcv[0] = 1;
  Object opresult3506 = callmethod(opresult3505, "++", 1, partcv, params);
// compilenode returning opresult3506
  *var_s = opresult3506;
  if (opresult3506 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 744
  setline(744);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3508 = gc_frame_new();
  int callframe3509 = gc_frame_new();
  partcv[0] = 0;
  Object call3510 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3509);
// compilenode returning call3510
  gc_frame_newslot(call3510);
  Object block3511 = alloc_Block(NULL, NULL, "ast", 744);
  gc_frame_newslot(block3511);
  block_savedest(block3511);
  Object closure3512 = createclosure(4, "_apply");
setclosureframe(closure3512, stackframe);
  addtoclosure(closure3512, var_depth);
  addtoclosure(closure3512, var_spc);
  addtoclosure(closure3512, var_s);
  addtoclosure(closure3512, selfslot);
  struct UserObject *uo3512 = (struct UserObject*)block3511;
  uo3512->data[0] = (Object)closure3512;
  Method *meth_meth_ast__apply3512 = addmethod2pos(block3511, "_apply", &meth_ast__apply3512, 0);
int argcv_meth_ast__apply3512[] = {1};
meth_meth_ast__apply3512->type = alloc_MethodType(1, argcv_meth_ast__apply3512);
  meth_meth_ast__apply3512->definitionModule = modulename;
  meth_meth_ast__apply3512->definitionLine = 742;
// compilenode returning block3511
  gc_frame_newslot(block3511);
  params[0] = call3510;
  params[1] = block3511;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3543 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3508);
// compilenode returning call3543
// Begin line 748
  setline(748);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 747
  setline(747);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3545 == NULL) {
    strlit3545 = alloc_String("""\x0a""");
    gc_root(strlit3545);
  }
// compilenode returning strlit3545
  int op_slot_right_3544 = gc_frame_newslot(strlit3545);
// compilenode returning *var_s
  int op_slot_left_3544 = gc_frame_newslot(*var_s);
  params[0] = strlit3545;
  partcv[0] = 1;
  Object opresult3547 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3547
  *var_s = opresult3547;
  if (opresult3547 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if3483 = done;
  } else {
  }
// compilenode returning if3483
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3550 == NULL) {
    strlit3550 = alloc_String("Body:");
    gc_root(strlit3550);
  }
// compilenode returning strlit3550
  int op_slot_right_3549 = gc_frame_newslot(strlit3550);
// compilenode returning *var_spc
  int op_slot_right_3552 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_3552 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3554 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3554
  int op_slot_left_3549 = gc_frame_newslot(opresult3554);
  params[0] = strlit3550;
  partcv[0] = 1;
  Object opresult3555 = callmethod(opresult3554, "++", 1, partcv, params);
// compilenode returning opresult3555
  *var_s = opresult3555;
  if (opresult3555 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3557 = gc_frame_new();
  int callframe3558 = gc_frame_new();
  partcv[0] = 0;
  Object call3559 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3558);
// compilenode returning call3559
// compilenode returning call3559
  gc_frame_newslot(call3559);
  Object block3560 = alloc_Block(NULL, NULL, "ast", 750);
  gc_frame_newslot(block3560);
  block_savedest(block3560);
  Object closure3561 = createclosure(4, "_apply");
setclosureframe(closure3561, stackframe);
  addtoclosure(closure3561, var_depth);
  addtoclosure(closure3561, var_spc);
  addtoclosure(closure3561, var_s);
  addtoclosure(closure3561, selfslot);
  struct UserObject *uo3561 = (struct UserObject*)block3560;
  uo3561->data[0] = (Object)closure3561;
  Method *meth_meth_ast__apply3561 = addmethod2pos(block3560, "_apply", &meth_ast__apply3561, 0);
int argcv_meth_ast__apply3561[] = {1};
meth_meth_ast__apply3561->type = alloc_MethodType(1, argcv_meth_ast__apply3561);
  meth_meth_ast__apply3561->definitionModule = modulename;
  meth_meth_ast__apply3561->definitionLine = 750;
// compilenode returning block3560
  gc_frame_newslot(block3560);
  params[0] = call3559;
  params[1] = block3560;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3580 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3557);
// compilenode returning call3580
// Begin line 753
  setline(753);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_decType3581(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "decType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for decType (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for decType");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 759
  setline(759);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 756
  setline(756);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3584 = alloc_Boolean(0);
// compilenode returning bool3584
  int op_slot_right_3583 = gc_frame_newslot(bool3584);
  int callframe3586 = gc_frame_new();
  partcv[0] = 0;
  Object call3587 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3586);
// compilenode returning call3587
  int op_slot_left_3583 = gc_frame_newslot(call3587);
  params[0] = bool3584;
  partcv[0] = 1;
  Object opresult3588 = callmethod(call3587, "==", 1, partcv, params);
// compilenode returning opresult3588
  Object if3582 = done;
  if (istrue(opresult3588)) {
// Begin line 757
  setline(757);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3589 = gc_frame_new();
  if (strlit3590 == NULL) {
    strlit3590 = alloc_String("Unknown");
    gc_root(strlit3590);
  }
// compilenode returning strlit3590
  gc_frame_newslot(strlit3590);
  Object bool3591 = alloc_Boolean(0);
// compilenode returning bool3591
  gc_frame_newslot(bool3591);
// compilenode returning *var_identifierNode
  params[0] = strlit3590;
  params[1] = bool3591;
  partcv[0] = 2;
  Object call3592 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe3589);
// compilenode returning call3592
  return call3592;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if3582 = undefined;
  } else {
  }
// compilenode returning if3582
// Begin line 760
  setline(760);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 759
  setline(759);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3593 = gc_frame_new();
  partcv[0] = 0;
  Object call3594 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3593);
// compilenode returning call3594
  return call3594;
// compilenode returning undefined
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast__apply3607(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 765
  setline(765);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 764
  setline(764);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3609 == NULL) {
    strlit3609 = alloc_String("    ");
    gc_root(strlit3609);
  }
// compilenode returning strlit3609
  int op_slot_right_3608 = gc_frame_newslot(strlit3609);
// compilenode returning *var_spc
  int op_slot_left_3608 = gc_frame_newslot(*var_spc);
  params[0] = strlit3609;
  partcv[0] = 1;
  Object opresult3611 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult3611
  *var_spc = opresult3611;
  if (opresult3611 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3656(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_part = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_pnr = &(stackframe->slots[0]);
  *var_pnr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 773
  setline(773);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 772
  setline(772);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3657 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3658 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe3657);
// compilenode returning call3658
// compilenode returning call3658
// compilenode returning *var_pnr
  params[0] = *var_pnr;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres3659 = callmethod(call3658, "[]", 1, partcv, params);
// compilenode returning idxres3659
  *var_p = idxres3659;
  if (idxres3659 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 773
  setline(773);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3661 = gc_frame_new();
  Object num3663 = alloc_Float64(1);
// compilenode returning num3663
  int op_slot_right_3662 = gc_frame_newslot(num3663);
// compilenode returning *var_depth
  int op_slot_left_3662 = gc_frame_newslot(*var_depth);
  params[0] = num3663;
  partcv[0] = 1;
  Object sum3665 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum3665
  gc_frame_newslot(sum3665);
// compilenode returning *var_p
  params[0] = sum3665;
  partcv[0] = 1;
  Object call3666 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe3661);
// compilenode returning call3666
  int op_slot_right_3660 = gc_frame_newslot(call3666);
// compilenode returning *var_s
  int op_slot_left_3660 = gc_frame_newslot(*var_s);
  params[0] = call3666;
  partcv[0] = 1;
  Object opresult3668 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3668
  *var_s = opresult3668;
  if (opresult3668 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 777
  setline(777);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 774
  setline(774);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3673 = alloc_Boolean(0);
// compilenode returning bool3673
  int op_slot_right_3672 = gc_frame_newslot(bool3673);
  int callframe3675 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3676 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3675);
// compilenode returning call3676
// compilenode returning call3676
  int op_slot_left_3672 = gc_frame_newslot(call3676);
  params[0] = bool3673;
  partcv[0] = 1;
  Object opresult3677 = callmethod(call3676, "!=", 1, partcv, params);
// compilenode returning opresult3677
  int op_slot_right_3671 = gc_frame_newslot(opresult3677);
  int callframe3680 = gc_frame_new();
  int callframe3681 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3682 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe3681);
// compilenode returning call3682
// compilenode returning call3682
  partcv[0] = 0;
  Object call3683 = callmethod(call3682, "size",
    1, partcv, params);
  gc_frame_end(callframe3680);
// compilenode returning call3683
// compilenode returning call3683
  int op_slot_right_3679 = gc_frame_newslot(call3683);
// compilenode returning *var_pnr
  int op_slot_left_3679 = gc_frame_newslot(*var_pnr);
  params[0] = call3683;
  partcv[0] = 1;
  Object opresult3685 = callmethod(*var_pnr, "<", 1, partcv, params);
// compilenode returning opresult3685
  int op_slot_left_3671 = gc_frame_newslot(opresult3685);
  params[0] = opresult3677;
  partcv[0] = 1;
  Object opresult3686 = callmethod(opresult3685, "||", 1, partcv, params);
// compilenode returning opresult3686
  Object if3670 = done;
  if (istrue(opresult3686)) {
// Begin line 776
  setline(776);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 775
  setline(775);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3688 == NULL) {
    strlit3688 = alloc_String(", ");
    gc_root(strlit3688);
  }
// compilenode returning strlit3688
  int op_slot_right_3687 = gc_frame_newslot(strlit3688);
// compilenode returning *var_s
  int op_slot_left_3687 = gc_frame_newslot(*var_s);
  params[0] = strlit3688;
  partcv[0] = 1;
  Object opresult3690 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3690
  *var_s = opresult3690;
  if (opresult3690 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if3670 = done;
  } else {
  }
// compilenode returning if3670
  gc_frame_end(frame);
  return if3670;
}
Object meth_ast__apply3620(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 769
  setline(769);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3622 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3623 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe3622);
// compilenode returning call3623
// compilenode returning call3623
  int op_slot_right_3621 = gc_frame_newslot(call3623);
// compilenode returning *var_s
  int op_slot_left_3621 = gc_frame_newslot(*var_s);
  params[0] = call3623;
  partcv[0] = 1;
  Object opresult3625 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3625
  *var_s = opresult3625;
  if (opresult3625 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 769
  setline(769);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3630 = alloc_Boolean(0);
// compilenode returning bool3630
  int op_slot_right_3629 = gc_frame_newslot(bool3630);
  int callframe3632 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3633 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3632);
// compilenode returning call3633
// compilenode returning call3633
  int op_slot_left_3629 = gc_frame_newslot(call3633);
  params[0] = bool3630;
  partcv[0] = 1;
  Object opresult3634 = callmethod(call3633, "!=", 1, partcv, params);
// compilenode returning opresult3634
  int op_slot_right_3628 = gc_frame_newslot(opresult3634);
  Object num3637 = alloc_Float64(0);
// compilenode returning num3637
  int op_slot_right_3636 = gc_frame_newslot(num3637);
  int callframe3639 = gc_frame_new();
  int callframe3640 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3641 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe3640);
// compilenode returning call3641
// compilenode returning call3641
  partcv[0] = 0;
  Object call3642 = callmethod(call3641, "size",
    1, partcv, params);
  gc_frame_end(callframe3639);
// compilenode returning call3642
// compilenode returning call3642
  int op_slot_left_3636 = gc_frame_newslot(call3642);
  params[0] = num3637;
  partcv[0] = 1;
  Object opresult3643 = callmethod(call3642, ">", 1, partcv, params);
// compilenode returning opresult3643
  int op_slot_left_3628 = gc_frame_newslot(opresult3643);
  params[0] = opresult3634;
  partcv[0] = 1;
  Object opresult3644 = callmethod(opresult3643, "||", 1, partcv, params);
// compilenode returning opresult3644
  Object if3627 = done;
  if (istrue(opresult3644)) {
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 770
  setline(770);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3646 == NULL) {
    strlit3646 = alloc_String("(");
    gc_root(strlit3646);
  }
// compilenode returning strlit3646
  int op_slot_right_3645 = gc_frame_newslot(strlit3646);
// compilenode returning *var_s
  int op_slot_left_3645 = gc_frame_newslot(*var_s);
  params[0] = strlit3646;
  partcv[0] = 1;
  Object opresult3648 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3648
  *var_s = opresult3648;
  if (opresult3648 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3650 = gc_frame_new();
  int callframe3651 = gc_frame_new();
  int callframe3652 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3653 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe3652);
// compilenode returning call3653
// compilenode returning call3653
  partcv[0] = 0;
  Object call3654 = callmethod(call3653, "indices",
    1, partcv, params);
  gc_frame_end(callframe3651);
// compilenode returning call3654
// compilenode returning call3654
  gc_frame_newslot(call3654);
  Object block3655 = alloc_Block(NULL, NULL, "ast", 771);
  gc_frame_newslot(block3655);
  block_savedest(block3655);
  Object closure3656 = createclosure(4, "_apply");
setclosureframe(closure3656, stackframe);
  addtoclosure(closure3656, var_part);
  addtoclosure(closure3656, var_depth);
  addtoclosure(closure3656, var_s);
  addtoclosure(closure3656, selfslot);
  struct UserObject *uo3656 = (struct UserObject*)block3655;
  uo3656->data[0] = (Object)closure3656;
  Method *meth_meth_ast__apply3656 = addmethod2pos(block3655, "_apply", &meth_ast__apply3656, 0);
int argcv_meth_ast__apply3656[] = {1};
meth_meth_ast__apply3656->type = alloc_MethodType(1, argcv_meth_ast__apply3656);
  meth_meth_ast__apply3656->definitionModule = modulename;
  meth_meth_ast__apply3656->definitionLine = 771;
// compilenode returning block3655
  gc_frame_newslot(block3655);
  params[0] = call3654;
  params[1] = block3655;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3693 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3650);
// compilenode returning call3693
// Begin line 781
  setline(781);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 778
  setline(778);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3696 = alloc_Boolean(0);
// compilenode returning bool3696
  int op_slot_right_3695 = gc_frame_newslot(bool3696);
  int callframe3698 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3699 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3698);
// compilenode returning call3699
// compilenode returning call3699
  int op_slot_left_3695 = gc_frame_newslot(call3699);
  params[0] = bool3696;
  partcv[0] = 1;
  Object opresult3700 = callmethod(call3699, "!=", 1, partcv, params);
// compilenode returning opresult3700
  Object if3694 = done;
  if (istrue(opresult3700)) {
// Begin line 780
  setline(780);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 779
  setline(779);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3702 = gc_frame_new();
  int callframe3703 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3704 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3703);
// compilenode returning call3704
// compilenode returning call3704
  partcv[0] = 0;
  Object call3705 = callmethod(call3704, "value",
    1, partcv, params);
  gc_frame_end(callframe3702);
// compilenode returning call3705
// compilenode returning call3705
  int op_slot_right_3701 = gc_frame_newslot(call3705);
  if (strlit3708 == NULL) {
    strlit3708 = alloc_String("*");
    gc_root(strlit3708);
  }
// compilenode returning strlit3708
  int op_slot_right_3707 = gc_frame_newslot(strlit3708);
// compilenode returning *var_s
  int op_slot_left_3707 = gc_frame_newslot(*var_s);
  params[0] = strlit3708;
  partcv[0] = 1;
  Object opresult3710 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3710
  int op_slot_left_3701 = gc_frame_newslot(opresult3710);
  params[0] = call3705;
  partcv[0] = 1;
  Object opresult3711 = callmethod(opresult3710, "++", 1, partcv, params);
// compilenode returning opresult3711
  *var_s = opresult3711;
  if (opresult3711 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if3694 = done;
  } else {
  }
// compilenode returning if3694
// Begin line 782
  setline(782);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 781
  setline(781);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3714 == NULL) {
    strlit3714 = alloc_String(")");
    gc_root(strlit3714);
  }
// compilenode returning strlit3714
  int op_slot_right_3713 = gc_frame_newslot(strlit3714);
// compilenode returning *var_s
  int op_slot_left_3713 = gc_frame_newslot(*var_s);
  params[0] = strlit3714;
  partcv[0] = 1;
  Object opresult3716 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3716
  *var_s = opresult3716;
  if (opresult3716 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if3627 = done;
  } else {
  }
// compilenode returning if3627
  gc_frame_end(frame);
  return if3627;
}
Object meth_ast__apply3762(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 790
  setline(790);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3764 = gc_frame_new();
  Object num3765 = alloc_Float64(0);
// compilenode returning num3765
  gc_frame_newslot(num3765);
// compilenode returning *var_b
  params[0] = num3765;
  partcv[0] = 1;
  Object call3766 = callmethod(*var_b, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe3764);
// compilenode returning call3766
  int op_slot_right_3763 = gc_frame_newslot(call3766);
  if (strlit3770 == NULL) {
    strlit3770 = alloc_String("");
    gc_root(strlit3770);
  }
// compilenode returning strlit3770
  int op_slot_right_3769 = gc_frame_newslot(strlit3770);
// compilenode returning *var_a
  int op_slot_left_3769 = gc_frame_newslot(*var_a);
  params[0] = strlit3770;
  partcv[0] = 1;
  Object opresult3772 = callmethod(*var_a, "!=", 1, partcv, params);
// compilenode returning opresult3772
  Object if3768 = done;
struct StackFrameObject *iftmpstackframe3768 = stackframe;
  if (istrue(opresult3772)) {
stackframe = alloc_StackFrame(0, iftmpstackframe3768);
gc_frame_newslot((Object)stackframe);
  if (strlit3774 == NULL) {
    strlit3774 = alloc_String(", ");
    gc_root(strlit3774);
  }
// compilenode returning strlit3774
  int op_slot_right_3773 = gc_frame_newslot(strlit3774);
// compilenode returning *var_a
  int op_slot_left_3773 = gc_frame_newslot(*var_a);
  params[0] = strlit3774;
  partcv[0] = 1;
  Object opresult3776 = callmethod(*var_a, "++", 1, partcv, params);
// compilenode returning opresult3776
    gc_frame_newslot(opresult3776);
    if3768 = opresult3776;
  } else {
stackframe = alloc_StackFrame(0, iftmpstackframe3768);
gc_frame_newslot((Object)stackframe);
  if (strlit3777 == NULL) {
    strlit3777 = alloc_String("");
    gc_root(strlit3777);
  }
// compilenode returning strlit3777
    gc_frame_newslot(strlit3777);
    if3768 = strlit3777;
  }
stackframe = iftmpstackframe3768;
// compilenode returning if3768
  int op_slot_left_3763 = gc_frame_newslot(if3768);
  params[0] = call3766;
  partcv[0] = 1;
  Object opresult3778 = callmethod(if3768, "++", 1, partcv, params);
// compilenode returning opresult3778
  gc_frame_end(frame);
  return opresult3778;
}
Object meth_ast__apply3795(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 794
  setline(794);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3797 = gc_frame_new();
  Object num3799 = alloc_Float64(1);
// compilenode returning num3799
  int op_slot_right_3798 = gc_frame_newslot(num3799);
// compilenode returning *var_depth
  int op_slot_left_3798 = gc_frame_newslot(*var_depth);
  params[0] = num3799;
  partcv[0] = 1;
  Object sum3801 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum3801
  gc_frame_newslot(sum3801);
// compilenode returning *var_mx
  params[0] = sum3801;
  partcv[0] = 1;
  Object call3802 = callmethod(*var_mx, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe3797);
// compilenode returning call3802
  int op_slot_right_3796 = gc_frame_newslot(call3802);
  if (strlit3805 == NULL) {
    strlit3805 = alloc_String("    ");
    gc_root(strlit3805);
  }
// compilenode returning strlit3805
  int op_slot_right_3804 = gc_frame_newslot(strlit3805);
// compilenode returning *var_spc
  int op_slot_right_3807 = gc_frame_newslot(*var_spc);
  if (strlit3810 == NULL) {
    strlit3810 = alloc_String("""\x0a""");
    gc_root(strlit3810);
  }
// compilenode returning strlit3810
  int op_slot_right_3809 = gc_frame_newslot(strlit3810);
// compilenode returning *var_s
  int op_slot_left_3809 = gc_frame_newslot(*var_s);
  params[0] = strlit3810;
  partcv[0] = 1;
  Object opresult3812 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3812
  int op_slot_left_3807 = gc_frame_newslot(opresult3812);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3813 = callmethod(opresult3812, "++", 1, partcv, params);
// compilenode returning opresult3813
  int op_slot_left_3804 = gc_frame_newslot(opresult3813);
  params[0] = strlit3805;
  partcv[0] = 1;
  Object opresult3814 = callmethod(opresult3813, "++", 1, partcv, params);
// compilenode returning opresult3814
  int op_slot_left_3796 = gc_frame_newslot(opresult3814);
  params[0] = call3802;
  partcv[0] = 1;
  Object opresult3815 = callmethod(opresult3814, "++", 1, partcv, params);
// compilenode returning opresult3815
  *var_s = opresult3815;
  if (opresult3815 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace3595(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 763
  setline(763);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 762
  setline(762);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3596 == NULL) {
    strlit3596 = alloc_String("");
    gc_root(strlit3596);
  }
// compilenode returning strlit3596
  *var_spc = strlit3596;
  if (strlit3596 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 763
  setline(763);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3597 = gc_frame_new();
  Object num3600 = alloc_Float64(1);
// compilenode returning num3600
  int op_slot_right_3599 = gc_frame_newslot(num3600);
// compilenode returning *var_depth
  int op_slot_left_3599 = gc_frame_newslot(*var_depth);
  params[0] = num3600;
  partcv[0] = 1;
  Object diff3602 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff3602
  int op_slot_right_3598 = gc_frame_newslot(diff3602);
  Object num3604 = alloc_Float64(0);
// compilenode returning num3604
  int op_slot_left_3598 = gc_frame_newslot(num3604);
  params[0] = diff3602;
  partcv[0] = 1;
  Object opresult3605 = callmethod(num3604, "..", 1, partcv, params);
// compilenode returning opresult3605
  gc_frame_newslot(opresult3605);
  Object block3606 = alloc_Block(NULL, NULL, "ast", 763);
  gc_frame_newslot(block3606);
  block_savedest(block3606);
  Object closure3607 = createclosure(2, "_apply");
setclosureframe(closure3607, stackframe);
  addtoclosure(closure3607, var_spc);
  addtoclosure(closure3607, selfslot);
  struct UserObject *uo3607 = (struct UserObject*)block3606;
  uo3607->data[0] = (Object)closure3607;
  Method *meth_meth_ast__apply3607 = addmethod2pos(block3606, "_apply", &meth_ast__apply3607, 0);
int argcv_meth_ast__apply3607[] = {1};
meth_meth_ast__apply3607->type = alloc_MethodType(1, argcv_meth_ast__apply3607);
  meth_meth_ast__apply3607->definitionModule = modulename;
  meth_meth_ast__apply3607->definitionLine = 750;
// compilenode returning block3606
  gc_frame_newslot(block3606);
  params[0] = opresult3605;
  params[1] = block3606;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3614 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3597);
// compilenode returning call3614
// Begin line 767
  setline(767);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 766
  setline(766);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3615 == NULL) {
    strlit3615 = alloc_String("method ");
    gc_root(strlit3615);
  }
// compilenode returning strlit3615
  *var_s = strlit3615;
  if (strlit3615 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 767
  setline(767);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3616 = gc_frame_new();
  int callframe3617 = gc_frame_new();
  partcv[0] = 0;
  Object call3618 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3617);
// compilenode returning call3618
// compilenode returning call3618
  gc_frame_newslot(call3618);
  Object block3619 = alloc_Block(NULL, NULL, "ast", 767);
  gc_frame_newslot(block3619);
  block_savedest(block3619);
  Object closure3620 = createclosure(3, "_apply");
setclosureframe(closure3620, stackframe);
  addtoclosure(closure3620, var_s);
  addtoclosure(closure3620, var_depth);
  addtoclosure(closure3620, selfslot);
  struct UserObject *uo3620 = (struct UserObject*)block3619;
  uo3620->data[0] = (Object)closure3620;
  Method *meth_meth_ast__apply3620 = addmethod2pos(block3619, "_apply", &meth_ast__apply3620, 0);
int argcv_meth_ast__apply3620[] = {1};
meth_meth_ast__apply3620->type = alloc_MethodType(1, argcv_meth_ast__apply3620);
  meth_meth_ast__apply3620->definitionModule = modulename;
  meth_meth_ast__apply3620->definitionLine = 767;
// compilenode returning block3619
  gc_frame_newslot(block3619);
  params[0] = call3618;
  params[1] = block3619;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3719 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3616);
// compilenode returning call3719
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 784
  setline(784);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3722 = alloc_Boolean(0);
// compilenode returning bool3722
  int op_slot_right_3721 = gc_frame_newslot(bool3722);
  int callframe3724 = gc_frame_new();
  partcv[0] = 0;
  Object call3725 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3724);
// compilenode returning call3725
// compilenode returning call3725
  int op_slot_left_3721 = gc_frame_newslot(call3725);
  params[0] = bool3722;
  partcv[0] = 1;
  Object opresult3726 = callmethod(call3725, "!=", 1, partcv, params);
// compilenode returning opresult3726
  Object if3720 = done;
  if (istrue(opresult3726)) {
// Begin line 786
  setline(786);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 785
  setline(785);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3729 == NULL) {
    strlit3729 = alloc_String("");
    gc_root(strlit3729);
  }
// compilenode returning strlit3729
  int op_slot_right_3728 = gc_frame_newslot(strlit3729);
  int callframe3732 = gc_frame_new();
  Object num3733 = alloc_Float64(0);
// compilenode returning num3733
  gc_frame_newslot(num3733);
  int callframe3734 = gc_frame_new();
  partcv[0] = 0;
  Object call3735 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3734);
// compilenode returning call3735
// compilenode returning call3735
  params[0] = num3733;
  partcv[0] = 1;
  Object call3736 = callmethod(call3735, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe3732);
// compilenode returning call3736
  int op_slot_right_3731 = gc_frame_newslot(call3736);
  if (strlit3738 == NULL) {
    strlit3738 = alloc_String(" -> ");
    gc_root(strlit3738);
  }
// compilenode returning strlit3738
  int op_slot_left_3731 = gc_frame_newslot(strlit3738);
  params[0] = call3736;
  partcv[0] = 1;
  Object opresult3739 = callmethod(strlit3738, "++", 1, partcv, params);
// compilenode returning opresult3739
  int op_slot_left_3728 = gc_frame_newslot(opresult3739);
  params[0] = strlit3729;
  partcv[0] = 1;
  Object opresult3740 = callmethod(opresult3739, "++", 1, partcv, params);
// compilenode returning opresult3740
  int op_slot_right_3727 = gc_frame_newslot(opresult3740);
// compilenode returning *var_s
  int op_slot_left_3727 = gc_frame_newslot(*var_s);
  params[0] = opresult3740;
  partcv[0] = 1;
  Object opresult3742 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3742
  *var_s = opresult3742;
  if (opresult3742 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if3720 = done;
  } else {
  }
// compilenode returning if3720
// Begin line 792
  setline(792);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num3746 = alloc_Float64(0);
// compilenode returning num3746
  int op_slot_right_3745 = gc_frame_newslot(num3746);
  int callframe3748 = gc_frame_new();
  int callframe3749 = gc_frame_new();
  partcv[0] = 0;
  Object call3750 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3749);
// compilenode returning call3750
// compilenode returning call3750
  partcv[0] = 0;
  Object call3751 = callmethod(call3750, "size",
    1, partcv, params);
  gc_frame_end(callframe3748);
// compilenode returning call3751
// compilenode returning call3751
  int op_slot_left_3745 = gc_frame_newslot(call3751);
  params[0] = num3746;
  partcv[0] = 1;
  Object opresult3752 = callmethod(call3751, ">", 1, partcv, params);
// compilenode returning opresult3752
  Object if3744 = done;
  if (istrue(opresult3752)) {
// Begin line 789
  setline(789);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 788
  setline(788);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3754 == NULL) {
    strlit3754 = alloc_String(" is ");
    gc_root(strlit3754);
  }
// compilenode returning strlit3754
  int op_slot_right_3753 = gc_frame_newslot(strlit3754);
// compilenode returning *var_s
  int op_slot_left_3753 = gc_frame_newslot(*var_s);
  params[0] = strlit3754;
  partcv[0] = 1;
  Object opresult3756 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3756
  *var_s = opresult3756;
  if (opresult3756 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 789
  setline(789);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3759 = gc_frame_new();
  if (strlit3760 == NULL) {
    strlit3760 = alloc_String("");
    gc_root(strlit3760);
  }
// compilenode returning strlit3760
  gc_frame_newslot(strlit3760);
  Object block3761 = alloc_Block(NULL, NULL, "ast", 789);
  gc_frame_newslot(block3761);
  block_savedest(block3761);
  Object closure3762 = createclosure(1, "_apply");
setclosureframe(closure3762, stackframe);
  addtoclosure(closure3762, selfslot);
  struct UserObject *uo3762 = (struct UserObject*)block3761;
  uo3762->data[0] = (Object)closure3762;
  Method *meth_meth_ast__apply3762 = addmethod2pos(block3761, "_apply", &meth_ast__apply3762, 0);
int argcv_meth_ast__apply3762[] = {2};
meth_meth_ast__apply3762->type = alloc_MethodType(1, argcv_meth_ast__apply3762);
  meth_meth_ast__apply3762->definitionModule = modulename;
  meth_meth_ast__apply3762->definitionLine = 787;
// compilenode returning block3761
  gc_frame_newslot(block3761);
// Begin line 789
  setline(789);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3780 = gc_frame_new();
  partcv[0] = 0;
  Object call3781 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3780);
// compilenode returning call3781
// compilenode returning call3781
  params[0] = strlit3760;
  params[1] = block3761;
  partcv[0] = 2;
  Object call3782 = callmethod(call3781, "reduce",
    1, partcv, params);
  gc_frame_end(callframe3759);
// compilenode returning call3782
  int op_slot_right_3758 = gc_frame_newslot(call3782);
// compilenode returning *var_s
  int op_slot_left_3758 = gc_frame_newslot(*var_s);
  params[0] = call3782;
  partcv[0] = 1;
  Object opresult3784 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3784
  *var_s = opresult3784;
  if (opresult3784 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if3744 = done;
  } else {
  }
// compilenode returning if3744
// Begin line 793
  setline(793);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 792
  setline(792);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3787 == NULL) {
    strlit3787 = alloc_String(" {");
    gc_root(strlit3787);
  }
// compilenode returning strlit3787
  int op_slot_right_3786 = gc_frame_newslot(strlit3787);
// compilenode returning *var_s
  int op_slot_left_3786 = gc_frame_newslot(*var_s);
  params[0] = strlit3787;
  partcv[0] = 1;
  Object opresult3789 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3789
  *var_s = opresult3789;
  if (opresult3789 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 793
  setline(793);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3791 = gc_frame_new();
  int callframe3792 = gc_frame_new();
  partcv[0] = 0;
  Object call3793 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3792);
// compilenode returning call3793
// compilenode returning call3793
  gc_frame_newslot(call3793);
  Object block3794 = alloc_Block(NULL, NULL, "ast", 793);
  gc_frame_newslot(block3794);
  block_savedest(block3794);
  Object closure3795 = createclosure(4, "_apply");
setclosureframe(closure3795, stackframe);
  addtoclosure(closure3795, var_depth);
  addtoclosure(closure3795, var_spc);
  addtoclosure(closure3795, var_s);
  addtoclosure(closure3795, selfslot);
  struct UserObject *uo3795 = (struct UserObject*)block3794;
  uo3795->data[0] = (Object)closure3795;
  Method *meth_meth_ast__apply3795 = addmethod2pos(block3794, "_apply", &meth_ast__apply3795, 0);
int argcv_meth_ast__apply3795[] = {1};
meth_meth_ast__apply3795->type = alloc_MethodType(1, argcv_meth_ast__apply3795);
  meth_meth_ast__apply3795->definitionModule = modulename;
  meth_meth_ast__apply3795->definitionLine = 793;
// compilenode returning block3794
  gc_frame_newslot(block3794);
  params[0] = call3793;
  params[1] = block3794;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3818 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3791);
// compilenode returning call3818
// Begin line 797
  setline(797);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 796
  setline(796);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3820 == NULL) {
    strlit3820 = alloc_String("}");
    gc_root(strlit3820);
  }
// compilenode returning strlit3820
  int op_slot_right_3819 = gc_frame_newslot(strlit3820);
// compilenode returning *var_spc
  int op_slot_right_3822 = gc_frame_newslot(*var_spc);
  if (strlit3825 == NULL) {
    strlit3825 = alloc_String("""\x0a""");
    gc_root(strlit3825);
  }
// compilenode returning strlit3825
  int op_slot_right_3824 = gc_frame_newslot(strlit3825);
// compilenode returning *var_s
  int op_slot_left_3824 = gc_frame_newslot(*var_s);
  params[0] = strlit3825;
  partcv[0] = 1;
  Object opresult3827 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3827
  int op_slot_left_3822 = gc_frame_newslot(opresult3827);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3828 = callmethod(opresult3827, "++", 1, partcv, params);
// compilenode returning opresult3828
  int op_slot_left_3819 = gc_frame_newslot(opresult3828);
  params[0] = strlit3820;
  partcv[0] = 1;
  Object opresult3829 = callmethod(opresult3828, "++", 1, partcv, params);
// compilenode returning opresult3829
  *var_s = opresult3829;
  if (opresult3829 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 797
  setline(797);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new3031(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 4)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_methodNode = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  Object *var_collections = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[2]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[3]);
  *var_dtype_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 4)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3032 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3032 = alloc_userobj2(23,19, objclass3032);
  gc_frame_newslot(obj3032);
if (objclass3032 == NULL) {
  glfree(obj3032->class->name);
  obj3032->class->name = "methodNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3032, self, 0);
  addmethodreal(obj3032,"outer", &reader_ast_outer_3033);
  Object oldself3032 = self;
  struct StackFrameObject *oldstackframe3032 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3032);
  gc_frame_newslot((Object)stackframe);
  self = obj3032;
  Object *oldselfslot3032 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3032 = (*(struct UserObject *)self).data[0], lowerouter3032 = thisouter3032;
  if (inheritingObject3032) {
    struct UserObject *inho3032 = (struct UserObject *)inheritingObject3032;
    while (inho3032->super != GraceDefaultObject) inho3032 = (struct UserObject *)inho3032->super;
    inho3032->super = obj3032;
    self = inheritingObject3032;
    *selfslot = self;
    lowerouter3032 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3032;
  }
if (objclass3032 == NULL) {
  Method *reader3034 = addmethodrealflags(obj3032, "kind",&reader_ast_kind_3034, MFLAG_DEF);
  reader3034->definitionModule = modulename;
  reader3034->definitionLine = 655;
}
adddatum2(obj3032, alloc_Undefined(), 1);
if (objclass3032 == NULL) {
  Method *reader3035 = addmethodrealflags(obj3032, "value",&reader_ast_value_3035, MFLAG_DEF);
  reader3035->definitionModule = modulename;
  reader3035->definitionLine = 656;
}
adddatum2(obj3032, alloc_Undefined(), 2);
if (objclass3032 == NULL) {
  Method *reader3036 = addmethodrealflags(obj3032, "signature",&reader_ast_signature_3036, MFLAG_DEF);
  reader3036->definitionModule = modulename;
  reader3036->definitionLine = 657;
}
adddatum2(obj3032, alloc_Undefined(), 3);
if (objclass3032 == NULL) {
  Method *reader3037 = addmethodrealflags(obj3032, "body",&reader_ast_body_3037, MFLAG_DEF);
  reader3037->definitionModule = modulename;
  reader3037->definitionLine = 658;
}
adddatum2(obj3032, alloc_Undefined(), 4);
if (objclass3032 == NULL) {
  Method *reader3038 = addmethodrealflags(obj3032, "dtype",&reader_ast_dtype_3038, 0);
  Method *writer3038 = addmethodrealflags(obj3032, "dtype:=",&writer_ast_dtype_3038, 0);
  reader3038->definitionModule = modulename;
  writer3038->definitionModule = modulename;
  reader3038->definitionLine = 659;
  writer3038->definitionLine = 659;
}
obj3032->flags |= OFLAG_MUTABLE;
adddatum2(obj3032, alloc_Undefined(), 5);
if (objclass3032 == NULL) {
  Method *reader3039 = addmethodrealflags(obj3032, "varargs",&reader_ast_varargs_3039, 0);
  Method *writer3039 = addmethodrealflags(obj3032, "varargs:=",&writer_ast_varargs_3039, 0);
  reader3039->definitionModule = modulename;
  writer3039->definitionModule = modulename;
  reader3039->definitionLine = 660;
  writer3039->definitionLine = 660;
}
obj3032->flags |= OFLAG_MUTABLE;
adddatum2(obj3032, alloc_Undefined(), 6);
if (objclass3032 == NULL) {
  Method *reader3040 = addmethodrealflags(obj3032, "generics",&reader_ast_generics_3040, 0);
  Method *writer3040 = addmethodrealflags(obj3032, "generics:=",&writer_ast_generics_3040, 0);
  reader3040->definitionModule = modulename;
  writer3040->definitionModule = modulename;
  reader3040->definitionLine = 661;
  writer3040->definitionLine = 661;
}
obj3032->flags |= OFLAG_MUTABLE;
adddatum2(obj3032, alloc_Undefined(), 7);
if (objclass3032 == NULL) {
  Method *reader3041 = addmethodrealflags(obj3032, "selfclosure",&reader_ast_selfclosure_3041, 0);
  Method *writer3041 = addmethodrealflags(obj3032, "selfclosure:=",&writer_ast_selfclosure_3041, 0);
  reader3041->definitionModule = modulename;
  writer3041->definitionModule = modulename;
  reader3041->definitionLine = 662;
  writer3041->definitionLine = 662;
}
obj3032->flags |= OFLAG_MUTABLE;
adddatum2(obj3032, alloc_Undefined(), 8);
if (objclass3032 == NULL) {
  Method *reader3042 = addmethodrealflags(obj3032, "annotations",&reader_ast_annotations_3042, MFLAG_DEF);
  reader3042->definitionModule = modulename;
  reader3042->definitionLine = 663;
}
adddatum2(obj3032, alloc_Undefined(), 9);
if (objclass3032 == NULL) {
  Method *reader3043 = addmethodrealflags(obj3032, "properties",&reader_ast_properties_3043, 0);
  Method *writer3043 = addmethodrealflags(obj3032, "properties:=",&writer_ast_properties_3043, 0);
  reader3043->definitionModule = modulename;
  writer3043->definitionModule = modulename;
  reader3043->definitionLine = 664;
  writer3043->definitionLine = 664;
}
obj3032->flags |= OFLAG_MUTABLE;
adddatum2(obj3032, alloc_Undefined(), 10);
  struct UserObject *uo3044 = (struct UserObject*)obj3032;
  uo3044->data[11] = emptyclosure;
  Method *meth_meth_ast_accept3044 = addmethod2pos(obj3032, "accept", &meth_ast_accept3044, 11);
int argcv_meth_ast_accept3044[] = {1};
meth_meth_ast_accept3044->type = alloc_MethodType(1, argcv_meth_ast_accept3044);
meth_meth_ast_accept3044->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept3044->type->names[0] = "visitor";
  meth_meth_ast_accept3044->definitionModule = modulename;
  meth_meth_ast_accept3044->definitionLine = 664;
  block_savedest(obj3032);
  Object closure3099 = createclosure(2, "map()before()after");
setclosureframe(closure3099, stackframe);
  addtoclosure(closure3099, var_name_39_);
  addtoclosure(closure3099, var_methodNode);
  struct UserObject *uo3099 = (struct UserObject*)obj3032;
  uo3099->data[12] = (Object)closure3099;
  Method *meth_meth_ast_map_40__41_before_40__41_after3099 = addmethod2pos(obj3032, "map()before()after", &meth_ast_map_40__41_before_40__41_after3099, 12);
int argcv_meth_ast_map_40__41_before_40__41_after3099[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after3099->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after3099);
  meth_meth_ast_map_40__41_before_40__41_after3099->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after3099->definitionLine = 683;
  struct UserObject *uo3174 = (struct UserObject*)obj3032;
  uo3174->data[13] = emptyclosure;
  Method *meth_meth_ast_map3174 = addmethod2pos(obj3032, "map", &meth_ast_map3174, 13);
int argcv_meth_ast_map3174[] = {1};
meth_meth_ast_map3174->type = alloc_MethodType(1, argcv_meth_ast_map3174);
  meth_meth_ast_map3174->definitionModule = modulename;
  meth_meth_ast_map3174->definitionLine = 701;
  struct UserObject *uo3183 = (struct UserObject*)obj3032;
  uo3183->data[14] = emptyclosure;
  Method *meth_meth_ast_eachParameter3183 = addmethod2pos(obj3032, "eachParameter", &meth_ast_eachParameter3183, 14);
int argcv_meth_ast_eachParameter3183[] = {1};
meth_meth_ast_eachParameter3183->type = alloc_MethodType(1, argcv_meth_ast_eachParameter3183);
  meth_meth_ast_eachParameter3183->definitionModule = modulename;
  meth_meth_ast_eachParameter3183->definitionLine = 704;
  struct UserObject *uo3200 = (struct UserObject*)obj3032;
  uo3200->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty3200 = addmethod2pos(obj3032, "pretty", &meth_ast_pretty3200, 15);
int argcv_meth_ast_pretty3200[] = {1};
meth_meth_ast_pretty3200->type = alloc_MethodType(1, argcv_meth_ast_pretty3200);
  meth_meth_ast_pretty3200->definitionModule = modulename;
  meth_meth_ast_pretty3200->definitionLine = 711;
  block_savedest(obj3032);
  Object closure3581 = createclosure(1, "decType");
setclosureframe(closure3581, stackframe);
  addtoclosure(closure3581, var_identifierNode);
  struct UserObject *uo3581 = (struct UserObject*)obj3032;
  uo3581->data[16] = (Object)closure3581;
  Method *meth_meth_ast_decType3581 = addmethod2pos(obj3032, "decType", &meth_ast_decType3581, 16);
int argcv_meth_ast_decType3581[] = {0};
meth_meth_ast_decType3581->type = alloc_MethodType(1, argcv_meth_ast_decType3581);
  meth_meth_ast_decType3581->definitionModule = modulename;
  meth_meth_ast_decType3581->definitionLine = 755;
  struct UserObject *uo3595 = (struct UserObject*)obj3032;
  uo3595->data[17] = emptyclosure;
  Method *meth_meth_ast_toGrace3595 = addmethod2pos(obj3032, "toGrace", &meth_ast_toGrace3595, 17);
int argcv_meth_ast_toGrace3595[] = {1};
meth_meth_ast_toGrace3595->type = alloc_MethodType(1, argcv_meth_ast_toGrace3595);
meth_meth_ast_toGrace3595->type->types[0] = type_Number;
meth_meth_ast_toGrace3595->type->names[0] = "depth";
  meth_meth_ast_toGrace3595->definitionModule = modulename;
  meth_meth_ast_toGrace3595->definitionLine = 761;
  sourceObject = obj3032;
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3831 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3832 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe3831);
// compilenode returning call3832
  struct UserObject *obj3032_uo = (struct UserObject *)obj3032;
  obj3032_uo->super = call3832;
  sourceObject = obj3032;
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3833 == NULL) {
    strlit3833 = alloc_String("method");
    gc_root(strlit3833);
  }
// compilenode returning strlit3833
  adddatum2(obj3032, strlit3833, 1);
  sourceObject = obj3032;
// Begin line 655
  setline(655);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name_39_
  adddatum2(obj3032, *var_name_39_, 2);
  sourceObject = obj3032;
// Begin line 656
  setline(656);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_signature_39_
  adddatum2(obj3032, *var_signature_39_, 3);
  sourceObject = obj3032;
// Begin line 657
  setline(657);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_body_39_
  adddatum2(obj3032, *var_body_39_, 4);
  sourceObject = obj3032;
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dtype_39_
  adddatum2(obj3032, *var_dtype_39_, 5);
  sourceObject = obj3032;
// Begin line 659
  setline(659);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3834 = alloc_Boolean(0);
// compilenode returning bool3834
  adddatum2(obj3032, bool3834, 6);
  sourceObject = obj3032;
// Begin line 660
  setline(660);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array3835 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array3835
  adddatum2(obj3032, array3835, 7);
  sourceObject = obj3032;
// Begin line 661
  setline(661);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3836 = alloc_Boolean(0);
// compilenode returning bool3836
  adddatum2(obj3032, bool3836, 8);
  sourceObject = obj3032;
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3837 = gc_frame_new();
  int callframe3838 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call3839 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe3838);
// compilenode returning call3839
// compilenode returning call3839
  partcv[0] = 0;
  Object call3840 = callmethod(call3839, "new",
    1, partcv, params);
  gc_frame_end(callframe3837);
// compilenode returning call3840
// compilenode returning call3840
  adddatum2(obj3032, call3840, 9);
  sourceObject = obj3032;
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3841 = gc_frame_new();
  int callframe3842 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call3843 = callmethod(*var_collections, "map",
    1, partcv, params);
  gc_frame_end(callframe3842);
// compilenode returning call3843
// compilenode returning call3843
  partcv[0] = 0;
  Object call3844 = callmethod(call3843, "new",
    1, partcv, params);
  gc_frame_end(callframe3841);
// compilenode returning call3844
// compilenode returning call3844
  adddatum2(obj3032, call3844, 10);
  sourceObject = obj3032;
  sourceObject = obj3032;
  sourceObject = obj3032;
  sourceObject = obj3032;
  sourceObject = obj3032;
  sourceObject = obj3032;
  sourceObject = obj3032;
objclass3032 = obj3032->class;
  objclass3032->definitionModule = modulename;
  objclass3032->definitionLine = 507;
  (*(struct UserObject *)self).data[0] = lowerouter3032;
  self = oldself3032;
  selfslot = oldselfslot3032;
  stackframe = oldstackframe3032;
  gc_frame_end(frame);
  return obj3032;
}
Object meth_ast_new3031_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 4)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_methodNode = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  Object *var_collections = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[2]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[3]);
  *var_dtype_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 4)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3032 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3032 = alloc_userobj2(23,19, objclass3032);
  gc_frame_newslot(obj3032);
if (objclass3032 == NULL) {
  glfree(obj3032->class->name);
  obj3032->class->name = "methodNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3032, self, 0);
  addmethodreal(obj3032,"outer", &reader_ast_outer_3033);
  Object oldself3032 = self;
  struct StackFrameObject *oldstackframe3032 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3032);
  gc_frame_newslot((Object)stackframe);
  self = obj3032;
  Object *oldselfslot3032 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3032 = (*(struct UserObject *)self).data[0], lowerouter3032 = thisouter3032;
  if (inheritingObject3032) {
    struct UserObject *inho3032 = (struct UserObject *)inheritingObject3032;
    while (inho3032->super != GraceDefaultObject) inho3032 = (struct UserObject *)inho3032->super;
    inho3032->super = obj3032;
    self = inheritingObject3032;
    *selfslot = self;
    lowerouter3032 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3032;
  }
if (objclass3032 == NULL) {
  Method *reader3034 = addmethodrealflags(obj3032, "kind",&reader_ast_kind_3034, MFLAG_DEF);
  reader3034->definitionModule = modulename;
  reader3034->definitionLine = 655;
}
adddatum2(obj3032, alloc_Undefined(), 1);
if (objclass3032 == NULL) {
  Method *reader3035 = addmethodrealflags(obj3032, "value",&reader_ast_value_3035, MFLAG_DEF);
  reader3035->definitionModule = modulename;
  reader3035->definitionLine = 656;
}
adddatum2(obj3032, alloc_Undefined(), 2);
if (objclass3032 == NULL) {
  Method *reader3036 = addmethodrealflags(obj3032, "signature",&reader_ast_signature_3036, MFLAG_DEF);
  reader3036->definitionModule = modulename;
  reader3036->definitionLine = 657;
}
adddatum2(obj3032, alloc_Undefined(), 3);
if (objclass3032 == NULL) {
  Method *reader3037 = addmethodrealflags(obj3032, "body",&reader_ast_body_3037, MFLAG_DEF);
  reader3037->definitionModule = modulename;
  reader3037->definitionLine = 658;
}
adddatum2(obj3032, alloc_Undefined(), 4);
if (objclass3032 == NULL) {
  Method *reader3038 = addmethodrealflags(obj3032, "dtype",&reader_ast_dtype_3038, 0);
  Method *writer3038 = addmethodrealflags(obj3032, "dtype:=",&writer_ast_dtype_3038, 0);
  reader3038->definitionModule = modulename;
  writer3038->definitionModule = modulename;
  reader3038->definitionLine = 659;
  writer3038->definitionLine = 659;
}
obj3032->flags |= OFLAG_MUTABLE;
adddatum2(obj3032, alloc_Undefined(), 5);
if (objclass3032 == NULL) {
  Method *reader3039 = addmethodrealflags(obj3032, "varargs",&reader_ast_varargs_3039, 0);
  Method *writer3039 = addmethodrealflags(obj3032, "varargs:=",&writer_ast_varargs_3039, 0);
  reader3039->definitionModule = modulename;
  writer3039->definitionModule = modulename;
  reader3039->definitionLine = 660;
  writer3039->definitionLine = 660;
}
obj3032->flags |= OFLAG_MUTABLE;
adddatum2(obj3032, alloc_Undefined(), 6);
if (objclass3032 == NULL) {
  Method *reader3040 = addmethodrealflags(obj3032, "generics",&reader_ast_generics_3040, 0);
  Method *writer3040 = addmethodrealflags(obj3032, "generics:=",&writer_ast_generics_3040, 0);
  reader3040->definitionModule = modulename;
  writer3040->definitionModule = modulename;
  reader3040->definitionLine = 661;
  writer3040->definitionLine = 661;
}
obj3032->flags |= OFLAG_MUTABLE;
adddatum2(obj3032, alloc_Undefined(), 7);
if (objclass3032 == NULL) {
  Method *reader3041 = addmethodrealflags(obj3032, "selfclosure",&reader_ast_selfclosure_3041, 0);
  Method *writer3041 = addmethodrealflags(obj3032, "selfclosure:=",&writer_ast_selfclosure_3041, 0);
  reader3041->definitionModule = modulename;
  writer3041->definitionModule = modulename;
  reader3041->definitionLine = 662;
  writer3041->definitionLine = 662;
}
obj3032->flags |= OFLAG_MUTABLE;
adddatum2(obj3032, alloc_Undefined(), 8);
if (objclass3032 == NULL) {
  Method *reader3042 = addmethodrealflags(obj3032, "annotations",&reader_ast_annotations_3042, MFLAG_DEF);
  reader3042->definitionModule = modulename;
  reader3042->definitionLine = 663;
}
adddatum2(obj3032, alloc_Undefined(), 9);
if (objclass3032 == NULL) {
  Method *reader3043 = addmethodrealflags(obj3032, "properties",&reader_ast_properties_3043, 0);
  Method *writer3043 = addmethodrealflags(obj3032, "properties:=",&writer_ast_properties_3043, 0);
  reader3043->definitionModule = modulename;
  writer3043->definitionModule = modulename;
  reader3043->definitionLine = 664;
  writer3043->definitionLine = 664;
}
obj3032->flags |= OFLAG_MUTABLE;
adddatum2(obj3032, alloc_Undefined(), 10);
  struct UserObject *uo3044 = (struct UserObject*)obj3032;
  uo3044->data[11] = emptyclosure;
  Method *meth_meth_ast_accept3044 = addmethod2pos(obj3032, "accept", &meth_ast_accept3044, 11);
int argcv_meth_ast_accept3044[] = {1};
meth_meth_ast_accept3044->type = alloc_MethodType(1, argcv_meth_ast_accept3044);
meth_meth_ast_accept3044->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept3044->type->names[0] = "visitor";
  meth_meth_ast_accept3044->definitionModule = modulename;
  meth_meth_ast_accept3044->definitionLine = 664;
  block_savedest(obj3032);
  Object closure3099 = createclosure(2, "map()before()after");
setclosureframe(closure3099, stackframe);
  addtoclosure(closure3099, var_name_39_);
  addtoclosure(closure3099, var_methodNode);
  struct UserObject *uo3099 = (struct UserObject*)obj3032;
  uo3099->data[12] = (Object)closure3099;
  Method *meth_meth_ast_map_40__41_before_40__41_after3099 = addmethod2pos(obj3032, "map()before()after", &meth_ast_map_40__41_before_40__41_after3099, 12);
int argcv_meth_ast_map_40__41_before_40__41_after3099[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after3099->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after3099);
  meth_meth_ast_map_40__41_before_40__41_after3099->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after3099->definitionLine = 683;
  struct UserObject *uo3174 = (struct UserObject*)obj3032;
  uo3174->data[13] = emptyclosure;
  Method *meth_meth_ast_map3174 = addmethod2pos(obj3032, "map", &meth_ast_map3174, 13);
int argcv_meth_ast_map3174[] = {1};
meth_meth_ast_map3174->type = alloc_MethodType(1, argcv_meth_ast_map3174);
  meth_meth_ast_map3174->definitionModule = modulename;
  meth_meth_ast_map3174->definitionLine = 701;
  struct UserObject *uo3183 = (struct UserObject*)obj3032;
  uo3183->data[14] = emptyclosure;
  Method *meth_meth_ast_eachParameter3183 = addmethod2pos(obj3032, "eachParameter", &meth_ast_eachParameter3183, 14);
int argcv_meth_ast_eachParameter3183[] = {1};
meth_meth_ast_eachParameter3183->type = alloc_MethodType(1, argcv_meth_ast_eachParameter3183);
  meth_meth_ast_eachParameter3183->definitionModule = modulename;
  meth_meth_ast_eachParameter3183->definitionLine = 704;
  struct UserObject *uo3200 = (struct UserObject*)obj3032;
  uo3200->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty3200 = addmethod2pos(obj3032, "pretty", &meth_ast_pretty3200, 15);
int argcv_meth_ast_pretty3200[] = {1};
meth_meth_ast_pretty3200->type = alloc_MethodType(1, argcv_meth_ast_pretty3200);
  meth_meth_ast_pretty3200->definitionModule = modulename;
  meth_meth_ast_pretty3200->definitionLine = 711;
  block_savedest(obj3032);
  Object closure3581 = createclosure(1, "decType");
setclosureframe(closure3581, stackframe);
  addtoclosure(closure3581, var_identifierNode);
  struct UserObject *uo3581 = (struct UserObject*)obj3032;
  uo3581->data[16] = (Object)closure3581;
  Method *meth_meth_ast_decType3581 = addmethod2pos(obj3032, "decType", &meth_ast_decType3581, 16);
int argcv_meth_ast_decType3581[] = {0};
meth_meth_ast_decType3581->type = alloc_MethodType(1, argcv_meth_ast_decType3581);
  meth_meth_ast_decType3581->definitionModule = modulename;
  meth_meth_ast_decType3581->definitionLine = 755;
  struct UserObject *uo3595 = (struct UserObject*)obj3032;
  uo3595->data[17] = emptyclosure;
  Method *meth_meth_ast_toGrace3595 = addmethod2pos(obj3032, "toGrace", &meth_ast_toGrace3595, 17);
int argcv_meth_ast_toGrace3595[] = {1};
meth_meth_ast_toGrace3595->type = alloc_MethodType(1, argcv_meth_ast_toGrace3595);
meth_meth_ast_toGrace3595->type->types[0] = type_Number;
meth_meth_ast_toGrace3595->type->names[0] = "depth";
  meth_meth_ast_toGrace3595->definitionModule = modulename;
  meth_meth_ast_toGrace3595->definitionLine = 761;
  sourceObject = obj3032;
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3831 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3832 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe3831);
// compilenode returning call3832
  struct UserObject *obj3032_uo = (struct UserObject *)obj3032;
  obj3032_uo->super = call3832;
  sourceObject = obj3032;
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3833 == NULL) {
    strlit3833 = alloc_String("method");
    gc_root(strlit3833);
  }
// compilenode returning strlit3833
  adddatum2(obj3032, strlit3833, 1);
  sourceObject = obj3032;
// Begin line 655
  setline(655);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name_39_
  adddatum2(obj3032, *var_name_39_, 2);
  sourceObject = obj3032;
// Begin line 656
  setline(656);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_signature_39_
  adddatum2(obj3032, *var_signature_39_, 3);
  sourceObject = obj3032;
// Begin line 657
  setline(657);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_body_39_
  adddatum2(obj3032, *var_body_39_, 4);
  sourceObject = obj3032;
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dtype_39_
  adddatum2(obj3032, *var_dtype_39_, 5);
  sourceObject = obj3032;
// Begin line 659
  setline(659);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3834 = alloc_Boolean(0);
// compilenode returning bool3834
  adddatum2(obj3032, bool3834, 6);
  sourceObject = obj3032;
// Begin line 660
  setline(660);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array3835 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array3835
  adddatum2(obj3032, array3835, 7);
  sourceObject = obj3032;
// Begin line 661
  setline(661);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3836 = alloc_Boolean(0);
// compilenode returning bool3836
  adddatum2(obj3032, bool3836, 8);
  sourceObject = obj3032;
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3837 = gc_frame_new();
  int callframe3838 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call3839 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe3838);
// compilenode returning call3839
// compilenode returning call3839
  partcv[0] = 0;
  Object call3840 = callmethod(call3839, "new",
    1, partcv, params);
  gc_frame_end(callframe3837);
// compilenode returning call3840
// compilenode returning call3840
  adddatum2(obj3032, call3840, 9);
  sourceObject = obj3032;
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3841 = gc_frame_new();
  int callframe3842 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call3843 = callmethod(*var_collections, "map",
    1, partcv, params);
  gc_frame_end(callframe3842);
// compilenode returning call3843
// compilenode returning call3843
  partcv[0] = 0;
  Object call3844 = callmethod(call3843, "new",
    1, partcv, params);
  gc_frame_end(callframe3841);
// compilenode returning call3844
// compilenode returning call3844
  adddatum2(obj3032, call3844, 10);
  sourceObject = obj3032;
  sourceObject = obj3032;
  sourceObject = obj3032;
  sourceObject = obj3032;
  sourceObject = obj3032;
  sourceObject = obj3032;
  sourceObject = obj3032;
objclass3032 = obj3032->class;
  objclass3032->definitionModule = modulename;
  objclass3032->definitionLine = 507;
  (*(struct UserObject *)self).data[0] = lowerouter3032;
  self = oldself3032;
  selfslot = oldselfslot3032;
  stackframe = oldstackframe3032;
  gc_frame_end(frame);
  return obj3032;
}
Object meth_ast_callNode3846(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_callNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for callNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for callNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 800
  setline(800);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_callNode
  gc_frame_end(frame);
  return *var_callNode;
}
Object meth_ast__apply3874(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 825
  setline(825);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3875 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_arg
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call3876 = callmethod(*var_arg, "accept",
    1, partcv, params);
  gc_frame_end(callframe3875);
// compilenode returning call3876
  gc_frame_end(frame);
  return call3876;
}
Object meth_ast__apply3869(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 824
  setline(824);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3870 = gc_frame_new();
  int callframe3871 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3872 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe3871);
// compilenode returning call3872
// compilenode returning call3872
  gc_frame_newslot(call3872);
  Object block3873 = alloc_Block(NULL, NULL, "ast", 824);
  gc_frame_newslot(block3873);
  block_savedest(block3873);
  Object closure3874 = createclosure(2, "_apply");
setclosureframe(closure3874, stackframe);
  addtoclosure(closure3874, var_visitor);
  addtoclosure(closure3874, selfslot);
  struct UserObject *uo3874 = (struct UserObject*)block3873;
  uo3874->data[0] = (Object)closure3874;
  Method *meth_meth_ast__apply3874 = addmethod2pos(block3873, "_apply", &meth_ast__apply3874, 0);
int argcv_meth_ast__apply3874[] = {1};
meth_meth_ast__apply3874->type = alloc_MethodType(1, argcv_meth_ast__apply3874);
  meth_meth_ast__apply3874->definitionModule = modulename;
  meth_meth_ast__apply3874->definitionLine = 824;
// compilenode returning block3873
  gc_frame_newslot(block3873);
  params[0] = call3872;
  params[1] = block3873;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3878 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3870);
// compilenode returning call3878
  gc_frame_end(frame);
  return call3878;
}
Object meth_ast_accept3857(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 829
  setline(829);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 821
  setline(821);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3859 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call3860 = callmethod(*var_visitor, "visitCall",
    1, partcv, params);
  gc_frame_end(callframe3859);
// compilenode returning call3860
  Object if3858 = done;
  if (istrue(call3860)) {
// Begin line 822
  setline(822);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3861 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe3862 = gc_frame_new();
  partcv[0] = 0;
  Object call3863 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3862);
// compilenode returning call3863
// compilenode returning call3863
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call3864 = callmethod(call3863, "accept",
    1, partcv, params);
  gc_frame_end(callframe3861);
// compilenode returning call3864
// Begin line 823
  setline(823);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3865 = gc_frame_new();
  int callframe3866 = gc_frame_new();
  partcv[0] = 0;
  Object call3867 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3866);
// compilenode returning call3867
// compilenode returning call3867
  gc_frame_newslot(call3867);
  Object block3868 = alloc_Block(NULL, NULL, "ast", 823);
  gc_frame_newslot(block3868);
  block_savedest(block3868);
  Object closure3869 = createclosure(2, "_apply");
setclosureframe(closure3869, stackframe);
  addtoclosure(closure3869, var_visitor);
  addtoclosure(closure3869, selfslot);
  struct UserObject *uo3869 = (struct UserObject*)block3868;
  uo3869->data[0] = (Object)closure3869;
  Method *meth_meth_ast__apply3869 = addmethod2pos(block3868, "_apply", &meth_ast__apply3869, 0);
int argcv_meth_ast__apply3869[] = {1};
meth_meth_ast__apply3869->type = alloc_MethodType(1, argcv_meth_ast__apply3869);
  meth_meth_ast__apply3869->definitionModule = modulename;
  meth_meth_ast__apply3869->definitionLine = 823;
// compilenode returning block3868
  gc_frame_newslot(block3868);
  params[0] = call3867;
  params[1] = block3868;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3880 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3865);
// compilenode returning call3880
    gc_frame_newslot(call3880);
    if3858 = call3880;
  } else {
  }
// compilenode returning if3858
  gc_frame_end(frame);
  return if3858;
}
Object meth_ast_map_40__41_before_40__41_after3881(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_callNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 831
  setline(831);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3882 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call3883 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe3882);
// compilenode returning call3883
// Begin line 832
  setline(832);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3884 = gc_frame_new();
  int callframe3885 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe3886 = gc_frame_new();
  partcv[0] = 0;
  Object call3887 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3886);
// compilenode returning call3887
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3888 = callmethod(call3887, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe3885);
// compilenode returning call3888
  gc_frame_newslot(call3888);
// Begin line 833
  setline(833);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3889 = gc_frame_new();
  int callframe3890 = gc_frame_new();
  partcv[0] = 0;
  Object call3891 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3890);
// compilenode returning call3891
  gc_frame_newslot(call3891);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe3892 = gc_frame_new();
  int callframe3893 = gc_frame_new();
  Object call3894 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3893);
// compilenode returning call3894
// compilenode returning call3894
  partcv[0] = 0;
  Object call3895 = callmethodflags(call3894, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3892);
// compilenode returning call3895
// compilenode returning call3895
  params[0] = call3891;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3896 = callmethodflags(call3895, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3889);
// compilenode returning call3896
  gc_frame_newslot(call3896);
// Begin line 832
  setline(832);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_callNode
  params[0] = call3888;
  params[1] = call3896;
  partcv[0] = 2;
  Object call3897 = callmethod(*var_callNode, "new",
    1, partcv, params);
  gc_frame_end(callframe3884);
// compilenode returning call3897
  *var_n = call3897;
  if (call3897 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 837
  setline(837);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 834
  setline(834);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3900 = alloc_Boolean(0);
// compilenode returning bool3900
  int op_slot_right_3899 = gc_frame_newslot(bool3900);
  int callframe3902 = gc_frame_new();
  partcv[0] = 0;
  Object call3903 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3902);
// compilenode returning call3903
  int op_slot_left_3899 = gc_frame_newslot(call3903);
  params[0] = bool3900;
  partcv[0] = 1;
  Object opresult3904 = callmethod(call3903, "!=", 1, partcv, params);
// compilenode returning opresult3904
  Object if3898 = done;
  if (istrue(opresult3904)) {
// Begin line 835
  setline(835);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 833
  setline(833);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3905 = gc_frame_new();
// Begin line 835
  setline(835);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3906 = gc_frame_new();
  int callframe3907 = gc_frame_new();
  partcv[0] = 0;
  Object call3908 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3907);
// compilenode returning call3908
  gc_frame_newslot(call3908);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe3909 = gc_frame_new();
  int callframe3910 = gc_frame_new();
  Object call3911 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3910);
// compilenode returning call3911
// compilenode returning call3911
  partcv[0] = 0;
  Object call3912 = callmethodflags(call3911, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3909);
// compilenode returning call3912
// compilenode returning call3912
  params[0] = call3908;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3913 = callmethodflags(call3912, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3906);
// compilenode returning call3913
  gc_frame_newslot(call3913);
// compilenode returning *var_n
  params[0] = call3913;
  partcv[0] = 1;
  Object call3914 = callmethod(*var_n, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe3905);
// compilenode returning call3914
// compilenode returning done
    gc_frame_newslot(done);
    if3898 = done;
  } else {
  }
// compilenode returning if3898
// Begin line 838
  setline(838);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 835
  setline(835);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3915 = gc_frame_new();
// Begin line 837
  setline(837);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3916 = gc_frame_new();
  partcv[0] = 0;
  Object call3917 = callmethodflags(self, "isPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3916);
// compilenode returning call3917
  gc_frame_newslot(call3917);
// compilenode returning *var_n
  params[0] = call3917;
  partcv[0] = 1;
  Object call3918 = callmethod(*var_n, "isPattern:=",
    1, partcv, params);
  gc_frame_end(callframe3915);
// compilenode returning call3918
// compilenode returning done
// Begin line 838
  setline(838);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3919 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3920 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe3919);
// compilenode returning call3920
  *var_n = call3920;
  if (call3920 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 840
  setline(840);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 835
  setline(835);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3922 = gc_frame_new();
// Begin line 839
  setline(839);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3923 = gc_frame_new();
  partcv[0] = 0;
  Object call3924 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3923);
// compilenode returning call3924
  gc_frame_newslot(call3924);
// compilenode returning *var_n
  params[0] = call3924;
  partcv[0] = 1;
  Object call3925 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe3922);
// compilenode returning call3925
// compilenode returning done
// Begin line 840
  setline(840);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3926 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3927 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe3926);
// compilenode returning call3927
// Begin line 841
  setline(841);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply3931(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3934(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map3928(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 844
  setline(844);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3929 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block3930 = alloc_Block(NULL, NULL, "ast", 844);
  gc_frame_newslot(block3930);
  block_savedest(block3930);
  Object closure3931 = createclosure(1, "_apply");
setclosureframe(closure3931, stackframe);
  addtoclosure(closure3931, selfslot);
  struct UserObject *uo3931 = (struct UserObject*)block3930;
  uo3931->data[0] = (Object)closure3931;
  Method *meth_meth_ast__apply3931 = addmethod2pos(block3930, "_apply", &meth_ast__apply3931, 0);
int argcv_meth_ast__apply3931[] = {0};
meth_meth_ast__apply3931->type = alloc_MethodType(1, argcv_meth_ast__apply3931);
  meth_meth_ast__apply3931->definitionModule = modulename;
  meth_meth_ast__apply3931->definitionLine = 835;
// compilenode returning block3930
  gc_frame_newslot(block3930);
  Object block3933 = alloc_Block(NULL, NULL, "ast", 844);
  gc_frame_newslot(block3933);
  block_savedest(block3933);
  Object closure3934 = createclosure(1, "_apply");
setclosureframe(closure3934, stackframe);
  addtoclosure(closure3934, selfslot);
  struct UserObject *uo3934 = (struct UserObject*)block3933;
  uo3934->data[0] = (Object)closure3934;
  Method *meth_meth_ast__apply3934 = addmethod2pos(block3933, "_apply", &meth_ast__apply3934, 0);
int argcv_meth_ast__apply3934[] = {0};
meth_meth_ast__apply3934->type = alloc_MethodType(1, argcv_meth_ast__apply3934);
  meth_meth_ast__apply3934->definitionModule = modulename;
  meth_meth_ast__apply3934->definitionLine = 835;
// compilenode returning block3933
  gc_frame_newslot(block3933);
  params[0] = *var_blk;
  params[1] = block3930;
  params[2] = block3933;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3936 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3929);
// compilenode returning call3936
  gc_frame_end(frame);
  return call3936;
}
Object meth_ast__apply3945(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 849
  setline(849);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3947 == NULL) {
    strlit3947 = alloc_String("  ");
    gc_root(strlit3947);
  }
// compilenode returning strlit3947
  int op_slot_right_3946 = gc_frame_newslot(strlit3947);
// compilenode returning *var_spc
  int op_slot_left_3946 = gc_frame_newslot(*var_spc);
  params[0] = strlit3947;
  partcv[0] = 1;
  Object opresult3949 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult3949
  *var_spc = opresult3949;
  if (opresult3949 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4001(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 858
  setline(858);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 857
  setline(857);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4003 == NULL) {
    strlit4003 = alloc_String("""\x0a""");
    gc_root(strlit4003);
  }
// compilenode returning strlit4003
  int op_slot_right_4002 = gc_frame_newslot(strlit4003);
  int callframe4006 = gc_frame_new();
  Object num4007 = alloc_Float64(0);
// compilenode returning num4007
  gc_frame_newslot(num4007);
// compilenode returning *var_g
  params[0] = num4007;
  partcv[0] = 1;
  Object call4008 = callmethod(*var_g, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4006);
// compilenode returning call4008
  int op_slot_right_4005 = gc_frame_newslot(call4008);
  if (strlit4011 == NULL) {
    strlit4011 = alloc_String("    ");
    gc_root(strlit4011);
  }
// compilenode returning strlit4011
  int op_slot_right_4010 = gc_frame_newslot(strlit4011);
// compilenode returning *var_spc
  int op_slot_right_4013 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_4013 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4015 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4015
  int op_slot_left_4010 = gc_frame_newslot(opresult4015);
  params[0] = strlit4011;
  partcv[0] = 1;
  Object opresult4016 = callmethod(opresult4015, "++", 1, partcv, params);
// compilenode returning opresult4016
  int op_slot_left_4005 = gc_frame_newslot(opresult4016);
  params[0] = call4008;
  partcv[0] = 1;
  Object opresult4017 = callmethod(opresult4016, "++", 1, partcv, params);
// compilenode returning opresult4017
  int op_slot_left_4002 = gc_frame_newslot(opresult4017);
  params[0] = strlit4003;
  partcv[0] = 1;
  Object opresult4018 = callmethod(opresult4017, "++", 1, partcv, params);
// compilenode returning opresult4018
  *var_s = opresult4018;
  if (opresult4018 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4056(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 864
  setline(864);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4058 = gc_frame_new();
  Object num4060 = alloc_Float64(3);
// compilenode returning num4060
  int op_slot_right_4059 = gc_frame_newslot(num4060);
// compilenode returning *var_depth
  int op_slot_left_4059 = gc_frame_newslot(*var_depth);
  params[0] = num4060;
  partcv[0] = 1;
  Object sum4062 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum4062
  gc_frame_newslot(sum4062);
// compilenode returning *var_arg
  params[0] = sum4062;
  partcv[0] = 1;
  Object call4063 = callmethod(*var_arg, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4058);
// compilenode returning call4063
  int op_slot_right_4057 = gc_frame_newslot(call4063);
// compilenode returning *var_spc
  int op_slot_right_4065 = gc_frame_newslot(*var_spc);
  if (strlit4068 == NULL) {
    strlit4068 = alloc_String("""\x0a""    ");
    gc_root(strlit4068);
  }
// compilenode returning strlit4068
  int op_slot_right_4067 = gc_frame_newslot(strlit4068);
// compilenode returning *var_s
  int op_slot_left_4067 = gc_frame_newslot(*var_s);
  params[0] = strlit4068;
  partcv[0] = 1;
  Object opresult4070 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4070
  int op_slot_left_4065 = gc_frame_newslot(opresult4070);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4071 = callmethod(opresult4070, "++", 1, partcv, params);
// compilenode returning opresult4071
  int op_slot_left_4057 = gc_frame_newslot(opresult4071);
  params[0] = call4063;
  partcv[0] = 1;
  Object opresult4072 = callmethod(opresult4071, "++", 1, partcv, params);
// compilenode returning opresult4072
  *var_s = opresult4072;
  if (opresult4072 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4034(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 862
  setline(862);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4036 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4037 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe4036);
// compilenode returning call4037
// compilenode returning call4037
  int op_slot_right_4035 = gc_frame_newslot(call4037);
  if (strlit4040 == NULL) {
    strlit4040 = alloc_String("Part: ");
    gc_root(strlit4040);
  }
// compilenode returning strlit4040
  int op_slot_right_4039 = gc_frame_newslot(strlit4040);
// compilenode returning *var_spc
  int op_slot_right_4042 = gc_frame_newslot(*var_spc);
  if (strlit4045 == NULL) {
    strlit4045 = alloc_String("""\x0a""  ");
    gc_root(strlit4045);
  }
// compilenode returning strlit4045
  int op_slot_right_4044 = gc_frame_newslot(strlit4045);
// compilenode returning *var_s
  int op_slot_left_4044 = gc_frame_newslot(*var_s);
  params[0] = strlit4045;
  partcv[0] = 1;
  Object opresult4047 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4047
  int op_slot_left_4042 = gc_frame_newslot(opresult4047);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4048 = callmethod(opresult4047, "++", 1, partcv, params);
// compilenode returning opresult4048
  int op_slot_left_4039 = gc_frame_newslot(opresult4048);
  params[0] = strlit4040;
  partcv[0] = 1;
  Object opresult4049 = callmethod(opresult4048, "++", 1, partcv, params);
// compilenode returning opresult4049
  int op_slot_left_4035 = gc_frame_newslot(opresult4049);
  params[0] = call4037;
  partcv[0] = 1;
  Object opresult4050 = callmethod(opresult4049, "++", 1, partcv, params);
// compilenode returning opresult4050
  *var_s = opresult4050;
  if (opresult4050 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4052 = gc_frame_new();
  int callframe4053 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4054 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4053);
// compilenode returning call4054
// compilenode returning call4054
  gc_frame_newslot(call4054);
  Object block4055 = alloc_Block(NULL, NULL, "ast", 863);
  gc_frame_newslot(block4055);
  block_savedest(block4055);
  Object closure4056 = createclosure(4, "_apply");
setclosureframe(closure4056, stackframe);
  addtoclosure(closure4056, var_depth);
  addtoclosure(closure4056, var_spc);
  addtoclosure(closure4056, var_s);
  addtoclosure(closure4056, selfslot);
  struct UserObject *uo4056 = (struct UserObject*)block4055;
  uo4056->data[0] = (Object)closure4056;
  Method *meth_meth_ast__apply4056 = addmethod2pos(block4055, "_apply", &meth_ast__apply4056, 0);
int argcv_meth_ast__apply4056[] = {1};
meth_meth_ast__apply4056->type = alloc_MethodType(1, argcv_meth_ast__apply4056);
  meth_meth_ast__apply4056->definitionModule = modulename;
  meth_meth_ast__apply4056->definitionLine = 863;
// compilenode returning block4055
  gc_frame_newslot(block4055);
  params[0] = call4054;
  params[1] = block4055;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4075 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4052);
// compilenode returning call4075
  gc_frame_end(frame);
  return call4075;
}
Object meth_ast_pretty3937(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 847
  setline(847);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3938 == NULL) {
    strlit3938 = alloc_String("");
    gc_root(strlit3938);
  }
// compilenode returning strlit3938
  *var_spc = strlit3938;
  if (strlit3938 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3939 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_3940 = gc_frame_newslot(*var_depth);
  Object num3942 = alloc_Float64(0);
// compilenode returning num3942
  int op_slot_left_3940 = gc_frame_newslot(num3942);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult3943 = callmethod(num3942, "..", 1, partcv, params);
// compilenode returning opresult3943
  gc_frame_newslot(opresult3943);
  Object block3944 = alloc_Block(NULL, NULL, "ast", 848);
  gc_frame_newslot(block3944);
  block_savedest(block3944);
  Object closure3945 = createclosure(2, "_apply");
setclosureframe(closure3945, stackframe);
  addtoclosure(closure3945, var_spc);
  addtoclosure(closure3945, selfslot);
  struct UserObject *uo3945 = (struct UserObject*)block3944;
  uo3945->data[0] = (Object)closure3945;
  Method *meth_meth_ast__apply3945 = addmethod2pos(block3944, "_apply", &meth_ast__apply3945, 0);
int argcv_meth_ast__apply3945[] = {1};
meth_meth_ast__apply3945->type = alloc_MethodType(1, argcv_meth_ast__apply3945);
  meth_meth_ast__apply3945->definitionModule = modulename;
  meth_meth_ast__apply3945->definitionLine = 835;
// compilenode returning block3944
  gc_frame_newslot(block3944);
  params[0] = opresult3943;
  params[1] = block3944;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3952 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3939);
// compilenode returning call3952
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 851
  setline(851);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3953 == NULL) {
    strlit3953 = alloc_String("Call""\x0a""");
    gc_root(strlit3953);
  }
// compilenode returning strlit3953
  *var_s = strlit3953;
  if (strlit3953 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 853
  setline(853);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3956 == NULL) {
    strlit3956 = alloc_String("");
    gc_root(strlit3956);
  }
// compilenode returning strlit3956
  int op_slot_right_3955 = gc_frame_newslot(strlit3956);
  int callframe3959 = gc_frame_new();
  Object num3961 = alloc_Float64(1);
// compilenode returning num3961
  int op_slot_right_3960 = gc_frame_newslot(num3961);
// compilenode returning *var_depth
  int op_slot_left_3960 = gc_frame_newslot(*var_depth);
  params[0] = num3961;
  partcv[0] = 1;
  Object sum3963 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum3963
  gc_frame_newslot(sum3963);
  int callframe3964 = gc_frame_new();
  partcv[0] = 0;
  Object call3965 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3964);
// compilenode returning call3965
// compilenode returning call3965
  params[0] = sum3963;
  partcv[0] = 1;
  Object call3966 = callmethod(call3965, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3959);
// compilenode returning call3966
  int op_slot_right_3958 = gc_frame_newslot(call3966);
  if (strlit3968 == NULL) {
    strlit3968 = alloc_String("Method: ");
    gc_root(strlit3968);
  }
// compilenode returning strlit3968
  int op_slot_left_3958 = gc_frame_newslot(strlit3968);
  params[0] = call3966;
  partcv[0] = 1;
  Object opresult3969 = callmethod(strlit3968, "++", 1, partcv, params);
// compilenode returning opresult3969
  int op_slot_left_3955 = gc_frame_newslot(opresult3969);
  params[0] = strlit3956;
  partcv[0] = 1;
  Object opresult3970 = callmethod(opresult3969, "++", 1, partcv, params);
// compilenode returning opresult3970
  int op_slot_right_3954 = gc_frame_newslot(opresult3970);
// compilenode returning *var_spc
  int op_slot_right_3972 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_3972 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3974 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3974
  int op_slot_left_3954 = gc_frame_newslot(opresult3974);
  params[0] = opresult3970;
  partcv[0] = 1;
  Object opresult3975 = callmethod(opresult3974, "++", 1, partcv, params);
// compilenode returning opresult3975
  *var_s = opresult3975;
  if (opresult3975 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 854
  setline(854);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 853
  setline(853);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3978 == NULL) {
    strlit3978 = alloc_String("""\x0a""");
    gc_root(strlit3978);
  }
// compilenode returning strlit3978
  int op_slot_right_3977 = gc_frame_newslot(strlit3978);
// compilenode returning *var_s
  int op_slot_left_3977 = gc_frame_newslot(*var_s);
  params[0] = strlit3978;
  partcv[0] = 1;
  Object opresult3980 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3980
  *var_s = opresult3980;
  if (opresult3980 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 860
  setline(860);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 854
  setline(854);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3984 = gc_frame_new();
  partcv[0] = 0;
  Object call3985 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3984);
// compilenode returning call3985
  int op_slot_right_3983 = gc_frame_newslot(call3985);
  Object bool3987 = alloc_Boolean(0);
// compilenode returning bool3987
  int op_slot_left_3983 = gc_frame_newslot(bool3987);
  params[0] = call3985;
  partcv[0] = 1;
  Object opresult3988 = callmethod(bool3987, "!=", 1, partcv, params);
// compilenode returning opresult3988
  Object if3982 = done;
  if (istrue(opresult3988)) {
// Begin line 856
  setline(856);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 855
  setline(855);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3990 == NULL) {
    strlit3990 = alloc_String("  Generics:""\x0a""");
    gc_root(strlit3990);
  }
// compilenode returning strlit3990
  int op_slot_right_3989 = gc_frame_newslot(strlit3990);
// compilenode returning *var_spc
  int op_slot_right_3992 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_3992 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3994 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3994
  int op_slot_left_3989 = gc_frame_newslot(opresult3994);
  params[0] = strlit3990;
  partcv[0] = 1;
  Object opresult3995 = callmethod(opresult3994, "++", 1, partcv, params);
// compilenode returning opresult3995
  *var_s = opresult3995;
  if (opresult3995 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 856
  setline(856);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3997 = gc_frame_new();
  int callframe3998 = gc_frame_new();
  partcv[0] = 0;
  Object call3999 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3998);
// compilenode returning call3999
  gc_frame_newslot(call3999);
  Object block4000 = alloc_Block(NULL, NULL, "ast", 856);
  gc_frame_newslot(block4000);
  block_savedest(block4000);
  Object closure4001 = createclosure(3, "_apply");
setclosureframe(closure4001, stackframe);
  addtoclosure(closure4001, var_spc);
  addtoclosure(closure4001, var_s);
  addtoclosure(closure4001, selfslot);
  struct UserObject *uo4001 = (struct UserObject*)block4000;
  uo4001->data[0] = (Object)closure4001;
  Method *meth_meth_ast__apply4001 = addmethod2pos(block4000, "_apply", &meth_ast__apply4001, 0);
int argcv_meth_ast__apply4001[] = {1};
meth_meth_ast__apply4001->type = alloc_MethodType(1, argcv_meth_ast__apply4001);
  meth_meth_ast__apply4001->definitionModule = modulename;
  meth_meth_ast__apply4001->definitionLine = 852;
// compilenode returning block4000
  gc_frame_newslot(block4000);
  params[0] = call3999;
  params[1] = block4000;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4021 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3997);
// compilenode returning call4021
    gc_frame_newslot(call4021);
    if3982 = call4021;
  } else {
  }
// compilenode returning if3982
// Begin line 861
  setline(861);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 860
  setline(860);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4023 == NULL) {
    strlit4023 = alloc_String("Arguments:");
    gc_root(strlit4023);
  }
// compilenode returning strlit4023
  int op_slot_right_4022 = gc_frame_newslot(strlit4023);
// compilenode returning *var_spc
  int op_slot_right_4025 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_4025 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4027 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4027
  int op_slot_left_4022 = gc_frame_newslot(opresult4027);
  params[0] = strlit4023;
  partcv[0] = 1;
  Object opresult4028 = callmethod(opresult4027, "++", 1, partcv, params);
// compilenode returning opresult4028
  *var_s = opresult4028;
  if (opresult4028 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 861
  setline(861);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4030 = gc_frame_new();
  int callframe4031 = gc_frame_new();
  partcv[0] = 0;
  Object call4032 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4031);
// compilenode returning call4032
// compilenode returning call4032
  gc_frame_newslot(call4032);
  Object block4033 = alloc_Block(NULL, NULL, "ast", 861);
  gc_frame_newslot(block4033);
  block_savedest(block4033);
  Object closure4034 = createclosure(4, "_apply");
setclosureframe(closure4034, stackframe);
  addtoclosure(closure4034, var_spc);
  addtoclosure(closure4034, var_s);
  addtoclosure(closure4034, var_depth);
  addtoclosure(closure4034, selfslot);
  struct UserObject *uo4034 = (struct UserObject*)block4033;
  uo4034->data[0] = (Object)closure4034;
  Method *meth_meth_ast__apply4034 = addmethod2pos(block4033, "_apply", &meth_ast__apply4034, 0);
int argcv_meth_ast__apply4034[] = {1};
meth_meth_ast__apply4034->type = alloc_MethodType(1, argcv_meth_ast__apply4034);
  meth_meth_ast__apply4034->definitionModule = modulename;
  meth_meth_ast__apply4034->definitionLine = 861;
// compilenode returning block4033
  gc_frame_newslot(block4033);
  params[0] = call4032;
  params[1] = block4033;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4077 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4030);
// compilenode returning call4077
// Begin line 867
  setline(867);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply4090(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 873
  setline(873);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 872
  setline(872);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4092 == NULL) {
    strlit4092 = alloc_String("    ");
    gc_root(strlit4092);
  }
// compilenode returning strlit4092
  int op_slot_right_4091 = gc_frame_newslot(strlit4092);
// compilenode returning *var_spc
  int op_slot_left_4091 = gc_frame_newslot(*var_spc);
  params[0] = strlit4092;
  partcv[0] = 1;
  Object opresult4094 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult4094
  *var_spc = opresult4094;
  if (opresult4094 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4180(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_part = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_anr = &(stackframe->slots[0]);
  *var_anr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_arg = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "arg");
// Begin line 890
  setline(890);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 889
  setline(889);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4181 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4182 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4181);
// compilenode returning call4182
// compilenode returning call4182
// compilenode returning *var_anr
  params[0] = *var_anr;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres4183 = callmethod(call4182, "[]", 1, partcv, params);
// compilenode returning idxres4183
  *var_arg = idxres4183;
  if (idxres4183 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 890
  setline(890);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4185 = gc_frame_new();
  Object num4187 = alloc_Float64(1);
// compilenode returning num4187
  int op_slot_right_4186 = gc_frame_newslot(num4187);
// compilenode returning *var_depth
  int op_slot_left_4186 = gc_frame_newslot(*var_depth);
  params[0] = num4187;
  partcv[0] = 1;
  Object sum4189 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum4189
  gc_frame_newslot(sum4189);
// compilenode returning *var_arg
  params[0] = sum4189;
  partcv[0] = 1;
  Object call4190 = callmethod(*var_arg, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4185);
// compilenode returning call4190
  int op_slot_right_4184 = gc_frame_newslot(call4190);
// compilenode returning *var_s
  int op_slot_left_4184 = gc_frame_newslot(*var_s);
  params[0] = call4190;
  partcv[0] = 1;
  Object opresult4192 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4192
  *var_s = opresult4192;
  if (opresult4192 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 894
  setline(894);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4196 = gc_frame_new();
  int callframe4197 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4198 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4197);
// compilenode returning call4198
// compilenode returning call4198
  partcv[0] = 0;
  Object call4199 = callmethod(call4198, "size",
    1, partcv, params);
  gc_frame_end(callframe4196);
// compilenode returning call4199
// compilenode returning call4199
  int op_slot_right_4195 = gc_frame_newslot(call4199);
// compilenode returning *var_anr
  int op_slot_left_4195 = gc_frame_newslot(*var_anr);
  params[0] = call4199;
  partcv[0] = 1;
  Object opresult4201 = callmethod(*var_anr, "<", 1, partcv, params);
// compilenode returning opresult4201
  Object if4194 = done;
  if (istrue(opresult4201)) {
// Begin line 893
  setline(893);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 892
  setline(892);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4203 == NULL) {
    strlit4203 = alloc_String(", ");
    gc_root(strlit4203);
  }
// compilenode returning strlit4203
  int op_slot_right_4202 = gc_frame_newslot(strlit4203);
// compilenode returning *var_s
  int op_slot_left_4202 = gc_frame_newslot(*var_s);
  params[0] = strlit4203;
  partcv[0] = 1;
  Object opresult4205 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4205
  *var_s = opresult4205;
  if (opresult4205 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if4194 = done;
  } else {
  }
// compilenode returning if4194
  gc_frame_end(frame);
  return if4194;
}
Object meth_ast__apply4153(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 886
  setline(886);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 885
  setline(885);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4155 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4156 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe4155);
// compilenode returning call4156
// compilenode returning call4156
  int op_slot_right_4154 = gc_frame_newslot(call4156);
// compilenode returning *var_s
  int op_slot_left_4154 = gc_frame_newslot(*var_s);
  params[0] = call4156;
  partcv[0] = 1;
  Object opresult4158 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4158
  *var_s = opresult4158;
  if (opresult4158 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 897
  setline(897);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 886
  setline(886);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num4162 = alloc_Float64(0);
// compilenode returning num4162
  int op_slot_right_4161 = gc_frame_newslot(num4162);
  int callframe4164 = gc_frame_new();
  int callframe4165 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4166 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4165);
// compilenode returning call4166
// compilenode returning call4166
  partcv[0] = 0;
  Object call4167 = callmethod(call4166, "size",
    1, partcv, params);
  gc_frame_end(callframe4164);
// compilenode returning call4167
// compilenode returning call4167
  int op_slot_left_4161 = gc_frame_newslot(call4167);
  params[0] = num4162;
  partcv[0] = 1;
  Object opresult4168 = callmethod(call4167, ">", 1, partcv, params);
// compilenode returning opresult4168
  Object if4160 = done;
  if (istrue(opresult4168)) {
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 887
  setline(887);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4170 == NULL) {
    strlit4170 = alloc_String("(");
    gc_root(strlit4170);
  }
// compilenode returning strlit4170
  int op_slot_right_4169 = gc_frame_newslot(strlit4170);
// compilenode returning *var_s
  int op_slot_left_4169 = gc_frame_newslot(*var_s);
  params[0] = strlit4170;
  partcv[0] = 1;
  Object opresult4172 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4172
  *var_s = opresult4172;
  if (opresult4172 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4174 = gc_frame_new();
  int callframe4175 = gc_frame_new();
  int callframe4176 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4177 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4176);
// compilenode returning call4177
// compilenode returning call4177
  partcv[0] = 0;
  Object call4178 = callmethod(call4177, "indices",
    1, partcv, params);
  gc_frame_end(callframe4175);
// compilenode returning call4178
// compilenode returning call4178
  gc_frame_newslot(call4178);
  Object block4179 = alloc_Block(NULL, NULL, "ast", 888);
  gc_frame_newslot(block4179);
  block_savedest(block4179);
  Object closure4180 = createclosure(4, "_apply");
setclosureframe(closure4180, stackframe);
  addtoclosure(closure4180, var_part);
  addtoclosure(closure4180, var_depth);
  addtoclosure(closure4180, var_s);
  addtoclosure(closure4180, selfslot);
  struct UserObject *uo4180 = (struct UserObject*)block4179;
  uo4180->data[0] = (Object)closure4180;
  Method *meth_meth_ast__apply4180 = addmethod2pos(block4179, "_apply", &meth_ast__apply4180, 0);
int argcv_meth_ast__apply4180[] = {1};
meth_meth_ast__apply4180->type = alloc_MethodType(1, argcv_meth_ast__apply4180);
  meth_meth_ast__apply4180->definitionModule = modulename;
  meth_meth_ast__apply4180->definitionLine = 888;
// compilenode returning block4179
  gc_frame_newslot(block4179);
  params[0] = call4178;
  params[1] = block4179;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4208 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4174);
// compilenode returning call4208
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 895
  setline(895);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4210 == NULL) {
    strlit4210 = alloc_String(")");
    gc_root(strlit4210);
  }
// compilenode returning strlit4210
  int op_slot_right_4209 = gc_frame_newslot(strlit4210);
// compilenode returning *var_s
  int op_slot_left_4209 = gc_frame_newslot(*var_s);
  params[0] = strlit4210;
  partcv[0] = 1;
  Object opresult4212 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4212
  *var_s = opresult4212;
  if (opresult4212 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if4160 = done;
  } else {
  }
// compilenode returning if4160
  gc_frame_end(frame);
  return if4160;
}
Object meth_ast_toGrace4078(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_member = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "member");
// Begin line 871
  setline(871);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 870
  setline(870);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4079 == NULL) {
    strlit4079 = alloc_String("");
    gc_root(strlit4079);
  }
// compilenode returning strlit4079
  *var_spc = strlit4079;
  if (strlit4079 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 871
  setline(871);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4080 = gc_frame_new();
  Object num4083 = alloc_Float64(1);
// compilenode returning num4083
  int op_slot_right_4082 = gc_frame_newslot(num4083);
// compilenode returning *var_depth
  int op_slot_left_4082 = gc_frame_newslot(*var_depth);
  params[0] = num4083;
  partcv[0] = 1;
  Object diff4085 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff4085
  int op_slot_right_4081 = gc_frame_newslot(diff4085);
  Object num4087 = alloc_Float64(0);
// compilenode returning num4087
  int op_slot_left_4081 = gc_frame_newslot(num4087);
  params[0] = diff4085;
  partcv[0] = 1;
  Object opresult4088 = callmethod(num4087, "..", 1, partcv, params);
// compilenode returning opresult4088
  gc_frame_newslot(opresult4088);
  Object block4089 = alloc_Block(NULL, NULL, "ast", 871);
  gc_frame_newslot(block4089);
  block_savedest(block4089);
  Object closure4090 = createclosure(2, "_apply");
setclosureframe(closure4090, stackframe);
  addtoclosure(closure4090, var_spc);
  addtoclosure(closure4090, selfslot);
  struct UserObject *uo4090 = (struct UserObject*)block4089;
  uo4090->data[0] = (Object)closure4090;
  Method *meth_meth_ast__apply4090 = addmethod2pos(block4089, "_apply", &meth_ast__apply4090, 0);
int argcv_meth_ast__apply4090[] = {1};
meth_meth_ast__apply4090->type = alloc_MethodType(1, argcv_meth_ast__apply4090);
  meth_meth_ast__apply4090->definitionModule = modulename;
  meth_meth_ast__apply4090->definitionLine = 863;
// compilenode returning block4089
  gc_frame_newslot(block4089);
  params[0] = opresult4088;
  params[1] = block4089;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4097 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4080);
// compilenode returning call4097
// Begin line 876
  setline(876);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 874
  setline(874);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4098 == NULL) {
    strlit4098 = alloc_String("");
    gc_root(strlit4098);
  }
// compilenode returning strlit4098
  *var_s = strlit4098;
  if (strlit4098 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 884
  setline(884);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 876
  setline(876);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4101 == NULL) {
    strlit4101 = alloc_String("member");
    gc_root(strlit4101);
  }
// compilenode returning strlit4101
  int op_slot_right_4100 = gc_frame_newslot(strlit4101);
  int callframe4103 = gc_frame_new();
  int callframe4104 = gc_frame_new();
  partcv[0] = 0;
  Object call4105 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4104);
// compilenode returning call4105
// compilenode returning call4105
  partcv[0] = 0;
  Object call4106 = callmethod(call4105, "kind",
    1, partcv, params);
  gc_frame_end(callframe4103);
// compilenode returning call4106
// compilenode returning call4106
  int op_slot_left_4100 = gc_frame_newslot(call4106);
  params[0] = strlit4101;
  partcv[0] = 1;
  Object opresult4107 = callmethod(call4106, "==", 1, partcv, params);
// compilenode returning opresult4107
  Object if4099 = done;
  if (istrue(opresult4107)) {
// Begin line 878
  setline(878);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 877
  setline(877);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4108 = gc_frame_new();
  partcv[0] = 0;
  Object call4109 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4108);
// compilenode returning call4109
// compilenode returning call4109
  *var_member = call4109;
  if (call4109 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 882
  setline(882);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 878
  setline(878);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4112 == NULL) {
    strlit4112 = alloc_String("prefix");
    gc_root(strlit4112);
  }
// compilenode returning strlit4112
  int op_slot_right_4111 = gc_frame_newslot(strlit4112);
  int callframe4114 = gc_frame_new();
  Object num4115 = alloc_Float64(1);
// compilenode returning num4115
  gc_frame_newslot(num4115);
  Object num4116 = alloc_Float64(6);
// compilenode returning num4116
  gc_frame_newslot(num4116);
  int callframe4117 = gc_frame_new();
// compilenode returning *var_member
  partcv[0] = 0;
  Object call4118 = callmethod(*var_member, "value",
    1, partcv, params);
  gc_frame_end(callframe4117);
// compilenode returning call4118
// compilenode returning call4118
  params[0] = num4115;
  params[1] = num4116;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4119 = callmethod(call4118, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe4114);
// compilenode returning call4119
  int op_slot_left_4111 = gc_frame_newslot(call4119);
  params[0] = strlit4112;
  partcv[0] = 1;
  Object opresult4120 = callmethod(call4119, "==", 1, partcv, params);
// compilenode returning opresult4120
  Object if4110 = done;
  if (istrue(opresult4120)) {
// Begin line 879
  setline(879);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4121 = gc_frame_new();
  Object num4122 = alloc_Float64(7);
// compilenode returning num4122
  gc_frame_newslot(num4122);
  int callframe4123 = gc_frame_new();
  int callframe4124 = gc_frame_new();
// compilenode returning *var_member
  partcv[0] = 0;
  Object call4125 = callmethod(*var_member, "value",
    1, partcv, params);
  gc_frame_end(callframe4124);
// compilenode returning call4125
// compilenode returning call4125
  partcv[0] = 0;
  Object call4126 = callmethod(call4125, "size",
    1, partcv, params);
  gc_frame_end(callframe4123);
// compilenode returning call4126
// compilenode returning call4126
  gc_frame_newslot(call4126);
  int callframe4127 = gc_frame_new();
// compilenode returning *var_member
  partcv[0] = 0;
  Object call4128 = callmethod(*var_member, "value",
    1, partcv, params);
  gc_frame_end(callframe4127);
// compilenode returning call4128
// compilenode returning call4128
  params[0] = num4122;
  params[1] = call4126;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4129 = callmethod(call4128, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe4121);
// compilenode returning call4129
  *var_s = call4129;
  if (call4129 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 880
  setline(880);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4132 = gc_frame_new();
  Object num4133 = alloc_Float64(0);
// compilenode returning num4133
  gc_frame_newslot(num4133);
  int callframe4134 = gc_frame_new();
// compilenode returning *var_member
  partcv[0] = 0;
  Object call4135 = callmethod(*var_member, "in",
    1, partcv, params);
  gc_frame_end(callframe4134);
// compilenode returning call4135
// compilenode returning call4135
  params[0] = num4133;
  partcv[0] = 1;
  Object call4136 = callmethod(call4135, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4132);
// compilenode returning call4136
  int op_slot_right_4131 = gc_frame_newslot(call4136);
// compilenode returning *var_s
  int op_slot_left_4131 = gc_frame_newslot(*var_s);
  params[0] = call4136;
  partcv[0] = 1;
  Object opresult4138 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4138
  return opresult4138;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if4110 = undefined;
  } else {
  }
// compilenode returning if4110
// Begin line 883
  setline(883);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 882
  setline(882);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4140 == NULL) {
    strlit4140 = alloc_String(".");
    gc_root(strlit4140);
  }
// compilenode returning strlit4140
  int op_slot_right_4139 = gc_frame_newslot(strlit4140);
  int callframe4142 = gc_frame_new();
  Object num4143 = alloc_Float64(0);
// compilenode returning num4143
  gc_frame_newslot(num4143);
  int callframe4144 = gc_frame_new();
// compilenode returning *var_member
  partcv[0] = 0;
  Object call4145 = callmethod(*var_member, "in",
    1, partcv, params);
  gc_frame_end(callframe4144);
// compilenode returning call4145
// compilenode returning call4145
  params[0] = num4143;
  partcv[0] = 1;
  Object call4146 = callmethod(call4145, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4142);
// compilenode returning call4146
  int op_slot_left_4139 = gc_frame_newslot(call4146);
  params[0] = strlit4140;
  partcv[0] = 1;
  Object opresult4147 = callmethod(call4146, "++", 1, partcv, params);
// compilenode returning opresult4147
  *var_s = opresult4147;
  if (opresult4147 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if4099 = done;
  } else {
  }
// compilenode returning if4099
// Begin line 884
  setline(884);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4149 = gc_frame_new();
  int callframe4150 = gc_frame_new();
  partcv[0] = 0;
  Object call4151 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4150);
// compilenode returning call4151
// compilenode returning call4151
  gc_frame_newslot(call4151);
  Object block4152 = alloc_Block(NULL, NULL, "ast", 884);
  gc_frame_newslot(block4152);
  block_savedest(block4152);
  Object closure4153 = createclosure(3, "_apply");
setclosureframe(closure4153, stackframe);
  addtoclosure(closure4153, var_s);
  addtoclosure(closure4153, var_depth);
  addtoclosure(closure4153, selfslot);
  struct UserObject *uo4153 = (struct UserObject*)block4152;
  uo4153->data[0] = (Object)closure4153;
  Method *meth_meth_ast__apply4153 = addmethod2pos(block4152, "_apply", &meth_ast__apply4153, 0);
int argcv_meth_ast__apply4153[] = {1};
meth_meth_ast__apply4153->type = alloc_MethodType(1, argcv_meth_ast__apply4153);
  meth_meth_ast__apply4153->definitionModule = modulename;
  meth_meth_ast__apply4153->definitionLine = 884;
// compilenode returning block4152
  gc_frame_newslot(block4152);
  params[0] = call4151;
  params[1] = block4152;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4215 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4149);
// compilenode returning call4215
// Begin line 898
  setline(898);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new3849(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_callNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_what = &(stackframe->slots[0]);
  *var_what = args[curarg];
  curarg++;
  Object *var_with_39_ = &(stackframe->slots[1]);
  *var_with_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3850 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3850 = alloc_userobj2(13,12, objclass3850);
  gc_frame_newslot(obj3850);
if (objclass3850 == NULL) {
  glfree(obj3850->class->name);
  obj3850->class->name = "callNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3850, self, 0);
  addmethodreal(obj3850,"outer", &reader_ast_outer_3851);
  Object oldself3850 = self;
  struct StackFrameObject *oldstackframe3850 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3850);
  gc_frame_newslot((Object)stackframe);
  self = obj3850;
  Object *oldselfslot3850 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3850 = (*(struct UserObject *)self).data[0], lowerouter3850 = thisouter3850;
  if (inheritingObject3850) {
    struct UserObject *inho3850 = (struct UserObject *)inheritingObject3850;
    while (inho3850->super != GraceDefaultObject) inho3850 = (struct UserObject *)inho3850->super;
    inho3850->super = obj3850;
    self = inheritingObject3850;
    *selfslot = self;
    lowerouter3850 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3850;
  }
if (objclass3850 == NULL) {
  Method *reader3852 = addmethodrealflags(obj3850, "kind",&reader_ast_kind_3852, MFLAG_DEF);
  reader3852->definitionModule = modulename;
  reader3852->definitionLine = 816;
}
adddatum2(obj3850, alloc_Undefined(), 1);
if (objclass3850 == NULL) {
  Method *reader3853 = addmethodrealflags(obj3850, "value",&reader_ast_value_3853, MFLAG_DEF);
  reader3853->definitionModule = modulename;
  reader3853->definitionLine = 817;
}
adddatum2(obj3850, alloc_Undefined(), 2);
if (objclass3850 == NULL) {
  Method *reader3854 = addmethodrealflags(obj3850, "with",&reader_ast_with_3854, MFLAG_DEF);
  reader3854->definitionModule = modulename;
  reader3854->definitionLine = 818;
}
adddatum2(obj3850, alloc_Undefined(), 3);
if (objclass3850 == NULL) {
  Method *reader3855 = addmethodrealflags(obj3850, "generics",&reader_ast_generics_3855, 0);
  Method *writer3855 = addmethodrealflags(obj3850, "generics:=",&writer_ast_generics_3855, 0);
  reader3855->definitionModule = modulename;
  writer3855->definitionModule = modulename;
  reader3855->definitionLine = 819;
  writer3855->definitionLine = 819;
}
obj3850->flags |= OFLAG_MUTABLE;
adddatum2(obj3850, alloc_Undefined(), 4);
if (objclass3850 == NULL) {
  Method *reader3856 = addmethodrealflags(obj3850, "isPattern",&reader_ast_isPattern_3856, 0);
  Method *writer3856 = addmethodrealflags(obj3850, "isPattern:=",&writer_ast_isPattern_3856, 0);
  reader3856->definitionModule = modulename;
  writer3856->definitionModule = modulename;
  reader3856->definitionLine = 820;
  writer3856->definitionLine = 820;
}
obj3850->flags |= OFLAG_MUTABLE;
adddatum2(obj3850, alloc_Undefined(), 5);
  struct UserObject *uo3857 = (struct UserObject*)obj3850;
  uo3857->data[6] = emptyclosure;
  Method *meth_meth_ast_accept3857 = addmethod2pos(obj3850, "accept", &meth_ast_accept3857, 6);
int argcv_meth_ast_accept3857[] = {1};
meth_meth_ast_accept3857->type = alloc_MethodType(1, argcv_meth_ast_accept3857);
meth_meth_ast_accept3857->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept3857->type->names[0] = "visitor";
  meth_meth_ast_accept3857->definitionModule = modulename;
  meth_meth_ast_accept3857->definitionLine = 820;
  block_savedest(obj3850);
  Object closure3881 = createclosure(1, "map()before()after");
setclosureframe(closure3881, stackframe);
  addtoclosure(closure3881, var_callNode);
  struct UserObject *uo3881 = (struct UserObject*)obj3850;
  uo3881->data[7] = (Object)closure3881;
  Method *meth_meth_ast_map_40__41_before_40__41_after3881 = addmethod2pos(obj3850, "map()before()after", &meth_ast_map_40__41_before_40__41_after3881, 7);
int argcv_meth_ast_map_40__41_before_40__41_after3881[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after3881->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after3881);
  meth_meth_ast_map_40__41_before_40__41_after3881->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after3881->definitionLine = 830;
  struct UserObject *uo3928 = (struct UserObject*)obj3850;
  uo3928->data[8] = emptyclosure;
  Method *meth_meth_ast_map3928 = addmethod2pos(obj3850, "map", &meth_ast_map3928, 8);
int argcv_meth_ast_map3928[] = {1};
meth_meth_ast_map3928->type = alloc_MethodType(1, argcv_meth_ast_map3928);
  meth_meth_ast_map3928->definitionModule = modulename;
  meth_meth_ast_map3928->definitionLine = 843;
  struct UserObject *uo3937 = (struct UserObject*)obj3850;
  uo3937->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty3937 = addmethod2pos(obj3850, "pretty", &meth_ast_pretty3937, 9);
int argcv_meth_ast_pretty3937[] = {1};
meth_meth_ast_pretty3937->type = alloc_MethodType(1, argcv_meth_ast_pretty3937);
  meth_meth_ast_pretty3937->definitionModule = modulename;
  meth_meth_ast_pretty3937->definitionLine = 846;
  struct UserObject *uo4078 = (struct UserObject*)obj3850;
  uo4078->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace4078 = addmethod2pos(obj3850, "toGrace", &meth_ast_toGrace4078, 10);
int argcv_meth_ast_toGrace4078[] = {1};
meth_meth_ast_toGrace4078->type = alloc_MethodType(1, argcv_meth_ast_toGrace4078);
meth_meth_ast_toGrace4078->type->types[0] = type_Number;
meth_meth_ast_toGrace4078->type->names[0] = "depth";
  meth_meth_ast_toGrace4078->definitionModule = modulename;
  meth_meth_ast_toGrace4078->definitionLine = 869;
  sourceObject = obj3850;
// Begin line 814
  setline(814);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4216 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4217 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe4216);
// compilenode returning call4217
  struct UserObject *obj3850_uo = (struct UserObject *)obj3850;
  obj3850_uo->super = call4217;
  sourceObject = obj3850;
// Begin line 815
  setline(815);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4218 == NULL) {
    strlit4218 = alloc_String("call");
    gc_root(strlit4218);
  }
// compilenode returning strlit4218
  adddatum2(obj3850, strlit4218, 1);
  sourceObject = obj3850;
// Begin line 816
  setline(816);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_what
  adddatum2(obj3850, *var_what, 2);
  sourceObject = obj3850;
// Begin line 817
  setline(817);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_with_39_
  adddatum2(obj3850, *var_with_39_, 3);
  sourceObject = obj3850;
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4219 = alloc_Boolean(0);
// compilenode returning bool4219
  adddatum2(obj3850, bool4219, 4);
  sourceObject = obj3850;
// Begin line 819
  setline(819);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4220 = alloc_Boolean(0);
// compilenode returning bool4220
  adddatum2(obj3850, bool4220, 5);
  sourceObject = obj3850;
  sourceObject = obj3850;
  sourceObject = obj3850;
  sourceObject = obj3850;
  sourceObject = obj3850;
objclass3850 = obj3850->class;
  objclass3850->definitionModule = modulename;
  objclass3850->definitionLine = 663;
  (*(struct UserObject *)self).data[0] = lowerouter3850;
  self = oldself3850;
  selfslot = oldselfslot3850;
  stackframe = oldstackframe3850;
  gc_frame_end(frame);
  return obj3850;
}
Object meth_ast_new3849_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_callNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_what = &(stackframe->slots[0]);
  *var_what = args[curarg];
  curarg++;
  Object *var_with_39_ = &(stackframe->slots[1]);
  *var_with_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3850 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3850 = alloc_userobj2(13,12, objclass3850);
  gc_frame_newslot(obj3850);
if (objclass3850 == NULL) {
  glfree(obj3850->class->name);
  obj3850->class->name = "callNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3850, self, 0);
  addmethodreal(obj3850,"outer", &reader_ast_outer_3851);
  Object oldself3850 = self;
  struct StackFrameObject *oldstackframe3850 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3850);
  gc_frame_newslot((Object)stackframe);
  self = obj3850;
  Object *oldselfslot3850 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3850 = (*(struct UserObject *)self).data[0], lowerouter3850 = thisouter3850;
  if (inheritingObject3850) {
    struct UserObject *inho3850 = (struct UserObject *)inheritingObject3850;
    while (inho3850->super != GraceDefaultObject) inho3850 = (struct UserObject *)inho3850->super;
    inho3850->super = obj3850;
    self = inheritingObject3850;
    *selfslot = self;
    lowerouter3850 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3850;
  }
if (objclass3850 == NULL) {
  Method *reader3852 = addmethodrealflags(obj3850, "kind",&reader_ast_kind_3852, MFLAG_DEF);
  reader3852->definitionModule = modulename;
  reader3852->definitionLine = 816;
}
adddatum2(obj3850, alloc_Undefined(), 1);
if (objclass3850 == NULL) {
  Method *reader3853 = addmethodrealflags(obj3850, "value",&reader_ast_value_3853, MFLAG_DEF);
  reader3853->definitionModule = modulename;
  reader3853->definitionLine = 817;
}
adddatum2(obj3850, alloc_Undefined(), 2);
if (objclass3850 == NULL) {
  Method *reader3854 = addmethodrealflags(obj3850, "with",&reader_ast_with_3854, MFLAG_DEF);
  reader3854->definitionModule = modulename;
  reader3854->definitionLine = 818;
}
adddatum2(obj3850, alloc_Undefined(), 3);
if (objclass3850 == NULL) {
  Method *reader3855 = addmethodrealflags(obj3850, "generics",&reader_ast_generics_3855, 0);
  Method *writer3855 = addmethodrealflags(obj3850, "generics:=",&writer_ast_generics_3855, 0);
  reader3855->definitionModule = modulename;
  writer3855->definitionModule = modulename;
  reader3855->definitionLine = 819;
  writer3855->definitionLine = 819;
}
obj3850->flags |= OFLAG_MUTABLE;
adddatum2(obj3850, alloc_Undefined(), 4);
if (objclass3850 == NULL) {
  Method *reader3856 = addmethodrealflags(obj3850, "isPattern",&reader_ast_isPattern_3856, 0);
  Method *writer3856 = addmethodrealflags(obj3850, "isPattern:=",&writer_ast_isPattern_3856, 0);
  reader3856->definitionModule = modulename;
  writer3856->definitionModule = modulename;
  reader3856->definitionLine = 820;
  writer3856->definitionLine = 820;
}
obj3850->flags |= OFLAG_MUTABLE;
adddatum2(obj3850, alloc_Undefined(), 5);
  struct UserObject *uo3857 = (struct UserObject*)obj3850;
  uo3857->data[6] = emptyclosure;
  Method *meth_meth_ast_accept3857 = addmethod2pos(obj3850, "accept", &meth_ast_accept3857, 6);
int argcv_meth_ast_accept3857[] = {1};
meth_meth_ast_accept3857->type = alloc_MethodType(1, argcv_meth_ast_accept3857);
meth_meth_ast_accept3857->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept3857->type->names[0] = "visitor";
  meth_meth_ast_accept3857->definitionModule = modulename;
  meth_meth_ast_accept3857->definitionLine = 820;
  block_savedest(obj3850);
  Object closure3881 = createclosure(1, "map()before()after");
setclosureframe(closure3881, stackframe);
  addtoclosure(closure3881, var_callNode);
  struct UserObject *uo3881 = (struct UserObject*)obj3850;
  uo3881->data[7] = (Object)closure3881;
  Method *meth_meth_ast_map_40__41_before_40__41_after3881 = addmethod2pos(obj3850, "map()before()after", &meth_ast_map_40__41_before_40__41_after3881, 7);
int argcv_meth_ast_map_40__41_before_40__41_after3881[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after3881->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after3881);
  meth_meth_ast_map_40__41_before_40__41_after3881->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after3881->definitionLine = 830;
  struct UserObject *uo3928 = (struct UserObject*)obj3850;
  uo3928->data[8] = emptyclosure;
  Method *meth_meth_ast_map3928 = addmethod2pos(obj3850, "map", &meth_ast_map3928, 8);
int argcv_meth_ast_map3928[] = {1};
meth_meth_ast_map3928->type = alloc_MethodType(1, argcv_meth_ast_map3928);
  meth_meth_ast_map3928->definitionModule = modulename;
  meth_meth_ast_map3928->definitionLine = 843;
  struct UserObject *uo3937 = (struct UserObject*)obj3850;
  uo3937->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty3937 = addmethod2pos(obj3850, "pretty", &meth_ast_pretty3937, 9);
int argcv_meth_ast_pretty3937[] = {1};
meth_meth_ast_pretty3937->type = alloc_MethodType(1, argcv_meth_ast_pretty3937);
  meth_meth_ast_pretty3937->definitionModule = modulename;
  meth_meth_ast_pretty3937->definitionLine = 846;
  struct UserObject *uo4078 = (struct UserObject*)obj3850;
  uo4078->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace4078 = addmethod2pos(obj3850, "toGrace", &meth_ast_toGrace4078, 10);
int argcv_meth_ast_toGrace4078[] = {1};
meth_meth_ast_toGrace4078->type = alloc_MethodType(1, argcv_meth_ast_toGrace4078);
meth_meth_ast_toGrace4078->type->types[0] = type_Number;
meth_meth_ast_toGrace4078->type->names[0] = "depth";
  meth_meth_ast_toGrace4078->definitionModule = modulename;
  meth_meth_ast_toGrace4078->definitionLine = 869;
  sourceObject = obj3850;
// Begin line 814
  setline(814);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4216 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4217 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe4216);
// compilenode returning call4217
  struct UserObject *obj3850_uo = (struct UserObject *)obj3850;
  obj3850_uo->super = call4217;
  sourceObject = obj3850;
// Begin line 815
  setline(815);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4218 == NULL) {
    strlit4218 = alloc_String("call");
    gc_root(strlit4218);
  }
// compilenode returning strlit4218
  adddatum2(obj3850, strlit4218, 1);
  sourceObject = obj3850;
// Begin line 816
  setline(816);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_what
  adddatum2(obj3850, *var_what, 2);
  sourceObject = obj3850;
// Begin line 817
  setline(817);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_with_39_
  adddatum2(obj3850, *var_with_39_, 3);
  sourceObject = obj3850;
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4219 = alloc_Boolean(0);
// compilenode returning bool4219
  adddatum2(obj3850, bool4219, 4);
  sourceObject = obj3850;
// Begin line 819
  setline(819);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4220 = alloc_Boolean(0);
// compilenode returning bool4220
  adddatum2(obj3850, bool4220, 5);
  sourceObject = obj3850;
  sourceObject = obj3850;
  sourceObject = obj3850;
  sourceObject = obj3850;
  sourceObject = obj3850;
objclass3850 = obj3850->class;
  objclass3850->definitionModule = modulename;
  objclass3850->definitionLine = 663;
  (*(struct UserObject *)self).data[0] = lowerouter3850;
  self = oldself3850;
  selfslot = oldselfslot3850;
  stackframe = oldstackframe3850;
  gc_frame_end(frame);
  return obj3850;
}
Object meth_ast_classNode4222(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "classNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_classNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for classNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for classNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_classNode
  gc_frame_end(frame);
  return *var_classNode;
}
Object meth_ast__apply4271(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 938
  setline(938);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4272 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_p
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call4273 = callmethod(*var_p, "accept",
    1, partcv, params);
  gc_frame_end(callframe4272);
// compilenode returning call4273
  gc_frame_end(frame);
  return call4273;
}
Object meth_ast__apply4266(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 937
  setline(937);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4267 = gc_frame_new();
  int callframe4268 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4269 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4268);
// compilenode returning call4269
// compilenode returning call4269
  gc_frame_newslot(call4269);
  Object block4270 = alloc_Block(NULL, NULL, "ast", 937);
  gc_frame_newslot(block4270);
  block_savedest(block4270);
  Object closure4271 = createclosure(2, "_apply");
setclosureframe(closure4271, stackframe);
  addtoclosure(closure4271, var_visitor);
  addtoclosure(closure4271, selfslot);
  struct UserObject *uo4271 = (struct UserObject*)block4270;
  uo4271->data[0] = (Object)closure4271;
  Method *meth_meth_ast__apply4271 = addmethod2pos(block4270, "_apply", &meth_ast__apply4271, 0);
int argcv_meth_ast__apply4271[] = {1};
meth_meth_ast__apply4271->type = alloc_MethodType(1, argcv_meth_ast__apply4271);
  meth_meth_ast__apply4271->definitionModule = modulename;
  meth_meth_ast__apply4271->definitionLine = 937;
// compilenode returning block4270
  gc_frame_newslot(block4270);
  params[0] = call4269;
  params[1] = block4270;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4275 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4267);
// compilenode returning call4275
// Begin line 943
  setline(943);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4278 = alloc_Boolean(0);
// compilenode returning bool4278
  int op_slot_right_4277 = gc_frame_newslot(bool4278);
  int callframe4280 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4281 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4280);
// compilenode returning call4281
// compilenode returning call4281
  int op_slot_left_4277 = gc_frame_newslot(call4281);
  params[0] = bool4278;
  partcv[0] = 1;
  Object opresult4282 = callmethod(call4281, "!=", 1, partcv, params);
// compilenode returning opresult4282
  Object if4276 = done;
  if (istrue(opresult4282)) {
// Begin line 941
  setline(941);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4283 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe4284 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4285 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4284);
// compilenode returning call4285
// compilenode returning call4285
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call4286 = callmethod(call4285, "accept",
    1, partcv, params);
  gc_frame_end(callframe4283);
// compilenode returning call4286
    gc_frame_newslot(call4286);
    if4276 = call4286;
  } else {
  }
// compilenode returning if4276
  gc_frame_end(frame);
  return if4276;
}
Object meth_ast__apply4293(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 945
  setline(945);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4294 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_x
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call4295 = callmethod(*var_x, "accept",
    1, partcv, params);
  gc_frame_end(callframe4294);
// compilenode returning call4295
  gc_frame_end(frame);
  return call4295;
}
Object meth_ast_accept4239(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 948
  setline(948);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 930
  setline(930);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4241 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call4242 = callmethod(*var_visitor, "visitClass",
    1, partcv, params);
  gc_frame_end(callframe4241);
// compilenode returning call4242
  Object if4240 = done;
  if (istrue(call4242)) {
// Begin line 931
  setline(931);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4243 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe4244 = gc_frame_new();
  partcv[0] = 0;
  Object call4245 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4244);
// compilenode returning call4245
// compilenode returning call4245
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call4246 = callmethod(call4245, "accept",
    1, partcv, params);
  gc_frame_end(callframe4243);
// compilenode returning call4246
// Begin line 932
  setline(932);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4247 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe4248 = gc_frame_new();
  partcv[0] = 0;
  Object call4249 = callmethodflags(self, "constructor", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4248);
// compilenode returning call4249
// compilenode returning call4249
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call4250 = callmethod(call4249, "accept",
    1, partcv, params);
  gc_frame_end(callframe4247);
// compilenode returning call4250
// Begin line 936
  setline(936);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 933
  setline(933);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4253 = alloc_Boolean(0);
// compilenode returning bool4253
  int op_slot_right_4252 = gc_frame_newslot(bool4253);
  int callframe4255 = gc_frame_new();
  partcv[0] = 0;
  Object call4256 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4255);
// compilenode returning call4256
// compilenode returning call4256
  int op_slot_left_4252 = gc_frame_newslot(call4256);
  params[0] = bool4253;
  partcv[0] = 1;
  Object opresult4257 = callmethod(call4256, "!=", 1, partcv, params);
// compilenode returning opresult4257
  Object if4251 = done;
  if (istrue(opresult4257)) {
// Begin line 934
  setline(934);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4258 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe4259 = gc_frame_new();
  partcv[0] = 0;
  Object call4260 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4259);
// compilenode returning call4260
// compilenode returning call4260
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call4261 = callmethod(call4260, "accept",
    1, partcv, params);
  gc_frame_end(callframe4258);
// compilenode returning call4261
    gc_frame_newslot(call4261);
    if4251 = call4261;
  } else {
  }
// compilenode returning if4251
// Begin line 936
  setline(936);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4262 = gc_frame_new();
  int callframe4263 = gc_frame_new();
  partcv[0] = 0;
  Object call4264 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4263);
// compilenode returning call4264
// compilenode returning call4264
  gc_frame_newslot(call4264);
  Object block4265 = alloc_Block(NULL, NULL, "ast", 936);
  gc_frame_newslot(block4265);
  block_savedest(block4265);
  Object closure4266 = createclosure(2, "_apply");
setclosureframe(closure4266, stackframe);
  addtoclosure(closure4266, var_visitor);
  addtoclosure(closure4266, selfslot);
  struct UserObject *uo4266 = (struct UserObject*)block4265;
  uo4266->data[0] = (Object)closure4266;
  Method *meth_meth_ast__apply4266 = addmethod2pos(block4265, "_apply", &meth_ast__apply4266, 0);
int argcv_meth_ast__apply4266[] = {1};
meth_meth_ast__apply4266->type = alloc_MethodType(1, argcv_meth_ast__apply4266);
  meth_meth_ast__apply4266->definitionModule = modulename;
  meth_meth_ast__apply4266->definitionLine = 936;
// compilenode returning block4265
  gc_frame_newslot(block4265);
  params[0] = call4264;
  params[1] = block4265;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4288 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4262);
// compilenode returning call4288
// Begin line 944
  setline(944);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4289 = gc_frame_new();
  int callframe4290 = gc_frame_new();
  partcv[0] = 0;
  Object call4291 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4290);
// compilenode returning call4291
// compilenode returning call4291
  gc_frame_newslot(call4291);
  Object block4292 = alloc_Block(NULL, NULL, "ast", 944);
  gc_frame_newslot(block4292);
  block_savedest(block4292);
  Object closure4293 = createclosure(2, "_apply");
setclosureframe(closure4293, stackframe);
  addtoclosure(closure4293, var_visitor);
  addtoclosure(closure4293, selfslot);
  struct UserObject *uo4293 = (struct UserObject*)block4292;
  uo4293->data[0] = (Object)closure4293;
  Method *meth_meth_ast__apply4293 = addmethod2pos(block4292, "_apply", &meth_ast__apply4293, 0);
int argcv_meth_ast__apply4293[] = {1};
meth_meth_ast__apply4293->type = alloc_MethodType(1, argcv_meth_ast__apply4293);
  meth_meth_ast__apply4293->definitionModule = modulename;
  meth_meth_ast__apply4293->definitionLine = 944;
// compilenode returning block4292
  gc_frame_newslot(block4292);
  params[0] = call4291;
  params[1] = block4292;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4297 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4289);
// compilenode returning call4297
    gc_frame_newslot(call4297);
    if4240 = call4297;
  } else {
  }
// compilenode returning if4240
  gc_frame_end(frame);
  return if4240;
}
Object meth_ast__apply4345(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_blk = getfromclosure(closure, 0);
  Object *var_blkBefore = getfromclosure(closure, 1);
  Object *var_blkAfter = getfromclosure(closure, 2);
  Object *var_n = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 955
  setline(955);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4346 = gc_frame_new();
  int callframe4347 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// compilenode returning *var_a
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4348 = callmethod(*var_a, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe4347);
// compilenode returning call4348
  gc_frame_newslot(call4348);
  int callframe4349 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call4350 = callmethod(*var_n, "annotations",
    1, partcv, params);
  gc_frame_end(callframe4349);
// compilenode returning call4350
// compilenode returning call4350
  params[0] = call4348;
  partcv[0] = 1;
  Object call4351 = callmethod(call4350, "push",
    1, partcv, params);
  gc_frame_end(callframe4346);
// compilenode returning call4351
  gc_frame_end(frame);
  return call4351;
}
Object meth_ast_map_40__41_before_40__41_after4298(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[6];
  int partcv[3];
  Object *var_classNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 950
  setline(950);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4299 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call4300 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe4299);
// compilenode returning call4300
// Begin line 951
  setline(951);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4301 = gc_frame_new();
  int callframe4302 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe4303 = gc_frame_new();
  partcv[0] = 0;
  Object call4304 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4303);
// compilenode returning call4304
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4305 = callmethod(call4304, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe4302);
// compilenode returning call4305
  gc_frame_newslot(call4305);
// Begin line 952
  setline(952);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4306 = gc_frame_new();
  int callframe4307 = gc_frame_new();
  partcv[0] = 0;
  Object call4308 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4307);
// compilenode returning call4308
  gc_frame_newslot(call4308);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe4309 = gc_frame_new();
  int callframe4310 = gc_frame_new();
  Object call4311 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4310);
// compilenode returning call4311
// compilenode returning call4311
  partcv[0] = 0;
  Object call4312 = callmethodflags(call4311, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4309);
// compilenode returning call4312
// compilenode returning call4312
  params[0] = call4308;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4313 = callmethodflags(call4312, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4306);
// compilenode returning call4313
  gc_frame_newslot(call4313);
  int callframe4314 = gc_frame_new();
  int callframe4315 = gc_frame_new();
  partcv[0] = 0;
  Object call4316 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4315);
// compilenode returning call4316
  gc_frame_newslot(call4316);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe4317 = gc_frame_new();
  int callframe4318 = gc_frame_new();
  Object call4319 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4318);
// compilenode returning call4319
// compilenode returning call4319
  partcv[0] = 0;
  Object call4320 = callmethodflags(call4319, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4317);
// compilenode returning call4320
// compilenode returning call4320
  params[0] = call4316;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4321 = callmethodflags(call4320, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4314);
// compilenode returning call4321
  gc_frame_newslot(call4321);
// Begin line 953
  setline(953);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4322 = gc_frame_new();
  int callframe4323 = gc_frame_new();
  partcv[0] = 0;
  Object call4324 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4323);
// compilenode returning call4324
  gc_frame_newslot(call4324);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe4325 = gc_frame_new();
  int callframe4326 = gc_frame_new();
  Object call4327 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4326);
// compilenode returning call4327
// compilenode returning call4327
  partcv[0] = 0;
  Object call4328 = callmethodflags(call4327, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4325);
// compilenode returning call4328
// compilenode returning call4328
  params[0] = call4324;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 4;
  Object call4329 = callmethodflags(call4328, "maybeMap", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4322);
// compilenode returning call4329
  gc_frame_newslot(call4329);
  int callframe4330 = gc_frame_new();
  partcv[0] = 0;
  Object call4331 = callmethodflags(self, "constructor", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4330);
// compilenode returning call4331
  gc_frame_newslot(call4331);
  int callframe4332 = gc_frame_new();
  partcv[0] = 0;
  Object call4333 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4332);
// compilenode returning call4333
  gc_frame_newslot(call4333);
// Begin line 951
  setline(951);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_classNode
  params[0] = call4305;
  params[1] = call4313;
  params[2] = call4321;
  params[3] = call4329;
  params[4] = call4331;
  params[5] = call4333;
  partcv[0] = 6;
  Object call4334 = callmethod(*var_classNode, "new",
    1, partcv, params);
  gc_frame_end(callframe4301);
// compilenode returning call4334
  *var_n = call4334;
  if (call4334 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 954
  setline(954);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4335 = gc_frame_new();
  int callframe4336 = gc_frame_new();
  int callframe4337 = gc_frame_new();
  partcv[0] = 0;
  Object call4338 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4337);
// compilenode returning call4338
  gc_frame_newslot(call4338);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe4339 = gc_frame_new();
  int callframe4340 = gc_frame_new();
  Object call4341 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4340);
// compilenode returning call4341
// compilenode returning call4341
  partcv[0] = 0;
  Object call4342 = callmethodflags(call4341, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4339);
// compilenode returning call4342
// compilenode returning call4342
  params[0] = call4338;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4343 = callmethodflags(call4342, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4336);
// compilenode returning call4343
  gc_frame_newslot(call4343);
  Object block4344 = alloc_Block(NULL, NULL, "ast", 954);
  gc_frame_newslot(block4344);
  block_savedest(block4344);
  Object closure4345 = createclosure(5, "_apply");
setclosureframe(closure4345, stackframe);
  addtoclosure(closure4345, var_blk);
  addtoclosure(closure4345, var_blkBefore);
  addtoclosure(closure4345, var_blkAfter);
  addtoclosure(closure4345, var_n);
  addtoclosure(closure4345, selfslot);
  struct UserObject *uo4345 = (struct UserObject*)block4344;
  uo4345->data[0] = (Object)closure4345;
  Method *meth_meth_ast__apply4345 = addmethod2pos(block4344, "_apply", &meth_ast__apply4345, 0);
int argcv_meth_ast__apply4345[] = {1};
meth_meth_ast__apply4345->type = alloc_MethodType(1, argcv_meth_ast__apply4345);
  meth_meth_ast__apply4345->definitionModule = modulename;
  meth_meth_ast__apply4345->definitionLine = 954;
// compilenode returning block4344
  gc_frame_newslot(block4344);
  params[0] = call4343;
  params[1] = block4344;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4353 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4335);
// compilenode returning call4353
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4354 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call4355 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe4354);
// compilenode returning call4355
  *var_n = call4355;
  if (call4355 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 955
  setline(955);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4357 = gc_frame_new();
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4358 = gc_frame_new();
  partcv[0] = 0;
  Object call4359 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4358);
// compilenode returning call4359
  gc_frame_newslot(call4359);
// compilenode returning *var_n
  params[0] = call4359;
  partcv[0] = 1;
  Object call4360 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe4357);
// compilenode returning call4360
// compilenode returning done
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4361 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call4362 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe4361);
// compilenode returning call4362
// Begin line 960
  setline(960);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply4366(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4369(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map4363(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 963
  setline(963);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4364 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block4365 = alloc_Block(NULL, NULL, "ast", 963);
  gc_frame_newslot(block4365);
  block_savedest(block4365);
  Object closure4366 = createclosure(1, "_apply");
setclosureframe(closure4366, stackframe);
  addtoclosure(closure4366, selfslot);
  struct UserObject *uo4366 = (struct UserObject*)block4365;
  uo4366->data[0] = (Object)closure4366;
  Method *meth_meth_ast__apply4366 = addmethod2pos(block4365, "_apply", &meth_ast__apply4366, 0);
int argcv_meth_ast__apply4366[] = {0};
meth_meth_ast__apply4366->type = alloc_MethodType(1, argcv_meth_ast__apply4366);
  meth_meth_ast__apply4366->definitionModule = modulename;
  meth_meth_ast__apply4366->definitionLine = 955;
// compilenode returning block4365
  gc_frame_newslot(block4365);
  Object block4368 = alloc_Block(NULL, NULL, "ast", 963);
  gc_frame_newslot(block4368);
  block_savedest(block4368);
  Object closure4369 = createclosure(1, "_apply");
setclosureframe(closure4369, stackframe);
  addtoclosure(closure4369, selfslot);
  struct UserObject *uo4369 = (struct UserObject*)block4368;
  uo4369->data[0] = (Object)closure4369;
  Method *meth_meth_ast__apply4369 = addmethod2pos(block4368, "_apply", &meth_ast__apply4369, 0);
int argcv_meth_ast__apply4369[] = {0};
meth_meth_ast__apply4369->type = alloc_MethodType(1, argcv_meth_ast__apply4369);
  meth_meth_ast__apply4369->definitionModule = modulename;
  meth_meth_ast__apply4369->definitionLine = 955;
// compilenode returning block4368
  gc_frame_newslot(block4368);
  params[0] = *var_blk;
  params[1] = block4365;
  params[2] = block4368;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4371 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4364);
// compilenode returning call4371
  gc_frame_end(frame);
  return call4371;
}
Object meth_ast__apply4380(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 969
  setline(969);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 968
  setline(968);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4382 == NULL) {
    strlit4382 = alloc_String("  ");
    gc_root(strlit4382);
  }
// compilenode returning strlit4382
  int op_slot_right_4381 = gc_frame_newslot(strlit4382);
// compilenode returning *var_spc
  int op_slot_left_4381 = gc_frame_newslot(*var_spc);
  params[0] = strlit4382;
  partcv[0] = 1;
  Object opresult4384 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult4384
  *var_spc = opresult4384;
  if (opresult4384 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4582(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 986
  setline(986);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 985
  setline(985);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4584 == NULL) {
    strlit4584 = alloc_String("");
    gc_root(strlit4584);
  }
// compilenode returning strlit4584
  int op_slot_right_4583 = gc_frame_newslot(strlit4584);
  int callframe4587 = gc_frame_new();
  Object num4589 = alloc_Float64(4);
// compilenode returning num4589
  int op_slot_right_4588 = gc_frame_newslot(num4589);
// compilenode returning *var_depth
  int op_slot_left_4588 = gc_frame_newslot(*var_depth);
  params[0] = num4589;
  partcv[0] = 1;
  Object sum4591 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum4591
  gc_frame_newslot(sum4591);
// compilenode returning *var_p
  params[0] = sum4591;
  partcv[0] = 1;
  Object call4592 = callmethod(*var_p, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4587);
// compilenode returning call4592
  int op_slot_right_4586 = gc_frame_newslot(call4592);
  if (strlit4595 == NULL) {
    strlit4595 = alloc_String("");
    gc_root(strlit4595);
  }
// compilenode returning strlit4595
  int op_slot_right_4594 = gc_frame_newslot(strlit4595);
// compilenode returning *var_spc
  int op_slot_right_4597 = gc_frame_newslot(*var_spc);
  if (strlit4600 == NULL) {
    strlit4600 = alloc_String("""\x0a""      ");
    gc_root(strlit4600);
  }
// compilenode returning strlit4600
  int op_slot_right_4599 = gc_frame_newslot(strlit4600);
// compilenode returning *var_s
  int op_slot_right_4602 = gc_frame_newslot(*var_s);
  if (strlit4604 == NULL) {
    strlit4604 = alloc_String("");
    gc_root(strlit4604);
  }
// compilenode returning strlit4604
  int op_slot_left_4602 = gc_frame_newslot(strlit4604);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4605 = callmethod(strlit4604, "++", 1, partcv, params);
// compilenode returning opresult4605
  int op_slot_left_4599 = gc_frame_newslot(opresult4605);
  params[0] = strlit4600;
  partcv[0] = 1;
  Object opresult4606 = callmethod(opresult4605, "++", 1, partcv, params);
// compilenode returning opresult4606
  int op_slot_left_4597 = gc_frame_newslot(opresult4606);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4607 = callmethod(opresult4606, "++", 1, partcv, params);
// compilenode returning opresult4607
  int op_slot_left_4594 = gc_frame_newslot(opresult4607);
  params[0] = strlit4595;
  partcv[0] = 1;
  Object opresult4608 = callmethod(opresult4607, "++", 1, partcv, params);
// compilenode returning opresult4608
  int op_slot_left_4586 = gc_frame_newslot(opresult4608);
  params[0] = call4592;
  partcv[0] = 1;
  Object opresult4609 = callmethod(opresult4608, "++", 1, partcv, params);
// compilenode returning opresult4609
  int op_slot_left_4583 = gc_frame_newslot(opresult4609);
  params[0] = strlit4584;
  partcv[0] = 1;
  Object opresult4610 = callmethod(opresult4609, "++", 1, partcv, params);
// compilenode returning opresult4610
  *var_s = opresult4610;
  if (opresult4610 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4536(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 982
  setline(982);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4538 == NULL) {
    strlit4538 = alloc_String("");
    gc_root(strlit4538);
  }
// compilenode returning strlit4538
  int op_slot_right_4537 = gc_frame_newslot(strlit4538);
  int callframe4541 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4542 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe4541);
// compilenode returning call4542
// compilenode returning call4542
  int op_slot_right_4540 = gc_frame_newslot(call4542);
  if (strlit4545 == NULL) {
    strlit4545 = alloc_String("Part: ");
    gc_root(strlit4545);
  }
// compilenode returning strlit4545
  int op_slot_right_4544 = gc_frame_newslot(strlit4545);
// compilenode returning *var_spc
  int op_slot_right_4547 = gc_frame_newslot(*var_spc);
  if (strlit4550 == NULL) {
    strlit4550 = alloc_String("""\x0a""  ");
    gc_root(strlit4550);
  }
// compilenode returning strlit4550
  int op_slot_right_4549 = gc_frame_newslot(strlit4550);
// compilenode returning *var_s
  int op_slot_right_4552 = gc_frame_newslot(*var_s);
  if (strlit4554 == NULL) {
    strlit4554 = alloc_String("");
    gc_root(strlit4554);
  }
// compilenode returning strlit4554
  int op_slot_left_4552 = gc_frame_newslot(strlit4554);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4555 = callmethod(strlit4554, "++", 1, partcv, params);
// compilenode returning opresult4555
  int op_slot_left_4549 = gc_frame_newslot(opresult4555);
  params[0] = strlit4550;
  partcv[0] = 1;
  Object opresult4556 = callmethod(opresult4555, "++", 1, partcv, params);
// compilenode returning opresult4556
  int op_slot_left_4547 = gc_frame_newslot(opresult4556);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4557 = callmethod(opresult4556, "++", 1, partcv, params);
// compilenode returning opresult4557
  int op_slot_left_4544 = gc_frame_newslot(opresult4557);
  params[0] = strlit4545;
  partcv[0] = 1;
  Object opresult4558 = callmethod(opresult4557, "++", 1, partcv, params);
// compilenode returning opresult4558
  int op_slot_left_4540 = gc_frame_newslot(opresult4558);
  params[0] = call4542;
  partcv[0] = 1;
  Object opresult4559 = callmethod(opresult4558, "++", 1, partcv, params);
// compilenode returning opresult4559
  int op_slot_left_4537 = gc_frame_newslot(opresult4559);
  params[0] = strlit4538;
  partcv[0] = 1;
  Object opresult4560 = callmethod(opresult4559, "++", 1, partcv, params);
// compilenode returning opresult4560
  *var_s = opresult4560;
  if (opresult4560 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 984
  setline(984);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4563 == NULL) {
    strlit4563 = alloc_String("Parameters:");
    gc_root(strlit4563);
  }
// compilenode returning strlit4563
  int op_slot_right_4562 = gc_frame_newslot(strlit4563);
// compilenode returning *var_spc
  int op_slot_right_4565 = gc_frame_newslot(*var_spc);
  if (strlit4568 == NULL) {
    strlit4568 = alloc_String("""\x0a""    ");
    gc_root(strlit4568);
  }
// compilenode returning strlit4568
  int op_slot_right_4567 = gc_frame_newslot(strlit4568);
// compilenode returning *var_s
  int op_slot_right_4570 = gc_frame_newslot(*var_s);
  if (strlit4572 == NULL) {
    strlit4572 = alloc_String("");
    gc_root(strlit4572);
  }
// compilenode returning strlit4572
  int op_slot_left_4570 = gc_frame_newslot(strlit4572);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4573 = callmethod(strlit4572, "++", 1, partcv, params);
// compilenode returning opresult4573
  int op_slot_left_4567 = gc_frame_newslot(opresult4573);
  params[0] = strlit4568;
  partcv[0] = 1;
  Object opresult4574 = callmethod(opresult4573, "++", 1, partcv, params);
// compilenode returning opresult4574
  int op_slot_left_4565 = gc_frame_newslot(opresult4574);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4575 = callmethod(opresult4574, "++", 1, partcv, params);
// compilenode returning opresult4575
  int op_slot_left_4562 = gc_frame_newslot(opresult4575);
  params[0] = strlit4563;
  partcv[0] = 1;
  Object opresult4576 = callmethod(opresult4575, "++", 1, partcv, params);
// compilenode returning opresult4576
  *var_s = opresult4576;
  if (opresult4576 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 984
  setline(984);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4578 = gc_frame_new();
  int callframe4579 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4580 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4579);
// compilenode returning call4580
// compilenode returning call4580
  gc_frame_newslot(call4580);
  Object block4581 = alloc_Block(NULL, NULL, "ast", 984);
  gc_frame_newslot(block4581);
  block_savedest(block4581);
  Object closure4582 = createclosure(4, "_apply");
setclosureframe(closure4582, stackframe);
  addtoclosure(closure4582, var_depth);
  addtoclosure(closure4582, var_spc);
  addtoclosure(closure4582, var_s);
  addtoclosure(closure4582, selfslot);
  struct UserObject *uo4582 = (struct UserObject*)block4581;
  uo4582->data[0] = (Object)closure4582;
  Method *meth_meth_ast__apply4582 = addmethod2pos(block4581, "_apply", &meth_ast__apply4582, 0);
int argcv_meth_ast__apply4582[] = {1};
meth_meth_ast__apply4582->type = alloc_MethodType(1, argcv_meth_ast__apply4582);
  meth_meth_ast__apply4582->definitionModule = modulename;
  meth_meth_ast__apply4582->definitionLine = 984;
// compilenode returning block4581
  gc_frame_newslot(block4581);
  params[0] = call4580;
  params[1] = block4581;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4613 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4578);
// compilenode returning call4613
// Begin line 990
  setline(990);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 987
  setline(987);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4616 = alloc_Boolean(0);
// compilenode returning bool4616
  int op_slot_right_4615 = gc_frame_newslot(bool4616);
  int callframe4618 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4619 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4618);
// compilenode returning call4619
// compilenode returning call4619
  int op_slot_left_4615 = gc_frame_newslot(call4619);
  params[0] = bool4616;
  partcv[0] = 1;
  Object opresult4620 = callmethod(call4619, "!=", 1, partcv, params);
// compilenode returning opresult4620
  Object if4614 = done;
  if (istrue(opresult4620)) {
// Begin line 989
  setline(989);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 988
  setline(988);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4622 == NULL) {
    strlit4622 = alloc_String("");
    gc_root(strlit4622);
  }
// compilenode returning strlit4622
  int op_slot_right_4621 = gc_frame_newslot(strlit4622);
  int callframe4625 = gc_frame_new();
  Object num4627 = alloc_Float64(3);
// compilenode returning num4627
  int op_slot_right_4626 = gc_frame_newslot(num4627);
// compilenode returning *var_depth
  int op_slot_left_4626 = gc_frame_newslot(*var_depth);
  params[0] = num4627;
  partcv[0] = 1;
  Object sum4629 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum4629
  gc_frame_newslot(sum4629);
  int callframe4630 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4631 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4630);
// compilenode returning call4631
// compilenode returning call4631
  params[0] = sum4629;
  partcv[0] = 1;
  Object call4632 = callmethod(call4631, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4625);
// compilenode returning call4632
  int op_slot_right_4624 = gc_frame_newslot(call4632);
  if (strlit4635 == NULL) {
    strlit4635 = alloc_String("Vararg: ");
    gc_root(strlit4635);
  }
// compilenode returning strlit4635
  int op_slot_right_4634 = gc_frame_newslot(strlit4635);
// compilenode returning *var_spc
  int op_slot_right_4637 = gc_frame_newslot(*var_spc);
  if (strlit4640 == NULL) {
    strlit4640 = alloc_String("""\x0a""    ");
    gc_root(strlit4640);
  }
// compilenode returning strlit4640
  int op_slot_right_4639 = gc_frame_newslot(strlit4640);
// compilenode returning *var_s
  int op_slot_right_4642 = gc_frame_newslot(*var_s);
  if (strlit4644 == NULL) {
    strlit4644 = alloc_String("");
    gc_root(strlit4644);
  }
// compilenode returning strlit4644
  int op_slot_left_4642 = gc_frame_newslot(strlit4644);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4645 = callmethod(strlit4644, "++", 1, partcv, params);
// compilenode returning opresult4645
  int op_slot_left_4639 = gc_frame_newslot(opresult4645);
  params[0] = strlit4640;
  partcv[0] = 1;
  Object opresult4646 = callmethod(opresult4645, "++", 1, partcv, params);
// compilenode returning opresult4646
  int op_slot_left_4637 = gc_frame_newslot(opresult4646);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4647 = callmethod(opresult4646, "++", 1, partcv, params);
// compilenode returning opresult4647
  int op_slot_left_4634 = gc_frame_newslot(opresult4647);
  params[0] = strlit4635;
  partcv[0] = 1;
  Object opresult4648 = callmethod(opresult4647, "++", 1, partcv, params);
// compilenode returning opresult4648
  int op_slot_left_4624 = gc_frame_newslot(opresult4648);
  params[0] = call4632;
  partcv[0] = 1;
  Object opresult4649 = callmethod(opresult4648, "++", 1, partcv, params);
// compilenode returning opresult4649
  int op_slot_left_4621 = gc_frame_newslot(opresult4649);
  params[0] = strlit4622;
  partcv[0] = 1;
  Object opresult4650 = callmethod(opresult4649, "++", 1, partcv, params);
// compilenode returning opresult4650
  *var_s = opresult4650;
  if (opresult4650 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if4614 = done;
  } else {
  }
// compilenode returning if4614
  gc_frame_end(frame);
  return if4614;
}
Object meth_ast__apply4677(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 995
  setline(995);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 994
  setline(994);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4680 == NULL) {
    strlit4680 = alloc_String("");
    gc_root(strlit4680);
  }
// compilenode returning strlit4680
  int op_slot_right_4679 = gc_frame_newslot(strlit4680);
  int callframe4683 = gc_frame_new();
  Object num4684 = alloc_Float64(0);
// compilenode returning num4684
  gc_frame_newslot(num4684);
// compilenode returning *var_g
  params[0] = num4684;
  partcv[0] = 1;
  Object call4685 = callmethod(*var_g, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4683);
// compilenode returning call4685
  int op_slot_right_4682 = gc_frame_newslot(call4685);
  if (strlit4688 == NULL) {
    strlit4688 = alloc_String("");
    gc_root(strlit4688);
  }
// compilenode returning strlit4688
  int op_slot_right_4687 = gc_frame_newslot(strlit4688);
// compilenode returning *var_spc
  int op_slot_right_4690 = gc_frame_newslot(*var_spc);
  if (strlit4692 == NULL) {
    strlit4692 = alloc_String("""\x0a""  ");
    gc_root(strlit4692);
  }
// compilenode returning strlit4692
  int op_slot_left_4690 = gc_frame_newslot(strlit4692);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4693 = callmethod(strlit4692, "++", 1, partcv, params);
// compilenode returning opresult4693
  int op_slot_left_4687 = gc_frame_newslot(opresult4693);
  params[0] = strlit4688;
  partcv[0] = 1;
  Object opresult4694 = callmethod(opresult4693, "++", 1, partcv, params);
// compilenode returning opresult4694
  int op_slot_left_4682 = gc_frame_newslot(opresult4694);
  params[0] = call4685;
  partcv[0] = 1;
  Object opresult4695 = callmethod(opresult4694, "++", 1, partcv, params);
// compilenode returning opresult4695
  int op_slot_left_4679 = gc_frame_newslot(opresult4695);
  params[0] = strlit4680;
  partcv[0] = 1;
  Object opresult4696 = callmethod(opresult4695, "++", 1, partcv, params);
// compilenode returning opresult4696
  int op_slot_right_4678 = gc_frame_newslot(opresult4696);
// compilenode returning *var_s
  int op_slot_left_4678 = gc_frame_newslot(*var_s);
  params[0] = opresult4696;
  partcv[0] = 1;
  Object opresult4698 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4698
  *var_s = opresult4698;
  if (opresult4698 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4727(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1001
  setline(1001);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1000
  setline(1000);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4730 == NULL) {
    strlit4730 = alloc_String("");
    gc_root(strlit4730);
  }
// compilenode returning strlit4730
  int op_slot_right_4729 = gc_frame_newslot(strlit4730);
  int callframe4733 = gc_frame_new();
  Object num4735 = alloc_Float64(2);
// compilenode returning num4735
  int op_slot_right_4734 = gc_frame_newslot(num4735);
// compilenode returning *var_depth
  int op_slot_left_4734 = gc_frame_newslot(*var_depth);
  params[0] = num4735;
  partcv[0] = 1;
  Object sum4737 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum4737
  gc_frame_newslot(sum4737);
// compilenode returning *var_a
  params[0] = sum4737;
  partcv[0] = 1;
  Object call4738 = callmethod(*var_a, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4733);
// compilenode returning call4738
  int op_slot_right_4732 = gc_frame_newslot(call4738);
  if (strlit4741 == NULL) {
    strlit4741 = alloc_String("");
    gc_root(strlit4741);
  }
// compilenode returning strlit4741
  int op_slot_right_4740 = gc_frame_newslot(strlit4741);
// compilenode returning *var_spc
  int op_slot_right_4743 = gc_frame_newslot(*var_spc);
  if (strlit4745 == NULL) {
    strlit4745 = alloc_String("""\x0a""  ");
    gc_root(strlit4745);
  }
// compilenode returning strlit4745
  int op_slot_left_4743 = gc_frame_newslot(strlit4745);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4746 = callmethod(strlit4745, "++", 1, partcv, params);
// compilenode returning opresult4746
  int op_slot_left_4740 = gc_frame_newslot(opresult4746);
  params[0] = strlit4741;
  partcv[0] = 1;
  Object opresult4747 = callmethod(opresult4746, "++", 1, partcv, params);
// compilenode returning opresult4747
  int op_slot_left_4732 = gc_frame_newslot(opresult4747);
  params[0] = call4738;
  partcv[0] = 1;
  Object opresult4748 = callmethod(opresult4747, "++", 1, partcv, params);
// compilenode returning opresult4748
  int op_slot_left_4729 = gc_frame_newslot(opresult4748);
  params[0] = strlit4730;
  partcv[0] = 1;
  Object opresult4749 = callmethod(opresult4748, "++", 1, partcv, params);
// compilenode returning opresult4749
  int op_slot_right_4728 = gc_frame_newslot(opresult4749);
// compilenode returning *var_s
  int op_slot_left_4728 = gc_frame_newslot(*var_s);
  params[0] = opresult4749;
  partcv[0] = 1;
  Object opresult4751 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4751
  *var_s = opresult4751;
  if (opresult4751 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4771(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1005
  setline(1005);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4773 = gc_frame_new();
  Object num4775 = alloc_Float64(2);
// compilenode returning num4775
  int op_slot_right_4774 = gc_frame_newslot(num4775);
// compilenode returning *var_depth
  int op_slot_left_4774 = gc_frame_newslot(*var_depth);
  params[0] = num4775;
  partcv[0] = 1;
  Object sum4777 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum4777
  gc_frame_newslot(sum4777);
// compilenode returning *var_x
  params[0] = sum4777;
  partcv[0] = 1;
  Object call4778 = callmethod(*var_x, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4773);
// compilenode returning call4778
  int op_slot_right_4772 = gc_frame_newslot(call4778);
// compilenode returning *var_spc
  int op_slot_right_4780 = gc_frame_newslot(*var_spc);
  if (strlit4783 == NULL) {
    strlit4783 = alloc_String("""\x0a""  ");
    gc_root(strlit4783);
  }
// compilenode returning strlit4783
  int op_slot_right_4782 = gc_frame_newslot(strlit4783);
// compilenode returning *var_s
  int op_slot_left_4782 = gc_frame_newslot(*var_s);
  params[0] = strlit4783;
  partcv[0] = 1;
  Object opresult4785 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4785
  int op_slot_left_4780 = gc_frame_newslot(opresult4785);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4786 = callmethod(opresult4785, "++", 1, partcv, params);
// compilenode returning opresult4786
  int op_slot_left_4772 = gc_frame_newslot(opresult4786);
  params[0] = call4778;
  partcv[0] = 1;
  Object opresult4787 = callmethod(opresult4786, "++", 1, partcv, params);
// compilenode returning opresult4787
  *var_s = opresult4787;
  if (opresult4787 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty4372(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 967
  setline(967);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 966
  setline(966);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4373 == NULL) {
    strlit4373 = alloc_String("");
    gc_root(strlit4373);
  }
// compilenode returning strlit4373
  *var_spc = strlit4373;
  if (strlit4373 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 967
  setline(967);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4374 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_4375 = gc_frame_newslot(*var_depth);
  Object num4377 = alloc_Float64(0);
// compilenode returning num4377
  int op_slot_left_4375 = gc_frame_newslot(num4377);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult4378 = callmethod(num4377, "..", 1, partcv, params);
// compilenode returning opresult4378
  gc_frame_newslot(opresult4378);
  Object block4379 = alloc_Block(NULL, NULL, "ast", 967);
  gc_frame_newslot(block4379);
  block_savedest(block4379);
  Object closure4380 = createclosure(2, "_apply");
setclosureframe(closure4380, stackframe);
  addtoclosure(closure4380, var_spc);
  addtoclosure(closure4380, selfslot);
  struct UserObject *uo4380 = (struct UserObject*)block4379;
  uo4380->data[0] = (Object)closure4380;
  Method *meth_meth_ast__apply4380 = addmethod2pos(block4379, "_apply", &meth_ast__apply4380, 0);
int argcv_meth_ast__apply4380[] = {1};
meth_meth_ast__apply4380->type = alloc_MethodType(1, argcv_meth_ast__apply4380);
  meth_meth_ast__apply4380->definitionModule = modulename;
  meth_meth_ast__apply4380->definitionLine = 955;
// compilenode returning block4379
  gc_frame_newslot(block4379);
  params[0] = opresult4378;
  params[1] = block4379;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4387 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4374);
// compilenode returning call4387
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 970
  setline(970);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4389 == NULL) {
    strlit4389 = alloc_String(")");
    gc_root(strlit4389);
  }
// compilenode returning strlit4389
  int op_slot_right_4388 = gc_frame_newslot(strlit4389);
  int callframe4392 = gc_frame_new();
  Object num4393 = alloc_Float64(0);
// compilenode returning num4393
  gc_frame_newslot(num4393);
  int callframe4394 = gc_frame_new();
  partcv[0] = 0;
  Object call4395 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4394);
// compilenode returning call4395
// compilenode returning call4395
  params[0] = num4393;
  partcv[0] = 1;
  Object call4396 = callmethod(call4395, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4392);
// compilenode returning call4396
  int op_slot_right_4391 = gc_frame_newslot(call4396);
  if (strlit4398 == NULL) {
    strlit4398 = alloc_String("Class(");
    gc_root(strlit4398);
  }
// compilenode returning strlit4398
  int op_slot_left_4391 = gc_frame_newslot(strlit4398);
  params[0] = call4396;
  partcv[0] = 1;
  Object opresult4399 = callmethod(strlit4398, "++", 1, partcv, params);
// compilenode returning opresult4399
  int op_slot_left_4388 = gc_frame_newslot(opresult4399);
  params[0] = strlit4389;
  partcv[0] = 1;
  Object opresult4400 = callmethod(opresult4399, "++", 1, partcv, params);
// compilenode returning opresult4400
  *var_s = opresult4400;
  if (opresult4400 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 975
  setline(975);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4403 = alloc_Boolean(0);
// compilenode returning bool4403
  int op_slot_right_4402 = gc_frame_newslot(bool4403);
  int callframe4405 = gc_frame_new();
  partcv[0] = 0;
  Object call4406 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4405);
// compilenode returning call4406
// compilenode returning call4406
  int op_slot_left_4402 = gc_frame_newslot(call4406);
  params[0] = bool4403;
  partcv[0] = 1;
  Object opresult4407 = callmethod(call4406, "!=", 1, partcv, params);
// compilenode returning opresult4407
  Object if4401 = done;
  if (istrue(opresult4407)) {
// Begin line 973
  setline(973);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4409 == NULL) {
    strlit4409 = alloc_String("Superclass:");
    gc_root(strlit4409);
  }
// compilenode returning strlit4409
  int op_slot_right_4408 = gc_frame_newslot(strlit4409);
// compilenode returning *var_spc
  int op_slot_right_4411 = gc_frame_newslot(*var_spc);
  if (strlit4414 == NULL) {
    strlit4414 = alloc_String("""\x0a""");
    gc_root(strlit4414);
  }
// compilenode returning strlit4414
  int op_slot_right_4413 = gc_frame_newslot(strlit4414);
// compilenode returning *var_s
  int op_slot_left_4413 = gc_frame_newslot(*var_s);
  params[0] = strlit4414;
  partcv[0] = 1;
  Object opresult4416 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4416
  int op_slot_left_4411 = gc_frame_newslot(opresult4416);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4417 = callmethod(opresult4416, "++", 1, partcv, params);
// compilenode returning opresult4417
  int op_slot_left_4408 = gc_frame_newslot(opresult4417);
  params[0] = strlit4409;
  partcv[0] = 1;
  Object opresult4418 = callmethod(opresult4417, "++", 1, partcv, params);
// compilenode returning opresult4418
  *var_s = opresult4418;
  if (opresult4418 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 973
  setline(973);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4421 = gc_frame_new();
  Object num4423 = alloc_Float64(2);
// compilenode returning num4423
  int op_slot_right_4422 = gc_frame_newslot(num4423);
// compilenode returning *var_depth
  int op_slot_left_4422 = gc_frame_newslot(*var_depth);
  params[0] = num4423;
  partcv[0] = 1;
  Object sum4425 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum4425
  gc_frame_newslot(sum4425);
  int callframe4426 = gc_frame_new();
  partcv[0] = 0;
  Object call4427 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4426);
// compilenode returning call4427
// compilenode returning call4427
  params[0] = sum4425;
  partcv[0] = 1;
  Object call4428 = callmethod(call4427, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4421);
// compilenode returning call4428
  int op_slot_right_4420 = gc_frame_newslot(call4428);
// compilenode returning *var_spc
  int op_slot_right_4430 = gc_frame_newslot(*var_spc);
  if (strlit4433 == NULL) {
    strlit4433 = alloc_String("""\x0a""  ");
    gc_root(strlit4433);
  }
// compilenode returning strlit4433
  int op_slot_right_4432 = gc_frame_newslot(strlit4433);
// compilenode returning *var_s
  int op_slot_left_4432 = gc_frame_newslot(*var_s);
  params[0] = strlit4433;
  partcv[0] = 1;
  Object opresult4435 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4435
  int op_slot_left_4430 = gc_frame_newslot(opresult4435);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4436 = callmethod(opresult4435, "++", 1, partcv, params);
// compilenode returning opresult4436
  int op_slot_left_4420 = gc_frame_newslot(opresult4436);
  params[0] = call4428;
  partcv[0] = 1;
  Object opresult4437 = callmethod(opresult4436, "++", 1, partcv, params);
// compilenode returning opresult4437
  *var_s = opresult4437;
  if (opresult4437 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if4401 = done;
  } else {
  }
// compilenode returning if4401
// Begin line 976
  setline(976);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 975
  setline(975);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4440 == NULL) {
    strlit4440 = alloc_String("""\x0a""");
    gc_root(strlit4440);
  }
// compilenode returning strlit4440
  int op_slot_right_4439 = gc_frame_newslot(strlit4440);
// compilenode returning *var_s
  int op_slot_left_4439 = gc_frame_newslot(*var_s);
  params[0] = strlit4440;
  partcv[0] = 1;
  Object opresult4442 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4442
  *var_s = opresult4442;
  if (opresult4442 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 977
  setline(977);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 976
  setline(976);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4445 == NULL) {
    strlit4445 = alloc_String("""\x0a""");
    gc_root(strlit4445);
  }
// compilenode returning strlit4445
  int op_slot_right_4444 = gc_frame_newslot(strlit4445);
  int callframe4448 = gc_frame_new();
  int callframe4449 = gc_frame_new();
  partcv[0] = 0;
  Object call4450 = callmethodflags(self, "constructor", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4449);
// compilenode returning call4450
  partcv[0] = 0;
  Object call4451 = callmethod(call4450, "value",
    1, partcv, params);
  gc_frame_end(callframe4448);
// compilenode returning call4451
// compilenode returning call4451
  int op_slot_right_4447 = gc_frame_newslot(call4451);
  if (strlit4454 == NULL) {
    strlit4454 = alloc_String("Constructor: ");
    gc_root(strlit4454);
  }
// compilenode returning strlit4454
  int op_slot_right_4453 = gc_frame_newslot(strlit4454);
// compilenode returning *var_spc
  int op_slot_right_4456 = gc_frame_newslot(*var_spc);
  if (strlit4459 == NULL) {
    strlit4459 = alloc_String("");
    gc_root(strlit4459);
  }
// compilenode returning strlit4459
  int op_slot_right_4458 = gc_frame_newslot(strlit4459);
// compilenode returning *var_s
  int op_slot_right_4461 = gc_frame_newslot(*var_s);
  if (strlit4463 == NULL) {
    strlit4463 = alloc_String("");
    gc_root(strlit4463);
  }
// compilenode returning strlit4463
  int op_slot_left_4461 = gc_frame_newslot(strlit4463);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4464 = callmethod(strlit4463, "++", 1, partcv, params);
// compilenode returning opresult4464
  int op_slot_left_4458 = gc_frame_newslot(opresult4464);
  params[0] = strlit4459;
  partcv[0] = 1;
  Object opresult4465 = callmethod(opresult4464, "++", 1, partcv, params);
// compilenode returning opresult4465
  int op_slot_left_4456 = gc_frame_newslot(opresult4465);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4466 = callmethod(opresult4465, "++", 1, partcv, params);
// compilenode returning opresult4466
  int op_slot_left_4453 = gc_frame_newslot(opresult4466);
  params[0] = strlit4454;
  partcv[0] = 1;
  Object opresult4467 = callmethod(opresult4466, "++", 1, partcv, params);
// compilenode returning opresult4467
  int op_slot_left_4447 = gc_frame_newslot(opresult4467);
  params[0] = call4451;
  partcv[0] = 1;
  Object opresult4468 = callmethod(opresult4467, "++", 1, partcv, params);
// compilenode returning opresult4468
  int op_slot_left_4444 = gc_frame_newslot(opresult4468);
  params[0] = strlit4445;
  partcv[0] = 1;
  Object opresult4469 = callmethod(opresult4468, "++", 1, partcv, params);
// compilenode returning opresult4469
  *var_s = opresult4469;
  if (opresult4469 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 980
  setline(980);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 977
  setline(977);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4473 = gc_frame_new();
  partcv[0] = 0;
  Object call4474 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4473);
// compilenode returning call4474
  int op_slot_right_4472 = gc_frame_newslot(call4474);
  Object bool4476 = alloc_Boolean(0);
// compilenode returning bool4476
  int op_slot_left_4472 = gc_frame_newslot(bool4476);
  params[0] = call4474;
  partcv[0] = 1;
  Object opresult4477 = callmethod(bool4476, "!=", 1, partcv, params);
// compilenode returning opresult4477
  Object if4471 = done;
  if (istrue(opresult4477)) {
// Begin line 979
  setline(979);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 978
  setline(978);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4479 == NULL) {
    strlit4479 = alloc_String("""\x0a""");
    gc_root(strlit4479);
  }
// compilenode returning strlit4479
  int op_slot_right_4478 = gc_frame_newslot(strlit4479);
  int callframe4482 = gc_frame_new();
  Object num4484 = alloc_Float64(2);
// compilenode returning num4484
  int op_slot_right_4483 = gc_frame_newslot(num4484);
// compilenode returning *var_depth
  int op_slot_left_4483 = gc_frame_newslot(*var_depth);
  params[0] = num4484;
  partcv[0] = 1;
  Object sum4486 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum4486
  gc_frame_newslot(sum4486);
  int callframe4487 = gc_frame_new();
  partcv[0] = 0;
  Object call4488 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4487);
// compilenode returning call4488
  params[0] = sum4486;
  partcv[0] = 1;
  Object call4489 = callmethod(call4488, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4482);
// compilenode returning call4489
  int op_slot_right_4481 = gc_frame_newslot(call4489);
  if (strlit4492 == NULL) {
    strlit4492 = alloc_String("");
    gc_root(strlit4492);
  }
// compilenode returning strlit4492
  int op_slot_right_4491 = gc_frame_newslot(strlit4492);
// compilenode returning *var_spc
  int op_slot_right_4494 = gc_frame_newslot(*var_spc);
  if (strlit4497 == NULL) {
    strlit4497 = alloc_String("Returns:""\x0a""  ");
    gc_root(strlit4497);
  }
// compilenode returning strlit4497
  int op_slot_right_4496 = gc_frame_newslot(strlit4497);
// compilenode returning *var_spc
  int op_slot_right_4499 = gc_frame_newslot(*var_spc);
  if (strlit4502 == NULL) {
    strlit4502 = alloc_String("");
    gc_root(strlit4502);
  }
// compilenode returning strlit4502
  int op_slot_right_4501 = gc_frame_newslot(strlit4502);
// compilenode returning *var_s
  int op_slot_right_4504 = gc_frame_newslot(*var_s);
  if (strlit4506 == NULL) {
    strlit4506 = alloc_String("");
    gc_root(strlit4506);
  }
// compilenode returning strlit4506
  int op_slot_left_4504 = gc_frame_newslot(strlit4506);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4507 = callmethod(strlit4506, "++", 1, partcv, params);
// compilenode returning opresult4507
  int op_slot_left_4501 = gc_frame_newslot(opresult4507);
  params[0] = strlit4502;
  partcv[0] = 1;
  Object opresult4508 = callmethod(opresult4507, "++", 1, partcv, params);
// compilenode returning opresult4508
  int op_slot_left_4499 = gc_frame_newslot(opresult4508);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4509 = callmethod(opresult4508, "++", 1, partcv, params);
// compilenode returning opresult4509
  int op_slot_left_4496 = gc_frame_newslot(opresult4509);
  params[0] = strlit4497;
  partcv[0] = 1;
  Object opresult4510 = callmethod(opresult4509, "++", 1, partcv, params);
// compilenode returning opresult4510
  int op_slot_left_4494 = gc_frame_newslot(opresult4510);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4511 = callmethod(opresult4510, "++", 1, partcv, params);
// compilenode returning opresult4511
  int op_slot_left_4491 = gc_frame_newslot(opresult4511);
  params[0] = strlit4492;
  partcv[0] = 1;
  Object opresult4512 = callmethod(opresult4511, "++", 1, partcv, params);
// compilenode returning opresult4512
  int op_slot_left_4481 = gc_frame_newslot(opresult4512);
  params[0] = call4489;
  partcv[0] = 1;
  Object opresult4513 = callmethod(opresult4512, "++", 1, partcv, params);
// compilenode returning opresult4513
  int op_slot_left_4478 = gc_frame_newslot(opresult4513);
  params[0] = strlit4479;
  partcv[0] = 1;
  Object opresult4514 = callmethod(opresult4513, "++", 1, partcv, params);
// compilenode returning opresult4514
  *var_s = opresult4514;
  if (opresult4514 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if4471 = done;
  } else {
  }
// compilenode returning if4471
// Begin line 981
  setline(981);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 980
  setline(980);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4517 == NULL) {
    strlit4517 = alloc_String("Signature:");
    gc_root(strlit4517);
  }
// compilenode returning strlit4517
  int op_slot_right_4516 = gc_frame_newslot(strlit4517);
// compilenode returning *var_spc
  int op_slot_right_4519 = gc_frame_newslot(*var_spc);
  if (strlit4522 == NULL) {
    strlit4522 = alloc_String("");
    gc_root(strlit4522);
  }
// compilenode returning strlit4522
  int op_slot_right_4521 = gc_frame_newslot(strlit4522);
// compilenode returning *var_s
  int op_slot_right_4524 = gc_frame_newslot(*var_s);
  if (strlit4526 == NULL) {
    strlit4526 = alloc_String("");
    gc_root(strlit4526);
  }
// compilenode returning strlit4526
  int op_slot_left_4524 = gc_frame_newslot(strlit4526);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4527 = callmethod(strlit4526, "++", 1, partcv, params);
// compilenode returning opresult4527
  int op_slot_left_4521 = gc_frame_newslot(opresult4527);
  params[0] = strlit4522;
  partcv[0] = 1;
  Object opresult4528 = callmethod(opresult4527, "++", 1, partcv, params);
// compilenode returning opresult4528
  int op_slot_left_4519 = gc_frame_newslot(opresult4528);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4529 = callmethod(opresult4528, "++", 1, partcv, params);
// compilenode returning opresult4529
  int op_slot_left_4516 = gc_frame_newslot(opresult4529);
  params[0] = strlit4517;
  partcv[0] = 1;
  Object opresult4530 = callmethod(opresult4529, "++", 1, partcv, params);
// compilenode returning opresult4530
  *var_s = opresult4530;
  if (opresult4530 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 981
  setline(981);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4532 = gc_frame_new();
  int callframe4533 = gc_frame_new();
  partcv[0] = 0;
  Object call4534 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4533);
// compilenode returning call4534
  gc_frame_newslot(call4534);
  Object block4535 = alloc_Block(NULL, NULL, "ast", 981);
  gc_frame_newslot(block4535);
  block_savedest(block4535);
  Object closure4536 = createclosure(4, "_apply");
setclosureframe(closure4536, stackframe);
  addtoclosure(closure4536, var_spc);
  addtoclosure(closure4536, var_s);
  addtoclosure(closure4536, var_depth);
  addtoclosure(closure4536, selfslot);
  struct UserObject *uo4536 = (struct UserObject*)block4535;
  uo4536->data[0] = (Object)closure4536;
  Method *meth_meth_ast__apply4536 = addmethod2pos(block4535, "_apply", &meth_ast__apply4536, 0);
int argcv_meth_ast__apply4536[] = {1};
meth_meth_ast__apply4536->type = alloc_MethodType(1, argcv_meth_ast__apply4536);
  meth_meth_ast__apply4536->definitionModule = modulename;
  meth_meth_ast__apply4536->definitionLine = 976;
// compilenode returning block4535
  gc_frame_newslot(block4535);
  params[0] = call4534;
  params[1] = block4535;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4653 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4532);
// compilenode returning call4653
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 991
  setline(991);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4656 = gc_frame_new();
  partcv[0] = 0;
  Object call4657 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4656);
// compilenode returning call4657
  int op_slot_right_4655 = gc_frame_newslot(call4657);
  Object bool4659 = alloc_Boolean(0);
// compilenode returning bool4659
  int op_slot_left_4655 = gc_frame_newslot(bool4659);
  params[0] = call4657;
  partcv[0] = 1;
  Object opresult4660 = callmethod(bool4659, "!=", 1, partcv, params);
// compilenode returning opresult4660
  Object if4654 = done;
  if (istrue(opresult4660)) {
// Begin line 993
  setline(993);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 992
  setline(992);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4662 == NULL) {
    strlit4662 = alloc_String("Generics:");
    gc_root(strlit4662);
  }
// compilenode returning strlit4662
  int op_slot_right_4661 = gc_frame_newslot(strlit4662);
// compilenode returning *var_spc
  int op_slot_right_4664 = gc_frame_newslot(*var_spc);
  if (strlit4667 == NULL) {
    strlit4667 = alloc_String("""\x0a""");
    gc_root(strlit4667);
  }
// compilenode returning strlit4667
  int op_slot_right_4666 = gc_frame_newslot(strlit4667);
// compilenode returning *var_s
  int op_slot_left_4666 = gc_frame_newslot(*var_s);
  params[0] = strlit4667;
  partcv[0] = 1;
  Object opresult4669 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4669
  int op_slot_left_4664 = gc_frame_newslot(opresult4669);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4670 = callmethod(opresult4669, "++", 1, partcv, params);
// compilenode returning opresult4670
  int op_slot_left_4661 = gc_frame_newslot(opresult4670);
  params[0] = strlit4662;
  partcv[0] = 1;
  Object opresult4671 = callmethod(opresult4670, "++", 1, partcv, params);
// compilenode returning opresult4671
  *var_s = opresult4671;
  if (opresult4671 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 993
  setline(993);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4673 = gc_frame_new();
  int callframe4674 = gc_frame_new();
  partcv[0] = 0;
  Object call4675 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4674);
// compilenode returning call4675
  gc_frame_newslot(call4675);
  Object block4676 = alloc_Block(NULL, NULL, "ast", 993);
  gc_frame_newslot(block4676);
  block_savedest(block4676);
  Object closure4677 = createclosure(3, "_apply");
setclosureframe(closure4677, stackframe);
  addtoclosure(closure4677, var_spc);
  addtoclosure(closure4677, var_s);
  addtoclosure(closure4677, selfslot);
  struct UserObject *uo4677 = (struct UserObject*)block4676;
  uo4677->data[0] = (Object)closure4677;
  Method *meth_meth_ast__apply4677 = addmethod2pos(block4676, "_apply", &meth_ast__apply4677, 0);
int argcv_meth_ast__apply4677[] = {1};
meth_meth_ast__apply4677->type = alloc_MethodType(1, argcv_meth_ast__apply4677);
  meth_meth_ast__apply4677->definitionModule = modulename;
  meth_meth_ast__apply4677->definitionLine = 988;
// compilenode returning block4676
  gc_frame_newslot(block4676);
  params[0] = call4675;
  params[1] = block4676;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4701 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4673);
// compilenode returning call4701
    gc_frame_newslot(call4701);
    if4654 = call4701;
  } else {
  }
// compilenode returning if4654
// Begin line 1003
  setline(1003);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num4704 = alloc_Float64(0);
// compilenode returning num4704
  int op_slot_right_4703 = gc_frame_newslot(num4704);
  int callframe4706 = gc_frame_new();
  int callframe4707 = gc_frame_new();
  partcv[0] = 0;
  Object call4708 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4707);
// compilenode returning call4708
  partcv[0] = 0;
  Object call4709 = callmethod(call4708, "size",
    1, partcv, params);
  gc_frame_end(callframe4706);
// compilenode returning call4709
// compilenode returning call4709
  int op_slot_left_4703 = gc_frame_newslot(call4709);
  params[0] = num4704;
  partcv[0] = 1;
  Object opresult4710 = callmethod(call4709, ">", 1, partcv, params);
// compilenode returning opresult4710
  Object if4702 = done;
  if (istrue(opresult4710)) {
// Begin line 999
  setline(999);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 998
  setline(998);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4712 == NULL) {
    strlit4712 = alloc_String("Annotations:");
    gc_root(strlit4712);
  }
// compilenode returning strlit4712
  int op_slot_right_4711 = gc_frame_newslot(strlit4712);
// compilenode returning *var_spc
  int op_slot_right_4714 = gc_frame_newslot(*var_spc);
  if (strlit4717 == NULL) {
    strlit4717 = alloc_String("""\x0a""");
    gc_root(strlit4717);
  }
// compilenode returning strlit4717
  int op_slot_right_4716 = gc_frame_newslot(strlit4717);
// compilenode returning *var_s
  int op_slot_left_4716 = gc_frame_newslot(*var_s);
  params[0] = strlit4717;
  partcv[0] = 1;
  Object opresult4719 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4719
  int op_slot_left_4714 = gc_frame_newslot(opresult4719);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4720 = callmethod(opresult4719, "++", 1, partcv, params);
// compilenode returning opresult4720
  int op_slot_left_4711 = gc_frame_newslot(opresult4720);
  params[0] = strlit4712;
  partcv[0] = 1;
  Object opresult4721 = callmethod(opresult4720, "++", 1, partcv, params);
// compilenode returning opresult4721
  *var_s = opresult4721;
  if (opresult4721 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 999
  setline(999);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4723 = gc_frame_new();
  int callframe4724 = gc_frame_new();
  partcv[0] = 0;
  Object call4725 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4724);
// compilenode returning call4725
  gc_frame_newslot(call4725);
  Object block4726 = alloc_Block(NULL, NULL, "ast", 999);
  gc_frame_newslot(block4726);
  block_savedest(block4726);
  Object closure4727 = createclosure(4, "_apply");
setclosureframe(closure4727, stackframe);
  addtoclosure(closure4727, var_depth);
  addtoclosure(closure4727, var_spc);
  addtoclosure(closure4727, var_s);
  addtoclosure(closure4727, selfslot);
  struct UserObject *uo4727 = (struct UserObject*)block4726;
  uo4727->data[0] = (Object)closure4727;
  Method *meth_meth_ast__apply4727 = addmethod2pos(block4726, "_apply", &meth_ast__apply4727, 0);
int argcv_meth_ast__apply4727[] = {1};
meth_meth_ast__apply4727->type = alloc_MethodType(1, argcv_meth_ast__apply4727);
  meth_meth_ast__apply4727->definitionModule = modulename;
  meth_meth_ast__apply4727->definitionLine = 997;
// compilenode returning block4726
  gc_frame_newslot(block4726);
  params[0] = call4725;
  params[1] = block4726;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4754 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4723);
// compilenode returning call4754
    gc_frame_newslot(call4754);
    if4702 = call4754;
  } else {
  }
// compilenode returning if4702
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1003
  setline(1003);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4756 == NULL) {
    strlit4756 = alloc_String("Body:");
    gc_root(strlit4756);
  }
// compilenode returning strlit4756
  int op_slot_right_4755 = gc_frame_newslot(strlit4756);
// compilenode returning *var_spc
  int op_slot_right_4758 = gc_frame_newslot(*var_spc);
  if (strlit4761 == NULL) {
    strlit4761 = alloc_String("""\x0a""");
    gc_root(strlit4761);
  }
// compilenode returning strlit4761
  int op_slot_right_4760 = gc_frame_newslot(strlit4761);
// compilenode returning *var_s
  int op_slot_left_4760 = gc_frame_newslot(*var_s);
  params[0] = strlit4761;
  partcv[0] = 1;
  Object opresult4763 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4763
  int op_slot_left_4758 = gc_frame_newslot(opresult4763);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4764 = callmethod(opresult4763, "++", 1, partcv, params);
// compilenode returning opresult4764
  int op_slot_left_4755 = gc_frame_newslot(opresult4764);
  params[0] = strlit4756;
  partcv[0] = 1;
  Object opresult4765 = callmethod(opresult4764, "++", 1, partcv, params);
// compilenode returning opresult4765
  *var_s = opresult4765;
  if (opresult4765 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4767 = gc_frame_new();
  int callframe4768 = gc_frame_new();
  partcv[0] = 0;
  Object call4769 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4768);
// compilenode returning call4769
// compilenode returning call4769
  gc_frame_newslot(call4769);
  Object block4770 = alloc_Block(NULL, NULL, "ast", 1004);
  gc_frame_newslot(block4770);
  block_savedest(block4770);
  Object closure4771 = createclosure(4, "_apply");
setclosureframe(closure4771, stackframe);
  addtoclosure(closure4771, var_depth);
  addtoclosure(closure4771, var_spc);
  addtoclosure(closure4771, var_s);
  addtoclosure(closure4771, selfslot);
  struct UserObject *uo4771 = (struct UserObject*)block4770;
  uo4771->data[0] = (Object)closure4771;
  Method *meth_meth_ast__apply4771 = addmethod2pos(block4770, "_apply", &meth_ast__apply4771, 0);
int argcv_meth_ast__apply4771[] = {1};
meth_meth_ast__apply4771->type = alloc_MethodType(1, argcv_meth_ast__apply4771);
  meth_meth_ast__apply4771->definitionModule = modulename;
  meth_meth_ast__apply4771->definitionLine = 1004;
// compilenode returning block4770
  gc_frame_newslot(block4770);
  params[0] = call4769;
  params[1] = block4770;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4790 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4767);
// compilenode returning call4790
// Begin line 1007
  setline(1007);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply4803(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1013
  setline(1013);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1012
  setline(1012);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4805 == NULL) {
    strlit4805 = alloc_String("    ");
    gc_root(strlit4805);
  }
// compilenode returning strlit4805
  int op_slot_right_4804 = gc_frame_newslot(strlit4805);
// compilenode returning *var_spc
  int op_slot_left_4804 = gc_frame_newslot(*var_spc);
  params[0] = strlit4805;
  partcv[0] = 1;
  Object opresult4807 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult4807
  *var_spc = opresult4807;
  if (opresult4807 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4878(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_part = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_pnr = &(stackframe->slots[0]);
  *var_pnr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 1024
  setline(1024);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1023
  setline(1023);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4879 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4880 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4879);
// compilenode returning call4880
// compilenode returning call4880
// compilenode returning *var_pnr
  params[0] = *var_pnr;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres4881 = callmethod(call4880, "[]", 1, partcv, params);
// compilenode returning idxres4881
  *var_p = idxres4881;
  if (idxres4881 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1024
  setline(1024);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4883 = gc_frame_new();
  Object num4885 = alloc_Float64(1);
// compilenode returning num4885
  int op_slot_right_4884 = gc_frame_newslot(num4885);
// compilenode returning *var_depth
  int op_slot_left_4884 = gc_frame_newslot(*var_depth);
  params[0] = num4885;
  partcv[0] = 1;
  Object sum4887 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum4887
  gc_frame_newslot(sum4887);
// compilenode returning *var_p
  params[0] = sum4887;
  partcv[0] = 1;
  Object call4888 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4883);
// compilenode returning call4888
  int op_slot_right_4882 = gc_frame_newslot(call4888);
// compilenode returning *var_s
  int op_slot_left_4882 = gc_frame_newslot(*var_s);
  params[0] = call4888;
  partcv[0] = 1;
  Object opresult4890 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4890
  *var_s = opresult4890;
  if (opresult4890 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1028
  setline(1028);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1025
  setline(1025);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4895 = alloc_Boolean(0);
// compilenode returning bool4895
  int op_slot_right_4894 = gc_frame_newslot(bool4895);
  int callframe4897 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4898 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4897);
// compilenode returning call4898
// compilenode returning call4898
  int op_slot_left_4894 = gc_frame_newslot(call4898);
  params[0] = bool4895;
  partcv[0] = 1;
  Object opresult4899 = callmethod(call4898, "!=", 1, partcv, params);
// compilenode returning opresult4899
  int op_slot_right_4893 = gc_frame_newslot(opresult4899);
  int callframe4902 = gc_frame_new();
  int callframe4903 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4904 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4903);
// compilenode returning call4904
// compilenode returning call4904
  partcv[0] = 0;
  Object call4905 = callmethod(call4904, "size",
    1, partcv, params);
  gc_frame_end(callframe4902);
// compilenode returning call4905
// compilenode returning call4905
  int op_slot_right_4901 = gc_frame_newslot(call4905);
// compilenode returning *var_pnr
  int op_slot_left_4901 = gc_frame_newslot(*var_pnr);
  params[0] = call4905;
  partcv[0] = 1;
  Object opresult4907 = callmethod(*var_pnr, "<", 1, partcv, params);
// compilenode returning opresult4907
  int op_slot_left_4893 = gc_frame_newslot(opresult4907);
  params[0] = opresult4899;
  partcv[0] = 1;
  Object opresult4908 = callmethod(opresult4907, "||", 1, partcv, params);
// compilenode returning opresult4908
  Object if4892 = done;
  if (istrue(opresult4908)) {
// Begin line 1027
  setline(1027);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1026
  setline(1026);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4910 == NULL) {
    strlit4910 = alloc_String(", ");
    gc_root(strlit4910);
  }
// compilenode returning strlit4910
  int op_slot_right_4909 = gc_frame_newslot(strlit4910);
// compilenode returning *var_s
  int op_slot_left_4909 = gc_frame_newslot(*var_s);
  params[0] = strlit4910;
  partcv[0] = 1;
  Object opresult4912 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4912
  *var_s = opresult4912;
  if (opresult4912 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if4892 = done;
  } else {
  }
// compilenode returning if4892
  gc_frame_end(frame);
  return if4892;
}
Object meth_ast__apply4842(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1020
  setline(1020);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1019
  setline(1019);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4844 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4845 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe4844);
// compilenode returning call4845
// compilenode returning call4845
  int op_slot_right_4843 = gc_frame_newslot(call4845);
// compilenode returning *var_s
  int op_slot_left_4843 = gc_frame_newslot(*var_s);
  params[0] = call4845;
  partcv[0] = 1;
  Object opresult4847 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4847
  *var_s = opresult4847;
  if (opresult4847 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1034
  setline(1034);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1020
  setline(1020);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4852 = alloc_Boolean(0);
// compilenode returning bool4852
  int op_slot_right_4851 = gc_frame_newslot(bool4852);
  int callframe4854 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4855 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4854);
// compilenode returning call4855
// compilenode returning call4855
  int op_slot_left_4851 = gc_frame_newslot(call4855);
  params[0] = bool4852;
  partcv[0] = 1;
  Object opresult4856 = callmethod(call4855, "!=", 1, partcv, params);
// compilenode returning opresult4856
  int op_slot_right_4850 = gc_frame_newslot(opresult4856);
  Object num4859 = alloc_Float64(0);
// compilenode returning num4859
  int op_slot_right_4858 = gc_frame_newslot(num4859);
  int callframe4861 = gc_frame_new();
  int callframe4862 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4863 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4862);
// compilenode returning call4863
// compilenode returning call4863
  partcv[0] = 0;
  Object call4864 = callmethod(call4863, "size",
    1, partcv, params);
  gc_frame_end(callframe4861);
// compilenode returning call4864
// compilenode returning call4864
  int op_slot_left_4858 = gc_frame_newslot(call4864);
  params[0] = num4859;
  partcv[0] = 1;
  Object opresult4865 = callmethod(call4864, ">", 1, partcv, params);
// compilenode returning opresult4865
  int op_slot_left_4850 = gc_frame_newslot(opresult4865);
  params[0] = opresult4856;
  partcv[0] = 1;
  Object opresult4866 = callmethod(opresult4865, "||", 1, partcv, params);
// compilenode returning opresult4866
  Object if4849 = done;
  if (istrue(opresult4866)) {
// Begin line 1022
  setline(1022);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1021
  setline(1021);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4868 == NULL) {
    strlit4868 = alloc_String("(");
    gc_root(strlit4868);
  }
// compilenode returning strlit4868
  int op_slot_right_4867 = gc_frame_newslot(strlit4868);
// compilenode returning *var_s
  int op_slot_left_4867 = gc_frame_newslot(*var_s);
  params[0] = strlit4868;
  partcv[0] = 1;
  Object opresult4870 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4870
  *var_s = opresult4870;
  if (opresult4870 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1022
  setline(1022);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4872 = gc_frame_new();
  int callframe4873 = gc_frame_new();
  int callframe4874 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4875 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4874);
// compilenode returning call4875
// compilenode returning call4875
  partcv[0] = 0;
  Object call4876 = callmethod(call4875, "indices",
    1, partcv, params);
  gc_frame_end(callframe4873);
// compilenode returning call4876
// compilenode returning call4876
  gc_frame_newslot(call4876);
  Object block4877 = alloc_Block(NULL, NULL, "ast", 1022);
  gc_frame_newslot(block4877);
  block_savedest(block4877);
  Object closure4878 = createclosure(4, "_apply");
setclosureframe(closure4878, stackframe);
  addtoclosure(closure4878, var_part);
  addtoclosure(closure4878, var_depth);
  addtoclosure(closure4878, var_s);
  addtoclosure(closure4878, selfslot);
  struct UserObject *uo4878 = (struct UserObject*)block4877;
  uo4878->data[0] = (Object)closure4878;
  Method *meth_meth_ast__apply4878 = addmethod2pos(block4877, "_apply", &meth_ast__apply4878, 0);
int argcv_meth_ast__apply4878[] = {1};
meth_meth_ast__apply4878->type = alloc_MethodType(1, argcv_meth_ast__apply4878);
  meth_meth_ast__apply4878->definitionModule = modulename;
  meth_meth_ast__apply4878->definitionLine = 1022;
// compilenode returning block4877
  gc_frame_newslot(block4877);
  params[0] = call4876;
  params[1] = block4877;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4915 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4872);
// compilenode returning call4915
// Begin line 1032
  setline(1032);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1029
  setline(1029);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4918 = alloc_Boolean(0);
// compilenode returning bool4918
  int op_slot_right_4917 = gc_frame_newslot(bool4918);
  int callframe4920 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4921 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4920);
// compilenode returning call4921
// compilenode returning call4921
  int op_slot_left_4917 = gc_frame_newslot(call4921);
  params[0] = bool4918;
  partcv[0] = 1;
  Object opresult4922 = callmethod(call4921, "!=", 1, partcv, params);
// compilenode returning opresult4922
  Object if4916 = done;
  if (istrue(opresult4922)) {
// Begin line 1031
  setline(1031);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1030
  setline(1030);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4924 = gc_frame_new();
  int callframe4925 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4926 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4925);
// compilenode returning call4926
// compilenode returning call4926
  partcv[0] = 0;
  Object call4927 = callmethod(call4926, "value",
    1, partcv, params);
  gc_frame_end(callframe4924);
// compilenode returning call4927
// compilenode returning call4927
  int op_slot_right_4923 = gc_frame_newslot(call4927);
  if (strlit4930 == NULL) {
    strlit4930 = alloc_String("*");
    gc_root(strlit4930);
  }
// compilenode returning strlit4930
  int op_slot_right_4929 = gc_frame_newslot(strlit4930);
// compilenode returning *var_s
  int op_slot_left_4929 = gc_frame_newslot(*var_s);
  params[0] = strlit4930;
  partcv[0] = 1;
  Object opresult4932 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4932
  int op_slot_left_4923 = gc_frame_newslot(opresult4932);
  params[0] = call4927;
  partcv[0] = 1;
  Object opresult4933 = callmethod(opresult4932, "++", 1, partcv, params);
// compilenode returning opresult4933
  *var_s = opresult4933;
  if (opresult4933 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if4916 = done;
  } else {
  }
// compilenode returning if4916
// Begin line 1033
  setline(1033);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1032
  setline(1032);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4936 == NULL) {
    strlit4936 = alloc_String(")");
    gc_root(strlit4936);
  }
// compilenode returning strlit4936
  int op_slot_right_4935 = gc_frame_newslot(strlit4936);
// compilenode returning *var_s
  int op_slot_left_4935 = gc_frame_newslot(*var_s);
  params[0] = strlit4936;
  partcv[0] = 1;
  Object opresult4938 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4938
  *var_s = opresult4938;
  if (opresult4938 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if4849 = done;
  } else {
  }
// compilenode returning if4849
  gc_frame_end(frame);
  return if4849;
}
Object meth_ast__apply4982(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1041
  setline(1041);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4984 = gc_frame_new();
  Object num4986 = alloc_Float64(1);
// compilenode returning num4986
  int op_slot_right_4985 = gc_frame_newslot(num4986);
// compilenode returning *var_depth
  int op_slot_left_4985 = gc_frame_newslot(*var_depth);
  params[0] = num4986;
  partcv[0] = 1;
  Object sum4988 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum4988
  gc_frame_newslot(sum4988);
// compilenode returning *var_mx
  params[0] = sum4988;
  partcv[0] = 1;
  Object call4989 = callmethod(*var_mx, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4984);
// compilenode returning call4989
  int op_slot_right_4983 = gc_frame_newslot(call4989);
  if (strlit4992 == NULL) {
    strlit4992 = alloc_String("    ");
    gc_root(strlit4992);
  }
// compilenode returning strlit4992
  int op_slot_right_4991 = gc_frame_newslot(strlit4992);
// compilenode returning *var_spc
  int op_slot_right_4994 = gc_frame_newslot(*var_spc);
  if (strlit4997 == NULL) {
    strlit4997 = alloc_String("""\x0a""");
    gc_root(strlit4997);
  }
// compilenode returning strlit4997
  int op_slot_right_4996 = gc_frame_newslot(strlit4997);
// compilenode returning *var_s
  int op_slot_left_4996 = gc_frame_newslot(*var_s);
  params[0] = strlit4997;
  partcv[0] = 1;
  Object opresult4999 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4999
  int op_slot_left_4994 = gc_frame_newslot(opresult4999);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5000 = callmethod(opresult4999, "++", 1, partcv, params);
// compilenode returning opresult5000
  int op_slot_left_4991 = gc_frame_newslot(opresult5000);
  params[0] = strlit4992;
  partcv[0] = 1;
  Object opresult5001 = callmethod(opresult5000, "++", 1, partcv, params);
// compilenode returning opresult5001
  int op_slot_left_4983 = gc_frame_newslot(opresult5001);
  params[0] = call4989;
  partcv[0] = 1;
  Object opresult5002 = callmethod(opresult5001, "++", 1, partcv, params);
// compilenode returning opresult5002
  *var_s = opresult5002;
  if (opresult5002 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace4791(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1011
  setline(1011);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1010
  setline(1010);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4792 == NULL) {
    strlit4792 = alloc_String("");
    gc_root(strlit4792);
  }
// compilenode returning strlit4792
  *var_spc = strlit4792;
  if (strlit4792 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1011
  setline(1011);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4793 = gc_frame_new();
  Object num4796 = alloc_Float64(1);
// compilenode returning num4796
  int op_slot_right_4795 = gc_frame_newslot(num4796);
// compilenode returning *var_depth
  int op_slot_left_4795 = gc_frame_newslot(*var_depth);
  params[0] = num4796;
  partcv[0] = 1;
  Object diff4798 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff4798
  int op_slot_right_4794 = gc_frame_newslot(diff4798);
  Object num4800 = alloc_Float64(0);
// compilenode returning num4800
  int op_slot_left_4794 = gc_frame_newslot(num4800);
  params[0] = diff4798;
  partcv[0] = 1;
  Object opresult4801 = callmethod(num4800, "..", 1, partcv, params);
// compilenode returning opresult4801
  gc_frame_newslot(opresult4801);
  Object block4802 = alloc_Block(NULL, NULL, "ast", 1011);
  gc_frame_newslot(block4802);
  block_savedest(block4802);
  Object closure4803 = createclosure(2, "_apply");
setclosureframe(closure4803, stackframe);
  addtoclosure(closure4803, var_spc);
  addtoclosure(closure4803, selfslot);
  struct UserObject *uo4803 = (struct UserObject*)block4802;
  uo4803->data[0] = (Object)closure4803;
  Method *meth_meth_ast__apply4803 = addmethod2pos(block4802, "_apply", &meth_ast__apply4803, 0);
int argcv_meth_ast__apply4803[] = {1};
meth_meth_ast__apply4803->type = alloc_MethodType(1, argcv_meth_ast__apply4803);
  meth_meth_ast__apply4803->definitionModule = modulename;
  meth_meth_ast__apply4803->definitionLine = 1004;
// compilenode returning block4802
  gc_frame_newslot(block4802);
  params[0] = opresult4801;
  params[1] = block4802;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4810 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4793);
// compilenode returning call4810
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1014
  setline(1014);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4812 == NULL) {
    strlit4812 = alloc_String("");
    gc_root(strlit4812);
  }
// compilenode returning strlit4812
  int op_slot_right_4811 = gc_frame_newslot(strlit4812);
  int callframe4815 = gc_frame_new();
  Object num4816 = alloc_Float64(0);
// compilenode returning num4816
  gc_frame_newslot(num4816);
  int callframe4817 = gc_frame_new();
  partcv[0] = 0;
  Object call4818 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4817);
// compilenode returning call4818
// compilenode returning call4818
  params[0] = num4816;
  partcv[0] = 1;
  Object call4819 = callmethod(call4818, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4815);
// compilenode returning call4819
  int op_slot_right_4814 = gc_frame_newslot(call4819);
  if (strlit4821 == NULL) {
    strlit4821 = alloc_String("class ");
    gc_root(strlit4821);
  }
// compilenode returning strlit4821
  int op_slot_left_4814 = gc_frame_newslot(strlit4821);
  params[0] = call4819;
  partcv[0] = 1;
  Object opresult4822 = callmethod(strlit4821, "++", 1, partcv, params);
// compilenode returning opresult4822
  int op_slot_left_4811 = gc_frame_newslot(opresult4822);
  params[0] = strlit4812;
  partcv[0] = 1;
  Object opresult4823 = callmethod(opresult4822, "++", 1, partcv, params);
// compilenode returning opresult4823
  *var_s = opresult4823;
  if (opresult4823 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1036
  setline(1036);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4826 == NULL) {
    strlit4826 = alloc_String("generic");
    gc_root(strlit4826);
  }
// compilenode returning strlit4826
  int op_slot_right_4825 = gc_frame_newslot(strlit4826);
  int callframe4828 = gc_frame_new();
  int callframe4829 = gc_frame_new();
  partcv[0] = 0;
  Object call4830 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4829);
// compilenode returning call4830
// compilenode returning call4830
  partcv[0] = 0;
  Object call4831 = callmethod(call4830, "kind",
    1, partcv, params);
  gc_frame_end(callframe4828);
// compilenode returning call4831
// compilenode returning call4831
  int op_slot_left_4825 = gc_frame_newslot(call4831);
  params[0] = strlit4826;
  partcv[0] = 1;
  Object opresult4832 = callmethod(call4831, "!=", 1, partcv, params);
// compilenode returning opresult4832
  Object if4824 = done;
  if (istrue(opresult4832)) {
// Begin line 1018
  setline(1018);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1017
  setline(1017);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4834 == NULL) {
    strlit4834 = alloc_String(".");
    gc_root(strlit4834);
  }
// compilenode returning strlit4834
  int op_slot_right_4833 = gc_frame_newslot(strlit4834);
// compilenode returning *var_s
  int op_slot_left_4833 = gc_frame_newslot(*var_s);
  params[0] = strlit4834;
  partcv[0] = 1;
  Object opresult4836 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4836
  *var_s = opresult4836;
  if (opresult4836 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1018
  setline(1018);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4838 = gc_frame_new();
  int callframe4839 = gc_frame_new();
  partcv[0] = 0;
  Object call4840 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4839);
// compilenode returning call4840
// compilenode returning call4840
  gc_frame_newslot(call4840);
  Object block4841 = alloc_Block(NULL, NULL, "ast", 1018);
  gc_frame_newslot(block4841);
  block_savedest(block4841);
  Object closure4842 = createclosure(3, "_apply");
setclosureframe(closure4842, stackframe);
  addtoclosure(closure4842, var_s);
  addtoclosure(closure4842, var_depth);
  addtoclosure(closure4842, selfslot);
  struct UserObject *uo4842 = (struct UserObject*)block4841;
  uo4842->data[0] = (Object)closure4842;
  Method *meth_meth_ast__apply4842 = addmethod2pos(block4841, "_apply", &meth_ast__apply4842, 0);
int argcv_meth_ast__apply4842[] = {1};
meth_meth_ast__apply4842->type = alloc_MethodType(1, argcv_meth_ast__apply4842);
  meth_meth_ast__apply4842->definitionModule = modulename;
  meth_meth_ast__apply4842->definitionLine = 1018;
// compilenode returning block4841
  gc_frame_newslot(block4841);
  params[0] = call4840;
  params[1] = block4841;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4941 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4838);
// compilenode returning call4941
    gc_frame_newslot(call4941);
    if4824 = call4941;
  } else {
  }
// compilenode returning if4824
// Begin line 1039
  setline(1039);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1036
  setline(1036);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4944 = gc_frame_new();
  partcv[0] = 0;
  Object call4945 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4944);
// compilenode returning call4945
  int op_slot_right_4943 = gc_frame_newslot(call4945);
  Object bool4947 = alloc_Boolean(0);
// compilenode returning bool4947
  int op_slot_left_4943 = gc_frame_newslot(bool4947);
  params[0] = call4945;
  partcv[0] = 1;
  Object opresult4948 = callmethod(bool4947, "!=", 1, partcv, params);
// compilenode returning opresult4948
  Object if4942 = done;
  if (istrue(opresult4948)) {
// Begin line 1038
  setline(1038);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1037
  setline(1037);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4950 == NULL) {
    strlit4950 = alloc_String("");
    gc_root(strlit4950);
  }
// compilenode returning strlit4950
  int op_slot_right_4949 = gc_frame_newslot(strlit4950);
  int callframe4953 = gc_frame_new();
  Object num4955 = alloc_Float64(1);
// compilenode returning num4955
  int op_slot_right_4954 = gc_frame_newslot(num4955);
// compilenode returning *var_depth
  int op_slot_left_4954 = gc_frame_newslot(*var_depth);
  params[0] = num4955;
  partcv[0] = 1;
  Object sum4957 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum4957
  gc_frame_newslot(sum4957);
  int callframe4958 = gc_frame_new();
  partcv[0] = 0;
  Object call4959 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4958);
// compilenode returning call4959
  params[0] = sum4957;
  partcv[0] = 1;
  Object call4960 = callmethod(call4959, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4953);
// compilenode returning call4960
  int op_slot_right_4952 = gc_frame_newslot(call4960);
  if (strlit4963 == NULL) {
    strlit4963 = alloc_String(" -> ");
    gc_root(strlit4963);
  }
// compilenode returning strlit4963
  int op_slot_right_4962 = gc_frame_newslot(strlit4963);
// compilenode returning *var_s
  int op_slot_right_4965 = gc_frame_newslot(*var_s);
  if (strlit4967 == NULL) {
    strlit4967 = alloc_String("");
    gc_root(strlit4967);
  }
// compilenode returning strlit4967
  int op_slot_left_4965 = gc_frame_newslot(strlit4967);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4968 = callmethod(strlit4967, "++", 1, partcv, params);
// compilenode returning opresult4968
  int op_slot_left_4962 = gc_frame_newslot(opresult4968);
  params[0] = strlit4963;
  partcv[0] = 1;
  Object opresult4969 = callmethod(opresult4968, "++", 1, partcv, params);
// compilenode returning opresult4969
  int op_slot_left_4952 = gc_frame_newslot(opresult4969);
  params[0] = call4960;
  partcv[0] = 1;
  Object opresult4970 = callmethod(opresult4969, "++", 1, partcv, params);
// compilenode returning opresult4970
  int op_slot_left_4949 = gc_frame_newslot(opresult4970);
  params[0] = strlit4950;
  partcv[0] = 1;
  Object opresult4971 = callmethod(opresult4970, "++", 1, partcv, params);
// compilenode returning opresult4971
  *var_s = opresult4971;
  if (opresult4971 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if4942 = done;
  } else {
  }
// compilenode returning if4942
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1039
  setline(1039);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4974 == NULL) {
    strlit4974 = alloc_String(" {");
    gc_root(strlit4974);
  }
// compilenode returning strlit4974
  int op_slot_right_4973 = gc_frame_newslot(strlit4974);
// compilenode returning *var_s
  int op_slot_left_4973 = gc_frame_newslot(*var_s);
  params[0] = strlit4974;
  partcv[0] = 1;
  Object opresult4976 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4976
  *var_s = opresult4976;
  if (opresult4976 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4978 = gc_frame_new();
  int callframe4979 = gc_frame_new();
  partcv[0] = 0;
  Object call4980 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4979);
// compilenode returning call4980
// compilenode returning call4980
  gc_frame_newslot(call4980);
  Object block4981 = alloc_Block(NULL, NULL, "ast", 1040);
  gc_frame_newslot(block4981);
  block_savedest(block4981);
  Object closure4982 = createclosure(4, "_apply");
setclosureframe(closure4982, stackframe);
  addtoclosure(closure4982, var_depth);
  addtoclosure(closure4982, var_spc);
  addtoclosure(closure4982, var_s);
  addtoclosure(closure4982, selfslot);
  struct UserObject *uo4982 = (struct UserObject*)block4981;
  uo4982->data[0] = (Object)closure4982;
  Method *meth_meth_ast__apply4982 = addmethod2pos(block4981, "_apply", &meth_ast__apply4982, 0);
int argcv_meth_ast__apply4982[] = {1};
meth_meth_ast__apply4982->type = alloc_MethodType(1, argcv_meth_ast__apply4982);
  meth_meth_ast__apply4982->definitionModule = modulename;
  meth_meth_ast__apply4982->definitionLine = 1040;
// compilenode returning block4981
  gc_frame_newslot(block4981);
  params[0] = call4980;
  params[1] = block4981;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5005 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4978);
// compilenode returning call5005
// Begin line 1044
  setline(1044);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1043
  setline(1043);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5007 == NULL) {
    strlit5007 = alloc_String("}");
    gc_root(strlit5007);
  }
// compilenode returning strlit5007
  int op_slot_right_5006 = gc_frame_newslot(strlit5007);
// compilenode returning *var_spc
  int op_slot_right_5009 = gc_frame_newslot(*var_spc);
  if (strlit5012 == NULL) {
    strlit5012 = alloc_String("""\x0a""");
    gc_root(strlit5012);
  }
// compilenode returning strlit5012
  int op_slot_right_5011 = gc_frame_newslot(strlit5012);
// compilenode returning *var_s
  int op_slot_left_5011 = gc_frame_newslot(*var_s);
  params[0] = strlit5012;
  partcv[0] = 1;
  Object opresult5014 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5014
  int op_slot_left_5009 = gc_frame_newslot(opresult5014);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5015 = callmethod(opresult5014, "++", 1, partcv, params);
// compilenode returning opresult5015
  int op_slot_left_5006 = gc_frame_newslot(opresult5015);
  params[0] = strlit5007;
  partcv[0] = 1;
  Object opresult5016 = callmethod(opresult5015, "++", 1, partcv, params);
// compilenode returning opresult5016
  *var_s = opresult5016;
  if (opresult5016 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1044
  setline(1044);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new4225(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 6)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_classNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  Object *var_collections = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[2]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[3]);
  *var_superclass_39_ = args[curarg];
  curarg++;
  Object *var_constructor_39_ = &(stackframe->slots[4]);
  *var_constructor_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[5]);
  *var_dtype_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 6)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[6]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4226 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4226 = alloc_userobj2(21,18, objclass4226);
  gc_frame_newslot(obj4226);
if (objclass4226 == NULL) {
  glfree(obj4226->class->name);
  obj4226->class->name = "classNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4226, self, 0);
  addmethodreal(obj4226,"outer", &reader_ast_outer_4227);
  Object oldself4226 = self;
  struct StackFrameObject *oldstackframe4226 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4226);
  gc_frame_newslot((Object)stackframe);
  self = obj4226;
  Object *oldselfslot4226 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4226 = (*(struct UserObject *)self).data[0], lowerouter4226 = thisouter4226;
  if (inheritingObject4226) {
    struct UserObject *inho4226 = (struct UserObject *)inheritingObject4226;
    while (inho4226->super != GraceDefaultObject) inho4226 = (struct UserObject *)inho4226->super;
    inho4226->super = obj4226;
    self = inheritingObject4226;
    *selfslot = self;
    lowerouter4226 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4226;
  }
if (objclass4226 == NULL) {
  Method *reader4228 = addmethodrealflags(obj4226, "kind",&reader_ast_kind_4228, MFLAG_DEF);
  reader4228->definitionModule = modulename;
  reader4228->definitionLine = 919;
}
adddatum2(obj4226, alloc_Undefined(), 1);
if (objclass4226 == NULL) {
  Method *reader4229 = addmethodrealflags(obj4226, "value",&reader_ast_value_4229, MFLAG_DEF);
  reader4229->definitionModule = modulename;
  reader4229->definitionLine = 920;
}
adddatum2(obj4226, alloc_Undefined(), 2);
if (objclass4226 == NULL) {
  Method *reader4230 = addmethodrealflags(obj4226, "name",&reader_ast_name_4230, MFLAG_DEF);
  reader4230->definitionModule = modulename;
  reader4230->definitionLine = 921;
}
adddatum2(obj4226, alloc_Undefined(), 3);
if (objclass4226 == NULL) {
  Method *reader4231 = addmethodrealflags(obj4226, "constructor",&reader_ast_constructor_4231, MFLAG_DEF);
  reader4231->definitionModule = modulename;
  reader4231->definitionLine = 922;
}
adddatum2(obj4226, alloc_Undefined(), 4);
if (objclass4226 == NULL) {
  Method *reader4232 = addmethodrealflags(obj4226, "signature",&reader_ast_signature_4232, MFLAG_DEF);
  reader4232->definitionModule = modulename;
  reader4232->definitionLine = 923;
}
adddatum2(obj4226, alloc_Undefined(), 5);
if (objclass4226 == NULL) {
  Method *reader4233 = addmethodrealflags(obj4226, "dtype",&reader_ast_dtype_4233, 0);
  Method *writer4233 = addmethodrealflags(obj4226, "dtype:=",&writer_ast_dtype_4233, 0);
  reader4233->definitionModule = modulename;
  writer4233->definitionModule = modulename;
  reader4233->definitionLine = 924;
  writer4233->definitionLine = 924;
}
obj4226->flags |= OFLAG_MUTABLE;
adddatum2(obj4226, alloc_Undefined(), 6);
if (objclass4226 == NULL) {
  Method *reader4234 = addmethodrealflags(obj4226, "generics",&reader_ast_generics_4234, 0);
  Method *writer4234 = addmethodrealflags(obj4226, "generics:=",&writer_ast_generics_4234, 0);
  reader4234->definitionModule = modulename;
  writer4234->definitionModule = modulename;
  reader4234->definitionLine = 925;
  writer4234->definitionLine = 925;
}
obj4226->flags |= OFLAG_MUTABLE;
adddatum2(obj4226, alloc_Undefined(), 7);
if (objclass4226 == NULL) {
  Method *reader4235 = addmethodrealflags(obj4226, "superclass",&reader_ast_superclass_4235, MFLAG_DEF);
  reader4235->definitionModule = modulename;
  reader4235->definitionLine = 926;
}
adddatum2(obj4226, alloc_Undefined(), 8);
if (objclass4226 == NULL) {
  Method *reader4236 = addmethodrealflags(obj4226, "annotations",&reader_ast_annotations_4236, MFLAG_DEF);
  reader4236->definitionModule = modulename;
  reader4236->definitionLine = 927;
}
adddatum2(obj4226, alloc_Undefined(), 9);
if (objclass4226 == NULL) {
  Method *reader4237 = addmethodrealflags(obj4226, "instanceMethods",&reader_ast_instanceMethods_4237, 0);
  Method *writer4237 = addmethodrealflags(obj4226, "instanceMethods:=",&writer_ast_instanceMethods_4237, 0);
  reader4237->definitionModule = modulename;
  writer4237->definitionModule = modulename;
  reader4237->definitionLine = 928;
  writer4237->definitionLine = 928;
}
obj4226->flags |= OFLAG_MUTABLE;
adddatum2(obj4226, alloc_Undefined(), 10);
if (objclass4226 == NULL) {
  Method *reader4238 = addmethodrealflags(obj4226, "data",&reader_ast_data_4238, 0);
  Method *writer4238 = addmethodrealflags(obj4226, "data:=",&writer_ast_data_4238, 0);
  reader4238->definitionModule = modulename;
  writer4238->definitionModule = modulename;
  reader4238->definitionLine = 929;
  writer4238->definitionLine = 929;
}
obj4226->flags |= OFLAG_MUTABLE;
adddatum2(obj4226, alloc_Undefined(), 11);
  struct UserObject *uo4239 = (struct UserObject*)obj4226;
  uo4239->data[12] = emptyclosure;
  Method *meth_meth_ast_accept4239 = addmethod2pos(obj4226, "accept", &meth_ast_accept4239, 12);
int argcv_meth_ast_accept4239[] = {1};
meth_meth_ast_accept4239->type = alloc_MethodType(1, argcv_meth_ast_accept4239);
meth_meth_ast_accept4239->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept4239->type->names[0] = "visitor";
  meth_meth_ast_accept4239->definitionModule = modulename;
  meth_meth_ast_accept4239->definitionLine = 929;
  block_savedest(obj4226);
  Object closure4298 = createclosure(1, "map()before()after");
setclosureframe(closure4298, stackframe);
  addtoclosure(closure4298, var_classNode);
  struct UserObject *uo4298 = (struct UserObject*)obj4226;
  uo4298->data[13] = (Object)closure4298;
  Method *meth_meth_ast_map_40__41_before_40__41_after4298 = addmethod2pos(obj4226, "map()before()after", &meth_ast_map_40__41_before_40__41_after4298, 13);
int argcv_meth_ast_map_40__41_before_40__41_after4298[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after4298->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after4298);
  meth_meth_ast_map_40__41_before_40__41_after4298->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after4298->definitionLine = 949;
  struct UserObject *uo4363 = (struct UserObject*)obj4226;
  uo4363->data[14] = emptyclosure;
  Method *meth_meth_ast_map4363 = addmethod2pos(obj4226, "map", &meth_ast_map4363, 14);
int argcv_meth_ast_map4363[] = {1};
meth_meth_ast_map4363->type = alloc_MethodType(1, argcv_meth_ast_map4363);
  meth_meth_ast_map4363->definitionModule = modulename;
  meth_meth_ast_map4363->definitionLine = 962;
  struct UserObject *uo4372 = (struct UserObject*)obj4226;
  uo4372->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty4372 = addmethod2pos(obj4226, "pretty", &meth_ast_pretty4372, 15);
int argcv_meth_ast_pretty4372[] = {1};
meth_meth_ast_pretty4372->type = alloc_MethodType(1, argcv_meth_ast_pretty4372);
  meth_meth_ast_pretty4372->definitionModule = modulename;
  meth_meth_ast_pretty4372->definitionLine = 965;
  struct UserObject *uo4791 = (struct UserObject*)obj4226;
  uo4791->data[16] = emptyclosure;
  Method *meth_meth_ast_toGrace4791 = addmethod2pos(obj4226, "toGrace", &meth_ast_toGrace4791, 16);
int argcv_meth_ast_toGrace4791[] = {1};
meth_meth_ast_toGrace4791->type = alloc_MethodType(1, argcv_meth_ast_toGrace4791);
meth_meth_ast_toGrace4791->type->types[0] = type_Number;
meth_meth_ast_toGrace4791->type->names[0] = "depth";
  meth_meth_ast_toGrace4791->definitionModule = modulename;
  meth_meth_ast_toGrace4791->definitionLine = 1009;
  sourceObject = obj4226;
// Begin line 917
  setline(917);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5018 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5019 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5018);
// compilenode returning call5019
  struct UserObject *obj4226_uo = (struct UserObject *)obj4226;
  obj4226_uo->super = call5019;
  sourceObject = obj4226;
// Begin line 918
  setline(918);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5020 == NULL) {
    strlit5020 = alloc_String("class");
    gc_root(strlit5020);
  }
// compilenode returning strlit5020
  adddatum2(obj4226, strlit5020, 1);
  sourceObject = obj4226;
// Begin line 919
  setline(919);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_body_39_
  adddatum2(obj4226, *var_body_39_, 2);
  sourceObject = obj4226;
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name_39_
  adddatum2(obj4226, *var_name_39_, 3);
  sourceObject = obj4226;
// Begin line 921
  setline(921);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_constructor_39_
  adddatum2(obj4226, *var_constructor_39_, 4);
  sourceObject = obj4226;
// Begin line 922
  setline(922);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_signature_39_
  adddatum2(obj4226, *var_signature_39_, 5);
  sourceObject = obj4226;
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dtype_39_
  adddatum2(obj4226, *var_dtype_39_, 6);
  sourceObject = obj4226;
// Begin line 924
  setline(924);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5021 = alloc_Boolean(0);
// compilenode returning bool5021
  adddatum2(obj4226, bool5021, 7);
  sourceObject = obj4226;
// Begin line 925
  setline(925);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_superclass_39_
  adddatum2(obj4226, *var_superclass_39_, 8);
  sourceObject = obj4226;
// Begin line 926
  setline(926);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5022 = gc_frame_new();
  int callframe5023 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call5024 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe5023);
// compilenode returning call5024
// compilenode returning call5024
  partcv[0] = 0;
  Object call5025 = callmethod(call5024, "new",
    1, partcv, params);
  gc_frame_end(callframe5022);
// compilenode returning call5025
// compilenode returning call5025
  adddatum2(obj4226, call5025, 9);
  sourceObject = obj4226;
// Begin line 927
  setline(927);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5026 = gc_frame_new();
  int callframe5027 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call5028 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe5027);
// compilenode returning call5028
// compilenode returning call5028
  partcv[0] = 0;
  Object call5029 = callmethod(call5028, "new",
    1, partcv, params);
  gc_frame_end(callframe5026);
// compilenode returning call5029
// compilenode returning call5029
  adddatum2(obj4226, call5029, 10);
  sourceObject = obj4226;
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5030 = alloc_Boolean(0);
// compilenode returning bool5030
  adddatum2(obj4226, bool5030, 11);
  sourceObject = obj4226;
  sourceObject = obj4226;
  sourceObject = obj4226;
  sourceObject = obj4226;
  sourceObject = obj4226;
objclass4226 = obj4226->class;
  objclass4226->definitionModule = modulename;
  objclass4226->definitionLine = 891;
  (*(struct UserObject *)self).data[0] = lowerouter4226;
  self = oldself4226;
  selfslot = oldselfslot4226;
  stackframe = oldstackframe4226;
  gc_frame_end(frame);
  return obj4226;
}
Object meth_ast_new4225_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 6)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_classNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  Object *var_collections = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[2]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[3]);
  *var_superclass_39_ = args[curarg];
  curarg++;
  Object *var_constructor_39_ = &(stackframe->slots[4]);
  *var_constructor_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[5]);
  *var_dtype_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 6)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[6]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4226 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4226 = alloc_userobj2(21,18, objclass4226);
  gc_frame_newslot(obj4226);
if (objclass4226 == NULL) {
  glfree(obj4226->class->name);
  obj4226->class->name = "classNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4226, self, 0);
  addmethodreal(obj4226,"outer", &reader_ast_outer_4227);
  Object oldself4226 = self;
  struct StackFrameObject *oldstackframe4226 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4226);
  gc_frame_newslot((Object)stackframe);
  self = obj4226;
  Object *oldselfslot4226 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4226 = (*(struct UserObject *)self).data[0], lowerouter4226 = thisouter4226;
  if (inheritingObject4226) {
    struct UserObject *inho4226 = (struct UserObject *)inheritingObject4226;
    while (inho4226->super != GraceDefaultObject) inho4226 = (struct UserObject *)inho4226->super;
    inho4226->super = obj4226;
    self = inheritingObject4226;
    *selfslot = self;
    lowerouter4226 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4226;
  }
if (objclass4226 == NULL) {
  Method *reader4228 = addmethodrealflags(obj4226, "kind",&reader_ast_kind_4228, MFLAG_DEF);
  reader4228->definitionModule = modulename;
  reader4228->definitionLine = 919;
}
adddatum2(obj4226, alloc_Undefined(), 1);
if (objclass4226 == NULL) {
  Method *reader4229 = addmethodrealflags(obj4226, "value",&reader_ast_value_4229, MFLAG_DEF);
  reader4229->definitionModule = modulename;
  reader4229->definitionLine = 920;
}
adddatum2(obj4226, alloc_Undefined(), 2);
if (objclass4226 == NULL) {
  Method *reader4230 = addmethodrealflags(obj4226, "name",&reader_ast_name_4230, MFLAG_DEF);
  reader4230->definitionModule = modulename;
  reader4230->definitionLine = 921;
}
adddatum2(obj4226, alloc_Undefined(), 3);
if (objclass4226 == NULL) {
  Method *reader4231 = addmethodrealflags(obj4226, "constructor",&reader_ast_constructor_4231, MFLAG_DEF);
  reader4231->definitionModule = modulename;
  reader4231->definitionLine = 922;
}
adddatum2(obj4226, alloc_Undefined(), 4);
if (objclass4226 == NULL) {
  Method *reader4232 = addmethodrealflags(obj4226, "signature",&reader_ast_signature_4232, MFLAG_DEF);
  reader4232->definitionModule = modulename;
  reader4232->definitionLine = 923;
}
adddatum2(obj4226, alloc_Undefined(), 5);
if (objclass4226 == NULL) {
  Method *reader4233 = addmethodrealflags(obj4226, "dtype",&reader_ast_dtype_4233, 0);
  Method *writer4233 = addmethodrealflags(obj4226, "dtype:=",&writer_ast_dtype_4233, 0);
  reader4233->definitionModule = modulename;
  writer4233->definitionModule = modulename;
  reader4233->definitionLine = 924;
  writer4233->definitionLine = 924;
}
obj4226->flags |= OFLAG_MUTABLE;
adddatum2(obj4226, alloc_Undefined(), 6);
if (objclass4226 == NULL) {
  Method *reader4234 = addmethodrealflags(obj4226, "generics",&reader_ast_generics_4234, 0);
  Method *writer4234 = addmethodrealflags(obj4226, "generics:=",&writer_ast_generics_4234, 0);
  reader4234->definitionModule = modulename;
  writer4234->definitionModule = modulename;
  reader4234->definitionLine = 925;
  writer4234->definitionLine = 925;
}
obj4226->flags |= OFLAG_MUTABLE;
adddatum2(obj4226, alloc_Undefined(), 7);
if (objclass4226 == NULL) {
  Method *reader4235 = addmethodrealflags(obj4226, "superclass",&reader_ast_superclass_4235, MFLAG_DEF);
  reader4235->definitionModule = modulename;
  reader4235->definitionLine = 926;
}
adddatum2(obj4226, alloc_Undefined(), 8);
if (objclass4226 == NULL) {
  Method *reader4236 = addmethodrealflags(obj4226, "annotations",&reader_ast_annotations_4236, MFLAG_DEF);
  reader4236->definitionModule = modulename;
  reader4236->definitionLine = 927;
}
adddatum2(obj4226, alloc_Undefined(), 9);
if (objclass4226 == NULL) {
  Method *reader4237 = addmethodrealflags(obj4226, "instanceMethods",&reader_ast_instanceMethods_4237, 0);
  Method *writer4237 = addmethodrealflags(obj4226, "instanceMethods:=",&writer_ast_instanceMethods_4237, 0);
  reader4237->definitionModule = modulename;
  writer4237->definitionModule = modulename;
  reader4237->definitionLine = 928;
  writer4237->definitionLine = 928;
}
obj4226->flags |= OFLAG_MUTABLE;
adddatum2(obj4226, alloc_Undefined(), 10);
if (objclass4226 == NULL) {
  Method *reader4238 = addmethodrealflags(obj4226, "data",&reader_ast_data_4238, 0);
  Method *writer4238 = addmethodrealflags(obj4226, "data:=",&writer_ast_data_4238, 0);
  reader4238->definitionModule = modulename;
  writer4238->definitionModule = modulename;
  reader4238->definitionLine = 929;
  writer4238->definitionLine = 929;
}
obj4226->flags |= OFLAG_MUTABLE;
adddatum2(obj4226, alloc_Undefined(), 11);
  struct UserObject *uo4239 = (struct UserObject*)obj4226;
  uo4239->data[12] = emptyclosure;
  Method *meth_meth_ast_accept4239 = addmethod2pos(obj4226, "accept", &meth_ast_accept4239, 12);
int argcv_meth_ast_accept4239[] = {1};
meth_meth_ast_accept4239->type = alloc_MethodType(1, argcv_meth_ast_accept4239);
meth_meth_ast_accept4239->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept4239->type->names[0] = "visitor";
  meth_meth_ast_accept4239->definitionModule = modulename;
  meth_meth_ast_accept4239->definitionLine = 929;
  block_savedest(obj4226);
  Object closure4298 = createclosure(1, "map()before()after");
setclosureframe(closure4298, stackframe);
  addtoclosure(closure4298, var_classNode);
  struct UserObject *uo4298 = (struct UserObject*)obj4226;
  uo4298->data[13] = (Object)closure4298;
  Method *meth_meth_ast_map_40__41_before_40__41_after4298 = addmethod2pos(obj4226, "map()before()after", &meth_ast_map_40__41_before_40__41_after4298, 13);
int argcv_meth_ast_map_40__41_before_40__41_after4298[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after4298->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after4298);
  meth_meth_ast_map_40__41_before_40__41_after4298->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after4298->definitionLine = 949;
  struct UserObject *uo4363 = (struct UserObject*)obj4226;
  uo4363->data[14] = emptyclosure;
  Method *meth_meth_ast_map4363 = addmethod2pos(obj4226, "map", &meth_ast_map4363, 14);
int argcv_meth_ast_map4363[] = {1};
meth_meth_ast_map4363->type = alloc_MethodType(1, argcv_meth_ast_map4363);
  meth_meth_ast_map4363->definitionModule = modulename;
  meth_meth_ast_map4363->definitionLine = 962;
  struct UserObject *uo4372 = (struct UserObject*)obj4226;
  uo4372->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty4372 = addmethod2pos(obj4226, "pretty", &meth_ast_pretty4372, 15);
int argcv_meth_ast_pretty4372[] = {1};
meth_meth_ast_pretty4372->type = alloc_MethodType(1, argcv_meth_ast_pretty4372);
  meth_meth_ast_pretty4372->definitionModule = modulename;
  meth_meth_ast_pretty4372->definitionLine = 965;
  struct UserObject *uo4791 = (struct UserObject*)obj4226;
  uo4791->data[16] = emptyclosure;
  Method *meth_meth_ast_toGrace4791 = addmethod2pos(obj4226, "toGrace", &meth_ast_toGrace4791, 16);
int argcv_meth_ast_toGrace4791[] = {1};
meth_meth_ast_toGrace4791->type = alloc_MethodType(1, argcv_meth_ast_toGrace4791);
meth_meth_ast_toGrace4791->type->types[0] = type_Number;
meth_meth_ast_toGrace4791->type->names[0] = "depth";
  meth_meth_ast_toGrace4791->definitionModule = modulename;
  meth_meth_ast_toGrace4791->definitionLine = 1009;
  sourceObject = obj4226;
// Begin line 917
  setline(917);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5018 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5019 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5018);
// compilenode returning call5019
  struct UserObject *obj4226_uo = (struct UserObject *)obj4226;
  obj4226_uo->super = call5019;
  sourceObject = obj4226;
// Begin line 918
  setline(918);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5020 == NULL) {
    strlit5020 = alloc_String("class");
    gc_root(strlit5020);
  }
// compilenode returning strlit5020
  adddatum2(obj4226, strlit5020, 1);
  sourceObject = obj4226;
// Begin line 919
  setline(919);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_body_39_
  adddatum2(obj4226, *var_body_39_, 2);
  sourceObject = obj4226;
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name_39_
  adddatum2(obj4226, *var_name_39_, 3);
  sourceObject = obj4226;
// Begin line 921
  setline(921);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_constructor_39_
  adddatum2(obj4226, *var_constructor_39_, 4);
  sourceObject = obj4226;
// Begin line 922
  setline(922);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_signature_39_
  adddatum2(obj4226, *var_signature_39_, 5);
  sourceObject = obj4226;
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dtype_39_
  adddatum2(obj4226, *var_dtype_39_, 6);
  sourceObject = obj4226;
// Begin line 924
  setline(924);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5021 = alloc_Boolean(0);
// compilenode returning bool5021
  adddatum2(obj4226, bool5021, 7);
  sourceObject = obj4226;
// Begin line 925
  setline(925);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_superclass_39_
  adddatum2(obj4226, *var_superclass_39_, 8);
  sourceObject = obj4226;
// Begin line 926
  setline(926);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5022 = gc_frame_new();
  int callframe5023 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call5024 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe5023);
// compilenode returning call5024
// compilenode returning call5024
  partcv[0] = 0;
  Object call5025 = callmethod(call5024, "new",
    1, partcv, params);
  gc_frame_end(callframe5022);
// compilenode returning call5025
// compilenode returning call5025
  adddatum2(obj4226, call5025, 9);
  sourceObject = obj4226;
// Begin line 927
  setline(927);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5026 = gc_frame_new();
  int callframe5027 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call5028 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe5027);
// compilenode returning call5028
// compilenode returning call5028
  partcv[0] = 0;
  Object call5029 = callmethod(call5028, "new",
    1, partcv, params);
  gc_frame_end(callframe5026);
// compilenode returning call5029
// compilenode returning call5029
  adddatum2(obj4226, call5029, 10);
  sourceObject = obj4226;
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5030 = alloc_Boolean(0);
// compilenode returning bool5030
  adddatum2(obj4226, bool5030, 11);
  sourceObject = obj4226;
  sourceObject = obj4226;
  sourceObject = obj4226;
  sourceObject = obj4226;
  sourceObject = obj4226;
objclass4226 = obj4226->class;
  objclass4226->definitionModule = modulename;
  objclass4226->definitionLine = 891;
  (*(struct UserObject *)self).data[0] = lowerouter4226;
  self = oldself4226;
  selfslot = oldselfslot4226;
  stackframe = oldstackframe4226;
  gc_frame_end(frame);
  return obj4226;
}
Object meth_ast_objectNode5032(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "objectNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_objectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for objectNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for objectNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_objectNode
  gc_frame_end(frame);
  return *var_objectNode;
}
Object meth_ast__apply5063(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1061
  setline(1061);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5064 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_x
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call5065 = callmethod(*var_x, "accept",
    1, partcv, params);
  gc_frame_end(callframe5064);
// compilenode returning call5065
  gc_frame_end(frame);
  return call5065;
}
Object meth_ast_accept5044(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1064
  setline(1064);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1056
  setline(1056);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5046 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call5047 = callmethod(*var_visitor, "visitObject",
    1, partcv, params);
  gc_frame_end(callframe5046);
// compilenode returning call5047
  Object if5045 = done;
  if (istrue(call5047)) {
// Begin line 1060
  setline(1060);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5050 = alloc_Boolean(0);
// compilenode returning bool5050
  int op_slot_right_5049 = gc_frame_newslot(bool5050);
  int callframe5052 = gc_frame_new();
  partcv[0] = 0;
  Object call5053 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5052);
// compilenode returning call5053
// compilenode returning call5053
  int op_slot_left_5049 = gc_frame_newslot(call5053);
  params[0] = bool5050;
  partcv[0] = 1;
  Object opresult5054 = callmethod(call5053, "!=", 1, partcv, params);
// compilenode returning opresult5054
  Object if5048 = done;
  if (istrue(opresult5054)) {
// Begin line 1058
  setline(1058);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5055 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe5056 = gc_frame_new();
  partcv[0] = 0;
  Object call5057 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5056);
// compilenode returning call5057
// compilenode returning call5057
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call5058 = callmethod(call5057, "accept",
    1, partcv, params);
  gc_frame_end(callframe5055);
// compilenode returning call5058
    gc_frame_newslot(call5058);
    if5048 = call5058;
  } else {
  }
// compilenode returning if5048
// Begin line 1060
  setline(1060);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5059 = gc_frame_new();
  int callframe5060 = gc_frame_new();
  partcv[0] = 0;
  Object call5061 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5060);
// compilenode returning call5061
// compilenode returning call5061
  gc_frame_newslot(call5061);
  Object block5062 = alloc_Block(NULL, NULL, "ast", 1060);
  gc_frame_newslot(block5062);
  block_savedest(block5062);
  Object closure5063 = createclosure(2, "_apply");
setclosureframe(closure5063, stackframe);
  addtoclosure(closure5063, var_visitor);
  addtoclosure(closure5063, selfslot);
  struct UserObject *uo5063 = (struct UserObject*)block5062;
  uo5063->data[0] = (Object)closure5063;
  Method *meth_meth_ast__apply5063 = addmethod2pos(block5062, "_apply", &meth_ast__apply5063, 0);
int argcv_meth_ast__apply5063[] = {1};
meth_meth_ast__apply5063->type = alloc_MethodType(1, argcv_meth_ast__apply5063);
  meth_meth_ast__apply5063->definitionModule = modulename;
  meth_meth_ast__apply5063->definitionLine = 1060;
// compilenode returning block5062
  gc_frame_newslot(block5062);
  params[0] = call5061;
  params[1] = block5062;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5067 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5059);
// compilenode returning call5067
    gc_frame_newslot(call5067);
    if5045 = call5067;
  } else {
  }
// compilenode returning if5045
  gc_frame_end(frame);
  return if5045;
}
Object meth_ast_map_40__41_before_40__41_after5068(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_objectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1066
  setline(1066);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5069 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call5070 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe5069);
// compilenode returning call5070
// Begin line 1067
  setline(1067);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5071 = gc_frame_new();
  int callframe5072 = gc_frame_new();
  int callframe5073 = gc_frame_new();
  partcv[0] = 0;
  Object call5074 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5073);
// compilenode returning call5074
  gc_frame_newslot(call5074);
// Begin line 1068
  setline(1068);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// Begin line 1067
  setline(1067);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5075 = gc_frame_new();
  int callframe5076 = gc_frame_new();
  Object call5077 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5076);
// compilenode returning call5077
// compilenode returning call5077
  partcv[0] = 0;
  Object call5078 = callmethodflags(call5077, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5075);
// compilenode returning call5078
// compilenode returning call5078
  params[0] = call5074;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5079 = callmethodflags(call5078, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5072);
// compilenode returning call5079
  gc_frame_newslot(call5079);
// Begin line 1068
  setline(1068);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5080 = gc_frame_new();
  int callframe5081 = gc_frame_new();
  partcv[0] = 0;
  Object call5082 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5081);
// compilenode returning call5082
  gc_frame_newslot(call5082);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// Begin line 1069
  setline(1069);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// Begin line 1068
  setline(1068);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5083 = gc_frame_new();
  int callframe5084 = gc_frame_new();
  Object call5085 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5084);
// compilenode returning call5085
// compilenode returning call5085
  partcv[0] = 0;
  Object call5086 = callmethodflags(call5085, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5083);
// compilenode returning call5086
// compilenode returning call5086
  params[0] = call5082;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 4;
  Object call5087 = callmethodflags(call5086, "maybeMap", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5080);
// compilenode returning call5087
  gc_frame_newslot(call5087);
// Begin line 1067
  setline(1067);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_objectNode
  params[0] = call5079;
  params[1] = call5087;
  partcv[0] = 2;
  Object call5088 = callmethod(*var_objectNode, "new",
    1, partcv, params);
  gc_frame_end(callframe5071);
// compilenode returning call5088
  *var_n = call5088;
  if (call5088 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1070
  setline(1070);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5089 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5090 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe5089);
// compilenode returning call5090
  *var_n = call5090;
  if (call5090 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1072
  setline(1072);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1068
  setline(1068);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5092 = gc_frame_new();
// Begin line 1071
  setline(1071);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5093 = gc_frame_new();
  partcv[0] = 0;
  Object call5094 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5093);
// compilenode returning call5094
  gc_frame_newslot(call5094);
// compilenode returning *var_n
  params[0] = call5094;
  partcv[0] = 1;
  Object call5095 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe5092);
// compilenode returning call5095
// compilenode returning done
// Begin line 1072
  setline(1072);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5096 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5097 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe5096);
// compilenode returning call5097
// Begin line 1073
  setline(1073);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply5101(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5104(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map5098(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5099 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block5100 = alloc_Block(NULL, NULL, "ast", 1076);
  gc_frame_newslot(block5100);
  block_savedest(block5100);
  Object closure5101 = createclosure(1, "_apply");
setclosureframe(closure5101, stackframe);
  addtoclosure(closure5101, selfslot);
  struct UserObject *uo5101 = (struct UserObject*)block5100;
  uo5101->data[0] = (Object)closure5101;
  Method *meth_meth_ast__apply5101 = addmethod2pos(block5100, "_apply", &meth_ast__apply5101, 0);
int argcv_meth_ast__apply5101[] = {0};
meth_meth_ast__apply5101->type = alloc_MethodType(1, argcv_meth_ast__apply5101);
  meth_meth_ast__apply5101->definitionModule = modulename;
  meth_meth_ast__apply5101->definitionLine = 1068;
// compilenode returning block5100
  gc_frame_newslot(block5100);
  Object block5103 = alloc_Block(NULL, NULL, "ast", 1076);
  gc_frame_newslot(block5103);
  block_savedest(block5103);
  Object closure5104 = createclosure(1, "_apply");
setclosureframe(closure5104, stackframe);
  addtoclosure(closure5104, selfslot);
  struct UserObject *uo5104 = (struct UserObject*)block5103;
  uo5104->data[0] = (Object)closure5104;
  Method *meth_meth_ast__apply5104 = addmethod2pos(block5103, "_apply", &meth_ast__apply5104, 0);
int argcv_meth_ast__apply5104[] = {0};
meth_meth_ast__apply5104->type = alloc_MethodType(1, argcv_meth_ast__apply5104);
  meth_meth_ast__apply5104->definitionModule = modulename;
  meth_meth_ast__apply5104->definitionLine = 1068;
// compilenode returning block5103
  gc_frame_newslot(block5103);
  params[0] = *var_blk;
  params[1] = block5100;
  params[2] = block5103;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5106 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5099);
// compilenode returning call5106
  gc_frame_end(frame);
  return call5106;
}
Object meth_ast__apply5115(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1083
  setline(1083);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1082
  setline(1082);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5117 == NULL) {
    strlit5117 = alloc_String("  ");
    gc_root(strlit5117);
  }
// compilenode returning strlit5117
  int op_slot_right_5116 = gc_frame_newslot(strlit5117);
// compilenode returning *var_spc
  int op_slot_left_5116 = gc_frame_newslot(*var_spc);
  params[0] = strlit5117;
  partcv[0] = 1;
  Object opresult5119 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult5119
  *var_spc = opresult5119;
  if (opresult5119 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5183(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1092
  setline(1092);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5185 = gc_frame_new();
  Object num5187 = alloc_Float64(1);
// compilenode returning num5187
  int op_slot_right_5186 = gc_frame_newslot(num5187);
// compilenode returning *var_depth
  int op_slot_left_5186 = gc_frame_newslot(*var_depth);
  params[0] = num5187;
  partcv[0] = 1;
  Object sum5189 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum5189
  gc_frame_newslot(sum5189);
// compilenode returning *var_x
  params[0] = sum5189;
  partcv[0] = 1;
  Object call5190 = callmethod(*var_x, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5185);
// compilenode returning call5190
  int op_slot_right_5184 = gc_frame_newslot(call5190);
// compilenode returning *var_spc
  int op_slot_right_5192 = gc_frame_newslot(*var_spc);
  if (strlit5195 == NULL) {
    strlit5195 = alloc_String("""\x0a""");
    gc_root(strlit5195);
  }
// compilenode returning strlit5195
  int op_slot_right_5194 = gc_frame_newslot(strlit5195);
// compilenode returning *var_s
  int op_slot_left_5194 = gc_frame_newslot(*var_s);
  params[0] = strlit5195;
  partcv[0] = 1;
  Object opresult5197 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5197
  int op_slot_left_5192 = gc_frame_newslot(opresult5197);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5198 = callmethod(opresult5197, "++", 1, partcv, params);
// compilenode returning opresult5198
  int op_slot_left_5184 = gc_frame_newslot(opresult5198);
  params[0] = call5190;
  partcv[0] = 1;
  Object opresult5199 = callmethod(opresult5198, "++", 1, partcv, params);
// compilenode returning opresult5199
  *var_s = opresult5199;
  if (opresult5199 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty5107(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth_39_ = &(stackframe->slots[0]);
  *var_depth_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_depth = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "depth");
  Object *var_spc = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "spc");
  Object *var_s = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "s");
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1079
  setline(1079);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_depth_39_
  *var_depth = *var_depth_39_;
  if (*var_depth_39_ == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1081
  setline(1081);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5108 == NULL) {
    strlit5108 = alloc_String("");
    gc_root(strlit5108);
  }
// compilenode returning strlit5108
  *var_spc = strlit5108;
  if (strlit5108 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1081
  setline(1081);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5109 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_5110 = gc_frame_newslot(*var_depth);
  Object num5112 = alloc_Float64(0);
// compilenode returning num5112
  int op_slot_left_5110 = gc_frame_newslot(num5112);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult5113 = callmethod(num5112, "..", 1, partcv, params);
// compilenode returning opresult5113
  gc_frame_newslot(opresult5113);
  Object block5114 = alloc_Block(NULL, NULL, "ast", 1081);
  gc_frame_newslot(block5114);
  block_savedest(block5114);
  Object closure5115 = createclosure(2, "_apply");
setclosureframe(closure5115, stackframe);
  addtoclosure(closure5115, var_spc);
  addtoclosure(closure5115, selfslot);
  struct UserObject *uo5115 = (struct UserObject*)block5114;
  uo5115->data[0] = (Object)closure5115;
  Method *meth_meth_ast__apply5115 = addmethod2pos(block5114, "_apply", &meth_ast__apply5115, 0);
int argcv_meth_ast__apply5115[] = {1};
meth_meth_ast__apply5115->type = alloc_MethodType(1, argcv_meth_ast__apply5115);
  meth_meth_ast__apply5115->definitionModule = modulename;
  meth_meth_ast__apply5115->definitionLine = 1068;
// compilenode returning block5114
  gc_frame_newslot(block5114);
  params[0] = opresult5113;
  params[1] = block5114;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5122 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5109);
// compilenode returning call5122
// Begin line 1085
  setline(1085);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1084
  setline(1084);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5123 == NULL) {
    strlit5123 = alloc_String("Object");
    gc_root(strlit5123);
  }
// compilenode returning strlit5123
  *var_s = strlit5123;
  if (strlit5123 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1091
  setline(1091);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1085
  setline(1085);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5126 = alloc_Boolean(0);
// compilenode returning bool5126
  int op_slot_right_5125 = gc_frame_newslot(bool5126);
  int callframe5128 = gc_frame_new();
  partcv[0] = 0;
  Object call5129 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5128);
// compilenode returning call5129
// compilenode returning call5129
  int op_slot_left_5125 = gc_frame_newslot(call5129);
  params[0] = bool5126;
  partcv[0] = 1;
  Object opresult5130 = callmethod(call5129, "!=", 1, partcv, params);
// compilenode returning opresult5130
  Object if5124 = done;
  if (istrue(opresult5130)) {
// Begin line 1087
  setline(1087);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1086
  setline(1086);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5132 == NULL) {
    strlit5132 = alloc_String("Superclass:");
    gc_root(strlit5132);
  }
// compilenode returning strlit5132
  int op_slot_right_5131 = gc_frame_newslot(strlit5132);
// compilenode returning *var_spc
  int op_slot_right_5134 = gc_frame_newslot(*var_spc);
  if (strlit5137 == NULL) {
    strlit5137 = alloc_String("""\x0a""");
    gc_root(strlit5137);
  }
// compilenode returning strlit5137
  int op_slot_right_5136 = gc_frame_newslot(strlit5137);
// compilenode returning *var_s
  int op_slot_left_5136 = gc_frame_newslot(*var_s);
  params[0] = strlit5137;
  partcv[0] = 1;
  Object opresult5139 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5139
  int op_slot_left_5134 = gc_frame_newslot(opresult5139);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5140 = callmethod(opresult5139, "++", 1, partcv, params);
// compilenode returning opresult5140
  int op_slot_left_5131 = gc_frame_newslot(opresult5140);
  params[0] = strlit5132;
  partcv[0] = 1;
  Object opresult5141 = callmethod(opresult5140, "++", 1, partcv, params);
// compilenode returning opresult5141
  *var_s = opresult5141;
  if (opresult5141 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1087
  setline(1087);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5144 = gc_frame_new();
  Object num5146 = alloc_Float64(1);
// compilenode returning num5146
  int op_slot_right_5145 = gc_frame_newslot(num5146);
// compilenode returning *var_depth
  int op_slot_left_5145 = gc_frame_newslot(*var_depth);
  params[0] = num5146;
  partcv[0] = 1;
  Object sum5148 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum5148
  gc_frame_newslot(sum5148);
  int callframe5149 = gc_frame_new();
  partcv[0] = 0;
  Object call5150 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5149);
// compilenode returning call5150
// compilenode returning call5150
  params[0] = sum5148;
  partcv[0] = 1;
  Object call5151 = callmethod(call5150, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5144);
// compilenode returning call5151
  int op_slot_right_5143 = gc_frame_newslot(call5151);
// compilenode returning *var_spc
  int op_slot_right_5153 = gc_frame_newslot(*var_spc);
  if (strlit5156 == NULL) {
    strlit5156 = alloc_String("""\x0a""  ");
    gc_root(strlit5156);
  }
// compilenode returning strlit5156
  int op_slot_right_5155 = gc_frame_newslot(strlit5156);
// compilenode returning *var_s
  int op_slot_left_5155 = gc_frame_newslot(*var_s);
  params[0] = strlit5156;
  partcv[0] = 1;
  Object opresult5158 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5158
  int op_slot_left_5153 = gc_frame_newslot(opresult5158);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5159 = callmethod(opresult5158, "++", 1, partcv, params);
// compilenode returning opresult5159
  int op_slot_left_5143 = gc_frame_newslot(opresult5159);
  params[0] = call5151;
  partcv[0] = 1;
  Object opresult5160 = callmethod(opresult5159, "++", 1, partcv, params);
// compilenode returning opresult5160
  *var_s = opresult5160;
  if (opresult5160 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1089
  setline(1089);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1088
  setline(1088);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5163 == NULL) {
    strlit5163 = alloc_String("Body:");
    gc_root(strlit5163);
  }
// compilenode returning strlit5163
  int op_slot_right_5162 = gc_frame_newslot(strlit5163);
// compilenode returning *var_spc
  int op_slot_right_5165 = gc_frame_newslot(*var_spc);
  if (strlit5168 == NULL) {
    strlit5168 = alloc_String("""\x0a""");
    gc_root(strlit5168);
  }
// compilenode returning strlit5168
  int op_slot_right_5167 = gc_frame_newslot(strlit5168);
// compilenode returning *var_s
  int op_slot_left_5167 = gc_frame_newslot(*var_s);
  params[0] = strlit5168;
  partcv[0] = 1;
  Object opresult5170 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5170
  int op_slot_left_5165 = gc_frame_newslot(opresult5170);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5171 = callmethod(opresult5170, "++", 1, partcv, params);
// compilenode returning opresult5171
  int op_slot_left_5162 = gc_frame_newslot(opresult5171);
  params[0] = strlit5163;
  partcv[0] = 1;
  Object opresult5172 = callmethod(opresult5171, "++", 1, partcv, params);
// compilenode returning opresult5172
  *var_s = opresult5172;
  if (opresult5172 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1090
  setline(1090);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1089
  setline(1089);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num5175 = alloc_Float64(1);
// compilenode returning num5175
  int op_slot_right_5174 = gc_frame_newslot(num5175);
// compilenode returning *var_depth
  int op_slot_left_5174 = gc_frame_newslot(*var_depth);
  params[0] = num5175;
  partcv[0] = 1;
  Object sum5177 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum5177
  *var_depth = sum5177;
  if (sum5177 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if5124 = done;
  } else {
  }
// compilenode returning if5124
// Begin line 1091
  setline(1091);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5179 = gc_frame_new();
  int callframe5180 = gc_frame_new();
  partcv[0] = 0;
  Object call5181 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5180);
// compilenode returning call5181
// compilenode returning call5181
  gc_frame_newslot(call5181);
  Object block5182 = alloc_Block(NULL, NULL, "ast", 1091);
  gc_frame_newslot(block5182);
  block_savedest(block5182);
  Object closure5183 = createclosure(4, "_apply");
setclosureframe(closure5183, stackframe);
  addtoclosure(closure5183, var_depth);
  addtoclosure(closure5183, var_spc);
  addtoclosure(closure5183, var_s);
  addtoclosure(closure5183, selfslot);
  struct UserObject *uo5183 = (struct UserObject*)block5182;
  uo5183->data[0] = (Object)closure5183;
  Method *meth_meth_ast__apply5183 = addmethod2pos(block5182, "_apply", &meth_ast__apply5183, 0);
int argcv_meth_ast__apply5183[] = {1};
meth_meth_ast__apply5183->type = alloc_MethodType(1, argcv_meth_ast__apply5183);
  meth_meth_ast__apply5183->definitionModule = modulename;
  meth_meth_ast__apply5183->definitionLine = 1091;
// compilenode returning block5182
  gc_frame_newslot(block5182);
  params[0] = call5181;
  params[1] = block5182;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5202 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5179);
// compilenode returning call5202
// Begin line 1094
  setline(1094);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply5215(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1100
  setline(1100);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1099
  setline(1099);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5217 == NULL) {
    strlit5217 = alloc_String("    ");
    gc_root(strlit5217);
  }
// compilenode returning strlit5217
  int op_slot_right_5216 = gc_frame_newslot(strlit5217);
// compilenode returning *var_spc
  int op_slot_left_5216 = gc_frame_newslot(*var_spc);
  params[0] = strlit5217;
  partcv[0] = 1;
  Object opresult5219 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult5219
  *var_spc = opresult5219;
  if (opresult5219 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5228(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1103
  setline(1103);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5230 = gc_frame_new();
  Object num5232 = alloc_Float64(1);
// compilenode returning num5232
  int op_slot_right_5231 = gc_frame_newslot(num5232);
// compilenode returning *var_depth
  int op_slot_left_5231 = gc_frame_newslot(*var_depth);
  params[0] = num5232;
  partcv[0] = 1;
  Object sum5234 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum5234
  gc_frame_newslot(sum5234);
// compilenode returning *var_x
  params[0] = sum5234;
  partcv[0] = 1;
  Object call5235 = callmethod(*var_x, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5230);
// compilenode returning call5235
  int op_slot_right_5229 = gc_frame_newslot(call5235);
  if (strlit5238 == NULL) {
    strlit5238 = alloc_String("    ");
    gc_root(strlit5238);
  }
// compilenode returning strlit5238
  int op_slot_right_5237 = gc_frame_newslot(strlit5238);
// compilenode returning *var_spc
  int op_slot_right_5240 = gc_frame_newslot(*var_spc);
  if (strlit5243 == NULL) {
    strlit5243 = alloc_String("""\x0a""");
    gc_root(strlit5243);
  }
// compilenode returning strlit5243
  int op_slot_right_5242 = gc_frame_newslot(strlit5243);
// compilenode returning *var_s
  int op_slot_left_5242 = gc_frame_newslot(*var_s);
  params[0] = strlit5243;
  partcv[0] = 1;
  Object opresult5245 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5245
  int op_slot_left_5240 = gc_frame_newslot(opresult5245);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5246 = callmethod(opresult5245, "++", 1, partcv, params);
// compilenode returning opresult5246
  int op_slot_left_5237 = gc_frame_newslot(opresult5246);
  params[0] = strlit5238;
  partcv[0] = 1;
  Object opresult5247 = callmethod(opresult5246, "++", 1, partcv, params);
// compilenode returning opresult5247
  int op_slot_left_5229 = gc_frame_newslot(opresult5247);
  params[0] = call5235;
  partcv[0] = 1;
  Object opresult5248 = callmethod(opresult5247, "++", 1, partcv, params);
// compilenode returning opresult5248
  *var_s = opresult5248;
  if (opresult5248 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace5203(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1098
  setline(1098);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1097
  setline(1097);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5204 == NULL) {
    strlit5204 = alloc_String("");
    gc_root(strlit5204);
  }
// compilenode returning strlit5204
  *var_spc = strlit5204;
  if (strlit5204 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1098
  setline(1098);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5205 = gc_frame_new();
  Object num5208 = alloc_Float64(1);
// compilenode returning num5208
  int op_slot_right_5207 = gc_frame_newslot(num5208);
// compilenode returning *var_depth
  int op_slot_left_5207 = gc_frame_newslot(*var_depth);
  params[0] = num5208;
  partcv[0] = 1;
  Object diff5210 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff5210
  int op_slot_right_5206 = gc_frame_newslot(diff5210);
  Object num5212 = alloc_Float64(0);
// compilenode returning num5212
  int op_slot_left_5206 = gc_frame_newslot(num5212);
  params[0] = diff5210;
  partcv[0] = 1;
  Object opresult5213 = callmethod(num5212, "..", 1, partcv, params);
// compilenode returning opresult5213
  gc_frame_newslot(opresult5213);
  Object block5214 = alloc_Block(NULL, NULL, "ast", 1098);
  gc_frame_newslot(block5214);
  block_savedest(block5214);
  Object closure5215 = createclosure(2, "_apply");
setclosureframe(closure5215, stackframe);
  addtoclosure(closure5215, var_spc);
  addtoclosure(closure5215, selfslot);
  struct UserObject *uo5215 = (struct UserObject*)block5214;
  uo5215->data[0] = (Object)closure5215;
  Method *meth_meth_ast__apply5215 = addmethod2pos(block5214, "_apply", &meth_ast__apply5215, 0);
int argcv_meth_ast__apply5215[] = {1};
meth_meth_ast__apply5215->type = alloc_MethodType(1, argcv_meth_ast__apply5215);
  meth_meth_ast__apply5215->definitionModule = modulename;
  meth_meth_ast__apply5215->definitionLine = 1091;
// compilenode returning block5214
  gc_frame_newslot(block5214);
  params[0] = opresult5213;
  params[1] = block5214;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5222 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5205);
// compilenode returning call5222
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5223 == NULL) {
    strlit5223 = alloc_String("object {");
    gc_root(strlit5223);
  }
// compilenode returning strlit5223
  *var_s = strlit5223;
  if (strlit5223 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5224 = gc_frame_new();
  int callframe5225 = gc_frame_new();
  partcv[0] = 0;
  Object call5226 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5225);
// compilenode returning call5226
// compilenode returning call5226
  gc_frame_newslot(call5226);
  Object block5227 = alloc_Block(NULL, NULL, "ast", 1102);
  gc_frame_newslot(block5227);
  block_savedest(block5227);
  Object closure5228 = createclosure(4, "_apply");
setclosureframe(closure5228, stackframe);
  addtoclosure(closure5228, var_depth);
  addtoclosure(closure5228, var_spc);
  addtoclosure(closure5228, var_s);
  addtoclosure(closure5228, selfslot);
  struct UserObject *uo5228 = (struct UserObject*)block5227;
  uo5228->data[0] = (Object)closure5228;
  Method *meth_meth_ast__apply5228 = addmethod2pos(block5227, "_apply", &meth_ast__apply5228, 0);
int argcv_meth_ast__apply5228[] = {1};
meth_meth_ast__apply5228->type = alloc_MethodType(1, argcv_meth_ast__apply5228);
  meth_meth_ast__apply5228->definitionModule = modulename;
  meth_meth_ast__apply5228->definitionLine = 1102;
// compilenode returning block5227
  gc_frame_newslot(block5227);
  params[0] = call5226;
  params[1] = block5227;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5251 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5224);
// compilenode returning call5251
// Begin line 1106
  setline(1106);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1105
  setline(1105);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5253 == NULL) {
    strlit5253 = alloc_String("}");
    gc_root(strlit5253);
  }
// compilenode returning strlit5253
  int op_slot_right_5252 = gc_frame_newslot(strlit5253);
// compilenode returning *var_spc
  int op_slot_right_5255 = gc_frame_newslot(*var_spc);
  if (strlit5258 == NULL) {
    strlit5258 = alloc_String("""\x0a""");
    gc_root(strlit5258);
  }
// compilenode returning strlit5258
  int op_slot_right_5257 = gc_frame_newslot(strlit5258);
// compilenode returning *var_s
  int op_slot_left_5257 = gc_frame_newslot(*var_s);
  params[0] = strlit5258;
  partcv[0] = 1;
  Object opresult5260 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5260
  int op_slot_left_5255 = gc_frame_newslot(opresult5260);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5261 = callmethod(opresult5260, "++", 1, partcv, params);
// compilenode returning opresult5261
  int op_slot_left_5252 = gc_frame_newslot(opresult5261);
  params[0] = strlit5253;
  partcv[0] = 1;
  Object opresult5262 = callmethod(opresult5261, "++", 1, partcv, params);
// compilenode returning opresult5262
  *var_s = opresult5262;
  if (opresult5262 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1106
  setline(1106);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new5035(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_objectNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_body = &(stackframe->slots[0]);
  *var_body = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[1]);
  *var_superclass_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5036 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5036 = alloc_userobj2(15,13, objclass5036);
  gc_frame_newslot(obj5036);
if (objclass5036 == NULL) {
  glfree(obj5036->class->name);
  obj5036->class->name = "objectNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5036, self, 0);
  addmethodreal(obj5036,"outer", &reader_ast_outer_5037);
  Object oldself5036 = self;
  struct StackFrameObject *oldstackframe5036 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5036);
  gc_frame_newslot((Object)stackframe);
  self = obj5036;
  Object *oldselfslot5036 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5036 = (*(struct UserObject *)self).data[0], lowerouter5036 = thisouter5036;
  if (inheritingObject5036) {
    struct UserObject *inho5036 = (struct UserObject *)inheritingObject5036;
    while (inho5036->super != GraceDefaultObject) inho5036 = (struct UserObject *)inho5036->super;
    inho5036->super = obj5036;
    self = inheritingObject5036;
    *selfslot = self;
    lowerouter5036 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5036;
  }
if (objclass5036 == NULL) {
  Method *reader5038 = addmethodrealflags(obj5036, "kind",&reader_ast_kind_5038, MFLAG_DEF);
  reader5038->definitionModule = modulename;
  reader5038->definitionLine = 1050;
}
adddatum2(obj5036, alloc_Undefined(), 1);
if (objclass5036 == NULL) {
  Method *reader5039 = addmethodrealflags(obj5036, "value",&reader_ast_value_5039, MFLAG_DEF);
  reader5039->definitionModule = modulename;
  reader5039->definitionLine = 1051;
}
adddatum2(obj5036, alloc_Undefined(), 2);
if (objclass5036 == NULL) {
  Method *reader5040 = addmethodrealflags(obj5036, "superclass",&reader_ast_superclass_5040, MFLAG_DEF);
  reader5040->definitionModule = modulename;
  reader5040->definitionLine = 1052;
}
adddatum2(obj5036, alloc_Undefined(), 3);
if (objclass5036 == NULL) {
  Method *reader5041 = addmethodrealflags(obj5036, "otype",&reader_ast_otype_5041, 0);
  Method *writer5041 = addmethodrealflags(obj5036, "otype:=",&writer_ast_otype_5041, 0);
  reader5041->definitionModule = modulename;
  writer5041->definitionModule = modulename;
  reader5041->definitionLine = 1053;
  writer5041->definitionLine = 1053;
}
obj5036->flags |= OFLAG_MUTABLE;
adddatum2(obj5036, alloc_Undefined(), 4);
if (objclass5036 == NULL) {
  Method *reader5042 = addmethodrealflags(obj5036, "classname",&reader_ast_classname_5042, 0);
  Method *writer5042 = addmethodrealflags(obj5036, "classname:=",&writer_ast_classname_5042, 0);
  reader5042->definitionModule = modulename;
  writer5042->definitionModule = modulename;
  reader5042->definitionLine = 1054;
  writer5042->definitionLine = 1054;
}
obj5036->flags |= OFLAG_MUTABLE;
adddatum2(obj5036, alloc_Undefined(), 5);
if (objclass5036 == NULL) {
  Method *reader5043 = addmethodrealflags(obj5036, "data",&reader_ast_data_5043, 0);
  Method *writer5043 = addmethodrealflags(obj5036, "data:=",&writer_ast_data_5043, 0);
  reader5043->definitionModule = modulename;
  writer5043->definitionModule = modulename;
  reader5043->definitionLine = 1055;
  writer5043->definitionLine = 1055;
}
obj5036->flags |= OFLAG_MUTABLE;
adddatum2(obj5036, alloc_Undefined(), 6);
  struct UserObject *uo5044 = (struct UserObject*)obj5036;
  uo5044->data[7] = emptyclosure;
  Method *meth_meth_ast_accept5044 = addmethod2pos(obj5036, "accept", &meth_ast_accept5044, 7);
int argcv_meth_ast_accept5044[] = {1};
meth_meth_ast_accept5044->type = alloc_MethodType(1, argcv_meth_ast_accept5044);
meth_meth_ast_accept5044->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5044->type->names[0] = "visitor";
  meth_meth_ast_accept5044->definitionModule = modulename;
  meth_meth_ast_accept5044->definitionLine = 1055;
  block_savedest(obj5036);
  Object closure5068 = createclosure(1, "map()before()after");
setclosureframe(closure5068, stackframe);
  addtoclosure(closure5068, var_objectNode);
  struct UserObject *uo5068 = (struct UserObject*)obj5036;
  uo5068->data[8] = (Object)closure5068;
  Method *meth_meth_ast_map_40__41_before_40__41_after5068 = addmethod2pos(obj5036, "map()before()after", &meth_ast_map_40__41_before_40__41_after5068, 8);
int argcv_meth_ast_map_40__41_before_40__41_after5068[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after5068->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after5068);
  meth_meth_ast_map_40__41_before_40__41_after5068->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after5068->definitionLine = 1065;
  struct UserObject *uo5098 = (struct UserObject*)obj5036;
  uo5098->data[9] = emptyclosure;
  Method *meth_meth_ast_map5098 = addmethod2pos(obj5036, "map", &meth_ast_map5098, 9);
int argcv_meth_ast_map5098[] = {1};
meth_meth_ast_map5098->type = alloc_MethodType(1, argcv_meth_ast_map5098);
  meth_meth_ast_map5098->definitionModule = modulename;
  meth_meth_ast_map5098->definitionLine = 1075;
  struct UserObject *uo5107 = (struct UserObject*)obj5036;
  uo5107->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty5107 = addmethod2pos(obj5036, "pretty", &meth_ast_pretty5107, 10);
int argcv_meth_ast_pretty5107[] = {1};
meth_meth_ast_pretty5107->type = alloc_MethodType(1, argcv_meth_ast_pretty5107);
  meth_meth_ast_pretty5107->definitionModule = modulename;
  meth_meth_ast_pretty5107->definitionLine = 1078;
  struct UserObject *uo5203 = (struct UserObject*)obj5036;
  uo5203->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace5203 = addmethod2pos(obj5036, "toGrace", &meth_ast_toGrace5203, 11);
int argcv_meth_ast_toGrace5203[] = {1};
meth_meth_ast_toGrace5203->type = alloc_MethodType(1, argcv_meth_ast_toGrace5203);
meth_meth_ast_toGrace5203->type->types[0] = type_Number;
meth_meth_ast_toGrace5203->type->names[0] = "depth";
  meth_meth_ast_toGrace5203->definitionModule = modulename;
  meth_meth_ast_toGrace5203->definitionLine = 1096;
  sourceObject = obj5036;
// Begin line 1048
  setline(1048);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5264 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5265 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5264);
// compilenode returning call5265
  struct UserObject *obj5036_uo = (struct UserObject *)obj5036;
  obj5036_uo->super = call5265;
  sourceObject = obj5036;
// Begin line 1049
  setline(1049);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5266 == NULL) {
    strlit5266 = alloc_String("object");
    gc_root(strlit5266);
  }
// compilenode returning strlit5266
  adddatum2(obj5036, strlit5266, 1);
  sourceObject = obj5036;
// Begin line 1050
  setline(1050);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_body
  adddatum2(obj5036, *var_body, 2);
  sourceObject = obj5036;
// Begin line 1051
  setline(1051);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_superclass_39_
  adddatum2(obj5036, *var_superclass_39_, 3);
  sourceObject = obj5036;
// Begin line 1052
  setline(1052);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5267 = alloc_Boolean(0);
// compilenode returning bool5267
  adddatum2(obj5036, bool5267, 4);
  sourceObject = obj5036;
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5268 == NULL) {
    strlit5268 = alloc_String("object");
    gc_root(strlit5268);
  }
// compilenode returning strlit5268
  adddatum2(obj5036, strlit5268, 5);
  sourceObject = obj5036;
// Begin line 1054
  setline(1054);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5269 = alloc_Boolean(0);
// compilenode returning bool5269
  adddatum2(obj5036, bool5269, 6);
  sourceObject = obj5036;
  sourceObject = obj5036;
  sourceObject = obj5036;
  sourceObject = obj5036;
  sourceObject = obj5036;
objclass5036 = obj5036->class;
  objclass5036->definitionModule = modulename;
  objclass5036->definitionLine = 927;
  (*(struct UserObject *)self).data[0] = lowerouter5036;
  self = oldself5036;
  selfslot = oldselfslot5036;
  stackframe = oldstackframe5036;
  gc_frame_end(frame);
  return obj5036;
}
Object meth_ast_new5035_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_objectNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_body = &(stackframe->slots[0]);
  *var_body = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[1]);
  *var_superclass_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5036 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5036 = alloc_userobj2(15,13, objclass5036);
  gc_frame_newslot(obj5036);
if (objclass5036 == NULL) {
  glfree(obj5036->class->name);
  obj5036->class->name = "objectNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5036, self, 0);
  addmethodreal(obj5036,"outer", &reader_ast_outer_5037);
  Object oldself5036 = self;
  struct StackFrameObject *oldstackframe5036 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5036);
  gc_frame_newslot((Object)stackframe);
  self = obj5036;
  Object *oldselfslot5036 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5036 = (*(struct UserObject *)self).data[0], lowerouter5036 = thisouter5036;
  if (inheritingObject5036) {
    struct UserObject *inho5036 = (struct UserObject *)inheritingObject5036;
    while (inho5036->super != GraceDefaultObject) inho5036 = (struct UserObject *)inho5036->super;
    inho5036->super = obj5036;
    self = inheritingObject5036;
    *selfslot = self;
    lowerouter5036 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5036;
  }
if (objclass5036 == NULL) {
  Method *reader5038 = addmethodrealflags(obj5036, "kind",&reader_ast_kind_5038, MFLAG_DEF);
  reader5038->definitionModule = modulename;
  reader5038->definitionLine = 1050;
}
adddatum2(obj5036, alloc_Undefined(), 1);
if (objclass5036 == NULL) {
  Method *reader5039 = addmethodrealflags(obj5036, "value",&reader_ast_value_5039, MFLAG_DEF);
  reader5039->definitionModule = modulename;
  reader5039->definitionLine = 1051;
}
adddatum2(obj5036, alloc_Undefined(), 2);
if (objclass5036 == NULL) {
  Method *reader5040 = addmethodrealflags(obj5036, "superclass",&reader_ast_superclass_5040, MFLAG_DEF);
  reader5040->definitionModule = modulename;
  reader5040->definitionLine = 1052;
}
adddatum2(obj5036, alloc_Undefined(), 3);
if (objclass5036 == NULL) {
  Method *reader5041 = addmethodrealflags(obj5036, "otype",&reader_ast_otype_5041, 0);
  Method *writer5041 = addmethodrealflags(obj5036, "otype:=",&writer_ast_otype_5041, 0);
  reader5041->definitionModule = modulename;
  writer5041->definitionModule = modulename;
  reader5041->definitionLine = 1053;
  writer5041->definitionLine = 1053;
}
obj5036->flags |= OFLAG_MUTABLE;
adddatum2(obj5036, alloc_Undefined(), 4);
if (objclass5036 == NULL) {
  Method *reader5042 = addmethodrealflags(obj5036, "classname",&reader_ast_classname_5042, 0);
  Method *writer5042 = addmethodrealflags(obj5036, "classname:=",&writer_ast_classname_5042, 0);
  reader5042->definitionModule = modulename;
  writer5042->definitionModule = modulename;
  reader5042->definitionLine = 1054;
  writer5042->definitionLine = 1054;
}
obj5036->flags |= OFLAG_MUTABLE;
adddatum2(obj5036, alloc_Undefined(), 5);
if (objclass5036 == NULL) {
  Method *reader5043 = addmethodrealflags(obj5036, "data",&reader_ast_data_5043, 0);
  Method *writer5043 = addmethodrealflags(obj5036, "data:=",&writer_ast_data_5043, 0);
  reader5043->definitionModule = modulename;
  writer5043->definitionModule = modulename;
  reader5043->definitionLine = 1055;
  writer5043->definitionLine = 1055;
}
obj5036->flags |= OFLAG_MUTABLE;
adddatum2(obj5036, alloc_Undefined(), 6);
  struct UserObject *uo5044 = (struct UserObject*)obj5036;
  uo5044->data[7] = emptyclosure;
  Method *meth_meth_ast_accept5044 = addmethod2pos(obj5036, "accept", &meth_ast_accept5044, 7);
int argcv_meth_ast_accept5044[] = {1};
meth_meth_ast_accept5044->type = alloc_MethodType(1, argcv_meth_ast_accept5044);
meth_meth_ast_accept5044->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5044->type->names[0] = "visitor";
  meth_meth_ast_accept5044->definitionModule = modulename;
  meth_meth_ast_accept5044->definitionLine = 1055;
  block_savedest(obj5036);
  Object closure5068 = createclosure(1, "map()before()after");
setclosureframe(closure5068, stackframe);
  addtoclosure(closure5068, var_objectNode);
  struct UserObject *uo5068 = (struct UserObject*)obj5036;
  uo5068->data[8] = (Object)closure5068;
  Method *meth_meth_ast_map_40__41_before_40__41_after5068 = addmethod2pos(obj5036, "map()before()after", &meth_ast_map_40__41_before_40__41_after5068, 8);
int argcv_meth_ast_map_40__41_before_40__41_after5068[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after5068->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after5068);
  meth_meth_ast_map_40__41_before_40__41_after5068->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after5068->definitionLine = 1065;
  struct UserObject *uo5098 = (struct UserObject*)obj5036;
  uo5098->data[9] = emptyclosure;
  Method *meth_meth_ast_map5098 = addmethod2pos(obj5036, "map", &meth_ast_map5098, 9);
int argcv_meth_ast_map5098[] = {1};
meth_meth_ast_map5098->type = alloc_MethodType(1, argcv_meth_ast_map5098);
  meth_meth_ast_map5098->definitionModule = modulename;
  meth_meth_ast_map5098->definitionLine = 1075;
  struct UserObject *uo5107 = (struct UserObject*)obj5036;
  uo5107->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty5107 = addmethod2pos(obj5036, "pretty", &meth_ast_pretty5107, 10);
int argcv_meth_ast_pretty5107[] = {1};
meth_meth_ast_pretty5107->type = alloc_MethodType(1, argcv_meth_ast_pretty5107);
  meth_meth_ast_pretty5107->definitionModule = modulename;
  meth_meth_ast_pretty5107->definitionLine = 1078;
  struct UserObject *uo5203 = (struct UserObject*)obj5036;
  uo5203->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace5203 = addmethod2pos(obj5036, "toGrace", &meth_ast_toGrace5203, 11);
int argcv_meth_ast_toGrace5203[] = {1};
meth_meth_ast_toGrace5203->type = alloc_MethodType(1, argcv_meth_ast_toGrace5203);
meth_meth_ast_toGrace5203->type->types[0] = type_Number;
meth_meth_ast_toGrace5203->type->names[0] = "depth";
  meth_meth_ast_toGrace5203->definitionModule = modulename;
  meth_meth_ast_toGrace5203->definitionLine = 1096;
  sourceObject = obj5036;
// Begin line 1048
  setline(1048);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5264 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5265 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5264);
// compilenode returning call5265
  struct UserObject *obj5036_uo = (struct UserObject *)obj5036;
  obj5036_uo->super = call5265;
  sourceObject = obj5036;
// Begin line 1049
  setline(1049);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5266 == NULL) {
    strlit5266 = alloc_String("object");
    gc_root(strlit5266);
  }
// compilenode returning strlit5266
  adddatum2(obj5036, strlit5266, 1);
  sourceObject = obj5036;
// Begin line 1050
  setline(1050);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_body
  adddatum2(obj5036, *var_body, 2);
  sourceObject = obj5036;
// Begin line 1051
  setline(1051);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_superclass_39_
  adddatum2(obj5036, *var_superclass_39_, 3);
  sourceObject = obj5036;
// Begin line 1052
  setline(1052);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5267 = alloc_Boolean(0);
// compilenode returning bool5267
  adddatum2(obj5036, bool5267, 4);
  sourceObject = obj5036;
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5268 == NULL) {
    strlit5268 = alloc_String("object");
    gc_root(strlit5268);
  }
// compilenode returning strlit5268
  adddatum2(obj5036, strlit5268, 5);
  sourceObject = obj5036;
// Begin line 1054
  setline(1054);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5269 = alloc_Boolean(0);
// compilenode returning bool5269
  adddatum2(obj5036, bool5269, 6);
  sourceObject = obj5036;
  sourceObject = obj5036;
  sourceObject = obj5036;
  sourceObject = obj5036;
  sourceObject = obj5036;
objclass5036 = obj5036->class;
  objclass5036->definitionModule = modulename;
  objclass5036->definitionLine = 927;
  (*(struct UserObject *)self).data[0] = lowerouter5036;
  self = oldself5036;
  selfslot = oldselfslot5036;
  stackframe = oldstackframe5036;
  gc_frame_end(frame);
  return obj5036;
}
Object meth_ast_arrayNode5271(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "arrayNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_arrayNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for arrayNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for arrayNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1109
  setline(1109);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_arrayNode
  gc_frame_end(frame);
  return *var_arrayNode;
}
Object meth_ast__apply5287(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ax = &(stackframe->slots[0]);
  *var_ax = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1116
  setline(1116);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5288 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_ax
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call5289 = callmethod(*var_ax, "accept",
    1, partcv, params);
  gc_frame_end(callframe5288);
// compilenode returning call5289
  gc_frame_end(frame);
  return call5289;
}
Object meth_ast_accept5279(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1119
  setline(1119);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1114
  setline(1114);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5281 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call5282 = callmethod(*var_visitor, "visitArray",
    1, partcv, params);
  gc_frame_end(callframe5281);
// compilenode returning call5282
  Object if5280 = done;
  if (istrue(call5282)) {
// Begin line 1115
  setline(1115);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5283 = gc_frame_new();
  int callframe5284 = gc_frame_new();
  partcv[0] = 0;
  Object call5285 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5284);
// compilenode returning call5285
// compilenode returning call5285
  gc_frame_newslot(call5285);
  Object block5286 = alloc_Block(NULL, NULL, "ast", 1115);
  gc_frame_newslot(block5286);
  block_savedest(block5286);
  Object closure5287 = createclosure(2, "_apply");
setclosureframe(closure5287, stackframe);
  addtoclosure(closure5287, var_visitor);
  addtoclosure(closure5287, selfslot);
  struct UserObject *uo5287 = (struct UserObject*)block5286;
  uo5287->data[0] = (Object)closure5287;
  Method *meth_meth_ast__apply5287 = addmethod2pos(block5286, "_apply", &meth_ast__apply5287, 0);
int argcv_meth_ast__apply5287[] = {1};
meth_meth_ast__apply5287->type = alloc_MethodType(1, argcv_meth_ast__apply5287);
  meth_meth_ast__apply5287->definitionModule = modulename;
  meth_meth_ast__apply5287->definitionLine = 1115;
// compilenode returning block5286
  gc_frame_newslot(block5286);
  params[0] = call5285;
  params[1] = block5286;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5291 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5283);
// compilenode returning call5291
    gc_frame_newslot(call5291);
    if5280 = call5291;
  } else {
  }
// compilenode returning if5280
  gc_frame_end(frame);
  return if5280;
}
Object meth_ast_map_40__41_before_40__41_after5292(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_arrayNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1121
  setline(1121);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5293 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call5294 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe5293);
// compilenode returning call5294
// Begin line 1122
  setline(1122);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5295 = gc_frame_new();
  int callframe5296 = gc_frame_new();
  int callframe5297 = gc_frame_new();
  partcv[0] = 0;
  Object call5298 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5297);
// compilenode returning call5298
  gc_frame_newslot(call5298);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe5299 = gc_frame_new();
  int callframe5300 = gc_frame_new();
  Object call5301 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5300);
// compilenode returning call5301
// compilenode returning call5301
  partcv[0] = 0;
  Object call5302 = callmethodflags(call5301, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5299);
// compilenode returning call5302
// compilenode returning call5302
  params[0] = call5298;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5303 = callmethodflags(call5302, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5296);
// compilenode returning call5303
  gc_frame_newslot(call5303);
// compilenode returning *var_arrayNode
  params[0] = call5303;
  partcv[0] = 1;
  Object call5304 = callmethod(*var_arrayNode, "new",
    1, partcv, params);
  gc_frame_end(callframe5295);
// compilenode returning call5304
  *var_n = call5304;
  if (call5304 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1123
  setline(1123);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5305 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5306 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe5305);
// compilenode returning call5306
  *var_n = call5306;
  if (call5306 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1125
  setline(1125);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1122
  setline(1122);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5308 = gc_frame_new();
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5309 = gc_frame_new();
  partcv[0] = 0;
  Object call5310 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5309);
// compilenode returning call5310
  gc_frame_newslot(call5310);
// compilenode returning *var_n
  params[0] = call5310;
  partcv[0] = 1;
  Object call5311 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe5308);
// compilenode returning call5311
// compilenode returning done
// Begin line 1125
  setline(1125);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5312 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5313 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe5312);
// compilenode returning call5313
// Begin line 1126
  setline(1126);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply5317(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5320(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map5314(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1129
  setline(1129);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5315 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block5316 = alloc_Block(NULL, NULL, "ast", 1129);
  gc_frame_newslot(block5316);
  block_savedest(block5316);
  Object closure5317 = createclosure(1, "_apply");
setclosureframe(closure5317, stackframe);
  addtoclosure(closure5317, selfslot);
  struct UserObject *uo5317 = (struct UserObject*)block5316;
  uo5317->data[0] = (Object)closure5317;
  Method *meth_meth_ast__apply5317 = addmethod2pos(block5316, "_apply", &meth_ast__apply5317, 0);
int argcv_meth_ast__apply5317[] = {0};
meth_meth_ast__apply5317->type = alloc_MethodType(1, argcv_meth_ast__apply5317);
  meth_meth_ast__apply5317->definitionModule = modulename;
  meth_meth_ast__apply5317->definitionLine = 1122;
// compilenode returning block5316
  gc_frame_newslot(block5316);
  Object block5319 = alloc_Block(NULL, NULL, "ast", 1129);
  gc_frame_newslot(block5319);
  block_savedest(block5319);
  Object closure5320 = createclosure(1, "_apply");
setclosureframe(closure5320, stackframe);
  addtoclosure(closure5320, selfslot);
  struct UserObject *uo5320 = (struct UserObject*)block5319;
  uo5320->data[0] = (Object)closure5320;
  Method *meth_meth_ast__apply5320 = addmethod2pos(block5319, "_apply", &meth_ast__apply5320, 0);
int argcv_meth_ast__apply5320[] = {0};
meth_meth_ast__apply5320->type = alloc_MethodType(1, argcv_meth_ast__apply5320);
  meth_meth_ast__apply5320->definitionModule = modulename;
  meth_meth_ast__apply5320->definitionLine = 1122;
// compilenode returning block5319
  gc_frame_newslot(block5319);
  params[0] = *var_blk;
  params[1] = block5316;
  params[2] = block5319;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5322 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5315);
// compilenode returning call5322
  gc_frame_end(frame);
  return call5322;
}
Object meth_ast__apply5331(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ai = &(stackframe->slots[0]);
  *var_ai = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1135
  setline(1135);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1134
  setline(1134);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5333 == NULL) {
    strlit5333 = alloc_String("  ");
    gc_root(strlit5333);
  }
// compilenode returning strlit5333
  int op_slot_right_5332 = gc_frame_newslot(strlit5333);
// compilenode returning *var_spc
  int op_slot_left_5332 = gc_frame_newslot(*var_spc);
  params[0] = strlit5333;
  partcv[0] = 1;
  Object opresult5335 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult5335
  *var_spc = opresult5335;
  if (opresult5335 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5344(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ax = &(stackframe->slots[0]);
  *var_ax = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1138
  setline(1138);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5346 = gc_frame_new();
  Object num5348 = alloc_Float64(1);
// compilenode returning num5348
  int op_slot_right_5347 = gc_frame_newslot(num5348);
// compilenode returning *var_depth
  int op_slot_left_5347 = gc_frame_newslot(*var_depth);
  params[0] = num5348;
  partcv[0] = 1;
  Object sum5350 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum5350
  gc_frame_newslot(sum5350);
// compilenode returning *var_ax
  params[0] = sum5350;
  partcv[0] = 1;
  Object call5351 = callmethod(*var_ax, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5346);
// compilenode returning call5351
  int op_slot_right_5345 = gc_frame_newslot(call5351);
// compilenode returning *var_spc
  int op_slot_right_5353 = gc_frame_newslot(*var_spc);
  if (strlit5356 == NULL) {
    strlit5356 = alloc_String("""\x0a""");
    gc_root(strlit5356);
  }
// compilenode returning strlit5356
  int op_slot_right_5355 = gc_frame_newslot(strlit5356);
// compilenode returning *var_s
  int op_slot_left_5355 = gc_frame_newslot(*var_s);
  params[0] = strlit5356;
  partcv[0] = 1;
  Object opresult5358 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5358
  int op_slot_left_5353 = gc_frame_newslot(opresult5358);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5359 = callmethod(opresult5358, "++", 1, partcv, params);
// compilenode returning opresult5359
  int op_slot_left_5345 = gc_frame_newslot(opresult5359);
  params[0] = call5351;
  partcv[0] = 1;
  Object opresult5360 = callmethod(opresult5359, "++", 1, partcv, params);
// compilenode returning opresult5360
  *var_s = opresult5360;
  if (opresult5360 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty5323(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1133
  setline(1133);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1132
  setline(1132);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5324 == NULL) {
    strlit5324 = alloc_String("");
    gc_root(strlit5324);
  }
// compilenode returning strlit5324
  *var_spc = strlit5324;
  if (strlit5324 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1133
  setline(1133);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5325 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_5326 = gc_frame_newslot(*var_depth);
  Object num5328 = alloc_Float64(0);
// compilenode returning num5328
  int op_slot_left_5326 = gc_frame_newslot(num5328);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult5329 = callmethod(num5328, "..", 1, partcv, params);
// compilenode returning opresult5329
  gc_frame_newslot(opresult5329);
  Object block5330 = alloc_Block(NULL, NULL, "ast", 1133);
  gc_frame_newslot(block5330);
  block_savedest(block5330);
  Object closure5331 = createclosure(2, "_apply");
setclosureframe(closure5331, stackframe);
  addtoclosure(closure5331, var_spc);
  addtoclosure(closure5331, selfslot);
  struct UserObject *uo5331 = (struct UserObject*)block5330;
  uo5331->data[0] = (Object)closure5331;
  Method *meth_meth_ast__apply5331 = addmethod2pos(block5330, "_apply", &meth_ast__apply5331, 0);
int argcv_meth_ast__apply5331[] = {1};
meth_meth_ast__apply5331->type = alloc_MethodType(1, argcv_meth_ast__apply5331);
  meth_meth_ast__apply5331->definitionModule = modulename;
  meth_meth_ast__apply5331->definitionLine = 1122;
// compilenode returning block5330
  gc_frame_newslot(block5330);
  params[0] = opresult5329;
  params[1] = block5330;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5338 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5325);
// compilenode returning call5338
// Begin line 1137
  setline(1137);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1136
  setline(1136);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5339 == NULL) {
    strlit5339 = alloc_String("Array");
    gc_root(strlit5339);
  }
// compilenode returning strlit5339
  *var_s = strlit5339;
  if (strlit5339 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1137
  setline(1137);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5340 = gc_frame_new();
  int callframe5341 = gc_frame_new();
  partcv[0] = 0;
  Object call5342 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5341);
// compilenode returning call5342
// compilenode returning call5342
  gc_frame_newslot(call5342);
  Object block5343 = alloc_Block(NULL, NULL, "ast", 1137);
  gc_frame_newslot(block5343);
  block_savedest(block5343);
  Object closure5344 = createclosure(4, "_apply");
setclosureframe(closure5344, stackframe);
  addtoclosure(closure5344, var_depth);
  addtoclosure(closure5344, var_spc);
  addtoclosure(closure5344, var_s);
  addtoclosure(closure5344, selfslot);
  struct UserObject *uo5344 = (struct UserObject*)block5343;
  uo5344->data[0] = (Object)closure5344;
  Method *meth_meth_ast__apply5344 = addmethod2pos(block5343, "_apply", &meth_ast__apply5344, 0);
int argcv_meth_ast__apply5344[] = {1};
meth_meth_ast__apply5344->type = alloc_MethodType(1, argcv_meth_ast__apply5344);
  meth_meth_ast__apply5344->definitionModule = modulename;
  meth_meth_ast__apply5344->definitionLine = 1137;
// compilenode returning block5343
  gc_frame_newslot(block5343);
  params[0] = call5342;
  params[1] = block5343;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5363 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5340);
// compilenode returning call5363
// Begin line 1140
  setline(1140);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply5372(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5374 = gc_frame_new();
  Object num5375 = alloc_Float64(0);
// compilenode returning num5375
  gc_frame_newslot(num5375);
  int callframe5376 = gc_frame_new();
  partcv[0] = 0;
  Object call5377 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5376);
// compilenode returning call5377
// compilenode returning call5377
// compilenode returning *var_i
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres5378 = callmethod(call5377, "[]", 1, partcv, params);
// compilenode returning idxres5378
  params[0] = num5375;
  partcv[0] = 1;
  Object call5379 = callmethod(idxres5378, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5374);
// compilenode returning call5379
  int op_slot_right_5373 = gc_frame_newslot(call5379);
// compilenode returning *var_s
  int op_slot_left_5373 = gc_frame_newslot(*var_s);
  params[0] = call5379;
  partcv[0] = 1;
  Object opresult5381 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5381
  *var_s = opresult5381;
  if (opresult5381 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1149
  setline(1149);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1146
  setline(1146);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5385 = gc_frame_new();
  int callframe5386 = gc_frame_new();
  partcv[0] = 0;
  Object call5387 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5386);
// compilenode returning call5387
// compilenode returning call5387
  partcv[0] = 0;
  Object call5388 = callmethod(call5387, "size",
    1, partcv, params);
  gc_frame_end(callframe5385);
// compilenode returning call5388
// compilenode returning call5388
  int op_slot_right_5384 = gc_frame_newslot(call5388);
// compilenode returning *var_i
  int op_slot_left_5384 = gc_frame_newslot(*var_i);
  params[0] = call5388;
  partcv[0] = 1;
  Object opresult5390 = callmethod(*var_i, "<", 1, partcv, params);
// compilenode returning opresult5390
  Object if5383 = done;
  if (istrue(opresult5390)) {
// Begin line 1148
  setline(1148);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1147
  setline(1147);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5392 == NULL) {
    strlit5392 = alloc_String(", ");
    gc_root(strlit5392);
  }
// compilenode returning strlit5392
  int op_slot_right_5391 = gc_frame_newslot(strlit5392);
// compilenode returning *var_s
  int op_slot_left_5391 = gc_frame_newslot(*var_s);
  params[0] = strlit5392;
  partcv[0] = 1;
  Object opresult5394 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5394
  *var_s = opresult5394;
  if (opresult5394 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if5383 = done;
  } else {
  }
// compilenode returning if5383
  gc_frame_end(frame);
  return if5383;
}
Object meth_ast_toGrace5364(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1144
  setline(1144);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1143
  setline(1143);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5365 == NULL) {
    strlit5365 = alloc_String("[");
    gc_root(strlit5365);
  }
// compilenode returning strlit5365
  *var_s = strlit5365;
  if (strlit5365 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1144
  setline(1144);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5366 = gc_frame_new();
  int callframe5367 = gc_frame_new();
  int callframe5368 = gc_frame_new();
  partcv[0] = 0;
  Object call5369 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5368);
// compilenode returning call5369
// compilenode returning call5369
  partcv[0] = 0;
  Object call5370 = callmethod(call5369, "indices",
    1, partcv, params);
  gc_frame_end(callframe5367);
// compilenode returning call5370
// compilenode returning call5370
  gc_frame_newslot(call5370);
  Object block5371 = alloc_Block(NULL, NULL, "ast", 1144);
  gc_frame_newslot(block5371);
  block_savedest(block5371);
  Object closure5372 = createclosure(2, "_apply");
setclosureframe(closure5372, stackframe);
  addtoclosure(closure5372, var_s);
  addtoclosure(closure5372, selfslot);
  struct UserObject *uo5372 = (struct UserObject*)block5371;
  uo5372->data[0] = (Object)closure5372;
  Method *meth_meth_ast__apply5372 = addmethod2pos(block5371, "_apply", &meth_ast__apply5372, 0);
int argcv_meth_ast__apply5372[] = {1};
meth_meth_ast__apply5372->type = alloc_MethodType(1, argcv_meth_ast__apply5372);
  meth_meth_ast__apply5372->definitionModule = modulename;
  meth_meth_ast__apply5372->definitionLine = 1144;
// compilenode returning block5371
  gc_frame_newslot(block5371);
  params[0] = call5370;
  params[1] = block5371;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5397 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5366);
// compilenode returning call5397
// Begin line 1151
  setline(1151);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1150
  setline(1150);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5399 == NULL) {
    strlit5399 = alloc_String("]");
    gc_root(strlit5399);
  }
// compilenode returning strlit5399
  int op_slot_right_5398 = gc_frame_newslot(strlit5399);
// compilenode returning *var_s
  int op_slot_left_5398 = gc_frame_newslot(*var_s);
  params[0] = strlit5399;
  partcv[0] = 1;
  Object opresult5401 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5401
  *var_s = opresult5401;
  if (opresult5401 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1151
  setline(1151);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new5274(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_arrayNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_values = &(stackframe->slots[0]);
  *var_values = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5275 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5275 = alloc_userobj2(8,9, objclass5275);
  gc_frame_newslot(obj5275);
if (objclass5275 == NULL) {
  glfree(obj5275->class->name);
  obj5275->class->name = "arrayNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5275, self, 0);
  addmethodreal(obj5275,"outer", &reader_ast_outer_5276);
  Object oldself5275 = self;
  struct StackFrameObject *oldstackframe5275 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5275);
  gc_frame_newslot((Object)stackframe);
  self = obj5275;
  Object *oldselfslot5275 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5275 = (*(struct UserObject *)self).data[0], lowerouter5275 = thisouter5275;
  if (inheritingObject5275) {
    struct UserObject *inho5275 = (struct UserObject *)inheritingObject5275;
    while (inho5275->super != GraceDefaultObject) inho5275 = (struct UserObject *)inho5275->super;
    inho5275->super = obj5275;
    self = inheritingObject5275;
    *selfslot = self;
    lowerouter5275 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5275;
  }
if (objclass5275 == NULL) {
  Method *reader5277 = addmethodrealflags(obj5275, "kind",&reader_ast_kind_5277, MFLAG_DEF);
  reader5277->definitionModule = modulename;
  reader5277->definitionLine = 1112;
}
adddatum2(obj5275, alloc_Undefined(), 1);
if (objclass5275 == NULL) {
  Method *reader5278 = addmethodrealflags(obj5275, "value",&reader_ast_value_5278, MFLAG_DEF);
  reader5278->definitionModule = modulename;
  reader5278->definitionLine = 1113;
}
adddatum2(obj5275, alloc_Undefined(), 2);
  struct UserObject *uo5279 = (struct UserObject*)obj5275;
  uo5279->data[3] = emptyclosure;
  Method *meth_meth_ast_accept5279 = addmethod2pos(obj5275, "accept", &meth_ast_accept5279, 3);
int argcv_meth_ast_accept5279[] = {1};
meth_meth_ast_accept5279->type = alloc_MethodType(1, argcv_meth_ast_accept5279);
meth_meth_ast_accept5279->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5279->type->names[0] = "visitor";
  meth_meth_ast_accept5279->definitionModule = modulename;
  meth_meth_ast_accept5279->definitionLine = 1113;
  block_savedest(obj5275);
  Object closure5292 = createclosure(1, "map()before()after");
setclosureframe(closure5292, stackframe);
  addtoclosure(closure5292, var_arrayNode);
  struct UserObject *uo5292 = (struct UserObject*)obj5275;
  uo5292->data[4] = (Object)closure5292;
  Method *meth_meth_ast_map_40__41_before_40__41_after5292 = addmethod2pos(obj5275, "map()before()after", &meth_ast_map_40__41_before_40__41_after5292, 4);
int argcv_meth_ast_map_40__41_before_40__41_after5292[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after5292->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after5292);
  meth_meth_ast_map_40__41_before_40__41_after5292->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after5292->definitionLine = 1120;
  struct UserObject *uo5314 = (struct UserObject*)obj5275;
  uo5314->data[5] = emptyclosure;
  Method *meth_meth_ast_map5314 = addmethod2pos(obj5275, "map", &meth_ast_map5314, 5);
int argcv_meth_ast_map5314[] = {1};
meth_meth_ast_map5314->type = alloc_MethodType(1, argcv_meth_ast_map5314);
  meth_meth_ast_map5314->definitionModule = modulename;
  meth_meth_ast_map5314->definitionLine = 1128;
  struct UserObject *uo5323 = (struct UserObject*)obj5275;
  uo5323->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty5323 = addmethod2pos(obj5275, "pretty", &meth_ast_pretty5323, 6);
int argcv_meth_ast_pretty5323[] = {1};
meth_meth_ast_pretty5323->type = alloc_MethodType(1, argcv_meth_ast_pretty5323);
  meth_meth_ast_pretty5323->definitionModule = modulename;
  meth_meth_ast_pretty5323->definitionLine = 1131;
  struct UserObject *uo5364 = (struct UserObject*)obj5275;
  uo5364->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace5364 = addmethod2pos(obj5275, "toGrace", &meth_ast_toGrace5364, 7);
int argcv_meth_ast_toGrace5364[] = {1};
meth_meth_ast_toGrace5364->type = alloc_MethodType(1, argcv_meth_ast_toGrace5364);
meth_meth_ast_toGrace5364->type->types[0] = type_Number;
meth_meth_ast_toGrace5364->type->names[0] = "depth";
  meth_meth_ast_toGrace5364->definitionModule = modulename;
  meth_meth_ast_toGrace5364->definitionLine = 1142;
  sourceObject = obj5275;
// Begin line 1110
  setline(1110);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5403 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5404 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5403);
// compilenode returning call5404
  struct UserObject *obj5275_uo = (struct UserObject *)obj5275;
  obj5275_uo->super = call5404;
  sourceObject = obj5275;
// Begin line 1111
  setline(1111);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5405 == NULL) {
    strlit5405 = alloc_String("array");
    gc_root(strlit5405);
  }
// compilenode returning strlit5405
  adddatum2(obj5275, strlit5405, 1);
  sourceObject = obj5275;
// Begin line 1112
  setline(1112);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  adddatum2(obj5275, *var_values, 2);
  sourceObject = obj5275;
  sourceObject = obj5275;
  sourceObject = obj5275;
  sourceObject = obj5275;
  sourceObject = obj5275;
objclass5275 = obj5275->class;
  objclass5275->definitionModule = modulename;
  objclass5275->definitionLine = 1102;
  (*(struct UserObject *)self).data[0] = lowerouter5275;
  self = oldself5275;
  selfslot = oldselfslot5275;
  stackframe = oldstackframe5275;
  gc_frame_end(frame);
  return obj5275;
}
Object meth_ast_new5274_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_arrayNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_values = &(stackframe->slots[0]);
  *var_values = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5275 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5275 = alloc_userobj2(8,9, objclass5275);
  gc_frame_newslot(obj5275);
if (objclass5275 == NULL) {
  glfree(obj5275->class->name);
  obj5275->class->name = "arrayNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5275, self, 0);
  addmethodreal(obj5275,"outer", &reader_ast_outer_5276);
  Object oldself5275 = self;
  struct StackFrameObject *oldstackframe5275 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5275);
  gc_frame_newslot((Object)stackframe);
  self = obj5275;
  Object *oldselfslot5275 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5275 = (*(struct UserObject *)self).data[0], lowerouter5275 = thisouter5275;
  if (inheritingObject5275) {
    struct UserObject *inho5275 = (struct UserObject *)inheritingObject5275;
    while (inho5275->super != GraceDefaultObject) inho5275 = (struct UserObject *)inho5275->super;
    inho5275->super = obj5275;
    self = inheritingObject5275;
    *selfslot = self;
    lowerouter5275 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5275;
  }
if (objclass5275 == NULL) {
  Method *reader5277 = addmethodrealflags(obj5275, "kind",&reader_ast_kind_5277, MFLAG_DEF);
  reader5277->definitionModule = modulename;
  reader5277->definitionLine = 1112;
}
adddatum2(obj5275, alloc_Undefined(), 1);
if (objclass5275 == NULL) {
  Method *reader5278 = addmethodrealflags(obj5275, "value",&reader_ast_value_5278, MFLAG_DEF);
  reader5278->definitionModule = modulename;
  reader5278->definitionLine = 1113;
}
adddatum2(obj5275, alloc_Undefined(), 2);
  struct UserObject *uo5279 = (struct UserObject*)obj5275;
  uo5279->data[3] = emptyclosure;
  Method *meth_meth_ast_accept5279 = addmethod2pos(obj5275, "accept", &meth_ast_accept5279, 3);
int argcv_meth_ast_accept5279[] = {1};
meth_meth_ast_accept5279->type = alloc_MethodType(1, argcv_meth_ast_accept5279);
meth_meth_ast_accept5279->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5279->type->names[0] = "visitor";
  meth_meth_ast_accept5279->definitionModule = modulename;
  meth_meth_ast_accept5279->definitionLine = 1113;
  block_savedest(obj5275);
  Object closure5292 = createclosure(1, "map()before()after");
setclosureframe(closure5292, stackframe);
  addtoclosure(closure5292, var_arrayNode);
  struct UserObject *uo5292 = (struct UserObject*)obj5275;
  uo5292->data[4] = (Object)closure5292;
  Method *meth_meth_ast_map_40__41_before_40__41_after5292 = addmethod2pos(obj5275, "map()before()after", &meth_ast_map_40__41_before_40__41_after5292, 4);
int argcv_meth_ast_map_40__41_before_40__41_after5292[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after5292->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after5292);
  meth_meth_ast_map_40__41_before_40__41_after5292->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after5292->definitionLine = 1120;
  struct UserObject *uo5314 = (struct UserObject*)obj5275;
  uo5314->data[5] = emptyclosure;
  Method *meth_meth_ast_map5314 = addmethod2pos(obj5275, "map", &meth_ast_map5314, 5);
int argcv_meth_ast_map5314[] = {1};
meth_meth_ast_map5314->type = alloc_MethodType(1, argcv_meth_ast_map5314);
  meth_meth_ast_map5314->definitionModule = modulename;
  meth_meth_ast_map5314->definitionLine = 1128;
  struct UserObject *uo5323 = (struct UserObject*)obj5275;
  uo5323->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty5323 = addmethod2pos(obj5275, "pretty", &meth_ast_pretty5323, 6);
int argcv_meth_ast_pretty5323[] = {1};
meth_meth_ast_pretty5323->type = alloc_MethodType(1, argcv_meth_ast_pretty5323);
  meth_meth_ast_pretty5323->definitionModule = modulename;
  meth_meth_ast_pretty5323->definitionLine = 1131;
  struct UserObject *uo5364 = (struct UserObject*)obj5275;
  uo5364->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace5364 = addmethod2pos(obj5275, "toGrace", &meth_ast_toGrace5364, 7);
int argcv_meth_ast_toGrace5364[] = {1};
meth_meth_ast_toGrace5364->type = alloc_MethodType(1, argcv_meth_ast_toGrace5364);
meth_meth_ast_toGrace5364->type->types[0] = type_Number;
meth_meth_ast_toGrace5364->type->names[0] = "depth";
  meth_meth_ast_toGrace5364->definitionModule = modulename;
  meth_meth_ast_toGrace5364->definitionLine = 1142;
  sourceObject = obj5275;
// Begin line 1110
  setline(1110);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5403 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5404 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5403);
// compilenode returning call5404
  struct UserObject *obj5275_uo = (struct UserObject *)obj5275;
  obj5275_uo->super = call5404;
  sourceObject = obj5275;
// Begin line 1111
  setline(1111);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5405 == NULL) {
    strlit5405 = alloc_String("array");
    gc_root(strlit5405);
  }
// compilenode returning strlit5405
  adddatum2(obj5275, strlit5405, 1);
  sourceObject = obj5275;
// Begin line 1112
  setline(1112);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  adddatum2(obj5275, *var_values, 2);
  sourceObject = obj5275;
  sourceObject = obj5275;
  sourceObject = obj5275;
  sourceObject = obj5275;
  sourceObject = obj5275;
objclass5275 = obj5275->class;
  objclass5275->definitionModule = modulename;
  objclass5275->definitionLine = 1102;
  (*(struct UserObject *)self).data[0] = lowerouter5275;
  self = oldself5275;
  selfslot = oldselfslot5275;
  stackframe = oldstackframe5275;
  gc_frame_end(frame);
  return obj5275;
}
Object meth_ast_memberNode5407(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "memberNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_memberNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for memberNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for memberNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1154
  setline(1154);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_memberNode
  gc_frame_end(frame);
  return *var_memberNode;
}
Object meth_ast_accept5416(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1163
  setline(1163);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1160
  setline(1160);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5418 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call5419 = callmethod(*var_visitor, "visitMember",
    1, partcv, params);
  gc_frame_end(callframe5418);
// compilenode returning call5419
  Object if5417 = done;
  if (istrue(call5419)) {
// Begin line 1161
  setline(1161);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5420 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe5421 = gc_frame_new();
  partcv[0] = 0;
  Object call5422 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5421);
// compilenode returning call5422
// compilenode returning call5422
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call5423 = callmethod(call5422, "accept",
    1, partcv, params);
  gc_frame_end(callframe5420);
// compilenode returning call5423
    gc_frame_newslot(call5423);
    if5417 = call5423;
  } else {
  }
// compilenode returning if5417
  gc_frame_end(frame);
  return if5417;
}
Object meth_ast_map_40__41_before_40__41_after5424(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_memberNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1165
  setline(1165);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5425 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call5426 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe5425);
// compilenode returning call5426
// Begin line 1166
  setline(1166);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5427 = gc_frame_new();
  int callframe5428 = gc_frame_new();
  partcv[0] = 0;
  Object call5429 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5428);
// compilenode returning call5429
  gc_frame_newslot(call5429);
  int callframe5430 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe5431 = gc_frame_new();
  partcv[0] = 0;
  Object call5432 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5431);
// compilenode returning call5432
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5433 = callmethod(call5432, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe5430);
// compilenode returning call5433
  gc_frame_newslot(call5433);
// compilenode returning *var_memberNode
  params[0] = call5429;
  params[1] = call5433;
  partcv[0] = 2;
  Object call5434 = callmethod(*var_memberNode, "new",
    1, partcv, params);
  gc_frame_end(callframe5427);
// compilenode returning call5434
  *var_n = call5434;
  if (call5434 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1167
  setline(1167);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5435 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5436 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe5435);
// compilenode returning call5436
  *var_n = call5436;
  if (call5436 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1169
  setline(1169);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1161
  setline(1161);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5438 = gc_frame_new();
// Begin line 1168
  setline(1168);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5439 = gc_frame_new();
  partcv[0] = 0;
  Object call5440 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5439);
// compilenode returning call5440
  gc_frame_newslot(call5440);
// compilenode returning *var_n
  params[0] = call5440;
  partcv[0] = 1;
  Object call5441 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe5438);
// compilenode returning call5441
// compilenode returning done
// Begin line 1169
  setline(1169);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5442 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5443 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe5442);
// compilenode returning call5443
// Begin line 1170
  setline(1170);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply5447(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5450(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map5444(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1173
  setline(1173);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5445 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block5446 = alloc_Block(NULL, NULL, "ast", 1173);
  gc_frame_newslot(block5446);
  block_savedest(block5446);
  Object closure5447 = createclosure(1, "_apply");
setclosureframe(closure5447, stackframe);
  addtoclosure(closure5447, selfslot);
  struct UserObject *uo5447 = (struct UserObject*)block5446;
  uo5447->data[0] = (Object)closure5447;
  Method *meth_meth_ast__apply5447 = addmethod2pos(block5446, "_apply", &meth_ast__apply5447, 0);
int argcv_meth_ast__apply5447[] = {0};
meth_meth_ast__apply5447->type = alloc_MethodType(1, argcv_meth_ast__apply5447);
  meth_meth_ast__apply5447->definitionModule = modulename;
  meth_meth_ast__apply5447->definitionLine = 1161;
// compilenode returning block5446
  gc_frame_newslot(block5446);
  Object block5449 = alloc_Block(NULL, NULL, "ast", 1173);
  gc_frame_newslot(block5449);
  block_savedest(block5449);
  Object closure5450 = createclosure(1, "_apply");
setclosureframe(closure5450, stackframe);
  addtoclosure(closure5450, selfslot);
  struct UserObject *uo5450 = (struct UserObject*)block5449;
  uo5450->data[0] = (Object)closure5450;
  Method *meth_meth_ast__apply5450 = addmethod2pos(block5449, "_apply", &meth_ast__apply5450, 0);
int argcv_meth_ast__apply5450[] = {0};
meth_meth_ast__apply5450->type = alloc_MethodType(1, argcv_meth_ast__apply5450);
  meth_meth_ast__apply5450->definitionModule = modulename;
  meth_meth_ast__apply5450->definitionLine = 1161;
// compilenode returning block5449
  gc_frame_newslot(block5449);
  params[0] = *var_blk;
  params[1] = block5446;
  params[2] = block5449;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5452 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5445);
// compilenode returning call5452
  gc_frame_end(frame);
  return call5452;
}
Object meth_ast__apply5461(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1179
  setline(1179);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1178
  setline(1178);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5463 == NULL) {
    strlit5463 = alloc_String("  ");
    gc_root(strlit5463);
  }
// compilenode returning strlit5463
  int op_slot_right_5462 = gc_frame_newslot(strlit5463);
// compilenode returning *var_spc
  int op_slot_left_5462 = gc_frame_newslot(*var_spc);
  params[0] = strlit5463;
  partcv[0] = 1;
  Object opresult5465 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult5465
  *var_spc = opresult5465;
  if (opresult5465 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty5453(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1177
  setline(1177);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1176
  setline(1176);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5454 == NULL) {
    strlit5454 = alloc_String("");
    gc_root(strlit5454);
  }
// compilenode returning strlit5454
  *var_spc = strlit5454;
  if (strlit5454 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1177
  setline(1177);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5455 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_5456 = gc_frame_newslot(*var_depth);
  Object num5458 = alloc_Float64(0);
// compilenode returning num5458
  int op_slot_left_5456 = gc_frame_newslot(num5458);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult5459 = callmethod(num5458, "..", 1, partcv, params);
// compilenode returning opresult5459
  gc_frame_newslot(opresult5459);
  Object block5460 = alloc_Block(NULL, NULL, "ast", 1177);
  gc_frame_newslot(block5460);
  block_savedest(block5460);
  Object closure5461 = createclosure(2, "_apply");
setclosureframe(closure5461, stackframe);
  addtoclosure(closure5461, var_spc);
  addtoclosure(closure5461, selfslot);
  struct UserObject *uo5461 = (struct UserObject*)block5460;
  uo5461->data[0] = (Object)closure5461;
  Method *meth_meth_ast__apply5461 = addmethod2pos(block5460, "_apply", &meth_ast__apply5461, 0);
int argcv_meth_ast__apply5461[] = {1};
meth_meth_ast__apply5461->type = alloc_MethodType(1, argcv_meth_ast__apply5461);
  meth_meth_ast__apply5461->definitionModule = modulename;
  meth_meth_ast__apply5461->definitionLine = 1161;
// compilenode returning block5460
  gc_frame_newslot(block5460);
  params[0] = opresult5459;
  params[1] = block5460;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5468 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5455);
// compilenode returning call5468
// Begin line 1181
  setline(1181);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5470 == NULL) {
    strlit5470 = alloc_String(")""\x0a""");
    gc_root(strlit5470);
  }
// compilenode returning strlit5470
  int op_slot_right_5469 = gc_frame_newslot(strlit5470);
  int callframe5473 = gc_frame_new();
  partcv[0] = 0;
  Object call5474 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5473);
// compilenode returning call5474
// compilenode returning call5474
  int op_slot_right_5472 = gc_frame_newslot(call5474);
  if (strlit5476 == NULL) {
    strlit5476 = alloc_String("Member(");
    gc_root(strlit5476);
  }
// compilenode returning strlit5476
  int op_slot_left_5472 = gc_frame_newslot(strlit5476);
  params[0] = call5474;
  partcv[0] = 1;
  Object opresult5477 = callmethod(strlit5476, "++", 1, partcv, params);
// compilenode returning opresult5477
  int op_slot_left_5469 = gc_frame_newslot(opresult5477);
  params[0] = strlit5470;
  partcv[0] = 1;
  Object opresult5478 = callmethod(opresult5477, "++", 1, partcv, params);
// compilenode returning opresult5478
  *var_s = opresult5478;
  if (opresult5478 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1181
  setline(1181);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5480 = gc_frame_new();
  Object num5482 = alloc_Float64(1);
// compilenode returning num5482
  int op_slot_right_5481 = gc_frame_newslot(num5482);
// compilenode returning *var_depth
  int op_slot_left_5481 = gc_frame_newslot(*var_depth);
  params[0] = num5482;
  partcv[0] = 1;
  Object sum5484 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum5484
  gc_frame_newslot(sum5484);
  int callframe5485 = gc_frame_new();
  partcv[0] = 0;
  Object call5486 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5485);
// compilenode returning call5486
// compilenode returning call5486
  params[0] = sum5484;
  partcv[0] = 1;
  Object call5487 = callmethod(call5486, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5480);
// compilenode returning call5487
  int op_slot_right_5479 = gc_frame_newslot(call5487);
// compilenode returning *var_spc
  int op_slot_right_5489 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_5489 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5491 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5491
  int op_slot_left_5479 = gc_frame_newslot(opresult5491);
  params[0] = call5487;
  partcv[0] = 1;
  Object opresult5492 = callmethod(opresult5491, "++", 1, partcv, params);
// compilenode returning opresult5492
  *var_s = opresult5492;
  if (opresult5492 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1182
  setline(1182);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace5494(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1186
  setline(1186);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1185
  setline(1185);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5495 == NULL) {
    strlit5495 = alloc_String("");
    gc_root(strlit5495);
  }
// compilenode returning strlit5495
  *var_s = strlit5495;
  if (strlit5495 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1192
  setline(1192);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1186
  setline(1186);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5498 == NULL) {
    strlit5498 = alloc_String("prefix");
    gc_root(strlit5498);
  }
// compilenode returning strlit5498
  int op_slot_right_5497 = gc_frame_newslot(strlit5498);
  int callframe5500 = gc_frame_new();
  Object num5501 = alloc_Float64(1);
// compilenode returning num5501
  gc_frame_newslot(num5501);
  Object num5502 = alloc_Float64(6);
// compilenode returning num5502
  gc_frame_newslot(num5502);
  int callframe5503 = gc_frame_new();
  partcv[0] = 0;
  Object call5504 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5503);
// compilenode returning call5504
// compilenode returning call5504
  params[0] = num5501;
  params[1] = num5502;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5505 = callmethod(call5504, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe5500);
// compilenode returning call5505
  int op_slot_left_5497 = gc_frame_newslot(call5505);
  params[0] = strlit5498;
  partcv[0] = 1;
  Object opresult5506 = callmethod(call5505, "==", 1, partcv, params);
// compilenode returning opresult5506
  Object if5496 = done;
  if (istrue(opresult5506)) {
// Begin line 1187
  setline(1187);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5507 = gc_frame_new();
  Object num5508 = alloc_Float64(7);
// compilenode returning num5508
  gc_frame_newslot(num5508);
  int callframe5509 = gc_frame_new();
  int callframe5510 = gc_frame_new();
  partcv[0] = 0;
  Object call5511 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5510);
// compilenode returning call5511
// compilenode returning call5511
  partcv[0] = 0;
  Object call5512 = callmethod(call5511, "size",
    1, partcv, params);
  gc_frame_end(callframe5509);
// compilenode returning call5512
// compilenode returning call5512
  gc_frame_newslot(call5512);
  int callframe5513 = gc_frame_new();
  partcv[0] = 0;
  Object call5514 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5513);
// compilenode returning call5514
// compilenode returning call5514
  params[0] = num5508;
  params[1] = call5512;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5515 = callmethod(call5514, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe5507);
// compilenode returning call5515
  *var_s = call5515;
  if (call5515 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1188
  setline(1188);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5518 = gc_frame_new();
  Object num5519 = alloc_Float64(0);
// compilenode returning num5519
  gc_frame_newslot(num5519);
  int callframe5520 = gc_frame_new();
  partcv[0] = 0;
  Object call5521 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5520);
// compilenode returning call5521
// compilenode returning call5521
  params[0] = num5519;
  partcv[0] = 1;
  Object call5522 = callmethod(call5521, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5518);
// compilenode returning call5522
  int op_slot_right_5517 = gc_frame_newslot(call5522);
  if (strlit5525 == NULL) {
    strlit5525 = alloc_String(" ");
    gc_root(strlit5525);
  }
// compilenode returning strlit5525
  int op_slot_right_5524 = gc_frame_newslot(strlit5525);
// compilenode returning *var_s
  int op_slot_left_5524 = gc_frame_newslot(*var_s);
  params[0] = strlit5525;
  partcv[0] = 1;
  Object opresult5527 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5527
  int op_slot_left_5517 = gc_frame_newslot(opresult5527);
  params[0] = call5522;
  partcv[0] = 1;
  Object opresult5528 = callmethod(opresult5527, "++", 1, partcv, params);
// compilenode returning opresult5528
  *var_s = opresult5528;
  if (opresult5528 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if5496 = done;
  } else {
// Begin line 1191
  setline(1191);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1190
  setline(1190);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5531 = gc_frame_new();
  partcv[0] = 0;
  Object call5532 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5531);
// compilenode returning call5532
// compilenode returning call5532
  int op_slot_right_5530 = gc_frame_newslot(call5532);
  if (strlit5535 == NULL) {
    strlit5535 = alloc_String(".");
    gc_root(strlit5535);
  }
// compilenode returning strlit5535
  int op_slot_right_5534 = gc_frame_newslot(strlit5535);
  int callframe5537 = gc_frame_new();
// compilenode returning *var_depth
  gc_frame_newslot(*var_depth);
  int callframe5538 = gc_frame_new();
  partcv[0] = 0;
  Object call5539 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5538);
// compilenode returning call5539
// compilenode returning call5539
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call5540 = callmethod(call5539, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5537);
// compilenode returning call5540
  int op_slot_left_5534 = gc_frame_newslot(call5540);
  params[0] = strlit5535;
  partcv[0] = 1;
  Object opresult5541 = callmethod(call5540, "++", 1, partcv, params);
// compilenode returning opresult5541
  int op_slot_left_5530 = gc_frame_newslot(opresult5541);
  params[0] = call5532;
  partcv[0] = 1;
  Object opresult5542 = callmethod(opresult5541, "++", 1, partcv, params);
// compilenode returning opresult5542
  *var_s = opresult5542;
  if (opresult5542 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if5496 = done;
  }
// compilenode returning if5496
// Begin line 1192
  setline(1192);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new5410(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_memberNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_what = &(stackframe->slots[0]);
  *var_what = args[curarg];
  curarg++;
  Object *var_in_39_ = &(stackframe->slots[1]);
  *var_in_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5411 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5411 = alloc_userobj2(10,10, objclass5411);
  gc_frame_newslot(obj5411);
if (objclass5411 == NULL) {
  glfree(obj5411->class->name);
  obj5411->class->name = "memberNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5411, self, 0);
  addmethodreal(obj5411,"outer", &reader_ast_outer_5412);
  Object oldself5411 = self;
  struct StackFrameObject *oldstackframe5411 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5411);
  gc_frame_newslot((Object)stackframe);
  self = obj5411;
  Object *oldselfslot5411 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5411 = (*(struct UserObject *)self).data[0], lowerouter5411 = thisouter5411;
  if (inheritingObject5411) {
    struct UserObject *inho5411 = (struct UserObject *)inheritingObject5411;
    while (inho5411->super != GraceDefaultObject) inho5411 = (struct UserObject *)inho5411->super;
    inho5411->super = obj5411;
    self = inheritingObject5411;
    *selfslot = self;
    lowerouter5411 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5411;
  }
if (objclass5411 == NULL) {
  Method *reader5413 = addmethodrealflags(obj5411, "kind",&reader_ast_kind_5413, MFLAG_DEF);
  reader5413->definitionModule = modulename;
  reader5413->definitionLine = 1157;
}
adddatum2(obj5411, alloc_Undefined(), 1);
if (objclass5411 == NULL) {
  Method *reader5414 = addmethodrealflags(obj5411, "value",&reader_ast_value_5414, 0);
  Method *writer5414 = addmethodrealflags(obj5411, "value:=",&writer_ast_value_5414, 0);
  reader5414->definitionModule = modulename;
  writer5414->definitionModule = modulename;
  reader5414->definitionLine = 1158;
  writer5414->definitionLine = 1158;
}
obj5411->flags |= OFLAG_MUTABLE;
adddatum2(obj5411, alloc_Undefined(), 2);
if (objclass5411 == NULL) {
  Method *reader5415 = addmethodrealflags(obj5411, "in",&reader_ast_in_5415, MFLAG_DEF);
  reader5415->definitionModule = modulename;
  reader5415->definitionLine = 1159;
}
adddatum2(obj5411, alloc_Undefined(), 3);
  struct UserObject *uo5416 = (struct UserObject*)obj5411;
  uo5416->data[4] = emptyclosure;
  Method *meth_meth_ast_accept5416 = addmethod2pos(obj5411, "accept", &meth_ast_accept5416, 4);
int argcv_meth_ast_accept5416[] = {1};
meth_meth_ast_accept5416->type = alloc_MethodType(1, argcv_meth_ast_accept5416);
meth_meth_ast_accept5416->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5416->type->names[0] = "visitor";
  meth_meth_ast_accept5416->definitionModule = modulename;
  meth_meth_ast_accept5416->definitionLine = 1159;
  block_savedest(obj5411);
  Object closure5424 = createclosure(1, "map()before()after");
setclosureframe(closure5424, stackframe);
  addtoclosure(closure5424, var_memberNode);
  struct UserObject *uo5424 = (struct UserObject*)obj5411;
  uo5424->data[5] = (Object)closure5424;
  Method *meth_meth_ast_map_40__41_before_40__41_after5424 = addmethod2pos(obj5411, "map()before()after", &meth_ast_map_40__41_before_40__41_after5424, 5);
int argcv_meth_ast_map_40__41_before_40__41_after5424[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after5424->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after5424);
  meth_meth_ast_map_40__41_before_40__41_after5424->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after5424->definitionLine = 1164;
  struct UserObject *uo5444 = (struct UserObject*)obj5411;
  uo5444->data[6] = emptyclosure;
  Method *meth_meth_ast_map5444 = addmethod2pos(obj5411, "map", &meth_ast_map5444, 6);
int argcv_meth_ast_map5444[] = {1};
meth_meth_ast_map5444->type = alloc_MethodType(1, argcv_meth_ast_map5444);
  meth_meth_ast_map5444->definitionModule = modulename;
  meth_meth_ast_map5444->definitionLine = 1172;
  struct UserObject *uo5453 = (struct UserObject*)obj5411;
  uo5453->data[7] = emptyclosure;
  Method *meth_meth_ast_pretty5453 = addmethod2pos(obj5411, "pretty", &meth_ast_pretty5453, 7);
int argcv_meth_ast_pretty5453[] = {1};
meth_meth_ast_pretty5453->type = alloc_MethodType(1, argcv_meth_ast_pretty5453);
  meth_meth_ast_pretty5453->definitionModule = modulename;
  meth_meth_ast_pretty5453->definitionLine = 1175;
  struct UserObject *uo5494 = (struct UserObject*)obj5411;
  uo5494->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace5494 = addmethod2pos(obj5411, "toGrace", &meth_ast_toGrace5494, 8);
int argcv_meth_ast_toGrace5494[] = {1};
meth_meth_ast_toGrace5494->type = alloc_MethodType(1, argcv_meth_ast_toGrace5494);
meth_meth_ast_toGrace5494->type->types[0] = type_Number;
meth_meth_ast_toGrace5494->type->names[0] = "depth";
  meth_meth_ast_toGrace5494->definitionModule = modulename;
  meth_meth_ast_toGrace5494->definitionLine = 1184;
  sourceObject = obj5411;
// Begin line 1155
  setline(1155);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5544 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5545 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5544);
// compilenode returning call5545
  struct UserObject *obj5411_uo = (struct UserObject *)obj5411;
  obj5411_uo->super = call5545;
  sourceObject = obj5411;
// Begin line 1156
  setline(1156);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5546 == NULL) {
    strlit5546 = alloc_String("member");
    gc_root(strlit5546);
  }
// compilenode returning strlit5546
  adddatum2(obj5411, strlit5546, 1);
  sourceObject = obj5411;
// Begin line 1157
  setline(1157);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_what
  adddatum2(obj5411, *var_what, 2);
  sourceObject = obj5411;
// Begin line 1158
  setline(1158);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_in_39_
  adddatum2(obj5411, *var_in_39_, 3);
  sourceObject = obj5411;
  sourceObject = obj5411;
  sourceObject = obj5411;
  sourceObject = obj5411;
  sourceObject = obj5411;
objclass5411 = obj5411->class;
  objclass5411->definitionModule = modulename;
  objclass5411->definitionLine = 1146;
  (*(struct UserObject *)self).data[0] = lowerouter5411;
  self = oldself5411;
  selfslot = oldselfslot5411;
  stackframe = oldstackframe5411;
  gc_frame_end(frame);
  return obj5411;
}
Object meth_ast_new5410_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_memberNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_what = &(stackframe->slots[0]);
  *var_what = args[curarg];
  curarg++;
  Object *var_in_39_ = &(stackframe->slots[1]);
  *var_in_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5411 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5411 = alloc_userobj2(10,10, objclass5411);
  gc_frame_newslot(obj5411);
if (objclass5411 == NULL) {
  glfree(obj5411->class->name);
  obj5411->class->name = "memberNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5411, self, 0);
  addmethodreal(obj5411,"outer", &reader_ast_outer_5412);
  Object oldself5411 = self;
  struct StackFrameObject *oldstackframe5411 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5411);
  gc_frame_newslot((Object)stackframe);
  self = obj5411;
  Object *oldselfslot5411 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5411 = (*(struct UserObject *)self).data[0], lowerouter5411 = thisouter5411;
  if (inheritingObject5411) {
    struct UserObject *inho5411 = (struct UserObject *)inheritingObject5411;
    while (inho5411->super != GraceDefaultObject) inho5411 = (struct UserObject *)inho5411->super;
    inho5411->super = obj5411;
    self = inheritingObject5411;
    *selfslot = self;
    lowerouter5411 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5411;
  }
if (objclass5411 == NULL) {
  Method *reader5413 = addmethodrealflags(obj5411, "kind",&reader_ast_kind_5413, MFLAG_DEF);
  reader5413->definitionModule = modulename;
  reader5413->definitionLine = 1157;
}
adddatum2(obj5411, alloc_Undefined(), 1);
if (objclass5411 == NULL) {
  Method *reader5414 = addmethodrealflags(obj5411, "value",&reader_ast_value_5414, 0);
  Method *writer5414 = addmethodrealflags(obj5411, "value:=",&writer_ast_value_5414, 0);
  reader5414->definitionModule = modulename;
  writer5414->definitionModule = modulename;
  reader5414->definitionLine = 1158;
  writer5414->definitionLine = 1158;
}
obj5411->flags |= OFLAG_MUTABLE;
adddatum2(obj5411, alloc_Undefined(), 2);
if (objclass5411 == NULL) {
  Method *reader5415 = addmethodrealflags(obj5411, "in",&reader_ast_in_5415, MFLAG_DEF);
  reader5415->definitionModule = modulename;
  reader5415->definitionLine = 1159;
}
adddatum2(obj5411, alloc_Undefined(), 3);
  struct UserObject *uo5416 = (struct UserObject*)obj5411;
  uo5416->data[4] = emptyclosure;
  Method *meth_meth_ast_accept5416 = addmethod2pos(obj5411, "accept", &meth_ast_accept5416, 4);
int argcv_meth_ast_accept5416[] = {1};
meth_meth_ast_accept5416->type = alloc_MethodType(1, argcv_meth_ast_accept5416);
meth_meth_ast_accept5416->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5416->type->names[0] = "visitor";
  meth_meth_ast_accept5416->definitionModule = modulename;
  meth_meth_ast_accept5416->definitionLine = 1159;
  block_savedest(obj5411);
  Object closure5424 = createclosure(1, "map()before()after");
setclosureframe(closure5424, stackframe);
  addtoclosure(closure5424, var_memberNode);
  struct UserObject *uo5424 = (struct UserObject*)obj5411;
  uo5424->data[5] = (Object)closure5424;
  Method *meth_meth_ast_map_40__41_before_40__41_after5424 = addmethod2pos(obj5411, "map()before()after", &meth_ast_map_40__41_before_40__41_after5424, 5);
int argcv_meth_ast_map_40__41_before_40__41_after5424[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after5424->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after5424);
  meth_meth_ast_map_40__41_before_40__41_after5424->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after5424->definitionLine = 1164;
  struct UserObject *uo5444 = (struct UserObject*)obj5411;
  uo5444->data[6] = emptyclosure;
  Method *meth_meth_ast_map5444 = addmethod2pos(obj5411, "map", &meth_ast_map5444, 6);
int argcv_meth_ast_map5444[] = {1};
meth_meth_ast_map5444->type = alloc_MethodType(1, argcv_meth_ast_map5444);
  meth_meth_ast_map5444->definitionModule = modulename;
  meth_meth_ast_map5444->definitionLine = 1172;
  struct UserObject *uo5453 = (struct UserObject*)obj5411;
  uo5453->data[7] = emptyclosure;
  Method *meth_meth_ast_pretty5453 = addmethod2pos(obj5411, "pretty", &meth_ast_pretty5453, 7);
int argcv_meth_ast_pretty5453[] = {1};
meth_meth_ast_pretty5453->type = alloc_MethodType(1, argcv_meth_ast_pretty5453);
  meth_meth_ast_pretty5453->definitionModule = modulename;
  meth_meth_ast_pretty5453->definitionLine = 1175;
  struct UserObject *uo5494 = (struct UserObject*)obj5411;
  uo5494->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace5494 = addmethod2pos(obj5411, "toGrace", &meth_ast_toGrace5494, 8);
int argcv_meth_ast_toGrace5494[] = {1};
meth_meth_ast_toGrace5494->type = alloc_MethodType(1, argcv_meth_ast_toGrace5494);
meth_meth_ast_toGrace5494->type->types[0] = type_Number;
meth_meth_ast_toGrace5494->type->names[0] = "depth";
  meth_meth_ast_toGrace5494->definitionModule = modulename;
  meth_meth_ast_toGrace5494->definitionLine = 1184;
  sourceObject = obj5411;
// Begin line 1155
  setline(1155);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5544 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5545 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5544);
// compilenode returning call5545
  struct UserObject *obj5411_uo = (struct UserObject *)obj5411;
  obj5411_uo->super = call5545;
  sourceObject = obj5411;
// Begin line 1156
  setline(1156);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5546 == NULL) {
    strlit5546 = alloc_String("member");
    gc_root(strlit5546);
  }
// compilenode returning strlit5546
  adddatum2(obj5411, strlit5546, 1);
  sourceObject = obj5411;
// Begin line 1157
  setline(1157);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_what
  adddatum2(obj5411, *var_what, 2);
  sourceObject = obj5411;
// Begin line 1158
  setline(1158);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_in_39_
  adddatum2(obj5411, *var_in_39_, 3);
  sourceObject = obj5411;
  sourceObject = obj5411;
  sourceObject = obj5411;
  sourceObject = obj5411;
  sourceObject = obj5411;
objclass5411 = obj5411->class;
  objclass5411->definitionModule = modulename;
  objclass5411->definitionLine = 1146;
  (*(struct UserObject *)self).data[0] = lowerouter5411;
  self = oldself5411;
  selfslot = oldselfslot5411;
  stackframe = oldstackframe5411;
  gc_frame_end(frame);
  return obj5411;
}
Object meth_ast_genericNode5548(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "genericNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for genericNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for genericNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1195
  setline(1195);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_genericNode
  gc_frame_end(frame);
  return *var_genericNode;
}
Object meth_ast__apply5569(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1204
  setline(1204);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5570 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_p
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call5571 = callmethod(*var_p, "accept",
    1, partcv, params);
  gc_frame_end(callframe5570);
// compilenode returning call5571
  gc_frame_end(frame);
  return call5571;
}
Object meth_ast_accept5557(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1207
  setline(1207);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1201
  setline(1201);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5559 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call5560 = callmethod(*var_visitor, "visitGeneric",
    1, partcv, params);
  gc_frame_end(callframe5559);
// compilenode returning call5560
  Object if5558 = done;
  if (istrue(call5560)) {
// Begin line 1202
  setline(1202);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5561 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe5562 = gc_frame_new();
  partcv[0] = 0;
  Object call5563 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5562);
// compilenode returning call5563
// compilenode returning call5563
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call5564 = callmethod(call5563, "accept",
    1, partcv, params);
  gc_frame_end(callframe5561);
// compilenode returning call5564
// Begin line 1203
  setline(1203);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5565 = gc_frame_new();
  int callframe5566 = gc_frame_new();
  partcv[0] = 0;
  Object call5567 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5566);
// compilenode returning call5567
// compilenode returning call5567
  gc_frame_newslot(call5567);
  Object block5568 = alloc_Block(NULL, NULL, "ast", 1203);
  gc_frame_newslot(block5568);
  block_savedest(block5568);
  Object closure5569 = createclosure(2, "_apply");
setclosureframe(closure5569, stackframe);
  addtoclosure(closure5569, var_visitor);
  addtoclosure(closure5569, selfslot);
  struct UserObject *uo5569 = (struct UserObject*)block5568;
  uo5569->data[0] = (Object)closure5569;
  Method *meth_meth_ast__apply5569 = addmethod2pos(block5568, "_apply", &meth_ast__apply5569, 0);
int argcv_meth_ast__apply5569[] = {1};
meth_meth_ast__apply5569->type = alloc_MethodType(1, argcv_meth_ast__apply5569);
  meth_meth_ast__apply5569->definitionModule = modulename;
  meth_meth_ast__apply5569->definitionLine = 1203;
// compilenode returning block5568
  gc_frame_newslot(block5568);
  params[0] = call5567;
  params[1] = block5568;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5573 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5565);
// compilenode returning call5573
    gc_frame_newslot(call5573);
    if5558 = call5573;
  } else {
  }
// compilenode returning if5558
  gc_frame_end(frame);
  return if5558;
}
Object meth_ast_map_40__41_before_40__41_after5574(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1209
  setline(1209);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5575 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call5576 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe5575);
// compilenode returning call5576
// Begin line 1210
  setline(1210);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5577 = gc_frame_new();
  int callframe5578 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe5579 = gc_frame_new();
  partcv[0] = 0;
  Object call5580 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5579);
// compilenode returning call5580
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5581 = callmethod(call5580, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe5578);
// compilenode returning call5581
  gc_frame_newslot(call5581);
  int callframe5582 = gc_frame_new();
  int callframe5583 = gc_frame_new();
  partcv[0] = 0;
  Object call5584 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5583);
// compilenode returning call5584
  gc_frame_newslot(call5584);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe5585 = gc_frame_new();
  int callframe5586 = gc_frame_new();
  Object call5587 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5586);
// compilenode returning call5587
// compilenode returning call5587
  partcv[0] = 0;
  Object call5588 = callmethodflags(call5587, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5585);
// compilenode returning call5588
// compilenode returning call5588
  params[0] = call5584;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5589 = callmethodflags(call5588, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5582);
// compilenode returning call5589
  gc_frame_newslot(call5589);
// compilenode returning *var_genericNode
  params[0] = call5581;
  params[1] = call5589;
  partcv[0] = 2;
  Object call5590 = callmethod(*var_genericNode, "new",
    1, partcv, params);
  gc_frame_end(callframe5577);
// compilenode returning call5590
  *var_n = call5590;
  if (call5590 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1211
  setline(1211);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5591 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5592 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe5591);
// compilenode returning call5592
  *var_n = call5592;
  if (call5592 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1213
  setline(1213);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1210
  setline(1210);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5594 = gc_frame_new();
// Begin line 1212
  setline(1212);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5595 = gc_frame_new();
  partcv[0] = 0;
  Object call5596 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5595);
// compilenode returning call5596
  gc_frame_newslot(call5596);
// compilenode returning *var_n
  params[0] = call5596;
  partcv[0] = 1;
  Object call5597 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe5594);
// compilenode returning call5597
// compilenode returning done
// Begin line 1213
  setline(1213);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5598 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5599 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe5598);
// compilenode returning call5599
// Begin line 1214
  setline(1214);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply5603(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5606(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map5600(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5601 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block5602 = alloc_Block(NULL, NULL, "ast", 1217);
  gc_frame_newslot(block5602);
  block_savedest(block5602);
  Object closure5603 = createclosure(1, "_apply");
setclosureframe(closure5603, stackframe);
  addtoclosure(closure5603, selfslot);
  struct UserObject *uo5603 = (struct UserObject*)block5602;
  uo5603->data[0] = (Object)closure5603;
  Method *meth_meth_ast__apply5603 = addmethod2pos(block5602, "_apply", &meth_ast__apply5603, 0);
int argcv_meth_ast__apply5603[] = {0};
meth_meth_ast__apply5603->type = alloc_MethodType(1, argcv_meth_ast__apply5603);
  meth_meth_ast__apply5603->definitionModule = modulename;
  meth_meth_ast__apply5603->definitionLine = 1210;
// compilenode returning block5602
  gc_frame_newslot(block5602);
  Object block5605 = alloc_Block(NULL, NULL, "ast", 1217);
  gc_frame_newslot(block5605);
  block_savedest(block5605);
  Object closure5606 = createclosure(1, "_apply");
setclosureframe(closure5606, stackframe);
  addtoclosure(closure5606, selfslot);
  struct UserObject *uo5606 = (struct UserObject*)block5605;
  uo5606->data[0] = (Object)closure5606;
  Method *meth_meth_ast__apply5606 = addmethod2pos(block5605, "_apply", &meth_ast__apply5606, 0);
int argcv_meth_ast__apply5606[] = {0};
meth_meth_ast__apply5606->type = alloc_MethodType(1, argcv_meth_ast__apply5606);
  meth_meth_ast__apply5606->definitionModule = modulename;
  meth_meth_ast__apply5606->definitionLine = 1210;
// compilenode returning block5605
  gc_frame_newslot(block5605);
  params[0] = *var_blk;
  params[1] = block5602;
  params[2] = block5605;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5608 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5601);
// compilenode returning call5608
  gc_frame_end(frame);
  return call5608;
}
Object meth_ast__apply5626(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1222
  setline(1222);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5628 = gc_frame_new();
  Object num5629 = alloc_Float64(0);
// compilenode returning num5629
  gc_frame_newslot(num5629);
// compilenode returning *var_p
  params[0] = num5629;
  partcv[0] = 1;
  Object call5630 = callmethod(*var_p, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5628);
// compilenode returning call5630
  int op_slot_right_5627 = gc_frame_newslot(call5630);
// compilenode returning *var_s
  int op_slot_left_5627 = gc_frame_newslot(*var_s);
  params[0] = call5630;
  partcv[0] = 1;
  Object opresult5632 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5632
  *var_s = opresult5632;
  if (opresult5632 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1224
  setline(1224);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1223
  setline(1223);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5635 == NULL) {
    strlit5635 = alloc_String(",");
    gc_root(strlit5635);
  }
// compilenode returning strlit5635
  int op_slot_right_5634 = gc_frame_newslot(strlit5635);
// compilenode returning *var_s
  int op_slot_left_5634 = gc_frame_newslot(*var_s);
  params[0] = strlit5635;
  partcv[0] = 1;
  Object opresult5637 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5637
  *var_s = opresult5637;
  if (opresult5637 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty5609(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1221
  setline(1221);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1220
  setline(1220);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5611 == NULL) {
    strlit5611 = alloc_String("<");
    gc_root(strlit5611);
  }
// compilenode returning strlit5611
  int op_slot_right_5610 = gc_frame_newslot(strlit5611);
  int callframe5614 = gc_frame_new();
  int callframe5615 = gc_frame_new();
  partcv[0] = 0;
  Object call5616 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5615);
// compilenode returning call5616
// compilenode returning call5616
  partcv[0] = 0;
  Object call5617 = callmethod(call5616, "value",
    1, partcv, params);
  gc_frame_end(callframe5614);
// compilenode returning call5617
// compilenode returning call5617
  int op_slot_right_5613 = gc_frame_newslot(call5617);
  if (strlit5619 == NULL) {
    strlit5619 = alloc_String("Generic(");
    gc_root(strlit5619);
  }
// compilenode returning strlit5619
  int op_slot_left_5613 = gc_frame_newslot(strlit5619);
  params[0] = call5617;
  partcv[0] = 1;
  Object opresult5620 = callmethod(strlit5619, "++", 1, partcv, params);
// compilenode returning opresult5620
  int op_slot_left_5610 = gc_frame_newslot(opresult5620);
  params[0] = strlit5611;
  partcv[0] = 1;
  Object opresult5621 = callmethod(opresult5620, "++", 1, partcv, params);
// compilenode returning opresult5621
  *var_s = opresult5621;
  if (opresult5621 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1221
  setline(1221);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5622 = gc_frame_new();
  int callframe5623 = gc_frame_new();
  partcv[0] = 0;
  Object call5624 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5623);
// compilenode returning call5624
  gc_frame_newslot(call5624);
  Object block5625 = alloc_Block(NULL, NULL, "ast", 1221);
  gc_frame_newslot(block5625);
  block_savedest(block5625);
  Object closure5626 = createclosure(2, "_apply");
setclosureframe(closure5626, stackframe);
  addtoclosure(closure5626, var_s);
  addtoclosure(closure5626, selfslot);
  struct UserObject *uo5626 = (struct UserObject*)block5625;
  uo5626->data[0] = (Object)closure5626;
  Method *meth_meth_ast__apply5626 = addmethod2pos(block5625, "_apply", &meth_ast__apply5626, 0);
int argcv_meth_ast__apply5626[] = {1};
meth_meth_ast__apply5626->type = alloc_MethodType(1, argcv_meth_ast__apply5626);
  meth_meth_ast__apply5626->definitionModule = modulename;
  meth_meth_ast__apply5626->definitionLine = 1220;
// compilenode returning block5625
  gc_frame_newslot(block5625);
  params[0] = call5624;
  params[1] = block5625;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5640 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5622);
// compilenode returning call5640
// Begin line 1226
  setline(1226);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5642 == NULL) {
    strlit5642 = alloc_String(">)");
    gc_root(strlit5642);
  }
// compilenode returning strlit5642
  int op_slot_right_5641 = gc_frame_newslot(strlit5642);
// compilenode returning *var_s
  int op_slot_left_5641 = gc_frame_newslot(*var_s);
  params[0] = strlit5642;
  partcv[0] = 1;
  Object opresult5644 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5644
  gc_frame_end(frame);
  return opresult5644;
}
Object meth_ast__apply5660(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1230
  setline(1230);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5662 = gc_frame_new();
  Object num5663 = alloc_Float64(0);
// compilenode returning num5663
  gc_frame_newslot(num5663);
  int callframe5664 = gc_frame_new();
  partcv[0] = 0;
  Object call5665 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5664);
// compilenode returning call5665
// compilenode returning call5665
// compilenode returning *var_i
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres5666 = callmethod(call5665, "[]", 1, partcv, params);
// compilenode returning idxres5666
  params[0] = num5663;
  partcv[0] = 1;
  Object call5667 = callmethod(idxres5666, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5662);
// compilenode returning call5667
  int op_slot_right_5661 = gc_frame_newslot(call5667);
// compilenode returning *var_s
  int op_slot_left_5661 = gc_frame_newslot(*var_s);
  params[0] = call5667;
  partcv[0] = 1;
  Object opresult5669 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5669
  *var_s = opresult5669;
  if (opresult5669 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1234
  setline(1234);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1231
  setline(1231);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5673 = gc_frame_new();
  int callframe5674 = gc_frame_new();
  partcv[0] = 0;
  Object call5675 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5674);
// compilenode returning call5675
// compilenode returning call5675
  partcv[0] = 0;
  Object call5676 = callmethod(call5675, "size",
    1, partcv, params);
  gc_frame_end(callframe5673);
// compilenode returning call5676
// compilenode returning call5676
  int op_slot_right_5672 = gc_frame_newslot(call5676);
// compilenode returning *var_i
  int op_slot_left_5672 = gc_frame_newslot(*var_i);
  params[0] = call5676;
  partcv[0] = 1;
  Object opresult5678 = callmethod(*var_i, "<", 1, partcv, params);
// compilenode returning opresult5678
  Object if5671 = done;
  if (istrue(opresult5678)) {
// Begin line 1233
  setline(1233);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1232
  setline(1232);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5680 == NULL) {
    strlit5680 = alloc_String(", ");
    gc_root(strlit5680);
  }
// compilenode returning strlit5680
  int op_slot_right_5679 = gc_frame_newslot(strlit5680);
// compilenode returning *var_s
  int op_slot_left_5679 = gc_frame_newslot(*var_s);
  params[0] = strlit5680;
  partcv[0] = 1;
  Object opresult5682 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5682
  *var_s = opresult5682;
  if (opresult5682 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if5671 = done;
  } else {
  }
// compilenode returning if5671
  gc_frame_end(frame);
  return if5671;
}
Object meth_ast_toGrace5645(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1229
  setline(1229);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1228
  setline(1228);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5647 == NULL) {
    strlit5647 = alloc_String("<");
    gc_root(strlit5647);
  }
// compilenode returning strlit5647
  int op_slot_right_5646 = gc_frame_newslot(strlit5647);
  int callframe5649 = gc_frame_new();
  int callframe5650 = gc_frame_new();
  partcv[0] = 0;
  Object call5651 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5650);
// compilenode returning call5651
// compilenode returning call5651
  partcv[0] = 0;
  Object call5652 = callmethod(call5651, "value",
    1, partcv, params);
  gc_frame_end(callframe5649);
// compilenode returning call5652
// compilenode returning call5652
  int op_slot_left_5646 = gc_frame_newslot(call5652);
  params[0] = strlit5647;
  partcv[0] = 1;
  Object opresult5653 = callmethod(call5652, "++", 1, partcv, params);
// compilenode returning opresult5653
  *var_s = opresult5653;
  if (opresult5653 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1229
  setline(1229);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5654 = gc_frame_new();
  int callframe5655 = gc_frame_new();
  int callframe5656 = gc_frame_new();
  partcv[0] = 0;
  Object call5657 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5656);
// compilenode returning call5657
// compilenode returning call5657
  partcv[0] = 0;
  Object call5658 = callmethod(call5657, "indices",
    1, partcv, params);
  gc_frame_end(callframe5655);
// compilenode returning call5658
// compilenode returning call5658
  gc_frame_newslot(call5658);
  Object block5659 = alloc_Block(NULL, NULL, "ast", 1229);
  gc_frame_newslot(block5659);
  block_savedest(block5659);
  Object closure5660 = createclosure(2, "_apply");
setclosureframe(closure5660, stackframe);
  addtoclosure(closure5660, var_s);
  addtoclosure(closure5660, selfslot);
  struct UserObject *uo5660 = (struct UserObject*)block5659;
  uo5660->data[0] = (Object)closure5660;
  Method *meth_meth_ast__apply5660 = addmethod2pos(block5659, "_apply", &meth_ast__apply5660, 0);
int argcv_meth_ast__apply5660[] = {1};
meth_meth_ast__apply5660->type = alloc_MethodType(1, argcv_meth_ast__apply5660);
  meth_meth_ast__apply5660->definitionModule = modulename;
  meth_meth_ast__apply5660->definitionLine = 1229;
// compilenode returning block5659
  gc_frame_newslot(block5659);
  params[0] = call5658;
  params[1] = block5659;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5685 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5654);
// compilenode returning call5685
// Begin line 1236
  setline(1236);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1235
  setline(1235);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5687 == NULL) {
    strlit5687 = alloc_String(">");
    gc_root(strlit5687);
  }
// compilenode returning strlit5687
  int op_slot_right_5686 = gc_frame_newslot(strlit5687);
// compilenode returning *var_s
  int op_slot_left_5686 = gc_frame_newslot(*var_s);
  params[0] = strlit5687;
  partcv[0] = 1;
  Object opresult5689 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5689
  *var_s = opresult5689;
  if (opresult5689 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1236
  setline(1236);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new5551(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_genericNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_base = &(stackframe->slots[0]);
  *var_base = args[curarg];
  curarg++;
  Object *var_params_39_ = &(stackframe->slots[1]);
  *var_params_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5552 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5552 = alloc_userobj2(9,10, objclass5552);
  gc_frame_newslot(obj5552);
if (objclass5552 == NULL) {
  glfree(obj5552->class->name);
  obj5552->class->name = "genericNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5552, self, 0);
  addmethodreal(obj5552,"outer", &reader_ast_outer_5553);
  Object oldself5552 = self;
  struct StackFrameObject *oldstackframe5552 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5552);
  gc_frame_newslot((Object)stackframe);
  self = obj5552;
  Object *oldselfslot5552 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5552 = (*(struct UserObject *)self).data[0], lowerouter5552 = thisouter5552;
  if (inheritingObject5552) {
    struct UserObject *inho5552 = (struct UserObject *)inheritingObject5552;
    while (inho5552->super != GraceDefaultObject) inho5552 = (struct UserObject *)inho5552->super;
    inho5552->super = obj5552;
    self = inheritingObject5552;
    *selfslot = self;
    lowerouter5552 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5552;
  }
if (objclass5552 == NULL) {
  Method *reader5554 = addmethodrealflags(obj5552, "kind",&reader_ast_kind_5554, MFLAG_DEF);
  reader5554->definitionModule = modulename;
  reader5554->definitionLine = 1198;
}
adddatum2(obj5552, alloc_Undefined(), 1);
if (objclass5552 == NULL) {
  Method *reader5555 = addmethodrealflags(obj5552, "value",&reader_ast_value_5555, MFLAG_DEF);
  reader5555->definitionModule = modulename;
  reader5555->definitionLine = 1199;
}
adddatum2(obj5552, alloc_Undefined(), 2);
if (objclass5552 == NULL) {
  Method *reader5556 = addmethodrealflags(obj5552, "params",&reader_ast_params_5556, MFLAG_DEF);
  reader5556->definitionModule = modulename;
  reader5556->definitionLine = 1200;
}
adddatum2(obj5552, alloc_Undefined(), 3);
  struct UserObject *uo5557 = (struct UserObject*)obj5552;
  uo5557->data[4] = emptyclosure;
  Method *meth_meth_ast_accept5557 = addmethod2pos(obj5552, "accept", &meth_ast_accept5557, 4);
int argcv_meth_ast_accept5557[] = {1};
meth_meth_ast_accept5557->type = alloc_MethodType(1, argcv_meth_ast_accept5557);
meth_meth_ast_accept5557->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5557->type->names[0] = "visitor";
  meth_meth_ast_accept5557->definitionModule = modulename;
  meth_meth_ast_accept5557->definitionLine = 1200;
  block_savedest(obj5552);
  Object closure5574 = createclosure(1, "map()before()after");
setclosureframe(closure5574, stackframe);
  addtoclosure(closure5574, var_genericNode);
  struct UserObject *uo5574 = (struct UserObject*)obj5552;
  uo5574->data[5] = (Object)closure5574;
  Method *meth_meth_ast_map_40__41_before_40__41_after5574 = addmethod2pos(obj5552, "map()before()after", &meth_ast_map_40__41_before_40__41_after5574, 5);
int argcv_meth_ast_map_40__41_before_40__41_after5574[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after5574->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after5574);
  meth_meth_ast_map_40__41_before_40__41_after5574->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after5574->definitionLine = 1208;
  struct UserObject *uo5600 = (struct UserObject*)obj5552;
  uo5600->data[6] = emptyclosure;
  Method *meth_meth_ast_map5600 = addmethod2pos(obj5552, "map", &meth_ast_map5600, 6);
int argcv_meth_ast_map5600[] = {1};
meth_meth_ast_map5600->type = alloc_MethodType(1, argcv_meth_ast_map5600);
  meth_meth_ast_map5600->definitionModule = modulename;
  meth_meth_ast_map5600->definitionLine = 1216;
  struct UserObject *uo5609 = (struct UserObject*)obj5552;
  uo5609->data[7] = emptyclosure;
  Method *meth_meth_ast_pretty5609 = addmethod2pos(obj5552, "pretty", &meth_ast_pretty5609, 7);
int argcv_meth_ast_pretty5609[] = {1};
meth_meth_ast_pretty5609->type = alloc_MethodType(1, argcv_meth_ast_pretty5609);
  meth_meth_ast_pretty5609->definitionModule = modulename;
  meth_meth_ast_pretty5609->definitionLine = 1219;
  struct UserObject *uo5645 = (struct UserObject*)obj5552;
  uo5645->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace5645 = addmethod2pos(obj5552, "toGrace", &meth_ast_toGrace5645, 8);
int argcv_meth_ast_toGrace5645[] = {1};
meth_meth_ast_toGrace5645->type = alloc_MethodType(1, argcv_meth_ast_toGrace5645);
meth_meth_ast_toGrace5645->type->types[0] = type_Number;
meth_meth_ast_toGrace5645->type->names[0] = "depth";
  meth_meth_ast_toGrace5645->definitionModule = modulename;
  meth_meth_ast_toGrace5645->definitionLine = 1227;
  sourceObject = obj5552;
// Begin line 1196
  setline(1196);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5691 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5692 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5691);
// compilenode returning call5692
  struct UserObject *obj5552_uo = (struct UserObject *)obj5552;
  obj5552_uo->super = call5692;
  sourceObject = obj5552;
// Begin line 1197
  setline(1197);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5693 == NULL) {
    strlit5693 = alloc_String("generic");
    gc_root(strlit5693);
  }
// compilenode returning strlit5693
  adddatum2(obj5552, strlit5693, 1);
  sourceObject = obj5552;
// Begin line 1198
  setline(1198);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_base
  adddatum2(obj5552, *var_base, 2);
  sourceObject = obj5552;
// Begin line 1199
  setline(1199);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_params_39_
  adddatum2(obj5552, *var_params_39_, 3);
  sourceObject = obj5552;
  sourceObject = obj5552;
  sourceObject = obj5552;
  sourceObject = obj5552;
  sourceObject = obj5552;
objclass5552 = obj5552->class;
  objclass5552->definitionModule = modulename;
  objclass5552->definitionLine = 1190;
  (*(struct UserObject *)self).data[0] = lowerouter5552;
  self = oldself5552;
  selfslot = oldselfslot5552;
  stackframe = oldstackframe5552;
  gc_frame_end(frame);
  return obj5552;
}
Object meth_ast_new5551_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_genericNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_base = &(stackframe->slots[0]);
  *var_base = args[curarg];
  curarg++;
  Object *var_params_39_ = &(stackframe->slots[1]);
  *var_params_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5552 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5552 = alloc_userobj2(9,10, objclass5552);
  gc_frame_newslot(obj5552);
if (objclass5552 == NULL) {
  glfree(obj5552->class->name);
  obj5552->class->name = "genericNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5552, self, 0);
  addmethodreal(obj5552,"outer", &reader_ast_outer_5553);
  Object oldself5552 = self;
  struct StackFrameObject *oldstackframe5552 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5552);
  gc_frame_newslot((Object)stackframe);
  self = obj5552;
  Object *oldselfslot5552 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5552 = (*(struct UserObject *)self).data[0], lowerouter5552 = thisouter5552;
  if (inheritingObject5552) {
    struct UserObject *inho5552 = (struct UserObject *)inheritingObject5552;
    while (inho5552->super != GraceDefaultObject) inho5552 = (struct UserObject *)inho5552->super;
    inho5552->super = obj5552;
    self = inheritingObject5552;
    *selfslot = self;
    lowerouter5552 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5552;
  }
if (objclass5552 == NULL) {
  Method *reader5554 = addmethodrealflags(obj5552, "kind",&reader_ast_kind_5554, MFLAG_DEF);
  reader5554->definitionModule = modulename;
  reader5554->definitionLine = 1198;
}
adddatum2(obj5552, alloc_Undefined(), 1);
if (objclass5552 == NULL) {
  Method *reader5555 = addmethodrealflags(obj5552, "value",&reader_ast_value_5555, MFLAG_DEF);
  reader5555->definitionModule = modulename;
  reader5555->definitionLine = 1199;
}
adddatum2(obj5552, alloc_Undefined(), 2);
if (objclass5552 == NULL) {
  Method *reader5556 = addmethodrealflags(obj5552, "params",&reader_ast_params_5556, MFLAG_DEF);
  reader5556->definitionModule = modulename;
  reader5556->definitionLine = 1200;
}
adddatum2(obj5552, alloc_Undefined(), 3);
  struct UserObject *uo5557 = (struct UserObject*)obj5552;
  uo5557->data[4] = emptyclosure;
  Method *meth_meth_ast_accept5557 = addmethod2pos(obj5552, "accept", &meth_ast_accept5557, 4);
int argcv_meth_ast_accept5557[] = {1};
meth_meth_ast_accept5557->type = alloc_MethodType(1, argcv_meth_ast_accept5557);
meth_meth_ast_accept5557->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5557->type->names[0] = "visitor";
  meth_meth_ast_accept5557->definitionModule = modulename;
  meth_meth_ast_accept5557->definitionLine = 1200;
  block_savedest(obj5552);
  Object closure5574 = createclosure(1, "map()before()after");
setclosureframe(closure5574, stackframe);
  addtoclosure(closure5574, var_genericNode);
  struct UserObject *uo5574 = (struct UserObject*)obj5552;
  uo5574->data[5] = (Object)closure5574;
  Method *meth_meth_ast_map_40__41_before_40__41_after5574 = addmethod2pos(obj5552, "map()before()after", &meth_ast_map_40__41_before_40__41_after5574, 5);
int argcv_meth_ast_map_40__41_before_40__41_after5574[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after5574->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after5574);
  meth_meth_ast_map_40__41_before_40__41_after5574->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after5574->definitionLine = 1208;
  struct UserObject *uo5600 = (struct UserObject*)obj5552;
  uo5600->data[6] = emptyclosure;
  Method *meth_meth_ast_map5600 = addmethod2pos(obj5552, "map", &meth_ast_map5600, 6);
int argcv_meth_ast_map5600[] = {1};
meth_meth_ast_map5600->type = alloc_MethodType(1, argcv_meth_ast_map5600);
  meth_meth_ast_map5600->definitionModule = modulename;
  meth_meth_ast_map5600->definitionLine = 1216;
  struct UserObject *uo5609 = (struct UserObject*)obj5552;
  uo5609->data[7] = emptyclosure;
  Method *meth_meth_ast_pretty5609 = addmethod2pos(obj5552, "pretty", &meth_ast_pretty5609, 7);
int argcv_meth_ast_pretty5609[] = {1};
meth_meth_ast_pretty5609->type = alloc_MethodType(1, argcv_meth_ast_pretty5609);
  meth_meth_ast_pretty5609->definitionModule = modulename;
  meth_meth_ast_pretty5609->definitionLine = 1219;
  struct UserObject *uo5645 = (struct UserObject*)obj5552;
  uo5645->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace5645 = addmethod2pos(obj5552, "toGrace", &meth_ast_toGrace5645, 8);
int argcv_meth_ast_toGrace5645[] = {1};
meth_meth_ast_toGrace5645->type = alloc_MethodType(1, argcv_meth_ast_toGrace5645);
meth_meth_ast_toGrace5645->type->types[0] = type_Number;
meth_meth_ast_toGrace5645->type->names[0] = "depth";
  meth_meth_ast_toGrace5645->definitionModule = modulename;
  meth_meth_ast_toGrace5645->definitionLine = 1227;
  sourceObject = obj5552;
// Begin line 1196
  setline(1196);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5691 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5692 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5691);
// compilenode returning call5692
  struct UserObject *obj5552_uo = (struct UserObject *)obj5552;
  obj5552_uo->super = call5692;
  sourceObject = obj5552;
// Begin line 1197
  setline(1197);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5693 == NULL) {
    strlit5693 = alloc_String("generic");
    gc_root(strlit5693);
  }
// compilenode returning strlit5693
  adddatum2(obj5552, strlit5693, 1);
  sourceObject = obj5552;
// Begin line 1198
  setline(1198);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_base
  adddatum2(obj5552, *var_base, 2);
  sourceObject = obj5552;
// Begin line 1199
  setline(1199);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_params_39_
  adddatum2(obj5552, *var_params_39_, 3);
  sourceObject = obj5552;
  sourceObject = obj5552;
  sourceObject = obj5552;
  sourceObject = obj5552;
  sourceObject = obj5552;
objclass5552 = obj5552->class;
  objclass5552->definitionModule = modulename;
  objclass5552->definitionLine = 1190;
  (*(struct UserObject *)self).data[0] = lowerouter5552;
  self = oldself5552;
  selfslot = oldselfslot5552;
  stackframe = oldstackframe5552;
  gc_frame_end(frame);
  return obj5552;
}
Object meth_ast_identifierNode5695(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "identifierNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for identifierNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for identifierNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1239
  setline(1239);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_identifierNode
  gc_frame_end(frame);
  return *var_identifierNode;
}
Object meth_ast_accept5707(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1253
  setline(1253);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1248
  setline(1248);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5709 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call5710 = callmethod(*var_visitor, "visitIdentifier",
    1, partcv, params);
  gc_frame_end(callframe5709);
// compilenode returning call5710
  Object if5708 = done;
  if (istrue(call5710)) {
// Begin line 1252
  setline(1252);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1249
  setline(1249);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5713 = alloc_Boolean(0);
// compilenode returning bool5713
  int op_slot_right_5712 = gc_frame_newslot(bool5713);
  int callframe5715 = gc_frame_new();
  partcv[0] = 0;
  Object call5716 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5715);
// compilenode returning call5716
// compilenode returning call5716
  int op_slot_left_5712 = gc_frame_newslot(call5716);
  params[0] = bool5713;
  partcv[0] = 1;
  Object opresult5717 = callmethod(call5716, "!=", 1, partcv, params);
// compilenode returning opresult5717
  Object if5711 = done;
  if (istrue(opresult5717)) {
// Begin line 1250
  setline(1250);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5718 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe5719 = gc_frame_new();
  partcv[0] = 0;
  Object call5720 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5719);
// compilenode returning call5720
// compilenode returning call5720
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call5721 = callmethod(call5720, "accept",
    1, partcv, params);
  gc_frame_end(callframe5718);
// compilenode returning call5721
    gc_frame_newslot(call5721);
    if5711 = call5721;
  } else {
  }
// compilenode returning if5711
    gc_frame_newslot(if5711);
    if5708 = if5711;
  } else {
  }
// compilenode returning if5708
  gc_frame_end(frame);
  return if5708;
}
Object meth_ast_map_40__41_before_40__41_after5722(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1255
  setline(1255);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5723 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call5724 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe5723);
// compilenode returning call5724
// Begin line 1256
  setline(1256);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5725 = gc_frame_new();
  int callframe5726 = gc_frame_new();
  partcv[0] = 0;
  Object call5727 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5726);
// compilenode returning call5727
  gc_frame_newslot(call5727);
  int callframe5728 = gc_frame_new();
  partcv[0] = 0;
  Object call5729 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5728);
// compilenode returning call5729
  gc_frame_newslot(call5729);
// compilenode returning *var_util
  params[0] = call5727;
  params[1] = call5729;
  partcv[0] = 2;
  Object call5730 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe5725);
// compilenode returning call5730
// Begin line 1257
  setline(1257);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5731 = gc_frame_new();
  int callframe5732 = gc_frame_new();
  partcv[0] = 0;
  Object call5733 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5732);
// compilenode returning call5733
  gc_frame_newslot(call5733);
  int callframe5734 = gc_frame_new();
  int callframe5735 = gc_frame_new();
  partcv[0] = 0;
  Object call5736 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5735);
// compilenode returning call5736
  gc_frame_newslot(call5736);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// Begin line 1258
  setline(1258);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// Begin line 1257
  setline(1257);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5737 = gc_frame_new();
  int callframe5738 = gc_frame_new();
  Object call5739 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5738);
// compilenode returning call5739
// compilenode returning call5739
  partcv[0] = 0;
  Object call5740 = callmethodflags(call5739, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5737);
// compilenode returning call5740
// compilenode returning call5740
  params[0] = call5736;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 4;
  Object call5741 = callmethodflags(call5740, "maybeMap", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5734);
// compilenode returning call5741
  gc_frame_newslot(call5741);
// compilenode returning *var_identifierNode
  params[0] = call5733;
  params[1] = call5741;
  partcv[0] = 2;
  Object call5742 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe5731);
// compilenode returning call5742
  *var_n = call5742;
  if (call5742 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1260
  setline(1260);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1257
  setline(1257);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5743 = gc_frame_new();
// Begin line 1259
  setline(1259);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5744 = gc_frame_new();
  partcv[0] = 0;
  Object call5745 = callmethodflags(self, "wildcard", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5744);
// compilenode returning call5745
  gc_frame_newslot(call5745);
// compilenode returning *var_n
  params[0] = call5745;
  partcv[0] = 1;
  Object call5746 = callmethod(*var_n, "wildcard:=",
    1, partcv, params);
  gc_frame_end(callframe5743);
// compilenode returning call5746
// compilenode returning done
// Begin line 1261
  setline(1261);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1257
  setline(1257);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5747 = gc_frame_new();
// Begin line 1260
  setline(1260);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5748 = gc_frame_new();
  partcv[0] = 0;
  Object call5749 = callmethodflags(self, "inBind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5748);
// compilenode returning call5749
  gc_frame_newslot(call5749);
// compilenode returning *var_n
  params[0] = call5749;
  partcv[0] = 1;
  Object call5750 = callmethod(*var_n, "inBind:=",
    1, partcv, params);
  gc_frame_end(callframe5747);
// compilenode returning call5750
// compilenode returning done
// Begin line 1262
  setline(1262);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1257
  setline(1257);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5751 = gc_frame_new();
// Begin line 1261
  setline(1261);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5752 = gc_frame_new();
  partcv[0] = 0;
  Object call5753 = callmethodflags(self, "inRequest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5752);
// compilenode returning call5753
  gc_frame_newslot(call5753);
// compilenode returning *var_n
  params[0] = call5753;
  partcv[0] = 1;
  Object call5754 = callmethod(*var_n, "inRequest:=",
    1, partcv, params);
  gc_frame_end(callframe5751);
// compilenode returning call5754
// compilenode returning done
// Begin line 1262
  setline(1262);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5755 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5756 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe5755);
// compilenode returning call5756
  *var_n = call5756;
  if (call5756 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1264
  setline(1264);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1257
  setline(1257);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5758 = gc_frame_new();
// Begin line 1263
  setline(1263);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5759 = gc_frame_new();
  partcv[0] = 0;
  Object call5760 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5759);
// compilenode returning call5760
  gc_frame_newslot(call5760);
// compilenode returning *var_n
  params[0] = call5760;
  partcv[0] = 1;
  Object call5761 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe5758);
// compilenode returning call5761
// compilenode returning done
// Begin line 1270
  setline(1270);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1264
  setline(1264);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5764 == NULL) {
    strlit5764 = alloc_String("identifier");
    gc_root(strlit5764);
  }
// compilenode returning strlit5764
  int op_slot_right_5763 = gc_frame_newslot(strlit5764);
  int callframe5766 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call5767 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe5766);
// compilenode returning call5767
// compilenode returning call5767
  int op_slot_left_5763 = gc_frame_newslot(call5767);
  params[0] = strlit5764;
  partcv[0] = 1;
  Object opresult5768 = callmethod(call5767, "==", 1, partcv, params);
// compilenode returning opresult5768
  Object if5762 = done;
  if (istrue(opresult5768)) {
// Begin line 1266
  setline(1266);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1264
  setline(1264);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5769 = gc_frame_new();
// Begin line 1265
  setline(1265);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5770 = gc_frame_new();
  partcv[0] = 0;
  Object call5771 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5770);
// compilenode returning call5771
  gc_frame_newslot(call5771);
// compilenode returning *var_n
  params[0] = call5771;
  partcv[0] = 1;
  Object call5772 = callmethod(*var_n, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe5769);
// compilenode returning call5772
// compilenode returning done
// Begin line 1267
  setline(1267);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1264
  setline(1264);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5773 = gc_frame_new();
// Begin line 1266
  setline(1266);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5774 = gc_frame_new();
  partcv[0] = 0;
  Object call5775 = callmethodflags(self, "wildcard", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5774);
// compilenode returning call5775
  gc_frame_newslot(call5775);
// compilenode returning *var_n
  params[0] = call5775;
  partcv[0] = 1;
  Object call5776 = callmethod(*var_n, "wildcard:=",
    1, partcv, params);
  gc_frame_end(callframe5773);
// compilenode returning call5776
// compilenode returning done
// Begin line 1268
  setline(1268);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1264
  setline(1264);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5777 = gc_frame_new();
// Begin line 1267
  setline(1267);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5778 = gc_frame_new();
  partcv[0] = 0;
  Object call5779 = callmethodflags(self, "inBind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5778);
// compilenode returning call5779
  gc_frame_newslot(call5779);
// compilenode returning *var_n
  params[0] = call5779;
  partcv[0] = 1;
  Object call5780 = callmethod(*var_n, "inBind:=",
    1, partcv, params);
  gc_frame_end(callframe5777);
// compilenode returning call5780
// compilenode returning done
// Begin line 1269
  setline(1269);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1264
  setline(1264);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5781 = gc_frame_new();
// Begin line 1268
  setline(1268);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5782 = gc_frame_new();
  partcv[0] = 0;
  Object call5783 = callmethodflags(self, "inRequest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5782);
// compilenode returning call5783
  gc_frame_newslot(call5783);
// compilenode returning *var_n
  params[0] = call5783;
  partcv[0] = 1;
  Object call5784 = callmethod(*var_n, "inRequest:=",
    1, partcv, params);
  gc_frame_end(callframe5781);
// compilenode returning call5784
// compilenode returning done
    gc_frame_newslot(done);
    if5762 = done;
  } else {
  }
// compilenode returning if5762
// Begin line 1270
  setline(1270);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5785 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5786 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe5785);
// compilenode returning call5786
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply5790(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5793(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map5787(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1274
  setline(1274);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5788 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block5789 = alloc_Block(NULL, NULL, "ast", 1274);
  gc_frame_newslot(block5789);
  block_savedest(block5789);
  Object closure5790 = createclosure(1, "_apply");
setclosureframe(closure5790, stackframe);
  addtoclosure(closure5790, selfslot);
  struct UserObject *uo5790 = (struct UserObject*)block5789;
  uo5790->data[0] = (Object)closure5790;
  Method *meth_meth_ast__apply5790 = addmethod2pos(block5789, "_apply", &meth_ast__apply5790, 0);
int argcv_meth_ast__apply5790[] = {0};
meth_meth_ast__apply5790->type = alloc_MethodType(1, argcv_meth_ast__apply5790);
  meth_meth_ast__apply5790->definitionModule = modulename;
  meth_meth_ast__apply5790->definitionLine = 1264;
// compilenode returning block5789
  gc_frame_newslot(block5789);
  Object block5792 = alloc_Block(NULL, NULL, "ast", 1274);
  gc_frame_newslot(block5792);
  block_savedest(block5792);
  Object closure5793 = createclosure(1, "_apply");
setclosureframe(closure5793, stackframe);
  addtoclosure(closure5793, selfslot);
  struct UserObject *uo5793 = (struct UserObject*)block5792;
  uo5793->data[0] = (Object)closure5793;
  Method *meth_meth_ast__apply5793 = addmethod2pos(block5792, "_apply", &meth_ast__apply5793, 0);
int argcv_meth_ast__apply5793[] = {0};
meth_meth_ast__apply5793->type = alloc_MethodType(1, argcv_meth_ast__apply5793);
  meth_meth_ast__apply5793->definitionModule = modulename;
  meth_meth_ast__apply5793->definitionLine = 1264;
// compilenode returning block5792
  gc_frame_newslot(block5792);
  params[0] = *var_blk;
  params[1] = block5789;
  params[2] = block5792;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5795 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5788);
// compilenode returning call5795
  gc_frame_end(frame);
  return call5795;
}
Object meth_ast__apply5804(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1280
  setline(1280);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1279
  setline(1279);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5806 == NULL) {
    strlit5806 = alloc_String("  ");
    gc_root(strlit5806);
  }
// compilenode returning strlit5806
  int op_slot_right_5805 = gc_frame_newslot(strlit5806);
// compilenode returning *var_spc
  int op_slot_left_5805 = gc_frame_newslot(*var_spc);
  params[0] = strlit5806;
  partcv[0] = 1;
  Object opresult5808 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult5808
  *var_spc = opresult5808;
  if (opresult5808 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty5796(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1278
  setline(1278);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1277
  setline(1277);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5797 == NULL) {
    strlit5797 = alloc_String("");
    gc_root(strlit5797);
  }
// compilenode returning strlit5797
  *var_spc = strlit5797;
  if (strlit5797 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1278
  setline(1278);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5798 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_5799 = gc_frame_newslot(*var_depth);
  Object num5801 = alloc_Float64(0);
// compilenode returning num5801
  int op_slot_left_5799 = gc_frame_newslot(num5801);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult5802 = callmethod(num5801, "..", 1, partcv, params);
// compilenode returning opresult5802
  gc_frame_newslot(opresult5802);
  Object block5803 = alloc_Block(NULL, NULL, "ast", 1278);
  gc_frame_newslot(block5803);
  block_savedest(block5803);
  Object closure5804 = createclosure(2, "_apply");
setclosureframe(closure5804, stackframe);
  addtoclosure(closure5804, var_spc);
  addtoclosure(closure5804, selfslot);
  struct UserObject *uo5804 = (struct UserObject*)block5803;
  uo5804->data[0] = (Object)closure5804;
  Method *meth_meth_ast__apply5804 = addmethod2pos(block5803, "_apply", &meth_ast__apply5804, 0);
int argcv_meth_ast__apply5804[] = {1};
meth_meth_ast__apply5804->type = alloc_MethodType(1, argcv_meth_ast__apply5804);
  meth_meth_ast__apply5804->definitionModule = modulename;
  meth_meth_ast__apply5804->definitionLine = 1264;
// compilenode returning block5803
  gc_frame_newslot(block5803);
  params[0] = opresult5802;
  params[1] = block5803;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5811 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5798);
// compilenode returning call5811
// Begin line 1282
  setline(1282);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_s = undefined;
// compilenode returning done
// Begin line 1287
  setline(1287);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1282
  setline(1282);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5813 = gc_frame_new();
  partcv[0] = 0;
  Object call5814 = callmethodflags(self, "wildcard", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5813);
// compilenode returning call5814
// compilenode returning call5814
  Object if5812 = done;
  if (istrue(call5814)) {
// Begin line 1284
  setline(1284);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1283
  setline(1283);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5815 == NULL) {
    strlit5815 = alloc_String("WildcardIdentifier");
    gc_root(strlit5815);
  }
// compilenode returning strlit5815
  *var_s = strlit5815;
  if (strlit5815 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if5812 = done;
  } else {
// Begin line 1286
  setline(1286);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1285
  setline(1285);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5818 == NULL) {
    strlit5818 = alloc_String(")");
    gc_root(strlit5818);
  }
// compilenode returning strlit5818
  int op_slot_right_5817 = gc_frame_newslot(strlit5818);
  int callframe5821 = gc_frame_new();
  partcv[0] = 0;
  Object call5822 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5821);
// compilenode returning call5822
// compilenode returning call5822
  int op_slot_right_5820 = gc_frame_newslot(call5822);
  if (strlit5824 == NULL) {
    strlit5824 = alloc_String("Identifier(");
    gc_root(strlit5824);
  }
// compilenode returning strlit5824
  int op_slot_left_5820 = gc_frame_newslot(strlit5824);
  params[0] = call5822;
  partcv[0] = 1;
  Object opresult5825 = callmethod(strlit5824, "++", 1, partcv, params);
// compilenode returning opresult5825
  int op_slot_left_5817 = gc_frame_newslot(opresult5825);
  params[0] = strlit5818;
  partcv[0] = 1;
  Object opresult5826 = callmethod(opresult5825, "++", 1, partcv, params);
// compilenode returning opresult5826
  *var_s = opresult5826;
  if (opresult5826 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if5812 = done;
  }
// compilenode returning if5812
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1287
  setline(1287);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5830 = alloc_Boolean(0);
// compilenode returning bool5830
  int op_slot_right_5829 = gc_frame_newslot(bool5830);
  int callframe5832 = gc_frame_new();
  partcv[0] = 0;
  Object call5833 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5832);
// compilenode returning call5833
// compilenode returning call5833
  int op_slot_left_5829 = gc_frame_newslot(call5833);
  params[0] = bool5830;
  partcv[0] = 1;
  Object opresult5834 = callmethod(call5833, "!=", 1, partcv, params);
// compilenode returning opresult5834
  Object if5828 = done;
  if (istrue(opresult5834)) {
// Begin line 1289
  setline(1289);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1288
  setline(1288);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5836 == NULL) {
    strlit5836 = alloc_String("Type:");
    gc_root(strlit5836);
  }
// compilenode returning strlit5836
  int op_slot_right_5835 = gc_frame_newslot(strlit5836);
// compilenode returning *var_spc
  int op_slot_right_5838 = gc_frame_newslot(*var_spc);
  if (strlit5841 == NULL) {
    strlit5841 = alloc_String("""\x0a""");
    gc_root(strlit5841);
  }
// compilenode returning strlit5841
  int op_slot_right_5840 = gc_frame_newslot(strlit5841);
// compilenode returning *var_s
  int op_slot_left_5840 = gc_frame_newslot(*var_s);
  params[0] = strlit5841;
  partcv[0] = 1;
  Object opresult5843 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5843
  int op_slot_left_5838 = gc_frame_newslot(opresult5843);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5844 = callmethod(opresult5843, "++", 1, partcv, params);
// compilenode returning opresult5844
  int op_slot_left_5835 = gc_frame_newslot(opresult5844);
  params[0] = strlit5836;
  partcv[0] = 1;
  Object opresult5845 = callmethod(opresult5844, "++", 1, partcv, params);
// compilenode returning opresult5845
  *var_s = opresult5845;
  if (opresult5845 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1289
  setline(1289);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5848 = gc_frame_new();
  Object num5850 = alloc_Float64(2);
// compilenode returning num5850
  int op_slot_right_5849 = gc_frame_newslot(num5850);
// compilenode returning *var_depth
  int op_slot_left_5849 = gc_frame_newslot(*var_depth);
  params[0] = num5850;
  partcv[0] = 1;
  Object sum5852 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum5852
  gc_frame_newslot(sum5852);
  int callframe5853 = gc_frame_new();
  partcv[0] = 0;
  Object call5854 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5853);
// compilenode returning call5854
// compilenode returning call5854
  params[0] = sum5852;
  partcv[0] = 1;
  Object call5855 = callmethod(call5854, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5848);
// compilenode returning call5855
  int op_slot_right_5847 = gc_frame_newslot(call5855);
  if (strlit5858 == NULL) {
    strlit5858 = alloc_String("  ");
    gc_root(strlit5858);
  }
// compilenode returning strlit5858
  int op_slot_right_5857 = gc_frame_newslot(strlit5858);
// compilenode returning *var_spc
  int op_slot_right_5860 = gc_frame_newslot(*var_spc);
  if (strlit5863 == NULL) {
    strlit5863 = alloc_String("""\x0a""");
    gc_root(strlit5863);
  }
// compilenode returning strlit5863
  int op_slot_right_5862 = gc_frame_newslot(strlit5863);
// compilenode returning *var_s
  int op_slot_left_5862 = gc_frame_newslot(*var_s);
  params[0] = strlit5863;
  partcv[0] = 1;
  Object opresult5865 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5865
  int op_slot_left_5860 = gc_frame_newslot(opresult5865);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5866 = callmethod(opresult5865, "++", 1, partcv, params);
// compilenode returning opresult5866
  int op_slot_left_5857 = gc_frame_newslot(opresult5866);
  params[0] = strlit5858;
  partcv[0] = 1;
  Object opresult5867 = callmethod(opresult5866, "++", 1, partcv, params);
// compilenode returning opresult5867
  int op_slot_left_5847 = gc_frame_newslot(opresult5867);
  params[0] = call5855;
  partcv[0] = 1;
  Object opresult5868 = callmethod(opresult5867, "++", 1, partcv, params);
// compilenode returning opresult5868
  *var_s = opresult5868;
  if (opresult5868 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if5828 = done;
  } else {
  }
// compilenode returning if5828
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_decType5870(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "decType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for decType (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for decType");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1297
  setline(1297);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1294
  setline(1294);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5873 = alloc_Boolean(0);
// compilenode returning bool5873
  int op_slot_right_5872 = gc_frame_newslot(bool5873);
  int callframe5875 = gc_frame_new();
  partcv[0] = 0;
  Object call5876 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5875);
// compilenode returning call5876
  int op_slot_left_5872 = gc_frame_newslot(call5876);
  params[0] = bool5873;
  partcv[0] = 1;
  Object opresult5877 = callmethod(call5876, "==", 1, partcv, params);
// compilenode returning opresult5877
  Object if5871 = done;
  if (istrue(opresult5877)) {
// Begin line 1295
  setline(1295);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5878 = gc_frame_new();
  if (strlit5879 == NULL) {
    strlit5879 = alloc_String("Unknown");
    gc_root(strlit5879);
  }
// compilenode returning strlit5879
  gc_frame_newslot(strlit5879);
  Object bool5880 = alloc_Boolean(0);
// compilenode returning bool5880
  gc_frame_newslot(bool5880);
// compilenode returning *var_identifierNode
  params[0] = strlit5879;
  params[1] = bool5880;
  partcv[0] = 2;
  Object call5881 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe5878);
// compilenode returning call5881
  return call5881;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if5871 = undefined;
  } else {
  }
// compilenode returning if5871
// Begin line 1298
  setline(1298);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1297
  setline(1297);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5882 = gc_frame_new();
  partcv[0] = 0;
  Object call5883 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5882);
// compilenode returning call5883
  return call5883;
// compilenode returning undefined
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_toGrace5884(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1301
  setline(1301);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_s = undefined;
// compilenode returning done
// Begin line 1306
  setline(1306);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1301
  setline(1301);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5886 = gc_frame_new();
  partcv[0] = 0;
  Object call5887 = callmethodflags(self, "wildcard", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5886);
// compilenode returning call5887
// compilenode returning call5887
  Object if5885 = done;
  if (istrue(call5887)) {
// Begin line 1303
  setline(1303);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1302
  setline(1302);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5888 == NULL) {
    strlit5888 = alloc_String("_");
    gc_root(strlit5888);
  }
// compilenode returning strlit5888
  *var_s = strlit5888;
  if (strlit5888 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if5885 = done;
  } else {
// Begin line 1305
  setline(1305);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1304
  setline(1304);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5890 = gc_frame_new();
  partcv[0] = 0;
  Object call5891 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5890);
// compilenode returning call5891
// compilenode returning call5891
  *var_s = call5891;
  if (call5891 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if5885 = done;
  }
// compilenode returning if5885
// Begin line 1309
  setline(1309);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1306
  setline(1306);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5895 = alloc_Boolean(0);
// compilenode returning bool5895
  int op_slot_right_5894 = gc_frame_newslot(bool5895);
  int callframe5897 = gc_frame_new();
  partcv[0] = 0;
  Object call5898 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5897);
// compilenode returning call5898
// compilenode returning call5898
  int op_slot_left_5894 = gc_frame_newslot(call5898);
  params[0] = bool5895;
  partcv[0] = 1;
  Object opresult5899 = callmethod(call5898, "!=", 1, partcv, params);
// compilenode returning opresult5899
  Object if5893 = done;
  if (istrue(opresult5899)) {
// Begin line 1307
  setline(1307);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5901 = gc_frame_new();
  Object num5903 = alloc_Float64(1);
// compilenode returning num5903
  int op_slot_right_5902 = gc_frame_newslot(num5903);
// compilenode returning *var_depth
  int op_slot_left_5902 = gc_frame_newslot(*var_depth);
  params[0] = num5903;
  partcv[0] = 1;
  Object sum5905 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum5905
  gc_frame_newslot(sum5905);
  int callframe5906 = gc_frame_new();
  partcv[0] = 0;
  Object call5907 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5906);
// compilenode returning call5907
// compilenode returning call5907
  params[0] = sum5905;
  partcv[0] = 1;
  Object call5908 = callmethod(call5907, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5901);
// compilenode returning call5908
  int op_slot_right_5900 = gc_frame_newslot(call5908);
  if (strlit5911 == NULL) {
    strlit5911 = alloc_String(" : ");
    gc_root(strlit5911);
  }
// compilenode returning strlit5911
  int op_slot_right_5910 = gc_frame_newslot(strlit5911);
// compilenode returning *var_s
  int op_slot_left_5910 = gc_frame_newslot(*var_s);
  params[0] = strlit5911;
  partcv[0] = 1;
  Object opresult5913 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5913
  int op_slot_left_5900 = gc_frame_newslot(opresult5913);
  params[0] = call5908;
  partcv[0] = 1;
  Object opresult5914 = callmethod(opresult5913, "++", 1, partcv, params);
// compilenode returning opresult5914
  *var_s = opresult5914;
  if (opresult5914 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if5893 = done;
  } else {
  }
// compilenode returning if5893
// Begin line 1309
  setline(1309);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asString5916(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1312
  setline(1312);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5918 == NULL) {
    strlit5918 = alloc_String("]>");
    gc_root(strlit5918);
  }
// compilenode returning strlit5918
  int op_slot_right_5917 = gc_frame_newslot(strlit5918);
  int callframe5921 = gc_frame_new();
  partcv[0] = 0;
  Object call5922 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5921);
// compilenode returning call5922
  int op_slot_right_5920 = gc_frame_newslot(call5922);
  if (strlit5924 == NULL) {
    strlit5924 = alloc_String("<Identifier[");
    gc_root(strlit5924);
  }
// compilenode returning strlit5924
  int op_slot_left_5920 = gc_frame_newslot(strlit5924);
  params[0] = call5922;
  partcv[0] = 1;
  Object opresult5925 = callmethod(strlit5924, "++", 1, partcv, params);
// compilenode returning opresult5925
  int op_slot_left_5917 = gc_frame_newslot(opresult5925);
  params[0] = strlit5918;
  partcv[0] = 1;
  Object opresult5926 = callmethod(opresult5925, "++", 1, partcv, params);
// compilenode returning opresult5926
  gc_frame_end(frame);
  return opresult5926;
}
Object meth_ast_new5698(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[1]);
  *var_dtype_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5699 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5699 = alloc_userobj2(19,15, objclass5699);
  gc_frame_newslot(obj5699);
if (objclass5699 == NULL) {
  glfree(obj5699->class->name);
  obj5699->class->name = "identifierNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5699, self, 0);
  addmethodreal(obj5699,"outer", &reader_ast_outer_5700);
  Object oldself5699 = self;
  struct StackFrameObject *oldstackframe5699 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5699);
  gc_frame_newslot((Object)stackframe);
  self = obj5699;
  Object *oldselfslot5699 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5699 = (*(struct UserObject *)self).data[0], lowerouter5699 = thisouter5699;
  if (inheritingObject5699) {
    struct UserObject *inho5699 = (struct UserObject *)inheritingObject5699;
    while (inho5699->super != GraceDefaultObject) inho5699 = (struct UserObject *)inho5699->super;
    inho5699->super = obj5699;
    self = inheritingObject5699;
    *selfslot = self;
    lowerouter5699 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5699;
  }
if (objclass5699 == NULL) {
  Method *reader5701 = addmethodrealflags(obj5699, "kind",&reader_ast_kind_5701, MFLAG_DEF);
  reader5701->definitionModule = modulename;
  reader5701->definitionLine = 1242;
}
adddatum2(obj5699, alloc_Undefined(), 1);
if (objclass5699 == NULL) {
  Method *reader5702 = addmethodrealflags(obj5699, "value",&reader_ast_value_5702, 0);
  Method *writer5702 = addmethodrealflags(obj5699, "value:=",&writer_ast_value_5702, 0);
  reader5702->definitionModule = modulename;
  writer5702->definitionModule = modulename;
  reader5702->definitionLine = 1243;
  writer5702->definitionLine = 1243;
}
obj5699->flags |= OFLAG_MUTABLE;
adddatum2(obj5699, alloc_Undefined(), 2);
if (objclass5699 == NULL) {
  Method *reader5703 = addmethodrealflags(obj5699, "wildcard",&reader_ast_wildcard_5703, 0);
  Method *writer5703 = addmethodrealflags(obj5699, "wildcard:=",&writer_ast_wildcard_5703, 0);
  reader5703->definitionModule = modulename;
  writer5703->definitionModule = modulename;
  reader5703->definitionLine = 1244;
  writer5703->definitionLine = 1244;
}
obj5699->flags |= OFLAG_MUTABLE;
adddatum2(obj5699, alloc_Undefined(), 3);
if (objclass5699 == NULL) {
  Method *reader5704 = addmethodrealflags(obj5699, "dtype",&reader_ast_dtype_5704, 0);
  Method *writer5704 = addmethodrealflags(obj5699, "dtype:=",&writer_ast_dtype_5704, 0);
  reader5704->definitionModule = modulename;
  writer5704->definitionModule = modulename;
  reader5704->definitionLine = 1245;
  writer5704->definitionLine = 1245;
}
obj5699->flags |= OFLAG_MUTABLE;
adddatum2(obj5699, alloc_Undefined(), 4);
if (objclass5699 == NULL) {
  Method *reader5705 = addmethodrealflags(obj5699, "inBind",&reader_ast_inBind_5705, 0);
  Method *writer5705 = addmethodrealflags(obj5699, "inBind:=",&writer_ast_inBind_5705, 0);
  reader5705->definitionModule = modulename;
  writer5705->definitionModule = modulename;
  reader5705->definitionLine = 1246;
  writer5705->definitionLine = 1246;
}
obj5699->flags |= OFLAG_MUTABLE;
adddatum2(obj5699, alloc_Undefined(), 5);
if (objclass5699 == NULL) {
  Method *reader5706 = addmethodrealflags(obj5699, "inRequest",&reader_ast_inRequest_5706, 0);
  Method *writer5706 = addmethodrealflags(obj5699, "inRequest:=",&writer_ast_inRequest_5706, 0);
  reader5706->definitionModule = modulename;
  writer5706->definitionModule = modulename;
  reader5706->definitionLine = 1247;
  writer5706->definitionLine = 1247;
}
obj5699->flags |= OFLAG_MUTABLE;
adddatum2(obj5699, alloc_Undefined(), 6);
  struct UserObject *uo5707 = (struct UserObject*)obj5699;
  uo5707->data[7] = emptyclosure;
  Method *meth_meth_ast_accept5707 = addmethod2pos(obj5699, "accept", &meth_ast_accept5707, 7);
int argcv_meth_ast_accept5707[] = {1};
meth_meth_ast_accept5707->type = alloc_MethodType(1, argcv_meth_ast_accept5707);
meth_meth_ast_accept5707->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5707->type->names[0] = "visitor";
  meth_meth_ast_accept5707->definitionModule = modulename;
  meth_meth_ast_accept5707->definitionLine = 1247;
  block_savedest(obj5699);
  Object closure5722 = createclosure(2, "map()before()after");
setclosureframe(closure5722, stackframe);
  addtoclosure(closure5722, var_util);
  addtoclosure(closure5722, var_identifierNode);
  struct UserObject *uo5722 = (struct UserObject*)obj5699;
  uo5722->data[8] = (Object)closure5722;
  Method *meth_meth_ast_map_40__41_before_40__41_after5722 = addmethod2pos(obj5699, "map()before()after", &meth_ast_map_40__41_before_40__41_after5722, 8);
int argcv_meth_ast_map_40__41_before_40__41_after5722[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after5722->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after5722);
  meth_meth_ast_map_40__41_before_40__41_after5722->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after5722->definitionLine = 1254;
  struct UserObject *uo5787 = (struct UserObject*)obj5699;
  uo5787->data[9] = emptyclosure;
  Method *meth_meth_ast_map5787 = addmethod2pos(obj5699, "map", &meth_ast_map5787, 9);
int argcv_meth_ast_map5787[] = {1};
meth_meth_ast_map5787->type = alloc_MethodType(1, argcv_meth_ast_map5787);
  meth_meth_ast_map5787->definitionModule = modulename;
  meth_meth_ast_map5787->definitionLine = 1273;
  struct UserObject *uo5796 = (struct UserObject*)obj5699;
  uo5796->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty5796 = addmethod2pos(obj5699, "pretty", &meth_ast_pretty5796, 10);
int argcv_meth_ast_pretty5796[] = {1};
meth_meth_ast_pretty5796->type = alloc_MethodType(1, argcv_meth_ast_pretty5796);
  meth_meth_ast_pretty5796->definitionModule = modulename;
  meth_meth_ast_pretty5796->definitionLine = 1276;
  block_savedest(obj5699);
  Object closure5870 = createclosure(1, "decType");
setclosureframe(closure5870, stackframe);
  addtoclosure(closure5870, var_identifierNode);
  struct UserObject *uo5870 = (struct UserObject*)obj5699;
  uo5870->data[11] = (Object)closure5870;
  Method *meth_meth_ast_decType5870 = addmethod2pos(obj5699, "decType", &meth_ast_decType5870, 11);
int argcv_meth_ast_decType5870[] = {0};
meth_meth_ast_decType5870->type = alloc_MethodType(1, argcv_meth_ast_decType5870);
  meth_meth_ast_decType5870->definitionModule = modulename;
  meth_meth_ast_decType5870->definitionLine = 1293;
  struct UserObject *uo5884 = (struct UserObject*)obj5699;
  uo5884->data[12] = emptyclosure;
  Method *meth_meth_ast_toGrace5884 = addmethod2pos(obj5699, "toGrace", &meth_ast_toGrace5884, 12);
int argcv_meth_ast_toGrace5884[] = {1};
meth_meth_ast_toGrace5884->type = alloc_MethodType(1, argcv_meth_ast_toGrace5884);
meth_meth_ast_toGrace5884->type->types[0] = type_Number;
meth_meth_ast_toGrace5884->type->names[0] = "depth";
  meth_meth_ast_toGrace5884->definitionModule = modulename;
  meth_meth_ast_toGrace5884->definitionLine = 1299;
  struct UserObject *uo5916 = (struct UserObject*)obj5699;
  uo5916->data[13] = emptyclosure;
  Method *meth_meth_ast_asString5916 = addmethod2pos(obj5699, "asString", &meth_ast_asString5916, 13);
int argcv_meth_ast_asString5916[] = {0};
meth_meth_ast_asString5916->type = alloc_MethodType(1, argcv_meth_ast_asString5916);
  meth_meth_ast_asString5916->definitionModule = modulename;
  meth_meth_ast_asString5916->definitionLine = 1311;
  sourceObject = obj5699;
// Begin line 1240
  setline(1240);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5927 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5928 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5927);
// compilenode returning call5928
  struct UserObject *obj5699_uo = (struct UserObject *)obj5699;
  obj5699_uo->super = call5928;
  sourceObject = obj5699;
// Begin line 1241
  setline(1241);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5929 == NULL) {
    strlit5929 = alloc_String("identifier");
    gc_root(strlit5929);
  }
// compilenode returning strlit5929
  adddatum2(obj5699, strlit5929, 1);
  sourceObject = obj5699;
// Begin line 1242
  setline(1242);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name
  adddatum2(obj5699, *var_name, 2);
  sourceObject = obj5699;
// Begin line 1243
  setline(1243);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5930 = alloc_Boolean(0);
// compilenode returning bool5930
  adddatum2(obj5699, bool5930, 3);
  sourceObject = obj5699;
// Begin line 1244
  setline(1244);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dtype_39_
  adddatum2(obj5699, *var_dtype_39_, 4);
  sourceObject = obj5699;
// Begin line 1245
  setline(1245);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5931 = alloc_Boolean(0);
// compilenode returning bool5931
  adddatum2(obj5699, bool5931, 5);
  sourceObject = obj5699;
// Begin line 1246
  setline(1246);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5932 = alloc_Boolean(0);
// compilenode returning bool5932
  adddatum2(obj5699, bool5932, 6);
  sourceObject = obj5699;
  sourceObject = obj5699;
  sourceObject = obj5699;
  sourceObject = obj5699;
  sourceObject = obj5699;
  sourceObject = obj5699;
  sourceObject = obj5699;
objclass5699 = obj5699->class;
  objclass5699->definitionModule = modulename;
  objclass5699->definitionLine = 1231;
  (*(struct UserObject *)self).data[0] = lowerouter5699;
  self = oldself5699;
  selfslot = oldselfslot5699;
  stackframe = oldstackframe5699;
  gc_frame_end(frame);
  return obj5699;
}
Object meth_ast_new5698_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[1]);
  *var_dtype_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5699 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5699 = alloc_userobj2(19,15, objclass5699);
  gc_frame_newslot(obj5699);
if (objclass5699 == NULL) {
  glfree(obj5699->class->name);
  obj5699->class->name = "identifierNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5699, self, 0);
  addmethodreal(obj5699,"outer", &reader_ast_outer_5700);
  Object oldself5699 = self;
  struct StackFrameObject *oldstackframe5699 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5699);
  gc_frame_newslot((Object)stackframe);
  self = obj5699;
  Object *oldselfslot5699 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5699 = (*(struct UserObject *)self).data[0], lowerouter5699 = thisouter5699;
  if (inheritingObject5699) {
    struct UserObject *inho5699 = (struct UserObject *)inheritingObject5699;
    while (inho5699->super != GraceDefaultObject) inho5699 = (struct UserObject *)inho5699->super;
    inho5699->super = obj5699;
    self = inheritingObject5699;
    *selfslot = self;
    lowerouter5699 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5699;
  }
if (objclass5699 == NULL) {
  Method *reader5701 = addmethodrealflags(obj5699, "kind",&reader_ast_kind_5701, MFLAG_DEF);
  reader5701->definitionModule = modulename;
  reader5701->definitionLine = 1242;
}
adddatum2(obj5699, alloc_Undefined(), 1);
if (objclass5699 == NULL) {
  Method *reader5702 = addmethodrealflags(obj5699, "value",&reader_ast_value_5702, 0);
  Method *writer5702 = addmethodrealflags(obj5699, "value:=",&writer_ast_value_5702, 0);
  reader5702->definitionModule = modulename;
  writer5702->definitionModule = modulename;
  reader5702->definitionLine = 1243;
  writer5702->definitionLine = 1243;
}
obj5699->flags |= OFLAG_MUTABLE;
adddatum2(obj5699, alloc_Undefined(), 2);
if (objclass5699 == NULL) {
  Method *reader5703 = addmethodrealflags(obj5699, "wildcard",&reader_ast_wildcard_5703, 0);
  Method *writer5703 = addmethodrealflags(obj5699, "wildcard:=",&writer_ast_wildcard_5703, 0);
  reader5703->definitionModule = modulename;
  writer5703->definitionModule = modulename;
  reader5703->definitionLine = 1244;
  writer5703->definitionLine = 1244;
}
obj5699->flags |= OFLAG_MUTABLE;
adddatum2(obj5699, alloc_Undefined(), 3);
if (objclass5699 == NULL) {
  Method *reader5704 = addmethodrealflags(obj5699, "dtype",&reader_ast_dtype_5704, 0);
  Method *writer5704 = addmethodrealflags(obj5699, "dtype:=",&writer_ast_dtype_5704, 0);
  reader5704->definitionModule = modulename;
  writer5704->definitionModule = modulename;
  reader5704->definitionLine = 1245;
  writer5704->definitionLine = 1245;
}
obj5699->flags |= OFLAG_MUTABLE;
adddatum2(obj5699, alloc_Undefined(), 4);
if (objclass5699 == NULL) {
  Method *reader5705 = addmethodrealflags(obj5699, "inBind",&reader_ast_inBind_5705, 0);
  Method *writer5705 = addmethodrealflags(obj5699, "inBind:=",&writer_ast_inBind_5705, 0);
  reader5705->definitionModule = modulename;
  writer5705->definitionModule = modulename;
  reader5705->definitionLine = 1246;
  writer5705->definitionLine = 1246;
}
obj5699->flags |= OFLAG_MUTABLE;
adddatum2(obj5699, alloc_Undefined(), 5);
if (objclass5699 == NULL) {
  Method *reader5706 = addmethodrealflags(obj5699, "inRequest",&reader_ast_inRequest_5706, 0);
  Method *writer5706 = addmethodrealflags(obj5699, "inRequest:=",&writer_ast_inRequest_5706, 0);
  reader5706->definitionModule = modulename;
  writer5706->definitionModule = modulename;
  reader5706->definitionLine = 1247;
  writer5706->definitionLine = 1247;
}
obj5699->flags |= OFLAG_MUTABLE;
adddatum2(obj5699, alloc_Undefined(), 6);
  struct UserObject *uo5707 = (struct UserObject*)obj5699;
  uo5707->data[7] = emptyclosure;
  Method *meth_meth_ast_accept5707 = addmethod2pos(obj5699, "accept", &meth_ast_accept5707, 7);
int argcv_meth_ast_accept5707[] = {1};
meth_meth_ast_accept5707->type = alloc_MethodType(1, argcv_meth_ast_accept5707);
meth_meth_ast_accept5707->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5707->type->names[0] = "visitor";
  meth_meth_ast_accept5707->definitionModule = modulename;
  meth_meth_ast_accept5707->definitionLine = 1247;
  block_savedest(obj5699);
  Object closure5722 = createclosure(2, "map()before()after");
setclosureframe(closure5722, stackframe);
  addtoclosure(closure5722, var_util);
  addtoclosure(closure5722, var_identifierNode);
  struct UserObject *uo5722 = (struct UserObject*)obj5699;
  uo5722->data[8] = (Object)closure5722;
  Method *meth_meth_ast_map_40__41_before_40__41_after5722 = addmethod2pos(obj5699, "map()before()after", &meth_ast_map_40__41_before_40__41_after5722, 8);
int argcv_meth_ast_map_40__41_before_40__41_after5722[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after5722->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after5722);
  meth_meth_ast_map_40__41_before_40__41_after5722->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after5722->definitionLine = 1254;
  struct UserObject *uo5787 = (struct UserObject*)obj5699;
  uo5787->data[9] = emptyclosure;
  Method *meth_meth_ast_map5787 = addmethod2pos(obj5699, "map", &meth_ast_map5787, 9);
int argcv_meth_ast_map5787[] = {1};
meth_meth_ast_map5787->type = alloc_MethodType(1, argcv_meth_ast_map5787);
  meth_meth_ast_map5787->definitionModule = modulename;
  meth_meth_ast_map5787->definitionLine = 1273;
  struct UserObject *uo5796 = (struct UserObject*)obj5699;
  uo5796->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty5796 = addmethod2pos(obj5699, "pretty", &meth_ast_pretty5796, 10);
int argcv_meth_ast_pretty5796[] = {1};
meth_meth_ast_pretty5796->type = alloc_MethodType(1, argcv_meth_ast_pretty5796);
  meth_meth_ast_pretty5796->definitionModule = modulename;
  meth_meth_ast_pretty5796->definitionLine = 1276;
  block_savedest(obj5699);
  Object closure5870 = createclosure(1, "decType");
setclosureframe(closure5870, stackframe);
  addtoclosure(closure5870, var_identifierNode);
  struct UserObject *uo5870 = (struct UserObject*)obj5699;
  uo5870->data[11] = (Object)closure5870;
  Method *meth_meth_ast_decType5870 = addmethod2pos(obj5699, "decType", &meth_ast_decType5870, 11);
int argcv_meth_ast_decType5870[] = {0};
meth_meth_ast_decType5870->type = alloc_MethodType(1, argcv_meth_ast_decType5870);
  meth_meth_ast_decType5870->definitionModule = modulename;
  meth_meth_ast_decType5870->definitionLine = 1293;
  struct UserObject *uo5884 = (struct UserObject*)obj5699;
  uo5884->data[12] = emptyclosure;
  Method *meth_meth_ast_toGrace5884 = addmethod2pos(obj5699, "toGrace", &meth_ast_toGrace5884, 12);
int argcv_meth_ast_toGrace5884[] = {1};
meth_meth_ast_toGrace5884->type = alloc_MethodType(1, argcv_meth_ast_toGrace5884);
meth_meth_ast_toGrace5884->type->types[0] = type_Number;
meth_meth_ast_toGrace5884->type->names[0] = "depth";
  meth_meth_ast_toGrace5884->definitionModule = modulename;
  meth_meth_ast_toGrace5884->definitionLine = 1299;
  struct UserObject *uo5916 = (struct UserObject*)obj5699;
  uo5916->data[13] = emptyclosure;
  Method *meth_meth_ast_asString5916 = addmethod2pos(obj5699, "asString", &meth_ast_asString5916, 13);
int argcv_meth_ast_asString5916[] = {0};
meth_meth_ast_asString5916->type = alloc_MethodType(1, argcv_meth_ast_asString5916);
  meth_meth_ast_asString5916->definitionModule = modulename;
  meth_meth_ast_asString5916->definitionLine = 1311;
  sourceObject = obj5699;
// Begin line 1240
  setline(1240);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5927 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5928 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5927);
// compilenode returning call5928
  struct UserObject *obj5699_uo = (struct UserObject *)obj5699;
  obj5699_uo->super = call5928;
  sourceObject = obj5699;
// Begin line 1241
  setline(1241);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5929 == NULL) {
    strlit5929 = alloc_String("identifier");
    gc_root(strlit5929);
  }
// compilenode returning strlit5929
  adddatum2(obj5699, strlit5929, 1);
  sourceObject = obj5699;
// Begin line 1242
  setline(1242);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name
  adddatum2(obj5699, *var_name, 2);
  sourceObject = obj5699;
// Begin line 1243
  setline(1243);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5930 = alloc_Boolean(0);
// compilenode returning bool5930
  adddatum2(obj5699, bool5930, 3);
  sourceObject = obj5699;
// Begin line 1244
  setline(1244);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dtype_39_
  adddatum2(obj5699, *var_dtype_39_, 4);
  sourceObject = obj5699;
// Begin line 1245
  setline(1245);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5931 = alloc_Boolean(0);
// compilenode returning bool5931
  adddatum2(obj5699, bool5931, 5);
  sourceObject = obj5699;
// Begin line 1246
  setline(1246);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5932 = alloc_Boolean(0);
// compilenode returning bool5932
  adddatum2(obj5699, bool5932, 6);
  sourceObject = obj5699;
  sourceObject = obj5699;
  sourceObject = obj5699;
  sourceObject = obj5699;
  sourceObject = obj5699;
  sourceObject = obj5699;
  sourceObject = obj5699;
objclass5699 = obj5699->class;
  objclass5699->definitionModule = modulename;
  objclass5699->definitionLine = 1231;
  (*(struct UserObject *)self).data[0] = lowerouter5699;
  self = oldself5699;
  selfslot = oldselfslot5699;
  stackframe = oldstackframe5699;
  gc_frame_end(frame);
  return obj5699;
}
Object meth_ast_octetsNode5934(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "octetsNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_octetsNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for octetsNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for octetsNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1315
  setline(1315);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_octetsNode
  gc_frame_end(frame);
  return *var_octetsNode;
}
Object meth_ast_accept5942(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1320
  setline(1320);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5943 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call5944 = callmethod(*var_visitor, "visitOctets",
    1, partcv, params);
  gc_frame_end(callframe5943);
// compilenode returning call5944
  gc_frame_end(frame);
  return call5944;
}
Object meth_ast_pretty5945(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1324
  setline(1324);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1323
  setline(1323);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5947 == NULL) {
    strlit5947 = alloc_String(")");
    gc_root(strlit5947);
  }
// compilenode returning strlit5947
  int op_slot_right_5946 = gc_frame_newslot(strlit5947);
  int callframe5950 = gc_frame_new();
  partcv[0] = 0;
  Object call5951 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5950);
// compilenode returning call5951
// compilenode returning call5951
  int op_slot_right_5949 = gc_frame_newslot(call5951);
  if (strlit5953 == NULL) {
    strlit5953 = alloc_String("Octets(");
    gc_root(strlit5953);
  }
// compilenode returning strlit5953
  int op_slot_left_5949 = gc_frame_newslot(strlit5953);
  params[0] = call5951;
  partcv[0] = 1;
  Object opresult5954 = callmethod(strlit5953, "++", 1, partcv, params);
// compilenode returning opresult5954
  int op_slot_left_5946 = gc_frame_newslot(opresult5954);
  params[0] = strlit5947;
  partcv[0] = 1;
  Object opresult5955 = callmethod(opresult5954, "++", 1, partcv, params);
// compilenode returning opresult5955
  gc_frame_end(frame);
  return opresult5955;
}
Object meth_ast_toGrace5956(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1326
  setline(1326);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5957 = gc_frame_new();
  partcv[0] = 0;
  Object call5958 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5957);
// compilenode returning call5958
// compilenode returning call5958
  gc_frame_end(frame);
  return call5958;
}
Object meth_ast_new5937(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5938 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5938 = alloc_userobj2(6,7, objclass5938);
  gc_frame_newslot(obj5938);
if (objclass5938 == NULL) {
  glfree(obj5938->class->name);
  obj5938->class->name = "octetsNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5938, self, 0);
  addmethodreal(obj5938,"outer", &reader_ast_outer_5939);
  Object oldself5938 = self;
  struct StackFrameObject *oldstackframe5938 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5938);
  gc_frame_newslot((Object)stackframe);
  self = obj5938;
  Object *oldselfslot5938 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5938 = (*(struct UserObject *)self).data[0], lowerouter5938 = thisouter5938;
  if (inheritingObject5938) {
    struct UserObject *inho5938 = (struct UserObject *)inheritingObject5938;
    while (inho5938->super != GraceDefaultObject) inho5938 = (struct UserObject *)inho5938->super;
    inho5938->super = obj5938;
    self = inheritingObject5938;
    *selfslot = self;
    lowerouter5938 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5938;
  }
if (objclass5938 == NULL) {
  Method *reader5940 = addmethodrealflags(obj5938, "kind",&reader_ast_kind_5940, MFLAG_DEF);
  reader5940->definitionModule = modulename;
  reader5940->definitionLine = 1318;
}
adddatum2(obj5938, alloc_Undefined(), 1);
if (objclass5938 == NULL) {
  Method *reader5941 = addmethodrealflags(obj5938, "value",&reader_ast_value_5941, MFLAG_DEF);
  reader5941->definitionModule = modulename;
  reader5941->definitionLine = 1319;
}
adddatum2(obj5938, alloc_Undefined(), 2);
  struct UserObject *uo5942 = (struct UserObject*)obj5938;
  uo5942->data[3] = emptyclosure;
  Method *meth_meth_ast_accept5942 = addmethod2pos(obj5938, "accept", &meth_ast_accept5942, 3);
int argcv_meth_ast_accept5942[] = {1};
meth_meth_ast_accept5942->type = alloc_MethodType(1, argcv_meth_ast_accept5942);
meth_meth_ast_accept5942->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5942->type->names[0] = "visitor";
  meth_meth_ast_accept5942->definitionModule = modulename;
  meth_meth_ast_accept5942->definitionLine = 1319;
  struct UserObject *uo5945 = (struct UserObject*)obj5938;
  uo5945->data[4] = emptyclosure;
  Method *meth_meth_ast_pretty5945 = addmethod2pos(obj5938, "pretty", &meth_ast_pretty5945, 4);
int argcv_meth_ast_pretty5945[] = {1};
meth_meth_ast_pretty5945->type = alloc_MethodType(1, argcv_meth_ast_pretty5945);
  meth_meth_ast_pretty5945->definitionModule = modulename;
  meth_meth_ast_pretty5945->definitionLine = 1322;
  struct UserObject *uo5956 = (struct UserObject*)obj5938;
  uo5956->data[5] = emptyclosure;
  Method *meth_meth_ast_toGrace5956 = addmethod2pos(obj5938, "toGrace", &meth_ast_toGrace5956, 5);
int argcv_meth_ast_toGrace5956[] = {1};
meth_meth_ast_toGrace5956->type = alloc_MethodType(1, argcv_meth_ast_toGrace5956);
meth_meth_ast_toGrace5956->type->types[0] = type_Number;
meth_meth_ast_toGrace5956->type->names[0] = "depth";
  meth_meth_ast_toGrace5956->definitionModule = modulename;
  meth_meth_ast_toGrace5956->definitionLine = 1325;
  sourceObject = obj5938;
// Begin line 1316
  setline(1316);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5959 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5960 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5959);
// compilenode returning call5960
  struct UserObject *obj5938_uo = (struct UserObject *)obj5938;
  obj5938_uo->super = call5960;
  sourceObject = obj5938;
// Begin line 1317
  setline(1317);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5961 == NULL) {
    strlit5961 = alloc_String("octets");
    gc_root(strlit5961);
  }
// compilenode returning strlit5961
  adddatum2(obj5938, strlit5961, 1);
  sourceObject = obj5938;
// Begin line 1318
  setline(1318);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  adddatum2(obj5938, *var_n, 2);
  sourceObject = obj5938;
  sourceObject = obj5938;
  sourceObject = obj5938;
objclass5938 = obj5938->class;
  objclass5938->definitionModule = modulename;
  objclass5938->definitionLine = 1307;
  (*(struct UserObject *)self).data[0] = lowerouter5938;
  self = oldself5938;
  selfslot = oldselfslot5938;
  stackframe = oldstackframe5938;
  gc_frame_end(frame);
  return obj5938;
}
Object meth_ast_new5937_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5938 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5938 = alloc_userobj2(6,7, objclass5938);
  gc_frame_newslot(obj5938);
if (objclass5938 == NULL) {
  glfree(obj5938->class->name);
  obj5938->class->name = "octetsNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5938, self, 0);
  addmethodreal(obj5938,"outer", &reader_ast_outer_5939);
  Object oldself5938 = self;
  struct StackFrameObject *oldstackframe5938 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5938);
  gc_frame_newslot((Object)stackframe);
  self = obj5938;
  Object *oldselfslot5938 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5938 = (*(struct UserObject *)self).data[0], lowerouter5938 = thisouter5938;
  if (inheritingObject5938) {
    struct UserObject *inho5938 = (struct UserObject *)inheritingObject5938;
    while (inho5938->super != GraceDefaultObject) inho5938 = (struct UserObject *)inho5938->super;
    inho5938->super = obj5938;
    self = inheritingObject5938;
    *selfslot = self;
    lowerouter5938 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5938;
  }
if (objclass5938 == NULL) {
  Method *reader5940 = addmethodrealflags(obj5938, "kind",&reader_ast_kind_5940, MFLAG_DEF);
  reader5940->definitionModule = modulename;
  reader5940->definitionLine = 1318;
}
adddatum2(obj5938, alloc_Undefined(), 1);
if (objclass5938 == NULL) {
  Method *reader5941 = addmethodrealflags(obj5938, "value",&reader_ast_value_5941, MFLAG_DEF);
  reader5941->definitionModule = modulename;
  reader5941->definitionLine = 1319;
}
adddatum2(obj5938, alloc_Undefined(), 2);
  struct UserObject *uo5942 = (struct UserObject*)obj5938;
  uo5942->data[3] = emptyclosure;
  Method *meth_meth_ast_accept5942 = addmethod2pos(obj5938, "accept", &meth_ast_accept5942, 3);
int argcv_meth_ast_accept5942[] = {1};
meth_meth_ast_accept5942->type = alloc_MethodType(1, argcv_meth_ast_accept5942);
meth_meth_ast_accept5942->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5942->type->names[0] = "visitor";
  meth_meth_ast_accept5942->definitionModule = modulename;
  meth_meth_ast_accept5942->definitionLine = 1319;
  struct UserObject *uo5945 = (struct UserObject*)obj5938;
  uo5945->data[4] = emptyclosure;
  Method *meth_meth_ast_pretty5945 = addmethod2pos(obj5938, "pretty", &meth_ast_pretty5945, 4);
int argcv_meth_ast_pretty5945[] = {1};
meth_meth_ast_pretty5945->type = alloc_MethodType(1, argcv_meth_ast_pretty5945);
  meth_meth_ast_pretty5945->definitionModule = modulename;
  meth_meth_ast_pretty5945->definitionLine = 1322;
  struct UserObject *uo5956 = (struct UserObject*)obj5938;
  uo5956->data[5] = emptyclosure;
  Method *meth_meth_ast_toGrace5956 = addmethod2pos(obj5938, "toGrace", &meth_ast_toGrace5956, 5);
int argcv_meth_ast_toGrace5956[] = {1};
meth_meth_ast_toGrace5956->type = alloc_MethodType(1, argcv_meth_ast_toGrace5956);
meth_meth_ast_toGrace5956->type->types[0] = type_Number;
meth_meth_ast_toGrace5956->type->names[0] = "depth";
  meth_meth_ast_toGrace5956->definitionModule = modulename;
  meth_meth_ast_toGrace5956->definitionLine = 1325;
  sourceObject = obj5938;
// Begin line 1316
  setline(1316);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5959 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5960 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5959);
// compilenode returning call5960
  struct UserObject *obj5938_uo = (struct UserObject *)obj5938;
  obj5938_uo->super = call5960;
  sourceObject = obj5938;
// Begin line 1317
  setline(1317);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5961 == NULL) {
    strlit5961 = alloc_String("octets");
    gc_root(strlit5961);
  }
// compilenode returning strlit5961
  adddatum2(obj5938, strlit5961, 1);
  sourceObject = obj5938;
// Begin line 1318
  setline(1318);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  adddatum2(obj5938, *var_n, 2);
  sourceObject = obj5938;
  sourceObject = obj5938;
  sourceObject = obj5938;
objclass5938 = obj5938->class;
  objclass5938->definitionModule = modulename;
  objclass5938->definitionLine = 1307;
  (*(struct UserObject *)self).data[0] = lowerouter5938;
  self = oldself5938;
  selfslot = oldselfslot5938;
  stackframe = oldstackframe5938;
  gc_frame_end(frame);
  return obj5938;
}
Object meth_ast_stringNode5963(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "stringNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for stringNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for stringNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1329
  setline(1329);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_stringNode
  gc_frame_end(frame);
  return *var_stringNode;
}
Object meth_ast_accept5971(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1334
  setline(1334);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5972 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call5973 = callmethod(*var_visitor, "visitString",
    1, partcv, params);
  gc_frame_end(callframe5972);
// compilenode returning call5973
  gc_frame_end(frame);
  return call5973;
}
Object meth_ast_map_40__41_before_40__41_after5974(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1337
  setline(1337);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5975 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call5976 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe5975);
// compilenode returning call5976
// Begin line 1338
  setline(1338);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5977 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blk
  params[0] = self;
  partcv[0] = 1;
  Object call5978 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe5977);
// compilenode returning call5978
  *var_n = call5978;
  if (call5978 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1340
  setline(1340);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1326
  setline(1326);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5979 = gc_frame_new();
// Begin line 1339
  setline(1339);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5980 = gc_frame_new();
  partcv[0] = 0;
  Object call5981 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5980);
// compilenode returning call5981
  gc_frame_newslot(call5981);
// compilenode returning *var_n
  params[0] = call5981;
  partcv[0] = 1;
  Object call5982 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe5979);
// compilenode returning call5982
// compilenode returning done
// Begin line 1340
  setline(1340);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5983 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5984 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe5983);
// compilenode returning call5984
// Begin line 1341
  setline(1341);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply5988(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5991(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map5985(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1344
  setline(1344);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5986 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block5987 = alloc_Block(NULL, NULL, "ast", 1344);
  gc_frame_newslot(block5987);
  block_savedest(block5987);
  Object closure5988 = createclosure(1, "_apply");
setclosureframe(closure5988, stackframe);
  addtoclosure(closure5988, selfslot);
  struct UserObject *uo5988 = (struct UserObject*)block5987;
  uo5988->data[0] = (Object)closure5988;
  Method *meth_meth_ast__apply5988 = addmethod2pos(block5987, "_apply", &meth_ast__apply5988, 0);
int argcv_meth_ast__apply5988[] = {0};
meth_meth_ast__apply5988->type = alloc_MethodType(1, argcv_meth_ast__apply5988);
  meth_meth_ast__apply5988->definitionModule = modulename;
  meth_meth_ast__apply5988->definitionLine = 1326;
// compilenode returning block5987
  gc_frame_newslot(block5987);
  Object block5990 = alloc_Block(NULL, NULL, "ast", 1344);
  gc_frame_newslot(block5990);
  block_savedest(block5990);
  Object closure5991 = createclosure(1, "_apply");
setclosureframe(closure5991, stackframe);
  addtoclosure(closure5991, selfslot);
  struct UserObject *uo5991 = (struct UserObject*)block5990;
  uo5991->data[0] = (Object)closure5991;
  Method *meth_meth_ast__apply5991 = addmethod2pos(block5990, "_apply", &meth_ast__apply5991, 0);
int argcv_meth_ast__apply5991[] = {0};
meth_meth_ast__apply5991->type = alloc_MethodType(1, argcv_meth_ast__apply5991);
  meth_meth_ast__apply5991->definitionModule = modulename;
  meth_meth_ast__apply5991->definitionLine = 1326;
// compilenode returning block5990
  gc_frame_newslot(block5990);
  params[0] = *var_blk;
  params[1] = block5987;
  params[2] = block5990;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5993 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5986);
// compilenode returning call5993
  gc_frame_end(frame);
  return call5993;
}
Object meth_ast_pretty5994(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1348
  setline(1348);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1347
  setline(1347);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5996 == NULL) {
    strlit5996 = alloc_String(")");
    gc_root(strlit5996);
  }
// compilenode returning strlit5996
  int op_slot_right_5995 = gc_frame_newslot(strlit5996);
  int callframe5999 = gc_frame_new();
  partcv[0] = 0;
  Object call6000 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5999);
// compilenode returning call6000
// compilenode returning call6000
  int op_slot_right_5998 = gc_frame_newslot(call6000);
  if (strlit6002 == NULL) {
    strlit6002 = alloc_String("String(");
    gc_root(strlit6002);
  }
// compilenode returning strlit6002
  int op_slot_left_5998 = gc_frame_newslot(strlit6002);
  params[0] = call6000;
  partcv[0] = 1;
  Object opresult6003 = callmethod(strlit6002, "++", 1, partcv, params);
// compilenode returning opresult6003
  int op_slot_left_5995 = gc_frame_newslot(opresult6003);
  params[0] = strlit5996;
  partcv[0] = 1;
  Object opresult6004 = callmethod(opresult6003, "++", 1, partcv, params);
// compilenode returning opresult6004
  gc_frame_end(frame);
  return opresult6004;
}
Object meth_ast__apply6011(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1364
  setline(1364);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1353
  setline(1353);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6014 == NULL) {
    strlit6014 = alloc_String("""\x0a""");
    gc_root(strlit6014);
  }
// compilenode returning strlit6014
  int op_slot_right_6013 = gc_frame_newslot(strlit6014);
// compilenode returning *var_c
  int op_slot_left_6013 = gc_frame_newslot(*var_c);
  params[0] = strlit6014;
  partcv[0] = 1;
  Object opresult6016 = callmethod(*var_c, "==", 1, partcv, params);
// compilenode returning opresult6016
  Object if6012 = done;
  if (istrue(opresult6016)) {
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1354
  setline(1354);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6018 == NULL) {
    strlit6018 = alloc_String("\\n");
    gc_root(strlit6018);
  }
// compilenode returning strlit6018
  int op_slot_right_6017 = gc_frame_newslot(strlit6018);
// compilenode returning *var_s
  int op_slot_left_6017 = gc_frame_newslot(*var_s);
  params[0] = strlit6018;
  partcv[0] = 1;
  Object opresult6020 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6020
  *var_s = opresult6020;
  if (opresult6020 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6012 = done;
  } else {
// Begin line 1357
  setline(1357);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6024 == NULL) {
    strlit6024 = alloc_String("""\x09""");
    gc_root(strlit6024);
  }
// compilenode returning strlit6024
  int op_slot_right_6023 = gc_frame_newslot(strlit6024);
// compilenode returning *var_c
  int op_slot_left_6023 = gc_frame_newslot(*var_c);
  params[0] = strlit6024;
  partcv[0] = 1;
  Object opresult6026 = callmethod(*var_c, "==", 1, partcv, params);
// compilenode returning opresult6026
  Object if6022 = done;
  if (istrue(opresult6026)) {
// Begin line 1357
  setline(1357);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1356
  setline(1356);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6028 == NULL) {
    strlit6028 = alloc_String("\\t");
    gc_root(strlit6028);
  }
// compilenode returning strlit6028
  int op_slot_right_6027 = gc_frame_newslot(strlit6028);
// compilenode returning *var_s
  int op_slot_left_6027 = gc_frame_newslot(*var_s);
  params[0] = strlit6028;
  partcv[0] = 1;
  Object opresult6030 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6030
  *var_s = opresult6030;
  if (opresult6030 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6022 = done;
  } else {
// Begin line 1359
  setline(1359);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1357
  setline(1357);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6034 == NULL) {
    strlit6034 = alloc_String("""\x22""");
    gc_root(strlit6034);
  }
// compilenode returning strlit6034
  int op_slot_right_6033 = gc_frame_newslot(strlit6034);
// compilenode returning *var_c
  int op_slot_left_6033 = gc_frame_newslot(*var_c);
  params[0] = strlit6034;
  partcv[0] = 1;
  Object opresult6036 = callmethod(*var_c, "==", 1, partcv, params);
// compilenode returning opresult6036
  Object if6032 = done;
  if (istrue(opresult6036)) {
// Begin line 1359
  setline(1359);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1358
  setline(1358);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6038 == NULL) {
    strlit6038 = alloc_String("\\""\x22""");
    gc_root(strlit6038);
  }
// compilenode returning strlit6038
  int op_slot_right_6037 = gc_frame_newslot(strlit6038);
// compilenode returning *var_s
  int op_slot_left_6037 = gc_frame_newslot(*var_s);
  params[0] = strlit6038;
  partcv[0] = 1;
  Object opresult6040 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6040
  *var_s = opresult6040;
  if (opresult6040 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6032 = done;
  } else {
// Begin line 1361
  setline(1361);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1359
  setline(1359);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6044 == NULL) {
    strlit6044 = alloc_String("\\");
    gc_root(strlit6044);
  }
// compilenode returning strlit6044
  int op_slot_right_6043 = gc_frame_newslot(strlit6044);
// compilenode returning *var_c
  int op_slot_left_6043 = gc_frame_newslot(*var_c);
  params[0] = strlit6044;
  partcv[0] = 1;
  Object opresult6046 = callmethod(*var_c, "==", 1, partcv, params);
// compilenode returning opresult6046
  Object if6042 = done;
  if (istrue(opresult6046)) {
// Begin line 1361
  setline(1361);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1360
  setline(1360);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6048 == NULL) {
    strlit6048 = alloc_String("\\\\");
    gc_root(strlit6048);
  }
// compilenode returning strlit6048
  int op_slot_right_6047 = gc_frame_newslot(strlit6048);
// compilenode returning *var_s
  int op_slot_left_6047 = gc_frame_newslot(*var_s);
  params[0] = strlit6048;
  partcv[0] = 1;
  Object opresult6050 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6050
  *var_s = opresult6050;
  if (opresult6050 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6042 = done;
  } else {
// Begin line 1363
  setline(1363);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1362
  setline(1362);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_c
  int op_slot_right_6052 = gc_frame_newslot(*var_c);
// compilenode returning *var_s
  int op_slot_left_6052 = gc_frame_newslot(*var_s);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult6054 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6054
  *var_s = opresult6054;
  if (opresult6054 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6042 = done;
  }
// compilenode returning if6042
    gc_frame_newslot(if6042);
    if6032 = if6042;
  }
// compilenode returning if6032
    gc_frame_newslot(if6032);
    if6022 = if6032;
  }
// compilenode returning if6022
    gc_frame_newslot(if6022);
    if6012 = if6022;
  }
// compilenode returning if6012
  gc_frame_end(frame);
  return if6012;
}
Object meth_ast_toGrace6005(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1351
  setline(1351);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1350
  setline(1350);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6006 == NULL) {
    strlit6006 = alloc_String("""\x22""");
    gc_root(strlit6006);
  }
// compilenode returning strlit6006
  *var_s = strlit6006;
  if (strlit6006 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1351
  setline(1351);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6007 = gc_frame_new();
  int callframe6008 = gc_frame_new();
  partcv[0] = 0;
  Object call6009 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6008);
// compilenode returning call6009
// compilenode returning call6009
  gc_frame_newslot(call6009);
  Object block6010 = alloc_Block(NULL, NULL, "ast", 1351);
  gc_frame_newslot(block6010);
  block_savedest(block6010);
  Object closure6011 = createclosure(2, "_apply");
setclosureframe(closure6011, stackframe);
  addtoclosure(closure6011, var_s);
  addtoclosure(closure6011, selfslot);
  struct UserObject *uo6011 = (struct UserObject*)block6010;
  uo6011->data[0] = (Object)closure6011;
  Method *meth_meth_ast__apply6011 = addmethod2pos(block6010, "_apply", &meth_ast__apply6011, 0);
int argcv_meth_ast__apply6011[] = {1};
meth_meth_ast__apply6011->type = alloc_MethodType(1, argcv_meth_ast__apply6011);
  meth_meth_ast__apply6011->definitionModule = modulename;
  meth_meth_ast__apply6011->definitionLine = 1351;
// compilenode returning block6010
  gc_frame_newslot(block6010);
  params[0] = call6009;
  params[1] = block6010;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6057 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6007);
// compilenode returning call6057
// Begin line 1366
  setline(1366);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1365
  setline(1365);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6059 == NULL) {
    strlit6059 = alloc_String("""\x22""");
    gc_root(strlit6059);
  }
// compilenode returning strlit6059
  int op_slot_right_6058 = gc_frame_newslot(strlit6059);
// compilenode returning *var_s
  int op_slot_left_6058 = gc_frame_newslot(*var_s);
  params[0] = strlit6059;
  partcv[0] = 1;
  Object opresult6061 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6061
  *var_s = opresult6061;
  if (opresult6061 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1366
  setline(1366);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new5966(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5967 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5967 = alloc_userobj2(9,9, objclass5967);
  gc_frame_newslot(obj5967);
if (objclass5967 == NULL) {
  glfree(obj5967->class->name);
  obj5967->class->name = "stringNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5967, self, 0);
  addmethodreal(obj5967,"outer", &reader_ast_outer_5968);
  Object oldself5967 = self;
  struct StackFrameObject *oldstackframe5967 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5967);
  gc_frame_newslot((Object)stackframe);
  self = obj5967;
  Object *oldselfslot5967 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5967 = (*(struct UserObject *)self).data[0], lowerouter5967 = thisouter5967;
  if (inheritingObject5967) {
    struct UserObject *inho5967 = (struct UserObject *)inheritingObject5967;
    while (inho5967->super != GraceDefaultObject) inho5967 = (struct UserObject *)inho5967->super;
    inho5967->super = obj5967;
    self = inheritingObject5967;
    *selfslot = self;
    lowerouter5967 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5967;
  }
if (objclass5967 == NULL) {
  Method *reader5969 = addmethodrealflags(obj5967, "kind",&reader_ast_kind_5969, MFLAG_DEF);
  reader5969->definitionModule = modulename;
  reader5969->definitionLine = 1332;
}
adddatum2(obj5967, alloc_Undefined(), 1);
if (objclass5967 == NULL) {
  Method *reader5970 = addmethodrealflags(obj5967, "value",&reader_ast_value_5970, 0);
  Method *writer5970 = addmethodrealflags(obj5967, "value:=",&writer_ast_value_5970, 0);
  reader5970->definitionModule = modulename;
  writer5970->definitionModule = modulename;
  reader5970->definitionLine = 1333;
  writer5970->definitionLine = 1333;
}
obj5967->flags |= OFLAG_MUTABLE;
adddatum2(obj5967, alloc_Undefined(), 2);
  struct UserObject *uo5971 = (struct UserObject*)obj5967;
  uo5971->data[3] = emptyclosure;
  Method *meth_meth_ast_accept5971 = addmethod2pos(obj5967, "accept", &meth_ast_accept5971, 3);
int argcv_meth_ast_accept5971[] = {1};
meth_meth_ast_accept5971->type = alloc_MethodType(1, argcv_meth_ast_accept5971);
meth_meth_ast_accept5971->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5971->type->names[0] = "visitor";
  meth_meth_ast_accept5971->definitionModule = modulename;
  meth_meth_ast_accept5971->definitionLine = 1333;
  struct UserObject *uo5974 = (struct UserObject*)obj5967;
  uo5974->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_before_40__41_after5974 = addmethod2pos(obj5967, "map()before()after", &meth_ast_map_40__41_before_40__41_after5974, 4);
int argcv_meth_ast_map_40__41_before_40__41_after5974[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after5974->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after5974);
  meth_meth_ast_map_40__41_before_40__41_after5974->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after5974->definitionLine = 1336;
  struct UserObject *uo5985 = (struct UserObject*)obj5967;
  uo5985->data[5] = emptyclosure;
  Method *meth_meth_ast_map5985 = addmethod2pos(obj5967, "map", &meth_ast_map5985, 5);
int argcv_meth_ast_map5985[] = {1};
meth_meth_ast_map5985->type = alloc_MethodType(1, argcv_meth_ast_map5985);
  meth_meth_ast_map5985->definitionModule = modulename;
  meth_meth_ast_map5985->definitionLine = 1343;
  struct UserObject *uo5994 = (struct UserObject*)obj5967;
  uo5994->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty5994 = addmethod2pos(obj5967, "pretty", &meth_ast_pretty5994, 6);
int argcv_meth_ast_pretty5994[] = {1};
meth_meth_ast_pretty5994->type = alloc_MethodType(1, argcv_meth_ast_pretty5994);
  meth_meth_ast_pretty5994->definitionModule = modulename;
  meth_meth_ast_pretty5994->definitionLine = 1346;
  struct UserObject *uo6005 = (struct UserObject*)obj5967;
  uo6005->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace6005 = addmethod2pos(obj5967, "toGrace", &meth_ast_toGrace6005, 7);
int argcv_meth_ast_toGrace6005[] = {1};
meth_meth_ast_toGrace6005->type = alloc_MethodType(1, argcv_meth_ast_toGrace6005);
meth_meth_ast_toGrace6005->type->types[0] = type_Number;
meth_meth_ast_toGrace6005->type->names[0] = "depth";
  meth_meth_ast_toGrace6005->definitionModule = modulename;
  meth_meth_ast_toGrace6005->definitionLine = 1349;
  sourceObject = obj5967;
// Begin line 1330
  setline(1330);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6063 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6064 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6063);
// compilenode returning call6064
  struct UserObject *obj5967_uo = (struct UserObject *)obj5967;
  obj5967_uo->super = call6064;
  sourceObject = obj5967;
// Begin line 1331
  setline(1331);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6065 == NULL) {
    strlit6065 = alloc_String("string");
    gc_root(strlit6065);
  }
// compilenode returning strlit6065
  adddatum2(obj5967, strlit6065, 1);
  sourceObject = obj5967;
// Begin line 1332
  setline(1332);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_v
  adddatum2(obj5967, *var_v, 2);
  sourceObject = obj5967;
  sourceObject = obj5967;
  sourceObject = obj5967;
  sourceObject = obj5967;
  sourceObject = obj5967;
objclass5967 = obj5967->class;
  objclass5967->definitionModule = modulename;
  objclass5967->definitionLine = 1326;
  (*(struct UserObject *)self).data[0] = lowerouter5967;
  self = oldself5967;
  selfslot = oldselfslot5967;
  stackframe = oldstackframe5967;
  gc_frame_end(frame);
  return obj5967;
}
Object meth_ast_new5966_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5967 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5967 = alloc_userobj2(9,9, objclass5967);
  gc_frame_newslot(obj5967);
if (objclass5967 == NULL) {
  glfree(obj5967->class->name);
  obj5967->class->name = "stringNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5967, self, 0);
  addmethodreal(obj5967,"outer", &reader_ast_outer_5968);
  Object oldself5967 = self;
  struct StackFrameObject *oldstackframe5967 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5967);
  gc_frame_newslot((Object)stackframe);
  self = obj5967;
  Object *oldselfslot5967 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5967 = (*(struct UserObject *)self).data[0], lowerouter5967 = thisouter5967;
  if (inheritingObject5967) {
    struct UserObject *inho5967 = (struct UserObject *)inheritingObject5967;
    while (inho5967->super != GraceDefaultObject) inho5967 = (struct UserObject *)inho5967->super;
    inho5967->super = obj5967;
    self = inheritingObject5967;
    *selfslot = self;
    lowerouter5967 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5967;
  }
if (objclass5967 == NULL) {
  Method *reader5969 = addmethodrealflags(obj5967, "kind",&reader_ast_kind_5969, MFLAG_DEF);
  reader5969->definitionModule = modulename;
  reader5969->definitionLine = 1332;
}
adddatum2(obj5967, alloc_Undefined(), 1);
if (objclass5967 == NULL) {
  Method *reader5970 = addmethodrealflags(obj5967, "value",&reader_ast_value_5970, 0);
  Method *writer5970 = addmethodrealflags(obj5967, "value:=",&writer_ast_value_5970, 0);
  reader5970->definitionModule = modulename;
  writer5970->definitionModule = modulename;
  reader5970->definitionLine = 1333;
  writer5970->definitionLine = 1333;
}
obj5967->flags |= OFLAG_MUTABLE;
adddatum2(obj5967, alloc_Undefined(), 2);
  struct UserObject *uo5971 = (struct UserObject*)obj5967;
  uo5971->data[3] = emptyclosure;
  Method *meth_meth_ast_accept5971 = addmethod2pos(obj5967, "accept", &meth_ast_accept5971, 3);
int argcv_meth_ast_accept5971[] = {1};
meth_meth_ast_accept5971->type = alloc_MethodType(1, argcv_meth_ast_accept5971);
meth_meth_ast_accept5971->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5971->type->names[0] = "visitor";
  meth_meth_ast_accept5971->definitionModule = modulename;
  meth_meth_ast_accept5971->definitionLine = 1333;
  struct UserObject *uo5974 = (struct UserObject*)obj5967;
  uo5974->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_before_40__41_after5974 = addmethod2pos(obj5967, "map()before()after", &meth_ast_map_40__41_before_40__41_after5974, 4);
int argcv_meth_ast_map_40__41_before_40__41_after5974[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after5974->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after5974);
  meth_meth_ast_map_40__41_before_40__41_after5974->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after5974->definitionLine = 1336;
  struct UserObject *uo5985 = (struct UserObject*)obj5967;
  uo5985->data[5] = emptyclosure;
  Method *meth_meth_ast_map5985 = addmethod2pos(obj5967, "map", &meth_ast_map5985, 5);
int argcv_meth_ast_map5985[] = {1};
meth_meth_ast_map5985->type = alloc_MethodType(1, argcv_meth_ast_map5985);
  meth_meth_ast_map5985->definitionModule = modulename;
  meth_meth_ast_map5985->definitionLine = 1343;
  struct UserObject *uo5994 = (struct UserObject*)obj5967;
  uo5994->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty5994 = addmethod2pos(obj5967, "pretty", &meth_ast_pretty5994, 6);
int argcv_meth_ast_pretty5994[] = {1};
meth_meth_ast_pretty5994->type = alloc_MethodType(1, argcv_meth_ast_pretty5994);
  meth_meth_ast_pretty5994->definitionModule = modulename;
  meth_meth_ast_pretty5994->definitionLine = 1346;
  struct UserObject *uo6005 = (struct UserObject*)obj5967;
  uo6005->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace6005 = addmethod2pos(obj5967, "toGrace", &meth_ast_toGrace6005, 7);
int argcv_meth_ast_toGrace6005[] = {1};
meth_meth_ast_toGrace6005->type = alloc_MethodType(1, argcv_meth_ast_toGrace6005);
meth_meth_ast_toGrace6005->type->types[0] = type_Number;
meth_meth_ast_toGrace6005->type->names[0] = "depth";
  meth_meth_ast_toGrace6005->definitionModule = modulename;
  meth_meth_ast_toGrace6005->definitionLine = 1349;
  sourceObject = obj5967;
// Begin line 1330
  setline(1330);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6063 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6064 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6063);
// compilenode returning call6064
  struct UserObject *obj5967_uo = (struct UserObject *)obj5967;
  obj5967_uo->super = call6064;
  sourceObject = obj5967;
// Begin line 1331
  setline(1331);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6065 == NULL) {
    strlit6065 = alloc_String("string");
    gc_root(strlit6065);
  }
// compilenode returning strlit6065
  adddatum2(obj5967, strlit6065, 1);
  sourceObject = obj5967;
// Begin line 1332
  setline(1332);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_v
  adddatum2(obj5967, *var_v, 2);
  sourceObject = obj5967;
  sourceObject = obj5967;
  sourceObject = obj5967;
  sourceObject = obj5967;
  sourceObject = obj5967;
objclass5967 = obj5967->class;
  objclass5967->definitionModule = modulename;
  objclass5967->definitionLine = 1326;
  (*(struct UserObject *)self).data[0] = lowerouter5967;
  self = oldself5967;
  selfslot = oldselfslot5967;
  stackframe = oldstackframe5967;
  gc_frame_end(frame);
  return obj5967;
}
Object meth_ast_numNode6067(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "numNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for numNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for numNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1369
  setline(1369);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_numNode
  gc_frame_end(frame);
  return *var_numNode;
}
Object meth_ast_accept6075(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1374
  setline(1374);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6076 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call6077 = callmethod(*var_visitor, "visitNum",
    1, partcv, params);
  gc_frame_end(callframe6076);
// compilenode returning call6077
  gc_frame_end(frame);
  return call6077;
}
Object meth_ast_map_40__41_before_40__41_after6078(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1377
  setline(1377);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6079 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call6080 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe6079);
// compilenode returning call6080
// Begin line 1378
  setline(1378);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6081 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blk
  params[0] = self;
  partcv[0] = 1;
  Object call6082 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe6081);
// compilenode returning call6082
  *var_n = call6082;
  if (call6082 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1380
  setline(1380);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1351
  setline(1351);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6083 = gc_frame_new();
// Begin line 1379
  setline(1379);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6084 = gc_frame_new();
  partcv[0] = 0;
  Object call6085 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6084);
// compilenode returning call6085
  gc_frame_newslot(call6085);
// compilenode returning *var_n
  params[0] = call6085;
  partcv[0] = 1;
  Object call6086 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe6083);
// compilenode returning call6086
// compilenode returning done
// Begin line 1380
  setline(1380);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6087 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6088 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe6087);
// compilenode returning call6088
// Begin line 1381
  setline(1381);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply6092(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6095(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map6089(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1384
  setline(1384);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6090 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block6091 = alloc_Block(NULL, NULL, "ast", 1384);
  gc_frame_newslot(block6091);
  block_savedest(block6091);
  Object closure6092 = createclosure(1, "_apply");
setclosureframe(closure6092, stackframe);
  addtoclosure(closure6092, selfslot);
  struct UserObject *uo6092 = (struct UserObject*)block6091;
  uo6092->data[0] = (Object)closure6092;
  Method *meth_meth_ast__apply6092 = addmethod2pos(block6091, "_apply", &meth_ast__apply6092, 0);
int argcv_meth_ast__apply6092[] = {0};
meth_meth_ast__apply6092->type = alloc_MethodType(1, argcv_meth_ast__apply6092);
  meth_meth_ast__apply6092->definitionModule = modulename;
  meth_meth_ast__apply6092->definitionLine = 1351;
// compilenode returning block6091
  gc_frame_newslot(block6091);
  Object block6094 = alloc_Block(NULL, NULL, "ast", 1384);
  gc_frame_newslot(block6094);
  block_savedest(block6094);
  Object closure6095 = createclosure(1, "_apply");
setclosureframe(closure6095, stackframe);
  addtoclosure(closure6095, selfslot);
  struct UserObject *uo6095 = (struct UserObject*)block6094;
  uo6095->data[0] = (Object)closure6095;
  Method *meth_meth_ast__apply6095 = addmethod2pos(block6094, "_apply", &meth_ast__apply6095, 0);
int argcv_meth_ast__apply6095[] = {0};
meth_meth_ast__apply6095->type = alloc_MethodType(1, argcv_meth_ast__apply6095);
  meth_meth_ast__apply6095->definitionModule = modulename;
  meth_meth_ast__apply6095->definitionLine = 1351;
// compilenode returning block6094
  gc_frame_newslot(block6094);
  params[0] = *var_blk;
  params[1] = block6091;
  params[2] = block6094;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6097 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6090);
// compilenode returning call6097
  gc_frame_end(frame);
  return call6097;
}
Object meth_ast_pretty6098(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1388
  setline(1388);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1387
  setline(1387);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6100 == NULL) {
    strlit6100 = alloc_String(")");
    gc_root(strlit6100);
  }
// compilenode returning strlit6100
  int op_slot_right_6099 = gc_frame_newslot(strlit6100);
  int callframe6103 = gc_frame_new();
  partcv[0] = 0;
  Object call6104 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6103);
// compilenode returning call6104
// compilenode returning call6104
  int op_slot_right_6102 = gc_frame_newslot(call6104);
  if (strlit6106 == NULL) {
    strlit6106 = alloc_String("Num(");
    gc_root(strlit6106);
  }
// compilenode returning strlit6106
  int op_slot_left_6102 = gc_frame_newslot(strlit6106);
  params[0] = call6104;
  partcv[0] = 1;
  Object opresult6107 = callmethod(strlit6106, "++", 1, partcv, params);
// compilenode returning opresult6107
  int op_slot_left_6099 = gc_frame_newslot(opresult6107);
  params[0] = strlit6100;
  partcv[0] = 1;
  Object opresult6108 = callmethod(opresult6107, "++", 1, partcv, params);
// compilenode returning opresult6108
  gc_frame_end(frame);
  return opresult6108;
}
Object meth_ast_toGrace6109(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1390
  setline(1390);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6110 = gc_frame_new();
  int callframe6111 = gc_frame_new();
  partcv[0] = 0;
  Object call6112 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6111);
// compilenode returning call6112
// compilenode returning call6112
  partcv[0] = 0;
  Object call6113 = callmethod(call6112, "asString",
    1, partcv, params);
  gc_frame_end(callframe6110);
// compilenode returning call6113
// compilenode returning call6113
  gc_frame_end(frame);
  return call6113;
}
Object meth_ast_new6070(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val = &(stackframe->slots[0]);
  *var_val = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6071 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6071 = alloc_userobj2(8,9, objclass6071);
  gc_frame_newslot(obj6071);
if (objclass6071 == NULL) {
  glfree(obj6071->class->name);
  obj6071->class->name = "numNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6071, self, 0);
  addmethodreal(obj6071,"outer", &reader_ast_outer_6072);
  Object oldself6071 = self;
  struct StackFrameObject *oldstackframe6071 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6071);
  gc_frame_newslot((Object)stackframe);
  self = obj6071;
  Object *oldselfslot6071 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6071 = (*(struct UserObject *)self).data[0], lowerouter6071 = thisouter6071;
  if (inheritingObject6071) {
    struct UserObject *inho6071 = (struct UserObject *)inheritingObject6071;
    while (inho6071->super != GraceDefaultObject) inho6071 = (struct UserObject *)inho6071->super;
    inho6071->super = obj6071;
    self = inheritingObject6071;
    *selfslot = self;
    lowerouter6071 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6071;
  }
if (objclass6071 == NULL) {
  Method *reader6073 = addmethodrealflags(obj6071, "kind",&reader_ast_kind_6073, MFLAG_DEF);
  reader6073->definitionModule = modulename;
  reader6073->definitionLine = 1372;
}
adddatum2(obj6071, alloc_Undefined(), 1);
if (objclass6071 == NULL) {
  Method *reader6074 = addmethodrealflags(obj6071, "value",&reader_ast_value_6074, MFLAG_DEF);
  reader6074->definitionModule = modulename;
  reader6074->definitionLine = 1373;
}
adddatum2(obj6071, alloc_Undefined(), 2);
  struct UserObject *uo6075 = (struct UserObject*)obj6071;
  uo6075->data[3] = emptyclosure;
  Method *meth_meth_ast_accept6075 = addmethod2pos(obj6071, "accept", &meth_ast_accept6075, 3);
int argcv_meth_ast_accept6075[] = {1};
meth_meth_ast_accept6075->type = alloc_MethodType(1, argcv_meth_ast_accept6075);
meth_meth_ast_accept6075->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept6075->type->names[0] = "visitor";
  meth_meth_ast_accept6075->definitionModule = modulename;
  meth_meth_ast_accept6075->definitionLine = 1373;
  struct UserObject *uo6078 = (struct UserObject*)obj6071;
  uo6078->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_before_40__41_after6078 = addmethod2pos(obj6071, "map()before()after", &meth_ast_map_40__41_before_40__41_after6078, 4);
int argcv_meth_ast_map_40__41_before_40__41_after6078[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after6078->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after6078);
  meth_meth_ast_map_40__41_before_40__41_after6078->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after6078->definitionLine = 1376;
  struct UserObject *uo6089 = (struct UserObject*)obj6071;
  uo6089->data[5] = emptyclosure;
  Method *meth_meth_ast_map6089 = addmethod2pos(obj6071, "map", &meth_ast_map6089, 5);
int argcv_meth_ast_map6089[] = {1};
meth_meth_ast_map6089->type = alloc_MethodType(1, argcv_meth_ast_map6089);
  meth_meth_ast_map6089->definitionModule = modulename;
  meth_meth_ast_map6089->definitionLine = 1383;
  struct UserObject *uo6098 = (struct UserObject*)obj6071;
  uo6098->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty6098 = addmethod2pos(obj6071, "pretty", &meth_ast_pretty6098, 6);
int argcv_meth_ast_pretty6098[] = {1};
meth_meth_ast_pretty6098->type = alloc_MethodType(1, argcv_meth_ast_pretty6098);
  meth_meth_ast_pretty6098->definitionModule = modulename;
  meth_meth_ast_pretty6098->definitionLine = 1386;
  struct UserObject *uo6109 = (struct UserObject*)obj6071;
  uo6109->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace6109 = addmethod2pos(obj6071, "toGrace", &meth_ast_toGrace6109, 7);
int argcv_meth_ast_toGrace6109[] = {1};
meth_meth_ast_toGrace6109->type = alloc_MethodType(1, argcv_meth_ast_toGrace6109);
meth_meth_ast_toGrace6109->type->types[0] = type_Number;
meth_meth_ast_toGrace6109->type->names[0] = "depth";
  meth_meth_ast_toGrace6109->definitionModule = modulename;
  meth_meth_ast_toGrace6109->definitionLine = 1389;
  sourceObject = obj6071;
// Begin line 1370
  setline(1370);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6114 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6115 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6114);
// compilenode returning call6115
  struct UserObject *obj6071_uo = (struct UserObject *)obj6071;
  obj6071_uo->super = call6115;
  sourceObject = obj6071;
// Begin line 1371
  setline(1371);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6116 == NULL) {
    strlit6116 = alloc_String("num");
    gc_root(strlit6116);
  }
// compilenode returning strlit6116
  adddatum2(obj6071, strlit6116, 1);
  sourceObject = obj6071;
// Begin line 1372
  setline(1372);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_val
  adddatum2(obj6071, *var_val, 2);
  sourceObject = obj6071;
  sourceObject = obj6071;
  sourceObject = obj6071;
  sourceObject = obj6071;
  sourceObject = obj6071;
objclass6071 = obj6071->class;
  objclass6071->definitionModule = modulename;
  objclass6071->definitionLine = 1351;
  (*(struct UserObject *)self).data[0] = lowerouter6071;
  self = oldself6071;
  selfslot = oldselfslot6071;
  stackframe = oldstackframe6071;
  gc_frame_end(frame);
  return obj6071;
}
Object meth_ast_new6070_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val = &(stackframe->slots[0]);
  *var_val = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6071 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6071 = alloc_userobj2(8,9, objclass6071);
  gc_frame_newslot(obj6071);
if (objclass6071 == NULL) {
  glfree(obj6071->class->name);
  obj6071->class->name = "numNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6071, self, 0);
  addmethodreal(obj6071,"outer", &reader_ast_outer_6072);
  Object oldself6071 = self;
  struct StackFrameObject *oldstackframe6071 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6071);
  gc_frame_newslot((Object)stackframe);
  self = obj6071;
  Object *oldselfslot6071 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6071 = (*(struct UserObject *)self).data[0], lowerouter6071 = thisouter6071;
  if (inheritingObject6071) {
    struct UserObject *inho6071 = (struct UserObject *)inheritingObject6071;
    while (inho6071->super != GraceDefaultObject) inho6071 = (struct UserObject *)inho6071->super;
    inho6071->super = obj6071;
    self = inheritingObject6071;
    *selfslot = self;
    lowerouter6071 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6071;
  }
if (objclass6071 == NULL) {
  Method *reader6073 = addmethodrealflags(obj6071, "kind",&reader_ast_kind_6073, MFLAG_DEF);
  reader6073->definitionModule = modulename;
  reader6073->definitionLine = 1372;
}
adddatum2(obj6071, alloc_Undefined(), 1);
if (objclass6071 == NULL) {
  Method *reader6074 = addmethodrealflags(obj6071, "value",&reader_ast_value_6074, MFLAG_DEF);
  reader6074->definitionModule = modulename;
  reader6074->definitionLine = 1373;
}
adddatum2(obj6071, alloc_Undefined(), 2);
  struct UserObject *uo6075 = (struct UserObject*)obj6071;
  uo6075->data[3] = emptyclosure;
  Method *meth_meth_ast_accept6075 = addmethod2pos(obj6071, "accept", &meth_ast_accept6075, 3);
int argcv_meth_ast_accept6075[] = {1};
meth_meth_ast_accept6075->type = alloc_MethodType(1, argcv_meth_ast_accept6075);
meth_meth_ast_accept6075->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept6075->type->names[0] = "visitor";
  meth_meth_ast_accept6075->definitionModule = modulename;
  meth_meth_ast_accept6075->definitionLine = 1373;
  struct UserObject *uo6078 = (struct UserObject*)obj6071;
  uo6078->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_before_40__41_after6078 = addmethod2pos(obj6071, "map()before()after", &meth_ast_map_40__41_before_40__41_after6078, 4);
int argcv_meth_ast_map_40__41_before_40__41_after6078[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after6078->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after6078);
  meth_meth_ast_map_40__41_before_40__41_after6078->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after6078->definitionLine = 1376;
  struct UserObject *uo6089 = (struct UserObject*)obj6071;
  uo6089->data[5] = emptyclosure;
  Method *meth_meth_ast_map6089 = addmethod2pos(obj6071, "map", &meth_ast_map6089, 5);
int argcv_meth_ast_map6089[] = {1};
meth_meth_ast_map6089->type = alloc_MethodType(1, argcv_meth_ast_map6089);
  meth_meth_ast_map6089->definitionModule = modulename;
  meth_meth_ast_map6089->definitionLine = 1383;
  struct UserObject *uo6098 = (struct UserObject*)obj6071;
  uo6098->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty6098 = addmethod2pos(obj6071, "pretty", &meth_ast_pretty6098, 6);
int argcv_meth_ast_pretty6098[] = {1};
meth_meth_ast_pretty6098->type = alloc_MethodType(1, argcv_meth_ast_pretty6098);
  meth_meth_ast_pretty6098->definitionModule = modulename;
  meth_meth_ast_pretty6098->definitionLine = 1386;
  struct UserObject *uo6109 = (struct UserObject*)obj6071;
  uo6109->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace6109 = addmethod2pos(obj6071, "toGrace", &meth_ast_toGrace6109, 7);
int argcv_meth_ast_toGrace6109[] = {1};
meth_meth_ast_toGrace6109->type = alloc_MethodType(1, argcv_meth_ast_toGrace6109);
meth_meth_ast_toGrace6109->type->types[0] = type_Number;
meth_meth_ast_toGrace6109->type->names[0] = "depth";
  meth_meth_ast_toGrace6109->definitionModule = modulename;
  meth_meth_ast_toGrace6109->definitionLine = 1389;
  sourceObject = obj6071;
// Begin line 1370
  setline(1370);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6114 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6115 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6114);
// compilenode returning call6115
  struct UserObject *obj6071_uo = (struct UserObject *)obj6071;
  obj6071_uo->super = call6115;
  sourceObject = obj6071;
// Begin line 1371
  setline(1371);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6116 == NULL) {
    strlit6116 = alloc_String("num");
    gc_root(strlit6116);
  }
// compilenode returning strlit6116
  adddatum2(obj6071, strlit6116, 1);
  sourceObject = obj6071;
// Begin line 1372
  setline(1372);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_val
  adddatum2(obj6071, *var_val, 2);
  sourceObject = obj6071;
  sourceObject = obj6071;
  sourceObject = obj6071;
  sourceObject = obj6071;
  sourceObject = obj6071;
objclass6071 = obj6071->class;
  objclass6071->definitionModule = modulename;
  objclass6071->definitionLine = 1351;
  (*(struct UserObject *)self).data[0] = lowerouter6071;
  self = oldself6071;
  selfslot = oldselfslot6071;
  stackframe = oldstackframe6071;
  gc_frame_end(frame);
  return obj6071;
}
Object meth_ast_opNode6118(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "opNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_opNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for opNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for opNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1393
  setline(1393);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_opNode
  gc_frame_end(frame);
  return *var_opNode;
}
Object meth_ast_accept6128(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1404
  setline(1404);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1400
  setline(1400);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6130 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call6131 = callmethod(*var_visitor, "visitOp",
    1, partcv, params);
  gc_frame_end(callframe6130);
// compilenode returning call6131
  Object if6129 = done;
  if (istrue(call6131)) {
// Begin line 1401
  setline(1401);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6132 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe6133 = gc_frame_new();
  partcv[0] = 0;
  Object call6134 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6133);
// compilenode returning call6134
// compilenode returning call6134
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call6135 = callmethod(call6134, "accept",
    1, partcv, params);
  gc_frame_end(callframe6132);
// compilenode returning call6135
// Begin line 1402
  setline(1402);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6136 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe6137 = gc_frame_new();
  partcv[0] = 0;
  Object call6138 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6137);
// compilenode returning call6138
// compilenode returning call6138
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call6139 = callmethod(call6138, "accept",
    1, partcv, params);
  gc_frame_end(callframe6136);
// compilenode returning call6139
    gc_frame_newslot(call6139);
    if6129 = call6139;
  } else {
  }
// compilenode returning if6129
  gc_frame_end(frame);
  return if6129;
}
Object meth_ast_map_40__41_before_40__41_after6140(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_opNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1406
  setline(1406);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6141 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call6142 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe6141);
// compilenode returning call6142
// Begin line 1407
  setline(1407);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6143 = gc_frame_new();
  int callframe6144 = gc_frame_new();
  partcv[0] = 0;
  Object call6145 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6144);
// compilenode returning call6145
  gc_frame_newslot(call6145);
  int callframe6146 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe6147 = gc_frame_new();
  partcv[0] = 0;
  Object call6148 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6147);
// compilenode returning call6148
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6149 = callmethod(call6148, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe6146);
// compilenode returning call6149
  gc_frame_newslot(call6149);
  int callframe6150 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe6151 = gc_frame_new();
  partcv[0] = 0;
  Object call6152 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6151);
// compilenode returning call6152
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6153 = callmethod(call6152, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe6150);
// compilenode returning call6153
  gc_frame_newslot(call6153);
// compilenode returning *var_opNode
  params[0] = call6145;
  params[1] = call6149;
  params[2] = call6153;
  partcv[0] = 3;
  Object call6154 = callmethod(*var_opNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6143);
// compilenode returning call6154
  *var_n = call6154;
  if (call6154 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1408
  setline(1408);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6155 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6156 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe6155);
// compilenode returning call6156
  *var_n = call6156;
  if (call6156 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1410
  setline(1410);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1402
  setline(1402);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6158 = gc_frame_new();
// Begin line 1409
  setline(1409);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6159 = gc_frame_new();
  partcv[0] = 0;
  Object call6160 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6159);
// compilenode returning call6160
  gc_frame_newslot(call6160);
// compilenode returning *var_n
  params[0] = call6160;
  partcv[0] = 1;
  Object call6161 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe6158);
// compilenode returning call6161
// compilenode returning done
// Begin line 1410
  setline(1410);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6162 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6163 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe6162);
// compilenode returning call6163
// Begin line 1411
  setline(1411);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply6167(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6170(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map6164(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1414
  setline(1414);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6165 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block6166 = alloc_Block(NULL, NULL, "ast", 1414);
  gc_frame_newslot(block6166);
  block_savedest(block6166);
  Object closure6167 = createclosure(1, "_apply");
setclosureframe(closure6167, stackframe);
  addtoclosure(closure6167, selfslot);
  struct UserObject *uo6167 = (struct UserObject*)block6166;
  uo6167->data[0] = (Object)closure6167;
  Method *meth_meth_ast__apply6167 = addmethod2pos(block6166, "_apply", &meth_ast__apply6167, 0);
int argcv_meth_ast__apply6167[] = {0};
meth_meth_ast__apply6167->type = alloc_MethodType(1, argcv_meth_ast__apply6167);
  meth_meth_ast__apply6167->definitionModule = modulename;
  meth_meth_ast__apply6167->definitionLine = 1402;
// compilenode returning block6166
  gc_frame_newslot(block6166);
  Object block6169 = alloc_Block(NULL, NULL, "ast", 1414);
  gc_frame_newslot(block6169);
  block_savedest(block6169);
  Object closure6170 = createclosure(1, "_apply");
setclosureframe(closure6170, stackframe);
  addtoclosure(closure6170, selfslot);
  struct UserObject *uo6170 = (struct UserObject*)block6169;
  uo6170->data[0] = (Object)closure6170;
  Method *meth_meth_ast__apply6170 = addmethod2pos(block6169, "_apply", &meth_ast__apply6170, 0);
int argcv_meth_ast__apply6170[] = {0};
meth_meth_ast__apply6170->type = alloc_MethodType(1, argcv_meth_ast__apply6170);
  meth_meth_ast__apply6170->definitionModule = modulename;
  meth_meth_ast__apply6170->definitionLine = 1402;
// compilenode returning block6169
  gc_frame_newslot(block6169);
  params[0] = *var_blk;
  params[1] = block6166;
  params[2] = block6169;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6172 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6165);
// compilenode returning call6172
  gc_frame_end(frame);
  return call6172;
}
Object meth_ast__apply6181(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1420
  setline(1420);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1419
  setline(1419);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6183 == NULL) {
    strlit6183 = alloc_String("  ");
    gc_root(strlit6183);
  }
// compilenode returning strlit6183
  int op_slot_right_6182 = gc_frame_newslot(strlit6183);
// compilenode returning *var_spc
  int op_slot_left_6182 = gc_frame_newslot(*var_spc);
  params[0] = strlit6183;
  partcv[0] = 1;
  Object opresult6185 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult6185
  *var_spc = opresult6185;
  if (opresult6185 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty6173(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1418
  setline(1418);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1417
  setline(1417);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6174 == NULL) {
    strlit6174 = alloc_String("");
    gc_root(strlit6174);
  }
// compilenode returning strlit6174
  *var_spc = strlit6174;
  if (strlit6174 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1418
  setline(1418);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6175 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_6176 = gc_frame_newslot(*var_depth);
  Object num6178 = alloc_Float64(0);
// compilenode returning num6178
  int op_slot_left_6176 = gc_frame_newslot(num6178);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6179 = callmethod(num6178, "..", 1, partcv, params);
// compilenode returning opresult6179
  gc_frame_newslot(opresult6179);
  Object block6180 = alloc_Block(NULL, NULL, "ast", 1418);
  gc_frame_newslot(block6180);
  block_savedest(block6180);
  Object closure6181 = createclosure(2, "_apply");
setclosureframe(closure6181, stackframe);
  addtoclosure(closure6181, var_spc);
  addtoclosure(closure6181, selfslot);
  struct UserObject *uo6181 = (struct UserObject*)block6180;
  uo6181->data[0] = (Object)closure6181;
  Method *meth_meth_ast__apply6181 = addmethod2pos(block6180, "_apply", &meth_ast__apply6181, 0);
int argcv_meth_ast__apply6181[] = {1};
meth_meth_ast__apply6181->type = alloc_MethodType(1, argcv_meth_ast__apply6181);
  meth_meth_ast__apply6181->definitionModule = modulename;
  meth_meth_ast__apply6181->definitionLine = 1402;
// compilenode returning block6180
  gc_frame_newslot(block6180);
  params[0] = opresult6179;
  params[1] = block6180;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6188 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6175);
// compilenode returning call6188
// Begin line 1422
  setline(1422);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1421
  setline(1421);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6190 == NULL) {
    strlit6190 = alloc_String(")");
    gc_root(strlit6190);
  }
// compilenode returning strlit6190
  int op_slot_right_6189 = gc_frame_newslot(strlit6190);
  int callframe6193 = gc_frame_new();
  partcv[0] = 0;
  Object call6194 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6193);
// compilenode returning call6194
// compilenode returning call6194
  int op_slot_right_6192 = gc_frame_newslot(call6194);
  if (strlit6196 == NULL) {
    strlit6196 = alloc_String("Op(");
    gc_root(strlit6196);
  }
// compilenode returning strlit6196
  int op_slot_left_6192 = gc_frame_newslot(strlit6196);
  params[0] = call6194;
  partcv[0] = 1;
  Object opresult6197 = callmethod(strlit6196, "++", 1, partcv, params);
// compilenode returning opresult6197
  int op_slot_left_6189 = gc_frame_newslot(opresult6197);
  params[0] = strlit6190;
  partcv[0] = 1;
  Object opresult6198 = callmethod(opresult6197, "++", 1, partcv, params);
// compilenode returning opresult6198
  *var_s = opresult6198;
  if (opresult6198 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1423
  setline(1423);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1422
  setline(1422);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6200 == NULL) {
    strlit6200 = alloc_String("""\x0a""");
    gc_root(strlit6200);
  }
// compilenode returning strlit6200
  int op_slot_right_6199 = gc_frame_newslot(strlit6200);
// compilenode returning *var_s
  int op_slot_left_6199 = gc_frame_newslot(*var_s);
  params[0] = strlit6200;
  partcv[0] = 1;
  Object opresult6202 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6202
  *var_s = opresult6202;
  if (opresult6202 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1423
  setline(1423);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6205 = gc_frame_new();
  Object num6207 = alloc_Float64(1);
// compilenode returning num6207
  int op_slot_right_6206 = gc_frame_newslot(num6207);
// compilenode returning *var_depth
  int op_slot_left_6206 = gc_frame_newslot(*var_depth);
  params[0] = num6207;
  partcv[0] = 1;
  Object sum6209 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum6209
  gc_frame_newslot(sum6209);
  int callframe6210 = gc_frame_new();
  partcv[0] = 0;
  Object call6211 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6210);
// compilenode returning call6211
// compilenode returning call6211
  params[0] = sum6209;
  partcv[0] = 1;
  Object call6212 = callmethod(call6211, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6205);
// compilenode returning call6212
  int op_slot_right_6204 = gc_frame_newslot(call6212);
// compilenode returning *var_spc
  int op_slot_right_6214 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_6214 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6216 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6216
  int op_slot_left_6204 = gc_frame_newslot(opresult6216);
  params[0] = call6212;
  partcv[0] = 1;
  Object opresult6217 = callmethod(opresult6216, "++", 1, partcv, params);
// compilenode returning opresult6217
  *var_s = opresult6217;
  if (opresult6217 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1425
  setline(1425);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1424
  setline(1424);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6220 == NULL) {
    strlit6220 = alloc_String("""\x0a""");
    gc_root(strlit6220);
  }
// compilenode returning strlit6220
  int op_slot_right_6219 = gc_frame_newslot(strlit6220);
// compilenode returning *var_s
  int op_slot_left_6219 = gc_frame_newslot(*var_s);
  params[0] = strlit6220;
  partcv[0] = 1;
  Object opresult6222 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6222
  *var_s = opresult6222;
  if (opresult6222 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1425
  setline(1425);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6225 = gc_frame_new();
  Object num6227 = alloc_Float64(1);
// compilenode returning num6227
  int op_slot_right_6226 = gc_frame_newslot(num6227);
// compilenode returning *var_depth
  int op_slot_left_6226 = gc_frame_newslot(*var_depth);
  params[0] = num6227;
  partcv[0] = 1;
  Object sum6229 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum6229
  gc_frame_newslot(sum6229);
  int callframe6230 = gc_frame_new();
  partcv[0] = 0;
  Object call6231 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6230);
// compilenode returning call6231
// compilenode returning call6231
  params[0] = sum6229;
  partcv[0] = 1;
  Object call6232 = callmethod(call6231, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6225);
// compilenode returning call6232
  int op_slot_right_6224 = gc_frame_newslot(call6232);
// compilenode returning *var_spc
  int op_slot_right_6234 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_6234 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6236 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6236
  int op_slot_left_6224 = gc_frame_newslot(opresult6236);
  params[0] = call6232;
  partcv[0] = 1;
  Object opresult6237 = callmethod(opresult6236, "++", 1, partcv, params);
// compilenode returning opresult6237
  *var_s = opresult6237;
  if (opresult6237 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace6239(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1430
  setline(1430);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1429
  setline(1429);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6240 == NULL) {
    strlit6240 = alloc_String("");
    gc_root(strlit6240);
  }
// compilenode returning strlit6240
  *var_s = strlit6240;
  if (strlit6240 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1435
  setline(1435);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1430
  setline(1430);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6244 = gc_frame_new();
  partcv[0] = 0;
  Object call6245 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6244);
// compilenode returning call6245
// compilenode returning call6245
  int op_slot_right_6243 = gc_frame_newslot(call6245);
  int callframe6247 = gc_frame_new();
  int callframe6248 = gc_frame_new();
  partcv[0] = 0;
  Object call6249 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6248);
// compilenode returning call6249
// compilenode returning call6249
  partcv[0] = 0;
  Object call6250 = callmethod(call6249, "value",
    1, partcv, params);
  gc_frame_end(callframe6247);
// compilenode returning call6250
// compilenode returning call6250
  int op_slot_left_6243 = gc_frame_newslot(call6250);
  params[0] = call6245;
  partcv[0] = 1;
  Object opresult6251 = callmethod(call6250, "!=", 1, partcv, params);
// compilenode returning opresult6251
  int op_slot_right_6242 = gc_frame_newslot(opresult6251);
  if (strlit6254 == NULL) {
    strlit6254 = alloc_String("op");
    gc_root(strlit6254);
  }
// compilenode returning strlit6254
  int op_slot_right_6253 = gc_frame_newslot(strlit6254);
  int callframe6256 = gc_frame_new();
  int callframe6257 = gc_frame_new();
  partcv[0] = 0;
  Object call6258 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6257);
// compilenode returning call6258
// compilenode returning call6258
  partcv[0] = 0;
  Object call6259 = callmethod(call6258, "kind",
    1, partcv, params);
  gc_frame_end(callframe6256);
// compilenode returning call6259
// compilenode returning call6259
  int op_slot_left_6253 = gc_frame_newslot(call6259);
  params[0] = strlit6254;
  partcv[0] = 1;
  Object opresult6260 = callmethod(call6259, "==", 1, partcv, params);
// compilenode returning opresult6260
  int op_slot_left_6242 = gc_frame_newslot(opresult6260);
  params[0] = opresult6251;
  partcv[0] = 1;
  Object opresult6261 = callmethod(opresult6260, "&&", 1, partcv, params);
// compilenode returning opresult6261
  Object if6241 = done;
  if (istrue(opresult6261)) {
// Begin line 1432
  setline(1432);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1431
  setline(1431);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6263 == NULL) {
    strlit6263 = alloc_String(")");
    gc_root(strlit6263);
  }
// compilenode returning strlit6263
  int op_slot_right_6262 = gc_frame_newslot(strlit6263);
  int callframe6266 = gc_frame_new();
  Object num6267 = alloc_Float64(0);
// compilenode returning num6267
  gc_frame_newslot(num6267);
  int callframe6268 = gc_frame_new();
  partcv[0] = 0;
  Object call6269 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6268);
// compilenode returning call6269
// compilenode returning call6269
  params[0] = num6267;
  partcv[0] = 1;
  Object call6270 = callmethod(call6269, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6266);
// compilenode returning call6270
  int op_slot_right_6265 = gc_frame_newslot(call6270);
  if (strlit6272 == NULL) {
    strlit6272 = alloc_String("(");
    gc_root(strlit6272);
  }
// compilenode returning strlit6272
  int op_slot_left_6265 = gc_frame_newslot(strlit6272);
  params[0] = call6270;
  partcv[0] = 1;
  Object opresult6273 = callmethod(strlit6272, "++", 1, partcv, params);
// compilenode returning opresult6273
  int op_slot_left_6262 = gc_frame_newslot(opresult6273);
  params[0] = strlit6263;
  partcv[0] = 1;
  Object opresult6274 = callmethod(opresult6273, "++", 1, partcv, params);
// compilenode returning opresult6274
  *var_s = opresult6274;
  if (opresult6274 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6241 = done;
  } else {
// Begin line 1433
  setline(1433);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6276 = gc_frame_new();
  Object num6277 = alloc_Float64(0);
// compilenode returning num6277
  gc_frame_newslot(num6277);
  int callframe6278 = gc_frame_new();
  partcv[0] = 0;
  Object call6279 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6278);
// compilenode returning call6279
// compilenode returning call6279
  params[0] = num6277;
  partcv[0] = 1;
  Object call6280 = callmethod(call6279, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6276);
// compilenode returning call6280
  *var_s = call6280;
  if (call6280 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6241 = done;
  }
// compilenode returning if6241
// Begin line 1440
  setline(1440);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1435
  setline(1435);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6284 == NULL) {
    strlit6284 = alloc_String("..");
    gc_root(strlit6284);
  }
// compilenode returning strlit6284
  int op_slot_right_6283 = gc_frame_newslot(strlit6284);
  int callframe6286 = gc_frame_new();
  partcv[0] = 0;
  Object call6287 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6286);
// compilenode returning call6287
// compilenode returning call6287
  int op_slot_left_6283 = gc_frame_newslot(call6287);
  params[0] = strlit6284;
  partcv[0] = 1;
  Object opresult6288 = callmethod(call6287, "==", 1, partcv, params);
// compilenode returning opresult6288
  Object if6282 = done;
  if (istrue(opresult6288)) {
// Begin line 1437
  setline(1437);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1436
  setline(1436);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6290 = gc_frame_new();
  partcv[0] = 0;
  Object call6291 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6290);
// compilenode returning call6291
// compilenode returning call6291
  int op_slot_right_6289 = gc_frame_newslot(call6291);
// compilenode returning *var_s
  int op_slot_left_6289 = gc_frame_newslot(*var_s);
  params[0] = call6291;
  partcv[0] = 1;
  Object opresult6293 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6293
  *var_s = opresult6293;
  if (opresult6293 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6282 = done;
  } else {
// Begin line 1439
  setline(1439);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1438
  setline(1438);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6296 == NULL) {
    strlit6296 = alloc_String(" ");
    gc_root(strlit6296);
  }
// compilenode returning strlit6296
  int op_slot_right_6295 = gc_frame_newslot(strlit6296);
  int callframe6299 = gc_frame_new();
  partcv[0] = 0;
  Object call6300 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6299);
// compilenode returning call6300
// compilenode returning call6300
  int op_slot_right_6298 = gc_frame_newslot(call6300);
  if (strlit6303 == NULL) {
    strlit6303 = alloc_String(" ");
    gc_root(strlit6303);
  }
// compilenode returning strlit6303
  int op_slot_right_6302 = gc_frame_newslot(strlit6303);
// compilenode returning *var_s
  int op_slot_left_6302 = gc_frame_newslot(*var_s);
  params[0] = strlit6303;
  partcv[0] = 1;
  Object opresult6305 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6305
  int op_slot_left_6298 = gc_frame_newslot(opresult6305);
  params[0] = call6300;
  partcv[0] = 1;
  Object opresult6306 = callmethod(opresult6305, "++", 1, partcv, params);
// compilenode returning opresult6306
  int op_slot_left_6295 = gc_frame_newslot(opresult6306);
  params[0] = strlit6296;
  partcv[0] = 1;
  Object opresult6307 = callmethod(opresult6306, "++", 1, partcv, params);
// compilenode returning opresult6307
  *var_s = opresult6307;
  if (opresult6307 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6282 = done;
  }
// compilenode returning if6282
// Begin line 1445
  setline(1445);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1440
  setline(1440);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6312 = gc_frame_new();
  partcv[0] = 0;
  Object call6313 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6312);
// compilenode returning call6313
// compilenode returning call6313
  int op_slot_right_6311 = gc_frame_newslot(call6313);
  int callframe6315 = gc_frame_new();
  int callframe6316 = gc_frame_new();
  partcv[0] = 0;
  Object call6317 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6316);
// compilenode returning call6317
// compilenode returning call6317
  partcv[0] = 0;
  Object call6318 = callmethod(call6317, "value",
    1, partcv, params);
  gc_frame_end(callframe6315);
// compilenode returning call6318
// compilenode returning call6318
  int op_slot_left_6311 = gc_frame_newslot(call6318);
  params[0] = call6313;
  partcv[0] = 1;
  Object opresult6319 = callmethod(call6318, "!=", 1, partcv, params);
// compilenode returning opresult6319
  int op_slot_right_6310 = gc_frame_newslot(opresult6319);
  if (strlit6322 == NULL) {
    strlit6322 = alloc_String("op");
    gc_root(strlit6322);
  }
// compilenode returning strlit6322
  int op_slot_right_6321 = gc_frame_newslot(strlit6322);
  int callframe6324 = gc_frame_new();
  int callframe6325 = gc_frame_new();
  partcv[0] = 0;
  Object call6326 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6325);
// compilenode returning call6326
// compilenode returning call6326
  partcv[0] = 0;
  Object call6327 = callmethod(call6326, "kind",
    1, partcv, params);
  gc_frame_end(callframe6324);
// compilenode returning call6327
// compilenode returning call6327
  int op_slot_left_6321 = gc_frame_newslot(call6327);
  params[0] = strlit6322;
  partcv[0] = 1;
  Object opresult6328 = callmethod(call6327, "==", 1, partcv, params);
// compilenode returning opresult6328
  int op_slot_left_6310 = gc_frame_newslot(opresult6328);
  params[0] = opresult6319;
  partcv[0] = 1;
  Object opresult6329 = callmethod(opresult6328, "&&", 1, partcv, params);
// compilenode returning opresult6329
  Object if6309 = done;
  if (istrue(opresult6329)) {
// Begin line 1442
  setline(1442);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1441
  setline(1441);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6331 == NULL) {
    strlit6331 = alloc_String(")");
    gc_root(strlit6331);
  }
// compilenode returning strlit6331
  int op_slot_right_6330 = gc_frame_newslot(strlit6331);
  int callframe6334 = gc_frame_new();
  Object num6335 = alloc_Float64(0);
// compilenode returning num6335
  gc_frame_newslot(num6335);
  int callframe6336 = gc_frame_new();
  partcv[0] = 0;
  Object call6337 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6336);
// compilenode returning call6337
// compilenode returning call6337
  params[0] = num6335;
  partcv[0] = 1;
  Object call6338 = callmethod(call6337, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6334);
// compilenode returning call6338
  int op_slot_right_6333 = gc_frame_newslot(call6338);
  if (strlit6341 == NULL) {
    strlit6341 = alloc_String("(");
    gc_root(strlit6341);
  }
// compilenode returning strlit6341
  int op_slot_right_6340 = gc_frame_newslot(strlit6341);
// compilenode returning *var_s
  int op_slot_left_6340 = gc_frame_newslot(*var_s);
  params[0] = strlit6341;
  partcv[0] = 1;
  Object opresult6343 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6343
  int op_slot_left_6333 = gc_frame_newslot(opresult6343);
  params[0] = call6338;
  partcv[0] = 1;
  Object opresult6344 = callmethod(opresult6343, "++", 1, partcv, params);
// compilenode returning opresult6344
  int op_slot_left_6330 = gc_frame_newslot(opresult6344);
  params[0] = strlit6331;
  partcv[0] = 1;
  Object opresult6345 = callmethod(opresult6344, "++", 1, partcv, params);
// compilenode returning opresult6345
  *var_s = opresult6345;
  if (opresult6345 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6309 = done;
  } else {
// Begin line 1443
  setline(1443);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6348 = gc_frame_new();
  Object num6349 = alloc_Float64(0);
// compilenode returning num6349
  gc_frame_newslot(num6349);
  int callframe6350 = gc_frame_new();
  partcv[0] = 0;
  Object call6351 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6350);
// compilenode returning call6351
// compilenode returning call6351
  params[0] = num6349;
  partcv[0] = 1;
  Object call6352 = callmethod(call6351, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6348);
// compilenode returning call6352
  int op_slot_right_6347 = gc_frame_newslot(call6352);
// compilenode returning *var_s
  int op_slot_left_6347 = gc_frame_newslot(*var_s);
  params[0] = call6352;
  partcv[0] = 1;
  Object opresult6354 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6354
  *var_s = opresult6354;
  if (opresult6354 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6309 = done;
  }
// compilenode returning if6309
// Begin line 1445
  setline(1445);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new6121(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_opNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_op = &(stackframe->slots[0]);
  *var_op = args[curarg];
  curarg++;
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[2]);
  *var_r = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6122 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6122 = alloc_userobj2(10,11, objclass6122);
  gc_frame_newslot(obj6122);
if (objclass6122 == NULL) {
  glfree(obj6122->class->name);
  obj6122->class->name = "opNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6122, self, 0);
  addmethodreal(obj6122,"outer", &reader_ast_outer_6123);
  Object oldself6122 = self;
  struct StackFrameObject *oldstackframe6122 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6122);
  gc_frame_newslot((Object)stackframe);
  self = obj6122;
  Object *oldselfslot6122 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6122 = (*(struct UserObject *)self).data[0], lowerouter6122 = thisouter6122;
  if (inheritingObject6122) {
    struct UserObject *inho6122 = (struct UserObject *)inheritingObject6122;
    while (inho6122->super != GraceDefaultObject) inho6122 = (struct UserObject *)inho6122->super;
    inho6122->super = obj6122;
    self = inheritingObject6122;
    *selfslot = self;
    lowerouter6122 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6122;
  }
if (objclass6122 == NULL) {
  Method *reader6124 = addmethodrealflags(obj6122, "kind",&reader_ast_kind_6124, MFLAG_DEF);
  reader6124->definitionModule = modulename;
  reader6124->definitionLine = 1396;
}
adddatum2(obj6122, alloc_Undefined(), 1);
if (objclass6122 == NULL) {
  Method *reader6125 = addmethodrealflags(obj6122, "value",&reader_ast_value_6125, MFLAG_DEF);
  reader6125->definitionModule = modulename;
  reader6125->definitionLine = 1397;
}
adddatum2(obj6122, alloc_Undefined(), 2);
if (objclass6122 == NULL) {
  Method *reader6126 = addmethodrealflags(obj6122, "left",&reader_ast_left_6126, MFLAG_DEF);
  reader6126->definitionModule = modulename;
  reader6126->definitionLine = 1398;
}
adddatum2(obj6122, alloc_Undefined(), 3);
if (objclass6122 == NULL) {
  Method *reader6127 = addmethodrealflags(obj6122, "right",&reader_ast_right_6127, MFLAG_DEF);
  reader6127->definitionModule = modulename;
  reader6127->definitionLine = 1399;
}
adddatum2(obj6122, alloc_Undefined(), 4);
  struct UserObject *uo6128 = (struct UserObject*)obj6122;
  uo6128->data[5] = emptyclosure;
  Method *meth_meth_ast_accept6128 = addmethod2pos(obj6122, "accept", &meth_ast_accept6128, 5);
int argcv_meth_ast_accept6128[] = {1};
meth_meth_ast_accept6128->type = alloc_MethodType(1, argcv_meth_ast_accept6128);
meth_meth_ast_accept6128->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept6128->type->names[0] = "visitor";
  meth_meth_ast_accept6128->definitionModule = modulename;
  meth_meth_ast_accept6128->definitionLine = 1399;
  block_savedest(obj6122);
  Object closure6140 = createclosure(1, "map()before()after");
setclosureframe(closure6140, stackframe);
  addtoclosure(closure6140, var_opNode);
  struct UserObject *uo6140 = (struct UserObject*)obj6122;
  uo6140->data[6] = (Object)closure6140;
  Method *meth_meth_ast_map_40__41_before_40__41_after6140 = addmethod2pos(obj6122, "map()before()after", &meth_ast_map_40__41_before_40__41_after6140, 6);
int argcv_meth_ast_map_40__41_before_40__41_after6140[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after6140->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after6140);
  meth_meth_ast_map_40__41_before_40__41_after6140->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after6140->definitionLine = 1405;
  struct UserObject *uo6164 = (struct UserObject*)obj6122;
  uo6164->data[7] = emptyclosure;
  Method *meth_meth_ast_map6164 = addmethod2pos(obj6122, "map", &meth_ast_map6164, 7);
int argcv_meth_ast_map6164[] = {1};
meth_meth_ast_map6164->type = alloc_MethodType(1, argcv_meth_ast_map6164);
  meth_meth_ast_map6164->definitionModule = modulename;
  meth_meth_ast_map6164->definitionLine = 1413;
  struct UserObject *uo6173 = (struct UserObject*)obj6122;
  uo6173->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty6173 = addmethod2pos(obj6122, "pretty", &meth_ast_pretty6173, 8);
int argcv_meth_ast_pretty6173[] = {1};
meth_meth_ast_pretty6173->type = alloc_MethodType(1, argcv_meth_ast_pretty6173);
  meth_meth_ast_pretty6173->definitionModule = modulename;
  meth_meth_ast_pretty6173->definitionLine = 1416;
  struct UserObject *uo6239 = (struct UserObject*)obj6122;
  uo6239->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace6239 = addmethod2pos(obj6122, "toGrace", &meth_ast_toGrace6239, 9);
int argcv_meth_ast_toGrace6239[] = {1};
meth_meth_ast_toGrace6239->type = alloc_MethodType(1, argcv_meth_ast_toGrace6239);
meth_meth_ast_toGrace6239->type->types[0] = type_Number;
meth_meth_ast_toGrace6239->type->names[0] = "depth";
  meth_meth_ast_toGrace6239->definitionModule = modulename;
  meth_meth_ast_toGrace6239->definitionLine = 1428;
  sourceObject = obj6122;
// Begin line 1394
  setline(1394);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6356 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6357 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6356);
// compilenode returning call6357
  struct UserObject *obj6122_uo = (struct UserObject *)obj6122;
  obj6122_uo->super = call6357;
  sourceObject = obj6122;
// Begin line 1395
  setline(1395);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6358 == NULL) {
    strlit6358 = alloc_String("op");
    gc_root(strlit6358);
  }
// compilenode returning strlit6358
  adddatum2(obj6122, strlit6358, 1);
  sourceObject = obj6122;
// Begin line 1396
  setline(1396);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_op
  adddatum2(obj6122, *var_op, 2);
  sourceObject = obj6122;
// Begin line 1397
  setline(1397);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_l
  adddatum2(obj6122, *var_l, 3);
  sourceObject = obj6122;
// Begin line 1398
  setline(1398);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_r
  adddatum2(obj6122, *var_r, 4);
  sourceObject = obj6122;
  sourceObject = obj6122;
  sourceObject = obj6122;
  sourceObject = obj6122;
  sourceObject = obj6122;
objclass6122 = obj6122->class;
  objclass6122->definitionModule = modulename;
  objclass6122->definitionLine = 1390;
  (*(struct UserObject *)self).data[0] = lowerouter6122;
  self = oldself6122;
  selfslot = oldselfslot6122;
  stackframe = oldstackframe6122;
  gc_frame_end(frame);
  return obj6122;
}
Object meth_ast_new6121_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_opNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_op = &(stackframe->slots[0]);
  *var_op = args[curarg];
  curarg++;
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[2]);
  *var_r = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6122 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6122 = alloc_userobj2(10,11, objclass6122);
  gc_frame_newslot(obj6122);
if (objclass6122 == NULL) {
  glfree(obj6122->class->name);
  obj6122->class->name = "opNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6122, self, 0);
  addmethodreal(obj6122,"outer", &reader_ast_outer_6123);
  Object oldself6122 = self;
  struct StackFrameObject *oldstackframe6122 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6122);
  gc_frame_newslot((Object)stackframe);
  self = obj6122;
  Object *oldselfslot6122 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6122 = (*(struct UserObject *)self).data[0], lowerouter6122 = thisouter6122;
  if (inheritingObject6122) {
    struct UserObject *inho6122 = (struct UserObject *)inheritingObject6122;
    while (inho6122->super != GraceDefaultObject) inho6122 = (struct UserObject *)inho6122->super;
    inho6122->super = obj6122;
    self = inheritingObject6122;
    *selfslot = self;
    lowerouter6122 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6122;
  }
if (objclass6122 == NULL) {
  Method *reader6124 = addmethodrealflags(obj6122, "kind",&reader_ast_kind_6124, MFLAG_DEF);
  reader6124->definitionModule = modulename;
  reader6124->definitionLine = 1396;
}
adddatum2(obj6122, alloc_Undefined(), 1);
if (objclass6122 == NULL) {
  Method *reader6125 = addmethodrealflags(obj6122, "value",&reader_ast_value_6125, MFLAG_DEF);
  reader6125->definitionModule = modulename;
  reader6125->definitionLine = 1397;
}
adddatum2(obj6122, alloc_Undefined(), 2);
if (objclass6122 == NULL) {
  Method *reader6126 = addmethodrealflags(obj6122, "left",&reader_ast_left_6126, MFLAG_DEF);
  reader6126->definitionModule = modulename;
  reader6126->definitionLine = 1398;
}
adddatum2(obj6122, alloc_Undefined(), 3);
if (objclass6122 == NULL) {
  Method *reader6127 = addmethodrealflags(obj6122, "right",&reader_ast_right_6127, MFLAG_DEF);
  reader6127->definitionModule = modulename;
  reader6127->definitionLine = 1399;
}
adddatum2(obj6122, alloc_Undefined(), 4);
  struct UserObject *uo6128 = (struct UserObject*)obj6122;
  uo6128->data[5] = emptyclosure;
  Method *meth_meth_ast_accept6128 = addmethod2pos(obj6122, "accept", &meth_ast_accept6128, 5);
int argcv_meth_ast_accept6128[] = {1};
meth_meth_ast_accept6128->type = alloc_MethodType(1, argcv_meth_ast_accept6128);
meth_meth_ast_accept6128->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept6128->type->names[0] = "visitor";
  meth_meth_ast_accept6128->definitionModule = modulename;
  meth_meth_ast_accept6128->definitionLine = 1399;
  block_savedest(obj6122);
  Object closure6140 = createclosure(1, "map()before()after");
setclosureframe(closure6140, stackframe);
  addtoclosure(closure6140, var_opNode);
  struct UserObject *uo6140 = (struct UserObject*)obj6122;
  uo6140->data[6] = (Object)closure6140;
  Method *meth_meth_ast_map_40__41_before_40__41_after6140 = addmethod2pos(obj6122, "map()before()after", &meth_ast_map_40__41_before_40__41_after6140, 6);
int argcv_meth_ast_map_40__41_before_40__41_after6140[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after6140->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after6140);
  meth_meth_ast_map_40__41_before_40__41_after6140->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after6140->definitionLine = 1405;
  struct UserObject *uo6164 = (struct UserObject*)obj6122;
  uo6164->data[7] = emptyclosure;
  Method *meth_meth_ast_map6164 = addmethod2pos(obj6122, "map", &meth_ast_map6164, 7);
int argcv_meth_ast_map6164[] = {1};
meth_meth_ast_map6164->type = alloc_MethodType(1, argcv_meth_ast_map6164);
  meth_meth_ast_map6164->definitionModule = modulename;
  meth_meth_ast_map6164->definitionLine = 1413;
  struct UserObject *uo6173 = (struct UserObject*)obj6122;
  uo6173->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty6173 = addmethod2pos(obj6122, "pretty", &meth_ast_pretty6173, 8);
int argcv_meth_ast_pretty6173[] = {1};
meth_meth_ast_pretty6173->type = alloc_MethodType(1, argcv_meth_ast_pretty6173);
  meth_meth_ast_pretty6173->definitionModule = modulename;
  meth_meth_ast_pretty6173->definitionLine = 1416;
  struct UserObject *uo6239 = (struct UserObject*)obj6122;
  uo6239->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace6239 = addmethod2pos(obj6122, "toGrace", &meth_ast_toGrace6239, 9);
int argcv_meth_ast_toGrace6239[] = {1};
meth_meth_ast_toGrace6239->type = alloc_MethodType(1, argcv_meth_ast_toGrace6239);
meth_meth_ast_toGrace6239->type->types[0] = type_Number;
meth_meth_ast_toGrace6239->type->names[0] = "depth";
  meth_meth_ast_toGrace6239->definitionModule = modulename;
  meth_meth_ast_toGrace6239->definitionLine = 1428;
  sourceObject = obj6122;
// Begin line 1394
  setline(1394);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6356 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6357 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6356);
// compilenode returning call6357
  struct UserObject *obj6122_uo = (struct UserObject *)obj6122;
  obj6122_uo->super = call6357;
  sourceObject = obj6122;
// Begin line 1395
  setline(1395);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6358 == NULL) {
    strlit6358 = alloc_String("op");
    gc_root(strlit6358);
  }
// compilenode returning strlit6358
  adddatum2(obj6122, strlit6358, 1);
  sourceObject = obj6122;
// Begin line 1396
  setline(1396);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_op
  adddatum2(obj6122, *var_op, 2);
  sourceObject = obj6122;
// Begin line 1397
  setline(1397);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_l
  adddatum2(obj6122, *var_l, 3);
  sourceObject = obj6122;
// Begin line 1398
  setline(1398);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_r
  adddatum2(obj6122, *var_r, 4);
  sourceObject = obj6122;
  sourceObject = obj6122;
  sourceObject = obj6122;
  sourceObject = obj6122;
  sourceObject = obj6122;
objclass6122 = obj6122->class;
  objclass6122->definitionModule = modulename;
  objclass6122->definitionLine = 1390;
  (*(struct UserObject *)self).data[0] = lowerouter6122;
  self = oldself6122;
  selfslot = oldselfslot6122;
  stackframe = oldstackframe6122;
  gc_frame_end(frame);
  return obj6122;
}
Object meth_ast_indexNode6360(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indexNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_indexNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for indexNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for indexNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1448
  setline(1448);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_indexNode
  gc_frame_end(frame);
  return *var_indexNode;
}
Object meth_ast_accept6369(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1458
  setline(1458);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1454
  setline(1454);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6371 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call6372 = callmethod(*var_visitor, "visitIndex",
    1, partcv, params);
  gc_frame_end(callframe6371);
// compilenode returning call6372
  Object if6370 = done;
  if (istrue(call6372)) {
// Begin line 1455
  setline(1455);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6373 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe6374 = gc_frame_new();
  partcv[0] = 0;
  Object call6375 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6374);
// compilenode returning call6375
// compilenode returning call6375
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call6376 = callmethod(call6375, "accept",
    1, partcv, params);
  gc_frame_end(callframe6373);
// compilenode returning call6376
// Begin line 1456
  setline(1456);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6377 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe6378 = gc_frame_new();
  partcv[0] = 0;
  Object call6379 = callmethodflags(self, "index", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6378);
// compilenode returning call6379
// compilenode returning call6379
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call6380 = callmethod(call6379, "accept",
    1, partcv, params);
  gc_frame_end(callframe6377);
// compilenode returning call6380
    gc_frame_newslot(call6380);
    if6370 = call6380;
  } else {
  }
// compilenode returning if6370
  gc_frame_end(frame);
  return if6370;
}
Object meth_ast_map_40__41_before_40__41_after6381(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_indexNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1460
  setline(1460);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6382 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call6383 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe6382);
// compilenode returning call6383
// Begin line 1461
  setline(1461);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6384 = gc_frame_new();
  int callframe6385 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe6386 = gc_frame_new();
  partcv[0] = 0;
  Object call6387 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6386);
// compilenode returning call6387
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6388 = callmethod(call6387, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe6385);
// compilenode returning call6388
  gc_frame_newslot(call6388);
  int callframe6389 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe6390 = gc_frame_new();
  partcv[0] = 0;
  Object call6391 = callmethodflags(self, "index", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6390);
// compilenode returning call6391
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6392 = callmethod(call6391, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe6389);
// compilenode returning call6392
  gc_frame_newslot(call6392);
// compilenode returning *var_indexNode
  params[0] = call6388;
  params[1] = call6392;
  partcv[0] = 2;
  Object call6393 = callmethod(*var_indexNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6384);
// compilenode returning call6393
  *var_n = call6393;
  if (call6393 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1462
  setline(1462);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6394 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6395 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe6394);
// compilenode returning call6395
  *var_n = call6395;
  if (call6395 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1464
  setline(1464);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1456
  setline(1456);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6397 = gc_frame_new();
// Begin line 1463
  setline(1463);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6398 = gc_frame_new();
  partcv[0] = 0;
  Object call6399 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6398);
// compilenode returning call6399
  gc_frame_newslot(call6399);
// compilenode returning *var_n
  params[0] = call6399;
  partcv[0] = 1;
  Object call6400 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe6397);
// compilenode returning call6400
// compilenode returning done
// Begin line 1464
  setline(1464);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6401 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6402 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe6401);
// compilenode returning call6402
// Begin line 1465
  setline(1465);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply6406(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6409(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map6403(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1468
  setline(1468);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6404 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block6405 = alloc_Block(NULL, NULL, "ast", 1468);
  gc_frame_newslot(block6405);
  block_savedest(block6405);
  Object closure6406 = createclosure(1, "_apply");
setclosureframe(closure6406, stackframe);
  addtoclosure(closure6406, selfslot);
  struct UserObject *uo6406 = (struct UserObject*)block6405;
  uo6406->data[0] = (Object)closure6406;
  Method *meth_meth_ast__apply6406 = addmethod2pos(block6405, "_apply", &meth_ast__apply6406, 0);
int argcv_meth_ast__apply6406[] = {0};
meth_meth_ast__apply6406->type = alloc_MethodType(1, argcv_meth_ast__apply6406);
  meth_meth_ast__apply6406->definitionModule = modulename;
  meth_meth_ast__apply6406->definitionLine = 1456;
// compilenode returning block6405
  gc_frame_newslot(block6405);
  Object block6408 = alloc_Block(NULL, NULL, "ast", 1468);
  gc_frame_newslot(block6408);
  block_savedest(block6408);
  Object closure6409 = createclosure(1, "_apply");
setclosureframe(closure6409, stackframe);
  addtoclosure(closure6409, selfslot);
  struct UserObject *uo6409 = (struct UserObject*)block6408;
  uo6409->data[0] = (Object)closure6409;
  Method *meth_meth_ast__apply6409 = addmethod2pos(block6408, "_apply", &meth_ast__apply6409, 0);
int argcv_meth_ast__apply6409[] = {0};
meth_meth_ast__apply6409->type = alloc_MethodType(1, argcv_meth_ast__apply6409);
  meth_meth_ast__apply6409->definitionModule = modulename;
  meth_meth_ast__apply6409->definitionLine = 1456;
// compilenode returning block6408
  gc_frame_newslot(block6408);
  params[0] = *var_blk;
  params[1] = block6405;
  params[2] = block6408;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6411 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6404);
// compilenode returning call6411
  gc_frame_end(frame);
  return call6411;
}
Object meth_ast__apply6420(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1474
  setline(1474);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1473
  setline(1473);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6422 == NULL) {
    strlit6422 = alloc_String("  ");
    gc_root(strlit6422);
  }
// compilenode returning strlit6422
  int op_slot_right_6421 = gc_frame_newslot(strlit6422);
// compilenode returning *var_spc
  int op_slot_left_6421 = gc_frame_newslot(*var_spc);
  params[0] = strlit6422;
  partcv[0] = 1;
  Object opresult6424 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult6424
  *var_spc = opresult6424;
  if (opresult6424 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty6412(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1472
  setline(1472);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1471
  setline(1471);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6413 == NULL) {
    strlit6413 = alloc_String("");
    gc_root(strlit6413);
  }
// compilenode returning strlit6413
  *var_spc = strlit6413;
  if (strlit6413 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1472
  setline(1472);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6414 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_6415 = gc_frame_newslot(*var_depth);
  Object num6417 = alloc_Float64(0);
// compilenode returning num6417
  int op_slot_left_6415 = gc_frame_newslot(num6417);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6418 = callmethod(num6417, "..", 1, partcv, params);
// compilenode returning opresult6418
  gc_frame_newslot(opresult6418);
  Object block6419 = alloc_Block(NULL, NULL, "ast", 1472);
  gc_frame_newslot(block6419);
  block_savedest(block6419);
  Object closure6420 = createclosure(2, "_apply");
setclosureframe(closure6420, stackframe);
  addtoclosure(closure6420, var_spc);
  addtoclosure(closure6420, selfslot);
  struct UserObject *uo6420 = (struct UserObject*)block6419;
  uo6420->data[0] = (Object)closure6420;
  Method *meth_meth_ast__apply6420 = addmethod2pos(block6419, "_apply", &meth_ast__apply6420, 0);
int argcv_meth_ast__apply6420[] = {1};
meth_meth_ast__apply6420->type = alloc_MethodType(1, argcv_meth_ast__apply6420);
  meth_meth_ast__apply6420->definitionModule = modulename;
  meth_meth_ast__apply6420->definitionLine = 1456;
// compilenode returning block6419
  gc_frame_newslot(block6419);
  params[0] = opresult6418;
  params[1] = block6419;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6427 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6414);
// compilenode returning call6427
// Begin line 1476
  setline(1476);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1475
  setline(1475);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6428 == NULL) {
    strlit6428 = alloc_String("Index");
    gc_root(strlit6428);
  }
// compilenode returning strlit6428
  *var_s = strlit6428;
  if (strlit6428 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1477
  setline(1477);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1476
  setline(1476);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6430 == NULL) {
    strlit6430 = alloc_String("""\x0a""");
    gc_root(strlit6430);
  }
// compilenode returning strlit6430
  int op_slot_right_6429 = gc_frame_newslot(strlit6430);
// compilenode returning *var_s
  int op_slot_left_6429 = gc_frame_newslot(*var_s);
  params[0] = strlit6430;
  partcv[0] = 1;
  Object opresult6432 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6432
  *var_s = opresult6432;
  if (opresult6432 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1477
  setline(1477);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6435 = gc_frame_new();
  Object num6437 = alloc_Float64(1);
// compilenode returning num6437
  int op_slot_right_6436 = gc_frame_newslot(num6437);
// compilenode returning *var_depth
  int op_slot_left_6436 = gc_frame_newslot(*var_depth);
  params[0] = num6437;
  partcv[0] = 1;
  Object sum6439 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum6439
  gc_frame_newslot(sum6439);
  int callframe6440 = gc_frame_new();
  partcv[0] = 0;
  Object call6441 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6440);
// compilenode returning call6441
// compilenode returning call6441
  params[0] = sum6439;
  partcv[0] = 1;
  Object call6442 = callmethod(call6441, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6435);
// compilenode returning call6442
  int op_slot_right_6434 = gc_frame_newslot(call6442);
// compilenode returning *var_spc
  int op_slot_right_6444 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_6444 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6446 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6446
  int op_slot_left_6434 = gc_frame_newslot(opresult6446);
  params[0] = call6442;
  partcv[0] = 1;
  Object opresult6447 = callmethod(opresult6446, "++", 1, partcv, params);
// compilenode returning opresult6447
  *var_s = opresult6447;
  if (opresult6447 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1479
  setline(1479);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1478
  setline(1478);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6450 == NULL) {
    strlit6450 = alloc_String("""\x0a""");
    gc_root(strlit6450);
  }
// compilenode returning strlit6450
  int op_slot_right_6449 = gc_frame_newslot(strlit6450);
// compilenode returning *var_s
  int op_slot_left_6449 = gc_frame_newslot(*var_s);
  params[0] = strlit6450;
  partcv[0] = 1;
  Object opresult6452 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6452
  *var_s = opresult6452;
  if (opresult6452 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1479
  setline(1479);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6455 = gc_frame_new();
  Object num6457 = alloc_Float64(1);
// compilenode returning num6457
  int op_slot_right_6456 = gc_frame_newslot(num6457);
// compilenode returning *var_depth
  int op_slot_left_6456 = gc_frame_newslot(*var_depth);
  params[0] = num6457;
  partcv[0] = 1;
  Object sum6459 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum6459
  gc_frame_newslot(sum6459);
  int callframe6460 = gc_frame_new();
  partcv[0] = 0;
  Object call6461 = callmethodflags(self, "index", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6460);
// compilenode returning call6461
// compilenode returning call6461
  params[0] = sum6459;
  partcv[0] = 1;
  Object call6462 = callmethod(call6461, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6455);
// compilenode returning call6462
  int op_slot_right_6454 = gc_frame_newslot(call6462);
// compilenode returning *var_spc
  int op_slot_right_6464 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_6464 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6466 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6466
  int op_slot_left_6454 = gc_frame_newslot(opresult6466);
  params[0] = call6462;
  partcv[0] = 1;
  Object opresult6467 = callmethod(opresult6466, "++", 1, partcv, params);
// compilenode returning opresult6467
  *var_s = opresult6467;
  if (opresult6467 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1480
  setline(1480);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply6481(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1486
  setline(1486);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1485
  setline(1485);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6483 == NULL) {
    strlit6483 = alloc_String("    ");
    gc_root(strlit6483);
  }
// compilenode returning strlit6483
  int op_slot_right_6482 = gc_frame_newslot(strlit6483);
// compilenode returning *var_spc
  int op_slot_left_6482 = gc_frame_newslot(*var_spc);
  params[0] = strlit6483;
  partcv[0] = 1;
  Object opresult6485 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult6485
  *var_spc = opresult6485;
  if (opresult6485 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace6469(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1484
  setline(1484);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1483
  setline(1483);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6470 == NULL) {
    strlit6470 = alloc_String("");
    gc_root(strlit6470);
  }
// compilenode returning strlit6470
  *var_spc = strlit6470;
  if (strlit6470 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1484
  setline(1484);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6471 = gc_frame_new();
  Object num6474 = alloc_Float64(1);
// compilenode returning num6474
  int op_slot_right_6473 = gc_frame_newslot(num6474);
// compilenode returning *var_depth
  int op_slot_left_6473 = gc_frame_newslot(*var_depth);
  params[0] = num6474;
  partcv[0] = 1;
  Object diff6476 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff6476
  int op_slot_right_6472 = gc_frame_newslot(diff6476);
  Object num6478 = alloc_Float64(0);
// compilenode returning num6478
  int op_slot_left_6472 = gc_frame_newslot(num6478);
  params[0] = diff6476;
  partcv[0] = 1;
  Object opresult6479 = callmethod(num6478, "..", 1, partcv, params);
// compilenode returning opresult6479
  gc_frame_newslot(opresult6479);
  Object block6480 = alloc_Block(NULL, NULL, "ast", 1484);
  gc_frame_newslot(block6480);
  block_savedest(block6480);
  Object closure6481 = createclosure(2, "_apply");
setclosureframe(closure6481, stackframe);
  addtoclosure(closure6481, var_spc);
  addtoclosure(closure6481, selfslot);
  struct UserObject *uo6481 = (struct UserObject*)block6480;
  uo6481->data[0] = (Object)closure6481;
  Method *meth_meth_ast__apply6481 = addmethod2pos(block6480, "_apply", &meth_ast__apply6481, 0);
int argcv_meth_ast__apply6481[] = {1};
meth_meth_ast__apply6481->type = alloc_MethodType(1, argcv_meth_ast__apply6481);
  meth_meth_ast__apply6481->definitionModule = modulename;
  meth_meth_ast__apply6481->definitionLine = 1479;
// compilenode returning block6480
  gc_frame_newslot(block6480);
  params[0] = opresult6479;
  params[1] = block6480;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6488 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6471);
// compilenode returning call6488
// Begin line 1487
  setline(1487);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6489 = gc_frame_new();
  Object num6491 = alloc_Float64(1);
// compilenode returning num6491
  int op_slot_right_6490 = gc_frame_newslot(num6491);
// compilenode returning *var_depth
  int op_slot_left_6490 = gc_frame_newslot(*var_depth);
  params[0] = num6491;
  partcv[0] = 1;
  Object sum6493 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum6493
  gc_frame_newslot(sum6493);
  int callframe6494 = gc_frame_new();
  partcv[0] = 0;
  Object call6495 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6494);
// compilenode returning call6495
// compilenode returning call6495
  params[0] = sum6493;
  partcv[0] = 1;
  Object call6496 = callmethod(call6495, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6489);
// compilenode returning call6496
  *var_s = call6496;
  if (call6496 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1489
  setline(1489);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1488
  setline(1488);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6498 == NULL) {
    strlit6498 = alloc_String("]");
    gc_root(strlit6498);
  }
// compilenode returning strlit6498
  int op_slot_right_6497 = gc_frame_newslot(strlit6498);
  int callframe6501 = gc_frame_new();
  Object num6503 = alloc_Float64(1);
// compilenode returning num6503
  int op_slot_right_6502 = gc_frame_newslot(num6503);
// compilenode returning *var_depth
  int op_slot_left_6502 = gc_frame_newslot(*var_depth);
  params[0] = num6503;
  partcv[0] = 1;
  Object sum6505 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum6505
  gc_frame_newslot(sum6505);
  int callframe6506 = gc_frame_new();
  partcv[0] = 0;
  Object call6507 = callmethodflags(self, "index", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6506);
// compilenode returning call6507
// compilenode returning call6507
  params[0] = sum6505;
  partcv[0] = 1;
  Object call6508 = callmethod(call6507, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6501);
// compilenode returning call6508
  int op_slot_right_6500 = gc_frame_newslot(call6508);
  if (strlit6511 == NULL) {
    strlit6511 = alloc_String("[");
    gc_root(strlit6511);
  }
// compilenode returning strlit6511
  int op_slot_right_6510 = gc_frame_newslot(strlit6511);
// compilenode returning *var_s
  int op_slot_left_6510 = gc_frame_newslot(*var_s);
  params[0] = strlit6511;
  partcv[0] = 1;
  Object opresult6513 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6513
  int op_slot_left_6500 = gc_frame_newslot(opresult6513);
  params[0] = call6508;
  partcv[0] = 1;
  Object opresult6514 = callmethod(opresult6513, "++", 1, partcv, params);
// compilenode returning opresult6514
  int op_slot_left_6497 = gc_frame_newslot(opresult6514);
  params[0] = strlit6498;
  partcv[0] = 1;
  Object opresult6515 = callmethod(opresult6514, "++", 1, partcv, params);
// compilenode returning opresult6515
  *var_s = opresult6515;
  if (opresult6515 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1489
  setline(1489);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new6363(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_indexNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  Object *var_index_39_ = &(stackframe->slots[1]);
  *var_index_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6364 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6364 = alloc_userobj2(9,10, objclass6364);
  gc_frame_newslot(obj6364);
if (objclass6364 == NULL) {
  glfree(obj6364->class->name);
  obj6364->class->name = "indexNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6364, self, 0);
  addmethodreal(obj6364,"outer", &reader_ast_outer_6365);
  Object oldself6364 = self;
  struct StackFrameObject *oldstackframe6364 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6364);
  gc_frame_newslot((Object)stackframe);
  self = obj6364;
  Object *oldselfslot6364 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6364 = (*(struct UserObject *)self).data[0], lowerouter6364 = thisouter6364;
  if (inheritingObject6364) {
    struct UserObject *inho6364 = (struct UserObject *)inheritingObject6364;
    while (inho6364->super != GraceDefaultObject) inho6364 = (struct UserObject *)inho6364->super;
    inho6364->super = obj6364;
    self = inheritingObject6364;
    *selfslot = self;
    lowerouter6364 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6364;
  }
if (objclass6364 == NULL) {
  Method *reader6366 = addmethodrealflags(obj6364, "kind",&reader_ast_kind_6366, MFLAG_DEF);
  reader6366->definitionModule = modulename;
  reader6366->definitionLine = 1451;
}
adddatum2(obj6364, alloc_Undefined(), 1);
if (objclass6364 == NULL) {
  Method *reader6367 = addmethodrealflags(obj6364, "value",&reader_ast_value_6367, MFLAG_DEF);
  reader6367->definitionModule = modulename;
  reader6367->definitionLine = 1452;
}
adddatum2(obj6364, alloc_Undefined(), 2);
if (objclass6364 == NULL) {
  Method *reader6368 = addmethodrealflags(obj6364, "index",&reader_ast_index_6368, MFLAG_DEF);
  reader6368->definitionModule = modulename;
  reader6368->definitionLine = 1453;
}
adddatum2(obj6364, alloc_Undefined(), 3);
  struct UserObject *uo6369 = (struct UserObject*)obj6364;
  uo6369->data[4] = emptyclosure;
  Method *meth_meth_ast_accept6369 = addmethod2pos(obj6364, "accept", &meth_ast_accept6369, 4);
int argcv_meth_ast_accept6369[] = {1};
meth_meth_ast_accept6369->type = alloc_MethodType(1, argcv_meth_ast_accept6369);
meth_meth_ast_accept6369->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept6369->type->names[0] = "visitor";
  meth_meth_ast_accept6369->definitionModule = modulename;
  meth_meth_ast_accept6369->definitionLine = 1453;
  block_savedest(obj6364);
  Object closure6381 = createclosure(1, "map()before()after");
setclosureframe(closure6381, stackframe);
  addtoclosure(closure6381, var_indexNode);
  struct UserObject *uo6381 = (struct UserObject*)obj6364;
  uo6381->data[5] = (Object)closure6381;
  Method *meth_meth_ast_map_40__41_before_40__41_after6381 = addmethod2pos(obj6364, "map()before()after", &meth_ast_map_40__41_before_40__41_after6381, 5);
int argcv_meth_ast_map_40__41_before_40__41_after6381[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after6381->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after6381);
  meth_meth_ast_map_40__41_before_40__41_after6381->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after6381->definitionLine = 1459;
  struct UserObject *uo6403 = (struct UserObject*)obj6364;
  uo6403->data[6] = emptyclosure;
  Method *meth_meth_ast_map6403 = addmethod2pos(obj6364, "map", &meth_ast_map6403, 6);
int argcv_meth_ast_map6403[] = {1};
meth_meth_ast_map6403->type = alloc_MethodType(1, argcv_meth_ast_map6403);
  meth_meth_ast_map6403->definitionModule = modulename;
  meth_meth_ast_map6403->definitionLine = 1467;
  struct UserObject *uo6412 = (struct UserObject*)obj6364;
  uo6412->data[7] = emptyclosure;
  Method *meth_meth_ast_pretty6412 = addmethod2pos(obj6364, "pretty", &meth_ast_pretty6412, 7);
int argcv_meth_ast_pretty6412[] = {1};
meth_meth_ast_pretty6412->type = alloc_MethodType(1, argcv_meth_ast_pretty6412);
  meth_meth_ast_pretty6412->definitionModule = modulename;
  meth_meth_ast_pretty6412->definitionLine = 1470;
  struct UserObject *uo6469 = (struct UserObject*)obj6364;
  uo6469->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace6469 = addmethod2pos(obj6364, "toGrace", &meth_ast_toGrace6469, 8);
int argcv_meth_ast_toGrace6469[] = {1};
meth_meth_ast_toGrace6469->type = alloc_MethodType(1, argcv_meth_ast_toGrace6469);
meth_meth_ast_toGrace6469->type->types[0] = type_Number;
meth_meth_ast_toGrace6469->type->names[0] = "depth";
  meth_meth_ast_toGrace6469->definitionModule = modulename;
  meth_meth_ast_toGrace6469->definitionLine = 1482;
  sourceObject = obj6364;
// Begin line 1449
  setline(1449);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6517 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6518 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6517);
// compilenode returning call6518
  struct UserObject *obj6364_uo = (struct UserObject *)obj6364;
  obj6364_uo->super = call6518;
  sourceObject = obj6364;
// Begin line 1450
  setline(1450);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6519 == NULL) {
    strlit6519 = alloc_String("index");
    gc_root(strlit6519);
  }
// compilenode returning strlit6519
  adddatum2(obj6364, strlit6519, 1);
  sourceObject = obj6364;
// Begin line 1451
  setline(1451);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_expr
  adddatum2(obj6364, *var_expr, 2);
  sourceObject = obj6364;
// Begin line 1452
  setline(1452);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_index_39_
  adddatum2(obj6364, *var_index_39_, 3);
  sourceObject = obj6364;
  sourceObject = obj6364;
  sourceObject = obj6364;
  sourceObject = obj6364;
  sourceObject = obj6364;
objclass6364 = obj6364->class;
  objclass6364->definitionModule = modulename;
  objclass6364->definitionLine = 1443;
  (*(struct UserObject *)self).data[0] = lowerouter6364;
  self = oldself6364;
  selfslot = oldselfslot6364;
  stackframe = oldstackframe6364;
  gc_frame_end(frame);
  return obj6364;
}
Object meth_ast_new6363_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_indexNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  Object *var_index_39_ = &(stackframe->slots[1]);
  *var_index_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6364 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6364 = alloc_userobj2(9,10, objclass6364);
  gc_frame_newslot(obj6364);
if (objclass6364 == NULL) {
  glfree(obj6364->class->name);
  obj6364->class->name = "indexNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6364, self, 0);
  addmethodreal(obj6364,"outer", &reader_ast_outer_6365);
  Object oldself6364 = self;
  struct StackFrameObject *oldstackframe6364 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6364);
  gc_frame_newslot((Object)stackframe);
  self = obj6364;
  Object *oldselfslot6364 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6364 = (*(struct UserObject *)self).data[0], lowerouter6364 = thisouter6364;
  if (inheritingObject6364) {
    struct UserObject *inho6364 = (struct UserObject *)inheritingObject6364;
    while (inho6364->super != GraceDefaultObject) inho6364 = (struct UserObject *)inho6364->super;
    inho6364->super = obj6364;
    self = inheritingObject6364;
    *selfslot = self;
    lowerouter6364 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6364;
  }
if (objclass6364 == NULL) {
  Method *reader6366 = addmethodrealflags(obj6364, "kind",&reader_ast_kind_6366, MFLAG_DEF);
  reader6366->definitionModule = modulename;
  reader6366->definitionLine = 1451;
}
adddatum2(obj6364, alloc_Undefined(), 1);
if (objclass6364 == NULL) {
  Method *reader6367 = addmethodrealflags(obj6364, "value",&reader_ast_value_6367, MFLAG_DEF);
  reader6367->definitionModule = modulename;
  reader6367->definitionLine = 1452;
}
adddatum2(obj6364, alloc_Undefined(), 2);
if (objclass6364 == NULL) {
  Method *reader6368 = addmethodrealflags(obj6364, "index",&reader_ast_index_6368, MFLAG_DEF);
  reader6368->definitionModule = modulename;
  reader6368->definitionLine = 1453;
}
adddatum2(obj6364, alloc_Undefined(), 3);
  struct UserObject *uo6369 = (struct UserObject*)obj6364;
  uo6369->data[4] = emptyclosure;
  Method *meth_meth_ast_accept6369 = addmethod2pos(obj6364, "accept", &meth_ast_accept6369, 4);
int argcv_meth_ast_accept6369[] = {1};
meth_meth_ast_accept6369->type = alloc_MethodType(1, argcv_meth_ast_accept6369);
meth_meth_ast_accept6369->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept6369->type->names[0] = "visitor";
  meth_meth_ast_accept6369->definitionModule = modulename;
  meth_meth_ast_accept6369->definitionLine = 1453;
  block_savedest(obj6364);
  Object closure6381 = createclosure(1, "map()before()after");
setclosureframe(closure6381, stackframe);
  addtoclosure(closure6381, var_indexNode);
  struct UserObject *uo6381 = (struct UserObject*)obj6364;
  uo6381->data[5] = (Object)closure6381;
  Method *meth_meth_ast_map_40__41_before_40__41_after6381 = addmethod2pos(obj6364, "map()before()after", &meth_ast_map_40__41_before_40__41_after6381, 5);
int argcv_meth_ast_map_40__41_before_40__41_after6381[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after6381->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after6381);
  meth_meth_ast_map_40__41_before_40__41_after6381->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after6381->definitionLine = 1459;
  struct UserObject *uo6403 = (struct UserObject*)obj6364;
  uo6403->data[6] = emptyclosure;
  Method *meth_meth_ast_map6403 = addmethod2pos(obj6364, "map", &meth_ast_map6403, 6);
int argcv_meth_ast_map6403[] = {1};
meth_meth_ast_map6403->type = alloc_MethodType(1, argcv_meth_ast_map6403);
  meth_meth_ast_map6403->definitionModule = modulename;
  meth_meth_ast_map6403->definitionLine = 1467;
  struct UserObject *uo6412 = (struct UserObject*)obj6364;
  uo6412->data[7] = emptyclosure;
  Method *meth_meth_ast_pretty6412 = addmethod2pos(obj6364, "pretty", &meth_ast_pretty6412, 7);
int argcv_meth_ast_pretty6412[] = {1};
meth_meth_ast_pretty6412->type = alloc_MethodType(1, argcv_meth_ast_pretty6412);
  meth_meth_ast_pretty6412->definitionModule = modulename;
  meth_meth_ast_pretty6412->definitionLine = 1470;
  struct UserObject *uo6469 = (struct UserObject*)obj6364;
  uo6469->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace6469 = addmethod2pos(obj6364, "toGrace", &meth_ast_toGrace6469, 8);
int argcv_meth_ast_toGrace6469[] = {1};
meth_meth_ast_toGrace6469->type = alloc_MethodType(1, argcv_meth_ast_toGrace6469);
meth_meth_ast_toGrace6469->type->types[0] = type_Number;
meth_meth_ast_toGrace6469->type->names[0] = "depth";
  meth_meth_ast_toGrace6469->definitionModule = modulename;
  meth_meth_ast_toGrace6469->definitionLine = 1482;
  sourceObject = obj6364;
// Begin line 1449
  setline(1449);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6517 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6518 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6517);
// compilenode returning call6518
  struct UserObject *obj6364_uo = (struct UserObject *)obj6364;
  obj6364_uo->super = call6518;
  sourceObject = obj6364;
// Begin line 1450
  setline(1450);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6519 == NULL) {
    strlit6519 = alloc_String("index");
    gc_root(strlit6519);
  }
// compilenode returning strlit6519
  adddatum2(obj6364, strlit6519, 1);
  sourceObject = obj6364;
// Begin line 1451
  setline(1451);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_expr
  adddatum2(obj6364, *var_expr, 2);
  sourceObject = obj6364;
// Begin line 1452
  setline(1452);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_index_39_
  adddatum2(obj6364, *var_index_39_, 3);
  sourceObject = obj6364;
  sourceObject = obj6364;
  sourceObject = obj6364;
  sourceObject = obj6364;
  sourceObject = obj6364;
objclass6364 = obj6364->class;
  objclass6364->definitionModule = modulename;
  objclass6364->definitionLine = 1443;
  (*(struct UserObject *)self).data[0] = lowerouter6364;
  self = oldself6364;
  selfslot = oldselfslot6364;
  stackframe = oldstackframe6364;
  gc_frame_end(frame);
  return obj6364;
}
Object meth_ast_bindNode6521(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for bindNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for bindNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1492
  setline(1492);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_bindNode
  gc_frame_end(frame);
  return *var_bindNode;
}
Object meth_ast_accept6530(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1502
  setline(1502);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1498
  setline(1498);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6532 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call6533 = callmethod(*var_visitor, "visitBind",
    1, partcv, params);
  gc_frame_end(callframe6532);
// compilenode returning call6533
  Object if6531 = done;
  if (istrue(call6533)) {
// Begin line 1499
  setline(1499);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6534 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe6535 = gc_frame_new();
  partcv[0] = 0;
  Object call6536 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6535);
// compilenode returning call6536
// compilenode returning call6536
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call6537 = callmethod(call6536, "accept",
    1, partcv, params);
  gc_frame_end(callframe6534);
// compilenode returning call6537
// Begin line 1500
  setline(1500);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6538 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe6539 = gc_frame_new();
  partcv[0] = 0;
  Object call6540 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6539);
// compilenode returning call6540
// compilenode returning call6540
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call6541 = callmethod(call6540, "accept",
    1, partcv, params);
  gc_frame_end(callframe6538);
// compilenode returning call6541
    gc_frame_newslot(call6541);
    if6531 = call6541;
  } else {
  }
// compilenode returning if6531
  gc_frame_end(frame);
  return if6531;
}
Object meth_ast_map_40__41_before_40__41_after6542(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1504
  setline(1504);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6543 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call6544 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe6543);
// compilenode returning call6544
// Begin line 1505
  setline(1505);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6545 = gc_frame_new();
  int callframe6546 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe6547 = gc_frame_new();
  partcv[0] = 0;
  Object call6548 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6547);
// compilenode returning call6548
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6549 = callmethod(call6548, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe6546);
// compilenode returning call6549
  gc_frame_newslot(call6549);
  int callframe6550 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe6551 = gc_frame_new();
  partcv[0] = 0;
  Object call6552 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6551);
// compilenode returning call6552
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6553 = callmethod(call6552, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe6550);
// compilenode returning call6553
  gc_frame_newslot(call6553);
// compilenode returning *var_bindNode
  params[0] = call6549;
  params[1] = call6553;
  partcv[0] = 2;
  Object call6554 = callmethod(*var_bindNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6545);
// compilenode returning call6554
  *var_n = call6554;
  if (call6554 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1506
  setline(1506);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6555 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6556 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe6555);
// compilenode returning call6556
  *var_n = call6556;
  if (call6556 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1508
  setline(1508);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1500
  setline(1500);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6558 = gc_frame_new();
// Begin line 1507
  setline(1507);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6559 = gc_frame_new();
  partcv[0] = 0;
  Object call6560 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6559);
// compilenode returning call6560
  gc_frame_newslot(call6560);
// compilenode returning *var_n
  params[0] = call6560;
  partcv[0] = 1;
  Object call6561 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe6558);
// compilenode returning call6561
// compilenode returning done
// Begin line 1508
  setline(1508);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6562 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6563 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe6562);
// compilenode returning call6563
// Begin line 1509
  setline(1509);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply6567(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6570(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map6564(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1512
  setline(1512);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6565 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block6566 = alloc_Block(NULL, NULL, "ast", 1512);
  gc_frame_newslot(block6566);
  block_savedest(block6566);
  Object closure6567 = createclosure(1, "_apply");
setclosureframe(closure6567, stackframe);
  addtoclosure(closure6567, selfslot);
  struct UserObject *uo6567 = (struct UserObject*)block6566;
  uo6567->data[0] = (Object)closure6567;
  Method *meth_meth_ast__apply6567 = addmethod2pos(block6566, "_apply", &meth_ast__apply6567, 0);
int argcv_meth_ast__apply6567[] = {0};
meth_meth_ast__apply6567->type = alloc_MethodType(1, argcv_meth_ast__apply6567);
  meth_meth_ast__apply6567->definitionModule = modulename;
  meth_meth_ast__apply6567->definitionLine = 1500;
// compilenode returning block6566
  gc_frame_newslot(block6566);
  Object block6569 = alloc_Block(NULL, NULL, "ast", 1512);
  gc_frame_newslot(block6569);
  block_savedest(block6569);
  Object closure6570 = createclosure(1, "_apply");
setclosureframe(closure6570, stackframe);
  addtoclosure(closure6570, selfslot);
  struct UserObject *uo6570 = (struct UserObject*)block6569;
  uo6570->data[0] = (Object)closure6570;
  Method *meth_meth_ast__apply6570 = addmethod2pos(block6569, "_apply", &meth_ast__apply6570, 0);
int argcv_meth_ast__apply6570[] = {0};
meth_meth_ast__apply6570->type = alloc_MethodType(1, argcv_meth_ast__apply6570);
  meth_meth_ast__apply6570->definitionModule = modulename;
  meth_meth_ast__apply6570->definitionLine = 1500;
// compilenode returning block6569
  gc_frame_newslot(block6569);
  params[0] = *var_blk;
  params[1] = block6566;
  params[2] = block6569;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6572 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6565);
// compilenode returning call6572
  gc_frame_end(frame);
  return call6572;
}
Object meth_ast__apply6581(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1518
  setline(1518);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1517
  setline(1517);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6583 == NULL) {
    strlit6583 = alloc_String("  ");
    gc_root(strlit6583);
  }
// compilenode returning strlit6583
  int op_slot_right_6582 = gc_frame_newslot(strlit6583);
// compilenode returning *var_spc
  int op_slot_left_6582 = gc_frame_newslot(*var_spc);
  params[0] = strlit6583;
  partcv[0] = 1;
  Object opresult6585 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult6585
  *var_spc = opresult6585;
  if (opresult6585 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty6573(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1516
  setline(1516);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1515
  setline(1515);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6574 == NULL) {
    strlit6574 = alloc_String("");
    gc_root(strlit6574);
  }
// compilenode returning strlit6574
  *var_spc = strlit6574;
  if (strlit6574 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1516
  setline(1516);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6575 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_6576 = gc_frame_newslot(*var_depth);
  Object num6578 = alloc_Float64(0);
// compilenode returning num6578
  int op_slot_left_6576 = gc_frame_newslot(num6578);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6579 = callmethod(num6578, "..", 1, partcv, params);
// compilenode returning opresult6579
  gc_frame_newslot(opresult6579);
  Object block6580 = alloc_Block(NULL, NULL, "ast", 1516);
  gc_frame_newslot(block6580);
  block_savedest(block6580);
  Object closure6581 = createclosure(2, "_apply");
setclosureframe(closure6581, stackframe);
  addtoclosure(closure6581, var_spc);
  addtoclosure(closure6581, selfslot);
  struct UserObject *uo6581 = (struct UserObject*)block6580;
  uo6581->data[0] = (Object)closure6581;
  Method *meth_meth_ast__apply6581 = addmethod2pos(block6580, "_apply", &meth_ast__apply6581, 0);
int argcv_meth_ast__apply6581[] = {1};
meth_meth_ast__apply6581->type = alloc_MethodType(1, argcv_meth_ast__apply6581);
  meth_meth_ast__apply6581->definitionModule = modulename;
  meth_meth_ast__apply6581->definitionLine = 1500;
// compilenode returning block6580
  gc_frame_newslot(block6580);
  params[0] = opresult6579;
  params[1] = block6580;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6588 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6575);
// compilenode returning call6588
// Begin line 1520
  setline(1520);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1519
  setline(1519);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6589 == NULL) {
    strlit6589 = alloc_String("Bind");
    gc_root(strlit6589);
  }
// compilenode returning strlit6589
  *var_s = strlit6589;
  if (strlit6589 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1521
  setline(1521);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1520
  setline(1520);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6591 == NULL) {
    strlit6591 = alloc_String("""\x0a""");
    gc_root(strlit6591);
  }
// compilenode returning strlit6591
  int op_slot_right_6590 = gc_frame_newslot(strlit6591);
// compilenode returning *var_s
  int op_slot_left_6590 = gc_frame_newslot(*var_s);
  params[0] = strlit6591;
  partcv[0] = 1;
  Object opresult6593 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6593
  *var_s = opresult6593;
  if (opresult6593 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1521
  setline(1521);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6596 = gc_frame_new();
  Object num6598 = alloc_Float64(1);
// compilenode returning num6598
  int op_slot_right_6597 = gc_frame_newslot(num6598);
// compilenode returning *var_depth
  int op_slot_left_6597 = gc_frame_newslot(*var_depth);
  params[0] = num6598;
  partcv[0] = 1;
  Object sum6600 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum6600
  gc_frame_newslot(sum6600);
  int callframe6601 = gc_frame_new();
  partcv[0] = 0;
  Object call6602 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6601);
// compilenode returning call6602
// compilenode returning call6602
  params[0] = sum6600;
  partcv[0] = 1;
  Object call6603 = callmethod(call6602, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6596);
// compilenode returning call6603
  int op_slot_right_6595 = gc_frame_newslot(call6603);
// compilenode returning *var_spc
  int op_slot_right_6605 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_6605 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6607 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6607
  int op_slot_left_6595 = gc_frame_newslot(opresult6607);
  params[0] = call6603;
  partcv[0] = 1;
  Object opresult6608 = callmethod(opresult6607, "++", 1, partcv, params);
// compilenode returning opresult6608
  *var_s = opresult6608;
  if (opresult6608 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1523
  setline(1523);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1522
  setline(1522);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6611 == NULL) {
    strlit6611 = alloc_String("""\x0a""");
    gc_root(strlit6611);
  }
// compilenode returning strlit6611
  int op_slot_right_6610 = gc_frame_newslot(strlit6611);
// compilenode returning *var_s
  int op_slot_left_6610 = gc_frame_newslot(*var_s);
  params[0] = strlit6611;
  partcv[0] = 1;
  Object opresult6613 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6613
  *var_s = opresult6613;
  if (opresult6613 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1523
  setline(1523);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6616 = gc_frame_new();
  Object num6618 = alloc_Float64(1);
// compilenode returning num6618
  int op_slot_right_6617 = gc_frame_newslot(num6618);
// compilenode returning *var_depth
  int op_slot_left_6617 = gc_frame_newslot(*var_depth);
  params[0] = num6618;
  partcv[0] = 1;
  Object sum6620 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum6620
  gc_frame_newslot(sum6620);
  int callframe6621 = gc_frame_new();
  partcv[0] = 0;
  Object call6622 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6621);
// compilenode returning call6622
// compilenode returning call6622
  params[0] = sum6620;
  partcv[0] = 1;
  Object call6623 = callmethod(call6622, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6616);
// compilenode returning call6623
  int op_slot_right_6615 = gc_frame_newslot(call6623);
// compilenode returning *var_spc
  int op_slot_right_6625 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_6625 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6627 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6627
  int op_slot_left_6615 = gc_frame_newslot(opresult6627);
  params[0] = call6623;
  partcv[0] = 1;
  Object opresult6628 = callmethod(opresult6627, "++", 1, partcv, params);
// compilenode returning opresult6628
  *var_s = opresult6628;
  if (opresult6628 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1524
  setline(1524);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply6642(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1530
  setline(1530);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1529
  setline(1529);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6644 == NULL) {
    strlit6644 = alloc_String("    ");
    gc_root(strlit6644);
  }
// compilenode returning strlit6644
  int op_slot_right_6643 = gc_frame_newslot(strlit6644);
// compilenode returning *var_spc
  int op_slot_left_6643 = gc_frame_newslot(*var_spc);
  params[0] = strlit6644;
  partcv[0] = 1;
  Object opresult6646 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult6646
  *var_spc = opresult6646;
  if (opresult6646 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace6630(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1528
  setline(1528);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1527
  setline(1527);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6631 == NULL) {
    strlit6631 = alloc_String("");
    gc_root(strlit6631);
  }
// compilenode returning strlit6631
  *var_spc = strlit6631;
  if (strlit6631 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1528
  setline(1528);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6632 = gc_frame_new();
  Object num6635 = alloc_Float64(1);
// compilenode returning num6635
  int op_slot_right_6634 = gc_frame_newslot(num6635);
// compilenode returning *var_depth
  int op_slot_left_6634 = gc_frame_newslot(*var_depth);
  params[0] = num6635;
  partcv[0] = 1;
  Object diff6637 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff6637
  int op_slot_right_6633 = gc_frame_newslot(diff6637);
  Object num6639 = alloc_Float64(0);
// compilenode returning num6639
  int op_slot_left_6633 = gc_frame_newslot(num6639);
  params[0] = diff6637;
  partcv[0] = 1;
  Object opresult6640 = callmethod(num6639, "..", 1, partcv, params);
// compilenode returning opresult6640
  gc_frame_newslot(opresult6640);
  Object block6641 = alloc_Block(NULL, NULL, "ast", 1528);
  gc_frame_newslot(block6641);
  block_savedest(block6641);
  Object closure6642 = createclosure(2, "_apply");
setclosureframe(closure6642, stackframe);
  addtoclosure(closure6642, var_spc);
  addtoclosure(closure6642, selfslot);
  struct UserObject *uo6642 = (struct UserObject*)block6641;
  uo6642->data[0] = (Object)closure6642;
  Method *meth_meth_ast__apply6642 = addmethod2pos(block6641, "_apply", &meth_ast__apply6642, 0);
int argcv_meth_ast__apply6642[] = {1};
meth_meth_ast__apply6642->type = alloc_MethodType(1, argcv_meth_ast__apply6642);
  meth_meth_ast__apply6642->definitionModule = modulename;
  meth_meth_ast__apply6642->definitionLine = 1523;
// compilenode returning block6641
  gc_frame_newslot(block6641);
  params[0] = opresult6640;
  params[1] = block6641;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6649 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6632);
// compilenode returning call6649
// Begin line 1531
  setline(1531);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6650 = gc_frame_new();
  Object num6652 = alloc_Float64(1);
// compilenode returning num6652
  int op_slot_right_6651 = gc_frame_newslot(num6652);
// compilenode returning *var_depth
  int op_slot_left_6651 = gc_frame_newslot(*var_depth);
  params[0] = num6652;
  partcv[0] = 1;
  Object sum6654 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum6654
  gc_frame_newslot(sum6654);
  int callframe6655 = gc_frame_new();
  partcv[0] = 0;
  Object call6656 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6655);
// compilenode returning call6656
// compilenode returning call6656
  params[0] = sum6654;
  partcv[0] = 1;
  Object call6657 = callmethod(call6656, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6650);
// compilenode returning call6657
  *var_s = call6657;
  if (call6657 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1532
  setline(1532);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6659 = gc_frame_new();
  Object num6661 = alloc_Float64(1);
// compilenode returning num6661
  int op_slot_right_6660 = gc_frame_newslot(num6661);
// compilenode returning *var_depth
  int op_slot_left_6660 = gc_frame_newslot(*var_depth);
  params[0] = num6661;
  partcv[0] = 1;
  Object sum6663 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum6663
  gc_frame_newslot(sum6663);
  int callframe6664 = gc_frame_new();
  partcv[0] = 0;
  Object call6665 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6664);
// compilenode returning call6665
// compilenode returning call6665
  params[0] = sum6663;
  partcv[0] = 1;
  Object call6666 = callmethod(call6665, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6659);
// compilenode returning call6666
  int op_slot_right_6658 = gc_frame_newslot(call6666);
  if (strlit6669 == NULL) {
    strlit6669 = alloc_String(" := ");
    gc_root(strlit6669);
  }
// compilenode returning strlit6669
  int op_slot_right_6668 = gc_frame_newslot(strlit6669);
// compilenode returning *var_s
  int op_slot_left_6668 = gc_frame_newslot(*var_s);
  params[0] = strlit6669;
  partcv[0] = 1;
  Object opresult6671 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6671
  int op_slot_left_6658 = gc_frame_newslot(opresult6671);
  params[0] = call6666;
  partcv[0] = 1;
  Object opresult6672 = callmethod(opresult6671, "++", 1, partcv, params);
// compilenode returning opresult6672
  *var_s = opresult6672;
  if (opresult6672 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1533
  setline(1533);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new6524(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_bindNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_dest_39_ = &(stackframe->slots[0]);
  *var_dest_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6525 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6525 = alloc_userobj2(9,10, objclass6525);
  gc_frame_newslot(obj6525);
if (objclass6525 == NULL) {
  glfree(obj6525->class->name);
  obj6525->class->name = "bindNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6525, self, 0);
  addmethodreal(obj6525,"outer", &reader_ast_outer_6526);
  Object oldself6525 = self;
  struct StackFrameObject *oldstackframe6525 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6525);
  gc_frame_newslot((Object)stackframe);
  self = obj6525;
  Object *oldselfslot6525 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6525 = (*(struct UserObject *)self).data[0], lowerouter6525 = thisouter6525;
  if (inheritingObject6525) {
    struct UserObject *inho6525 = (struct UserObject *)inheritingObject6525;
    while (inho6525->super != GraceDefaultObject) inho6525 = (struct UserObject *)inho6525->super;
    inho6525->super = obj6525;
    self = inheritingObject6525;
    *selfslot = self;
    lowerouter6525 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6525;
  }
if (objclass6525 == NULL) {
  Method *reader6527 = addmethodrealflags(obj6525, "kind",&reader_ast_kind_6527, MFLAG_DEF);
  reader6527->definitionModule = modulename;
  reader6527->definitionLine = 1495;
}
adddatum2(obj6525, alloc_Undefined(), 1);
if (objclass6525 == NULL) {
  Method *reader6528 = addmethodrealflags(obj6525, "dest",&reader_ast_dest_6528, MFLAG_DEF);
  reader6528->definitionModule = modulename;
  reader6528->definitionLine = 1496;
}
adddatum2(obj6525, alloc_Undefined(), 2);
if (objclass6525 == NULL) {
  Method *reader6529 = addmethodrealflags(obj6525, "value",&reader_ast_value_6529, MFLAG_DEF);
  reader6529->definitionModule = modulename;
  reader6529->definitionLine = 1497;
}
adddatum2(obj6525, alloc_Undefined(), 3);
  struct UserObject *uo6530 = (struct UserObject*)obj6525;
  uo6530->data[4] = emptyclosure;
  Method *meth_meth_ast_accept6530 = addmethod2pos(obj6525, "accept", &meth_ast_accept6530, 4);
int argcv_meth_ast_accept6530[] = {1};
meth_meth_ast_accept6530->type = alloc_MethodType(1, argcv_meth_ast_accept6530);
meth_meth_ast_accept6530->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept6530->type->names[0] = "visitor";
  meth_meth_ast_accept6530->definitionModule = modulename;
  meth_meth_ast_accept6530->definitionLine = 1497;
  block_savedest(obj6525);
  Object closure6542 = createclosure(1, "map()before()after");
setclosureframe(closure6542, stackframe);
  addtoclosure(closure6542, var_bindNode);
  struct UserObject *uo6542 = (struct UserObject*)obj6525;
  uo6542->data[5] = (Object)closure6542;
  Method *meth_meth_ast_map_40__41_before_40__41_after6542 = addmethod2pos(obj6525, "map()before()after", &meth_ast_map_40__41_before_40__41_after6542, 5);
int argcv_meth_ast_map_40__41_before_40__41_after6542[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after6542->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after6542);
  meth_meth_ast_map_40__41_before_40__41_after6542->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after6542->definitionLine = 1503;
  struct UserObject *uo6564 = (struct UserObject*)obj6525;
  uo6564->data[6] = emptyclosure;
  Method *meth_meth_ast_map6564 = addmethod2pos(obj6525, "map", &meth_ast_map6564, 6);
int argcv_meth_ast_map6564[] = {1};
meth_meth_ast_map6564->type = alloc_MethodType(1, argcv_meth_ast_map6564);
  meth_meth_ast_map6564->definitionModule = modulename;
  meth_meth_ast_map6564->definitionLine = 1511;
  struct UserObject *uo6573 = (struct UserObject*)obj6525;
  uo6573->data[7] = emptyclosure;
  Method *meth_meth_ast_pretty6573 = addmethod2pos(obj6525, "pretty", &meth_ast_pretty6573, 7);
int argcv_meth_ast_pretty6573[] = {1};
meth_meth_ast_pretty6573->type = alloc_MethodType(1, argcv_meth_ast_pretty6573);
  meth_meth_ast_pretty6573->definitionModule = modulename;
  meth_meth_ast_pretty6573->definitionLine = 1514;
  struct UserObject *uo6630 = (struct UserObject*)obj6525;
  uo6630->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace6630 = addmethod2pos(obj6525, "toGrace", &meth_ast_toGrace6630, 8);
int argcv_meth_ast_toGrace6630[] = {1};
meth_meth_ast_toGrace6630->type = alloc_MethodType(1, argcv_meth_ast_toGrace6630);
meth_meth_ast_toGrace6630->type->types[0] = type_Number;
meth_meth_ast_toGrace6630->type->names[0] = "depth";
  meth_meth_ast_toGrace6630->definitionModule = modulename;
  meth_meth_ast_toGrace6630->definitionLine = 1526;
  sourceObject = obj6525;
// Begin line 1493
  setline(1493);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6674 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6675 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6674);
// compilenode returning call6675
  struct UserObject *obj6525_uo = (struct UserObject *)obj6525;
  obj6525_uo->super = call6675;
  sourceObject = obj6525;
// Begin line 1494
  setline(1494);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6676 == NULL) {
    strlit6676 = alloc_String("bind");
    gc_root(strlit6676);
  }
// compilenode returning strlit6676
  adddatum2(obj6525, strlit6676, 1);
  sourceObject = obj6525;
// Begin line 1495
  setline(1495);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dest_39_
  adddatum2(obj6525, *var_dest_39_, 2);
  sourceObject = obj6525;
// Begin line 1496
  setline(1496);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_val_39_
  adddatum2(obj6525, *var_val_39_, 3);
  sourceObject = obj6525;
  sourceObject = obj6525;
  sourceObject = obj6525;
  sourceObject = obj6525;
  sourceObject = obj6525;
objclass6525 = obj6525->class;
  objclass6525->definitionModule = modulename;
  objclass6525->definitionLine = 1488;
  (*(struct UserObject *)self).data[0] = lowerouter6525;
  self = oldself6525;
  selfslot = oldselfslot6525;
  stackframe = oldstackframe6525;
  gc_frame_end(frame);
  return obj6525;
}
Object meth_ast_new6524_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_bindNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_dest_39_ = &(stackframe->slots[0]);
  *var_dest_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6525 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6525 = alloc_userobj2(9,10, objclass6525);
  gc_frame_newslot(obj6525);
if (objclass6525 == NULL) {
  glfree(obj6525->class->name);
  obj6525->class->name = "bindNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6525, self, 0);
  addmethodreal(obj6525,"outer", &reader_ast_outer_6526);
  Object oldself6525 = self;
  struct StackFrameObject *oldstackframe6525 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6525);
  gc_frame_newslot((Object)stackframe);
  self = obj6525;
  Object *oldselfslot6525 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6525 = (*(struct UserObject *)self).data[0], lowerouter6525 = thisouter6525;
  if (inheritingObject6525) {
    struct UserObject *inho6525 = (struct UserObject *)inheritingObject6525;
    while (inho6525->super != GraceDefaultObject) inho6525 = (struct UserObject *)inho6525->super;
    inho6525->super = obj6525;
    self = inheritingObject6525;
    *selfslot = self;
    lowerouter6525 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6525;
  }
if (objclass6525 == NULL) {
  Method *reader6527 = addmethodrealflags(obj6525, "kind",&reader_ast_kind_6527, MFLAG_DEF);
  reader6527->definitionModule = modulename;
  reader6527->definitionLine = 1495;
}
adddatum2(obj6525, alloc_Undefined(), 1);
if (objclass6525 == NULL) {
  Method *reader6528 = addmethodrealflags(obj6525, "dest",&reader_ast_dest_6528, MFLAG_DEF);
  reader6528->definitionModule = modulename;
  reader6528->definitionLine = 1496;
}
adddatum2(obj6525, alloc_Undefined(), 2);
if (objclass6525 == NULL) {
  Method *reader6529 = addmethodrealflags(obj6525, "value",&reader_ast_value_6529, MFLAG_DEF);
  reader6529->definitionModule = modulename;
  reader6529->definitionLine = 1497;
}
adddatum2(obj6525, alloc_Undefined(), 3);
  struct UserObject *uo6530 = (struct UserObject*)obj6525;
  uo6530->data[4] = emptyclosure;
  Method *meth_meth_ast_accept6530 = addmethod2pos(obj6525, "accept", &meth_ast_accept6530, 4);
int argcv_meth_ast_accept6530[] = {1};
meth_meth_ast_accept6530->type = alloc_MethodType(1, argcv_meth_ast_accept6530);
meth_meth_ast_accept6530->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept6530->type->names[0] = "visitor";
  meth_meth_ast_accept6530->definitionModule = modulename;
  meth_meth_ast_accept6530->definitionLine = 1497;
  block_savedest(obj6525);
  Object closure6542 = createclosure(1, "map()before()after");
setclosureframe(closure6542, stackframe);
  addtoclosure(closure6542, var_bindNode);
  struct UserObject *uo6542 = (struct UserObject*)obj6525;
  uo6542->data[5] = (Object)closure6542;
  Method *meth_meth_ast_map_40__41_before_40__41_after6542 = addmethod2pos(obj6525, "map()before()after", &meth_ast_map_40__41_before_40__41_after6542, 5);
int argcv_meth_ast_map_40__41_before_40__41_after6542[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after6542->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after6542);
  meth_meth_ast_map_40__41_before_40__41_after6542->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after6542->definitionLine = 1503;
  struct UserObject *uo6564 = (struct UserObject*)obj6525;
  uo6564->data[6] = emptyclosure;
  Method *meth_meth_ast_map6564 = addmethod2pos(obj6525, "map", &meth_ast_map6564, 6);
int argcv_meth_ast_map6564[] = {1};
meth_meth_ast_map6564->type = alloc_MethodType(1, argcv_meth_ast_map6564);
  meth_meth_ast_map6564->definitionModule = modulename;
  meth_meth_ast_map6564->definitionLine = 1511;
  struct UserObject *uo6573 = (struct UserObject*)obj6525;
  uo6573->data[7] = emptyclosure;
  Method *meth_meth_ast_pretty6573 = addmethod2pos(obj6525, "pretty", &meth_ast_pretty6573, 7);
int argcv_meth_ast_pretty6573[] = {1};
meth_meth_ast_pretty6573->type = alloc_MethodType(1, argcv_meth_ast_pretty6573);
  meth_meth_ast_pretty6573->definitionModule = modulename;
  meth_meth_ast_pretty6573->definitionLine = 1514;
  struct UserObject *uo6630 = (struct UserObject*)obj6525;
  uo6630->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace6630 = addmethod2pos(obj6525, "toGrace", &meth_ast_toGrace6630, 8);
int argcv_meth_ast_toGrace6630[] = {1};
meth_meth_ast_toGrace6630->type = alloc_MethodType(1, argcv_meth_ast_toGrace6630);
meth_meth_ast_toGrace6630->type->types[0] = type_Number;
meth_meth_ast_toGrace6630->type->names[0] = "depth";
  meth_meth_ast_toGrace6630->definitionModule = modulename;
  meth_meth_ast_toGrace6630->definitionLine = 1526;
  sourceObject = obj6525;
// Begin line 1493
  setline(1493);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6674 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6675 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6674);
// compilenode returning call6675
  struct UserObject *obj6525_uo = (struct UserObject *)obj6525;
  obj6525_uo->super = call6675;
  sourceObject = obj6525;
// Begin line 1494
  setline(1494);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6676 == NULL) {
    strlit6676 = alloc_String("bind");
    gc_root(strlit6676);
  }
// compilenode returning strlit6676
  adddatum2(obj6525, strlit6676, 1);
  sourceObject = obj6525;
// Begin line 1495
  setline(1495);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dest_39_
  adddatum2(obj6525, *var_dest_39_, 2);
  sourceObject = obj6525;
// Begin line 1496
  setline(1496);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_val_39_
  adddatum2(obj6525, *var_val_39_, 3);
  sourceObject = obj6525;
  sourceObject = obj6525;
  sourceObject = obj6525;
  sourceObject = obj6525;
  sourceObject = obj6525;
objclass6525 = obj6525->class;
  objclass6525->definitionModule = modulename;
  objclass6525->definitionLine = 1488;
  (*(struct UserObject *)self).data[0] = lowerouter6525;
  self = oldself6525;
  selfslot = oldselfslot6525;
  stackframe = oldstackframe6525;
  gc_frame_end(frame);
  return obj6525;
}
Object meth_ast_defDecNode6678(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defDecNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_defDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for defDecNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for defDecNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1536
  setline(1536);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_defDecNode
  gc_frame_end(frame);
  return *var_defDecNode;
}
Object meth_ast_accept6691(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1555
  setline(1555);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1546
  setline(1546);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6693 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call6694 = callmethod(*var_visitor, "visitDefDec",
    1, partcv, params);
  gc_frame_end(callframe6693);
// compilenode returning call6694
  Object if6692 = done;
  if (istrue(call6694)) {
// Begin line 1547
  setline(1547);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6695 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe6696 = gc_frame_new();
  partcv[0] = 0;
  Object call6697 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6696);
// compilenode returning call6697
// compilenode returning call6697
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call6698 = callmethod(call6697, "accept",
    1, partcv, params);
  gc_frame_end(callframe6695);
// compilenode returning call6698
// Begin line 1551
  setline(1551);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1548
  setline(1548);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool6701 = alloc_Boolean(0);
// compilenode returning bool6701
  int op_slot_right_6700 = gc_frame_newslot(bool6701);
  int callframe6703 = gc_frame_new();
  partcv[0] = 0;
  Object call6704 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6703);
// compilenode returning call6704
// compilenode returning call6704
  int op_slot_left_6700 = gc_frame_newslot(call6704);
  params[0] = bool6701;
  partcv[0] = 1;
  Object opresult6705 = callmethod(call6704, "!=", 1, partcv, params);
// compilenode returning opresult6705
  Object if6699 = done;
  if (istrue(opresult6705)) {
// Begin line 1549
  setline(1549);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6706 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe6707 = gc_frame_new();
  partcv[0] = 0;
  Object call6708 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6707);
// compilenode returning call6708
// compilenode returning call6708
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call6709 = callmethod(call6708, "accept",
    1, partcv, params);
  gc_frame_end(callframe6706);
// compilenode returning call6709
    gc_frame_newslot(call6709);
    if6699 = call6709;
  } else {
  }
// compilenode returning if6699
// Begin line 1554
  setline(1554);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1551
  setline(1551);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool6712 = alloc_Boolean(0);
// compilenode returning bool6712
  int op_slot_right_6711 = gc_frame_newslot(bool6712);
  int callframe6714 = gc_frame_new();
  partcv[0] = 0;
  Object call6715 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6714);
// compilenode returning call6715
// compilenode returning call6715
  int op_slot_left_6711 = gc_frame_newslot(call6715);
  params[0] = bool6712;
  partcv[0] = 1;
  Object opresult6716 = callmethod(call6715, "!=", 1, partcv, params);
// compilenode returning opresult6716
  Object if6710 = done;
  if (istrue(opresult6716)) {
// Begin line 1552
  setline(1552);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6717 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe6718 = gc_frame_new();
  partcv[0] = 0;
  Object call6719 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6718);
// compilenode returning call6719
// compilenode returning call6719
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call6720 = callmethod(call6719, "accept",
    1, partcv, params);
  gc_frame_end(callframe6717);
// compilenode returning call6720
    gc_frame_newslot(call6720);
    if6710 = call6720;
  } else {
  }
// compilenode returning if6710
    gc_frame_newslot(if6710);
    if6692 = if6710;
  } else {
  }
// compilenode returning if6692
  gc_frame_end(frame);
  return if6692;
}
Object meth_ast__apply6750(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_blk = getfromclosure(closure, 0);
  Object *var_blkBefore = getfromclosure(closure, 1);
  Object *var_blkAfter = getfromclosure(closure, 2);
  Object *var_n = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1561
  setline(1561);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6751 = gc_frame_new();
  int callframe6752 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// compilenode returning *var_a
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6753 = callmethod(*var_a, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe6752);
// compilenode returning call6753
  gc_frame_newslot(call6753);
  int callframe6754 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call6755 = callmethod(*var_n, "annotations",
    1, partcv, params);
  gc_frame_end(callframe6754);
// compilenode returning call6755
// compilenode returning call6755
  params[0] = call6753;
  partcv[0] = 1;
  Object call6756 = callmethod(call6755, "push",
    1, partcv, params);
  gc_frame_end(callframe6751);
// compilenode returning call6756
  gc_frame_end(frame);
  return call6756;
}
Object meth_ast_map_40__41_before_40__41_after6721(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_defDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1557
  setline(1557);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6722 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call6723 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe6722);
// compilenode returning call6723
// Begin line 1558
  setline(1558);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6724 = gc_frame_new();
  int callframe6725 = gc_frame_new();
  partcv[0] = 0;
  Object call6726 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6725);
// compilenode returning call6726
  gc_frame_newslot(call6726);
  int callframe6727 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe6728 = gc_frame_new();
  partcv[0] = 0;
  Object call6729 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6728);
// compilenode returning call6729
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6730 = callmethod(call6729, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe6727);
// compilenode returning call6730
  gc_frame_newslot(call6730);
// Begin line 1559
  setline(1559);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6731 = gc_frame_new();
  int callframe6732 = gc_frame_new();
  partcv[0] = 0;
  Object call6733 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6732);
// compilenode returning call6733
  gc_frame_newslot(call6733);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe6734 = gc_frame_new();
  int callframe6735 = gc_frame_new();
  Object call6736 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6735);
// compilenode returning call6736
// compilenode returning call6736
  partcv[0] = 0;
  Object call6737 = callmethodflags(call6736, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6734);
// compilenode returning call6737
// compilenode returning call6737
  params[0] = call6733;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 4;
  Object call6738 = callmethodflags(call6737, "maybeMap", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6731);
// compilenode returning call6738
  gc_frame_newslot(call6738);
// Begin line 1558
  setline(1558);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_defDecNode
  params[0] = call6726;
  params[1] = call6730;
  params[2] = call6738;
  partcv[0] = 3;
  Object call6739 = callmethod(*var_defDecNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6724);
// compilenode returning call6739
  *var_n = call6739;
  if (call6739 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1560
  setline(1560);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6740 = gc_frame_new();
  int callframe6741 = gc_frame_new();
  int callframe6742 = gc_frame_new();
  partcv[0] = 0;
  Object call6743 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6742);
// compilenode returning call6743
  gc_frame_newslot(call6743);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe6744 = gc_frame_new();
  int callframe6745 = gc_frame_new();
  Object call6746 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6745);
// compilenode returning call6746
// compilenode returning call6746
  partcv[0] = 0;
  Object call6747 = callmethodflags(call6746, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6744);
// compilenode returning call6747
// compilenode returning call6747
  params[0] = call6743;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6748 = callmethodflags(call6747, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6741);
// compilenode returning call6748
  gc_frame_newslot(call6748);
  Object block6749 = alloc_Block(NULL, NULL, "ast", 1560);
  gc_frame_newslot(block6749);
  block_savedest(block6749);
  Object closure6750 = createclosure(5, "_apply");
setclosureframe(closure6750, stackframe);
  addtoclosure(closure6750, var_blk);
  addtoclosure(closure6750, var_blkBefore);
  addtoclosure(closure6750, var_blkAfter);
  addtoclosure(closure6750, var_n);
  addtoclosure(closure6750, selfslot);
  struct UserObject *uo6750 = (struct UserObject*)block6749;
  uo6750->data[0] = (Object)closure6750;
  Method *meth_meth_ast__apply6750 = addmethod2pos(block6749, "_apply", &meth_ast__apply6750, 0);
int argcv_meth_ast__apply6750[] = {1};
meth_meth_ast__apply6750->type = alloc_MethodType(1, argcv_meth_ast__apply6750);
  meth_meth_ast__apply6750->definitionModule = modulename;
  meth_meth_ast__apply6750->definitionLine = 1560;
// compilenode returning block6749
  gc_frame_newslot(block6749);
  params[0] = call6748;
  params[1] = block6749;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6758 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6740);
// compilenode returning call6758
// Begin line 1563
  setline(1563);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6759 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6760 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe6759);
// compilenode returning call6760
  *var_n = call6760;
  if (call6760 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1565
  setline(1565);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1561
  setline(1561);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6762 = gc_frame_new();
// Begin line 1564
  setline(1564);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6763 = gc_frame_new();
  partcv[0] = 0;
  Object call6764 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6763);
// compilenode returning call6764
  gc_frame_newslot(call6764);
// compilenode returning *var_n
  params[0] = call6764;
  partcv[0] = 1;
  Object call6765 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe6762);
// compilenode returning call6765
// compilenode returning done
// Begin line 1565
  setline(1565);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6766 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6767 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe6766);
// compilenode returning call6767
// Begin line 1566
  setline(1566);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply6771(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6774(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map6768(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1569
  setline(1569);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6769 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block6770 = alloc_Block(NULL, NULL, "ast", 1569);
  gc_frame_newslot(block6770);
  block_savedest(block6770);
  Object closure6771 = createclosure(1, "_apply");
setclosureframe(closure6771, stackframe);
  addtoclosure(closure6771, selfslot);
  struct UserObject *uo6771 = (struct UserObject*)block6770;
  uo6771->data[0] = (Object)closure6771;
  Method *meth_meth_ast__apply6771 = addmethod2pos(block6770, "_apply", &meth_ast__apply6771, 0);
int argcv_meth_ast__apply6771[] = {0};
meth_meth_ast__apply6771->type = alloc_MethodType(1, argcv_meth_ast__apply6771);
  meth_meth_ast__apply6771->definitionModule = modulename;
  meth_meth_ast__apply6771->definitionLine = 1561;
// compilenode returning block6770
  gc_frame_newslot(block6770);
  Object block6773 = alloc_Block(NULL, NULL, "ast", 1569);
  gc_frame_newslot(block6773);
  block_savedest(block6773);
  Object closure6774 = createclosure(1, "_apply");
setclosureframe(closure6774, stackframe);
  addtoclosure(closure6774, selfslot);
  struct UserObject *uo6774 = (struct UserObject*)block6773;
  uo6774->data[0] = (Object)closure6774;
  Method *meth_meth_ast__apply6774 = addmethod2pos(block6773, "_apply", &meth_ast__apply6774, 0);
int argcv_meth_ast__apply6774[] = {0};
meth_meth_ast__apply6774->type = alloc_MethodType(1, argcv_meth_ast__apply6774);
  meth_meth_ast__apply6774->definitionModule = modulename;
  meth_meth_ast__apply6774->definitionLine = 1561;
// compilenode returning block6773
  gc_frame_newslot(block6773);
  params[0] = *var_blk;
  params[1] = block6770;
  params[2] = block6773;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6776 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6769);
// compilenode returning call6776
  gc_frame_end(frame);
  return call6776;
}
Object meth_ast__apply6785(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1575
  setline(1575);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1574
  setline(1574);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6787 == NULL) {
    strlit6787 = alloc_String("  ");
    gc_root(strlit6787);
  }
// compilenode returning strlit6787
  int op_slot_right_6786 = gc_frame_newslot(strlit6787);
// compilenode returning *var_spc
  int op_slot_left_6786 = gc_frame_newslot(*var_spc);
  params[0] = strlit6787;
  partcv[0] = 1;
  Object opresult6789 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult6789
  *var_spc = opresult6789;
  if (opresult6789 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty6777(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1573
  setline(1573);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1572
  setline(1572);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6778 == NULL) {
    strlit6778 = alloc_String("");
    gc_root(strlit6778);
  }
// compilenode returning strlit6778
  *var_spc = strlit6778;
  if (strlit6778 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1573
  setline(1573);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6779 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_6780 = gc_frame_newslot(*var_depth);
  Object num6782 = alloc_Float64(0);
// compilenode returning num6782
  int op_slot_left_6780 = gc_frame_newslot(num6782);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6783 = callmethod(num6782, "..", 1, partcv, params);
// compilenode returning opresult6783
  gc_frame_newslot(opresult6783);
  Object block6784 = alloc_Block(NULL, NULL, "ast", 1573);
  gc_frame_newslot(block6784);
  block_savedest(block6784);
  Object closure6785 = createclosure(2, "_apply");
setclosureframe(closure6785, stackframe);
  addtoclosure(closure6785, var_spc);
  addtoclosure(closure6785, selfslot);
  struct UserObject *uo6785 = (struct UserObject*)block6784;
  uo6785->data[0] = (Object)closure6785;
  Method *meth_meth_ast__apply6785 = addmethod2pos(block6784, "_apply", &meth_ast__apply6785, 0);
int argcv_meth_ast__apply6785[] = {1};
meth_meth_ast__apply6785->type = alloc_MethodType(1, argcv_meth_ast__apply6785);
  meth_meth_ast__apply6785->definitionModule = modulename;
  meth_meth_ast__apply6785->definitionLine = 1561;
// compilenode returning block6784
  gc_frame_newslot(block6784);
  params[0] = opresult6783;
  params[1] = block6784;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6792 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6779);
// compilenode returning call6792
// Begin line 1577
  setline(1577);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1576
  setline(1576);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6793 == NULL) {
    strlit6793 = alloc_String("defdec");
    gc_root(strlit6793);
  }
// compilenode returning strlit6793
  *var_s = strlit6793;
  if (strlit6793 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1578
  setline(1578);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1577
  setline(1577);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6795 == NULL) {
    strlit6795 = alloc_String("""\x0a""");
    gc_root(strlit6795);
  }
// compilenode returning strlit6795
  int op_slot_right_6794 = gc_frame_newslot(strlit6795);
// compilenode returning *var_s
  int op_slot_left_6794 = gc_frame_newslot(*var_s);
  params[0] = strlit6795;
  partcv[0] = 1;
  Object opresult6797 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6797
  *var_s = opresult6797;
  if (opresult6797 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1578
  setline(1578);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6800 = gc_frame_new();
// compilenode returning *var_depth
  gc_frame_newslot(*var_depth);
  int callframe6801 = gc_frame_new();
  partcv[0] = 0;
  Object call6802 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6801);
// compilenode returning call6802
// compilenode returning call6802
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6803 = callmethod(call6802, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6800);
// compilenode returning call6803
  int op_slot_right_6799 = gc_frame_newslot(call6803);
// compilenode returning *var_spc
  int op_slot_right_6805 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_6805 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6807 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6807
  int op_slot_left_6799 = gc_frame_newslot(opresult6807);
  params[0] = call6803;
  partcv[0] = 1;
  Object opresult6808 = callmethod(opresult6807, "++", 1, partcv, params);
// compilenode returning opresult6808
  *var_s = opresult6808;
  if (opresult6808 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1583
  setline(1583);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1579
  setline(1579);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool6812 = alloc_Boolean(0);
// compilenode returning bool6812
  int op_slot_right_6811 = gc_frame_newslot(bool6812);
  int callframe6814 = gc_frame_new();
  partcv[0] = 0;
  Object call6815 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6814);
// compilenode returning call6815
// compilenode returning call6815
  int op_slot_left_6811 = gc_frame_newslot(call6815);
  params[0] = bool6812;
  partcv[0] = 1;
  Object opresult6816 = callmethod(call6815, "!=", 1, partcv, params);
// compilenode returning opresult6816
  Object if6810 = done;
  if (istrue(opresult6816)) {
// Begin line 1581
  setline(1581);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1580
  setline(1580);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6818 == NULL) {
    strlit6818 = alloc_String("Type:");
    gc_root(strlit6818);
  }
// compilenode returning strlit6818
  int op_slot_right_6817 = gc_frame_newslot(strlit6818);
// compilenode returning *var_spc
  int op_slot_right_6820 = gc_frame_newslot(*var_spc);
  if (strlit6823 == NULL) {
    strlit6823 = alloc_String("""\x0a""");
    gc_root(strlit6823);
  }
// compilenode returning strlit6823
  int op_slot_right_6822 = gc_frame_newslot(strlit6823);
// compilenode returning *var_s
  int op_slot_left_6822 = gc_frame_newslot(*var_s);
  params[0] = strlit6823;
  partcv[0] = 1;
  Object opresult6825 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6825
  int op_slot_left_6820 = gc_frame_newslot(opresult6825);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6826 = callmethod(opresult6825, "++", 1, partcv, params);
// compilenode returning opresult6826
  int op_slot_left_6817 = gc_frame_newslot(opresult6826);
  params[0] = strlit6818;
  partcv[0] = 1;
  Object opresult6827 = callmethod(opresult6826, "++", 1, partcv, params);
// compilenode returning opresult6827
  *var_s = opresult6827;
  if (opresult6827 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1581
  setline(1581);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6830 = gc_frame_new();
  Object num6832 = alloc_Float64(2);
// compilenode returning num6832
  int op_slot_right_6831 = gc_frame_newslot(num6832);
// compilenode returning *var_depth
  int op_slot_left_6831 = gc_frame_newslot(*var_depth);
  params[0] = num6832;
  partcv[0] = 1;
  Object sum6834 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum6834
  gc_frame_newslot(sum6834);
  int callframe6835 = gc_frame_new();
  partcv[0] = 0;
  Object call6836 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6835);
// compilenode returning call6836
// compilenode returning call6836
  params[0] = sum6834;
  partcv[0] = 1;
  Object call6837 = callmethod(call6836, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6830);
// compilenode returning call6837
  int op_slot_right_6829 = gc_frame_newslot(call6837);
  if (strlit6840 == NULL) {
    strlit6840 = alloc_String("  ");
    gc_root(strlit6840);
  }
// compilenode returning strlit6840
  int op_slot_right_6839 = gc_frame_newslot(strlit6840);
// compilenode returning *var_spc
  int op_slot_right_6842 = gc_frame_newslot(*var_spc);
  if (strlit6845 == NULL) {
    strlit6845 = alloc_String("""\x0a""");
    gc_root(strlit6845);
  }
// compilenode returning strlit6845
  int op_slot_right_6844 = gc_frame_newslot(strlit6845);
// compilenode returning *var_s
  int op_slot_left_6844 = gc_frame_newslot(*var_s);
  params[0] = strlit6845;
  partcv[0] = 1;
  Object opresult6847 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6847
  int op_slot_left_6842 = gc_frame_newslot(opresult6847);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6848 = callmethod(opresult6847, "++", 1, partcv, params);
// compilenode returning opresult6848
  int op_slot_left_6839 = gc_frame_newslot(opresult6848);
  params[0] = strlit6840;
  partcv[0] = 1;
  Object opresult6849 = callmethod(opresult6848, "++", 1, partcv, params);
// compilenode returning opresult6849
  int op_slot_left_6829 = gc_frame_newslot(opresult6849);
  params[0] = call6837;
  partcv[0] = 1;
  Object opresult6850 = callmethod(opresult6849, "++", 1, partcv, params);
// compilenode returning opresult6850
  *var_s = opresult6850;
  if (opresult6850 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6810 = done;
  } else {
  }
// compilenode returning if6810
// Begin line 1587
  setline(1587);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1583
  setline(1583);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6854 = gc_frame_new();
  partcv[0] = 0;
  Object call6855 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6854);
// compilenode returning call6855
// compilenode returning call6855
  int op_slot_right_6853 = gc_frame_newslot(call6855);
  Object bool6857 = alloc_Boolean(0);
// compilenode returning bool6857
  int op_slot_left_6853 = gc_frame_newslot(bool6857);
  params[0] = call6855;
  partcv[0] = 1;
  Object opresult6858 = callmethod(bool6857, "!=", 1, partcv, params);
// compilenode returning opresult6858
  Object if6852 = done;
  if (istrue(opresult6858)) {
// Begin line 1585
  setline(1585);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1584
  setline(1584);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6860 == NULL) {
    strlit6860 = alloc_String("""\x0a""");
    gc_root(strlit6860);
  }
// compilenode returning strlit6860
  int op_slot_right_6859 = gc_frame_newslot(strlit6860);
// compilenode returning *var_s
  int op_slot_left_6859 = gc_frame_newslot(*var_s);
  params[0] = strlit6860;
  partcv[0] = 1;
  Object opresult6862 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6862
  *var_s = opresult6862;
  if (opresult6862 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1585
  setline(1585);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6865 = gc_frame_new();
  Object num6867 = alloc_Float64(1);
// compilenode returning num6867
  int op_slot_right_6866 = gc_frame_newslot(num6867);
// compilenode returning *var_depth
  int op_slot_left_6866 = gc_frame_newslot(*var_depth);
  params[0] = num6867;
  partcv[0] = 1;
  Object sum6869 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum6869
  gc_frame_newslot(sum6869);
  int callframe6870 = gc_frame_new();
  partcv[0] = 0;
  Object call6871 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6870);
// compilenode returning call6871
// compilenode returning call6871
  params[0] = sum6869;
  partcv[0] = 1;
  Object call6872 = callmethod(call6871, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6865);
// compilenode returning call6872
  int op_slot_right_6864 = gc_frame_newslot(call6872);
// compilenode returning *var_spc
  int op_slot_right_6874 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_6874 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6876 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6876
  int op_slot_left_6864 = gc_frame_newslot(opresult6876);
  params[0] = call6872;
  partcv[0] = 1;
  Object opresult6877 = callmethod(opresult6876, "++", 1, partcv, params);
// compilenode returning opresult6877
  *var_s = opresult6877;
  if (opresult6877 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6852 = done;
  } else {
  }
// compilenode returning if6852
// Begin line 1587
  setline(1587);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_decType6879(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "decType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for decType (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for decType");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1593
  setline(1593);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1590
  setline(1590);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool6882 = alloc_Boolean(0);
// compilenode returning bool6882
  int op_slot_right_6881 = gc_frame_newslot(bool6882);
  int callframe6884 = gc_frame_new();
  partcv[0] = 0;
  Object call6885 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6884);
// compilenode returning call6885
  int op_slot_left_6881 = gc_frame_newslot(call6885);
  params[0] = bool6882;
  partcv[0] = 1;
  Object opresult6886 = callmethod(call6885, "==", 1, partcv, params);
// compilenode returning opresult6886
  Object if6880 = done;
  if (istrue(opresult6886)) {
// Begin line 1591
  setline(1591);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6887 = gc_frame_new();
  if (strlit6888 == NULL) {
    strlit6888 = alloc_String("Unknown");
    gc_root(strlit6888);
  }
// compilenode returning strlit6888
  gc_frame_newslot(strlit6888);
  Object bool6889 = alloc_Boolean(0);
// compilenode returning bool6889
  gc_frame_newslot(bool6889);
// compilenode returning *var_identifierNode
  params[0] = strlit6888;
  params[1] = bool6889;
  partcv[0] = 2;
  Object call6890 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6887);
// compilenode returning call6890
  return call6890;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if6880 = undefined;
  } else {
  }
// compilenode returning if6880
// Begin line 1594
  setline(1594);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1593
  setline(1593);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6891 = gc_frame_new();
  partcv[0] = 0;
  Object call6892 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6891);
// compilenode returning call6892
  return call6892;
// compilenode returning undefined
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast__apply6905(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1599
  setline(1599);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1598
  setline(1598);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6907 == NULL) {
    strlit6907 = alloc_String("    ");
    gc_root(strlit6907);
  }
// compilenode returning strlit6907
  int op_slot_right_6906 = gc_frame_newslot(strlit6907);
// compilenode returning *var_spc
  int op_slot_left_6906 = gc_frame_newslot(*var_spc);
  params[0] = strlit6907;
  partcv[0] = 1;
  Object opresult6909 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult6909
  *var_spc = opresult6909;
  if (opresult6909 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6966(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1607
  setline(1607);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6968 = gc_frame_new();
  Object num6969 = alloc_Float64(0);
// compilenode returning num6969
  gc_frame_newslot(num6969);
// compilenode returning *var_b
  params[0] = num6969;
  partcv[0] = 1;
  Object call6970 = callmethod(*var_b, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6968);
// compilenode returning call6970
  int op_slot_right_6967 = gc_frame_newslot(call6970);
  if (strlit6974 == NULL) {
    strlit6974 = alloc_String("");
    gc_root(strlit6974);
  }
// compilenode returning strlit6974
  int op_slot_right_6973 = gc_frame_newslot(strlit6974);
// compilenode returning *var_a
  int op_slot_left_6973 = gc_frame_newslot(*var_a);
  params[0] = strlit6974;
  partcv[0] = 1;
  Object opresult6976 = callmethod(*var_a, "!=", 1, partcv, params);
// compilenode returning opresult6976
  Object if6972 = done;
struct StackFrameObject *iftmpstackframe6972 = stackframe;
  if (istrue(opresult6976)) {
stackframe = alloc_StackFrame(0, iftmpstackframe6972);
gc_frame_newslot((Object)stackframe);
  if (strlit6978 == NULL) {
    strlit6978 = alloc_String(", ");
    gc_root(strlit6978);
  }
// compilenode returning strlit6978
  int op_slot_right_6977 = gc_frame_newslot(strlit6978);
// compilenode returning *var_a
  int op_slot_left_6977 = gc_frame_newslot(*var_a);
  params[0] = strlit6978;
  partcv[0] = 1;
  Object opresult6980 = callmethod(*var_a, "++", 1, partcv, params);
// compilenode returning opresult6980
    gc_frame_newslot(opresult6980);
    if6972 = opresult6980;
  } else {
stackframe = alloc_StackFrame(0, iftmpstackframe6972);
gc_frame_newslot((Object)stackframe);
  if (strlit6981 == NULL) {
    strlit6981 = alloc_String("");
    gc_root(strlit6981);
  }
// compilenode returning strlit6981
    gc_frame_newslot(strlit6981);
    if6972 = strlit6981;
  }
stackframe = iftmpstackframe6972;
// compilenode returning if6972
  int op_slot_left_6967 = gc_frame_newslot(if6972);
  params[0] = call6970;
  partcv[0] = 1;
  Object opresult6982 = callmethod(if6972, "++", 1, partcv, params);
// compilenode returning opresult6982
  gc_frame_end(frame);
  return opresult6982;
}
Object meth_ast_toGrace6893(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1597
  setline(1597);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1596
  setline(1596);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6894 == NULL) {
    strlit6894 = alloc_String("");
    gc_root(strlit6894);
  }
// compilenode returning strlit6894
  *var_spc = strlit6894;
  if (strlit6894 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1597
  setline(1597);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6895 = gc_frame_new();
  Object num6898 = alloc_Float64(1);
// compilenode returning num6898
  int op_slot_right_6897 = gc_frame_newslot(num6898);
// compilenode returning *var_depth
  int op_slot_left_6897 = gc_frame_newslot(*var_depth);
  params[0] = num6898;
  partcv[0] = 1;
  Object diff6900 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff6900
  int op_slot_right_6896 = gc_frame_newslot(diff6900);
  Object num6902 = alloc_Float64(0);
// compilenode returning num6902
  int op_slot_left_6896 = gc_frame_newslot(num6902);
  params[0] = diff6900;
  partcv[0] = 1;
  Object opresult6903 = callmethod(num6902, "..", 1, partcv, params);
// compilenode returning opresult6903
  gc_frame_newslot(opresult6903);
  Object block6904 = alloc_Block(NULL, NULL, "ast", 1597);
  gc_frame_newslot(block6904);
  block_savedest(block6904);
  Object closure6905 = createclosure(2, "_apply");
setclosureframe(closure6905, stackframe);
  addtoclosure(closure6905, var_spc);
  addtoclosure(closure6905, selfslot);
  struct UserObject *uo6905 = (struct UserObject*)block6904;
  uo6905->data[0] = (Object)closure6905;
  Method *meth_meth_ast__apply6905 = addmethod2pos(block6904, "_apply", &meth_ast__apply6905, 0);
int argcv_meth_ast__apply6905[] = {1};
meth_meth_ast__apply6905->type = alloc_MethodType(1, argcv_meth_ast__apply6905);
  meth_meth_ast__apply6905->definitionModule = modulename;
  meth_meth_ast__apply6905->definitionLine = 1585;
// compilenode returning block6904
  gc_frame_newslot(block6904);
  params[0] = opresult6903;
  params[1] = block6904;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6912 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6895);
// compilenode returning call6912
// Begin line 1601
  setline(1601);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1600
  setline(1600);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6914 == NULL) {
    strlit6914 = alloc_String("");
    gc_root(strlit6914);
  }
// compilenode returning strlit6914
  int op_slot_right_6913 = gc_frame_newslot(strlit6914);
  int callframe6917 = gc_frame_new();
  Object num6918 = alloc_Float64(0);
// compilenode returning num6918
  gc_frame_newslot(num6918);
  int callframe6919 = gc_frame_new();
  partcv[0] = 0;
  Object call6920 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6919);
// compilenode returning call6920
// compilenode returning call6920
  params[0] = num6918;
  partcv[0] = 1;
  Object call6921 = callmethod(call6920, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6917);
// compilenode returning call6921
  int op_slot_right_6916 = gc_frame_newslot(call6921);
  if (strlit6923 == NULL) {
    strlit6923 = alloc_String("def ");
    gc_root(strlit6923);
  }
// compilenode returning strlit6923
  int op_slot_left_6916 = gc_frame_newslot(strlit6923);
  params[0] = call6921;
  partcv[0] = 1;
  Object opresult6924 = callmethod(strlit6923, "++", 1, partcv, params);
// compilenode returning opresult6924
  int op_slot_left_6913 = gc_frame_newslot(opresult6924);
  params[0] = strlit6914;
  partcv[0] = 1;
  Object opresult6925 = callmethod(opresult6924, "++", 1, partcv, params);
// compilenode returning opresult6925
  *var_s = opresult6925;
  if (opresult6925 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1604
  setline(1604);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1601
  setline(1601);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6928 == NULL) {
    strlit6928 = alloc_String("Unknown");
    gc_root(strlit6928);
  }
// compilenode returning strlit6928
  int op_slot_right_6927 = gc_frame_newslot(strlit6928);
  int callframe6930 = gc_frame_new();
  int callframe6931 = gc_frame_new();
  partcv[0] = 0;
  Object call6932 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6931);
// compilenode returning call6932
// compilenode returning call6932
  partcv[0] = 0;
  Object call6933 = callmethod(call6932, "value",
    1, partcv, params);
  gc_frame_end(callframe6930);
// compilenode returning call6933
// compilenode returning call6933
  int op_slot_left_6927 = gc_frame_newslot(call6933);
  params[0] = strlit6928;
  partcv[0] = 1;
  Object opresult6934 = callmethod(call6933, "!=", 1, partcv, params);
// compilenode returning opresult6934
  Object if6926 = done;
  if (istrue(opresult6934)) {
// Begin line 1602
  setline(1602);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6936 = gc_frame_new();
  Object num6937 = alloc_Float64(0);
// compilenode returning num6937
  gc_frame_newslot(num6937);
  int callframe6938 = gc_frame_new();
  partcv[0] = 0;
  Object call6939 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6938);
// compilenode returning call6939
// compilenode returning call6939
  params[0] = num6937;
  partcv[0] = 1;
  Object call6940 = callmethod(call6939, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6936);
// compilenode returning call6940
  int op_slot_right_6935 = gc_frame_newslot(call6940);
  if (strlit6943 == NULL) {
    strlit6943 = alloc_String(" : ");
    gc_root(strlit6943);
  }
// compilenode returning strlit6943
  int op_slot_right_6942 = gc_frame_newslot(strlit6943);
// compilenode returning *var_s
  int op_slot_left_6942 = gc_frame_newslot(*var_s);
  params[0] = strlit6943;
  partcv[0] = 1;
  Object opresult6945 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6945
  int op_slot_left_6935 = gc_frame_newslot(opresult6945);
  params[0] = call6940;
  partcv[0] = 1;
  Object opresult6946 = callmethod(opresult6945, "++", 1, partcv, params);
// compilenode returning opresult6946
  *var_s = opresult6946;
  if (opresult6946 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6926 = done;
  } else {
  }
// compilenode returning if6926
// Begin line 1609
  setline(1609);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1604
  setline(1604);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num6950 = alloc_Float64(0);
// compilenode returning num6950
  int op_slot_right_6949 = gc_frame_newslot(num6950);
  int callframe6952 = gc_frame_new();
  int callframe6953 = gc_frame_new();
  partcv[0] = 0;
  Object call6954 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6953);
// compilenode returning call6954
// compilenode returning call6954
  partcv[0] = 0;
  Object call6955 = callmethod(call6954, "size",
    1, partcv, params);
  gc_frame_end(callframe6952);
// compilenode returning call6955
// compilenode returning call6955
  int op_slot_left_6949 = gc_frame_newslot(call6955);
  params[0] = num6950;
  partcv[0] = 1;
  Object opresult6956 = callmethod(call6955, ">", 1, partcv, params);
// compilenode returning opresult6956
  Object if6948 = done;
  if (istrue(opresult6956)) {
// Begin line 1606
  setline(1606);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1605
  setline(1605);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6958 == NULL) {
    strlit6958 = alloc_String(" is ");
    gc_root(strlit6958);
  }
// compilenode returning strlit6958
  int op_slot_right_6957 = gc_frame_newslot(strlit6958);
// compilenode returning *var_s
  int op_slot_left_6957 = gc_frame_newslot(*var_s);
  params[0] = strlit6958;
  partcv[0] = 1;
  Object opresult6960 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6960
  *var_s = opresult6960;
  if (opresult6960 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1606
  setline(1606);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6963 = gc_frame_new();
  if (strlit6964 == NULL) {
    strlit6964 = alloc_String("");
    gc_root(strlit6964);
  }
// compilenode returning strlit6964
  gc_frame_newslot(strlit6964);
  Object block6965 = alloc_Block(NULL, NULL, "ast", 1606);
  gc_frame_newslot(block6965);
  block_savedest(block6965);
  Object closure6966 = createclosure(1, "_apply");
setclosureframe(closure6966, stackframe);
  addtoclosure(closure6966, selfslot);
  struct UserObject *uo6966 = (struct UserObject*)block6965;
  uo6966->data[0] = (Object)closure6966;
  Method *meth_meth_ast__apply6966 = addmethod2pos(block6965, "_apply", &meth_ast__apply6966, 0);
int argcv_meth_ast__apply6966[] = {2};
meth_meth_ast__apply6966->type = alloc_MethodType(1, argcv_meth_ast__apply6966);
  meth_meth_ast__apply6966->definitionModule = modulename;
  meth_meth_ast__apply6966->definitionLine = 1604;
// compilenode returning block6965
  gc_frame_newslot(block6965);
// Begin line 1606
  setline(1606);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6984 = gc_frame_new();
  partcv[0] = 0;
  Object call6985 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6984);
// compilenode returning call6985
// compilenode returning call6985
  params[0] = strlit6964;
  params[1] = block6965;
  partcv[0] = 2;
  Object call6986 = callmethod(call6985, "reduce",
    1, partcv, params);
  gc_frame_end(callframe6963);
// compilenode returning call6986
  int op_slot_right_6962 = gc_frame_newslot(call6986);
// compilenode returning *var_s
  int op_slot_left_6962 = gc_frame_newslot(*var_s);
  params[0] = call6986;
  partcv[0] = 1;
  Object opresult6988 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6988
  *var_s = opresult6988;
  if (opresult6988 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6948 = done;
  } else {
  }
// compilenode returning if6948
// Begin line 1612
  setline(1612);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1609
  setline(1609);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool6992 = alloc_Boolean(0);
// compilenode returning bool6992
  int op_slot_right_6991 = gc_frame_newslot(bool6992);
  int callframe6994 = gc_frame_new();
  partcv[0] = 0;
  Object call6995 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6994);
// compilenode returning call6995
// compilenode returning call6995
  int op_slot_left_6991 = gc_frame_newslot(call6995);
  params[0] = bool6992;
  partcv[0] = 1;
  Object opresult6996 = callmethod(call6995, "!=", 1, partcv, params);
// compilenode returning opresult6996
  Object if6990 = done;
  if (istrue(opresult6996)) {
// Begin line 1610
  setline(1610);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6998 = gc_frame_new();
// compilenode returning *var_depth
  gc_frame_newslot(*var_depth);
  int callframe6999 = gc_frame_new();
  partcv[0] = 0;
  Object call7000 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6999);
// compilenode returning call7000
// compilenode returning call7000
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7001 = callmethod(call7000, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6998);
// compilenode returning call7001
  int op_slot_right_6997 = gc_frame_newslot(call7001);
  if (strlit7004 == NULL) {
    strlit7004 = alloc_String(" = ");
    gc_root(strlit7004);
  }
// compilenode returning strlit7004
  int op_slot_right_7003 = gc_frame_newslot(strlit7004);
// compilenode returning *var_s
  int op_slot_left_7003 = gc_frame_newslot(*var_s);
  params[0] = strlit7004;
  partcv[0] = 1;
  Object opresult7006 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7006
  int op_slot_left_6997 = gc_frame_newslot(opresult7006);
  params[0] = call7001;
  partcv[0] = 1;
  Object opresult7007 = callmethod(opresult7006, "++", 1, partcv, params);
// compilenode returning opresult7007
  *var_s = opresult7007;
  if (opresult7007 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6990 = done;
  } else {
  }
// compilenode returning if6990
// Begin line 1612
  setline(1612);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new6681(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_defDecNode = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  Object *var_collections = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val = &(stackframe->slots[1]);
  *var_val = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6682 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6682 = alloc_userobj2(17,15, objclass6682);
  gc_frame_newslot(obj6682);
if (objclass6682 == NULL) {
  glfree(obj6682->class->name);
  obj6682->class->name = "defDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6682, self, 0);
  addmethodreal(obj6682,"outer", &reader_ast_outer_6683);
  Object oldself6682 = self;
  struct StackFrameObject *oldstackframe6682 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6682);
  gc_frame_newslot((Object)stackframe);
  self = obj6682;
  Object *oldselfslot6682 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6682 = (*(struct UserObject *)self).data[0], lowerouter6682 = thisouter6682;
  if (inheritingObject6682) {
    struct UserObject *inho6682 = (struct UserObject *)inheritingObject6682;
    while (inho6682->super != GraceDefaultObject) inho6682 = (struct UserObject *)inho6682->super;
    inho6682->super = obj6682;
    self = inheritingObject6682;
    *selfslot = self;
    lowerouter6682 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6682;
  }
if (objclass6682 == NULL) {
  Method *reader6684 = addmethodrealflags(obj6682, "kind",&reader_ast_kind_6684, MFLAG_DEF);
  reader6684->definitionModule = modulename;
  reader6684->definitionLine = 1539;
}
adddatum2(obj6682, alloc_Undefined(), 1);
if (objclass6682 == NULL) {
  Method *reader6685 = addmethodrealflags(obj6682, "name",&reader_ast_name_6685, MFLAG_DEF);
  reader6685->definitionModule = modulename;
  reader6685->definitionLine = 1540;
}
adddatum2(obj6682, alloc_Undefined(), 2);
if (objclass6682 == NULL) {
  Method *reader6686 = addmethodrealflags(obj6682, "value",&reader_ast_value_6686, MFLAG_DEF);
  reader6686->definitionModule = modulename;
  reader6686->definitionLine = 1541;
}
adddatum2(obj6682, alloc_Undefined(), 3);
if (objclass6682 == NULL) {
  Method *reader6687 = addmethodrealflags(obj6682, "dtype",&reader_ast_dtype_6687, 0);
  Method *writer6687 = addmethodrealflags(obj6682, "dtype:=",&writer_ast_dtype_6687, 0);
  reader6687->definitionModule = modulename;
  writer6687->definitionModule = modulename;
  reader6687->definitionLine = 1542;
  writer6687->definitionLine = 1542;
}
obj6682->flags |= OFLAG_MUTABLE;
adddatum2(obj6682, alloc_Undefined(), 4);
if (objclass6682 == NULL) {
  Method *reader6688 = addmethodrealflags(obj6682, "annotations",&reader_ast_annotations_6688, MFLAG_DEF);
  reader6688->definitionModule = modulename;
  reader6688->definitionLine = 1543;
}
adddatum2(obj6682, alloc_Undefined(), 5);
if (objclass6682 == NULL) {
  Method *reader6689 = addmethodrealflags(obj6682, "data",&reader_ast_data_6689, 0);
  Method *writer6689 = addmethodrealflags(obj6682, "data:=",&writer_ast_data_6689, 0);
  reader6689->definitionModule = modulename;
  writer6689->definitionModule = modulename;
  reader6689->definitionLine = 1544;
  writer6689->definitionLine = 1544;
}
obj6682->flags |= OFLAG_MUTABLE;
adddatum2(obj6682, alloc_Undefined(), 6);
if (objclass6682 == NULL) {
  Method *reader6690 = addmethodrealflags(obj6682, "startToken",&reader_ast_startToken_6690, 0);
  Method *writer6690 = addmethodrealflags(obj6682, "startToken:=",&writer_ast_startToken_6690, 0);
  reader6690->definitionModule = modulename;
  writer6690->definitionModule = modulename;
  reader6690->definitionLine = 1545;
  writer6690->definitionLine = 1545;
}
obj6682->flags |= OFLAG_MUTABLE;
adddatum2(obj6682, alloc_Undefined(), 7);
  struct UserObject *uo6691 = (struct UserObject*)obj6682;
  uo6691->data[8] = emptyclosure;
  Method *meth_meth_ast_accept6691 = addmethod2pos(obj6682, "accept", &meth_ast_accept6691, 8);
int argcv_meth_ast_accept6691[] = {1};
meth_meth_ast_accept6691->type = alloc_MethodType(1, argcv_meth_ast_accept6691);
meth_meth_ast_accept6691->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept6691->type->names[0] = "visitor";
  meth_meth_ast_accept6691->definitionModule = modulename;
  meth_meth_ast_accept6691->definitionLine = 1545;
  block_savedest(obj6682);
  Object closure6721 = createclosure(1, "map()before()after");
setclosureframe(closure6721, stackframe);
  addtoclosure(closure6721, var_defDecNode);
  struct UserObject *uo6721 = (struct UserObject*)obj6682;
  uo6721->data[9] = (Object)closure6721;
  Method *meth_meth_ast_map_40__41_before_40__41_after6721 = addmethod2pos(obj6682, "map()before()after", &meth_ast_map_40__41_before_40__41_after6721, 9);
int argcv_meth_ast_map_40__41_before_40__41_after6721[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after6721->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after6721);
  meth_meth_ast_map_40__41_before_40__41_after6721->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after6721->definitionLine = 1556;
  struct UserObject *uo6768 = (struct UserObject*)obj6682;
  uo6768->data[10] = emptyclosure;
  Method *meth_meth_ast_map6768 = addmethod2pos(obj6682, "map", &meth_ast_map6768, 10);
int argcv_meth_ast_map6768[] = {1};
meth_meth_ast_map6768->type = alloc_MethodType(1, argcv_meth_ast_map6768);
  meth_meth_ast_map6768->definitionModule = modulename;
  meth_meth_ast_map6768->definitionLine = 1568;
  struct UserObject *uo6777 = (struct UserObject*)obj6682;
  uo6777->data[11] = emptyclosure;
  Method *meth_meth_ast_pretty6777 = addmethod2pos(obj6682, "pretty", &meth_ast_pretty6777, 11);
int argcv_meth_ast_pretty6777[] = {1};
meth_meth_ast_pretty6777->type = alloc_MethodType(1, argcv_meth_ast_pretty6777);
  meth_meth_ast_pretty6777->definitionModule = modulename;
  meth_meth_ast_pretty6777->definitionLine = 1571;
  block_savedest(obj6682);
  Object closure6879 = createclosure(1, "decType");
setclosureframe(closure6879, stackframe);
  addtoclosure(closure6879, var_identifierNode);
  struct UserObject *uo6879 = (struct UserObject*)obj6682;
  uo6879->data[12] = (Object)closure6879;
  Method *meth_meth_ast_decType6879 = addmethod2pos(obj6682, "decType", &meth_ast_decType6879, 12);
int argcv_meth_ast_decType6879[] = {0};
meth_meth_ast_decType6879->type = alloc_MethodType(1, argcv_meth_ast_decType6879);
  meth_meth_ast_decType6879->definitionModule = modulename;
  meth_meth_ast_decType6879->definitionLine = 1589;
  struct UserObject *uo6893 = (struct UserObject*)obj6682;
  uo6893->data[13] = emptyclosure;
  Method *meth_meth_ast_toGrace6893 = addmethod2pos(obj6682, "toGrace", &meth_ast_toGrace6893, 13);
int argcv_meth_ast_toGrace6893[] = {1};
meth_meth_ast_toGrace6893->type = alloc_MethodType(1, argcv_meth_ast_toGrace6893);
meth_meth_ast_toGrace6893->type->types[0] = type_Number;
meth_meth_ast_toGrace6893->type->names[0] = "depth";
  meth_meth_ast_toGrace6893->definitionModule = modulename;
  meth_meth_ast_toGrace6893->definitionLine = 1595;
  sourceObject = obj6682;
// Begin line 1537
  setline(1537);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7009 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7010 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7009);
// compilenode returning call7010
  struct UserObject *obj6682_uo = (struct UserObject *)obj6682;
  obj6682_uo->super = call7010;
  sourceObject = obj6682;
// Begin line 1538
  setline(1538);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7011 == NULL) {
    strlit7011 = alloc_String("defdec");
    gc_root(strlit7011);
  }
// compilenode returning strlit7011
  adddatum2(obj6682, strlit7011, 1);
  sourceObject = obj6682;
// Begin line 1539
  setline(1539);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name_39_
  adddatum2(obj6682, *var_name_39_, 2);
  sourceObject = obj6682;
// Begin line 1540
  setline(1540);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_val
  adddatum2(obj6682, *var_val, 3);
  sourceObject = obj6682;
// Begin line 1541
  setline(1541);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dtype_39_
  adddatum2(obj6682, *var_dtype_39_, 4);
  sourceObject = obj6682;
// Begin line 1542
  setline(1542);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7012 = gc_frame_new();
  int callframe7013 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call7014 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe7013);
// compilenode returning call7014
// compilenode returning call7014
  partcv[0] = 0;
  Object call7015 = callmethod(call7014, "new",
    1, partcv, params);
  gc_frame_end(callframe7012);
// compilenode returning call7015
// compilenode returning call7015
  adddatum2(obj6682, call7015, 5);
  sourceObject = obj6682;
// Begin line 1543
  setline(1543);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7016 = alloc_Boolean(0);
// compilenode returning bool7016
  adddatum2(obj6682, bool7016, 6);
  sourceObject = obj6682;
// Begin line 1544
  setline(1544);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7017 = alloc_Boolean(0);
// compilenode returning bool7017
  adddatum2(obj6682, bool7017, 7);
  sourceObject = obj6682;
  sourceObject = obj6682;
  sourceObject = obj6682;
  sourceObject = obj6682;
  sourceObject = obj6682;
  sourceObject = obj6682;
objclass6682 = obj6682->class;
  objclass6682->definitionModule = modulename;
  objclass6682->definitionLine = 1532;
  (*(struct UserObject *)self).data[0] = lowerouter6682;
  self = oldself6682;
  selfslot = oldselfslot6682;
  stackframe = oldstackframe6682;
  gc_frame_end(frame);
  return obj6682;
}
Object meth_ast_new6681_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_defDecNode = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  Object *var_collections = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val = &(stackframe->slots[1]);
  *var_val = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6682 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6682 = alloc_userobj2(17,15, objclass6682);
  gc_frame_newslot(obj6682);
if (objclass6682 == NULL) {
  glfree(obj6682->class->name);
  obj6682->class->name = "defDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6682, self, 0);
  addmethodreal(obj6682,"outer", &reader_ast_outer_6683);
  Object oldself6682 = self;
  struct StackFrameObject *oldstackframe6682 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6682);
  gc_frame_newslot((Object)stackframe);
  self = obj6682;
  Object *oldselfslot6682 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6682 = (*(struct UserObject *)self).data[0], lowerouter6682 = thisouter6682;
  if (inheritingObject6682) {
    struct UserObject *inho6682 = (struct UserObject *)inheritingObject6682;
    while (inho6682->super != GraceDefaultObject) inho6682 = (struct UserObject *)inho6682->super;
    inho6682->super = obj6682;
    self = inheritingObject6682;
    *selfslot = self;
    lowerouter6682 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6682;
  }
if (objclass6682 == NULL) {
  Method *reader6684 = addmethodrealflags(obj6682, "kind",&reader_ast_kind_6684, MFLAG_DEF);
  reader6684->definitionModule = modulename;
  reader6684->definitionLine = 1539;
}
adddatum2(obj6682, alloc_Undefined(), 1);
if (objclass6682 == NULL) {
  Method *reader6685 = addmethodrealflags(obj6682, "name",&reader_ast_name_6685, MFLAG_DEF);
  reader6685->definitionModule = modulename;
  reader6685->definitionLine = 1540;
}
adddatum2(obj6682, alloc_Undefined(), 2);
if (objclass6682 == NULL) {
  Method *reader6686 = addmethodrealflags(obj6682, "value",&reader_ast_value_6686, MFLAG_DEF);
  reader6686->definitionModule = modulename;
  reader6686->definitionLine = 1541;
}
adddatum2(obj6682, alloc_Undefined(), 3);
if (objclass6682 == NULL) {
  Method *reader6687 = addmethodrealflags(obj6682, "dtype",&reader_ast_dtype_6687, 0);
  Method *writer6687 = addmethodrealflags(obj6682, "dtype:=",&writer_ast_dtype_6687, 0);
  reader6687->definitionModule = modulename;
  writer6687->definitionModule = modulename;
  reader6687->definitionLine = 1542;
  writer6687->definitionLine = 1542;
}
obj6682->flags |= OFLAG_MUTABLE;
adddatum2(obj6682, alloc_Undefined(), 4);
if (objclass6682 == NULL) {
  Method *reader6688 = addmethodrealflags(obj6682, "annotations",&reader_ast_annotations_6688, MFLAG_DEF);
  reader6688->definitionModule = modulename;
  reader6688->definitionLine = 1543;
}
adddatum2(obj6682, alloc_Undefined(), 5);
if (objclass6682 == NULL) {
  Method *reader6689 = addmethodrealflags(obj6682, "data",&reader_ast_data_6689, 0);
  Method *writer6689 = addmethodrealflags(obj6682, "data:=",&writer_ast_data_6689, 0);
  reader6689->definitionModule = modulename;
  writer6689->definitionModule = modulename;
  reader6689->definitionLine = 1544;
  writer6689->definitionLine = 1544;
}
obj6682->flags |= OFLAG_MUTABLE;
adddatum2(obj6682, alloc_Undefined(), 6);
if (objclass6682 == NULL) {
  Method *reader6690 = addmethodrealflags(obj6682, "startToken",&reader_ast_startToken_6690, 0);
  Method *writer6690 = addmethodrealflags(obj6682, "startToken:=",&writer_ast_startToken_6690, 0);
  reader6690->definitionModule = modulename;
  writer6690->definitionModule = modulename;
  reader6690->definitionLine = 1545;
  writer6690->definitionLine = 1545;
}
obj6682->flags |= OFLAG_MUTABLE;
adddatum2(obj6682, alloc_Undefined(), 7);
  struct UserObject *uo6691 = (struct UserObject*)obj6682;
  uo6691->data[8] = emptyclosure;
  Method *meth_meth_ast_accept6691 = addmethod2pos(obj6682, "accept", &meth_ast_accept6691, 8);
int argcv_meth_ast_accept6691[] = {1};
meth_meth_ast_accept6691->type = alloc_MethodType(1, argcv_meth_ast_accept6691);
meth_meth_ast_accept6691->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept6691->type->names[0] = "visitor";
  meth_meth_ast_accept6691->definitionModule = modulename;
  meth_meth_ast_accept6691->definitionLine = 1545;
  block_savedest(obj6682);
  Object closure6721 = createclosure(1, "map()before()after");
setclosureframe(closure6721, stackframe);
  addtoclosure(closure6721, var_defDecNode);
  struct UserObject *uo6721 = (struct UserObject*)obj6682;
  uo6721->data[9] = (Object)closure6721;
  Method *meth_meth_ast_map_40__41_before_40__41_after6721 = addmethod2pos(obj6682, "map()before()after", &meth_ast_map_40__41_before_40__41_after6721, 9);
int argcv_meth_ast_map_40__41_before_40__41_after6721[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after6721->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after6721);
  meth_meth_ast_map_40__41_before_40__41_after6721->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after6721->definitionLine = 1556;
  struct UserObject *uo6768 = (struct UserObject*)obj6682;
  uo6768->data[10] = emptyclosure;
  Method *meth_meth_ast_map6768 = addmethod2pos(obj6682, "map", &meth_ast_map6768, 10);
int argcv_meth_ast_map6768[] = {1};
meth_meth_ast_map6768->type = alloc_MethodType(1, argcv_meth_ast_map6768);
  meth_meth_ast_map6768->definitionModule = modulename;
  meth_meth_ast_map6768->definitionLine = 1568;
  struct UserObject *uo6777 = (struct UserObject*)obj6682;
  uo6777->data[11] = emptyclosure;
  Method *meth_meth_ast_pretty6777 = addmethod2pos(obj6682, "pretty", &meth_ast_pretty6777, 11);
int argcv_meth_ast_pretty6777[] = {1};
meth_meth_ast_pretty6777->type = alloc_MethodType(1, argcv_meth_ast_pretty6777);
  meth_meth_ast_pretty6777->definitionModule = modulename;
  meth_meth_ast_pretty6777->definitionLine = 1571;
  block_savedest(obj6682);
  Object closure6879 = createclosure(1, "decType");
setclosureframe(closure6879, stackframe);
  addtoclosure(closure6879, var_identifierNode);
  struct UserObject *uo6879 = (struct UserObject*)obj6682;
  uo6879->data[12] = (Object)closure6879;
  Method *meth_meth_ast_decType6879 = addmethod2pos(obj6682, "decType", &meth_ast_decType6879, 12);
int argcv_meth_ast_decType6879[] = {0};
meth_meth_ast_decType6879->type = alloc_MethodType(1, argcv_meth_ast_decType6879);
  meth_meth_ast_decType6879->definitionModule = modulename;
  meth_meth_ast_decType6879->definitionLine = 1589;
  struct UserObject *uo6893 = (struct UserObject*)obj6682;
  uo6893->data[13] = emptyclosure;
  Method *meth_meth_ast_toGrace6893 = addmethod2pos(obj6682, "toGrace", &meth_ast_toGrace6893, 13);
int argcv_meth_ast_toGrace6893[] = {1};
meth_meth_ast_toGrace6893->type = alloc_MethodType(1, argcv_meth_ast_toGrace6893);
meth_meth_ast_toGrace6893->type->types[0] = type_Number;
meth_meth_ast_toGrace6893->type->names[0] = "depth";
  meth_meth_ast_toGrace6893->definitionModule = modulename;
  meth_meth_ast_toGrace6893->definitionLine = 1595;
  sourceObject = obj6682;
// Begin line 1537
  setline(1537);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7009 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7010 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7009);
// compilenode returning call7010
  struct UserObject *obj6682_uo = (struct UserObject *)obj6682;
  obj6682_uo->super = call7010;
  sourceObject = obj6682;
// Begin line 1538
  setline(1538);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7011 == NULL) {
    strlit7011 = alloc_String("defdec");
    gc_root(strlit7011);
  }
// compilenode returning strlit7011
  adddatum2(obj6682, strlit7011, 1);
  sourceObject = obj6682;
// Begin line 1539
  setline(1539);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name_39_
  adddatum2(obj6682, *var_name_39_, 2);
  sourceObject = obj6682;
// Begin line 1540
  setline(1540);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_val
  adddatum2(obj6682, *var_val, 3);
  sourceObject = obj6682;
// Begin line 1541
  setline(1541);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dtype_39_
  adddatum2(obj6682, *var_dtype_39_, 4);
  sourceObject = obj6682;
// Begin line 1542
  setline(1542);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7012 = gc_frame_new();
  int callframe7013 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call7014 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe7013);
// compilenode returning call7014
// compilenode returning call7014
  partcv[0] = 0;
  Object call7015 = callmethod(call7014, "new",
    1, partcv, params);
  gc_frame_end(callframe7012);
// compilenode returning call7015
// compilenode returning call7015
  adddatum2(obj6682, call7015, 5);
  sourceObject = obj6682;
// Begin line 1543
  setline(1543);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7016 = alloc_Boolean(0);
// compilenode returning bool7016
  adddatum2(obj6682, bool7016, 6);
  sourceObject = obj6682;
// Begin line 1544
  setline(1544);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7017 = alloc_Boolean(0);
// compilenode returning bool7017
  adddatum2(obj6682, bool7017, 7);
  sourceObject = obj6682;
  sourceObject = obj6682;
  sourceObject = obj6682;
  sourceObject = obj6682;
  sourceObject = obj6682;
  sourceObject = obj6682;
objclass6682 = obj6682->class;
  objclass6682->definitionModule = modulename;
  objclass6682->definitionLine = 1532;
  (*(struct UserObject *)self).data[0] = lowerouter6682;
  self = oldself6682;
  selfslot = oldselfslot6682;
  stackframe = oldstackframe6682;
  gc_frame_end(frame);
  return obj6682;
}
Object meth_ast_varDecNode7019(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 33, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "varDecNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_varDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for varDecNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for varDecNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1615
  setline(1615);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_varDecNode
  gc_frame_end(frame);
  return *var_varDecNode;
}
Object meth_ast_accept7030(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1632
  setline(1632);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1623
  setline(1623);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7032 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call7033 = callmethod(*var_visitor, "visitVarDec",
    1, partcv, params);
  gc_frame_end(callframe7032);
// compilenode returning call7033
  Object if7031 = done;
  if (istrue(call7033)) {
// Begin line 1624
  setline(1624);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7034 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe7035 = gc_frame_new();
  partcv[0] = 0;
  Object call7036 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7035);
// compilenode returning call7036
// compilenode returning call7036
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call7037 = callmethod(call7036, "accept",
    1, partcv, params);
  gc_frame_end(callframe7034);
// compilenode returning call7037
// Begin line 1628
  setline(1628);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1625
  setline(1625);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7040 = alloc_Boolean(0);
// compilenode returning bool7040
  int op_slot_right_7039 = gc_frame_newslot(bool7040);
  int callframe7042 = gc_frame_new();
  partcv[0] = 0;
  Object call7043 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7042);
// compilenode returning call7043
// compilenode returning call7043
  int op_slot_left_7039 = gc_frame_newslot(call7043);
  params[0] = bool7040;
  partcv[0] = 1;
  Object opresult7044 = callmethod(call7043, "!=", 1, partcv, params);
// compilenode returning opresult7044
  Object if7038 = done;
  if (istrue(opresult7044)) {
// Begin line 1626
  setline(1626);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7045 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe7046 = gc_frame_new();
  partcv[0] = 0;
  Object call7047 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7046);
// compilenode returning call7047
// compilenode returning call7047
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call7048 = callmethod(call7047, "accept",
    1, partcv, params);
  gc_frame_end(callframe7045);
// compilenode returning call7048
    gc_frame_newslot(call7048);
    if7038 = call7048;
  } else {
  }
// compilenode returning if7038
// Begin line 1631
  setline(1631);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1628
  setline(1628);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7051 = alloc_Boolean(0);
// compilenode returning bool7051
  int op_slot_right_7050 = gc_frame_newslot(bool7051);
  int callframe7053 = gc_frame_new();
  partcv[0] = 0;
  Object call7054 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7053);
// compilenode returning call7054
// compilenode returning call7054
  int op_slot_left_7050 = gc_frame_newslot(call7054);
  params[0] = bool7051;
  partcv[0] = 1;
  Object opresult7055 = callmethod(call7054, "!=", 1, partcv, params);
// compilenode returning opresult7055
  Object if7049 = done;
  if (istrue(opresult7055)) {
// Begin line 1629
  setline(1629);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7056 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe7057 = gc_frame_new();
  partcv[0] = 0;
  Object call7058 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7057);
// compilenode returning call7058
// compilenode returning call7058
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call7059 = callmethod(call7058, "accept",
    1, partcv, params);
  gc_frame_end(callframe7056);
// compilenode returning call7059
    gc_frame_newslot(call7059);
    if7049 = call7059;
  } else {
  }
// compilenode returning if7049
    gc_frame_newslot(if7049);
    if7031 = if7049;
  } else {
  }
// compilenode returning if7031
  gc_frame_end(frame);
  return if7031;
}
Object meth_ast__apply7093(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_blk = getfromclosure(closure, 0);
  Object *var_blkBefore = getfromclosure(closure, 1);
  Object *var_blkAfter = getfromclosure(closure, 2);
  Object *var_n = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1639
  setline(1639);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7094 = gc_frame_new();
  int callframe7095 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// compilenode returning *var_a
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7096 = callmethod(*var_a, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe7095);
// compilenode returning call7096
  gc_frame_newslot(call7096);
  int callframe7097 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call7098 = callmethod(*var_n, "annotations",
    1, partcv, params);
  gc_frame_end(callframe7097);
// compilenode returning call7098
// compilenode returning call7098
  params[0] = call7096;
  partcv[0] = 1;
  Object call7099 = callmethod(call7098, "push",
    1, partcv, params);
  gc_frame_end(callframe7094);
// compilenode returning call7099
  gc_frame_end(frame);
  return call7099;
}
Object meth_ast_map_40__41_before_40__41_after7060(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_varDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1634
  setline(1634);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7061 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call7062 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe7061);
// compilenode returning call7062
// Begin line 1635
  setline(1635);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7063 = gc_frame_new();
  int callframe7064 = gc_frame_new();
  partcv[0] = 0;
  Object call7065 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7064);
// compilenode returning call7065
  gc_frame_newslot(call7065);
  int callframe7066 = gc_frame_new();
  int callframe7067 = gc_frame_new();
  partcv[0] = 0;
  Object call7068 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7067);
// compilenode returning call7068
  gc_frame_newslot(call7068);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// Begin line 1636
  setline(1636);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// Begin line 1635
  setline(1635);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7069 = gc_frame_new();
  int callframe7070 = gc_frame_new();
  Object call7071 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7070);
// compilenode returning call7071
// compilenode returning call7071
  partcv[0] = 0;
  Object call7072 = callmethodflags(call7071, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7069);
// compilenode returning call7072
// compilenode returning call7072
  params[0] = call7068;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 4;
  Object call7073 = callmethodflags(call7072, "maybeMap", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7066);
// compilenode returning call7073
  gc_frame_newslot(call7073);
// Begin line 1637
  setline(1637);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7074 = gc_frame_new();
  int callframe7075 = gc_frame_new();
  partcv[0] = 0;
  Object call7076 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7075);
// compilenode returning call7076
  gc_frame_newslot(call7076);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe7077 = gc_frame_new();
  int callframe7078 = gc_frame_new();
  Object call7079 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7078);
// compilenode returning call7079
// compilenode returning call7079
  partcv[0] = 0;
  Object call7080 = callmethodflags(call7079, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7077);
// compilenode returning call7080
// compilenode returning call7080
  params[0] = call7076;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 4;
  Object call7081 = callmethodflags(call7080, "maybeMap", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7074);
// compilenode returning call7081
  gc_frame_newslot(call7081);
// Begin line 1635
  setline(1635);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_varDecNode
  params[0] = call7065;
  params[1] = call7073;
  params[2] = call7081;
  partcv[0] = 3;
  Object call7082 = callmethod(*var_varDecNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7063);
// compilenode returning call7082
  *var_n = call7082;
  if (call7082 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1638
  setline(1638);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7083 = gc_frame_new();
  int callframe7084 = gc_frame_new();
  int callframe7085 = gc_frame_new();
  partcv[0] = 0;
  Object call7086 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7085);
// compilenode returning call7086
  gc_frame_newslot(call7086);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe7087 = gc_frame_new();
  int callframe7088 = gc_frame_new();
  Object call7089 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7088);
// compilenode returning call7089
// compilenode returning call7089
  partcv[0] = 0;
  Object call7090 = callmethodflags(call7089, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7087);
// compilenode returning call7090
// compilenode returning call7090
  params[0] = call7086;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7091 = callmethodflags(call7090, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7084);
// compilenode returning call7091
  gc_frame_newslot(call7091);
  Object block7092 = alloc_Block(NULL, NULL, "ast", 1638);
  gc_frame_newslot(block7092);
  block_savedest(block7092);
  Object closure7093 = createclosure(5, "_apply");
setclosureframe(closure7093, stackframe);
  addtoclosure(closure7093, var_blk);
  addtoclosure(closure7093, var_blkBefore);
  addtoclosure(closure7093, var_blkAfter);
  addtoclosure(closure7093, var_n);
  addtoclosure(closure7093, selfslot);
  struct UserObject *uo7093 = (struct UserObject*)block7092;
  uo7093->data[0] = (Object)closure7093;
  Method *meth_meth_ast__apply7093 = addmethod2pos(block7092, "_apply", &meth_ast__apply7093, 0);
int argcv_meth_ast__apply7093[] = {1};
meth_meth_ast__apply7093->type = alloc_MethodType(1, argcv_meth_ast__apply7093);
  meth_meth_ast__apply7093->definitionModule = modulename;
  meth_meth_ast__apply7093->definitionLine = 1638;
// compilenode returning block7092
  gc_frame_newslot(block7092);
  params[0] = call7091;
  params[1] = block7092;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7101 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7083);
// compilenode returning call7101
// Begin line 1641
  setline(1641);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7102 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7103 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7102);
// compilenode returning call7103
  *var_n = call7103;
  if (call7103 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1643
  setline(1643);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1639
  setline(1639);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7105 = gc_frame_new();
// Begin line 1642
  setline(1642);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7106 = gc_frame_new();
  partcv[0] = 0;
  Object call7107 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7106);
// compilenode returning call7107
  gc_frame_newslot(call7107);
// compilenode returning *var_n
  params[0] = call7107;
  partcv[0] = 1;
  Object call7108 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe7105);
// compilenode returning call7108
// compilenode returning done
// Begin line 1643
  setline(1643);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7109 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7110 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe7109);
// compilenode returning call7110
// Begin line 1644
  setline(1644);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply7114(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply7117(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map7111(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1647
  setline(1647);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7112 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block7113 = alloc_Block(NULL, NULL, "ast", 1647);
  gc_frame_newslot(block7113);
  block_savedest(block7113);
  Object closure7114 = createclosure(1, "_apply");
setclosureframe(closure7114, stackframe);
  addtoclosure(closure7114, selfslot);
  struct UserObject *uo7114 = (struct UserObject*)block7113;
  uo7114->data[0] = (Object)closure7114;
  Method *meth_meth_ast__apply7114 = addmethod2pos(block7113, "_apply", &meth_ast__apply7114, 0);
int argcv_meth_ast__apply7114[] = {0};
meth_meth_ast__apply7114->type = alloc_MethodType(1, argcv_meth_ast__apply7114);
  meth_meth_ast__apply7114->definitionModule = modulename;
  meth_meth_ast__apply7114->definitionLine = 1639;
// compilenode returning block7113
  gc_frame_newslot(block7113);
  Object block7116 = alloc_Block(NULL, NULL, "ast", 1647);
  gc_frame_newslot(block7116);
  block_savedest(block7116);
  Object closure7117 = createclosure(1, "_apply");
setclosureframe(closure7117, stackframe);
  addtoclosure(closure7117, selfslot);
  struct UserObject *uo7117 = (struct UserObject*)block7116;
  uo7117->data[0] = (Object)closure7117;
  Method *meth_meth_ast__apply7117 = addmethod2pos(block7116, "_apply", &meth_ast__apply7117, 0);
int argcv_meth_ast__apply7117[] = {0};
meth_meth_ast__apply7117->type = alloc_MethodType(1, argcv_meth_ast__apply7117);
  meth_meth_ast__apply7117->definitionModule = modulename;
  meth_meth_ast__apply7117->definitionLine = 1639;
// compilenode returning block7116
  gc_frame_newslot(block7116);
  params[0] = *var_blk;
  params[1] = block7113;
  params[2] = block7116;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7119 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7112);
// compilenode returning call7119
  gc_frame_end(frame);
  return call7119;
}
Object meth_ast__apply7128(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1653
  setline(1653);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1652
  setline(1652);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7130 == NULL) {
    strlit7130 = alloc_String("  ");
    gc_root(strlit7130);
  }
// compilenode returning strlit7130
  int op_slot_right_7129 = gc_frame_newslot(strlit7130);
// compilenode returning *var_spc
  int op_slot_left_7129 = gc_frame_newslot(*var_spc);
  params[0] = strlit7130;
  partcv[0] = 1;
  Object opresult7132 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult7132
  *var_spc = opresult7132;
  if (opresult7132 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty7120(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1651
  setline(1651);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1650
  setline(1650);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7121 == NULL) {
    strlit7121 = alloc_String("");
    gc_root(strlit7121);
  }
// compilenode returning strlit7121
  *var_spc = strlit7121;
  if (strlit7121 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1651
  setline(1651);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7122 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_7123 = gc_frame_newslot(*var_depth);
  Object num7125 = alloc_Float64(0);
// compilenode returning num7125
  int op_slot_left_7123 = gc_frame_newslot(num7125);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7126 = callmethod(num7125, "..", 1, partcv, params);
// compilenode returning opresult7126
  gc_frame_newslot(opresult7126);
  Object block7127 = alloc_Block(NULL, NULL, "ast", 1651);
  gc_frame_newslot(block7127);
  block_savedest(block7127);
  Object closure7128 = createclosure(2, "_apply");
setclosureframe(closure7128, stackframe);
  addtoclosure(closure7128, var_spc);
  addtoclosure(closure7128, selfslot);
  struct UserObject *uo7128 = (struct UserObject*)block7127;
  uo7128->data[0] = (Object)closure7128;
  Method *meth_meth_ast__apply7128 = addmethod2pos(block7127, "_apply", &meth_ast__apply7128, 0);
int argcv_meth_ast__apply7128[] = {1};
meth_meth_ast__apply7128->type = alloc_MethodType(1, argcv_meth_ast__apply7128);
  meth_meth_ast__apply7128->definitionModule = modulename;
  meth_meth_ast__apply7128->definitionLine = 1639;
// compilenode returning block7127
  gc_frame_newslot(block7127);
  params[0] = opresult7126;
  params[1] = block7127;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7135 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7122);
// compilenode returning call7135
// Begin line 1655
  setline(1655);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1654
  setline(1654);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7136 == NULL) {
    strlit7136 = alloc_String("VarDec");
    gc_root(strlit7136);
  }
// compilenode returning strlit7136
  *var_s = strlit7136;
  if (strlit7136 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1656
  setline(1656);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1655
  setline(1655);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7138 == NULL) {
    strlit7138 = alloc_String("""\x0a""");
    gc_root(strlit7138);
  }
// compilenode returning strlit7138
  int op_slot_right_7137 = gc_frame_newslot(strlit7138);
// compilenode returning *var_s
  int op_slot_left_7137 = gc_frame_newslot(*var_s);
  params[0] = strlit7138;
  partcv[0] = 1;
  Object opresult7140 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7140
  *var_s = opresult7140;
  if (opresult7140 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1656
  setline(1656);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7143 = gc_frame_new();
  Object num7145 = alloc_Float64(1);
// compilenode returning num7145
  int op_slot_right_7144 = gc_frame_newslot(num7145);
// compilenode returning *var_depth
  int op_slot_left_7144 = gc_frame_newslot(*var_depth);
  params[0] = num7145;
  partcv[0] = 1;
  Object sum7147 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum7147
  gc_frame_newslot(sum7147);
  int callframe7148 = gc_frame_new();
  partcv[0] = 0;
  Object call7149 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7148);
// compilenode returning call7149
// compilenode returning call7149
  params[0] = sum7147;
  partcv[0] = 1;
  Object call7150 = callmethod(call7149, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7143);
// compilenode returning call7150
  int op_slot_right_7142 = gc_frame_newslot(call7150);
// compilenode returning *var_spc
  int op_slot_right_7152 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_7152 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7154 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7154
  int op_slot_left_7142 = gc_frame_newslot(opresult7154);
  params[0] = call7150;
  partcv[0] = 1;
  Object opresult7155 = callmethod(opresult7154, "++", 1, partcv, params);
// compilenode returning opresult7155
  *var_s = opresult7155;
  if (opresult7155 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1661
  setline(1661);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1657
  setline(1657);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7159 = alloc_Boolean(0);
// compilenode returning bool7159
  int op_slot_right_7158 = gc_frame_newslot(bool7159);
  int callframe7161 = gc_frame_new();
  partcv[0] = 0;
  Object call7162 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7161);
// compilenode returning call7162
// compilenode returning call7162
  int op_slot_left_7158 = gc_frame_newslot(call7162);
  params[0] = bool7159;
  partcv[0] = 1;
  Object opresult7163 = callmethod(call7162, "!=", 1, partcv, params);
// compilenode returning opresult7163
  Object if7157 = done;
  if (istrue(opresult7163)) {
// Begin line 1659
  setline(1659);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1658
  setline(1658);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7165 == NULL) {
    strlit7165 = alloc_String("Type:");
    gc_root(strlit7165);
  }
// compilenode returning strlit7165
  int op_slot_right_7164 = gc_frame_newslot(strlit7165);
// compilenode returning *var_spc
  int op_slot_right_7167 = gc_frame_newslot(*var_spc);
  if (strlit7170 == NULL) {
    strlit7170 = alloc_String("""\x0a""");
    gc_root(strlit7170);
  }
// compilenode returning strlit7170
  int op_slot_right_7169 = gc_frame_newslot(strlit7170);
// compilenode returning *var_s
  int op_slot_left_7169 = gc_frame_newslot(*var_s);
  params[0] = strlit7170;
  partcv[0] = 1;
  Object opresult7172 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7172
  int op_slot_left_7167 = gc_frame_newslot(opresult7172);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7173 = callmethod(opresult7172, "++", 1, partcv, params);
// compilenode returning opresult7173
  int op_slot_left_7164 = gc_frame_newslot(opresult7173);
  params[0] = strlit7165;
  partcv[0] = 1;
  Object opresult7174 = callmethod(opresult7173, "++", 1, partcv, params);
// compilenode returning opresult7174
  *var_s = opresult7174;
  if (opresult7174 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1659
  setline(1659);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7177 = gc_frame_new();
  Object num7179 = alloc_Float64(2);
// compilenode returning num7179
  int op_slot_right_7178 = gc_frame_newslot(num7179);
// compilenode returning *var_depth
  int op_slot_left_7178 = gc_frame_newslot(*var_depth);
  params[0] = num7179;
  partcv[0] = 1;
  Object sum7181 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum7181
  gc_frame_newslot(sum7181);
  int callframe7182 = gc_frame_new();
  partcv[0] = 0;
  Object call7183 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7182);
// compilenode returning call7183
// compilenode returning call7183
  params[0] = sum7181;
  partcv[0] = 1;
  Object call7184 = callmethod(call7183, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7177);
// compilenode returning call7184
  int op_slot_right_7176 = gc_frame_newslot(call7184);
  if (strlit7187 == NULL) {
    strlit7187 = alloc_String("  ");
    gc_root(strlit7187);
  }
// compilenode returning strlit7187
  int op_slot_right_7186 = gc_frame_newslot(strlit7187);
// compilenode returning *var_spc
  int op_slot_right_7189 = gc_frame_newslot(*var_spc);
  if (strlit7192 == NULL) {
    strlit7192 = alloc_String("""\x0a""");
    gc_root(strlit7192);
  }
// compilenode returning strlit7192
  int op_slot_right_7191 = gc_frame_newslot(strlit7192);
// compilenode returning *var_s
  int op_slot_left_7191 = gc_frame_newslot(*var_s);
  params[0] = strlit7192;
  partcv[0] = 1;
  Object opresult7194 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7194
  int op_slot_left_7189 = gc_frame_newslot(opresult7194);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7195 = callmethod(opresult7194, "++", 1, partcv, params);
// compilenode returning opresult7195
  int op_slot_left_7186 = gc_frame_newslot(opresult7195);
  params[0] = strlit7187;
  partcv[0] = 1;
  Object opresult7196 = callmethod(opresult7195, "++", 1, partcv, params);
// compilenode returning opresult7196
  int op_slot_left_7176 = gc_frame_newslot(opresult7196);
  params[0] = call7184;
  partcv[0] = 1;
  Object opresult7197 = callmethod(opresult7196, "++", 1, partcv, params);
// compilenode returning opresult7197
  *var_s = opresult7197;
  if (opresult7197 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if7157 = done;
  } else {
  }
// compilenode returning if7157
// Begin line 1665
  setline(1665);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1661
  setline(1661);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7201 = gc_frame_new();
  partcv[0] = 0;
  Object call7202 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7201);
// compilenode returning call7202
// compilenode returning call7202
  int op_slot_right_7200 = gc_frame_newslot(call7202);
  Object bool7204 = alloc_Boolean(0);
// compilenode returning bool7204
  int op_slot_left_7200 = gc_frame_newslot(bool7204);
  params[0] = call7202;
  partcv[0] = 1;
  Object opresult7205 = callmethod(bool7204, "!=", 1, partcv, params);
// compilenode returning opresult7205
  Object if7199 = done;
  if (istrue(opresult7205)) {
// Begin line 1663
  setline(1663);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1662
  setline(1662);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7207 == NULL) {
    strlit7207 = alloc_String("""\x0a""");
    gc_root(strlit7207);
  }
// compilenode returning strlit7207
  int op_slot_right_7206 = gc_frame_newslot(strlit7207);
// compilenode returning *var_s
  int op_slot_left_7206 = gc_frame_newslot(*var_s);
  params[0] = strlit7207;
  partcv[0] = 1;
  Object opresult7209 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7209
  *var_s = opresult7209;
  if (opresult7209 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1663
  setline(1663);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7212 = gc_frame_new();
  Object num7214 = alloc_Float64(1);
// compilenode returning num7214
  int op_slot_right_7213 = gc_frame_newslot(num7214);
// compilenode returning *var_depth
  int op_slot_left_7213 = gc_frame_newslot(*var_depth);
  params[0] = num7214;
  partcv[0] = 1;
  Object sum7216 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum7216
  gc_frame_newslot(sum7216);
  int callframe7217 = gc_frame_new();
  partcv[0] = 0;
  Object call7218 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7217);
// compilenode returning call7218
// compilenode returning call7218
  params[0] = sum7216;
  partcv[0] = 1;
  Object call7219 = callmethod(call7218, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7212);
// compilenode returning call7219
  int op_slot_right_7211 = gc_frame_newslot(call7219);
// compilenode returning *var_spc
  int op_slot_right_7221 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_7221 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7223 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7223
  int op_slot_left_7211 = gc_frame_newslot(opresult7223);
  params[0] = call7219;
  partcv[0] = 1;
  Object opresult7224 = callmethod(opresult7223, "++", 1, partcv, params);
// compilenode returning opresult7224
  *var_s = opresult7224;
  if (opresult7224 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if7199 = done;
  } else {
  }
// compilenode returning if7199
// Begin line 1665
  setline(1665);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_decType7226(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "decType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for decType (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for decType");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1671
  setline(1671);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1668
  setline(1668);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7229 = alloc_Boolean(0);
// compilenode returning bool7229
  int op_slot_right_7228 = gc_frame_newslot(bool7229);
  int callframe7231 = gc_frame_new();
  partcv[0] = 0;
  Object call7232 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7231);
// compilenode returning call7232
  int op_slot_left_7228 = gc_frame_newslot(call7232);
  params[0] = bool7229;
  partcv[0] = 1;
  Object opresult7233 = callmethod(call7232, "==", 1, partcv, params);
// compilenode returning opresult7233
  Object if7227 = done;
  if (istrue(opresult7233)) {
// Begin line 1669
  setline(1669);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7234 = gc_frame_new();
  if (strlit7235 == NULL) {
    strlit7235 = alloc_String("Unknown");
    gc_root(strlit7235);
  }
// compilenode returning strlit7235
  gc_frame_newslot(strlit7235);
  Object bool7236 = alloc_Boolean(0);
// compilenode returning bool7236
  gc_frame_newslot(bool7236);
// compilenode returning *var_identifierNode
  params[0] = strlit7235;
  params[1] = bool7236;
  partcv[0] = 2;
  Object call7237 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7234);
// compilenode returning call7237
  return call7237;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if7227 = undefined;
  } else {
  }
// compilenode returning if7227
// Begin line 1672
  setline(1672);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1671
  setline(1671);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7238 = gc_frame_new();
  partcv[0] = 0;
  Object call7239 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7238);
// compilenode returning call7239
  return call7239;
// compilenode returning undefined
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast__apply7252(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1677
  setline(1677);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1676
  setline(1676);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7254 == NULL) {
    strlit7254 = alloc_String("    ");
    gc_root(strlit7254);
  }
// compilenode returning strlit7254
  int op_slot_right_7253 = gc_frame_newslot(strlit7254);
// compilenode returning *var_spc
  int op_slot_left_7253 = gc_frame_newslot(*var_spc);
  params[0] = strlit7254;
  partcv[0] = 1;
  Object opresult7256 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult7256
  *var_spc = opresult7256;
  if (opresult7256 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply7313(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1685
  setline(1685);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7315 = gc_frame_new();
  Object num7316 = alloc_Float64(0);
// compilenode returning num7316
  gc_frame_newslot(num7316);
// compilenode returning *var_b
  params[0] = num7316;
  partcv[0] = 1;
  Object call7317 = callmethod(*var_b, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7315);
// compilenode returning call7317
  int op_slot_right_7314 = gc_frame_newslot(call7317);
  if (strlit7321 == NULL) {
    strlit7321 = alloc_String("");
    gc_root(strlit7321);
  }
// compilenode returning strlit7321
  int op_slot_right_7320 = gc_frame_newslot(strlit7321);
// compilenode returning *var_a
  int op_slot_left_7320 = gc_frame_newslot(*var_a);
  params[0] = strlit7321;
  partcv[0] = 1;
  Object opresult7323 = callmethod(*var_a, "!=", 1, partcv, params);
// compilenode returning opresult7323
  Object if7319 = done;
struct StackFrameObject *iftmpstackframe7319 = stackframe;
  if (istrue(opresult7323)) {
stackframe = alloc_StackFrame(0, iftmpstackframe7319);
gc_frame_newslot((Object)stackframe);
  if (strlit7325 == NULL) {
    strlit7325 = alloc_String(", ");
    gc_root(strlit7325);
  }
// compilenode returning strlit7325
  int op_slot_right_7324 = gc_frame_newslot(strlit7325);
// compilenode returning *var_a
  int op_slot_left_7324 = gc_frame_newslot(*var_a);
  params[0] = strlit7325;
  partcv[0] = 1;
  Object opresult7327 = callmethod(*var_a, "++", 1, partcv, params);
// compilenode returning opresult7327
    gc_frame_newslot(opresult7327);
    if7319 = opresult7327;
  } else {
stackframe = alloc_StackFrame(0, iftmpstackframe7319);
gc_frame_newslot((Object)stackframe);
  if (strlit7328 == NULL) {
    strlit7328 = alloc_String("");
    gc_root(strlit7328);
  }
// compilenode returning strlit7328
    gc_frame_newslot(strlit7328);
    if7319 = strlit7328;
  }
stackframe = iftmpstackframe7319;
// compilenode returning if7319
  int op_slot_left_7314 = gc_frame_newslot(if7319);
  params[0] = call7317;
  partcv[0] = 1;
  Object opresult7329 = callmethod(if7319, "++", 1, partcv, params);
// compilenode returning opresult7329
  gc_frame_end(frame);
  return opresult7329;
}
Object meth_ast_toGrace7240(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1675
  setline(1675);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1674
  setline(1674);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7241 == NULL) {
    strlit7241 = alloc_String("");
    gc_root(strlit7241);
  }
// compilenode returning strlit7241
  *var_spc = strlit7241;
  if (strlit7241 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1675
  setline(1675);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7242 = gc_frame_new();
  Object num7245 = alloc_Float64(1);
// compilenode returning num7245
  int op_slot_right_7244 = gc_frame_newslot(num7245);
// compilenode returning *var_depth
  int op_slot_left_7244 = gc_frame_newslot(*var_depth);
  params[0] = num7245;
  partcv[0] = 1;
  Object diff7247 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff7247
  int op_slot_right_7243 = gc_frame_newslot(diff7247);
  Object num7249 = alloc_Float64(0);
// compilenode returning num7249
  int op_slot_left_7243 = gc_frame_newslot(num7249);
  params[0] = diff7247;
  partcv[0] = 1;
  Object opresult7250 = callmethod(num7249, "..", 1, partcv, params);
// compilenode returning opresult7250
  gc_frame_newslot(opresult7250);
  Object block7251 = alloc_Block(NULL, NULL, "ast", 1675);
  gc_frame_newslot(block7251);
  block_savedest(block7251);
  Object closure7252 = createclosure(2, "_apply");
setclosureframe(closure7252, stackframe);
  addtoclosure(closure7252, var_spc);
  addtoclosure(closure7252, selfslot);
  struct UserObject *uo7252 = (struct UserObject*)block7251;
  uo7252->data[0] = (Object)closure7252;
  Method *meth_meth_ast__apply7252 = addmethod2pos(block7251, "_apply", &meth_ast__apply7252, 0);
int argcv_meth_ast__apply7252[] = {1};
meth_meth_ast__apply7252->type = alloc_MethodType(1, argcv_meth_ast__apply7252);
  meth_meth_ast__apply7252->definitionModule = modulename;
  meth_meth_ast__apply7252->definitionLine = 1663;
// compilenode returning block7251
  gc_frame_newslot(block7251);
  params[0] = opresult7250;
  params[1] = block7251;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7259 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7242);
// compilenode returning call7259
// Begin line 1679
  setline(1679);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1678
  setline(1678);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7261 == NULL) {
    strlit7261 = alloc_String("");
    gc_root(strlit7261);
  }
// compilenode returning strlit7261
  int op_slot_right_7260 = gc_frame_newslot(strlit7261);
  int callframe7264 = gc_frame_new();
  Object num7265 = alloc_Float64(0);
// compilenode returning num7265
  gc_frame_newslot(num7265);
  int callframe7266 = gc_frame_new();
  partcv[0] = 0;
  Object call7267 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7266);
// compilenode returning call7267
// compilenode returning call7267
  params[0] = num7265;
  partcv[0] = 1;
  Object call7268 = callmethod(call7267, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7264);
// compilenode returning call7268
  int op_slot_right_7263 = gc_frame_newslot(call7268);
  if (strlit7270 == NULL) {
    strlit7270 = alloc_String("var ");
    gc_root(strlit7270);
  }
// compilenode returning strlit7270
  int op_slot_left_7263 = gc_frame_newslot(strlit7270);
  params[0] = call7268;
  partcv[0] = 1;
  Object opresult7271 = callmethod(strlit7270, "++", 1, partcv, params);
// compilenode returning opresult7271
  int op_slot_left_7260 = gc_frame_newslot(opresult7271);
  params[0] = strlit7261;
  partcv[0] = 1;
  Object opresult7272 = callmethod(opresult7271, "++", 1, partcv, params);
// compilenode returning opresult7272
  *var_s = opresult7272;
  if (opresult7272 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1682
  setline(1682);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1679
  setline(1679);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7275 == NULL) {
    strlit7275 = alloc_String("Unknown");
    gc_root(strlit7275);
  }
// compilenode returning strlit7275
  int op_slot_right_7274 = gc_frame_newslot(strlit7275);
  int callframe7277 = gc_frame_new();
  int callframe7278 = gc_frame_new();
  partcv[0] = 0;
  Object call7279 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7278);
// compilenode returning call7279
// compilenode returning call7279
  partcv[0] = 0;
  Object call7280 = callmethod(call7279, "value",
    1, partcv, params);
  gc_frame_end(callframe7277);
// compilenode returning call7280
// compilenode returning call7280
  int op_slot_left_7274 = gc_frame_newslot(call7280);
  params[0] = strlit7275;
  partcv[0] = 1;
  Object opresult7281 = callmethod(call7280, "!=", 1, partcv, params);
// compilenode returning opresult7281
  Object if7273 = done;
  if (istrue(opresult7281)) {
// Begin line 1680
  setline(1680);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7283 = gc_frame_new();
  Object num7284 = alloc_Float64(0);
// compilenode returning num7284
  gc_frame_newslot(num7284);
  int callframe7285 = gc_frame_new();
  partcv[0] = 0;
  Object call7286 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7285);
// compilenode returning call7286
// compilenode returning call7286
  params[0] = num7284;
  partcv[0] = 1;
  Object call7287 = callmethod(call7286, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7283);
// compilenode returning call7287
  int op_slot_right_7282 = gc_frame_newslot(call7287);
  if (strlit7290 == NULL) {
    strlit7290 = alloc_String(" : ");
    gc_root(strlit7290);
  }
// compilenode returning strlit7290
  int op_slot_right_7289 = gc_frame_newslot(strlit7290);
// compilenode returning *var_s
  int op_slot_left_7289 = gc_frame_newslot(*var_s);
  params[0] = strlit7290;
  partcv[0] = 1;
  Object opresult7292 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7292
  int op_slot_left_7282 = gc_frame_newslot(opresult7292);
  params[0] = call7287;
  partcv[0] = 1;
  Object opresult7293 = callmethod(opresult7292, "++", 1, partcv, params);
// compilenode returning opresult7293
  *var_s = opresult7293;
  if (opresult7293 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if7273 = done;
  } else {
  }
// compilenode returning if7273
// Begin line 1687
  setline(1687);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1682
  setline(1682);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num7297 = alloc_Float64(0);
// compilenode returning num7297
  int op_slot_right_7296 = gc_frame_newslot(num7297);
  int callframe7299 = gc_frame_new();
  int callframe7300 = gc_frame_new();
  partcv[0] = 0;
  Object call7301 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7300);
// compilenode returning call7301
// compilenode returning call7301
  partcv[0] = 0;
  Object call7302 = callmethod(call7301, "size",
    1, partcv, params);
  gc_frame_end(callframe7299);
// compilenode returning call7302
// compilenode returning call7302
  int op_slot_left_7296 = gc_frame_newslot(call7302);
  params[0] = num7297;
  partcv[0] = 1;
  Object opresult7303 = callmethod(call7302, ">", 1, partcv, params);
// compilenode returning opresult7303
  Object if7295 = done;
  if (istrue(opresult7303)) {
// Begin line 1684
  setline(1684);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1683
  setline(1683);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7305 == NULL) {
    strlit7305 = alloc_String(" is ");
    gc_root(strlit7305);
  }
// compilenode returning strlit7305
  int op_slot_right_7304 = gc_frame_newslot(strlit7305);
// compilenode returning *var_s
  int op_slot_left_7304 = gc_frame_newslot(*var_s);
  params[0] = strlit7305;
  partcv[0] = 1;
  Object opresult7307 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7307
  *var_s = opresult7307;
  if (opresult7307 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1684
  setline(1684);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7310 = gc_frame_new();
  if (strlit7311 == NULL) {
    strlit7311 = alloc_String("");
    gc_root(strlit7311);
  }
// compilenode returning strlit7311
  gc_frame_newslot(strlit7311);
  Object block7312 = alloc_Block(NULL, NULL, "ast", 1684);
  gc_frame_newslot(block7312);
  block_savedest(block7312);
  Object closure7313 = createclosure(1, "_apply");
setclosureframe(closure7313, stackframe);
  addtoclosure(closure7313, selfslot);
  struct UserObject *uo7313 = (struct UserObject*)block7312;
  uo7313->data[0] = (Object)closure7313;
  Method *meth_meth_ast__apply7313 = addmethod2pos(block7312, "_apply", &meth_ast__apply7313, 0);
int argcv_meth_ast__apply7313[] = {2};
meth_meth_ast__apply7313->type = alloc_MethodType(1, argcv_meth_ast__apply7313);
  meth_meth_ast__apply7313->definitionModule = modulename;
  meth_meth_ast__apply7313->definitionLine = 1682;
// compilenode returning block7312
  gc_frame_newslot(block7312);
// Begin line 1684
  setline(1684);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7331 = gc_frame_new();
  partcv[0] = 0;
  Object call7332 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7331);
// compilenode returning call7332
// compilenode returning call7332
  params[0] = strlit7311;
  params[1] = block7312;
  partcv[0] = 2;
  Object call7333 = callmethod(call7332, "reduce",
    1, partcv, params);
  gc_frame_end(callframe7310);
// compilenode returning call7333
  int op_slot_right_7309 = gc_frame_newslot(call7333);
// compilenode returning *var_s
  int op_slot_left_7309 = gc_frame_newslot(*var_s);
  params[0] = call7333;
  partcv[0] = 1;
  Object opresult7335 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7335
  *var_s = opresult7335;
  if (opresult7335 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if7295 = done;
  } else {
  }
// compilenode returning if7295
// Begin line 1690
  setline(1690);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1687
  setline(1687);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7339 = alloc_Boolean(0);
// compilenode returning bool7339
  int op_slot_right_7338 = gc_frame_newslot(bool7339);
  int callframe7341 = gc_frame_new();
  partcv[0] = 0;
  Object call7342 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7341);
// compilenode returning call7342
// compilenode returning call7342
  int op_slot_left_7338 = gc_frame_newslot(call7342);
  params[0] = bool7339;
  partcv[0] = 1;
  Object opresult7343 = callmethod(call7342, "!=", 1, partcv, params);
// compilenode returning opresult7343
  Object if7337 = done;
  if (istrue(opresult7343)) {
// Begin line 1688
  setline(1688);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7345 = gc_frame_new();
// compilenode returning *var_depth
  gc_frame_newslot(*var_depth);
  int callframe7346 = gc_frame_new();
  partcv[0] = 0;
  Object call7347 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7346);
// compilenode returning call7347
// compilenode returning call7347
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7348 = callmethod(call7347, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7345);
// compilenode returning call7348
  int op_slot_right_7344 = gc_frame_newslot(call7348);
  if (strlit7351 == NULL) {
    strlit7351 = alloc_String(" := ");
    gc_root(strlit7351);
  }
// compilenode returning strlit7351
  int op_slot_right_7350 = gc_frame_newslot(strlit7351);
// compilenode returning *var_s
  int op_slot_left_7350 = gc_frame_newslot(*var_s);
  params[0] = strlit7351;
  partcv[0] = 1;
  Object opresult7353 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7353
  int op_slot_left_7344 = gc_frame_newslot(opresult7353);
  params[0] = call7348;
  partcv[0] = 1;
  Object opresult7354 = callmethod(opresult7353, "++", 1, partcv, params);
// compilenode returning opresult7354
  *var_s = opresult7354;
  if (opresult7354 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if7337 = done;
  } else {
  }
// compilenode returning if7337
// Begin line 1690
  setline(1690);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new7022(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_varDecNode = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  Object *var_collections = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7023 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7023 = alloc_userobj2(13,13, objclass7023);
  gc_frame_newslot(obj7023);
if (objclass7023 == NULL) {
  glfree(obj7023->class->name);
  obj7023->class->name = "varDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7023, self, 0);
  addmethodreal(obj7023,"outer", &reader_ast_outer_7024);
  Object oldself7023 = self;
  struct StackFrameObject *oldstackframe7023 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7023);
  gc_frame_newslot((Object)stackframe);
  self = obj7023;
  Object *oldselfslot7023 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7023 = (*(struct UserObject *)self).data[0], lowerouter7023 = thisouter7023;
  if (inheritingObject7023) {
    struct UserObject *inho7023 = (struct UserObject *)inheritingObject7023;
    while (inho7023->super != GraceDefaultObject) inho7023 = (struct UserObject *)inho7023->super;
    inho7023->super = obj7023;
    self = inheritingObject7023;
    *selfslot = self;
    lowerouter7023 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7023;
  }
if (objclass7023 == NULL) {
  Method *reader7025 = addmethodrealflags(obj7023, "kind",&reader_ast_kind_7025, MFLAG_DEF);
  reader7025->definitionModule = modulename;
  reader7025->definitionLine = 1618;
}
adddatum2(obj7023, alloc_Undefined(), 1);
if (objclass7023 == NULL) {
  Method *reader7026 = addmethodrealflags(obj7023, "name",&reader_ast_name_7026, MFLAG_DEF);
  reader7026->definitionModule = modulename;
  reader7026->definitionLine = 1619;
}
adddatum2(obj7023, alloc_Undefined(), 2);
if (objclass7023 == NULL) {
  Method *reader7027 = addmethodrealflags(obj7023, "value",&reader_ast_value_7027, MFLAG_DEF);
  reader7027->definitionModule = modulename;
  reader7027->definitionLine = 1620;
}
adddatum2(obj7023, alloc_Undefined(), 3);
if (objclass7023 == NULL) {
  Method *reader7028 = addmethodrealflags(obj7023, "dtype",&reader_ast_dtype_7028, 0);
  Method *writer7028 = addmethodrealflags(obj7023, "dtype:=",&writer_ast_dtype_7028, 0);
  reader7028->definitionModule = modulename;
  writer7028->definitionModule = modulename;
  reader7028->definitionLine = 1621;
  writer7028->definitionLine = 1621;
}
obj7023->flags |= OFLAG_MUTABLE;
adddatum2(obj7023, alloc_Undefined(), 4);
if (objclass7023 == NULL) {
  Method *reader7029 = addmethodrealflags(obj7023, "annotations",&reader_ast_annotations_7029, MFLAG_DEF);
  reader7029->definitionModule = modulename;
  reader7029->definitionLine = 1622;
}
adddatum2(obj7023, alloc_Undefined(), 5);
  struct UserObject *uo7030 = (struct UserObject*)obj7023;
  uo7030->data[6] = emptyclosure;
  Method *meth_meth_ast_accept7030 = addmethod2pos(obj7023, "accept", &meth_ast_accept7030, 6);
int argcv_meth_ast_accept7030[] = {1};
meth_meth_ast_accept7030->type = alloc_MethodType(1, argcv_meth_ast_accept7030);
meth_meth_ast_accept7030->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept7030->type->names[0] = "visitor";
  meth_meth_ast_accept7030->definitionModule = modulename;
  meth_meth_ast_accept7030->definitionLine = 1622;
  block_savedest(obj7023);
  Object closure7060 = createclosure(1, "map()before()after");
setclosureframe(closure7060, stackframe);
  addtoclosure(closure7060, var_varDecNode);
  struct UserObject *uo7060 = (struct UserObject*)obj7023;
  uo7060->data[7] = (Object)closure7060;
  Method *meth_meth_ast_map_40__41_before_40__41_after7060 = addmethod2pos(obj7023, "map()before()after", &meth_ast_map_40__41_before_40__41_after7060, 7);
int argcv_meth_ast_map_40__41_before_40__41_after7060[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7060->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7060);
  meth_meth_ast_map_40__41_before_40__41_after7060->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7060->definitionLine = 1633;
  struct UserObject *uo7111 = (struct UserObject*)obj7023;
  uo7111->data[8] = emptyclosure;
  Method *meth_meth_ast_map7111 = addmethod2pos(obj7023, "map", &meth_ast_map7111, 8);
int argcv_meth_ast_map7111[] = {1};
meth_meth_ast_map7111->type = alloc_MethodType(1, argcv_meth_ast_map7111);
  meth_meth_ast_map7111->definitionModule = modulename;
  meth_meth_ast_map7111->definitionLine = 1646;
  struct UserObject *uo7120 = (struct UserObject*)obj7023;
  uo7120->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty7120 = addmethod2pos(obj7023, "pretty", &meth_ast_pretty7120, 9);
int argcv_meth_ast_pretty7120[] = {1};
meth_meth_ast_pretty7120->type = alloc_MethodType(1, argcv_meth_ast_pretty7120);
  meth_meth_ast_pretty7120->definitionModule = modulename;
  meth_meth_ast_pretty7120->definitionLine = 1649;
  block_savedest(obj7023);
  Object closure7226 = createclosure(1, "decType");
setclosureframe(closure7226, stackframe);
  addtoclosure(closure7226, var_identifierNode);
  struct UserObject *uo7226 = (struct UserObject*)obj7023;
  uo7226->data[10] = (Object)closure7226;
  Method *meth_meth_ast_decType7226 = addmethod2pos(obj7023, "decType", &meth_ast_decType7226, 10);
int argcv_meth_ast_decType7226[] = {0};
meth_meth_ast_decType7226->type = alloc_MethodType(1, argcv_meth_ast_decType7226);
  meth_meth_ast_decType7226->definitionModule = modulename;
  meth_meth_ast_decType7226->definitionLine = 1667;
  struct UserObject *uo7240 = (struct UserObject*)obj7023;
  uo7240->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace7240 = addmethod2pos(obj7023, "toGrace", &meth_ast_toGrace7240, 11);
int argcv_meth_ast_toGrace7240[] = {1};
meth_meth_ast_toGrace7240->type = alloc_MethodType(1, argcv_meth_ast_toGrace7240);
meth_meth_ast_toGrace7240->type->types[0] = type_Number;
meth_meth_ast_toGrace7240->type->names[0] = "depth";
  meth_meth_ast_toGrace7240->definitionModule = modulename;
  meth_meth_ast_toGrace7240->definitionLine = 1673;
  sourceObject = obj7023;
// Begin line 1616
  setline(1616);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7356 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7357 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7356);
// compilenode returning call7357
  struct UserObject *obj7023_uo = (struct UserObject *)obj7023;
  obj7023_uo->super = call7357;
  sourceObject = obj7023;
// Begin line 1617
  setline(1617);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7358 == NULL) {
    strlit7358 = alloc_String("vardec");
    gc_root(strlit7358);
  }
// compilenode returning strlit7358
  adddatum2(obj7023, strlit7358, 1);
  sourceObject = obj7023;
// Begin line 1618
  setline(1618);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name_39_
  adddatum2(obj7023, *var_name_39_, 2);
  sourceObject = obj7023;
// Begin line 1619
  setline(1619);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_val_39_
  adddatum2(obj7023, *var_val_39_, 3);
  sourceObject = obj7023;
// Begin line 1620
  setline(1620);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dtype_39_
  adddatum2(obj7023, *var_dtype_39_, 4);
  sourceObject = obj7023;
// Begin line 1621
  setline(1621);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7359 = gc_frame_new();
  int callframe7360 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call7361 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe7360);
// compilenode returning call7361
// compilenode returning call7361
  partcv[0] = 0;
  Object call7362 = callmethod(call7361, "new",
    1, partcv, params);
  gc_frame_end(callframe7359);
// compilenode returning call7362
// compilenode returning call7362
  adddatum2(obj7023, call7362, 5);
  sourceObject = obj7023;
  sourceObject = obj7023;
  sourceObject = obj7023;
  sourceObject = obj7023;
  sourceObject = obj7023;
  sourceObject = obj7023;
objclass7023 = obj7023->class;
  objclass7023->definitionModule = modulename;
  objclass7023->definitionLine = 1542;
  (*(struct UserObject *)self).data[0] = lowerouter7023;
  self = oldself7023;
  selfslot = oldselfslot7023;
  stackframe = oldstackframe7023;
  gc_frame_end(frame);
  return obj7023;
}
Object meth_ast_new7022_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_varDecNode = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  Object *var_collections = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7023 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7023 = alloc_userobj2(13,13, objclass7023);
  gc_frame_newslot(obj7023);
if (objclass7023 == NULL) {
  glfree(obj7023->class->name);
  obj7023->class->name = "varDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7023, self, 0);
  addmethodreal(obj7023,"outer", &reader_ast_outer_7024);
  Object oldself7023 = self;
  struct StackFrameObject *oldstackframe7023 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7023);
  gc_frame_newslot((Object)stackframe);
  self = obj7023;
  Object *oldselfslot7023 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7023 = (*(struct UserObject *)self).data[0], lowerouter7023 = thisouter7023;
  if (inheritingObject7023) {
    struct UserObject *inho7023 = (struct UserObject *)inheritingObject7023;
    while (inho7023->super != GraceDefaultObject) inho7023 = (struct UserObject *)inho7023->super;
    inho7023->super = obj7023;
    self = inheritingObject7023;
    *selfslot = self;
    lowerouter7023 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7023;
  }
if (objclass7023 == NULL) {
  Method *reader7025 = addmethodrealflags(obj7023, "kind",&reader_ast_kind_7025, MFLAG_DEF);
  reader7025->definitionModule = modulename;
  reader7025->definitionLine = 1618;
}
adddatum2(obj7023, alloc_Undefined(), 1);
if (objclass7023 == NULL) {
  Method *reader7026 = addmethodrealflags(obj7023, "name",&reader_ast_name_7026, MFLAG_DEF);
  reader7026->definitionModule = modulename;
  reader7026->definitionLine = 1619;
}
adddatum2(obj7023, alloc_Undefined(), 2);
if (objclass7023 == NULL) {
  Method *reader7027 = addmethodrealflags(obj7023, "value",&reader_ast_value_7027, MFLAG_DEF);
  reader7027->definitionModule = modulename;
  reader7027->definitionLine = 1620;
}
adddatum2(obj7023, alloc_Undefined(), 3);
if (objclass7023 == NULL) {
  Method *reader7028 = addmethodrealflags(obj7023, "dtype",&reader_ast_dtype_7028, 0);
  Method *writer7028 = addmethodrealflags(obj7023, "dtype:=",&writer_ast_dtype_7028, 0);
  reader7028->definitionModule = modulename;
  writer7028->definitionModule = modulename;
  reader7028->definitionLine = 1621;
  writer7028->definitionLine = 1621;
}
obj7023->flags |= OFLAG_MUTABLE;
adddatum2(obj7023, alloc_Undefined(), 4);
if (objclass7023 == NULL) {
  Method *reader7029 = addmethodrealflags(obj7023, "annotations",&reader_ast_annotations_7029, MFLAG_DEF);
  reader7029->definitionModule = modulename;
  reader7029->definitionLine = 1622;
}
adddatum2(obj7023, alloc_Undefined(), 5);
  struct UserObject *uo7030 = (struct UserObject*)obj7023;
  uo7030->data[6] = emptyclosure;
  Method *meth_meth_ast_accept7030 = addmethod2pos(obj7023, "accept", &meth_ast_accept7030, 6);
int argcv_meth_ast_accept7030[] = {1};
meth_meth_ast_accept7030->type = alloc_MethodType(1, argcv_meth_ast_accept7030);
meth_meth_ast_accept7030->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept7030->type->names[0] = "visitor";
  meth_meth_ast_accept7030->definitionModule = modulename;
  meth_meth_ast_accept7030->definitionLine = 1622;
  block_savedest(obj7023);
  Object closure7060 = createclosure(1, "map()before()after");
setclosureframe(closure7060, stackframe);
  addtoclosure(closure7060, var_varDecNode);
  struct UserObject *uo7060 = (struct UserObject*)obj7023;
  uo7060->data[7] = (Object)closure7060;
  Method *meth_meth_ast_map_40__41_before_40__41_after7060 = addmethod2pos(obj7023, "map()before()after", &meth_ast_map_40__41_before_40__41_after7060, 7);
int argcv_meth_ast_map_40__41_before_40__41_after7060[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7060->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7060);
  meth_meth_ast_map_40__41_before_40__41_after7060->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7060->definitionLine = 1633;
  struct UserObject *uo7111 = (struct UserObject*)obj7023;
  uo7111->data[8] = emptyclosure;
  Method *meth_meth_ast_map7111 = addmethod2pos(obj7023, "map", &meth_ast_map7111, 8);
int argcv_meth_ast_map7111[] = {1};
meth_meth_ast_map7111->type = alloc_MethodType(1, argcv_meth_ast_map7111);
  meth_meth_ast_map7111->definitionModule = modulename;
  meth_meth_ast_map7111->definitionLine = 1646;
  struct UserObject *uo7120 = (struct UserObject*)obj7023;
  uo7120->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty7120 = addmethod2pos(obj7023, "pretty", &meth_ast_pretty7120, 9);
int argcv_meth_ast_pretty7120[] = {1};
meth_meth_ast_pretty7120->type = alloc_MethodType(1, argcv_meth_ast_pretty7120);
  meth_meth_ast_pretty7120->definitionModule = modulename;
  meth_meth_ast_pretty7120->definitionLine = 1649;
  block_savedest(obj7023);
  Object closure7226 = createclosure(1, "decType");
setclosureframe(closure7226, stackframe);
  addtoclosure(closure7226, var_identifierNode);
  struct UserObject *uo7226 = (struct UserObject*)obj7023;
  uo7226->data[10] = (Object)closure7226;
  Method *meth_meth_ast_decType7226 = addmethod2pos(obj7023, "decType", &meth_ast_decType7226, 10);
int argcv_meth_ast_decType7226[] = {0};
meth_meth_ast_decType7226->type = alloc_MethodType(1, argcv_meth_ast_decType7226);
  meth_meth_ast_decType7226->definitionModule = modulename;
  meth_meth_ast_decType7226->definitionLine = 1667;
  struct UserObject *uo7240 = (struct UserObject*)obj7023;
  uo7240->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace7240 = addmethod2pos(obj7023, "toGrace", &meth_ast_toGrace7240, 11);
int argcv_meth_ast_toGrace7240[] = {1};
meth_meth_ast_toGrace7240->type = alloc_MethodType(1, argcv_meth_ast_toGrace7240);
meth_meth_ast_toGrace7240->type->types[0] = type_Number;
meth_meth_ast_toGrace7240->type->names[0] = "depth";
  meth_meth_ast_toGrace7240->definitionModule = modulename;
  meth_meth_ast_toGrace7240->definitionLine = 1673;
  sourceObject = obj7023;
// Begin line 1616
  setline(1616);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7356 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7357 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7356);
// compilenode returning call7357
  struct UserObject *obj7023_uo = (struct UserObject *)obj7023;
  obj7023_uo->super = call7357;
  sourceObject = obj7023;
// Begin line 1617
  setline(1617);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7358 == NULL) {
    strlit7358 = alloc_String("vardec");
    gc_root(strlit7358);
  }
// compilenode returning strlit7358
  adddatum2(obj7023, strlit7358, 1);
  sourceObject = obj7023;
// Begin line 1618
  setline(1618);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name_39_
  adddatum2(obj7023, *var_name_39_, 2);
  sourceObject = obj7023;
// Begin line 1619
  setline(1619);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_val_39_
  adddatum2(obj7023, *var_val_39_, 3);
  sourceObject = obj7023;
// Begin line 1620
  setline(1620);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dtype_39_
  adddatum2(obj7023, *var_dtype_39_, 4);
  sourceObject = obj7023;
// Begin line 1621
  setline(1621);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7359 = gc_frame_new();
  int callframe7360 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call7361 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe7360);
// compilenode returning call7361
// compilenode returning call7361
  partcv[0] = 0;
  Object call7362 = callmethod(call7361, "new",
    1, partcv, params);
  gc_frame_end(callframe7359);
// compilenode returning call7362
// compilenode returning call7362
  adddatum2(obj7023, call7362, 5);
  sourceObject = obj7023;
  sourceObject = obj7023;
  sourceObject = obj7023;
  sourceObject = obj7023;
  sourceObject = obj7023;
  sourceObject = obj7023;
objclass7023 = obj7023->class;
  objclass7023->definitionModule = modulename;
  objclass7023->definitionLine = 1542;
  (*(struct UserObject *)self).data[0] = lowerouter7023;
  self = oldself7023;
  selfslot = oldselfslot7023;
  stackframe = oldstackframe7023;
  gc_frame_end(frame);
  return obj7023;
}
Object meth_ast_importNode7364(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 34, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "importNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_importNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for importNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for importNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1693
  setline(1693);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_importNode
  gc_frame_end(frame);
  return *var_importNode;
}
Object meth_ast_accept7375(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1701
  setline(1701);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7376 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call7377 = callmethod(*var_visitor, "visitImport",
    1, partcv, params);
  gc_frame_end(callframe7376);
// compilenode returning call7377
  gc_frame_end(frame);
  return call7377;
}
Object meth_ast_map_40__41_before_40__41_after7378(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1704
  setline(1704);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7379 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call7380 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe7379);
// compilenode returning call7380
// Begin line 1705
  setline(1705);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7381 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blk
  params[0] = self;
  partcv[0] = 1;
  Object call7382 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7381);
// compilenode returning call7382
  *var_n = call7382;
  if (call7382 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1707
  setline(1707);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1621
  setline(1621);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7383 = gc_frame_new();
// Begin line 1706
  setline(1706);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7384 = gc_frame_new();
  partcv[0] = 0;
  Object call7385 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7384);
// compilenode returning call7385
  gc_frame_newslot(call7385);
// compilenode returning *var_n
  params[0] = call7385;
  partcv[0] = 1;
  Object call7386 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe7383);
// compilenode returning call7386
// compilenode returning done
// Begin line 1707
  setline(1707);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7387 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7388 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe7387);
// compilenode returning call7388
// Begin line 1708
  setline(1708);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply7392(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply7395(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map7389(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1711
  setline(1711);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7390 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block7391 = alloc_Block(NULL, NULL, "ast", 1711);
  gc_frame_newslot(block7391);
  block_savedest(block7391);
  Object closure7392 = createclosure(1, "_apply");
setclosureframe(closure7392, stackframe);
  addtoclosure(closure7392, selfslot);
  struct UserObject *uo7392 = (struct UserObject*)block7391;
  uo7392->data[0] = (Object)closure7392;
  Method *meth_meth_ast__apply7392 = addmethod2pos(block7391, "_apply", &meth_ast__apply7392, 0);
int argcv_meth_ast__apply7392[] = {0};
meth_meth_ast__apply7392->type = alloc_MethodType(1, argcv_meth_ast__apply7392);
  meth_meth_ast__apply7392->definitionModule = modulename;
  meth_meth_ast__apply7392->definitionLine = 1621;
// compilenode returning block7391
  gc_frame_newslot(block7391);
  Object block7394 = alloc_Block(NULL, NULL, "ast", 1711);
  gc_frame_newslot(block7394);
  block_savedest(block7394);
  Object closure7395 = createclosure(1, "_apply");
setclosureframe(closure7395, stackframe);
  addtoclosure(closure7395, selfslot);
  struct UserObject *uo7395 = (struct UserObject*)block7394;
  uo7395->data[0] = (Object)closure7395;
  Method *meth_meth_ast__apply7395 = addmethod2pos(block7394, "_apply", &meth_ast__apply7395, 0);
int argcv_meth_ast__apply7395[] = {0};
meth_meth_ast__apply7395->type = alloc_MethodType(1, argcv_meth_ast__apply7395);
  meth_meth_ast__apply7395->definitionModule = modulename;
  meth_meth_ast__apply7395->definitionLine = 1621;
// compilenode returning block7394
  gc_frame_newslot(block7394);
  params[0] = *var_blk;
  params[1] = block7391;
  params[2] = block7394;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7397 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7390);
// compilenode returning call7397
  gc_frame_end(frame);
  return call7397;
}
Object meth_ast__apply7406(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1717
  setline(1717);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1716
  setline(1716);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7408 == NULL) {
    strlit7408 = alloc_String("  ");
    gc_root(strlit7408);
  }
// compilenode returning strlit7408
  int op_slot_right_7407 = gc_frame_newslot(strlit7408);
// compilenode returning *var_spc
  int op_slot_left_7407 = gc_frame_newslot(*var_spc);
  params[0] = strlit7408;
  partcv[0] = 1;
  Object opresult7410 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult7410
  *var_spc = opresult7410;
  if (opresult7410 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty7398(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1715
  setline(1715);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1714
  setline(1714);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7399 == NULL) {
    strlit7399 = alloc_String("");
    gc_root(strlit7399);
  }
// compilenode returning strlit7399
  *var_spc = strlit7399;
  if (strlit7399 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1715
  setline(1715);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7400 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_7401 = gc_frame_newslot(*var_depth);
  Object num7403 = alloc_Float64(0);
// compilenode returning num7403
  int op_slot_left_7401 = gc_frame_newslot(num7403);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7404 = callmethod(num7403, "..", 1, partcv, params);
// compilenode returning opresult7404
  gc_frame_newslot(opresult7404);
  Object block7405 = alloc_Block(NULL, NULL, "ast", 1715);
  gc_frame_newslot(block7405);
  block_savedest(block7405);
  Object closure7406 = createclosure(2, "_apply");
setclosureframe(closure7406, stackframe);
  addtoclosure(closure7406, var_spc);
  addtoclosure(closure7406, selfslot);
  struct UserObject *uo7406 = (struct UserObject*)block7405;
  uo7406->data[0] = (Object)closure7406;
  Method *meth_meth_ast__apply7406 = addmethod2pos(block7405, "_apply", &meth_ast__apply7406, 0);
int argcv_meth_ast__apply7406[] = {1};
meth_meth_ast__apply7406->type = alloc_MethodType(1, argcv_meth_ast__apply7406);
  meth_meth_ast__apply7406->definitionModule = modulename;
  meth_meth_ast__apply7406->definitionLine = 1621;
// compilenode returning block7405
  gc_frame_newslot(block7405);
  params[0] = opresult7404;
  params[1] = block7405;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7413 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7400);
// compilenode returning call7413
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1718
  setline(1718);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7414 == NULL) {
    strlit7414 = alloc_String("Import");
    gc_root(strlit7414);
  }
// compilenode returning strlit7414
  *var_s = strlit7414;
  if (strlit7414 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7416 == NULL) {
    strlit7416 = alloc_String("""\x0a""");
    gc_root(strlit7416);
  }
// compilenode returning strlit7416
  int op_slot_right_7415 = gc_frame_newslot(strlit7416);
// compilenode returning *var_s
  int op_slot_left_7415 = gc_frame_newslot(*var_s);
  params[0] = strlit7416;
  partcv[0] = 1;
  Object opresult7418 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7418
  *var_s = opresult7418;
  if (opresult7418 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1721
  setline(1721);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7422 == NULL) {
    strlit7422 = alloc_String("""\x0a""");
    gc_root(strlit7422);
  }
// compilenode returning strlit7422
  int op_slot_right_7421 = gc_frame_newslot(strlit7422);
  int callframe7425 = gc_frame_new();
  partcv[0] = 0;
  Object call7426 = callmethodflags(self, "path", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7425);
// compilenode returning call7426
// compilenode returning call7426
  int op_slot_right_7424 = gc_frame_newslot(call7426);
  if (strlit7429 == NULL) {
    strlit7429 = alloc_String("Path: ");
    gc_root(strlit7429);
  }
// compilenode returning strlit7429
  int op_slot_right_7428 = gc_frame_newslot(strlit7429);
// compilenode returning *var_spc
  int op_slot_right_7431 = gc_frame_newslot(*var_spc);
  if (strlit7433 == NULL) {
    strlit7433 = alloc_String("");
    gc_root(strlit7433);
  }
// compilenode returning strlit7433
  int op_slot_left_7431 = gc_frame_newslot(strlit7433);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7434 = callmethod(strlit7433, "++", 1, partcv, params);
// compilenode returning opresult7434
  int op_slot_left_7428 = gc_frame_newslot(opresult7434);
  params[0] = strlit7429;
  partcv[0] = 1;
  Object opresult7435 = callmethod(opresult7434, "++", 1, partcv, params);
// compilenode returning opresult7435
  int op_slot_left_7424 = gc_frame_newslot(opresult7435);
  params[0] = call7426;
  partcv[0] = 1;
  Object opresult7436 = callmethod(opresult7435, "++", 1, partcv, params);
// compilenode returning opresult7436
  int op_slot_left_7421 = gc_frame_newslot(opresult7436);
  params[0] = strlit7422;
  partcv[0] = 1;
  Object opresult7437 = callmethod(opresult7436, "++", 1, partcv, params);
// compilenode returning opresult7437
  int op_slot_right_7420 = gc_frame_newslot(opresult7437);
// compilenode returning *var_s
  int op_slot_left_7420 = gc_frame_newslot(*var_s);
  params[0] = opresult7437;
  partcv[0] = 1;
  Object opresult7439 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7439
  *var_s = opresult7439;
  if (opresult7439 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1722
  setline(1722);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1721
  setline(1721);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7443 == NULL) {
    strlit7443 = alloc_String("""\x0a""");
    gc_root(strlit7443);
  }
// compilenode returning strlit7443
  int op_slot_right_7442 = gc_frame_newslot(strlit7443);
  int callframe7446 = gc_frame_new();
  partcv[0] = 0;
  Object call7447 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7446);
// compilenode returning call7447
// compilenode returning call7447
  int op_slot_right_7445 = gc_frame_newslot(call7447);
  if (strlit7450 == NULL) {
    strlit7450 = alloc_String("Identifier: ");
    gc_root(strlit7450);
  }
// compilenode returning strlit7450
  int op_slot_right_7449 = gc_frame_newslot(strlit7450);
// compilenode returning *var_spc
  int op_slot_right_7452 = gc_frame_newslot(*var_spc);
  if (strlit7454 == NULL) {
    strlit7454 = alloc_String("");
    gc_root(strlit7454);
  }
// compilenode returning strlit7454
  int op_slot_left_7452 = gc_frame_newslot(strlit7454);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7455 = callmethod(strlit7454, "++", 1, partcv, params);
// compilenode returning opresult7455
  int op_slot_left_7449 = gc_frame_newslot(opresult7455);
  params[0] = strlit7450;
  partcv[0] = 1;
  Object opresult7456 = callmethod(opresult7455, "++", 1, partcv, params);
// compilenode returning opresult7456
  int op_slot_left_7445 = gc_frame_newslot(opresult7456);
  params[0] = call7447;
  partcv[0] = 1;
  Object opresult7457 = callmethod(opresult7456, "++", 1, partcv, params);
// compilenode returning opresult7457
  int op_slot_left_7442 = gc_frame_newslot(opresult7457);
  params[0] = strlit7443;
  partcv[0] = 1;
  Object opresult7458 = callmethod(opresult7457, "++", 1, partcv, params);
// compilenode returning opresult7458
  int op_slot_right_7441 = gc_frame_newslot(opresult7458);
// compilenode returning *var_s
  int op_slot_left_7441 = gc_frame_newslot(*var_s);
  params[0] = opresult7458;
  partcv[0] = 1;
  Object opresult7460 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7460
  *var_s = opresult7460;
  if (opresult7460 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1722
  setline(1722);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace7462(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1725
  setline(1725);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7464 == NULL) {
    strlit7464 = alloc_String("");
    gc_root(strlit7464);
  }
// compilenode returning strlit7464
  int op_slot_right_7463 = gc_frame_newslot(strlit7464);
  int callframe7467 = gc_frame_new();
  partcv[0] = 0;
  Object call7468 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7467);
// compilenode returning call7468
// compilenode returning call7468
  int op_slot_right_7466 = gc_frame_newslot(call7468);
  if (strlit7471 == NULL) {
    strlit7471 = alloc_String("""\x22"" as ");
    gc_root(strlit7471);
  }
// compilenode returning strlit7471
  int op_slot_right_7470 = gc_frame_newslot(strlit7471);
  int callframe7474 = gc_frame_new();
  partcv[0] = 0;
  Object call7475 = callmethodflags(self, "path", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7474);
// compilenode returning call7475
// compilenode returning call7475
  int op_slot_right_7473 = gc_frame_newslot(call7475);
  if (strlit7477 == NULL) {
    strlit7477 = alloc_String("import ""\x22""");
    gc_root(strlit7477);
  }
// compilenode returning strlit7477
  int op_slot_left_7473 = gc_frame_newslot(strlit7477);
  params[0] = call7475;
  partcv[0] = 1;
  Object opresult7478 = callmethod(strlit7477, "++", 1, partcv, params);
// compilenode returning opresult7478
  int op_slot_left_7470 = gc_frame_newslot(opresult7478);
  params[0] = strlit7471;
  partcv[0] = 1;
  Object opresult7479 = callmethod(opresult7478, "++", 1, partcv, params);
// compilenode returning opresult7479
  int op_slot_left_7466 = gc_frame_newslot(opresult7479);
  params[0] = call7468;
  partcv[0] = 1;
  Object opresult7480 = callmethod(opresult7479, "++", 1, partcv, params);
// compilenode returning opresult7480
  int op_slot_left_7463 = gc_frame_newslot(opresult7480);
  params[0] = strlit7464;
  partcv[0] = 1;
  Object opresult7481 = callmethod(opresult7480, "++", 1, partcv, params);
// compilenode returning opresult7481
  gc_frame_end(frame);
  return opresult7481;
}
Object meth_ast_new7367(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  Object *var_name = &(stackframe->slots[1]);
  *var_name = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7368 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7368 = alloc_userobj2(12,12, objclass7368);
  gc_frame_newslot(obj7368);
if (objclass7368 == NULL) {
  glfree(obj7368->class->name);
  obj7368->class->name = "importNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7368, self, 0);
  addmethodreal(obj7368,"outer", &reader_ast_outer_7369);
  Object oldself7368 = self;
  struct StackFrameObject *oldstackframe7368 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7368);
  gc_frame_newslot((Object)stackframe);
  self = obj7368;
  Object *oldselfslot7368 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7368 = (*(struct UserObject *)self).data[0], lowerouter7368 = thisouter7368;
  if (inheritingObject7368) {
    struct UserObject *inho7368 = (struct UserObject *)inheritingObject7368;
    while (inho7368->super != GraceDefaultObject) inho7368 = (struct UserObject *)inho7368->super;
    inho7368->super = obj7368;
    self = inheritingObject7368;
    *selfslot = self;
    lowerouter7368 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7368;
  }
if (objclass7368 == NULL) {
  Method *reader7370 = addmethodrealflags(obj7368, "kind",&reader_ast_kind_7370, MFLAG_DEF);
  reader7370->definitionModule = modulename;
  reader7370->definitionLine = 1696;
}
adddatum2(obj7368, alloc_Undefined(), 1);
if (objclass7368 == NULL) {
  Method *reader7371 = addmethodrealflags(obj7368, "value",&reader_ast_value_7371, MFLAG_DEF);
  reader7371->definitionModule = modulename;
  reader7371->definitionLine = 1697;
}
adddatum2(obj7368, alloc_Undefined(), 2);
if (objclass7368 == NULL) {
  Method *reader7372 = addmethodrealflags(obj7368, "path",&reader_ast_path_7372, MFLAG_DEF);
  reader7372->definitionModule = modulename;
  reader7372->definitionLine = 1698;
}
adddatum2(obj7368, alloc_Undefined(), 3);
if (objclass7368 == NULL) {
  Method *reader7373 = addmethodrealflags(obj7368, "dtype",&reader_ast_dtype_7373, 0);
  Method *writer7373 = addmethodrealflags(obj7368, "dtype:=",&writer_ast_dtype_7373, 0);
  reader7373->definitionModule = modulename;
  writer7373->definitionModule = modulename;
  reader7373->definitionLine = 1699;
  writer7373->definitionLine = 1699;
}
obj7368->flags |= OFLAG_MUTABLE;
adddatum2(obj7368, alloc_Undefined(), 4);
if (objclass7368 == NULL) {
  Method *reader7374 = addmethodrealflags(obj7368, "linePos",&reader_ast_linePos_7374, MFLAG_DEF);
  reader7374->definitionModule = modulename;
  reader7374->definitionLine = 1700;
}
adddatum2(obj7368, alloc_Undefined(), 5);
  struct UserObject *uo7375 = (struct UserObject*)obj7368;
  uo7375->data[6] = emptyclosure;
  Method *meth_meth_ast_accept7375 = addmethod2pos(obj7368, "accept", &meth_ast_accept7375, 6);
int argcv_meth_ast_accept7375[] = {1};
meth_meth_ast_accept7375->type = alloc_MethodType(1, argcv_meth_ast_accept7375);
meth_meth_ast_accept7375->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept7375->type->names[0] = "visitor";
  meth_meth_ast_accept7375->definitionModule = modulename;
  meth_meth_ast_accept7375->definitionLine = 1700;
  struct UserObject *uo7378 = (struct UserObject*)obj7368;
  uo7378->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_before_40__41_after7378 = addmethod2pos(obj7368, "map()before()after", &meth_ast_map_40__41_before_40__41_after7378, 7);
int argcv_meth_ast_map_40__41_before_40__41_after7378[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7378->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7378);
  meth_meth_ast_map_40__41_before_40__41_after7378->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7378->definitionLine = 1703;
  struct UserObject *uo7389 = (struct UserObject*)obj7368;
  uo7389->data[8] = emptyclosure;
  Method *meth_meth_ast_map7389 = addmethod2pos(obj7368, "map", &meth_ast_map7389, 8);
int argcv_meth_ast_map7389[] = {1};
meth_meth_ast_map7389->type = alloc_MethodType(1, argcv_meth_ast_map7389);
  meth_meth_ast_map7389->definitionModule = modulename;
  meth_meth_ast_map7389->definitionLine = 1710;
  struct UserObject *uo7398 = (struct UserObject*)obj7368;
  uo7398->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty7398 = addmethod2pos(obj7368, "pretty", &meth_ast_pretty7398, 9);
int argcv_meth_ast_pretty7398[] = {1};
meth_meth_ast_pretty7398->type = alloc_MethodType(1, argcv_meth_ast_pretty7398);
  meth_meth_ast_pretty7398->definitionModule = modulename;
  meth_meth_ast_pretty7398->definitionLine = 1713;
  struct UserObject *uo7462 = (struct UserObject*)obj7368;
  uo7462->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace7462 = addmethod2pos(obj7368, "toGrace", &meth_ast_toGrace7462, 10);
int argcv_meth_ast_toGrace7462[] = {1};
meth_meth_ast_toGrace7462->type = alloc_MethodType(1, argcv_meth_ast_toGrace7462);
meth_meth_ast_toGrace7462->type->types[0] = type_Number;
meth_meth_ast_toGrace7462->type->names[0] = "depth";
  meth_meth_ast_toGrace7462->definitionModule = modulename;
  meth_meth_ast_toGrace7462->definitionLine = 1724;
  sourceObject = obj7368;
// Begin line 1694
  setline(1694);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7482 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7483 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7482);
// compilenode returning call7483
  struct UserObject *obj7368_uo = (struct UserObject *)obj7368;
  obj7368_uo->super = call7483;
  sourceObject = obj7368;
// Begin line 1695
  setline(1695);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7484 == NULL) {
    strlit7484 = alloc_String("import");
    gc_root(strlit7484);
  }
// compilenode returning strlit7484
  adddatum2(obj7368, strlit7484, 1);
  sourceObject = obj7368;
// Begin line 1696
  setline(1696);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name
  adddatum2(obj7368, *var_name, 2);
  sourceObject = obj7368;
// Begin line 1697
  setline(1697);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_path_39_
  adddatum2(obj7368, *var_path_39_, 3);
  sourceObject = obj7368;
// Begin line 1698
  setline(1698);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7485 = alloc_Boolean(0);
// compilenode returning bool7485
  adddatum2(obj7368, bool7485, 4);
  sourceObject = obj7368;
// Begin line 1699
  setline(1699);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num7486 = alloc_Float64(1);
// compilenode returning num7486
  adddatum2(obj7368, num7486, 5);
  sourceObject = obj7368;
  sourceObject = obj7368;
  sourceObject = obj7368;
  sourceObject = obj7368;
  sourceObject = obj7368;
objclass7368 = obj7368->class;
  objclass7368->definitionModule = modulename;
  objclass7368->definitionLine = 1621;
  (*(struct UserObject *)self).data[0] = lowerouter7368;
  self = oldself7368;
  selfslot = oldselfslot7368;
  stackframe = oldstackframe7368;
  gc_frame_end(frame);
  return obj7368;
}
Object meth_ast_new7367_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  Object *var_name = &(stackframe->slots[1]);
  *var_name = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7368 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7368 = alloc_userobj2(12,12, objclass7368);
  gc_frame_newslot(obj7368);
if (objclass7368 == NULL) {
  glfree(obj7368->class->name);
  obj7368->class->name = "importNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7368, self, 0);
  addmethodreal(obj7368,"outer", &reader_ast_outer_7369);
  Object oldself7368 = self;
  struct StackFrameObject *oldstackframe7368 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7368);
  gc_frame_newslot((Object)stackframe);
  self = obj7368;
  Object *oldselfslot7368 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7368 = (*(struct UserObject *)self).data[0], lowerouter7368 = thisouter7368;
  if (inheritingObject7368) {
    struct UserObject *inho7368 = (struct UserObject *)inheritingObject7368;
    while (inho7368->super != GraceDefaultObject) inho7368 = (struct UserObject *)inho7368->super;
    inho7368->super = obj7368;
    self = inheritingObject7368;
    *selfslot = self;
    lowerouter7368 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7368;
  }
if (objclass7368 == NULL) {
  Method *reader7370 = addmethodrealflags(obj7368, "kind",&reader_ast_kind_7370, MFLAG_DEF);
  reader7370->definitionModule = modulename;
  reader7370->definitionLine = 1696;
}
adddatum2(obj7368, alloc_Undefined(), 1);
if (objclass7368 == NULL) {
  Method *reader7371 = addmethodrealflags(obj7368, "value",&reader_ast_value_7371, MFLAG_DEF);
  reader7371->definitionModule = modulename;
  reader7371->definitionLine = 1697;
}
adddatum2(obj7368, alloc_Undefined(), 2);
if (objclass7368 == NULL) {
  Method *reader7372 = addmethodrealflags(obj7368, "path",&reader_ast_path_7372, MFLAG_DEF);
  reader7372->definitionModule = modulename;
  reader7372->definitionLine = 1698;
}
adddatum2(obj7368, alloc_Undefined(), 3);
if (objclass7368 == NULL) {
  Method *reader7373 = addmethodrealflags(obj7368, "dtype",&reader_ast_dtype_7373, 0);
  Method *writer7373 = addmethodrealflags(obj7368, "dtype:=",&writer_ast_dtype_7373, 0);
  reader7373->definitionModule = modulename;
  writer7373->definitionModule = modulename;
  reader7373->definitionLine = 1699;
  writer7373->definitionLine = 1699;
}
obj7368->flags |= OFLAG_MUTABLE;
adddatum2(obj7368, alloc_Undefined(), 4);
if (objclass7368 == NULL) {
  Method *reader7374 = addmethodrealflags(obj7368, "linePos",&reader_ast_linePos_7374, MFLAG_DEF);
  reader7374->definitionModule = modulename;
  reader7374->definitionLine = 1700;
}
adddatum2(obj7368, alloc_Undefined(), 5);
  struct UserObject *uo7375 = (struct UserObject*)obj7368;
  uo7375->data[6] = emptyclosure;
  Method *meth_meth_ast_accept7375 = addmethod2pos(obj7368, "accept", &meth_ast_accept7375, 6);
int argcv_meth_ast_accept7375[] = {1};
meth_meth_ast_accept7375->type = alloc_MethodType(1, argcv_meth_ast_accept7375);
meth_meth_ast_accept7375->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept7375->type->names[0] = "visitor";
  meth_meth_ast_accept7375->definitionModule = modulename;
  meth_meth_ast_accept7375->definitionLine = 1700;
  struct UserObject *uo7378 = (struct UserObject*)obj7368;
  uo7378->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_before_40__41_after7378 = addmethod2pos(obj7368, "map()before()after", &meth_ast_map_40__41_before_40__41_after7378, 7);
int argcv_meth_ast_map_40__41_before_40__41_after7378[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7378->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7378);
  meth_meth_ast_map_40__41_before_40__41_after7378->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7378->definitionLine = 1703;
  struct UserObject *uo7389 = (struct UserObject*)obj7368;
  uo7389->data[8] = emptyclosure;
  Method *meth_meth_ast_map7389 = addmethod2pos(obj7368, "map", &meth_ast_map7389, 8);
int argcv_meth_ast_map7389[] = {1};
meth_meth_ast_map7389->type = alloc_MethodType(1, argcv_meth_ast_map7389);
  meth_meth_ast_map7389->definitionModule = modulename;
  meth_meth_ast_map7389->definitionLine = 1710;
  struct UserObject *uo7398 = (struct UserObject*)obj7368;
  uo7398->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty7398 = addmethod2pos(obj7368, "pretty", &meth_ast_pretty7398, 9);
int argcv_meth_ast_pretty7398[] = {1};
meth_meth_ast_pretty7398->type = alloc_MethodType(1, argcv_meth_ast_pretty7398);
  meth_meth_ast_pretty7398->definitionModule = modulename;
  meth_meth_ast_pretty7398->definitionLine = 1713;
  struct UserObject *uo7462 = (struct UserObject*)obj7368;
  uo7462->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace7462 = addmethod2pos(obj7368, "toGrace", &meth_ast_toGrace7462, 10);
int argcv_meth_ast_toGrace7462[] = {1};
meth_meth_ast_toGrace7462->type = alloc_MethodType(1, argcv_meth_ast_toGrace7462);
meth_meth_ast_toGrace7462->type->types[0] = type_Number;
meth_meth_ast_toGrace7462->type->names[0] = "depth";
  meth_meth_ast_toGrace7462->definitionModule = modulename;
  meth_meth_ast_toGrace7462->definitionLine = 1724;
  sourceObject = obj7368;
// Begin line 1694
  setline(1694);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7482 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7483 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7482);
// compilenode returning call7483
  struct UserObject *obj7368_uo = (struct UserObject *)obj7368;
  obj7368_uo->super = call7483;
  sourceObject = obj7368;
// Begin line 1695
  setline(1695);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7484 == NULL) {
    strlit7484 = alloc_String("import");
    gc_root(strlit7484);
  }
// compilenode returning strlit7484
  adddatum2(obj7368, strlit7484, 1);
  sourceObject = obj7368;
// Begin line 1696
  setline(1696);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name
  adddatum2(obj7368, *var_name, 2);
  sourceObject = obj7368;
// Begin line 1697
  setline(1697);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_path_39_
  adddatum2(obj7368, *var_path_39_, 3);
  sourceObject = obj7368;
// Begin line 1698
  setline(1698);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7485 = alloc_Boolean(0);
// compilenode returning bool7485
  adddatum2(obj7368, bool7485, 4);
  sourceObject = obj7368;
// Begin line 1699
  setline(1699);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num7486 = alloc_Float64(1);
// compilenode returning num7486
  adddatum2(obj7368, num7486, 5);
  sourceObject = obj7368;
  sourceObject = obj7368;
  sourceObject = obj7368;
  sourceObject = obj7368;
  sourceObject = obj7368;
objclass7368 = obj7368->class;
  objclass7368->definitionModule = modulename;
  objclass7368->definitionLine = 1621;
  (*(struct UserObject *)self).data[0] = lowerouter7368;
  self = oldself7368;
  selfslot = oldselfslot7368;
  stackframe = oldstackframe7368;
  gc_frame_end(frame);
  return obj7368;
}
Object meth_ast_dialectNode7488(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 35, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dialectNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_dialectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for dialectNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for dialectNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1728
  setline(1728);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dialectNode
  gc_frame_end(frame);
  return *var_dialectNode;
}
Object meth_ast_accept7496(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1733
  setline(1733);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7497 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call7498 = callmethod(*var_visitor, "visitDialect",
    1, partcv, params);
  gc_frame_end(callframe7497);
// compilenode returning call7498
  gc_frame_end(frame);
  return call7498;
}
Object meth_ast_map_40__41_before_40__41_after7499(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1736
  setline(1736);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7500 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call7501 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe7500);
// compilenode returning call7501
// Begin line 1737
  setline(1737);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7502 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blk
  params[0] = self;
  partcv[0] = 1;
  Object call7503 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7502);
// compilenode returning call7503
  *var_n = call7503;
  if (call7503 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1725
  setline(1725);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7504 = gc_frame_new();
// Begin line 1738
  setline(1738);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7505 = gc_frame_new();
  partcv[0] = 0;
  Object call7506 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7505);
// compilenode returning call7506
  gc_frame_newslot(call7506);
// compilenode returning *var_n
  params[0] = call7506;
  partcv[0] = 1;
  Object call7507 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe7504);
// compilenode returning call7507
// compilenode returning done
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7508 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7509 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe7508);
// compilenode returning call7509
// Begin line 1740
  setline(1740);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply7513(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply7516(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map7510(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1743
  setline(1743);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7511 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block7512 = alloc_Block(NULL, NULL, "ast", 1743);
  gc_frame_newslot(block7512);
  block_savedest(block7512);
  Object closure7513 = createclosure(1, "_apply");
setclosureframe(closure7513, stackframe);
  addtoclosure(closure7513, selfslot);
  struct UserObject *uo7513 = (struct UserObject*)block7512;
  uo7513->data[0] = (Object)closure7513;
  Method *meth_meth_ast__apply7513 = addmethod2pos(block7512, "_apply", &meth_ast__apply7513, 0);
int argcv_meth_ast__apply7513[] = {0};
meth_meth_ast__apply7513->type = alloc_MethodType(1, argcv_meth_ast__apply7513);
  meth_meth_ast__apply7513->definitionModule = modulename;
  meth_meth_ast__apply7513->definitionLine = 1725;
// compilenode returning block7512
  gc_frame_newslot(block7512);
  Object block7515 = alloc_Block(NULL, NULL, "ast", 1743);
  gc_frame_newslot(block7515);
  block_savedest(block7515);
  Object closure7516 = createclosure(1, "_apply");
setclosureframe(closure7516, stackframe);
  addtoclosure(closure7516, selfslot);
  struct UserObject *uo7516 = (struct UserObject*)block7515;
  uo7516->data[0] = (Object)closure7516;
  Method *meth_meth_ast__apply7516 = addmethod2pos(block7515, "_apply", &meth_ast__apply7516, 0);
int argcv_meth_ast__apply7516[] = {0};
meth_meth_ast__apply7516->type = alloc_MethodType(1, argcv_meth_ast__apply7516);
  meth_meth_ast__apply7516->definitionModule = modulename;
  meth_meth_ast__apply7516->definitionLine = 1725;
// compilenode returning block7515
  gc_frame_newslot(block7515);
  params[0] = *var_blk;
  params[1] = block7512;
  params[2] = block7515;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7518 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7511);
// compilenode returning call7518
  gc_frame_end(frame);
  return call7518;
}
Object meth_ast__apply7527(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1749
  setline(1749);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1748
  setline(1748);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7529 == NULL) {
    strlit7529 = alloc_String("  ");
    gc_root(strlit7529);
  }
// compilenode returning strlit7529
  int op_slot_right_7528 = gc_frame_newslot(strlit7529);
// compilenode returning *var_spc
  int op_slot_left_7528 = gc_frame_newslot(*var_spc);
  params[0] = strlit7529;
  partcv[0] = 1;
  Object opresult7531 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult7531
  *var_spc = opresult7531;
  if (opresult7531 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty7519(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1747
  setline(1747);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1746
  setline(1746);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7520 == NULL) {
    strlit7520 = alloc_String("");
    gc_root(strlit7520);
  }
// compilenode returning strlit7520
  *var_spc = strlit7520;
  if (strlit7520 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1747
  setline(1747);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7521 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_7522 = gc_frame_newslot(*var_depth);
  Object num7524 = alloc_Float64(0);
// compilenode returning num7524
  int op_slot_left_7522 = gc_frame_newslot(num7524);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7525 = callmethod(num7524, "..", 1, partcv, params);
// compilenode returning opresult7525
  gc_frame_newslot(opresult7525);
  Object block7526 = alloc_Block(NULL, NULL, "ast", 1747);
  gc_frame_newslot(block7526);
  block_savedest(block7526);
  Object closure7527 = createclosure(2, "_apply");
setclosureframe(closure7527, stackframe);
  addtoclosure(closure7527, var_spc);
  addtoclosure(closure7527, selfslot);
  struct UserObject *uo7527 = (struct UserObject*)block7526;
  uo7527->data[0] = (Object)closure7527;
  Method *meth_meth_ast__apply7527 = addmethod2pos(block7526, "_apply", &meth_ast__apply7527, 0);
int argcv_meth_ast__apply7527[] = {1};
meth_meth_ast__apply7527->type = alloc_MethodType(1, argcv_meth_ast__apply7527);
  meth_meth_ast__apply7527->definitionModule = modulename;
  meth_meth_ast__apply7527->definitionLine = 1725;
// compilenode returning block7526
  gc_frame_newslot(block7526);
  params[0] = opresult7525;
  params[1] = block7526;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7534 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7521);
// compilenode returning call7534
// Begin line 1751
  setline(1751);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1750
  setline(1750);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7535 == NULL) {
    strlit7535 = alloc_String("Dialect");
    gc_root(strlit7535);
  }
// compilenode returning strlit7535
  *var_s = strlit7535;
  if (strlit7535 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1752
  setline(1752);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1751
  setline(1751);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7537 == NULL) {
    strlit7537 = alloc_String("""\x0a""");
    gc_root(strlit7537);
  }
// compilenode returning strlit7537
  int op_slot_right_7536 = gc_frame_newslot(strlit7537);
// compilenode returning *var_s
  int op_slot_left_7536 = gc_frame_newslot(*var_s);
  params[0] = strlit7537;
  partcv[0] = 1;
  Object opresult7539 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7539
  *var_s = opresult7539;
  if (opresult7539 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1753
  setline(1753);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1752
  setline(1752);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7543 == NULL) {
    strlit7543 = alloc_String("""\x0a""");
    gc_root(strlit7543);
  }
// compilenode returning strlit7543
  int op_slot_right_7542 = gc_frame_newslot(strlit7543);
  int callframe7546 = gc_frame_new();
  partcv[0] = 0;
  Object call7547 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7546);
// compilenode returning call7547
// compilenode returning call7547
  int op_slot_right_7545 = gc_frame_newslot(call7547);
  if (strlit7550 == NULL) {
    strlit7550 = alloc_String("Path: ");
    gc_root(strlit7550);
  }
// compilenode returning strlit7550
  int op_slot_right_7549 = gc_frame_newslot(strlit7550);
// compilenode returning *var_spc
  int op_slot_right_7552 = gc_frame_newslot(*var_spc);
  if (strlit7554 == NULL) {
    strlit7554 = alloc_String("");
    gc_root(strlit7554);
  }
// compilenode returning strlit7554
  int op_slot_left_7552 = gc_frame_newslot(strlit7554);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7555 = callmethod(strlit7554, "++", 1, partcv, params);
// compilenode returning opresult7555
  int op_slot_left_7549 = gc_frame_newslot(opresult7555);
  params[0] = strlit7550;
  partcv[0] = 1;
  Object opresult7556 = callmethod(opresult7555, "++", 1, partcv, params);
// compilenode returning opresult7556
  int op_slot_left_7545 = gc_frame_newslot(opresult7556);
  params[0] = call7547;
  partcv[0] = 1;
  Object opresult7557 = callmethod(opresult7556, "++", 1, partcv, params);
// compilenode returning opresult7557
  int op_slot_left_7542 = gc_frame_newslot(opresult7557);
  params[0] = strlit7543;
  partcv[0] = 1;
  Object opresult7558 = callmethod(opresult7557, "++", 1, partcv, params);
// compilenode returning opresult7558
  int op_slot_right_7541 = gc_frame_newslot(opresult7558);
// compilenode returning *var_s
  int op_slot_left_7541 = gc_frame_newslot(*var_s);
  params[0] = opresult7558;
  partcv[0] = 1;
  Object opresult7560 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7560
  *var_s = opresult7560;
  if (opresult7560 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1753
  setline(1753);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace7562(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1756
  setline(1756);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7564 == NULL) {
    strlit7564 = alloc_String("""\x22""");
    gc_root(strlit7564);
  }
// compilenode returning strlit7564
  int op_slot_right_7563 = gc_frame_newslot(strlit7564);
  int callframe7567 = gc_frame_new();
  partcv[0] = 0;
  Object call7568 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7567);
// compilenode returning call7568
// compilenode returning call7568
  int op_slot_right_7566 = gc_frame_newslot(call7568);
  if (strlit7570 == NULL) {
    strlit7570 = alloc_String("dialect ""\x22""");
    gc_root(strlit7570);
  }
// compilenode returning strlit7570
  int op_slot_left_7566 = gc_frame_newslot(strlit7570);
  params[0] = call7568;
  partcv[0] = 1;
  Object opresult7571 = callmethod(strlit7570, "++", 1, partcv, params);
// compilenode returning opresult7571
  int op_slot_left_7563 = gc_frame_newslot(opresult7571);
  params[0] = strlit7564;
  partcv[0] = 1;
  Object opresult7572 = callmethod(opresult7571, "++", 1, partcv, params);
// compilenode returning opresult7572
  gc_frame_end(frame);
  return opresult7572;
}
Object meth_ast_new7491(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7492 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7492 = alloc_userobj2(8,9, objclass7492);
  gc_frame_newslot(obj7492);
if (objclass7492 == NULL) {
  glfree(obj7492->class->name);
  obj7492->class->name = "dialectNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7492, self, 0);
  addmethodreal(obj7492,"outer", &reader_ast_outer_7493);
  Object oldself7492 = self;
  struct StackFrameObject *oldstackframe7492 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7492);
  gc_frame_newslot((Object)stackframe);
  self = obj7492;
  Object *oldselfslot7492 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7492 = (*(struct UserObject *)self).data[0], lowerouter7492 = thisouter7492;
  if (inheritingObject7492) {
    struct UserObject *inho7492 = (struct UserObject *)inheritingObject7492;
    while (inho7492->super != GraceDefaultObject) inho7492 = (struct UserObject *)inho7492->super;
    inho7492->super = obj7492;
    self = inheritingObject7492;
    *selfslot = self;
    lowerouter7492 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7492;
  }
if (objclass7492 == NULL) {
  Method *reader7494 = addmethodrealflags(obj7492, "kind",&reader_ast_kind_7494, MFLAG_DEF);
  reader7494->definitionModule = modulename;
  reader7494->definitionLine = 1731;
}
adddatum2(obj7492, alloc_Undefined(), 1);
if (objclass7492 == NULL) {
  Method *reader7495 = addmethodrealflags(obj7492, "value",&reader_ast_value_7495, MFLAG_DEF);
  reader7495->definitionModule = modulename;
  reader7495->definitionLine = 1732;
}
adddatum2(obj7492, alloc_Undefined(), 2);
  struct UserObject *uo7496 = (struct UserObject*)obj7492;
  uo7496->data[3] = emptyclosure;
  Method *meth_meth_ast_accept7496 = addmethod2pos(obj7492, "accept", &meth_ast_accept7496, 3);
int argcv_meth_ast_accept7496[] = {1};
meth_meth_ast_accept7496->type = alloc_MethodType(1, argcv_meth_ast_accept7496);
meth_meth_ast_accept7496->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept7496->type->names[0] = "visitor";
  meth_meth_ast_accept7496->definitionModule = modulename;
  meth_meth_ast_accept7496->definitionLine = 1732;
  struct UserObject *uo7499 = (struct UserObject*)obj7492;
  uo7499->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_before_40__41_after7499 = addmethod2pos(obj7492, "map()before()after", &meth_ast_map_40__41_before_40__41_after7499, 4);
int argcv_meth_ast_map_40__41_before_40__41_after7499[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7499->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7499);
  meth_meth_ast_map_40__41_before_40__41_after7499->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7499->definitionLine = 1735;
  struct UserObject *uo7510 = (struct UserObject*)obj7492;
  uo7510->data[5] = emptyclosure;
  Method *meth_meth_ast_map7510 = addmethod2pos(obj7492, "map", &meth_ast_map7510, 5);
int argcv_meth_ast_map7510[] = {1};
meth_meth_ast_map7510->type = alloc_MethodType(1, argcv_meth_ast_map7510);
  meth_meth_ast_map7510->definitionModule = modulename;
  meth_meth_ast_map7510->definitionLine = 1742;
  struct UserObject *uo7519 = (struct UserObject*)obj7492;
  uo7519->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty7519 = addmethod2pos(obj7492, "pretty", &meth_ast_pretty7519, 6);
int argcv_meth_ast_pretty7519[] = {1};
meth_meth_ast_pretty7519->type = alloc_MethodType(1, argcv_meth_ast_pretty7519);
  meth_meth_ast_pretty7519->definitionModule = modulename;
  meth_meth_ast_pretty7519->definitionLine = 1745;
  struct UserObject *uo7562 = (struct UserObject*)obj7492;
  uo7562->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace7562 = addmethod2pos(obj7492, "toGrace", &meth_ast_toGrace7562, 7);
int argcv_meth_ast_toGrace7562[] = {1};
meth_meth_ast_toGrace7562->type = alloc_MethodType(1, argcv_meth_ast_toGrace7562);
meth_meth_ast_toGrace7562->type->types[0] = type_Number;
meth_meth_ast_toGrace7562->type->names[0] = "depth";
  meth_meth_ast_toGrace7562->definitionModule = modulename;
  meth_meth_ast_toGrace7562->definitionLine = 1755;
  sourceObject = obj7492;
// Begin line 1729
  setline(1729);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7573 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7574 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7573);
// compilenode returning call7574
  struct UserObject *obj7492_uo = (struct UserObject *)obj7492;
  obj7492_uo->super = call7574;
  sourceObject = obj7492;
// Begin line 1730
  setline(1730);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7575 == NULL) {
    strlit7575 = alloc_String("dialect");
    gc_root(strlit7575);
  }
// compilenode returning strlit7575
  adddatum2(obj7492, strlit7575, 1);
  sourceObject = obj7492;
// Begin line 1731
  setline(1731);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_path_39_
  adddatum2(obj7492, *var_path_39_, 2);
  sourceObject = obj7492;
  sourceObject = obj7492;
  sourceObject = obj7492;
  sourceObject = obj7492;
  sourceObject = obj7492;
objclass7492 = obj7492->class;
  objclass7492->definitionModule = modulename;
  objclass7492->definitionLine = 1725;
  (*(struct UserObject *)self).data[0] = lowerouter7492;
  self = oldself7492;
  selfslot = oldselfslot7492;
  stackframe = oldstackframe7492;
  gc_frame_end(frame);
  return obj7492;
}
Object meth_ast_new7491_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7492 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7492 = alloc_userobj2(8,9, objclass7492);
  gc_frame_newslot(obj7492);
if (objclass7492 == NULL) {
  glfree(obj7492->class->name);
  obj7492->class->name = "dialectNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7492, self, 0);
  addmethodreal(obj7492,"outer", &reader_ast_outer_7493);
  Object oldself7492 = self;
  struct StackFrameObject *oldstackframe7492 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7492);
  gc_frame_newslot((Object)stackframe);
  self = obj7492;
  Object *oldselfslot7492 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7492 = (*(struct UserObject *)self).data[0], lowerouter7492 = thisouter7492;
  if (inheritingObject7492) {
    struct UserObject *inho7492 = (struct UserObject *)inheritingObject7492;
    while (inho7492->super != GraceDefaultObject) inho7492 = (struct UserObject *)inho7492->super;
    inho7492->super = obj7492;
    self = inheritingObject7492;
    *selfslot = self;
    lowerouter7492 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7492;
  }
if (objclass7492 == NULL) {
  Method *reader7494 = addmethodrealflags(obj7492, "kind",&reader_ast_kind_7494, MFLAG_DEF);
  reader7494->definitionModule = modulename;
  reader7494->definitionLine = 1731;
}
adddatum2(obj7492, alloc_Undefined(), 1);
if (objclass7492 == NULL) {
  Method *reader7495 = addmethodrealflags(obj7492, "value",&reader_ast_value_7495, MFLAG_DEF);
  reader7495->definitionModule = modulename;
  reader7495->definitionLine = 1732;
}
adddatum2(obj7492, alloc_Undefined(), 2);
  struct UserObject *uo7496 = (struct UserObject*)obj7492;
  uo7496->data[3] = emptyclosure;
  Method *meth_meth_ast_accept7496 = addmethod2pos(obj7492, "accept", &meth_ast_accept7496, 3);
int argcv_meth_ast_accept7496[] = {1};
meth_meth_ast_accept7496->type = alloc_MethodType(1, argcv_meth_ast_accept7496);
meth_meth_ast_accept7496->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept7496->type->names[0] = "visitor";
  meth_meth_ast_accept7496->definitionModule = modulename;
  meth_meth_ast_accept7496->definitionLine = 1732;
  struct UserObject *uo7499 = (struct UserObject*)obj7492;
  uo7499->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_before_40__41_after7499 = addmethod2pos(obj7492, "map()before()after", &meth_ast_map_40__41_before_40__41_after7499, 4);
int argcv_meth_ast_map_40__41_before_40__41_after7499[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7499->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7499);
  meth_meth_ast_map_40__41_before_40__41_after7499->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7499->definitionLine = 1735;
  struct UserObject *uo7510 = (struct UserObject*)obj7492;
  uo7510->data[5] = emptyclosure;
  Method *meth_meth_ast_map7510 = addmethod2pos(obj7492, "map", &meth_ast_map7510, 5);
int argcv_meth_ast_map7510[] = {1};
meth_meth_ast_map7510->type = alloc_MethodType(1, argcv_meth_ast_map7510);
  meth_meth_ast_map7510->definitionModule = modulename;
  meth_meth_ast_map7510->definitionLine = 1742;
  struct UserObject *uo7519 = (struct UserObject*)obj7492;
  uo7519->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty7519 = addmethod2pos(obj7492, "pretty", &meth_ast_pretty7519, 6);
int argcv_meth_ast_pretty7519[] = {1};
meth_meth_ast_pretty7519->type = alloc_MethodType(1, argcv_meth_ast_pretty7519);
  meth_meth_ast_pretty7519->definitionModule = modulename;
  meth_meth_ast_pretty7519->definitionLine = 1745;
  struct UserObject *uo7562 = (struct UserObject*)obj7492;
  uo7562->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace7562 = addmethod2pos(obj7492, "toGrace", &meth_ast_toGrace7562, 7);
int argcv_meth_ast_toGrace7562[] = {1};
meth_meth_ast_toGrace7562->type = alloc_MethodType(1, argcv_meth_ast_toGrace7562);
meth_meth_ast_toGrace7562->type->types[0] = type_Number;
meth_meth_ast_toGrace7562->type->names[0] = "depth";
  meth_meth_ast_toGrace7562->definitionModule = modulename;
  meth_meth_ast_toGrace7562->definitionLine = 1755;
  sourceObject = obj7492;
// Begin line 1729
  setline(1729);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7573 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7574 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7573);
// compilenode returning call7574
  struct UserObject *obj7492_uo = (struct UserObject *)obj7492;
  obj7492_uo->super = call7574;
  sourceObject = obj7492;
// Begin line 1730
  setline(1730);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7575 == NULL) {
    strlit7575 = alloc_String("dialect");
    gc_root(strlit7575);
  }
// compilenode returning strlit7575
  adddatum2(obj7492, strlit7575, 1);
  sourceObject = obj7492;
// Begin line 1731
  setline(1731);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_path_39_
  adddatum2(obj7492, *var_path_39_, 2);
  sourceObject = obj7492;
  sourceObject = obj7492;
  sourceObject = obj7492;
  sourceObject = obj7492;
  sourceObject = obj7492;
objclass7492 = obj7492->class;
  objclass7492->definitionModule = modulename;
  objclass7492->definitionLine = 1725;
  (*(struct UserObject *)self).data[0] = lowerouter7492;
  self = oldself7492;
  selfslot = oldselfslot7492;
  stackframe = oldstackframe7492;
  gc_frame_end(frame);
  return obj7492;
}
Object meth_ast_returnNode7577(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 36, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "returnNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_returnNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for returnNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for returnNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1759
  setline(1759);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_returnNode
  gc_frame_end(frame);
  return *var_returnNode;
}
Object meth_ast_accept7585(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1767
  setline(1767);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1764
  setline(1764);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7587 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call7588 = callmethod(*var_visitor, "visitReturn",
    1, partcv, params);
  gc_frame_end(callframe7587);
// compilenode returning call7588
  Object if7586 = done;
  if (istrue(call7588)) {
// Begin line 1765
  setline(1765);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7589 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe7590 = gc_frame_new();
  partcv[0] = 0;
  Object call7591 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7590);
// compilenode returning call7591
// compilenode returning call7591
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call7592 = callmethod(call7591, "accept",
    1, partcv, params);
  gc_frame_end(callframe7589);
// compilenode returning call7592
    gc_frame_newslot(call7592);
    if7586 = call7592;
  } else {
  }
// compilenode returning if7586
  gc_frame_end(frame);
  return if7586;
}
Object meth_ast_map_40__41_before_40__41_after7593(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_returnNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7594 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call7595 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe7594);
// compilenode returning call7595
// Begin line 1770
  setline(1770);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7596 = gc_frame_new();
  int callframe7597 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe7598 = gc_frame_new();
  partcv[0] = 0;
  Object call7599 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7598);
// compilenode returning call7599
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7600 = callmethod(call7599, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe7597);
// compilenode returning call7600
  gc_frame_newslot(call7600);
// compilenode returning *var_returnNode
  params[0] = call7600;
  partcv[0] = 1;
  Object call7601 = callmethod(*var_returnNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7596);
// compilenode returning call7601
  *var_n = call7601;
  if (call7601 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1771
  setline(1771);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7602 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7603 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7602);
// compilenode returning call7603
  *var_n = call7603;
  if (call7603 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1773
  setline(1773);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1765
  setline(1765);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7605 = gc_frame_new();
// Begin line 1772
  setline(1772);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7606 = gc_frame_new();
  partcv[0] = 0;
  Object call7607 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7606);
// compilenode returning call7607
  gc_frame_newslot(call7607);
// compilenode returning *var_n
  params[0] = call7607;
  partcv[0] = 1;
  Object call7608 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe7605);
// compilenode returning call7608
// compilenode returning done
// Begin line 1773
  setline(1773);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7609 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7610 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe7609);
// compilenode returning call7610
// Begin line 1774
  setline(1774);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply7614(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply7617(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map7611(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1777
  setline(1777);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7612 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block7613 = alloc_Block(NULL, NULL, "ast", 1777);
  gc_frame_newslot(block7613);
  block_savedest(block7613);
  Object closure7614 = createclosure(1, "_apply");
setclosureframe(closure7614, stackframe);
  addtoclosure(closure7614, selfslot);
  struct UserObject *uo7614 = (struct UserObject*)block7613;
  uo7614->data[0] = (Object)closure7614;
  Method *meth_meth_ast__apply7614 = addmethod2pos(block7613, "_apply", &meth_ast__apply7614, 0);
int argcv_meth_ast__apply7614[] = {0};
meth_meth_ast__apply7614->type = alloc_MethodType(1, argcv_meth_ast__apply7614);
  meth_meth_ast__apply7614->definitionModule = modulename;
  meth_meth_ast__apply7614->definitionLine = 1765;
// compilenode returning block7613
  gc_frame_newslot(block7613);
  Object block7616 = alloc_Block(NULL, NULL, "ast", 1777);
  gc_frame_newslot(block7616);
  block_savedest(block7616);
  Object closure7617 = createclosure(1, "_apply");
setclosureframe(closure7617, stackframe);
  addtoclosure(closure7617, selfslot);
  struct UserObject *uo7617 = (struct UserObject*)block7616;
  uo7617->data[0] = (Object)closure7617;
  Method *meth_meth_ast__apply7617 = addmethod2pos(block7616, "_apply", &meth_ast__apply7617, 0);
int argcv_meth_ast__apply7617[] = {0};
meth_meth_ast__apply7617->type = alloc_MethodType(1, argcv_meth_ast__apply7617);
  meth_meth_ast__apply7617->definitionModule = modulename;
  meth_meth_ast__apply7617->definitionLine = 1765;
// compilenode returning block7616
  gc_frame_newslot(block7616);
  params[0] = *var_blk;
  params[1] = block7613;
  params[2] = block7616;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7619 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7612);
// compilenode returning call7619
  gc_frame_end(frame);
  return call7619;
}
Object meth_ast__apply7628(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1783
  setline(1783);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1782
  setline(1782);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7630 == NULL) {
    strlit7630 = alloc_String("  ");
    gc_root(strlit7630);
  }
// compilenode returning strlit7630
  int op_slot_right_7629 = gc_frame_newslot(strlit7630);
// compilenode returning *var_spc
  int op_slot_left_7629 = gc_frame_newslot(*var_spc);
  params[0] = strlit7630;
  partcv[0] = 1;
  Object opresult7632 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult7632
  *var_spc = opresult7632;
  if (opresult7632 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty7620(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1781
  setline(1781);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1780
  setline(1780);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7621 == NULL) {
    strlit7621 = alloc_String("");
    gc_root(strlit7621);
  }
// compilenode returning strlit7621
  *var_spc = strlit7621;
  if (strlit7621 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1781
  setline(1781);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7622 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_7623 = gc_frame_newslot(*var_depth);
  Object num7625 = alloc_Float64(0);
// compilenode returning num7625
  int op_slot_left_7623 = gc_frame_newslot(num7625);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7626 = callmethod(num7625, "..", 1, partcv, params);
// compilenode returning opresult7626
  gc_frame_newslot(opresult7626);
  Object block7627 = alloc_Block(NULL, NULL, "ast", 1781);
  gc_frame_newslot(block7627);
  block_savedest(block7627);
  Object closure7628 = createclosure(2, "_apply");
setclosureframe(closure7628, stackframe);
  addtoclosure(closure7628, var_spc);
  addtoclosure(closure7628, selfslot);
  struct UserObject *uo7628 = (struct UserObject*)block7627;
  uo7628->data[0] = (Object)closure7628;
  Method *meth_meth_ast__apply7628 = addmethod2pos(block7627, "_apply", &meth_ast__apply7628, 0);
int argcv_meth_ast__apply7628[] = {1};
meth_meth_ast__apply7628->type = alloc_MethodType(1, argcv_meth_ast__apply7628);
  meth_meth_ast__apply7628->definitionModule = modulename;
  meth_meth_ast__apply7628->definitionLine = 1765;
// compilenode returning block7627
  gc_frame_newslot(block7627);
  params[0] = opresult7626;
  params[1] = block7627;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7635 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7622);
// compilenode returning call7635
// Begin line 1785
  setline(1785);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1784
  setline(1784);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7636 == NULL) {
    strlit7636 = alloc_String("Return");
    gc_root(strlit7636);
  }
// compilenode returning strlit7636
  *var_s = strlit7636;
  if (strlit7636 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1786
  setline(1786);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1785
  setline(1785);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7638 == NULL) {
    strlit7638 = alloc_String("""\x0a""");
    gc_root(strlit7638);
  }
// compilenode returning strlit7638
  int op_slot_right_7637 = gc_frame_newslot(strlit7638);
// compilenode returning *var_s
  int op_slot_left_7637 = gc_frame_newslot(*var_s);
  params[0] = strlit7638;
  partcv[0] = 1;
  Object opresult7640 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7640
  *var_s = opresult7640;
  if (opresult7640 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1786
  setline(1786);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7643 = gc_frame_new();
  Object num7645 = alloc_Float64(1);
// compilenode returning num7645
  int op_slot_right_7644 = gc_frame_newslot(num7645);
// compilenode returning *var_depth
  int op_slot_left_7644 = gc_frame_newslot(*var_depth);
  params[0] = num7645;
  partcv[0] = 1;
  Object sum7647 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum7647
  gc_frame_newslot(sum7647);
  int callframe7648 = gc_frame_new();
  partcv[0] = 0;
  Object call7649 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7648);
// compilenode returning call7649
// compilenode returning call7649
  params[0] = sum7647;
  partcv[0] = 1;
  Object call7650 = callmethod(call7649, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7643);
// compilenode returning call7650
  int op_slot_right_7642 = gc_frame_newslot(call7650);
// compilenode returning *var_spc
  int op_slot_right_7652 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_7652 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7654 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7654
  int op_slot_left_7642 = gc_frame_newslot(opresult7654);
  params[0] = call7650;
  partcv[0] = 1;
  Object opresult7655 = callmethod(opresult7654, "++", 1, partcv, params);
// compilenode returning opresult7655
  *var_s = opresult7655;
  if (opresult7655 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1787
  setline(1787);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace7657(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1790
  setline(1790);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7659 = gc_frame_new();
// compilenode returning *var_depth
  gc_frame_newslot(*var_depth);
  int callframe7660 = gc_frame_new();
  partcv[0] = 0;
  Object call7661 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7660);
// compilenode returning call7661
// compilenode returning call7661
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7662 = callmethod(call7661, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7659);
// compilenode returning call7662
  int op_slot_right_7658 = gc_frame_newslot(call7662);
  if (strlit7664 == NULL) {
    strlit7664 = alloc_String("return ");
    gc_root(strlit7664);
  }
// compilenode returning strlit7664
  int op_slot_left_7658 = gc_frame_newslot(strlit7664);
  params[0] = call7662;
  partcv[0] = 1;
  Object opresult7665 = callmethod(strlit7664, "++", 1, partcv, params);
// compilenode returning opresult7665
  gc_frame_end(frame);
  return opresult7665;
}
Object meth_ast_new7580(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_returnNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7581 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7581 = alloc_userobj2(8,9, objclass7581);
  gc_frame_newslot(obj7581);
if (objclass7581 == NULL) {
  glfree(obj7581->class->name);
  obj7581->class->name = "returnNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7581, self, 0);
  addmethodreal(obj7581,"outer", &reader_ast_outer_7582);
  Object oldself7581 = self;
  struct StackFrameObject *oldstackframe7581 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7581);
  gc_frame_newslot((Object)stackframe);
  self = obj7581;
  Object *oldselfslot7581 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7581 = (*(struct UserObject *)self).data[0], lowerouter7581 = thisouter7581;
  if (inheritingObject7581) {
    struct UserObject *inho7581 = (struct UserObject *)inheritingObject7581;
    while (inho7581->super != GraceDefaultObject) inho7581 = (struct UserObject *)inho7581->super;
    inho7581->super = obj7581;
    self = inheritingObject7581;
    *selfslot = self;
    lowerouter7581 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7581;
  }
if (objclass7581 == NULL) {
  Method *reader7583 = addmethodrealflags(obj7581, "kind",&reader_ast_kind_7583, MFLAG_DEF);
  reader7583->definitionModule = modulename;
  reader7583->definitionLine = 1762;
}
adddatum2(obj7581, alloc_Undefined(), 1);
if (objclass7581 == NULL) {
  Method *reader7584 = addmethodrealflags(obj7581, "value",&reader_ast_value_7584, MFLAG_DEF);
  reader7584->definitionModule = modulename;
  reader7584->definitionLine = 1763;
}
adddatum2(obj7581, alloc_Undefined(), 2);
  struct UserObject *uo7585 = (struct UserObject*)obj7581;
  uo7585->data[3] = emptyclosure;
  Method *meth_meth_ast_accept7585 = addmethod2pos(obj7581, "accept", &meth_ast_accept7585, 3);
int argcv_meth_ast_accept7585[] = {1};
meth_meth_ast_accept7585->type = alloc_MethodType(1, argcv_meth_ast_accept7585);
meth_meth_ast_accept7585->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept7585->type->names[0] = "visitor";
  meth_meth_ast_accept7585->definitionModule = modulename;
  meth_meth_ast_accept7585->definitionLine = 1763;
  block_savedest(obj7581);
  Object closure7593 = createclosure(1, "map()before()after");
setclosureframe(closure7593, stackframe);
  addtoclosure(closure7593, var_returnNode);
  struct UserObject *uo7593 = (struct UserObject*)obj7581;
  uo7593->data[4] = (Object)closure7593;
  Method *meth_meth_ast_map_40__41_before_40__41_after7593 = addmethod2pos(obj7581, "map()before()after", &meth_ast_map_40__41_before_40__41_after7593, 4);
int argcv_meth_ast_map_40__41_before_40__41_after7593[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7593->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7593);
  meth_meth_ast_map_40__41_before_40__41_after7593->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7593->definitionLine = 1768;
  struct UserObject *uo7611 = (struct UserObject*)obj7581;
  uo7611->data[5] = emptyclosure;
  Method *meth_meth_ast_map7611 = addmethod2pos(obj7581, "map", &meth_ast_map7611, 5);
int argcv_meth_ast_map7611[] = {1};
meth_meth_ast_map7611->type = alloc_MethodType(1, argcv_meth_ast_map7611);
  meth_meth_ast_map7611->definitionModule = modulename;
  meth_meth_ast_map7611->definitionLine = 1776;
  struct UserObject *uo7620 = (struct UserObject*)obj7581;
  uo7620->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty7620 = addmethod2pos(obj7581, "pretty", &meth_ast_pretty7620, 6);
int argcv_meth_ast_pretty7620[] = {1};
meth_meth_ast_pretty7620->type = alloc_MethodType(1, argcv_meth_ast_pretty7620);
  meth_meth_ast_pretty7620->definitionModule = modulename;
  meth_meth_ast_pretty7620->definitionLine = 1779;
  struct UserObject *uo7657 = (struct UserObject*)obj7581;
  uo7657->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace7657 = addmethod2pos(obj7581, "toGrace", &meth_ast_toGrace7657, 7);
int argcv_meth_ast_toGrace7657[] = {1};
meth_meth_ast_toGrace7657->type = alloc_MethodType(1, argcv_meth_ast_toGrace7657);
meth_meth_ast_toGrace7657->type->types[0] = type_Number;
meth_meth_ast_toGrace7657->type->names[0] = "depth";
  meth_meth_ast_toGrace7657->definitionModule = modulename;
  meth_meth_ast_toGrace7657->definitionLine = 1789;
  sourceObject = obj7581;
// Begin line 1760
  setline(1760);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7666 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7667 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7666);
// compilenode returning call7667
  struct UserObject *obj7581_uo = (struct UserObject *)obj7581;
  obj7581_uo->super = call7667;
  sourceObject = obj7581;
// Begin line 1761
  setline(1761);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7668 == NULL) {
    strlit7668 = alloc_String("return");
    gc_root(strlit7668);
  }
// compilenode returning strlit7668
  adddatum2(obj7581, strlit7668, 1);
  sourceObject = obj7581;
// Begin line 1762
  setline(1762);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_expr
  adddatum2(obj7581, *var_expr, 2);
  sourceObject = obj7581;
  sourceObject = obj7581;
  sourceObject = obj7581;
  sourceObject = obj7581;
  sourceObject = obj7581;
objclass7581 = obj7581->class;
  objclass7581->definitionModule = modulename;
  objclass7581->definitionLine = 1756;
  (*(struct UserObject *)self).data[0] = lowerouter7581;
  self = oldself7581;
  selfslot = oldselfslot7581;
  stackframe = oldstackframe7581;
  gc_frame_end(frame);
  return obj7581;
}
Object meth_ast_new7580_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_returnNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7581 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7581 = alloc_userobj2(8,9, objclass7581);
  gc_frame_newslot(obj7581);
if (objclass7581 == NULL) {
  glfree(obj7581->class->name);
  obj7581->class->name = "returnNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7581, self, 0);
  addmethodreal(obj7581,"outer", &reader_ast_outer_7582);
  Object oldself7581 = self;
  struct StackFrameObject *oldstackframe7581 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7581);
  gc_frame_newslot((Object)stackframe);
  self = obj7581;
  Object *oldselfslot7581 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7581 = (*(struct UserObject *)self).data[0], lowerouter7581 = thisouter7581;
  if (inheritingObject7581) {
    struct UserObject *inho7581 = (struct UserObject *)inheritingObject7581;
    while (inho7581->super != GraceDefaultObject) inho7581 = (struct UserObject *)inho7581->super;
    inho7581->super = obj7581;
    self = inheritingObject7581;
    *selfslot = self;
    lowerouter7581 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7581;
  }
if (objclass7581 == NULL) {
  Method *reader7583 = addmethodrealflags(obj7581, "kind",&reader_ast_kind_7583, MFLAG_DEF);
  reader7583->definitionModule = modulename;
  reader7583->definitionLine = 1762;
}
adddatum2(obj7581, alloc_Undefined(), 1);
if (objclass7581 == NULL) {
  Method *reader7584 = addmethodrealflags(obj7581, "value",&reader_ast_value_7584, MFLAG_DEF);
  reader7584->definitionModule = modulename;
  reader7584->definitionLine = 1763;
}
adddatum2(obj7581, alloc_Undefined(), 2);
  struct UserObject *uo7585 = (struct UserObject*)obj7581;
  uo7585->data[3] = emptyclosure;
  Method *meth_meth_ast_accept7585 = addmethod2pos(obj7581, "accept", &meth_ast_accept7585, 3);
int argcv_meth_ast_accept7585[] = {1};
meth_meth_ast_accept7585->type = alloc_MethodType(1, argcv_meth_ast_accept7585);
meth_meth_ast_accept7585->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept7585->type->names[0] = "visitor";
  meth_meth_ast_accept7585->definitionModule = modulename;
  meth_meth_ast_accept7585->definitionLine = 1763;
  block_savedest(obj7581);
  Object closure7593 = createclosure(1, "map()before()after");
setclosureframe(closure7593, stackframe);
  addtoclosure(closure7593, var_returnNode);
  struct UserObject *uo7593 = (struct UserObject*)obj7581;
  uo7593->data[4] = (Object)closure7593;
  Method *meth_meth_ast_map_40__41_before_40__41_after7593 = addmethod2pos(obj7581, "map()before()after", &meth_ast_map_40__41_before_40__41_after7593, 4);
int argcv_meth_ast_map_40__41_before_40__41_after7593[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7593->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7593);
  meth_meth_ast_map_40__41_before_40__41_after7593->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7593->definitionLine = 1768;
  struct UserObject *uo7611 = (struct UserObject*)obj7581;
  uo7611->data[5] = emptyclosure;
  Method *meth_meth_ast_map7611 = addmethod2pos(obj7581, "map", &meth_ast_map7611, 5);
int argcv_meth_ast_map7611[] = {1};
meth_meth_ast_map7611->type = alloc_MethodType(1, argcv_meth_ast_map7611);
  meth_meth_ast_map7611->definitionModule = modulename;
  meth_meth_ast_map7611->definitionLine = 1776;
  struct UserObject *uo7620 = (struct UserObject*)obj7581;
  uo7620->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty7620 = addmethod2pos(obj7581, "pretty", &meth_ast_pretty7620, 6);
int argcv_meth_ast_pretty7620[] = {1};
meth_meth_ast_pretty7620->type = alloc_MethodType(1, argcv_meth_ast_pretty7620);
  meth_meth_ast_pretty7620->definitionModule = modulename;
  meth_meth_ast_pretty7620->definitionLine = 1779;
  struct UserObject *uo7657 = (struct UserObject*)obj7581;
  uo7657->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace7657 = addmethod2pos(obj7581, "toGrace", &meth_ast_toGrace7657, 7);
int argcv_meth_ast_toGrace7657[] = {1};
meth_meth_ast_toGrace7657->type = alloc_MethodType(1, argcv_meth_ast_toGrace7657);
meth_meth_ast_toGrace7657->type->types[0] = type_Number;
meth_meth_ast_toGrace7657->type->names[0] = "depth";
  meth_meth_ast_toGrace7657->definitionModule = modulename;
  meth_meth_ast_toGrace7657->definitionLine = 1789;
  sourceObject = obj7581;
// Begin line 1760
  setline(1760);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7666 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7667 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7666);
// compilenode returning call7667
  struct UserObject *obj7581_uo = (struct UserObject *)obj7581;
  obj7581_uo->super = call7667;
  sourceObject = obj7581;
// Begin line 1761
  setline(1761);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7668 == NULL) {
    strlit7668 = alloc_String("return");
    gc_root(strlit7668);
  }
// compilenode returning strlit7668
  adddatum2(obj7581, strlit7668, 1);
  sourceObject = obj7581;
// Begin line 1762
  setline(1762);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_expr
  adddatum2(obj7581, *var_expr, 2);
  sourceObject = obj7581;
  sourceObject = obj7581;
  sourceObject = obj7581;
  sourceObject = obj7581;
  sourceObject = obj7581;
objclass7581 = obj7581->class;
  objclass7581->definitionModule = modulename;
  objclass7581->definitionLine = 1756;
  (*(struct UserObject *)self).data[0] = lowerouter7581;
  self = oldself7581;
  selfslot = oldselfslot7581;
  stackframe = oldstackframe7581;
  gc_frame_end(frame);
  return obj7581;
}
Object meth_ast_inheritsNode7670(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 37, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "inheritsNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_inheritsNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for inheritsNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for inheritsNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1793
  setline(1793);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_inheritsNode
  gc_frame_end(frame);
  return *var_inheritsNode;
}
Object meth_ast_accept7678(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1801
  setline(1801);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1798
  setline(1798);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7680 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call7681 = callmethod(*var_visitor, "visitInherits",
    1, partcv, params);
  gc_frame_end(callframe7680);
// compilenode returning call7681
  Object if7679 = done;
  if (istrue(call7681)) {
// Begin line 1799
  setline(1799);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7682 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe7683 = gc_frame_new();
  partcv[0] = 0;
  Object call7684 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7683);
// compilenode returning call7684
// compilenode returning call7684
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call7685 = callmethod(call7684, "accept",
    1, partcv, params);
  gc_frame_end(callframe7682);
// compilenode returning call7685
    gc_frame_newslot(call7685);
    if7679 = call7685;
  } else {
  }
// compilenode returning if7679
  gc_frame_end(frame);
  return if7679;
}
Object meth_ast_map_40__41_before_40__41_after7686(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_inheritsNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1803
  setline(1803);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7687 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call7688 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe7687);
// compilenode returning call7688
// Begin line 1804
  setline(1804);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7689 = gc_frame_new();
  int callframe7690 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe7691 = gc_frame_new();
  partcv[0] = 0;
  Object call7692 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7691);
// compilenode returning call7692
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7693 = callmethod(call7692, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe7690);
// compilenode returning call7693
  gc_frame_newslot(call7693);
// compilenode returning *var_inheritsNode
  params[0] = call7693;
  partcv[0] = 1;
  Object call7694 = callmethod(*var_inheritsNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7689);
// compilenode returning call7694
  *var_n = call7694;
  if (call7694 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1805
  setline(1805);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7695 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7696 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7695);
// compilenode returning call7696
  *var_n = call7696;
  if (call7696 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1807
  setline(1807);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1799
  setline(1799);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7698 = gc_frame_new();
// Begin line 1806
  setline(1806);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7699 = gc_frame_new();
  partcv[0] = 0;
  Object call7700 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7699);
// compilenode returning call7700
  gc_frame_newslot(call7700);
// compilenode returning *var_n
  params[0] = call7700;
  partcv[0] = 1;
  Object call7701 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe7698);
// compilenode returning call7701
// compilenode returning done
// Begin line 1807
  setline(1807);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7702 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7703 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe7702);
// compilenode returning call7703
// Begin line 1808
  setline(1808);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply7707(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply7710(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map7704(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1811
  setline(1811);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7705 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block7706 = alloc_Block(NULL, NULL, "ast", 1811);
  gc_frame_newslot(block7706);
  block_savedest(block7706);
  Object closure7707 = createclosure(1, "_apply");
setclosureframe(closure7707, stackframe);
  addtoclosure(closure7707, selfslot);
  struct UserObject *uo7707 = (struct UserObject*)block7706;
  uo7707->data[0] = (Object)closure7707;
  Method *meth_meth_ast__apply7707 = addmethod2pos(block7706, "_apply", &meth_ast__apply7707, 0);
int argcv_meth_ast__apply7707[] = {0};
meth_meth_ast__apply7707->type = alloc_MethodType(1, argcv_meth_ast__apply7707);
  meth_meth_ast__apply7707->definitionModule = modulename;
  meth_meth_ast__apply7707->definitionLine = 1799;
// compilenode returning block7706
  gc_frame_newslot(block7706);
  Object block7709 = alloc_Block(NULL, NULL, "ast", 1811);
  gc_frame_newslot(block7709);
  block_savedest(block7709);
  Object closure7710 = createclosure(1, "_apply");
setclosureframe(closure7710, stackframe);
  addtoclosure(closure7710, selfslot);
  struct UserObject *uo7710 = (struct UserObject*)block7709;
  uo7710->data[0] = (Object)closure7710;
  Method *meth_meth_ast__apply7710 = addmethod2pos(block7709, "_apply", &meth_ast__apply7710, 0);
int argcv_meth_ast__apply7710[] = {0};
meth_meth_ast__apply7710->type = alloc_MethodType(1, argcv_meth_ast__apply7710);
  meth_meth_ast__apply7710->definitionModule = modulename;
  meth_meth_ast__apply7710->definitionLine = 1799;
// compilenode returning block7709
  gc_frame_newslot(block7709);
  params[0] = *var_blk;
  params[1] = block7706;
  params[2] = block7709;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7712 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7705);
// compilenode returning call7712
  gc_frame_end(frame);
  return call7712;
}
Object meth_ast__apply7721(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1817
  setline(1817);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1816
  setline(1816);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7723 == NULL) {
    strlit7723 = alloc_String("  ");
    gc_root(strlit7723);
  }
// compilenode returning strlit7723
  int op_slot_right_7722 = gc_frame_newslot(strlit7723);
// compilenode returning *var_spc
  int op_slot_left_7722 = gc_frame_newslot(*var_spc);
  params[0] = strlit7723;
  partcv[0] = 1;
  Object opresult7725 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult7725
  *var_spc = opresult7725;
  if (opresult7725 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty7713(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1815
  setline(1815);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1814
  setline(1814);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7714 == NULL) {
    strlit7714 = alloc_String("");
    gc_root(strlit7714);
  }
// compilenode returning strlit7714
  *var_spc = strlit7714;
  if (strlit7714 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1815
  setline(1815);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7715 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_7716 = gc_frame_newslot(*var_depth);
  Object num7718 = alloc_Float64(0);
// compilenode returning num7718
  int op_slot_left_7716 = gc_frame_newslot(num7718);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7719 = callmethod(num7718, "..", 1, partcv, params);
// compilenode returning opresult7719
  gc_frame_newslot(opresult7719);
  Object block7720 = alloc_Block(NULL, NULL, "ast", 1815);
  gc_frame_newslot(block7720);
  block_savedest(block7720);
  Object closure7721 = createclosure(2, "_apply");
setclosureframe(closure7721, stackframe);
  addtoclosure(closure7721, var_spc);
  addtoclosure(closure7721, selfslot);
  struct UserObject *uo7721 = (struct UserObject*)block7720;
  uo7721->data[0] = (Object)closure7721;
  Method *meth_meth_ast__apply7721 = addmethod2pos(block7720, "_apply", &meth_ast__apply7721, 0);
int argcv_meth_ast__apply7721[] = {1};
meth_meth_ast__apply7721->type = alloc_MethodType(1, argcv_meth_ast__apply7721);
  meth_meth_ast__apply7721->definitionModule = modulename;
  meth_meth_ast__apply7721->definitionLine = 1799;
// compilenode returning block7720
  gc_frame_newslot(block7720);
  params[0] = opresult7719;
  params[1] = block7720;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7728 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7715);
// compilenode returning call7728
// Begin line 1819
  setline(1819);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1818
  setline(1818);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7729 == NULL) {
    strlit7729 = alloc_String("Inherits");
    gc_root(strlit7729);
  }
// compilenode returning strlit7729
  *var_s = strlit7729;
  if (strlit7729 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1820
  setline(1820);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1819
  setline(1819);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7731 == NULL) {
    strlit7731 = alloc_String("""\x0a""");
    gc_root(strlit7731);
  }
// compilenode returning strlit7731
  int op_slot_right_7730 = gc_frame_newslot(strlit7731);
// compilenode returning *var_s
  int op_slot_left_7730 = gc_frame_newslot(*var_s);
  params[0] = strlit7731;
  partcv[0] = 1;
  Object opresult7733 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7733
  *var_s = opresult7733;
  if (opresult7733 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1820
  setline(1820);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7736 = gc_frame_new();
  Object num7738 = alloc_Float64(1);
// compilenode returning num7738
  int op_slot_right_7737 = gc_frame_newslot(num7738);
// compilenode returning *var_depth
  int op_slot_left_7737 = gc_frame_newslot(*var_depth);
  params[0] = num7738;
  partcv[0] = 1;
  Object sum7740 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum7740
  gc_frame_newslot(sum7740);
  int callframe7741 = gc_frame_new();
  partcv[0] = 0;
  Object call7742 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7741);
// compilenode returning call7742
// compilenode returning call7742
  params[0] = sum7740;
  partcv[0] = 1;
  Object call7743 = callmethod(call7742, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7736);
// compilenode returning call7743
  int op_slot_right_7735 = gc_frame_newslot(call7743);
// compilenode returning *var_spc
  int op_slot_right_7745 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_7745 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7747 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7747
  int op_slot_left_7735 = gc_frame_newslot(opresult7747);
  params[0] = call7743;
  partcv[0] = 1;
  Object opresult7748 = callmethod(opresult7747, "++", 1, partcv, params);
// compilenode returning opresult7748
  *var_s = opresult7748;
  if (opresult7748 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1821
  setline(1821);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace7750(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1824
  setline(1824);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7752 == NULL) {
    strlit7752 = alloc_String("");
    gc_root(strlit7752);
  }
// compilenode returning strlit7752
  int op_slot_right_7751 = gc_frame_newslot(strlit7752);
  int callframe7755 = gc_frame_new();
  Object num7756 = alloc_Float64(0);
// compilenode returning num7756
  gc_frame_newslot(num7756);
  int callframe7757 = gc_frame_new();
  partcv[0] = 0;
  Object call7758 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7757);
// compilenode returning call7758
// compilenode returning call7758
  params[0] = num7756;
  partcv[0] = 1;
  Object call7759 = callmethod(call7758, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7755);
// compilenode returning call7759
  int op_slot_right_7754 = gc_frame_newslot(call7759);
  if (strlit7761 == NULL) {
    strlit7761 = alloc_String("inherits ");
    gc_root(strlit7761);
  }
// compilenode returning strlit7761
  int op_slot_left_7754 = gc_frame_newslot(strlit7761);
  params[0] = call7759;
  partcv[0] = 1;
  Object opresult7762 = callmethod(strlit7761, "++", 1, partcv, params);
// compilenode returning opresult7762
  int op_slot_left_7751 = gc_frame_newslot(opresult7762);
  params[0] = strlit7752;
  partcv[0] = 1;
  Object opresult7763 = callmethod(opresult7762, "++", 1, partcv, params);
// compilenode returning opresult7763
  gc_frame_end(frame);
  return opresult7763;
}
Object meth_ast_new7673(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_inheritsNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7674 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7674 = alloc_userobj2(8,9, objclass7674);
  gc_frame_newslot(obj7674);
if (objclass7674 == NULL) {
  glfree(obj7674->class->name);
  obj7674->class->name = "inheritsNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7674, self, 0);
  addmethodreal(obj7674,"outer", &reader_ast_outer_7675);
  Object oldself7674 = self;
  struct StackFrameObject *oldstackframe7674 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7674);
  gc_frame_newslot((Object)stackframe);
  self = obj7674;
  Object *oldselfslot7674 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7674 = (*(struct UserObject *)self).data[0], lowerouter7674 = thisouter7674;
  if (inheritingObject7674) {
    struct UserObject *inho7674 = (struct UserObject *)inheritingObject7674;
    while (inho7674->super != GraceDefaultObject) inho7674 = (struct UserObject *)inho7674->super;
    inho7674->super = obj7674;
    self = inheritingObject7674;
    *selfslot = self;
    lowerouter7674 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7674;
  }
if (objclass7674 == NULL) {
  Method *reader7676 = addmethodrealflags(obj7674, "kind",&reader_ast_kind_7676, MFLAG_DEF);
  reader7676->definitionModule = modulename;
  reader7676->definitionLine = 1796;
}
adddatum2(obj7674, alloc_Undefined(), 1);
if (objclass7674 == NULL) {
  Method *reader7677 = addmethodrealflags(obj7674, "value",&reader_ast_value_7677, MFLAG_DEF);
  reader7677->definitionModule = modulename;
  reader7677->definitionLine = 1797;
}
adddatum2(obj7674, alloc_Undefined(), 2);
  struct UserObject *uo7678 = (struct UserObject*)obj7674;
  uo7678->data[3] = emptyclosure;
  Method *meth_meth_ast_accept7678 = addmethod2pos(obj7674, "accept", &meth_ast_accept7678, 3);
int argcv_meth_ast_accept7678[] = {1};
meth_meth_ast_accept7678->type = alloc_MethodType(1, argcv_meth_ast_accept7678);
meth_meth_ast_accept7678->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept7678->type->names[0] = "visitor";
  meth_meth_ast_accept7678->definitionModule = modulename;
  meth_meth_ast_accept7678->definitionLine = 1797;
  block_savedest(obj7674);
  Object closure7686 = createclosure(1, "map()before()after");
setclosureframe(closure7686, stackframe);
  addtoclosure(closure7686, var_inheritsNode);
  struct UserObject *uo7686 = (struct UserObject*)obj7674;
  uo7686->data[4] = (Object)closure7686;
  Method *meth_meth_ast_map_40__41_before_40__41_after7686 = addmethod2pos(obj7674, "map()before()after", &meth_ast_map_40__41_before_40__41_after7686, 4);
int argcv_meth_ast_map_40__41_before_40__41_after7686[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7686->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7686);
  meth_meth_ast_map_40__41_before_40__41_after7686->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7686->definitionLine = 1802;
  struct UserObject *uo7704 = (struct UserObject*)obj7674;
  uo7704->data[5] = emptyclosure;
  Method *meth_meth_ast_map7704 = addmethod2pos(obj7674, "map", &meth_ast_map7704, 5);
int argcv_meth_ast_map7704[] = {1};
meth_meth_ast_map7704->type = alloc_MethodType(1, argcv_meth_ast_map7704);
  meth_meth_ast_map7704->definitionModule = modulename;
  meth_meth_ast_map7704->definitionLine = 1810;
  struct UserObject *uo7713 = (struct UserObject*)obj7674;
  uo7713->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty7713 = addmethod2pos(obj7674, "pretty", &meth_ast_pretty7713, 6);
int argcv_meth_ast_pretty7713[] = {1};
meth_meth_ast_pretty7713->type = alloc_MethodType(1, argcv_meth_ast_pretty7713);
  meth_meth_ast_pretty7713->definitionModule = modulename;
  meth_meth_ast_pretty7713->definitionLine = 1813;
  struct UserObject *uo7750 = (struct UserObject*)obj7674;
  uo7750->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace7750 = addmethod2pos(obj7674, "toGrace", &meth_ast_toGrace7750, 7);
int argcv_meth_ast_toGrace7750[] = {1};
meth_meth_ast_toGrace7750->type = alloc_MethodType(1, argcv_meth_ast_toGrace7750);
meth_meth_ast_toGrace7750->type->types[0] = type_Number;
meth_meth_ast_toGrace7750->type->names[0] = "depth";
  meth_meth_ast_toGrace7750->definitionModule = modulename;
  meth_meth_ast_toGrace7750->definitionLine = 1823;
  sourceObject = obj7674;
// Begin line 1794
  setline(1794);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7764 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7765 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7764);
// compilenode returning call7765
  struct UserObject *obj7674_uo = (struct UserObject *)obj7674;
  obj7674_uo->super = call7765;
  sourceObject = obj7674;
// Begin line 1795
  setline(1795);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7766 == NULL) {
    strlit7766 = alloc_String("inherits");
    gc_root(strlit7766);
  }
// compilenode returning strlit7766
  adddatum2(obj7674, strlit7766, 1);
  sourceObject = obj7674;
// Begin line 1796
  setline(1796);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_expr
  adddatum2(obj7674, *var_expr, 2);
  sourceObject = obj7674;
  sourceObject = obj7674;
  sourceObject = obj7674;
  sourceObject = obj7674;
  sourceObject = obj7674;
objclass7674 = obj7674->class;
  objclass7674->definitionModule = modulename;
  objclass7674->definitionLine = 1790;
  (*(struct UserObject *)self).data[0] = lowerouter7674;
  self = oldself7674;
  selfslot = oldselfslot7674;
  stackframe = oldstackframe7674;
  gc_frame_end(frame);
  return obj7674;
}
Object meth_ast_new7673_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_inheritsNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7674 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7674 = alloc_userobj2(8,9, objclass7674);
  gc_frame_newslot(obj7674);
if (objclass7674 == NULL) {
  glfree(obj7674->class->name);
  obj7674->class->name = "inheritsNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7674, self, 0);
  addmethodreal(obj7674,"outer", &reader_ast_outer_7675);
  Object oldself7674 = self;
  struct StackFrameObject *oldstackframe7674 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7674);
  gc_frame_newslot((Object)stackframe);
  self = obj7674;
  Object *oldselfslot7674 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7674 = (*(struct UserObject *)self).data[0], lowerouter7674 = thisouter7674;
  if (inheritingObject7674) {
    struct UserObject *inho7674 = (struct UserObject *)inheritingObject7674;
    while (inho7674->super != GraceDefaultObject) inho7674 = (struct UserObject *)inho7674->super;
    inho7674->super = obj7674;
    self = inheritingObject7674;
    *selfslot = self;
    lowerouter7674 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7674;
  }
if (objclass7674 == NULL) {
  Method *reader7676 = addmethodrealflags(obj7674, "kind",&reader_ast_kind_7676, MFLAG_DEF);
  reader7676->definitionModule = modulename;
  reader7676->definitionLine = 1796;
}
adddatum2(obj7674, alloc_Undefined(), 1);
if (objclass7674 == NULL) {
  Method *reader7677 = addmethodrealflags(obj7674, "value",&reader_ast_value_7677, MFLAG_DEF);
  reader7677->definitionModule = modulename;
  reader7677->definitionLine = 1797;
}
adddatum2(obj7674, alloc_Undefined(), 2);
  struct UserObject *uo7678 = (struct UserObject*)obj7674;
  uo7678->data[3] = emptyclosure;
  Method *meth_meth_ast_accept7678 = addmethod2pos(obj7674, "accept", &meth_ast_accept7678, 3);
int argcv_meth_ast_accept7678[] = {1};
meth_meth_ast_accept7678->type = alloc_MethodType(1, argcv_meth_ast_accept7678);
meth_meth_ast_accept7678->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept7678->type->names[0] = "visitor";
  meth_meth_ast_accept7678->definitionModule = modulename;
  meth_meth_ast_accept7678->definitionLine = 1797;
  block_savedest(obj7674);
  Object closure7686 = createclosure(1, "map()before()after");
setclosureframe(closure7686, stackframe);
  addtoclosure(closure7686, var_inheritsNode);
  struct UserObject *uo7686 = (struct UserObject*)obj7674;
  uo7686->data[4] = (Object)closure7686;
  Method *meth_meth_ast_map_40__41_before_40__41_after7686 = addmethod2pos(obj7674, "map()before()after", &meth_ast_map_40__41_before_40__41_after7686, 4);
int argcv_meth_ast_map_40__41_before_40__41_after7686[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7686->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7686);
  meth_meth_ast_map_40__41_before_40__41_after7686->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7686->definitionLine = 1802;
  struct UserObject *uo7704 = (struct UserObject*)obj7674;
  uo7704->data[5] = emptyclosure;
  Method *meth_meth_ast_map7704 = addmethod2pos(obj7674, "map", &meth_ast_map7704, 5);
int argcv_meth_ast_map7704[] = {1};
meth_meth_ast_map7704->type = alloc_MethodType(1, argcv_meth_ast_map7704);
  meth_meth_ast_map7704->definitionModule = modulename;
  meth_meth_ast_map7704->definitionLine = 1810;
  struct UserObject *uo7713 = (struct UserObject*)obj7674;
  uo7713->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty7713 = addmethod2pos(obj7674, "pretty", &meth_ast_pretty7713, 6);
int argcv_meth_ast_pretty7713[] = {1};
meth_meth_ast_pretty7713->type = alloc_MethodType(1, argcv_meth_ast_pretty7713);
  meth_meth_ast_pretty7713->definitionModule = modulename;
  meth_meth_ast_pretty7713->definitionLine = 1813;
  struct UserObject *uo7750 = (struct UserObject*)obj7674;
  uo7750->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace7750 = addmethod2pos(obj7674, "toGrace", &meth_ast_toGrace7750, 7);
int argcv_meth_ast_toGrace7750[] = {1};
meth_meth_ast_toGrace7750->type = alloc_MethodType(1, argcv_meth_ast_toGrace7750);
meth_meth_ast_toGrace7750->type->types[0] = type_Number;
meth_meth_ast_toGrace7750->type->names[0] = "depth";
  meth_meth_ast_toGrace7750->definitionModule = modulename;
  meth_meth_ast_toGrace7750->definitionLine = 1823;
  sourceObject = obj7674;
// Begin line 1794
  setline(1794);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7764 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7765 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7764);
// compilenode returning call7765
  struct UserObject *obj7674_uo = (struct UserObject *)obj7674;
  obj7674_uo->super = call7765;
  sourceObject = obj7674;
// Begin line 1795
  setline(1795);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7766 == NULL) {
    strlit7766 = alloc_String("inherits");
    gc_root(strlit7766);
  }
// compilenode returning strlit7766
  adddatum2(obj7674, strlit7766, 1);
  sourceObject = obj7674;
// Begin line 1796
  setline(1796);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_expr
  adddatum2(obj7674, *var_expr, 2);
  sourceObject = obj7674;
  sourceObject = obj7674;
  sourceObject = obj7674;
  sourceObject = obj7674;
  sourceObject = obj7674;
objclass7674 = obj7674->class;
  objclass7674->definitionModule = modulename;
  objclass7674->definitionLine = 1790;
  (*(struct UserObject *)self).data[0] = lowerouter7674;
  self = oldself7674;
  selfslot = oldselfslot7674;
  stackframe = oldstackframe7674;
  gc_frame_end(frame);
  return obj7674;
}
Object meth_ast_blankNode7768(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 38, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blankNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blankNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for blankNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for blankNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1827
  setline(1827);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_blankNode
  gc_frame_end(frame);
  return *var_blankNode;
}
Object meth_ast_accept7776(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map_40__41_before_40__41_after7777(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1834
  setline(1834);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning self
  gc_frame_end(frame);
  return self;
}
Object meth_ast__apply7781(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply7784(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map7778(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1837
  setline(1837);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7779 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block7780 = alloc_Block(NULL, NULL, "ast", 1837);
  gc_frame_newslot(block7780);
  block_savedest(block7780);
  Object closure7781 = createclosure(1, "_apply");
setclosureframe(closure7781, stackframe);
  addtoclosure(closure7781, selfslot);
  struct UserObject *uo7781 = (struct UserObject*)block7780;
  uo7781->data[0] = (Object)closure7781;
  Method *meth_meth_ast__apply7781 = addmethod2pos(block7780, "_apply", &meth_ast__apply7781, 0);
int argcv_meth_ast__apply7781[] = {0};
meth_meth_ast__apply7781->type = alloc_MethodType(1, argcv_meth_ast__apply7781);
  meth_meth_ast__apply7781->definitionModule = modulename;
  meth_meth_ast__apply7781->definitionLine = 1824;
// compilenode returning block7780
  gc_frame_newslot(block7780);
  Object block7783 = alloc_Block(NULL, NULL, "ast", 1837);
  gc_frame_newslot(block7783);
  block_savedest(block7783);
  Object closure7784 = createclosure(1, "_apply");
setclosureframe(closure7784, stackframe);
  addtoclosure(closure7784, selfslot);
  struct UserObject *uo7784 = (struct UserObject*)block7783;
  uo7784->data[0] = (Object)closure7784;
  Method *meth_meth_ast__apply7784 = addmethod2pos(block7783, "_apply", &meth_ast__apply7784, 0);
int argcv_meth_ast__apply7784[] = {0};
meth_meth_ast__apply7784->type = alloc_MethodType(1, argcv_meth_ast__apply7784);
  meth_meth_ast__apply7784->definitionModule = modulename;
  meth_meth_ast__apply7784->definitionLine = 1824;
// compilenode returning block7783
  gc_frame_newslot(block7783);
  params[0] = *var_blk;
  params[1] = block7780;
  params[2] = block7783;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7786 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7779);
// compilenode returning call7786
  gc_frame_end(frame);
  return call7786;
}
Object meth_ast_pretty7787(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1840
  setline(1840);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7788 == NULL) {
    strlit7788 = alloc_String("Blank");
    gc_root(strlit7788);
  }
// compilenode returning strlit7788
  gc_frame_end(frame);
  return strlit7788;
}
Object meth_ast_toGrace7789(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1843
  setline(1843);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7790 == NULL) {
    strlit7790 = alloc_String("");
    gc_root(strlit7790);
  }
// compilenode returning strlit7790
  gc_frame_end(frame);
  return strlit7790;
}
Object meth_ast_new7771(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7772 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7772 = alloc_userobj2(8,9, objclass7772);
  gc_frame_newslot(obj7772);
if (objclass7772 == NULL) {
  glfree(obj7772->class->name);
  obj7772->class->name = "blankNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7772, self, 0);
  addmethodreal(obj7772,"outer", &reader_ast_outer_7773);
  Object oldself7772 = self;
  struct StackFrameObject *oldstackframe7772 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7772);
  gc_frame_newslot((Object)stackframe);
  self = obj7772;
  Object *oldselfslot7772 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7772 = (*(struct UserObject *)self).data[0], lowerouter7772 = thisouter7772;
  if (inheritingObject7772) {
    struct UserObject *inho7772 = (struct UserObject *)inheritingObject7772;
    while (inho7772->super != GraceDefaultObject) inho7772 = (struct UserObject *)inho7772->super;
    inho7772->super = obj7772;
    self = inheritingObject7772;
    *selfslot = self;
    lowerouter7772 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7772;
  }
if (objclass7772 == NULL) {
  Method *reader7774 = addmethodrealflags(obj7772, "kind",&reader_ast_kind_7774, MFLAG_DEF);
  reader7774->definitionModule = modulename;
  reader7774->definitionLine = 1830;
}
adddatum2(obj7772, alloc_Undefined(), 1);
if (objclass7772 == NULL) {
  Method *reader7775 = addmethodrealflags(obj7772, "value",&reader_ast_value_7775, MFLAG_DEF);
  reader7775->definitionModule = modulename;
  reader7775->definitionLine = 1831;
}
adddatum2(obj7772, alloc_Undefined(), 2);
  struct UserObject *uo7776 = (struct UserObject*)obj7772;
  uo7776->data[3] = emptyclosure;
  Method *meth_meth_ast_accept7776 = addmethod2pos(obj7772, "accept", &meth_ast_accept7776, 3);
int argcv_meth_ast_accept7776[] = {1};
meth_meth_ast_accept7776->type = alloc_MethodType(1, argcv_meth_ast_accept7776);
meth_meth_ast_accept7776->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept7776->type->names[0] = "visitor";
  meth_meth_ast_accept7776->definitionModule = modulename;
  meth_meth_ast_accept7776->definitionLine = 1831;
  struct UserObject *uo7777 = (struct UserObject*)obj7772;
  uo7777->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_before_40__41_after7777 = addmethod2pos(obj7772, "map()before()after", &meth_ast_map_40__41_before_40__41_after7777, 4);
int argcv_meth_ast_map_40__41_before_40__41_after7777[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7777->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7777);
  meth_meth_ast_map_40__41_before_40__41_after7777->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7777->definitionLine = 1833;
  struct UserObject *uo7778 = (struct UserObject*)obj7772;
  uo7778->data[5] = emptyclosure;
  Method *meth_meth_ast_map7778 = addmethod2pos(obj7772, "map", &meth_ast_map7778, 5);
int argcv_meth_ast_map7778[] = {1};
meth_meth_ast_map7778->type = alloc_MethodType(1, argcv_meth_ast_map7778);
  meth_meth_ast_map7778->definitionModule = modulename;
  meth_meth_ast_map7778->definitionLine = 1836;
  struct UserObject *uo7787 = (struct UserObject*)obj7772;
  uo7787->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty7787 = addmethod2pos(obj7772, "pretty", &meth_ast_pretty7787, 6);
int argcv_meth_ast_pretty7787[] = {1};
meth_meth_ast_pretty7787->type = alloc_MethodType(1, argcv_meth_ast_pretty7787);
  meth_meth_ast_pretty7787->definitionModule = modulename;
  meth_meth_ast_pretty7787->definitionLine = 1839;
  struct UserObject *uo7789 = (struct UserObject*)obj7772;
  uo7789->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace7789 = addmethod2pos(obj7772, "toGrace", &meth_ast_toGrace7789, 7);
int argcv_meth_ast_toGrace7789[] = {1};
meth_meth_ast_toGrace7789->type = alloc_MethodType(1, argcv_meth_ast_toGrace7789);
meth_meth_ast_toGrace7789->type->types[0] = type_Number;
meth_meth_ast_toGrace7789->type->names[0] = "depth";
  meth_meth_ast_toGrace7789->definitionModule = modulename;
  meth_meth_ast_toGrace7789->definitionLine = 1842;
  sourceObject = obj7772;
// Begin line 1828
  setline(1828);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7791 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7792 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7791);
// compilenode returning call7792
  struct UserObject *obj7772_uo = (struct UserObject *)obj7772;
  obj7772_uo->super = call7792;
  sourceObject = obj7772;
// Begin line 1829
  setline(1829);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7793 == NULL) {
    strlit7793 = alloc_String("blank");
    gc_root(strlit7793);
  }
// compilenode returning strlit7793
  adddatum2(obj7772, strlit7793, 1);
  sourceObject = obj7772;
// Begin line 1830
  setline(1830);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7794 == NULL) {
    strlit7794 = alloc_String("blank");
    gc_root(strlit7794);
  }
// compilenode returning strlit7794
  adddatum2(obj7772, strlit7794, 2);
  sourceObject = obj7772;
  sourceObject = obj7772;
  sourceObject = obj7772;
  sourceObject = obj7772;
  sourceObject = obj7772;
objclass7772 = obj7772->class;
  objclass7772->definitionModule = modulename;
  objclass7772->definitionLine = 1824;
  (*(struct UserObject *)self).data[0] = lowerouter7772;
  self = oldself7772;
  selfslot = oldselfslot7772;
  stackframe = oldstackframe7772;
  gc_frame_end(frame);
  return obj7772;
}
Object meth_ast_new7771_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7772 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7772 = alloc_userobj2(8,9, objclass7772);
  gc_frame_newslot(obj7772);
if (objclass7772 == NULL) {
  glfree(obj7772->class->name);
  obj7772->class->name = "blankNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7772, self, 0);
  addmethodreal(obj7772,"outer", &reader_ast_outer_7773);
  Object oldself7772 = self;
  struct StackFrameObject *oldstackframe7772 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7772);
  gc_frame_newslot((Object)stackframe);
  self = obj7772;
  Object *oldselfslot7772 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7772 = (*(struct UserObject *)self).data[0], lowerouter7772 = thisouter7772;
  if (inheritingObject7772) {
    struct UserObject *inho7772 = (struct UserObject *)inheritingObject7772;
    while (inho7772->super != GraceDefaultObject) inho7772 = (struct UserObject *)inho7772->super;
    inho7772->super = obj7772;
    self = inheritingObject7772;
    *selfslot = self;
    lowerouter7772 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7772;
  }
if (objclass7772 == NULL) {
  Method *reader7774 = addmethodrealflags(obj7772, "kind",&reader_ast_kind_7774, MFLAG_DEF);
  reader7774->definitionModule = modulename;
  reader7774->definitionLine = 1830;
}
adddatum2(obj7772, alloc_Undefined(), 1);
if (objclass7772 == NULL) {
  Method *reader7775 = addmethodrealflags(obj7772, "value",&reader_ast_value_7775, MFLAG_DEF);
  reader7775->definitionModule = modulename;
  reader7775->definitionLine = 1831;
}
adddatum2(obj7772, alloc_Undefined(), 2);
  struct UserObject *uo7776 = (struct UserObject*)obj7772;
  uo7776->data[3] = emptyclosure;
  Method *meth_meth_ast_accept7776 = addmethod2pos(obj7772, "accept", &meth_ast_accept7776, 3);
int argcv_meth_ast_accept7776[] = {1};
meth_meth_ast_accept7776->type = alloc_MethodType(1, argcv_meth_ast_accept7776);
meth_meth_ast_accept7776->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept7776->type->names[0] = "visitor";
  meth_meth_ast_accept7776->definitionModule = modulename;
  meth_meth_ast_accept7776->definitionLine = 1831;
  struct UserObject *uo7777 = (struct UserObject*)obj7772;
  uo7777->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_before_40__41_after7777 = addmethod2pos(obj7772, "map()before()after", &meth_ast_map_40__41_before_40__41_after7777, 4);
int argcv_meth_ast_map_40__41_before_40__41_after7777[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7777->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7777);
  meth_meth_ast_map_40__41_before_40__41_after7777->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7777->definitionLine = 1833;
  struct UserObject *uo7778 = (struct UserObject*)obj7772;
  uo7778->data[5] = emptyclosure;
  Method *meth_meth_ast_map7778 = addmethod2pos(obj7772, "map", &meth_ast_map7778, 5);
int argcv_meth_ast_map7778[] = {1};
meth_meth_ast_map7778->type = alloc_MethodType(1, argcv_meth_ast_map7778);
  meth_meth_ast_map7778->definitionModule = modulename;
  meth_meth_ast_map7778->definitionLine = 1836;
  struct UserObject *uo7787 = (struct UserObject*)obj7772;
  uo7787->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty7787 = addmethod2pos(obj7772, "pretty", &meth_ast_pretty7787, 6);
int argcv_meth_ast_pretty7787[] = {1};
meth_meth_ast_pretty7787->type = alloc_MethodType(1, argcv_meth_ast_pretty7787);
  meth_meth_ast_pretty7787->definitionModule = modulename;
  meth_meth_ast_pretty7787->definitionLine = 1839;
  struct UserObject *uo7789 = (struct UserObject*)obj7772;
  uo7789->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace7789 = addmethod2pos(obj7772, "toGrace", &meth_ast_toGrace7789, 7);
int argcv_meth_ast_toGrace7789[] = {1};
meth_meth_ast_toGrace7789->type = alloc_MethodType(1, argcv_meth_ast_toGrace7789);
meth_meth_ast_toGrace7789->type->types[0] = type_Number;
meth_meth_ast_toGrace7789->type->names[0] = "depth";
  meth_meth_ast_toGrace7789->definitionModule = modulename;
  meth_meth_ast_toGrace7789->definitionLine = 1842;
  sourceObject = obj7772;
// Begin line 1828
  setline(1828);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7791 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7792 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7791);
// compilenode returning call7792
  struct UserObject *obj7772_uo = (struct UserObject *)obj7772;
  obj7772_uo->super = call7792;
  sourceObject = obj7772;
// Begin line 1829
  setline(1829);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7793 == NULL) {
    strlit7793 = alloc_String("blank");
    gc_root(strlit7793);
  }
// compilenode returning strlit7793
  adddatum2(obj7772, strlit7793, 1);
  sourceObject = obj7772;
// Begin line 1830
  setline(1830);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7794 == NULL) {
    strlit7794 = alloc_String("blank");
    gc_root(strlit7794);
  }
// compilenode returning strlit7794
  adddatum2(obj7772, strlit7794, 2);
  sourceObject = obj7772;
  sourceObject = obj7772;
  sourceObject = obj7772;
  sourceObject = obj7772;
  sourceObject = obj7772;
objclass7772 = obj7772->class;
  objclass7772->definitionModule = modulename;
  objclass7772->definitionLine = 1824;
  (*(struct UserObject *)self).data[0] = lowerouter7772;
  self = oldself7772;
  selfslot = oldselfslot7772;
  stackframe = oldstackframe7772;
  gc_frame_end(frame);
  return obj7772;
}
Object meth_ast_signaturePart7796(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 39, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "signaturePart");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_signaturePart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for signaturePart (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for signaturePart");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1847
  setline(1847);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_signaturePart
  gc_frame_end(frame);
  return *var_signaturePart;
}
Object meth_ast_map_40__41_before_40__41_after7807(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_signaturePart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1864
  setline(1864);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7808 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call7809 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe7808);
// compilenode returning call7809
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7810 = gc_frame_new();
  int callframe7811 = gc_frame_new();
  partcv[0] = 0;
  Object call7812 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7811);
// compilenode returning call7812
  gc_frame_newslot(call7812);
  int callframe7813 = gc_frame_new();
  int callframe7814 = gc_frame_new();
  partcv[0] = 0;
  Object call7815 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7814);
// compilenode returning call7815
  gc_frame_newslot(call7815);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe7816 = gc_frame_new();
  int callframe7817 = gc_frame_new();
  Object call7818 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7817);
// compilenode returning call7818
// compilenode returning call7818
  partcv[0] = 0;
  Object call7819 = callmethodflags(call7818, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7816);
// compilenode returning call7819
// compilenode returning call7819
  params[0] = call7815;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7820 = callmethodflags(call7819, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7813);
// compilenode returning call7820
  gc_frame_newslot(call7820);
  int callframe7821 = gc_frame_new();
  partcv[0] = 0;
  Object call7822 = callmethodflags(self, "vararg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7821);
// compilenode returning call7822
  gc_frame_newslot(call7822);
// compilenode returning *var_signaturePart
  params[0] = call7812;
  params[1] = call7820;
  params[2] = call7822;
  partcv[0] = 3;
  Object call7823 = callmethod(*var_signaturePart, "new",
    1, partcv, params);
  gc_frame_end(callframe7810);
// compilenode returning call7823
  *var_n = call7823;
  if (call7823 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1866
  setline(1866);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7824 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7825 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7824);
// compilenode returning call7825
  *var_n = call7825;
  if (call7825 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1867
  setline(1867);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7827 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7828 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe7827);
// compilenode returning call7828
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply7832(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply7835(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map7829(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1871
  setline(1871);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7830 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block7831 = alloc_Block(NULL, NULL, "ast", 1871);
  gc_frame_newslot(block7831);
  block_savedest(block7831);
  Object closure7832 = createclosure(1, "_apply");
setclosureframe(closure7832, stackframe);
  addtoclosure(closure7832, selfslot);
  struct UserObject *uo7832 = (struct UserObject*)block7831;
  uo7832->data[0] = (Object)closure7832;
  Method *meth_meth_ast__apply7832 = addmethod2pos(block7831, "_apply", &meth_ast__apply7832, 0);
int argcv_meth_ast__apply7832[] = {0};
meth_meth_ast__apply7832->type = alloc_MethodType(1, argcv_meth_ast__apply7832);
  meth_meth_ast__apply7832->definitionModule = modulename;
  meth_meth_ast__apply7832->definitionLine = 1865;
// compilenode returning block7831
  gc_frame_newslot(block7831);
  Object block7834 = alloc_Block(NULL, NULL, "ast", 1871);
  gc_frame_newslot(block7834);
  block_savedest(block7834);
  Object closure7835 = createclosure(1, "_apply");
setclosureframe(closure7835, stackframe);
  addtoclosure(closure7835, selfslot);
  struct UserObject *uo7835 = (struct UserObject*)block7834;
  uo7835->data[0] = (Object)closure7835;
  Method *meth_meth_ast__apply7835 = addmethod2pos(block7834, "_apply", &meth_ast__apply7835, 0);
int argcv_meth_ast__apply7835[] = {0};
meth_meth_ast__apply7835->type = alloc_MethodType(1, argcv_meth_ast__apply7835);
  meth_meth_ast__apply7835->definitionModule = modulename;
  meth_meth_ast__apply7835->definitionLine = 1865;
// compilenode returning block7834
  gc_frame_newslot(block7834);
  params[0] = *var_blk;
  params[1] = block7831;
  params[2] = block7834;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7837 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7830);
// compilenode returning call7837
  gc_frame_end(frame);
  return call7837;
}
Object meth_ast_new7799(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_signaturePart = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_values = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_values, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_values = &(stackframe->slots[0]);
  *var_values = var_init_values;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7800 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7800 = alloc_userobj2(15,12, objclass7800);
  gc_frame_newslot(obj7800);
if (objclass7800 == NULL) {
  glfree(obj7800->class->name);
  obj7800->class->name = "signaturePart";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7800, self, 0);
  addmethodreal(obj7800,"outer", &reader_ast_outer_7801);
  Object oldself7800 = self;
  struct StackFrameObject *oldstackframe7800 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7800);
  gc_frame_newslot((Object)stackframe);
  self = obj7800;
  Object *oldselfslot7800 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7800 = (*(struct UserObject *)self).data[0], lowerouter7800 = thisouter7800;
  if (inheritingObject7800) {
    struct UserObject *inho7800 = (struct UserObject *)inheritingObject7800;
    while (inho7800->super != GraceDefaultObject) inho7800 = (struct UserObject *)inho7800->super;
    inho7800->super = obj7800;
    self = inheritingObject7800;
    *selfslot = self;
    lowerouter7800 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7800;
  }
if (objclass7800 == NULL) {
  Method *reader7802 = addmethodrealflags(obj7800, "kind",&reader_ast_kind_7802, MFLAG_DEF);
  reader7802->definitionModule = modulename;
  reader7802->definitionLine = 1850;
}
adddatum2(obj7800, alloc_Undefined(), 1);
if (objclass7800 == NULL) {
  Method *reader7803 = addmethodrealflags(obj7800, "name",&reader_ast_name_7803, 0);
  Method *writer7803 = addmethodrealflags(obj7800, "name:=",&writer_ast_name_7803, 0);
  reader7803->definitionModule = modulename;
  writer7803->definitionModule = modulename;
  reader7803->definitionLine = 1851;
  writer7803->definitionLine = 1851;
}
obj7800->flags |= OFLAG_MUTABLE;
adddatum2(obj7800, alloc_Undefined(), 2);
if (objclass7800 == NULL) {
  Method *reader7804 = addmethodrealflags(obj7800, "params",&reader_ast_params_7804, 0);
  Method *writer7804 = addmethodrealflags(obj7800, "params:=",&writer_ast_params_7804, 0);
  reader7804->definitionModule = modulename;
  writer7804->definitionModule = modulename;
  reader7804->definitionLine = 1852;
  writer7804->definitionLine = 1852;
}
obj7800->flags |= OFLAG_MUTABLE;
adddatum2(obj7800, alloc_Undefined(), 3);
if (objclass7800 == NULL) {
  Method *reader7805 = addmethodrealflags(obj7800, "vararg",&reader_ast_vararg_7805, 0);
  Method *writer7805 = addmethodrealflags(obj7800, "vararg:=",&writer_ast_vararg_7805, 0);
  reader7805->definitionModule = modulename;
  writer7805->definitionModule = modulename;
  reader7805->definitionLine = 1853;
  writer7805->definitionLine = 1853;
}
obj7800->flags |= OFLAG_MUTABLE;
adddatum2(obj7800, alloc_Undefined(), 4);
if (objclass7800 == NULL) {
  Method *reader7806 = addmethodrealflags(obj7800, "generics",&reader_ast_generics_7806, 0);
  Method *writer7806 = addmethodrealflags(obj7800, "generics:=",&writer_ast_generics_7806, 0);
  reader7806->definitionModule = modulename;
  writer7806->definitionModule = modulename;
  reader7806->definitionLine = 1854;
  writer7806->definitionLine = 1854;
}
obj7800->flags |= OFLAG_MUTABLE;
adddatum2(obj7800, alloc_Undefined(), 5);
  block_savedest(obj7800);
  Object closure7807 = createclosure(1, "map()before()after");
setclosureframe(closure7807, stackframe);
  addtoclosure(closure7807, var_signaturePart);
  struct UserObject *uo7807 = (struct UserObject*)obj7800;
  uo7807->data[6] = (Object)closure7807;
  Method *meth_meth_ast_map_40__41_before_40__41_after7807 = addmethod2pos(obj7800, "map()before()after", &meth_ast_map_40__41_before_40__41_after7807, 6);
int argcv_meth_ast_map_40__41_before_40__41_after7807[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7807->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7807);
  meth_meth_ast_map_40__41_before_40__41_after7807->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7807->definitionLine = 1863;
  struct UserObject *uo7829 = (struct UserObject*)obj7800;
  uo7829->data[7] = emptyclosure;
  Method *meth_meth_ast_map7829 = addmethod2pos(obj7800, "map", &meth_ast_map7829, 7);
int argcv_meth_ast_map7829[] = {1};
meth_meth_ast_map7829->type = alloc_MethodType(1, argcv_meth_ast_map7829);
  meth_meth_ast_map7829->definitionModule = modulename;
  meth_meth_ast_map7829->definitionLine = 1870;
  sourceObject = obj7800;
// Begin line 1848
  setline(1848);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7838 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7839 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7838);
// compilenode returning call7839
  struct UserObject *obj7800_uo = (struct UserObject *)obj7800;
  obj7800_uo->super = call7839;
  sourceObject = obj7800;
// Begin line 1849
  setline(1849);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7840 == NULL) {
    strlit7840 = alloc_String("signaturepart");
    gc_root(strlit7840);
  }
// compilenode returning strlit7840
  adddatum2(obj7800, strlit7840, 1);
  sourceObject = obj7800;
// Begin line 1850
  setline(1850);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7841 == NULL) {
    strlit7841 = alloc_String("");
    gc_root(strlit7841);
  }
// compilenode returning strlit7841
  adddatum2(obj7800, strlit7841, 2);
  sourceObject = obj7800;
// Begin line 1851
  setline(1851);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array7842 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array7842
  adddatum2(obj7800, array7842, 3);
  sourceObject = obj7800;
// Begin line 1852
  setline(1852);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7843 = alloc_Boolean(0);
// compilenode returning bool7843
  adddatum2(obj7800, bool7843, 4);
  sourceObject = obj7800;
// Begin line 1853
  setline(1853);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array7844 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array7844
  adddatum2(obj7800, array7844, 5);
  sourceObject = obj7800;
// Begin line 1857
  setline(1857);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1854
  setline(1854);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num7847 = alloc_Float64(0);
// compilenode returning num7847
  int op_slot_right_7846 = gc_frame_newslot(num7847);
  int callframe7849 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call7850 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe7849);
// compilenode returning call7850
// compilenode returning call7850
  int op_slot_left_7846 = gc_frame_newslot(call7850);
  params[0] = num7847;
  partcv[0] = 1;
  Object opresult7851 = callmethod(call7850, ">", 1, partcv, params);
// compilenode returning opresult7851
  Object if7845 = done;
struct StackFrameObject *iftmpstackframe7845 = stackframe;
  if (istrue(opresult7851)) {
stackframe = alloc_StackFrame(0, iftmpstackframe7845);
gc_frame_newslot((Object)stackframe);
// Begin line 1856
  setline(1856);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1854
  setline(1854);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7852 = gc_frame_new();
// Begin line 1856
  setline(1856);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1855
  setline(1855);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  Object num7853 = alloc_Float64(1);
// compilenode returning num7853
  params[0] = num7853;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres7854 = callmethod(*var_values, "[]", 1, partcv, params);
// compilenode returning idxres7854
  gc_frame_newslot(idxres7854);
  params[0] = idxres7854;
  partcv[0] = 1;
  Object call7855 = callmethodflags(self, "name:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7852);
// compilenode returning call7855
// compilenode returning done
    gc_frame_newslot(done);
    if7845 = done;
  } else {
  }
stackframe = iftmpstackframe7845;
// compilenode returning if7845
  sourceObject = obj7800;
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1857
  setline(1857);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num7858 = alloc_Float64(1);
// compilenode returning num7858
  int op_slot_right_7857 = gc_frame_newslot(num7858);
  int callframe7860 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call7861 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe7860);
// compilenode returning call7861
// compilenode returning call7861
  int op_slot_left_7857 = gc_frame_newslot(call7861);
  params[0] = num7858;
  partcv[0] = 1;
  Object opresult7862 = callmethod(call7861, ">", 1, partcv, params);
// compilenode returning opresult7862
  Object if7856 = done;
struct StackFrameObject *iftmpstackframe7856 = stackframe;
  if (istrue(opresult7862)) {
stackframe = alloc_StackFrame(0, iftmpstackframe7856);
gc_frame_newslot((Object)stackframe);
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1857
  setline(1857);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7863 = gc_frame_new();
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1858
  setline(1858);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  Object num7864 = alloc_Float64(2);
// compilenode returning num7864
  params[0] = num7864;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres7865 = callmethod(*var_values, "[]", 1, partcv, params);
// compilenode returning idxres7865
  gc_frame_newslot(idxres7865);
  params[0] = idxres7865;
  partcv[0] = 1;
  Object call7866 = callmethodflags(self, "params:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7863);
// compilenode returning call7866
// compilenode returning done
    gc_frame_newslot(done);
    if7856 = done;
  } else {
  }
stackframe = iftmpstackframe7856;
// compilenode returning if7856
  sourceObject = obj7800;
// Begin line 1863
  setline(1863);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num7869 = alloc_Float64(2);
// compilenode returning num7869
  int op_slot_right_7868 = gc_frame_newslot(num7869);
  int callframe7871 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call7872 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe7871);
// compilenode returning call7872
// compilenode returning call7872
  int op_slot_left_7868 = gc_frame_newslot(call7872);
  params[0] = num7869;
  partcv[0] = 1;
  Object opresult7873 = callmethod(call7872, ">", 1, partcv, params);
// compilenode returning opresult7873
  Object if7867 = done;
struct StackFrameObject *iftmpstackframe7867 = stackframe;
  if (istrue(opresult7873)) {
stackframe = alloc_StackFrame(0, iftmpstackframe7867);
gc_frame_newslot((Object)stackframe);
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7874 = gc_frame_new();
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1861
  setline(1861);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  Object num7875 = alloc_Float64(3);
// compilenode returning num7875
  params[0] = num7875;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres7876 = callmethod(*var_values, "[]", 1, partcv, params);
// compilenode returning idxres7876
  gc_frame_newslot(idxres7876);
  params[0] = idxres7876;
  partcv[0] = 1;
  Object call7877 = callmethodflags(self, "vararg:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7874);
// compilenode returning call7877
// compilenode returning done
    gc_frame_newslot(done);
    if7867 = done;
  } else {
  }
stackframe = iftmpstackframe7867;
// compilenode returning if7867
  sourceObject = obj7800;
  sourceObject = obj7800;
objclass7800 = obj7800->class;
  objclass7800->definitionModule = modulename;
  objclass7800->definitionLine = 1824;
  (*(struct UserObject *)self).data[0] = lowerouter7800;
  self = oldself7800;
  selfslot = oldselfslot7800;
  stackframe = oldstackframe7800;
  gc_frame_end(frame);
  return obj7800;
}
Object meth_ast_new7799_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_signaturePart = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_values = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_values, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_values = &(stackframe->slots[0]);
  *var_values = var_init_values;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7800 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7800 = alloc_userobj2(15,12, objclass7800);
  gc_frame_newslot(obj7800);
if (objclass7800 == NULL) {
  glfree(obj7800->class->name);
  obj7800->class->name = "signaturePart";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7800, self, 0);
  addmethodreal(obj7800,"outer", &reader_ast_outer_7801);
  Object oldself7800 = self;
  struct StackFrameObject *oldstackframe7800 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7800);
  gc_frame_newslot((Object)stackframe);
  self = obj7800;
  Object *oldselfslot7800 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7800 = (*(struct UserObject *)self).data[0], lowerouter7800 = thisouter7800;
  if (inheritingObject7800) {
    struct UserObject *inho7800 = (struct UserObject *)inheritingObject7800;
    while (inho7800->super != GraceDefaultObject) inho7800 = (struct UserObject *)inho7800->super;
    inho7800->super = obj7800;
    self = inheritingObject7800;
    *selfslot = self;
    lowerouter7800 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7800;
  }
if (objclass7800 == NULL) {
  Method *reader7802 = addmethodrealflags(obj7800, "kind",&reader_ast_kind_7802, MFLAG_DEF);
  reader7802->definitionModule = modulename;
  reader7802->definitionLine = 1850;
}
adddatum2(obj7800, alloc_Undefined(), 1);
if (objclass7800 == NULL) {
  Method *reader7803 = addmethodrealflags(obj7800, "name",&reader_ast_name_7803, 0);
  Method *writer7803 = addmethodrealflags(obj7800, "name:=",&writer_ast_name_7803, 0);
  reader7803->definitionModule = modulename;
  writer7803->definitionModule = modulename;
  reader7803->definitionLine = 1851;
  writer7803->definitionLine = 1851;
}
obj7800->flags |= OFLAG_MUTABLE;
adddatum2(obj7800, alloc_Undefined(), 2);
if (objclass7800 == NULL) {
  Method *reader7804 = addmethodrealflags(obj7800, "params",&reader_ast_params_7804, 0);
  Method *writer7804 = addmethodrealflags(obj7800, "params:=",&writer_ast_params_7804, 0);
  reader7804->definitionModule = modulename;
  writer7804->definitionModule = modulename;
  reader7804->definitionLine = 1852;
  writer7804->definitionLine = 1852;
}
obj7800->flags |= OFLAG_MUTABLE;
adddatum2(obj7800, alloc_Undefined(), 3);
if (objclass7800 == NULL) {
  Method *reader7805 = addmethodrealflags(obj7800, "vararg",&reader_ast_vararg_7805, 0);
  Method *writer7805 = addmethodrealflags(obj7800, "vararg:=",&writer_ast_vararg_7805, 0);
  reader7805->definitionModule = modulename;
  writer7805->definitionModule = modulename;
  reader7805->definitionLine = 1853;
  writer7805->definitionLine = 1853;
}
obj7800->flags |= OFLAG_MUTABLE;
adddatum2(obj7800, alloc_Undefined(), 4);
if (objclass7800 == NULL) {
  Method *reader7806 = addmethodrealflags(obj7800, "generics",&reader_ast_generics_7806, 0);
  Method *writer7806 = addmethodrealflags(obj7800, "generics:=",&writer_ast_generics_7806, 0);
  reader7806->definitionModule = modulename;
  writer7806->definitionModule = modulename;
  reader7806->definitionLine = 1854;
  writer7806->definitionLine = 1854;
}
obj7800->flags |= OFLAG_MUTABLE;
adddatum2(obj7800, alloc_Undefined(), 5);
  block_savedest(obj7800);
  Object closure7807 = createclosure(1, "map()before()after");
setclosureframe(closure7807, stackframe);
  addtoclosure(closure7807, var_signaturePart);
  struct UserObject *uo7807 = (struct UserObject*)obj7800;
  uo7807->data[6] = (Object)closure7807;
  Method *meth_meth_ast_map_40__41_before_40__41_after7807 = addmethod2pos(obj7800, "map()before()after", &meth_ast_map_40__41_before_40__41_after7807, 6);
int argcv_meth_ast_map_40__41_before_40__41_after7807[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7807->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7807);
  meth_meth_ast_map_40__41_before_40__41_after7807->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7807->definitionLine = 1863;
  struct UserObject *uo7829 = (struct UserObject*)obj7800;
  uo7829->data[7] = emptyclosure;
  Method *meth_meth_ast_map7829 = addmethod2pos(obj7800, "map", &meth_ast_map7829, 7);
int argcv_meth_ast_map7829[] = {1};
meth_meth_ast_map7829->type = alloc_MethodType(1, argcv_meth_ast_map7829);
  meth_meth_ast_map7829->definitionModule = modulename;
  meth_meth_ast_map7829->definitionLine = 1870;
  sourceObject = obj7800;
// Begin line 1848
  setline(1848);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7838 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7839 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7838);
// compilenode returning call7839
  struct UserObject *obj7800_uo = (struct UserObject *)obj7800;
  obj7800_uo->super = call7839;
  sourceObject = obj7800;
// Begin line 1849
  setline(1849);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7840 == NULL) {
    strlit7840 = alloc_String("signaturepart");
    gc_root(strlit7840);
  }
// compilenode returning strlit7840
  adddatum2(obj7800, strlit7840, 1);
  sourceObject = obj7800;
// Begin line 1850
  setline(1850);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7841 == NULL) {
    strlit7841 = alloc_String("");
    gc_root(strlit7841);
  }
// compilenode returning strlit7841
  adddatum2(obj7800, strlit7841, 2);
  sourceObject = obj7800;
// Begin line 1851
  setline(1851);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array7842 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array7842
  adddatum2(obj7800, array7842, 3);
  sourceObject = obj7800;
// Begin line 1852
  setline(1852);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7843 = alloc_Boolean(0);
// compilenode returning bool7843
  adddatum2(obj7800, bool7843, 4);
  sourceObject = obj7800;
// Begin line 1853
  setline(1853);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array7844 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array7844
  adddatum2(obj7800, array7844, 5);
  sourceObject = obj7800;
// Begin line 1857
  setline(1857);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1854
  setline(1854);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num7847 = alloc_Float64(0);
// compilenode returning num7847
  int op_slot_right_7846 = gc_frame_newslot(num7847);
  int callframe7849 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call7850 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe7849);
// compilenode returning call7850
// compilenode returning call7850
  int op_slot_left_7846 = gc_frame_newslot(call7850);
  params[0] = num7847;
  partcv[0] = 1;
  Object opresult7851 = callmethod(call7850, ">", 1, partcv, params);
// compilenode returning opresult7851
  Object if7845 = done;
struct StackFrameObject *iftmpstackframe7845 = stackframe;
  if (istrue(opresult7851)) {
stackframe = alloc_StackFrame(0, iftmpstackframe7845);
gc_frame_newslot((Object)stackframe);
// Begin line 1856
  setline(1856);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1854
  setline(1854);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7852 = gc_frame_new();
// Begin line 1856
  setline(1856);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1855
  setline(1855);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  Object num7853 = alloc_Float64(1);
// compilenode returning num7853
  params[0] = num7853;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres7854 = callmethod(*var_values, "[]", 1, partcv, params);
// compilenode returning idxres7854
  gc_frame_newslot(idxres7854);
  params[0] = idxres7854;
  partcv[0] = 1;
  Object call7855 = callmethodflags(self, "name:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7852);
// compilenode returning call7855
// compilenode returning done
    gc_frame_newslot(done);
    if7845 = done;
  } else {
  }
stackframe = iftmpstackframe7845;
// compilenode returning if7845
  sourceObject = obj7800;
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1857
  setline(1857);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num7858 = alloc_Float64(1);
// compilenode returning num7858
  int op_slot_right_7857 = gc_frame_newslot(num7858);
  int callframe7860 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call7861 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe7860);
// compilenode returning call7861
// compilenode returning call7861
  int op_slot_left_7857 = gc_frame_newslot(call7861);
  params[0] = num7858;
  partcv[0] = 1;
  Object opresult7862 = callmethod(call7861, ">", 1, partcv, params);
// compilenode returning opresult7862
  Object if7856 = done;
struct StackFrameObject *iftmpstackframe7856 = stackframe;
  if (istrue(opresult7862)) {
stackframe = alloc_StackFrame(0, iftmpstackframe7856);
gc_frame_newslot((Object)stackframe);
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1857
  setline(1857);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7863 = gc_frame_new();
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1858
  setline(1858);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  Object num7864 = alloc_Float64(2);
// compilenode returning num7864
  params[0] = num7864;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres7865 = callmethod(*var_values, "[]", 1, partcv, params);
// compilenode returning idxres7865
  gc_frame_newslot(idxres7865);
  params[0] = idxres7865;
  partcv[0] = 1;
  Object call7866 = callmethodflags(self, "params:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7863);
// compilenode returning call7866
// compilenode returning done
    gc_frame_newslot(done);
    if7856 = done;
  } else {
  }
stackframe = iftmpstackframe7856;
// compilenode returning if7856
  sourceObject = obj7800;
// Begin line 1863
  setline(1863);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num7869 = alloc_Float64(2);
// compilenode returning num7869
  int op_slot_right_7868 = gc_frame_newslot(num7869);
  int callframe7871 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call7872 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe7871);
// compilenode returning call7872
// compilenode returning call7872
  int op_slot_left_7868 = gc_frame_newslot(call7872);
  params[0] = num7869;
  partcv[0] = 1;
  Object opresult7873 = callmethod(call7872, ">", 1, partcv, params);
// compilenode returning opresult7873
  Object if7867 = done;
struct StackFrameObject *iftmpstackframe7867 = stackframe;
  if (istrue(opresult7873)) {
stackframe = alloc_StackFrame(0, iftmpstackframe7867);
gc_frame_newslot((Object)stackframe);
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7874 = gc_frame_new();
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1861
  setline(1861);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  Object num7875 = alloc_Float64(3);
// compilenode returning num7875
  params[0] = num7875;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres7876 = callmethod(*var_values, "[]", 1, partcv, params);
// compilenode returning idxres7876
  gc_frame_newslot(idxres7876);
  params[0] = idxres7876;
  partcv[0] = 1;
  Object call7877 = callmethodflags(self, "vararg:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7874);
// compilenode returning call7877
// compilenode returning done
    gc_frame_newslot(done);
    if7867 = done;
  } else {
  }
stackframe = iftmpstackframe7867;
// compilenode returning if7867
  sourceObject = obj7800;
  sourceObject = obj7800;
objclass7800 = obj7800->class;
  objclass7800->definitionModule = modulename;
  objclass7800->definitionLine = 1824;
  (*(struct UserObject *)self).data[0] = lowerouter7800;
  self = oldself7800;
  selfslot = oldselfslot7800;
  stackframe = oldstackframe7800;
  gc_frame_end(frame);
  return obj7800;
}
Object meth_ast_ast7879(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 40, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ast");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ast = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for ast (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for <Identifier[ast]>");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2022
  setline(2022);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_ast
  gc_frame_end(frame);
  return *var_ast;
}
Object meth_ast_visitCall7882(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitCall (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitCall");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2027
  setline(2027);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7883 = gc_frame_new();
// Begin line 2026
  setline(2026);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7884 = alloc_Boolean(1);
// compilenode returning bool7884
  gc_frame_newslot(bool7884);
// compilenode returning *var_c
  params[0] = bool7884;
  partcv[0] = 1;
  Object call7885 = callmethod(*var_c, "isPattern:=",
    1, partcv, params);
  gc_frame_end(callframe7883);
// compilenode returning call7885
// compilenode returning done
// Begin line 2027
  setline(2027);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7886 = alloc_Boolean(1);
// compilenode returning bool7886
  gc_frame_end(frame);
  return bool7886;
}
Object meth_ast_patternMarkVisitor7889(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 41, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "patternMarkVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_patternMarkVisitor = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for patternMarkVisitor (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for <Identifier[patternMarkVisitor]>");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2023
  setline(2023);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_patternMarkVisitor
  gc_frame_end(frame);
  return *var_patternMarkVisitor;
}
Object module_ast_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(45, 45);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = module_StandardPrelude_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<ast>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(45, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object params[1];
  int partcv[2];
Object *var_util = alloc_var();
Object *var_collections = alloc_var();
  Object *var_baseNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "baseNode");
  Object *var_forNode = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "forNode");
  Object *var_whileNode = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "whileNode");
  Object *var_ifNode = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "ifNode");
  Object *var_blockNode = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "blockNode");
  Object *var_catchCaseNode = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "catchCaseNode");
  Object *var_matchCaseNode = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "matchCaseNode");
  Object *var_methodTypeNode = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "methodTypeNode");
  Object *var_typeNode = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "typeNode");
  Object *var_methodNode = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "methodNode");
  Object *var_callNode = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "callNode");
  Object *var_classNode = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "classNode");
  Object *var_objectNode = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "objectNode");
  Object *var_arrayNode = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "arrayNode");
  Object *var_memberNode = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "memberNode");
  Object *var_genericNode = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "genericNode");
  Object *var_identifierNode = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "identifierNode");
  Object *var_octetsNode = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "octetsNode");
  Object *var_stringNode = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "stringNode");
  Object *var_numNode = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "numNode");
  Object *var_opNode = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "opNode");
  Object *var_indexNode = &(stackframe->slots[22]);
  setframeelementname(stackframe, 22, "indexNode");
  Object *var_bindNode = &(stackframe->slots[23]);
  setframeelementname(stackframe, 23, "bindNode");
  Object *var_defDecNode = &(stackframe->slots[24]);
  setframeelementname(stackframe, 24, "defDecNode");
  Object *var_varDecNode = &(stackframe->slots[25]);
  setframeelementname(stackframe, 25, "varDecNode");
  Object *var_importNode = &(stackframe->slots[26]);
  setframeelementname(stackframe, 26, "importNode");
  Object *var_dialectNode = &(stackframe->slots[27]);
  setframeelementname(stackframe, 27, "dialectNode");
  Object *var_returnNode = &(stackframe->slots[28]);
  setframeelementname(stackframe, 28, "returnNode");
  Object *var_inheritsNode = &(stackframe->slots[29]);
  setframeelementname(stackframe, 29, "inheritsNode");
  Object *var_blankNode = &(stackframe->slots[30]);
  setframeelementname(stackframe, 30, "blankNode");
  Object *var_signaturePart = &(stackframe->slots[31]);
  setframeelementname(stackframe, 31, "signaturePart");
  Object *var_ASTVisitor = &(stackframe->slots[32]);
  setframeelementname(stackframe, 32, "ASTVisitor");
  Object *var_ast = &(stackframe->slots[33]);
  setframeelementname(stackframe, 33, "ast");
  Object *var_patternMarkVisitor = &(stackframe->slots[34]);
  setframeelementname(stackframe, 34, "patternMarkVisitor");
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure0 = createclosure(1, "listMap()before()after");
setclosureframe(closure0, stackframe);
  addtoclosure(closure0, var_collections);
  struct UserObject *uo0 = (struct UserObject*)self;
  uo0->data[1] = (Object)closure0;
  Method *meth_meth_ast_listMap_40__41_before_40__41_after0 = addmethod2pos(self, "listMap()before()after", &meth_ast_listMap_40__41_before_40__41_after0, 1);
int argcv_meth_ast_listMap_40__41_before_40__41_after0[] = {2, 1, 1};
meth_meth_ast_listMap_40__41_before_40__41_after0->type = alloc_MethodType(3, argcv_meth_ast_listMap_40__41_before_40__41_after0);
  meth_meth_ast_listMap_40__41_before_40__41_after0->definitionModule = modulename;
  meth_meth_ast_listMap_40__41_before_40__41_after0->definitionLine = 22;
// compilenode returning 
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
  struct UserObject *uo14 = (struct UserObject*)self;
  uo14->data[2] = emptyclosure;
  Method *meth_meth_ast_maybeMap14 = addmethod2pos(self, "maybeMap", &meth_ast_maybeMap14, 2);
int argcv_meth_ast_maybeMap14[] = {4};
meth_meth_ast_maybeMap14->type = alloc_MethodType(1, argcv_meth_ast_maybeMap14);
  meth_meth_ast_maybeMap14->definitionModule = modulename;
  meth_meth_ast_maybeMap14->definitionLine = 30;
// compilenode returning 
// Begin line 1875
  setline(1875);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure22 = createclosure(1, "callWithPart");
setclosureframe(closure22, stackframe);
  addtoclosure(closure22, var_baseNode);
  struct UserObject *uo22 = (struct UserObject*)self;
  uo22->data[3] = (Object)closure22;
  Method *meth_meth_ast_callWithPart22 = addmethod2pos(self, "callWithPart", &meth_ast_callWithPart22, 3);
int argcv_meth_ast_callWithPart22[] = {0};
meth_meth_ast_callWithPart22->type = alloc_MethodType(1, argcv_meth_ast_callWithPart22);
  meth_meth_ast_callWithPart22->definitionModule = modulename;
  meth_meth_ast_callWithPart22->definitionLine = 1875;
  block_savedest(self);
  Object closure94 = createclosure(1, "callWithPart()object");
setclosureframe(closure94, stackframe);
  addtoclosure(closure94, var_baseNode);
  Method *meth_meth_ast_callWithPart22_object = addmethod2pos(self, "callWithPart()object", &meth_ast_callWithPart22_object, 3);
  meth_meth_ast_callWithPart22_object->definitionModule = modulename;
  meth_meth_ast_callWithPart22_object->definitionLine = 1875;
// compilenode returning 
// Begin line 1934
  setline(1934);
  setmodule(modulename);
  setsource(originalSourceLines);
// Type ASTVisitor
Object type95 = alloc_Type("ASTVisitor", 28);
*var_ASTVisitor = type95;
add_Method((ClassData)type95, "visitFor", NULL);
add_Method((ClassData)type95, "visitWhile", NULL);
add_Method((ClassData)type95, "visitIf", NULL);
add_Method((ClassData)type95, "visitBlock", NULL);
add_Method((ClassData)type95, "visitMatchCase", NULL);
add_Method((ClassData)type95, "visitCatchCase", NULL);
add_Method((ClassData)type95, "visitMethodType", NULL);
add_Method((ClassData)type95, "visitType", NULL);
add_Method((ClassData)type95, "visitMethod", NULL);
add_Method((ClassData)type95, "visitCall", NULL);
add_Method((ClassData)type95, "visitClass", NULL);
add_Method((ClassData)type95, "visitObject", NULL);
add_Method((ClassData)type95, "visitArray", NULL);
add_Method((ClassData)type95, "visitMember", NULL);
add_Method((ClassData)type95, "visitGeneric", NULL);
add_Method((ClassData)type95, "visitIdentifier", NULL);
add_Method((ClassData)type95, "visitOctets", NULL);
add_Method((ClassData)type95, "visitString", NULL);
add_Method((ClassData)type95, "visitNum", NULL);
add_Method((ClassData)type95, "visitOp", NULL);
add_Method((ClassData)type95, "visitIndex", NULL);
add_Method((ClassData)type95, "visitBind", NULL);
add_Method((ClassData)type95, "visitDefDec", NULL);
add_Method((ClassData)type95, "visitVarDec", NULL);
add_Method((ClassData)type95, "visitImport", NULL);
add_Method((ClassData)type95, "visitReturn", NULL);
add_Method((ClassData)type95, "visitInherits", NULL);
add_Method((ClassData)type95, "visitDialect", NULL);
// Begin line 1886
  setline(1886);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure96 = createclosure(1, "ASTVisitor");
setclosureframe(closure96, stackframe);
  addtoclosure(closure96, var_ASTVisitor);
  struct UserObject *uo96 = (struct UserObject*)self;
  uo96->data[4] = (Object)closure96;
  Method *meth_meth_ast_ASTVisitor96 = addmethod2pos(self, "ASTVisitor", &meth_ast_ASTVisitor96, 4);
int argcv_meth_ast_ASTVisitor96[] = {0};
meth_meth_ast_ASTVisitor96->type = alloc_MethodType(1, argcv_meth_ast_ASTVisitor96);
  meth_meth_ast_ASTVisitor96->definitionModule = modulename;
  meth_meth_ast_ASTVisitor96->definitionLine = 1886;
// compilenode returning 
// compilenode returning done
type_ASTVisitor = *var_ASTVisitor;
// Begin line 1934
  setline(1934);
  setmodule(modulename);
  setsource(originalSourceLines);
  struct UserObject *uo97 = (struct UserObject*)self;
  uo97->data[5] = emptyclosure;
  Method *meth_meth_ast_baseVisitor97 = addmethod2pos(self, "baseVisitor", &meth_ast_baseVisitor97, 5);
int argcv_meth_ast_baseVisitor97[] = {0};
meth_meth_ast_baseVisitor97->type = alloc_MethodType(1, argcv_meth_ast_baseVisitor97);
  meth_meth_ast_baseVisitor97->definitionModule = modulename;
  meth_meth_ast_baseVisitor97->definitionLine = 1934;
  Method *meth_meth_ast_baseVisitor97_object = addmethod2pos(self, "baseVisitor()object", &meth_ast_baseVisitor97_object, 5);
int argcv_meth_ast_baseVisitor97_object[] = {0};
meth_meth_ast_baseVisitor97_object->type = alloc_MethodType(1, argcv_meth_ast_baseVisitor97_object);
  meth_meth_ast_baseVisitor97_object->definitionModule = modulename;
  meth_meth_ast_baseVisitor97_object->definitionLine = 1934;
// compilenode returning 
// Begin line 2031
  setline(2031);
  setmodule(modulename);
  setsource(originalSourceLines);
  struct UserObject *uo157 = (struct UserObject*)self;
  uo157->data[6] = emptyclosure;
  Method *meth_meth_ast_findAnnotation157 = addmethod2pos(self, "findAnnotation", &meth_ast_findAnnotation157, 6);
int argcv_meth_ast_findAnnotation157[] = {2};
meth_meth_ast_findAnnotation157->type = alloc_MethodType(1, argcv_meth_ast_findAnnotation157);
  meth_meth_ast_findAnnotation157->definitionModule = modulename;
  meth_meth_ast_findAnnotation157->definitionLine = 2031;
// compilenode returning 
// Begin line 2044
  setline(2044);
  setmodule(modulename);
  setsource(originalSourceLines);
  struct UserObject *uo187 = (struct UserObject*)self;
  uo187->data[7] = emptyclosure;
  Method *meth_meth_ast_isPublic187 = addmethod2pos(self, "isPublic", &meth_ast_isPublic187, 7);
int argcv_meth_ast_isPublic187[] = {1};
meth_meth_ast_isPublic187->type = alloc_MethodType(1, argcv_meth_ast_isPublic187);
  meth_meth_ast_isPublic187->definitionModule = modulename;
  meth_meth_ast_isPublic187->definitionLine = 2044;
// compilenode returning 
// Begin line 2052
  setline(2052);
  setmodule(modulename);
  setsource(originalSourceLines);
  struct UserObject *uo207 = (struct UserObject*)self;
  uo207->data[8] = emptyclosure;
  Method *meth_meth_ast_isWritable207 = addmethod2pos(self, "isWritable", &meth_ast_isWritable207, 8);
int argcv_meth_ast_isWritable207[] = {1};
meth_meth_ast_isWritable207->type = alloc_MethodType(1, argcv_meth_ast_isWritable207);
  meth_meth_ast_isWritable207->definitionModule = modulename;
  meth_meth_ast_isWritable207->definitionLine = 2052;
// compilenode returning 
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// Import of util as util
  if (module_util == NULL)
    module_util = module_util_init();
  *var_util = module_util;
// compilenode returning done
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// Import of mgcollections as collections
  if (module_mgcollections == NULL)
    module_mgcollections = module_mgcollections_init();
  *var_collections = module_mgcollections;
// compilenode returning done
// compilenode returning 
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2053
  setline(2053);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure227 = createclosure(1, "baseNode");
setclosureframe(closure227, stackframe);
  addtoclosure(closure227, var_baseNode);
  struct UserObject *uo227 = (struct UserObject*)self;
  uo227->data[9] = (Object)closure227;
  Method *meth_meth_ast_baseNode227 = addmethod2pos(self, "baseNode", &meth_ast_baseNode227, 9);
int argcv_meth_ast_baseNode227[] = {0};
meth_meth_ast_baseNode227->type = alloc_MethodType(1, argcv_meth_ast_baseNode227);
  meth_meth_ast_baseNode227->definitionModule = modulename;
  meth_meth_ast_baseNode227->definitionLine = 2053;
// compilenode returning 
// Begin line 2053
  setline(2053);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject228 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj228 = alloc_userobj2(2,4, objclass228);
  gc_frame_newslot(obj228);
// OBJECT OUTER DEC outer
  adddatum2(obj228, self, 0);
  addmethodreal(obj228,"outer", &reader_ast_outer_229);
  Object oldself228 = self;
  struct StackFrameObject *oldstackframe228 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe228);
  gc_frame_newslot((Object)stackframe);
  self = obj228;
  Object *oldselfslot228 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter228 = (*(struct UserObject *)self).data[0], lowerouter228 = thisouter228;
  if (inheritingObject228) {
    struct UserObject *inho228 = (struct UserObject *)inheritingObject228;
    while (inho228->super != GraceDefaultObject) inho228 = (struct UserObject *)inho228->super;
    inho228->super = obj228;
    self = inheritingObject228;
    *selfslot = self;
    lowerouter228 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter228;
  }
  block_savedest(obj228);
  Object closure230 = createclosure(1, "new");
setclosureframe(closure230, stackframe);
  addtoclosure(closure230, var_util);
  struct UserObject *uo230 = (struct UserObject*)obj228;
  uo230->data[1] = (Object)closure230;
  Method *meth_meth_ast_new230 = addmethod2pos(obj228, "new", &meth_ast_new230, 1);
int argcv_meth_ast_new230[] = {0};
meth_meth_ast_new230->type = alloc_MethodType(1, argcv_meth_ast_new230);
  meth_meth_ast_new230->definitionModule = modulename;
  meth_meth_ast_new230->definitionLine = 2053;
  block_savedest(obj228);
  Object closure243 = createclosure(1, "new()object");
setclosureframe(closure243, stackframe);
  addtoclosure(closure243, var_util);
  Method *meth_meth_ast_new230_object = addmethod2pos(obj228, "new()object", &meth_ast_new230_object, 1);
  meth_meth_ast_new230_object->definitionModule = modulename;
  meth_meth_ast_new230_object->definitionLine = 2053;
  sourceObject = obj228;
objclass228 = obj228->class;
  objclass228->definitionModule = modulename;
  objclass228->definitionLine = 2053;
  (*(struct UserObject *)self).data[0] = lowerouter228;
  self = oldself228;
  selfslot = oldselfslot228;
  stackframe = oldstackframe228;
// compilenode returning obj228
  *var_baseNode = obj228;
  if (obj228 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 44
  setline(44);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure244 = createclosure(1, "forNode");
setclosureframe(closure244, stackframe);
  addtoclosure(closure244, var_forNode);
  struct UserObject *uo244 = (struct UserObject*)self;
  uo244->data[10] = (Object)closure244;
  Method *meth_meth_ast_forNode244 = addmethod2pos(self, "forNode", &meth_ast_forNode244, 10);
int argcv_meth_ast_forNode244[] = {0};
meth_meth_ast_forNode244->type = alloc_MethodType(1, argcv_meth_ast_forNode244);
  meth_meth_ast_forNode244->definitionModule = modulename;
  meth_meth_ast_forNode244->definitionLine = 40;
// compilenode returning 
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject245 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj245 = alloc_userobj2(2,4, objclass245);
  gc_frame_newslot(obj245);
// OBJECT OUTER DEC outer
  adddatum2(obj245, self, 0);
  addmethodreal(obj245,"outer", &reader_ast_outer_246);
  Object oldself245 = self;
  struct StackFrameObject *oldstackframe245 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe245);
  gc_frame_newslot((Object)stackframe);
  self = obj245;
  Object *oldselfslot245 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter245 = (*(struct UserObject *)self).data[0], lowerouter245 = thisouter245;
  if (inheritingObject245) {
    struct UserObject *inho245 = (struct UserObject *)inheritingObject245;
    while (inho245->super != GraceDefaultObject) inho245 = (struct UserObject *)inho245->super;
    inho245->super = obj245;
    self = inheritingObject245;
    *selfslot = self;
    lowerouter245 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter245;
  }
  block_savedest(obj245);
  Object closure247 = createclosure(1, "new");
setclosureframe(closure247, stackframe);
  addtoclosure(closure247, var_baseNode);
  struct UserObject *uo247 = (struct UserObject*)obj245;
  uo247->data[1] = (Object)closure247;
  Method *meth_meth_ast_new247 = addmethod2pos(obj245, "new", &meth_ast_new247, 1);
int argcv_meth_ast_new247[] = {2};
meth_meth_ast_new247->type = alloc_MethodType(1, argcv_meth_ast_new247);
  meth_meth_ast_new247->definitionModule = modulename;
  meth_meth_ast_new247->definitionLine = 40;
  block_savedest(obj245);
  Object closure377 = createclosure(1, "new()object");
setclosureframe(closure377, stackframe);
  addtoclosure(closure377, var_baseNode);
  Method *meth_meth_ast_new247_object = addmethod2pos(obj245, "new()object", &meth_ast_new247_object, 1);
  meth_meth_ast_new247_object->definitionModule = modulename;
  meth_meth_ast_new247_object->definitionLine = 40;
  sourceObject = obj245;
objclass245 = obj245->class;
  objclass245->definitionModule = modulename;
  objclass245->definitionLine = 40;
  (*(struct UserObject *)self).data[0] = lowerouter245;
  self = oldself245;
  selfslot = oldselfslot245;
  stackframe = oldstackframe245;
// compilenode returning obj245
  *var_forNode = obj245;
  if (obj245 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 77
  setline(77);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure378 = createclosure(1, "whileNode");
setclosureframe(closure378, stackframe);
  addtoclosure(closure378, var_whileNode);
  struct UserObject *uo378 = (struct UserObject*)self;
  uo378->data[11] = (Object)closure378;
  Method *meth_meth_ast_whileNode378 = addmethod2pos(self, "whileNode", &meth_ast_whileNode378, 11);
int argcv_meth_ast_whileNode378[] = {0};
meth_meth_ast_whileNode378->type = alloc_MethodType(1, argcv_meth_ast_whileNode378);
  meth_meth_ast_whileNode378->definitionModule = modulename;
  meth_meth_ast_whileNode378->definitionLine = 73;
// compilenode returning 
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject379 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj379 = alloc_userobj2(2,4, objclass379);
  gc_frame_newslot(obj379);
// OBJECT OUTER DEC outer
  adddatum2(obj379, self, 0);
  addmethodreal(obj379,"outer", &reader_ast_outer_380);
  Object oldself379 = self;
  struct StackFrameObject *oldstackframe379 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe379);
  gc_frame_newslot((Object)stackframe);
  self = obj379;
  Object *oldselfslot379 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter379 = (*(struct UserObject *)self).data[0], lowerouter379 = thisouter379;
  if (inheritingObject379) {
    struct UserObject *inho379 = (struct UserObject *)inheritingObject379;
    while (inho379->super != GraceDefaultObject) inho379 = (struct UserObject *)inho379->super;
    inho379->super = obj379;
    self = inheritingObject379;
    *selfslot = self;
    lowerouter379 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter379;
  }
  block_savedest(obj379);
  Object closure381 = createclosure(1, "new");
setclosureframe(closure381, stackframe);
  addtoclosure(closure381, var_baseNode);
  struct UserObject *uo381 = (struct UserObject*)obj379;
  uo381->data[1] = (Object)closure381;
  Method *meth_meth_ast_new381 = addmethod2pos(obj379, "new", &meth_ast_new381, 1);
int argcv_meth_ast_new381[] = {2};
meth_meth_ast_new381->type = alloc_MethodType(1, argcv_meth_ast_new381);
  meth_meth_ast_new381->definitionModule = modulename;
  meth_meth_ast_new381->definitionLine = 73;
  block_savedest(obj379);
  Object closure552 = createclosure(1, "new()object");
setclosureframe(closure552, stackframe);
  addtoclosure(closure552, var_baseNode);
  Method *meth_meth_ast_new381_object = addmethod2pos(obj379, "new()object", &meth_ast_new381_object, 1);
  meth_meth_ast_new381_object->definitionModule = modulename;
  meth_meth_ast_new381_object->definitionLine = 73;
  sourceObject = obj379;
objclass379 = obj379->class;
  objclass379->definitionModule = modulename;
  objclass379->definitionLine = 73;
  (*(struct UserObject *)self).data[0] = lowerouter379;
  self = oldself379;
  selfslot = oldselfslot379;
  stackframe = oldstackframe379;
// compilenode returning obj379
  *var_whileNode = obj379;
  if (obj379 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure553 = createclosure(1, "ifNode");
setclosureframe(closure553, stackframe);
  addtoclosure(closure553, var_ifNode);
  struct UserObject *uo553 = (struct UserObject*)self;
  uo553->data[12] = (Object)closure553;
  Method *meth_meth_ast_ifNode553 = addmethod2pos(self, "ifNode", &meth_ast_ifNode553, 12);
int argcv_meth_ast_ifNode553[] = {0};
meth_meth_ast_ifNode553->type = alloc_MethodType(1, argcv_meth_ast_ifNode553);
  meth_meth_ast_ifNode553->definitionModule = modulename;
  meth_meth_ast_ifNode553->definitionLine = 110;
// compilenode returning 
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject554 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj554 = alloc_userobj2(2,4, objclass554);
  gc_frame_newslot(obj554);
// OBJECT OUTER DEC outer
  adddatum2(obj554, self, 0);
  addmethodreal(obj554,"outer", &reader_ast_outer_555);
  Object oldself554 = self;
  struct StackFrameObject *oldstackframe554 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe554);
  gc_frame_newslot((Object)stackframe);
  self = obj554;
  Object *oldselfslot554 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter554 = (*(struct UserObject *)self).data[0], lowerouter554 = thisouter554;
  if (inheritingObject554) {
    struct UserObject *inho554 = (struct UserObject *)inheritingObject554;
    while (inho554->super != GraceDefaultObject) inho554 = (struct UserObject *)inho554->super;
    inho554->super = obj554;
    self = inheritingObject554;
    *selfslot = self;
    lowerouter554 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter554;
  }
  block_savedest(obj554);
  Object closure556 = createclosure(2, "new");
setclosureframe(closure556, stackframe);
  addtoclosure(closure556, var_ifNode);
  addtoclosure(closure556, var_baseNode);
  struct UserObject *uo556 = (struct UserObject*)obj554;
  uo556->data[1] = (Object)closure556;
  Method *meth_meth_ast_new556 = addmethod2pos(obj554, "new", &meth_ast_new556, 1);
int argcv_meth_ast_new556[] = {3};
meth_meth_ast_new556->type = alloc_MethodType(1, argcv_meth_ast_new556);
  meth_meth_ast_new556->definitionModule = modulename;
  meth_meth_ast_new556->definitionLine = 110;
  block_savedest(obj554);
  Object closure869 = createclosure(2, "new()object");
setclosureframe(closure869, stackframe);
  addtoclosure(closure869, var_ifNode);
  addtoclosure(closure869, var_baseNode);
  Method *meth_meth_ast_new556_object = addmethod2pos(obj554, "new()object", &meth_ast_new556_object, 1);
  meth_meth_ast_new556_object->definitionModule = modulename;
  meth_meth_ast_new556_object->definitionLine = 110;
  sourceObject = obj554;
objclass554 = obj554->class;
  objclass554->definitionModule = modulename;
  objclass554->definitionLine = 110;
  (*(struct UserObject *)self).data[0] = lowerouter554;
  self = oldself554;
  selfslot = oldselfslot554;
  stackframe = oldstackframe554;
// compilenode returning obj554
  *var_ifNode = obj554;
  if (obj554 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 189
  setline(189);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure870 = createclosure(1, "blockNode");
setclosureframe(closure870, stackframe);
  addtoclosure(closure870, var_blockNode);
  struct UserObject *uo870 = (struct UserObject*)self;
  uo870->data[13] = (Object)closure870;
  Method *meth_meth_ast_blockNode870 = addmethod2pos(self, "blockNode", &meth_ast_blockNode870, 13);
int argcv_meth_ast_blockNode870[] = {0};
meth_meth_ast_blockNode870->type = alloc_MethodType(1, argcv_meth_ast_blockNode870);
  meth_meth_ast_blockNode870->definitionModule = modulename;
  meth_meth_ast_blockNode870->definitionLine = 181;
// compilenode returning 
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject871 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj871 = alloc_userobj2(2,4, objclass871);
  gc_frame_newslot(obj871);
// OBJECT OUTER DEC outer
  adddatum2(obj871, self, 0);
  addmethodreal(obj871,"outer", &reader_ast_outer_872);
  Object oldself871 = self;
  struct StackFrameObject *oldstackframe871 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe871);
  gc_frame_newslot((Object)stackframe);
  self = obj871;
  Object *oldselfslot871 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter871 = (*(struct UserObject *)self).data[0], lowerouter871 = thisouter871;
  if (inheritingObject871) {
    struct UserObject *inho871 = (struct UserObject *)inheritingObject871;
    while (inho871->super != GraceDefaultObject) inho871 = (struct UserObject *)inho871->super;
    inho871->super = obj871;
    self = inheritingObject871;
    *selfslot = self;
    lowerouter871 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter871;
  }
  block_savedest(obj871);
  Object closure873 = createclosure(3, "new");
setclosureframe(closure873, stackframe);
  addtoclosure(closure873, var_blockNode);
  addtoclosure(closure873, var_baseNode);
  addtoclosure(closure873, var_patternMarkVisitor);
  struct UserObject *uo873 = (struct UserObject*)obj871;
  uo873->data[1] = (Object)closure873;
  Method *meth_meth_ast_new873 = addmethod2pos(obj871, "new", &meth_ast_new873, 1);
int argcv_meth_ast_new873[] = {2};
meth_meth_ast_new873->type = alloc_MethodType(1, argcv_meth_ast_new873);
  meth_meth_ast_new873->definitionModule = modulename;
  meth_meth_ast_new873->definitionLine = 181;
  block_savedest(obj871);
  Object closure1245 = createclosure(3, "new()object");
setclosureframe(closure1245, stackframe);
  addtoclosure(closure1245, var_blockNode);
  addtoclosure(closure1245, var_baseNode);
  addtoclosure(closure1245, var_patternMarkVisitor);
  Method *meth_meth_ast_new873_object = addmethod2pos(obj871, "new()object", &meth_ast_new873_object, 1);
  meth_meth_ast_new873_object->definitionModule = modulename;
  meth_meth_ast_new873_object->definitionLine = 181;
  sourceObject = obj871;
objclass871 = obj871->class;
  objclass871->definitionModule = modulename;
  objclass871->definitionLine = 181;
  (*(struct UserObject *)self).data[0] = lowerouter871;
  self = oldself871;
  selfslot = oldselfslot871;
  stackframe = oldstackframe871;
// compilenode returning obj871
  *var_blockNode = obj871;
  if (obj871 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure1246 = createclosure(1, "catchCaseNode");
setclosureframe(closure1246, stackframe);
  addtoclosure(closure1246, var_catchCaseNode);
  struct UserObject *uo1246 = (struct UserObject*)self;
  uo1246->data[14] = (Object)closure1246;
  Method *meth_meth_ast_catchCaseNode1246 = addmethod2pos(self, "catchCaseNode", &meth_ast_catchCaseNode1246, 14);
int argcv_meth_ast_catchCaseNode1246[] = {0};
meth_meth_ast_catchCaseNode1246->type = alloc_MethodType(1, argcv_meth_ast_catchCaseNode1246);
  meth_meth_ast_catchCaseNode1246->definitionModule = modulename;
  meth_meth_ast_catchCaseNode1246->definitionLine = 275;
// compilenode returning 
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject1247 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1247 = alloc_userobj2(2,4, objclass1247);
  gc_frame_newslot(obj1247);
// OBJECT OUTER DEC outer
  adddatum2(obj1247, self, 0);
  addmethodreal(obj1247,"outer", &reader_ast_outer_1248);
  Object oldself1247 = self;
  struct StackFrameObject *oldstackframe1247 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1247);
  gc_frame_newslot((Object)stackframe);
  self = obj1247;
  Object *oldselfslot1247 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1247 = (*(struct UserObject *)self).data[0], lowerouter1247 = thisouter1247;
  if (inheritingObject1247) {
    struct UserObject *inho1247 = (struct UserObject *)inheritingObject1247;
    while (inho1247->super != GraceDefaultObject) inho1247 = (struct UserObject *)inho1247->super;
    inho1247->super = obj1247;
    self = inheritingObject1247;
    *selfslot = self;
    lowerouter1247 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1247;
  }
  block_savedest(obj1247);
  Object closure1249 = createclosure(2, "new");
setclosureframe(closure1249, stackframe);
  addtoclosure(closure1249, var_catchCaseNode);
  addtoclosure(closure1249, var_baseNode);
  struct UserObject *uo1249 = (struct UserObject*)obj1247;
  uo1249->data[1] = (Object)closure1249;
  Method *meth_meth_ast_new1249 = addmethod2pos(obj1247, "new", &meth_ast_new1249, 1);
int argcv_meth_ast_new1249[] = {3};
meth_meth_ast_new1249->type = alloc_MethodType(1, argcv_meth_ast_new1249);
  meth_meth_ast_new1249->definitionModule = modulename;
  meth_meth_ast_new1249->definitionLine = 275;
  block_savedest(obj1247);
  Object closure1536 = createclosure(2, "new()object");
setclosureframe(closure1536, stackframe);
  addtoclosure(closure1536, var_catchCaseNode);
  addtoclosure(closure1536, var_baseNode);
  Method *meth_meth_ast_new1249_object = addmethod2pos(obj1247, "new()object", &meth_ast_new1249_object, 1);
  meth_meth_ast_new1249_object->definitionModule = modulename;
  meth_meth_ast_new1249_object->definitionLine = 275;
  sourceObject = obj1247;
objclass1247 = obj1247->class;
  objclass1247->definitionModule = modulename;
  objclass1247->definitionLine = 275;
  (*(struct UserObject *)self).data[0] = lowerouter1247;
  self = oldself1247;
  selfslot = oldselfslot1247;
  stackframe = oldstackframe1247;
// compilenode returning obj1247
  *var_catchCaseNode = obj1247;
  if (obj1247 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 340
  setline(340);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure1537 = createclosure(1, "matchCaseNode");
setclosureframe(closure1537, stackframe);
  addtoclosure(closure1537, var_matchCaseNode);
  struct UserObject *uo1537 = (struct UserObject*)self;
  uo1537->data[15] = (Object)closure1537;
  Method *meth_meth_ast_matchCaseNode1537 = addmethod2pos(self, "matchCaseNode", &meth_ast_matchCaseNode1537, 15);
int argcv_meth_ast_matchCaseNode1537[] = {0};
meth_meth_ast_matchCaseNode1537->type = alloc_MethodType(1, argcv_meth_ast_matchCaseNode1537);
  meth_meth_ast_matchCaseNode1537->definitionModule = modulename;
  meth_meth_ast_matchCaseNode1537->definitionLine = 335;
// compilenode returning 
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject1538 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1538 = alloc_userobj2(2,4, objclass1538);
  gc_frame_newslot(obj1538);
// OBJECT OUTER DEC outer
  adddatum2(obj1538, self, 0);
  addmethodreal(obj1538,"outer", &reader_ast_outer_1539);
  Object oldself1538 = self;
  struct StackFrameObject *oldstackframe1538 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1538);
  gc_frame_newslot((Object)stackframe);
  self = obj1538;
  Object *oldselfslot1538 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1538 = (*(struct UserObject *)self).data[0], lowerouter1538 = thisouter1538;
  if (inheritingObject1538) {
    struct UserObject *inho1538 = (struct UserObject *)inheritingObject1538;
    while (inho1538->super != GraceDefaultObject) inho1538 = (struct UserObject *)inho1538->super;
    inho1538->super = obj1538;
    self = inheritingObject1538;
    *selfslot = self;
    lowerouter1538 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1538;
  }
  block_savedest(obj1538);
  Object closure1540 = createclosure(2, "new");
setclosureframe(closure1540, stackframe);
  addtoclosure(closure1540, var_matchCaseNode);
  addtoclosure(closure1540, var_baseNode);
  struct UserObject *uo1540 = (struct UserObject*)obj1538;
  uo1540->data[1] = (Object)closure1540;
  Method *meth_meth_ast_new1540 = addmethod2pos(obj1538, "new", &meth_ast_new1540, 1);
int argcv_meth_ast_new1540[] = {3};
meth_meth_ast_new1540->type = alloc_MethodType(1, argcv_meth_ast_new1540);
  meth_meth_ast_new1540->definitionModule = modulename;
  meth_meth_ast_new1540->definitionLine = 335;
  block_savedest(obj1538);
  Object closure1827 = createclosure(2, "new()object");
setclosureframe(closure1827, stackframe);
  addtoclosure(closure1827, var_matchCaseNode);
  addtoclosure(closure1827, var_baseNode);
  Method *meth_meth_ast_new1540_object = addmethod2pos(obj1538, "new()object", &meth_ast_new1540_object, 1);
  meth_meth_ast_new1540_object->definitionModule = modulename;
  meth_meth_ast_new1540_object->definitionLine = 335;
  sourceObject = obj1538;
objclass1538 = obj1538->class;
  objclass1538->definitionModule = modulename;
  objclass1538->definitionLine = 335;
  (*(struct UserObject *)self).data[0] = lowerouter1538;
  self = oldself1538;
  selfslot = oldselfslot1538;
  stackframe = oldstackframe1538;
// compilenode returning obj1538
  *var_matchCaseNode = obj1538;
  if (obj1538 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure1828 = createclosure(1, "methodTypeNode");
setclosureframe(closure1828, stackframe);
  addtoclosure(closure1828, var_methodTypeNode);
  struct UserObject *uo1828 = (struct UserObject*)self;
  uo1828->data[16] = (Object)closure1828;
  Method *meth_meth_ast_methodTypeNode1828 = addmethod2pos(self, "methodTypeNode", &meth_ast_methodTypeNode1828, 16);
int argcv_meth_ast_methodTypeNode1828[] = {0};
meth_meth_ast_methodTypeNode1828->type = alloc_MethodType(1, argcv_meth_ast_methodTypeNode1828);
  meth_meth_ast_methodTypeNode1828->definitionModule = modulename;
  meth_meth_ast_methodTypeNode1828->definitionLine = 395;
// compilenode returning 
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject1829 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1829 = alloc_userobj2(2,4, objclass1829);
  gc_frame_newslot(obj1829);
// OBJECT OUTER DEC outer
  adddatum2(obj1829, self, 0);
  addmethodreal(obj1829,"outer", &reader_ast_outer_1830);
  Object oldself1829 = self;
  struct StackFrameObject *oldstackframe1829 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1829);
  gc_frame_newslot((Object)stackframe);
  self = obj1829;
  Object *oldselfslot1829 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1829 = (*(struct UserObject *)self).data[0], lowerouter1829 = thisouter1829;
  if (inheritingObject1829) {
    struct UserObject *inho1829 = (struct UserObject *)inheritingObject1829;
    while (inho1829->super != GraceDefaultObject) inho1829 = (struct UserObject *)inho1829->super;
    inho1829->super = obj1829;
    self = inheritingObject1829;
    *selfslot = self;
    lowerouter1829 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1829;
  }
  block_savedest(obj1829);
  Object closure1831 = createclosure(2, "new");
setclosureframe(closure1831, stackframe);
  addtoclosure(closure1831, var_methodTypeNode);
  addtoclosure(closure1831, var_baseNode);
  struct UserObject *uo1831 = (struct UserObject*)obj1829;
  uo1831->data[1] = (Object)closure1831;
  Method *meth_meth_ast_new1831 = addmethod2pos(obj1829, "new", &meth_ast_new1831, 1);
int argcv_meth_ast_new1831[] = {3};
meth_meth_ast_new1831->type = alloc_MethodType(1, argcv_meth_ast_new1831);
  meth_meth_ast_new1831->definitionModule = modulename;
  meth_meth_ast_new1831->definitionLine = 395;
  block_savedest(obj1829);
  Object closure2282 = createclosure(2, "new()object");
setclosureframe(closure2282, stackframe);
  addtoclosure(closure2282, var_methodTypeNode);
  addtoclosure(closure2282, var_baseNode);
  Method *meth_meth_ast_new1831_object = addmethod2pos(obj1829, "new()object", &meth_ast_new1831_object, 1);
  meth_meth_ast_new1831_object->definitionModule = modulename;
  meth_meth_ast_new1831_object->definitionLine = 395;
  sourceObject = obj1829;
objclass1829 = obj1829->class;
  objclass1829->definitionModule = modulename;
  objclass1829->definitionLine = 395;
  (*(struct UserObject *)self).data[0] = lowerouter1829;
  self = oldself1829;
  selfslot = oldselfslot1829;
  stackframe = oldstackframe1829;
// compilenode returning obj1829
  *var_methodTypeNode = obj1829;
  if (obj1829 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 495
  setline(495);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure2283 = createclosure(1, "typeNode");
setclosureframe(closure2283, stackframe);
  addtoclosure(closure2283, var_typeNode);
  struct UserObject *uo2283 = (struct UserObject*)self;
  uo2283->data[17] = (Object)closure2283;
  Method *meth_meth_ast_typeNode2283 = addmethod2pos(self, "typeNode", &meth_ast_typeNode2283, 17);
int argcv_meth_ast_typeNode2283[] = {0};
meth_meth_ast_typeNode2283->type = alloc_MethodType(1, argcv_meth_ast_typeNode2283);
  meth_meth_ast_typeNode2283->definitionModule = modulename;
  meth_meth_ast_typeNode2283->definitionLine = 495;
// compilenode returning 
// Begin line 495
  setline(495);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject2284 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2284 = alloc_userobj2(2,4, objclass2284);
  gc_frame_newslot(obj2284);
// OBJECT OUTER DEC outer
  adddatum2(obj2284, self, 0);
  addmethodreal(obj2284,"outer", &reader_ast_outer_2285);
  Object oldself2284 = self;
  struct StackFrameObject *oldstackframe2284 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2284);
  gc_frame_newslot((Object)stackframe);
  self = obj2284;
  Object *oldselfslot2284 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2284 = (*(struct UserObject *)self).data[0], lowerouter2284 = thisouter2284;
  if (inheritingObject2284) {
    struct UserObject *inho2284 = (struct UserObject *)inheritingObject2284;
    while (inho2284->super != GraceDefaultObject) inho2284 = (struct UserObject *)inho2284->super;
    inho2284->super = obj2284;
    self = inheritingObject2284;
    *selfslot = self;
    lowerouter2284 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2284;
  }
  block_savedest(obj2284);
  Object closure2286 = createclosure(3, "new");
setclosureframe(closure2286, stackframe);
  addtoclosure(closure2286, var_typeNode);
  addtoclosure(closure2286, var_baseNode);
  addtoclosure(closure2286, var_collections);
  struct UserObject *uo2286 = (struct UserObject*)obj2284;
  uo2286->data[1] = (Object)closure2286;
  Method *meth_meth_ast_new2286 = addmethod2pos(obj2284, "new", &meth_ast_new2286, 1);
int argcv_meth_ast_new2286[] = {2};
meth_meth_ast_new2286->type = alloc_MethodType(1, argcv_meth_ast_new2286);
  meth_meth_ast_new2286->definitionModule = modulename;
  meth_meth_ast_new2286->definitionLine = 495;
  block_savedest(obj2284);
  Object closure3027 = createclosure(3, "new()object");
setclosureframe(closure3027, stackframe);
  addtoclosure(closure3027, var_typeNode);
  addtoclosure(closure3027, var_baseNode);
  addtoclosure(closure3027, var_collections);
  Method *meth_meth_ast_new2286_object = addmethod2pos(obj2284, "new()object", &meth_ast_new2286_object, 1);
  meth_meth_ast_new2286_object->definitionModule = modulename;
  meth_meth_ast_new2286_object->definitionLine = 495;
  sourceObject = obj2284;
objclass2284 = obj2284->class;
  objclass2284->definitionModule = modulename;
  objclass2284->definitionLine = 495;
  (*(struct UserObject *)self).data[0] = lowerouter2284;
  self = oldself2284;
  selfslot = oldselfslot2284;
  stackframe = oldstackframe2284;
// compilenode returning obj2284
  *var_typeNode = obj2284;
  if (obj2284 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 637
  setline(637);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure3028 = createclosure(1, "methodNode");
setclosureframe(closure3028, stackframe);
  addtoclosure(closure3028, var_methodNode);
  struct UserObject *uo3028 = (struct UserObject*)self;
  uo3028->data[18] = (Object)closure3028;
  Method *meth_meth_ast_methodNode3028 = addmethod2pos(self, "methodNode", &meth_ast_methodNode3028, 18);
int argcv_meth_ast_methodNode3028[] = {0};
meth_meth_ast_methodNode3028->type = alloc_MethodType(1, argcv_meth_ast_methodNode3028);
  meth_meth_ast_methodNode3028->definitionModule = modulename;
  meth_meth_ast_methodNode3028->definitionLine = 507;
// compilenode returning 
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject3029 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3029 = alloc_userobj2(2,4, objclass3029);
  gc_frame_newslot(obj3029);
// OBJECT OUTER DEC outer
  adddatum2(obj3029, self, 0);
  addmethodreal(obj3029,"outer", &reader_ast_outer_3030);
  Object oldself3029 = self;
  struct StackFrameObject *oldstackframe3029 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3029);
  gc_frame_newslot((Object)stackframe);
  self = obj3029;
  Object *oldselfslot3029 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3029 = (*(struct UserObject *)self).data[0], lowerouter3029 = thisouter3029;
  if (inheritingObject3029) {
    struct UserObject *inho3029 = (struct UserObject *)inheritingObject3029;
    while (inho3029->super != GraceDefaultObject) inho3029 = (struct UserObject *)inho3029->super;
    inho3029->super = obj3029;
    self = inheritingObject3029;
    *selfslot = self;
    lowerouter3029 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3029;
  }
  block_savedest(obj3029);
  Object closure3031 = createclosure(4, "new");
setclosureframe(closure3031, stackframe);
  addtoclosure(closure3031, var_methodNode);
  addtoclosure(closure3031, var_identifierNode);
  addtoclosure(closure3031, var_baseNode);
  addtoclosure(closure3031, var_collections);
  struct UserObject *uo3031 = (struct UserObject*)obj3029;
  uo3031->data[1] = (Object)closure3031;
  Method *meth_meth_ast_new3031 = addmethod2pos(obj3029, "new", &meth_ast_new3031, 1);
int argcv_meth_ast_new3031[] = {4};
meth_meth_ast_new3031->type = alloc_MethodType(1, argcv_meth_ast_new3031);
  meth_meth_ast_new3031->definitionModule = modulename;
  meth_meth_ast_new3031->definitionLine = 507;
  block_savedest(obj3029);
  Object closure3845 = createclosure(4, "new()object");
setclosureframe(closure3845, stackframe);
  addtoclosure(closure3845, var_methodNode);
  addtoclosure(closure3845, var_identifierNode);
  addtoclosure(closure3845, var_baseNode);
  addtoclosure(closure3845, var_collections);
  Method *meth_meth_ast_new3031_object = addmethod2pos(obj3029, "new()object", &meth_ast_new3031_object, 1);
  meth_meth_ast_new3031_object->definitionModule = modulename;
  meth_meth_ast_new3031_object->definitionLine = 507;
  sourceObject = obj3029;
objclass3029 = obj3029->class;
  objclass3029->definitionModule = modulename;
  objclass3029->definitionLine = 507;
  (*(struct UserObject *)self).data[0] = lowerouter3029;
  self = oldself3029;
  selfslot = oldselfslot3029;
  stackframe = oldstackframe3029;
// compilenode returning obj3029
  *var_methodNode = obj3029;
  if (obj3029 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 800
  setline(800);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure3846 = createclosure(1, "callNode");
setclosureframe(closure3846, stackframe);
  addtoclosure(closure3846, var_callNode);
  struct UserObject *uo3846 = (struct UserObject*)self;
  uo3846->data[19] = (Object)closure3846;
  Method *meth_meth_ast_callNode3846 = addmethod2pos(self, "callNode", &meth_ast_callNode3846, 19);
int argcv_meth_ast_callNode3846[] = {0};
meth_meth_ast_callNode3846->type = alloc_MethodType(1, argcv_meth_ast_callNode3846);
  meth_meth_ast_callNode3846->definitionModule = modulename;
  meth_meth_ast_callNode3846->definitionLine = 663;
// compilenode returning 
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject3847 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3847 = alloc_userobj2(2,4, objclass3847);
  gc_frame_newslot(obj3847);
// OBJECT OUTER DEC outer
  adddatum2(obj3847, self, 0);
  addmethodreal(obj3847,"outer", &reader_ast_outer_3848);
  Object oldself3847 = self;
  struct StackFrameObject *oldstackframe3847 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3847);
  gc_frame_newslot((Object)stackframe);
  self = obj3847;
  Object *oldselfslot3847 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3847 = (*(struct UserObject *)self).data[0], lowerouter3847 = thisouter3847;
  if (inheritingObject3847) {
    struct UserObject *inho3847 = (struct UserObject *)inheritingObject3847;
    while (inho3847->super != GraceDefaultObject) inho3847 = (struct UserObject *)inho3847->super;
    inho3847->super = obj3847;
    self = inheritingObject3847;
    *selfslot = self;
    lowerouter3847 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3847;
  }
  block_savedest(obj3847);
  Object closure3849 = createclosure(2, "new");
setclosureframe(closure3849, stackframe);
  addtoclosure(closure3849, var_callNode);
  addtoclosure(closure3849, var_baseNode);
  struct UserObject *uo3849 = (struct UserObject*)obj3847;
  uo3849->data[1] = (Object)closure3849;
  Method *meth_meth_ast_new3849 = addmethod2pos(obj3847, "new", &meth_ast_new3849, 1);
int argcv_meth_ast_new3849[] = {2};
meth_meth_ast_new3849->type = alloc_MethodType(1, argcv_meth_ast_new3849);
  meth_meth_ast_new3849->definitionModule = modulename;
  meth_meth_ast_new3849->definitionLine = 663;
  block_savedest(obj3847);
  Object closure4221 = createclosure(2, "new()object");
setclosureframe(closure4221, stackframe);
  addtoclosure(closure4221, var_callNode);
  addtoclosure(closure4221, var_baseNode);
  Method *meth_meth_ast_new3849_object = addmethod2pos(obj3847, "new()object", &meth_ast_new3849_object, 1);
  meth_meth_ast_new3849_object->definitionModule = modulename;
  meth_meth_ast_new3849_object->definitionLine = 663;
  sourceObject = obj3847;
objclass3847 = obj3847->class;
  objclass3847->definitionModule = modulename;
  objclass3847->definitionLine = 663;
  (*(struct UserObject *)self).data[0] = lowerouter3847;
  self = oldself3847;
  selfslot = oldselfslot3847;
  stackframe = oldstackframe3847;
// compilenode returning obj3847
  *var_callNode = obj3847;
  if (obj3847 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure4222 = createclosure(1, "classNode");
setclosureframe(closure4222, stackframe);
  addtoclosure(closure4222, var_classNode);
  struct UserObject *uo4222 = (struct UserObject*)self;
  uo4222->data[20] = (Object)closure4222;
  Method *meth_meth_ast_classNode4222 = addmethod2pos(self, "classNode", &meth_ast_classNode4222, 20);
int argcv_meth_ast_classNode4222[] = {0};
meth_meth_ast_classNode4222->type = alloc_MethodType(1, argcv_meth_ast_classNode4222);
  meth_meth_ast_classNode4222->definitionModule = modulename;
  meth_meth_ast_classNode4222->definitionLine = 891;
// compilenode returning 
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject4223 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4223 = alloc_userobj2(2,4, objclass4223);
  gc_frame_newslot(obj4223);
// OBJECT OUTER DEC outer
  adddatum2(obj4223, self, 0);
  addmethodreal(obj4223,"outer", &reader_ast_outer_4224);
  Object oldself4223 = self;
  struct StackFrameObject *oldstackframe4223 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4223);
  gc_frame_newslot((Object)stackframe);
  self = obj4223;
  Object *oldselfslot4223 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4223 = (*(struct UserObject *)self).data[0], lowerouter4223 = thisouter4223;
  if (inheritingObject4223) {
    struct UserObject *inho4223 = (struct UserObject *)inheritingObject4223;
    while (inho4223->super != GraceDefaultObject) inho4223 = (struct UserObject *)inho4223->super;
    inho4223->super = obj4223;
    self = inheritingObject4223;
    *selfslot = self;
    lowerouter4223 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4223;
  }
  block_savedest(obj4223);
  Object closure4225 = createclosure(3, "new");
setclosureframe(closure4225, stackframe);
  addtoclosure(closure4225, var_classNode);
  addtoclosure(closure4225, var_baseNode);
  addtoclosure(closure4225, var_collections);
  struct UserObject *uo4225 = (struct UserObject*)obj4223;
  uo4225->data[1] = (Object)closure4225;
  Method *meth_meth_ast_new4225 = addmethod2pos(obj4223, "new", &meth_ast_new4225, 1);
int argcv_meth_ast_new4225[] = {6};
meth_meth_ast_new4225->type = alloc_MethodType(1, argcv_meth_ast_new4225);
  meth_meth_ast_new4225->definitionModule = modulename;
  meth_meth_ast_new4225->definitionLine = 891;
  block_savedest(obj4223);
  Object closure5031 = createclosure(3, "new()object");
setclosureframe(closure5031, stackframe);
  addtoclosure(closure5031, var_classNode);
  addtoclosure(closure5031, var_baseNode);
  addtoclosure(closure5031, var_collections);
  Method *meth_meth_ast_new4225_object = addmethod2pos(obj4223, "new()object", &meth_ast_new4225_object, 1);
  meth_meth_ast_new4225_object->definitionModule = modulename;
  meth_meth_ast_new4225_object->definitionLine = 891;
  sourceObject = obj4223;
objclass4223 = obj4223->class;
  objclass4223->definitionModule = modulename;
  objclass4223->definitionLine = 891;
  (*(struct UserObject *)self).data[0] = lowerouter4223;
  self = oldself4223;
  selfslot = oldselfslot4223;
  stackframe = oldstackframe4223;
// compilenode returning obj4223
  *var_classNode = obj4223;
  if (obj4223 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 927
  setline(927);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure5032 = createclosure(1, "objectNode");
setclosureframe(closure5032, stackframe);
  addtoclosure(closure5032, var_objectNode);
  struct UserObject *uo5032 = (struct UserObject*)self;
  uo5032->data[21] = (Object)closure5032;
  Method *meth_meth_ast_objectNode5032 = addmethod2pos(self, "objectNode", &meth_ast_objectNode5032, 21);
int argcv_meth_ast_objectNode5032[] = {0};
meth_meth_ast_objectNode5032->type = alloc_MethodType(1, argcv_meth_ast_objectNode5032);
  meth_meth_ast_objectNode5032->definitionModule = modulename;
  meth_meth_ast_objectNode5032->definitionLine = 927;
// compilenode returning 
// Begin line 927
  setline(927);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject5033 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5033 = alloc_userobj2(2,4, objclass5033);
  gc_frame_newslot(obj5033);
// OBJECT OUTER DEC outer
  adddatum2(obj5033, self, 0);
  addmethodreal(obj5033,"outer", &reader_ast_outer_5034);
  Object oldself5033 = self;
  struct StackFrameObject *oldstackframe5033 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5033);
  gc_frame_newslot((Object)stackframe);
  self = obj5033;
  Object *oldselfslot5033 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5033 = (*(struct UserObject *)self).data[0], lowerouter5033 = thisouter5033;
  if (inheritingObject5033) {
    struct UserObject *inho5033 = (struct UserObject *)inheritingObject5033;
    while (inho5033->super != GraceDefaultObject) inho5033 = (struct UserObject *)inho5033->super;
    inho5033->super = obj5033;
    self = inheritingObject5033;
    *selfslot = self;
    lowerouter5033 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5033;
  }
  block_savedest(obj5033);
  Object closure5035 = createclosure(2, "new");
setclosureframe(closure5035, stackframe);
  addtoclosure(closure5035, var_objectNode);
  addtoclosure(closure5035, var_baseNode);
  struct UserObject *uo5035 = (struct UserObject*)obj5033;
  uo5035->data[1] = (Object)closure5035;
  Method *meth_meth_ast_new5035 = addmethod2pos(obj5033, "new", &meth_ast_new5035, 1);
int argcv_meth_ast_new5035[] = {2};
meth_meth_ast_new5035->type = alloc_MethodType(1, argcv_meth_ast_new5035);
  meth_meth_ast_new5035->definitionModule = modulename;
  meth_meth_ast_new5035->definitionLine = 927;
  block_savedest(obj5033);
  Object closure5270 = createclosure(2, "new()object");
setclosureframe(closure5270, stackframe);
  addtoclosure(closure5270, var_objectNode);
  addtoclosure(closure5270, var_baseNode);
  Method *meth_meth_ast_new5035_object = addmethod2pos(obj5033, "new()object", &meth_ast_new5035_object, 1);
  meth_meth_ast_new5035_object->definitionModule = modulename;
  meth_meth_ast_new5035_object->definitionLine = 927;
  sourceObject = obj5033;
objclass5033 = obj5033->class;
  objclass5033->definitionModule = modulename;
  objclass5033->definitionLine = 927;
  (*(struct UserObject *)self).data[0] = lowerouter5033;
  self = oldself5033;
  selfslot = oldselfslot5033;
  stackframe = oldstackframe5033;
// compilenode returning obj5033
  *var_objectNode = obj5033;
  if (obj5033 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1109
  setline(1109);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure5271 = createclosure(1, "arrayNode");
setclosureframe(closure5271, stackframe);
  addtoclosure(closure5271, var_arrayNode);
  struct UserObject *uo5271 = (struct UserObject*)self;
  uo5271->data[22] = (Object)closure5271;
  Method *meth_meth_ast_arrayNode5271 = addmethod2pos(self, "arrayNode", &meth_ast_arrayNode5271, 22);
int argcv_meth_ast_arrayNode5271[] = {0};
meth_meth_ast_arrayNode5271->type = alloc_MethodType(1, argcv_meth_ast_arrayNode5271);
  meth_meth_ast_arrayNode5271->definitionModule = modulename;
  meth_meth_ast_arrayNode5271->definitionLine = 1102;
// compilenode returning 
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject5272 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5272 = alloc_userobj2(2,4, objclass5272);
  gc_frame_newslot(obj5272);
// OBJECT OUTER DEC outer
  adddatum2(obj5272, self, 0);
  addmethodreal(obj5272,"outer", &reader_ast_outer_5273);
  Object oldself5272 = self;
  struct StackFrameObject *oldstackframe5272 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5272);
  gc_frame_newslot((Object)stackframe);
  self = obj5272;
  Object *oldselfslot5272 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5272 = (*(struct UserObject *)self).data[0], lowerouter5272 = thisouter5272;
  if (inheritingObject5272) {
    struct UserObject *inho5272 = (struct UserObject *)inheritingObject5272;
    while (inho5272->super != GraceDefaultObject) inho5272 = (struct UserObject *)inho5272->super;
    inho5272->super = obj5272;
    self = inheritingObject5272;
    *selfslot = self;
    lowerouter5272 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5272;
  }
  block_savedest(obj5272);
  Object closure5274 = createclosure(2, "new");
setclosureframe(closure5274, stackframe);
  addtoclosure(closure5274, var_arrayNode);
  addtoclosure(closure5274, var_baseNode);
  struct UserObject *uo5274 = (struct UserObject*)obj5272;
  uo5274->data[1] = (Object)closure5274;
  Method *meth_meth_ast_new5274 = addmethod2pos(obj5272, "new", &meth_ast_new5274, 1);
int argcv_meth_ast_new5274[] = {1};
meth_meth_ast_new5274->type = alloc_MethodType(1, argcv_meth_ast_new5274);
  meth_meth_ast_new5274->definitionModule = modulename;
  meth_meth_ast_new5274->definitionLine = 1102;
  block_savedest(obj5272);
  Object closure5406 = createclosure(2, "new()object");
setclosureframe(closure5406, stackframe);
  addtoclosure(closure5406, var_arrayNode);
  addtoclosure(closure5406, var_baseNode);
  Method *meth_meth_ast_new5274_object = addmethod2pos(obj5272, "new()object", &meth_ast_new5274_object, 1);
  meth_meth_ast_new5274_object->definitionModule = modulename;
  meth_meth_ast_new5274_object->definitionLine = 1102;
  sourceObject = obj5272;
objclass5272 = obj5272->class;
  objclass5272->definitionModule = modulename;
  objclass5272->definitionLine = 1102;
  (*(struct UserObject *)self).data[0] = lowerouter5272;
  self = oldself5272;
  selfslot = oldselfslot5272;
  stackframe = oldstackframe5272;
// compilenode returning obj5272
  *var_arrayNode = obj5272;
  if (obj5272 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1154
  setline(1154);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1146
  setline(1146);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure5407 = createclosure(1, "memberNode");
setclosureframe(closure5407, stackframe);
  addtoclosure(closure5407, var_memberNode);
  struct UserObject *uo5407 = (struct UserObject*)self;
  uo5407->data[23] = (Object)closure5407;
  Method *meth_meth_ast_memberNode5407 = addmethod2pos(self, "memberNode", &meth_ast_memberNode5407, 23);
int argcv_meth_ast_memberNode5407[] = {0};
meth_meth_ast_memberNode5407->type = alloc_MethodType(1, argcv_meth_ast_memberNode5407);
  meth_meth_ast_memberNode5407->definitionModule = modulename;
  meth_meth_ast_memberNode5407->definitionLine = 1146;
// compilenode returning 
// Begin line 1146
  setline(1146);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject5408 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5408 = alloc_userobj2(2,4, objclass5408);
  gc_frame_newslot(obj5408);
// OBJECT OUTER DEC outer
  adddatum2(obj5408, self, 0);
  addmethodreal(obj5408,"outer", &reader_ast_outer_5409);
  Object oldself5408 = self;
  struct StackFrameObject *oldstackframe5408 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5408);
  gc_frame_newslot((Object)stackframe);
  self = obj5408;
  Object *oldselfslot5408 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5408 = (*(struct UserObject *)self).data[0], lowerouter5408 = thisouter5408;
  if (inheritingObject5408) {
    struct UserObject *inho5408 = (struct UserObject *)inheritingObject5408;
    while (inho5408->super != GraceDefaultObject) inho5408 = (struct UserObject *)inho5408->super;
    inho5408->super = obj5408;
    self = inheritingObject5408;
    *selfslot = self;
    lowerouter5408 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5408;
  }
  block_savedest(obj5408);
  Object closure5410 = createclosure(2, "new");
setclosureframe(closure5410, stackframe);
  addtoclosure(closure5410, var_memberNode);
  addtoclosure(closure5410, var_baseNode);
  struct UserObject *uo5410 = (struct UserObject*)obj5408;
  uo5410->data[1] = (Object)closure5410;
  Method *meth_meth_ast_new5410 = addmethod2pos(obj5408, "new", &meth_ast_new5410, 1);
int argcv_meth_ast_new5410[] = {2};
meth_meth_ast_new5410->type = alloc_MethodType(1, argcv_meth_ast_new5410);
  meth_meth_ast_new5410->definitionModule = modulename;
  meth_meth_ast_new5410->definitionLine = 1146;
  block_savedest(obj5408);
  Object closure5547 = createclosure(2, "new()object");
setclosureframe(closure5547, stackframe);
  addtoclosure(closure5547, var_memberNode);
  addtoclosure(closure5547, var_baseNode);
  Method *meth_meth_ast_new5410_object = addmethod2pos(obj5408, "new()object", &meth_ast_new5410_object, 1);
  meth_meth_ast_new5410_object->definitionModule = modulename;
  meth_meth_ast_new5410_object->definitionLine = 1146;
  sourceObject = obj5408;
objclass5408 = obj5408->class;
  objclass5408->definitionModule = modulename;
  objclass5408->definitionLine = 1146;
  (*(struct UserObject *)self).data[0] = lowerouter5408;
  self = oldself5408;
  selfslot = oldselfslot5408;
  stackframe = oldstackframe5408;
// compilenode returning obj5408
  *var_memberNode = obj5408;
  if (obj5408 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1195
  setline(1195);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1190
  setline(1190);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure5548 = createclosure(1, "genericNode");
setclosureframe(closure5548, stackframe);
  addtoclosure(closure5548, var_genericNode);
  struct UserObject *uo5548 = (struct UserObject*)self;
  uo5548->data[24] = (Object)closure5548;
  Method *meth_meth_ast_genericNode5548 = addmethod2pos(self, "genericNode", &meth_ast_genericNode5548, 24);
int argcv_meth_ast_genericNode5548[] = {0};
meth_meth_ast_genericNode5548->type = alloc_MethodType(1, argcv_meth_ast_genericNode5548);
  meth_meth_ast_genericNode5548->definitionModule = modulename;
  meth_meth_ast_genericNode5548->definitionLine = 1190;
// compilenode returning 
// Begin line 1190
  setline(1190);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject5549 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5549 = alloc_userobj2(2,4, objclass5549);
  gc_frame_newslot(obj5549);
// OBJECT OUTER DEC outer
  adddatum2(obj5549, self, 0);
  addmethodreal(obj5549,"outer", &reader_ast_outer_5550);
  Object oldself5549 = self;
  struct StackFrameObject *oldstackframe5549 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5549);
  gc_frame_newslot((Object)stackframe);
  self = obj5549;
  Object *oldselfslot5549 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5549 = (*(struct UserObject *)self).data[0], lowerouter5549 = thisouter5549;
  if (inheritingObject5549) {
    struct UserObject *inho5549 = (struct UserObject *)inheritingObject5549;
    while (inho5549->super != GraceDefaultObject) inho5549 = (struct UserObject *)inho5549->super;
    inho5549->super = obj5549;
    self = inheritingObject5549;
    *selfslot = self;
    lowerouter5549 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5549;
  }
  block_savedest(obj5549);
  Object closure5551 = createclosure(2, "new");
setclosureframe(closure5551, stackframe);
  addtoclosure(closure5551, var_genericNode);
  addtoclosure(closure5551, var_baseNode);
  struct UserObject *uo5551 = (struct UserObject*)obj5549;
  uo5551->data[1] = (Object)closure5551;
  Method *meth_meth_ast_new5551 = addmethod2pos(obj5549, "new", &meth_ast_new5551, 1);
int argcv_meth_ast_new5551[] = {2};
meth_meth_ast_new5551->type = alloc_MethodType(1, argcv_meth_ast_new5551);
  meth_meth_ast_new5551->definitionModule = modulename;
  meth_meth_ast_new5551->definitionLine = 1190;
  block_savedest(obj5549);
  Object closure5694 = createclosure(2, "new()object");
setclosureframe(closure5694, stackframe);
  addtoclosure(closure5694, var_genericNode);
  addtoclosure(closure5694, var_baseNode);
  Method *meth_meth_ast_new5551_object = addmethod2pos(obj5549, "new()object", &meth_ast_new5551_object, 1);
  meth_meth_ast_new5551_object->definitionModule = modulename;
  meth_meth_ast_new5551_object->definitionLine = 1190;
  sourceObject = obj5549;
objclass5549 = obj5549->class;
  objclass5549->definitionModule = modulename;
  objclass5549->definitionLine = 1190;
  (*(struct UserObject *)self).data[0] = lowerouter5549;
  self = oldself5549;
  selfslot = oldselfslot5549;
  stackframe = oldstackframe5549;
// compilenode returning obj5549
  *var_genericNode = obj5549;
  if (obj5549 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1239
  setline(1239);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1231
  setline(1231);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure5695 = createclosure(1, "identifierNode");
setclosureframe(closure5695, stackframe);
  addtoclosure(closure5695, var_identifierNode);
  struct UserObject *uo5695 = (struct UserObject*)self;
  uo5695->data[25] = (Object)closure5695;
  Method *meth_meth_ast_identifierNode5695 = addmethod2pos(self, "identifierNode", &meth_ast_identifierNode5695, 25);
int argcv_meth_ast_identifierNode5695[] = {0};
meth_meth_ast_identifierNode5695->type = alloc_MethodType(1, argcv_meth_ast_identifierNode5695);
  meth_meth_ast_identifierNode5695->definitionModule = modulename;
  meth_meth_ast_identifierNode5695->definitionLine = 1231;
// compilenode returning 
// Begin line 1231
  setline(1231);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject5696 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5696 = alloc_userobj2(2,4, objclass5696);
  gc_frame_newslot(obj5696);
// OBJECT OUTER DEC outer
  adddatum2(obj5696, self, 0);
  addmethodreal(obj5696,"outer", &reader_ast_outer_5697);
  Object oldself5696 = self;
  struct StackFrameObject *oldstackframe5696 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5696);
  gc_frame_newslot((Object)stackframe);
  self = obj5696;
  Object *oldselfslot5696 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5696 = (*(struct UserObject *)self).data[0], lowerouter5696 = thisouter5696;
  if (inheritingObject5696) {
    struct UserObject *inho5696 = (struct UserObject *)inheritingObject5696;
    while (inho5696->super != GraceDefaultObject) inho5696 = (struct UserObject *)inho5696->super;
    inho5696->super = obj5696;
    self = inheritingObject5696;
    *selfslot = self;
    lowerouter5696 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5696;
  }
  block_savedest(obj5696);
  Object closure5698 = createclosure(3, "new");
setclosureframe(closure5698, stackframe);
  addtoclosure(closure5698, var_util);
  addtoclosure(closure5698, var_identifierNode);
  addtoclosure(closure5698, var_baseNode);
  struct UserObject *uo5698 = (struct UserObject*)obj5696;
  uo5698->data[1] = (Object)closure5698;
  Method *meth_meth_ast_new5698 = addmethod2pos(obj5696, "new", &meth_ast_new5698, 1);
int argcv_meth_ast_new5698[] = {2};
meth_meth_ast_new5698->type = alloc_MethodType(1, argcv_meth_ast_new5698);
  meth_meth_ast_new5698->definitionModule = modulename;
  meth_meth_ast_new5698->definitionLine = 1231;
  block_savedest(obj5696);
  Object closure5933 = createclosure(3, "new()object");
setclosureframe(closure5933, stackframe);
  addtoclosure(closure5933, var_util);
  addtoclosure(closure5933, var_identifierNode);
  addtoclosure(closure5933, var_baseNode);
  Method *meth_meth_ast_new5698_object = addmethod2pos(obj5696, "new()object", &meth_ast_new5698_object, 1);
  meth_meth_ast_new5698_object->definitionModule = modulename;
  meth_meth_ast_new5698_object->definitionLine = 1231;
  sourceObject = obj5696;
objclass5696 = obj5696->class;
  objclass5696->definitionModule = modulename;
  objclass5696->definitionLine = 1231;
  (*(struct UserObject *)self).data[0] = lowerouter5696;
  self = oldself5696;
  selfslot = oldselfslot5696;
  stackframe = oldstackframe5696;
// compilenode returning obj5696
  *var_identifierNode = obj5696;
  if (obj5696 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1315
  setline(1315);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1307
  setline(1307);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure5934 = createclosure(1, "octetsNode");
setclosureframe(closure5934, stackframe);
  addtoclosure(closure5934, var_octetsNode);
  struct UserObject *uo5934 = (struct UserObject*)self;
  uo5934->data[26] = (Object)closure5934;
  Method *meth_meth_ast_octetsNode5934 = addmethod2pos(self, "octetsNode", &meth_ast_octetsNode5934, 26);
int argcv_meth_ast_octetsNode5934[] = {0};
meth_meth_ast_octetsNode5934->type = alloc_MethodType(1, argcv_meth_ast_octetsNode5934);
  meth_meth_ast_octetsNode5934->definitionModule = modulename;
  meth_meth_ast_octetsNode5934->definitionLine = 1307;
// compilenode returning 
// Begin line 1307
  setline(1307);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject5935 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5935 = alloc_userobj2(2,4, objclass5935);
  gc_frame_newslot(obj5935);
// OBJECT OUTER DEC outer
  adddatum2(obj5935, self, 0);
  addmethodreal(obj5935,"outer", &reader_ast_outer_5936);
  Object oldself5935 = self;
  struct StackFrameObject *oldstackframe5935 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5935);
  gc_frame_newslot((Object)stackframe);
  self = obj5935;
  Object *oldselfslot5935 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5935 = (*(struct UserObject *)self).data[0], lowerouter5935 = thisouter5935;
  if (inheritingObject5935) {
    struct UserObject *inho5935 = (struct UserObject *)inheritingObject5935;
    while (inho5935->super != GraceDefaultObject) inho5935 = (struct UserObject *)inho5935->super;
    inho5935->super = obj5935;
    self = inheritingObject5935;
    *selfslot = self;
    lowerouter5935 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5935;
  }
  block_savedest(obj5935);
  Object closure5937 = createclosure(1, "new");
setclosureframe(closure5937, stackframe);
  addtoclosure(closure5937, var_baseNode);
  struct UserObject *uo5937 = (struct UserObject*)obj5935;
  uo5937->data[1] = (Object)closure5937;
  Method *meth_meth_ast_new5937 = addmethod2pos(obj5935, "new", &meth_ast_new5937, 1);
int argcv_meth_ast_new5937[] = {1};
meth_meth_ast_new5937->type = alloc_MethodType(1, argcv_meth_ast_new5937);
  meth_meth_ast_new5937->definitionModule = modulename;
  meth_meth_ast_new5937->definitionLine = 1307;
  block_savedest(obj5935);
  Object closure5962 = createclosure(1, "new()object");
setclosureframe(closure5962, stackframe);
  addtoclosure(closure5962, var_baseNode);
  Method *meth_meth_ast_new5937_object = addmethod2pos(obj5935, "new()object", &meth_ast_new5937_object, 1);
  meth_meth_ast_new5937_object->definitionModule = modulename;
  meth_meth_ast_new5937_object->definitionLine = 1307;
  sourceObject = obj5935;
objclass5935 = obj5935->class;
  objclass5935->definitionModule = modulename;
  objclass5935->definitionLine = 1307;
  (*(struct UserObject *)self).data[0] = lowerouter5935;
  self = oldself5935;
  selfslot = oldselfslot5935;
  stackframe = oldstackframe5935;
// compilenode returning obj5935
  *var_octetsNode = obj5935;
  if (obj5935 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1329
  setline(1329);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1326
  setline(1326);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure5963 = createclosure(1, "stringNode");
setclosureframe(closure5963, stackframe);
  addtoclosure(closure5963, var_stringNode);
  struct UserObject *uo5963 = (struct UserObject*)self;
  uo5963->data[27] = (Object)closure5963;
  Method *meth_meth_ast_stringNode5963 = addmethod2pos(self, "stringNode", &meth_ast_stringNode5963, 27);
int argcv_meth_ast_stringNode5963[] = {0};
meth_meth_ast_stringNode5963->type = alloc_MethodType(1, argcv_meth_ast_stringNode5963);
  meth_meth_ast_stringNode5963->definitionModule = modulename;
  meth_meth_ast_stringNode5963->definitionLine = 1326;
// compilenode returning 
// Begin line 1326
  setline(1326);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject5964 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5964 = alloc_userobj2(2,4, objclass5964);
  gc_frame_newslot(obj5964);
// OBJECT OUTER DEC outer
  adddatum2(obj5964, self, 0);
  addmethodreal(obj5964,"outer", &reader_ast_outer_5965);
  Object oldself5964 = self;
  struct StackFrameObject *oldstackframe5964 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5964);
  gc_frame_newslot((Object)stackframe);
  self = obj5964;
  Object *oldselfslot5964 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5964 = (*(struct UserObject *)self).data[0], lowerouter5964 = thisouter5964;
  if (inheritingObject5964) {
    struct UserObject *inho5964 = (struct UserObject *)inheritingObject5964;
    while (inho5964->super != GraceDefaultObject) inho5964 = (struct UserObject *)inho5964->super;
    inho5964->super = obj5964;
    self = inheritingObject5964;
    *selfslot = self;
    lowerouter5964 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5964;
  }
  block_savedest(obj5964);
  Object closure5966 = createclosure(1, "new");
setclosureframe(closure5966, stackframe);
  addtoclosure(closure5966, var_baseNode);
  struct UserObject *uo5966 = (struct UserObject*)obj5964;
  uo5966->data[1] = (Object)closure5966;
  Method *meth_meth_ast_new5966 = addmethod2pos(obj5964, "new", &meth_ast_new5966, 1);
int argcv_meth_ast_new5966[] = {1};
meth_meth_ast_new5966->type = alloc_MethodType(1, argcv_meth_ast_new5966);
  meth_meth_ast_new5966->definitionModule = modulename;
  meth_meth_ast_new5966->definitionLine = 1326;
  block_savedest(obj5964);
  Object closure6066 = createclosure(1, "new()object");
setclosureframe(closure6066, stackframe);
  addtoclosure(closure6066, var_baseNode);
  Method *meth_meth_ast_new5966_object = addmethod2pos(obj5964, "new()object", &meth_ast_new5966_object, 1);
  meth_meth_ast_new5966_object->definitionModule = modulename;
  meth_meth_ast_new5966_object->definitionLine = 1326;
  sourceObject = obj5964;
objclass5964 = obj5964->class;
  objclass5964->definitionModule = modulename;
  objclass5964->definitionLine = 1326;
  (*(struct UserObject *)self).data[0] = lowerouter5964;
  self = oldself5964;
  selfslot = oldselfslot5964;
  stackframe = oldstackframe5964;
// compilenode returning obj5964
  *var_stringNode = obj5964;
  if (obj5964 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1369
  setline(1369);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1351
  setline(1351);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure6067 = createclosure(1, "numNode");
setclosureframe(closure6067, stackframe);
  addtoclosure(closure6067, var_numNode);
  struct UserObject *uo6067 = (struct UserObject*)self;
  uo6067->data[28] = (Object)closure6067;
  Method *meth_meth_ast_numNode6067 = addmethod2pos(self, "numNode", &meth_ast_numNode6067, 28);
int argcv_meth_ast_numNode6067[] = {0};
meth_meth_ast_numNode6067->type = alloc_MethodType(1, argcv_meth_ast_numNode6067);
  meth_meth_ast_numNode6067->definitionModule = modulename;
  meth_meth_ast_numNode6067->definitionLine = 1351;
// compilenode returning 
// Begin line 1351
  setline(1351);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject6068 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6068 = alloc_userobj2(2,4, objclass6068);
  gc_frame_newslot(obj6068);
// OBJECT OUTER DEC outer
  adddatum2(obj6068, self, 0);
  addmethodreal(obj6068,"outer", &reader_ast_outer_6069);
  Object oldself6068 = self;
  struct StackFrameObject *oldstackframe6068 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6068);
  gc_frame_newslot((Object)stackframe);
  self = obj6068;
  Object *oldselfslot6068 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6068 = (*(struct UserObject *)self).data[0], lowerouter6068 = thisouter6068;
  if (inheritingObject6068) {
    struct UserObject *inho6068 = (struct UserObject *)inheritingObject6068;
    while (inho6068->super != GraceDefaultObject) inho6068 = (struct UserObject *)inho6068->super;
    inho6068->super = obj6068;
    self = inheritingObject6068;
    *selfslot = self;
    lowerouter6068 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6068;
  }
  block_savedest(obj6068);
  Object closure6070 = createclosure(1, "new");
setclosureframe(closure6070, stackframe);
  addtoclosure(closure6070, var_baseNode);
  struct UserObject *uo6070 = (struct UserObject*)obj6068;
  uo6070->data[1] = (Object)closure6070;
  Method *meth_meth_ast_new6070 = addmethod2pos(obj6068, "new", &meth_ast_new6070, 1);
int argcv_meth_ast_new6070[] = {1};
meth_meth_ast_new6070->type = alloc_MethodType(1, argcv_meth_ast_new6070);
  meth_meth_ast_new6070->definitionModule = modulename;
  meth_meth_ast_new6070->definitionLine = 1351;
  block_savedest(obj6068);
  Object closure6117 = createclosure(1, "new()object");
setclosureframe(closure6117, stackframe);
  addtoclosure(closure6117, var_baseNode);
  Method *meth_meth_ast_new6070_object = addmethod2pos(obj6068, "new()object", &meth_ast_new6070_object, 1);
  meth_meth_ast_new6070_object->definitionModule = modulename;
  meth_meth_ast_new6070_object->definitionLine = 1351;
  sourceObject = obj6068;
objclass6068 = obj6068->class;
  objclass6068->definitionModule = modulename;
  objclass6068->definitionLine = 1351;
  (*(struct UserObject *)self).data[0] = lowerouter6068;
  self = oldself6068;
  selfslot = oldselfslot6068;
  stackframe = oldstackframe6068;
// compilenode returning obj6068
  *var_numNode = obj6068;
  if (obj6068 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1393
  setline(1393);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1390
  setline(1390);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure6118 = createclosure(1, "opNode");
setclosureframe(closure6118, stackframe);
  addtoclosure(closure6118, var_opNode);
  struct UserObject *uo6118 = (struct UserObject*)self;
  uo6118->data[29] = (Object)closure6118;
  Method *meth_meth_ast_opNode6118 = addmethod2pos(self, "opNode", &meth_ast_opNode6118, 29);
int argcv_meth_ast_opNode6118[] = {0};
meth_meth_ast_opNode6118->type = alloc_MethodType(1, argcv_meth_ast_opNode6118);
  meth_meth_ast_opNode6118->definitionModule = modulename;
  meth_meth_ast_opNode6118->definitionLine = 1390;
// compilenode returning 
// Begin line 1390
  setline(1390);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject6119 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6119 = alloc_userobj2(2,4, objclass6119);
  gc_frame_newslot(obj6119);
// OBJECT OUTER DEC outer
  adddatum2(obj6119, self, 0);
  addmethodreal(obj6119,"outer", &reader_ast_outer_6120);
  Object oldself6119 = self;
  struct StackFrameObject *oldstackframe6119 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6119);
  gc_frame_newslot((Object)stackframe);
  self = obj6119;
  Object *oldselfslot6119 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6119 = (*(struct UserObject *)self).data[0], lowerouter6119 = thisouter6119;
  if (inheritingObject6119) {
    struct UserObject *inho6119 = (struct UserObject *)inheritingObject6119;
    while (inho6119->super != GraceDefaultObject) inho6119 = (struct UserObject *)inho6119->super;
    inho6119->super = obj6119;
    self = inheritingObject6119;
    *selfslot = self;
    lowerouter6119 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6119;
  }
  block_savedest(obj6119);
  Object closure6121 = createclosure(2, "new");
setclosureframe(closure6121, stackframe);
  addtoclosure(closure6121, var_opNode);
  addtoclosure(closure6121, var_baseNode);
  struct UserObject *uo6121 = (struct UserObject*)obj6119;
  uo6121->data[1] = (Object)closure6121;
  Method *meth_meth_ast_new6121 = addmethod2pos(obj6119, "new", &meth_ast_new6121, 1);
int argcv_meth_ast_new6121[] = {3};
meth_meth_ast_new6121->type = alloc_MethodType(1, argcv_meth_ast_new6121);
  meth_meth_ast_new6121->definitionModule = modulename;
  meth_meth_ast_new6121->definitionLine = 1390;
  block_savedest(obj6119);
  Object closure6359 = createclosure(2, "new()object");
setclosureframe(closure6359, stackframe);
  addtoclosure(closure6359, var_opNode);
  addtoclosure(closure6359, var_baseNode);
  Method *meth_meth_ast_new6121_object = addmethod2pos(obj6119, "new()object", &meth_ast_new6121_object, 1);
  meth_meth_ast_new6121_object->definitionModule = modulename;
  meth_meth_ast_new6121_object->definitionLine = 1390;
  sourceObject = obj6119;
objclass6119 = obj6119->class;
  objclass6119->definitionModule = modulename;
  objclass6119->definitionLine = 1390;
  (*(struct UserObject *)self).data[0] = lowerouter6119;
  self = oldself6119;
  selfslot = oldselfslot6119;
  stackframe = oldstackframe6119;
// compilenode returning obj6119
  *var_opNode = obj6119;
  if (obj6119 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1448
  setline(1448);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1443
  setline(1443);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure6360 = createclosure(1, "indexNode");
setclosureframe(closure6360, stackframe);
  addtoclosure(closure6360, var_indexNode);
  struct UserObject *uo6360 = (struct UserObject*)self;
  uo6360->data[30] = (Object)closure6360;
  Method *meth_meth_ast_indexNode6360 = addmethod2pos(self, "indexNode", &meth_ast_indexNode6360, 30);
int argcv_meth_ast_indexNode6360[] = {0};
meth_meth_ast_indexNode6360->type = alloc_MethodType(1, argcv_meth_ast_indexNode6360);
  meth_meth_ast_indexNode6360->definitionModule = modulename;
  meth_meth_ast_indexNode6360->definitionLine = 1443;
// compilenode returning 
// Begin line 1443
  setline(1443);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject6361 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6361 = alloc_userobj2(2,4, objclass6361);
  gc_frame_newslot(obj6361);
// OBJECT OUTER DEC outer
  adddatum2(obj6361, self, 0);
  addmethodreal(obj6361,"outer", &reader_ast_outer_6362);
  Object oldself6361 = self;
  struct StackFrameObject *oldstackframe6361 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6361);
  gc_frame_newslot((Object)stackframe);
  self = obj6361;
  Object *oldselfslot6361 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6361 = (*(struct UserObject *)self).data[0], lowerouter6361 = thisouter6361;
  if (inheritingObject6361) {
    struct UserObject *inho6361 = (struct UserObject *)inheritingObject6361;
    while (inho6361->super != GraceDefaultObject) inho6361 = (struct UserObject *)inho6361->super;
    inho6361->super = obj6361;
    self = inheritingObject6361;
    *selfslot = self;
    lowerouter6361 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6361;
  }
  block_savedest(obj6361);
  Object closure6363 = createclosure(2, "new");
setclosureframe(closure6363, stackframe);
  addtoclosure(closure6363, var_indexNode);
  addtoclosure(closure6363, var_baseNode);
  struct UserObject *uo6363 = (struct UserObject*)obj6361;
  uo6363->data[1] = (Object)closure6363;
  Method *meth_meth_ast_new6363 = addmethod2pos(obj6361, "new", &meth_ast_new6363, 1);
int argcv_meth_ast_new6363[] = {2};
meth_meth_ast_new6363->type = alloc_MethodType(1, argcv_meth_ast_new6363);
  meth_meth_ast_new6363->definitionModule = modulename;
  meth_meth_ast_new6363->definitionLine = 1443;
  block_savedest(obj6361);
  Object closure6520 = createclosure(2, "new()object");
setclosureframe(closure6520, stackframe);
  addtoclosure(closure6520, var_indexNode);
  addtoclosure(closure6520, var_baseNode);
  Method *meth_meth_ast_new6363_object = addmethod2pos(obj6361, "new()object", &meth_ast_new6363_object, 1);
  meth_meth_ast_new6363_object->definitionModule = modulename;
  meth_meth_ast_new6363_object->definitionLine = 1443;
  sourceObject = obj6361;
objclass6361 = obj6361->class;
  objclass6361->definitionModule = modulename;
  objclass6361->definitionLine = 1443;
  (*(struct UserObject *)self).data[0] = lowerouter6361;
  self = oldself6361;
  selfslot = oldselfslot6361;
  stackframe = oldstackframe6361;
// compilenode returning obj6361
  *var_indexNode = obj6361;
  if (obj6361 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1492
  setline(1492);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1488
  setline(1488);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure6521 = createclosure(1, "bindNode");
setclosureframe(closure6521, stackframe);
  addtoclosure(closure6521, var_bindNode);
  struct UserObject *uo6521 = (struct UserObject*)self;
  uo6521->data[31] = (Object)closure6521;
  Method *meth_meth_ast_bindNode6521 = addmethod2pos(self, "bindNode", &meth_ast_bindNode6521, 31);
int argcv_meth_ast_bindNode6521[] = {0};
meth_meth_ast_bindNode6521->type = alloc_MethodType(1, argcv_meth_ast_bindNode6521);
  meth_meth_ast_bindNode6521->definitionModule = modulename;
  meth_meth_ast_bindNode6521->definitionLine = 1488;
// compilenode returning 
// Begin line 1488
  setline(1488);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject6522 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6522 = alloc_userobj2(2,4, objclass6522);
  gc_frame_newslot(obj6522);
// OBJECT OUTER DEC outer
  adddatum2(obj6522, self, 0);
  addmethodreal(obj6522,"outer", &reader_ast_outer_6523);
  Object oldself6522 = self;
  struct StackFrameObject *oldstackframe6522 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6522);
  gc_frame_newslot((Object)stackframe);
  self = obj6522;
  Object *oldselfslot6522 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6522 = (*(struct UserObject *)self).data[0], lowerouter6522 = thisouter6522;
  if (inheritingObject6522) {
    struct UserObject *inho6522 = (struct UserObject *)inheritingObject6522;
    while (inho6522->super != GraceDefaultObject) inho6522 = (struct UserObject *)inho6522->super;
    inho6522->super = obj6522;
    self = inheritingObject6522;
    *selfslot = self;
    lowerouter6522 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6522;
  }
  block_savedest(obj6522);
  Object closure6524 = createclosure(2, "new");
setclosureframe(closure6524, stackframe);
  addtoclosure(closure6524, var_bindNode);
  addtoclosure(closure6524, var_baseNode);
  struct UserObject *uo6524 = (struct UserObject*)obj6522;
  uo6524->data[1] = (Object)closure6524;
  Method *meth_meth_ast_new6524 = addmethod2pos(obj6522, "new", &meth_ast_new6524, 1);
int argcv_meth_ast_new6524[] = {2};
meth_meth_ast_new6524->type = alloc_MethodType(1, argcv_meth_ast_new6524);
  meth_meth_ast_new6524->definitionModule = modulename;
  meth_meth_ast_new6524->definitionLine = 1488;
  block_savedest(obj6522);
  Object closure6677 = createclosure(2, "new()object");
setclosureframe(closure6677, stackframe);
  addtoclosure(closure6677, var_bindNode);
  addtoclosure(closure6677, var_baseNode);
  Method *meth_meth_ast_new6524_object = addmethod2pos(obj6522, "new()object", &meth_ast_new6524_object, 1);
  meth_meth_ast_new6524_object->definitionModule = modulename;
  meth_meth_ast_new6524_object->definitionLine = 1488;
  sourceObject = obj6522;
objclass6522 = obj6522->class;
  objclass6522->definitionModule = modulename;
  objclass6522->definitionLine = 1488;
  (*(struct UserObject *)self).data[0] = lowerouter6522;
  self = oldself6522;
  selfslot = oldselfslot6522;
  stackframe = oldstackframe6522;
// compilenode returning obj6522
  *var_bindNode = obj6522;
  if (obj6522 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1536
  setline(1536);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1532
  setline(1532);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure6678 = createclosure(1, "defDecNode");
setclosureframe(closure6678, stackframe);
  addtoclosure(closure6678, var_defDecNode);
  struct UserObject *uo6678 = (struct UserObject*)self;
  uo6678->data[32] = (Object)closure6678;
  Method *meth_meth_ast_defDecNode6678 = addmethod2pos(self, "defDecNode", &meth_ast_defDecNode6678, 32);
int argcv_meth_ast_defDecNode6678[] = {0};
meth_meth_ast_defDecNode6678->type = alloc_MethodType(1, argcv_meth_ast_defDecNode6678);
  meth_meth_ast_defDecNode6678->definitionModule = modulename;
  meth_meth_ast_defDecNode6678->definitionLine = 1532;
// compilenode returning 
// Begin line 1532
  setline(1532);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject6679 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6679 = alloc_userobj2(2,4, objclass6679);
  gc_frame_newslot(obj6679);
// OBJECT OUTER DEC outer
  adddatum2(obj6679, self, 0);
  addmethodreal(obj6679,"outer", &reader_ast_outer_6680);
  Object oldself6679 = self;
  struct StackFrameObject *oldstackframe6679 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6679);
  gc_frame_newslot((Object)stackframe);
  self = obj6679;
  Object *oldselfslot6679 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6679 = (*(struct UserObject *)self).data[0], lowerouter6679 = thisouter6679;
  if (inheritingObject6679) {
    struct UserObject *inho6679 = (struct UserObject *)inheritingObject6679;
    while (inho6679->super != GraceDefaultObject) inho6679 = (struct UserObject *)inho6679->super;
    inho6679->super = obj6679;
    self = inheritingObject6679;
    *selfslot = self;
    lowerouter6679 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6679;
  }
  block_savedest(obj6679);
  Object closure6681 = createclosure(4, "new");
setclosureframe(closure6681, stackframe);
  addtoclosure(closure6681, var_defDecNode);
  addtoclosure(closure6681, var_identifierNode);
  addtoclosure(closure6681, var_baseNode);
  addtoclosure(closure6681, var_collections);
  struct UserObject *uo6681 = (struct UserObject*)obj6679;
  uo6681->data[1] = (Object)closure6681;
  Method *meth_meth_ast_new6681 = addmethod2pos(obj6679, "new", &meth_ast_new6681, 1);
int argcv_meth_ast_new6681[] = {3};
meth_meth_ast_new6681->type = alloc_MethodType(1, argcv_meth_ast_new6681);
  meth_meth_ast_new6681->definitionModule = modulename;
  meth_meth_ast_new6681->definitionLine = 1532;
  block_savedest(obj6679);
  Object closure7018 = createclosure(4, "new()object");
setclosureframe(closure7018, stackframe);
  addtoclosure(closure7018, var_defDecNode);
  addtoclosure(closure7018, var_identifierNode);
  addtoclosure(closure7018, var_baseNode);
  addtoclosure(closure7018, var_collections);
  Method *meth_meth_ast_new6681_object = addmethod2pos(obj6679, "new()object", &meth_ast_new6681_object, 1);
  meth_meth_ast_new6681_object->definitionModule = modulename;
  meth_meth_ast_new6681_object->definitionLine = 1532;
  sourceObject = obj6679;
objclass6679 = obj6679->class;
  objclass6679->definitionModule = modulename;
  objclass6679->definitionLine = 1532;
  (*(struct UserObject *)self).data[0] = lowerouter6679;
  self = oldself6679;
  selfslot = oldselfslot6679;
  stackframe = oldstackframe6679;
// compilenode returning obj6679
  *var_defDecNode = obj6679;
  if (obj6679 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1615
  setline(1615);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1542
  setline(1542);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure7019 = createclosure(1, "varDecNode");
setclosureframe(closure7019, stackframe);
  addtoclosure(closure7019, var_varDecNode);
  struct UserObject *uo7019 = (struct UserObject*)self;
  uo7019->data[33] = (Object)closure7019;
  Method *meth_meth_ast_varDecNode7019 = addmethod2pos(self, "varDecNode", &meth_ast_varDecNode7019, 33);
int argcv_meth_ast_varDecNode7019[] = {0};
meth_meth_ast_varDecNode7019->type = alloc_MethodType(1, argcv_meth_ast_varDecNode7019);
  meth_meth_ast_varDecNode7019->definitionModule = modulename;
  meth_meth_ast_varDecNode7019->definitionLine = 1542;
// compilenode returning 
// Begin line 1542
  setline(1542);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject7020 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7020 = alloc_userobj2(2,4, objclass7020);
  gc_frame_newslot(obj7020);
// OBJECT OUTER DEC outer
  adddatum2(obj7020, self, 0);
  addmethodreal(obj7020,"outer", &reader_ast_outer_7021);
  Object oldself7020 = self;
  struct StackFrameObject *oldstackframe7020 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7020);
  gc_frame_newslot((Object)stackframe);
  self = obj7020;
  Object *oldselfslot7020 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7020 = (*(struct UserObject *)self).data[0], lowerouter7020 = thisouter7020;
  if (inheritingObject7020) {
    struct UserObject *inho7020 = (struct UserObject *)inheritingObject7020;
    while (inho7020->super != GraceDefaultObject) inho7020 = (struct UserObject *)inho7020->super;
    inho7020->super = obj7020;
    self = inheritingObject7020;
    *selfslot = self;
    lowerouter7020 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7020;
  }
  block_savedest(obj7020);
  Object closure7022 = createclosure(4, "new");
setclosureframe(closure7022, stackframe);
  addtoclosure(closure7022, var_varDecNode);
  addtoclosure(closure7022, var_identifierNode);
  addtoclosure(closure7022, var_baseNode);
  addtoclosure(closure7022, var_collections);
  struct UserObject *uo7022 = (struct UserObject*)obj7020;
  uo7022->data[1] = (Object)closure7022;
  Method *meth_meth_ast_new7022 = addmethod2pos(obj7020, "new", &meth_ast_new7022, 1);
int argcv_meth_ast_new7022[] = {3};
meth_meth_ast_new7022->type = alloc_MethodType(1, argcv_meth_ast_new7022);
  meth_meth_ast_new7022->definitionModule = modulename;
  meth_meth_ast_new7022->definitionLine = 1542;
  block_savedest(obj7020);
  Object closure7363 = createclosure(4, "new()object");
setclosureframe(closure7363, stackframe);
  addtoclosure(closure7363, var_varDecNode);
  addtoclosure(closure7363, var_identifierNode);
  addtoclosure(closure7363, var_baseNode);
  addtoclosure(closure7363, var_collections);
  Method *meth_meth_ast_new7022_object = addmethod2pos(obj7020, "new()object", &meth_ast_new7022_object, 1);
  meth_meth_ast_new7022_object->definitionModule = modulename;
  meth_meth_ast_new7022_object->definitionLine = 1542;
  sourceObject = obj7020;
objclass7020 = obj7020->class;
  objclass7020->definitionModule = modulename;
  objclass7020->definitionLine = 1542;
  (*(struct UserObject *)self).data[0] = lowerouter7020;
  self = oldself7020;
  selfslot = oldselfslot7020;
  stackframe = oldstackframe7020;
// compilenode returning obj7020
  *var_varDecNode = obj7020;
  if (obj7020 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1693
  setline(1693);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1621
  setline(1621);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure7364 = createclosure(1, "importNode");
setclosureframe(closure7364, stackframe);
  addtoclosure(closure7364, var_importNode);
  struct UserObject *uo7364 = (struct UserObject*)self;
  uo7364->data[34] = (Object)closure7364;
  Method *meth_meth_ast_importNode7364 = addmethod2pos(self, "importNode", &meth_ast_importNode7364, 34);
int argcv_meth_ast_importNode7364[] = {0};
meth_meth_ast_importNode7364->type = alloc_MethodType(1, argcv_meth_ast_importNode7364);
  meth_meth_ast_importNode7364->definitionModule = modulename;
  meth_meth_ast_importNode7364->definitionLine = 1621;
// compilenode returning 
// Begin line 1621
  setline(1621);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject7365 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7365 = alloc_userobj2(2,4, objclass7365);
  gc_frame_newslot(obj7365);
// OBJECT OUTER DEC outer
  adddatum2(obj7365, self, 0);
  addmethodreal(obj7365,"outer", &reader_ast_outer_7366);
  Object oldself7365 = self;
  struct StackFrameObject *oldstackframe7365 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7365);
  gc_frame_newslot((Object)stackframe);
  self = obj7365;
  Object *oldselfslot7365 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7365 = (*(struct UserObject *)self).data[0], lowerouter7365 = thisouter7365;
  if (inheritingObject7365) {
    struct UserObject *inho7365 = (struct UserObject *)inheritingObject7365;
    while (inho7365->super != GraceDefaultObject) inho7365 = (struct UserObject *)inho7365->super;
    inho7365->super = obj7365;
    self = inheritingObject7365;
    *selfslot = self;
    lowerouter7365 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7365;
  }
  block_savedest(obj7365);
  Object closure7367 = createclosure(1, "new");
setclosureframe(closure7367, stackframe);
  addtoclosure(closure7367, var_baseNode);
  struct UserObject *uo7367 = (struct UserObject*)obj7365;
  uo7367->data[1] = (Object)closure7367;
  Method *meth_meth_ast_new7367 = addmethod2pos(obj7365, "new", &meth_ast_new7367, 1);
int argcv_meth_ast_new7367[] = {2};
meth_meth_ast_new7367->type = alloc_MethodType(1, argcv_meth_ast_new7367);
  meth_meth_ast_new7367->definitionModule = modulename;
  meth_meth_ast_new7367->definitionLine = 1621;
  block_savedest(obj7365);
  Object closure7487 = createclosure(1, "new()object");
setclosureframe(closure7487, stackframe);
  addtoclosure(closure7487, var_baseNode);
  Method *meth_meth_ast_new7367_object = addmethod2pos(obj7365, "new()object", &meth_ast_new7367_object, 1);
  meth_meth_ast_new7367_object->definitionModule = modulename;
  meth_meth_ast_new7367_object->definitionLine = 1621;
  sourceObject = obj7365;
objclass7365 = obj7365->class;
  objclass7365->definitionModule = modulename;
  objclass7365->definitionLine = 1621;
  (*(struct UserObject *)self).data[0] = lowerouter7365;
  self = oldself7365;
  selfslot = oldselfslot7365;
  stackframe = oldstackframe7365;
// compilenode returning obj7365
  *var_importNode = obj7365;
  if (obj7365 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1728
  setline(1728);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1725
  setline(1725);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure7488 = createclosure(1, "dialectNode");
setclosureframe(closure7488, stackframe);
  addtoclosure(closure7488, var_dialectNode);
  struct UserObject *uo7488 = (struct UserObject*)self;
  uo7488->data[35] = (Object)closure7488;
  Method *meth_meth_ast_dialectNode7488 = addmethod2pos(self, "dialectNode", &meth_ast_dialectNode7488, 35);
int argcv_meth_ast_dialectNode7488[] = {0};
meth_meth_ast_dialectNode7488->type = alloc_MethodType(1, argcv_meth_ast_dialectNode7488);
  meth_meth_ast_dialectNode7488->definitionModule = modulename;
  meth_meth_ast_dialectNode7488->definitionLine = 1725;
// compilenode returning 
// Begin line 1725
  setline(1725);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject7489 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7489 = alloc_userobj2(2,4, objclass7489);
  gc_frame_newslot(obj7489);
// OBJECT OUTER DEC outer
  adddatum2(obj7489, self, 0);
  addmethodreal(obj7489,"outer", &reader_ast_outer_7490);
  Object oldself7489 = self;
  struct StackFrameObject *oldstackframe7489 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7489);
  gc_frame_newslot((Object)stackframe);
  self = obj7489;
  Object *oldselfslot7489 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7489 = (*(struct UserObject *)self).data[0], lowerouter7489 = thisouter7489;
  if (inheritingObject7489) {
    struct UserObject *inho7489 = (struct UserObject *)inheritingObject7489;
    while (inho7489->super != GraceDefaultObject) inho7489 = (struct UserObject *)inho7489->super;
    inho7489->super = obj7489;
    self = inheritingObject7489;
    *selfslot = self;
    lowerouter7489 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7489;
  }
  block_savedest(obj7489);
  Object closure7491 = createclosure(1, "new");
setclosureframe(closure7491, stackframe);
  addtoclosure(closure7491, var_baseNode);
  struct UserObject *uo7491 = (struct UserObject*)obj7489;
  uo7491->data[1] = (Object)closure7491;
  Method *meth_meth_ast_new7491 = addmethod2pos(obj7489, "new", &meth_ast_new7491, 1);
int argcv_meth_ast_new7491[] = {1};
meth_meth_ast_new7491->type = alloc_MethodType(1, argcv_meth_ast_new7491);
  meth_meth_ast_new7491->definitionModule = modulename;
  meth_meth_ast_new7491->definitionLine = 1725;
  block_savedest(obj7489);
  Object closure7576 = createclosure(1, "new()object");
setclosureframe(closure7576, stackframe);
  addtoclosure(closure7576, var_baseNode);
  Method *meth_meth_ast_new7491_object = addmethod2pos(obj7489, "new()object", &meth_ast_new7491_object, 1);
  meth_meth_ast_new7491_object->definitionModule = modulename;
  meth_meth_ast_new7491_object->definitionLine = 1725;
  sourceObject = obj7489;
objclass7489 = obj7489->class;
  objclass7489->definitionModule = modulename;
  objclass7489->definitionLine = 1725;
  (*(struct UserObject *)self).data[0] = lowerouter7489;
  self = oldself7489;
  selfslot = oldselfslot7489;
  stackframe = oldstackframe7489;
// compilenode returning obj7489
  *var_dialectNode = obj7489;
  if (obj7489 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1759
  setline(1759);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1756
  setline(1756);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure7577 = createclosure(1, "returnNode");
setclosureframe(closure7577, stackframe);
  addtoclosure(closure7577, var_returnNode);
  struct UserObject *uo7577 = (struct UserObject*)self;
  uo7577->data[36] = (Object)closure7577;
  Method *meth_meth_ast_returnNode7577 = addmethod2pos(self, "returnNode", &meth_ast_returnNode7577, 36);
int argcv_meth_ast_returnNode7577[] = {0};
meth_meth_ast_returnNode7577->type = alloc_MethodType(1, argcv_meth_ast_returnNode7577);
  meth_meth_ast_returnNode7577->definitionModule = modulename;
  meth_meth_ast_returnNode7577->definitionLine = 1756;
// compilenode returning 
// Begin line 1756
  setline(1756);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject7578 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7578 = alloc_userobj2(2,4, objclass7578);
  gc_frame_newslot(obj7578);
// OBJECT OUTER DEC outer
  adddatum2(obj7578, self, 0);
  addmethodreal(obj7578,"outer", &reader_ast_outer_7579);
  Object oldself7578 = self;
  struct StackFrameObject *oldstackframe7578 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7578);
  gc_frame_newslot((Object)stackframe);
  self = obj7578;
  Object *oldselfslot7578 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7578 = (*(struct UserObject *)self).data[0], lowerouter7578 = thisouter7578;
  if (inheritingObject7578) {
    struct UserObject *inho7578 = (struct UserObject *)inheritingObject7578;
    while (inho7578->super != GraceDefaultObject) inho7578 = (struct UserObject *)inho7578->super;
    inho7578->super = obj7578;
    self = inheritingObject7578;
    *selfslot = self;
    lowerouter7578 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7578;
  }
  block_savedest(obj7578);
  Object closure7580 = createclosure(2, "new");
setclosureframe(closure7580, stackframe);
  addtoclosure(closure7580, var_returnNode);
  addtoclosure(closure7580, var_baseNode);
  struct UserObject *uo7580 = (struct UserObject*)obj7578;
  uo7580->data[1] = (Object)closure7580;
  Method *meth_meth_ast_new7580 = addmethod2pos(obj7578, "new", &meth_ast_new7580, 1);
int argcv_meth_ast_new7580[] = {1};
meth_meth_ast_new7580->type = alloc_MethodType(1, argcv_meth_ast_new7580);
  meth_meth_ast_new7580->definitionModule = modulename;
  meth_meth_ast_new7580->definitionLine = 1756;
  block_savedest(obj7578);
  Object closure7669 = createclosure(2, "new()object");
setclosureframe(closure7669, stackframe);
  addtoclosure(closure7669, var_returnNode);
  addtoclosure(closure7669, var_baseNode);
  Method *meth_meth_ast_new7580_object = addmethod2pos(obj7578, "new()object", &meth_ast_new7580_object, 1);
  meth_meth_ast_new7580_object->definitionModule = modulename;
  meth_meth_ast_new7580_object->definitionLine = 1756;
  sourceObject = obj7578;
objclass7578 = obj7578->class;
  objclass7578->definitionModule = modulename;
  objclass7578->definitionLine = 1756;
  (*(struct UserObject *)self).data[0] = lowerouter7578;
  self = oldself7578;
  selfslot = oldselfslot7578;
  stackframe = oldstackframe7578;
// compilenode returning obj7578
  *var_returnNode = obj7578;
  if (obj7578 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1793
  setline(1793);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1790
  setline(1790);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure7670 = createclosure(1, "inheritsNode");
setclosureframe(closure7670, stackframe);
  addtoclosure(closure7670, var_inheritsNode);
  struct UserObject *uo7670 = (struct UserObject*)self;
  uo7670->data[37] = (Object)closure7670;
  Method *meth_meth_ast_inheritsNode7670 = addmethod2pos(self, "inheritsNode", &meth_ast_inheritsNode7670, 37);
int argcv_meth_ast_inheritsNode7670[] = {0};
meth_meth_ast_inheritsNode7670->type = alloc_MethodType(1, argcv_meth_ast_inheritsNode7670);
  meth_meth_ast_inheritsNode7670->definitionModule = modulename;
  meth_meth_ast_inheritsNode7670->definitionLine = 1790;
// compilenode returning 
// Begin line 1790
  setline(1790);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject7671 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7671 = alloc_userobj2(2,4, objclass7671);
  gc_frame_newslot(obj7671);
// OBJECT OUTER DEC outer
  adddatum2(obj7671, self, 0);
  addmethodreal(obj7671,"outer", &reader_ast_outer_7672);
  Object oldself7671 = self;
  struct StackFrameObject *oldstackframe7671 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7671);
  gc_frame_newslot((Object)stackframe);
  self = obj7671;
  Object *oldselfslot7671 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7671 = (*(struct UserObject *)self).data[0], lowerouter7671 = thisouter7671;
  if (inheritingObject7671) {
    struct UserObject *inho7671 = (struct UserObject *)inheritingObject7671;
    while (inho7671->super != GraceDefaultObject) inho7671 = (struct UserObject *)inho7671->super;
    inho7671->super = obj7671;
    self = inheritingObject7671;
    *selfslot = self;
    lowerouter7671 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7671;
  }
  block_savedest(obj7671);
  Object closure7673 = createclosure(2, "new");
setclosureframe(closure7673, stackframe);
  addtoclosure(closure7673, var_inheritsNode);
  addtoclosure(closure7673, var_baseNode);
  struct UserObject *uo7673 = (struct UserObject*)obj7671;
  uo7673->data[1] = (Object)closure7673;
  Method *meth_meth_ast_new7673 = addmethod2pos(obj7671, "new", &meth_ast_new7673, 1);
int argcv_meth_ast_new7673[] = {1};
meth_meth_ast_new7673->type = alloc_MethodType(1, argcv_meth_ast_new7673);
  meth_meth_ast_new7673->definitionModule = modulename;
  meth_meth_ast_new7673->definitionLine = 1790;
  block_savedest(obj7671);
  Object closure7767 = createclosure(2, "new()object");
setclosureframe(closure7767, stackframe);
  addtoclosure(closure7767, var_inheritsNode);
  addtoclosure(closure7767, var_baseNode);
  Method *meth_meth_ast_new7673_object = addmethod2pos(obj7671, "new()object", &meth_ast_new7673_object, 1);
  meth_meth_ast_new7673_object->definitionModule = modulename;
  meth_meth_ast_new7673_object->definitionLine = 1790;
  sourceObject = obj7671;
objclass7671 = obj7671->class;
  objclass7671->definitionModule = modulename;
  objclass7671->definitionLine = 1790;
  (*(struct UserObject *)self).data[0] = lowerouter7671;
  self = oldself7671;
  selfslot = oldselfslot7671;
  stackframe = oldstackframe7671;
// compilenode returning obj7671
  *var_inheritsNode = obj7671;
  if (obj7671 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1827
  setline(1827);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1824
  setline(1824);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure7768 = createclosure(1, "blankNode");
setclosureframe(closure7768, stackframe);
  addtoclosure(closure7768, var_blankNode);
  struct UserObject *uo7768 = (struct UserObject*)self;
  uo7768->data[38] = (Object)closure7768;
  Method *meth_meth_ast_blankNode7768 = addmethod2pos(self, "blankNode", &meth_ast_blankNode7768, 38);
int argcv_meth_ast_blankNode7768[] = {0};
meth_meth_ast_blankNode7768->type = alloc_MethodType(1, argcv_meth_ast_blankNode7768);
  meth_meth_ast_blankNode7768->definitionModule = modulename;
  meth_meth_ast_blankNode7768->definitionLine = 1824;
// compilenode returning 
// Begin line 1824
  setline(1824);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject7769 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7769 = alloc_userobj2(2,4, objclass7769);
  gc_frame_newslot(obj7769);
// OBJECT OUTER DEC outer
  adddatum2(obj7769, self, 0);
  addmethodreal(obj7769,"outer", &reader_ast_outer_7770);
  Object oldself7769 = self;
  struct StackFrameObject *oldstackframe7769 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7769);
  gc_frame_newslot((Object)stackframe);
  self = obj7769;
  Object *oldselfslot7769 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7769 = (*(struct UserObject *)self).data[0], lowerouter7769 = thisouter7769;
  if (inheritingObject7769) {
    struct UserObject *inho7769 = (struct UserObject *)inheritingObject7769;
    while (inho7769->super != GraceDefaultObject) inho7769 = (struct UserObject *)inho7769->super;
    inho7769->super = obj7769;
    self = inheritingObject7769;
    *selfslot = self;
    lowerouter7769 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7769;
  }
  block_savedest(obj7769);
  Object closure7771 = createclosure(1, "new");
setclosureframe(closure7771, stackframe);
  addtoclosure(closure7771, var_baseNode);
  struct UserObject *uo7771 = (struct UserObject*)obj7769;
  uo7771->data[1] = (Object)closure7771;
  Method *meth_meth_ast_new7771 = addmethod2pos(obj7769, "new", &meth_ast_new7771, 1);
int argcv_meth_ast_new7771[] = {0};
meth_meth_ast_new7771->type = alloc_MethodType(1, argcv_meth_ast_new7771);
  meth_meth_ast_new7771->definitionModule = modulename;
  meth_meth_ast_new7771->definitionLine = 1824;
  block_savedest(obj7769);
  Object closure7795 = createclosure(1, "new()object");
setclosureframe(closure7795, stackframe);
  addtoclosure(closure7795, var_baseNode);
  Method *meth_meth_ast_new7771_object = addmethod2pos(obj7769, "new()object", &meth_ast_new7771_object, 1);
  meth_meth_ast_new7771_object->definitionModule = modulename;
  meth_meth_ast_new7771_object->definitionLine = 1824;
  sourceObject = obj7769;
objclass7769 = obj7769->class;
  objclass7769->definitionModule = modulename;
  objclass7769->definitionLine = 1824;
  (*(struct UserObject *)self).data[0] = lowerouter7769;
  self = oldself7769;
  selfslot = oldselfslot7769;
  stackframe = oldstackframe7769;
// compilenode returning obj7769
  *var_blankNode = obj7769;
  if (obj7769 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1827
  setline(1827);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 1847
  setline(1847);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1824
  setline(1824);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure7796 = createclosure(1, "signaturePart");
setclosureframe(closure7796, stackframe);
  addtoclosure(closure7796, var_signaturePart);
  struct UserObject *uo7796 = (struct UserObject*)self;
  uo7796->data[39] = (Object)closure7796;
  Method *meth_meth_ast_signaturePart7796 = addmethod2pos(self, "signaturePart", &meth_ast_signaturePart7796, 39);
int argcv_meth_ast_signaturePart7796[] = {0};
meth_meth_ast_signaturePart7796->type = alloc_MethodType(1, argcv_meth_ast_signaturePart7796);
  meth_meth_ast_signaturePart7796->definitionModule = modulename;
  meth_meth_ast_signaturePart7796->definitionLine = 1824;
// compilenode returning 
// Begin line 1824
  setline(1824);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject7797 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7797 = alloc_userobj2(2,4, objclass7797);
  gc_frame_newslot(obj7797);
// OBJECT OUTER DEC outer
  adddatum2(obj7797, self, 0);
  addmethodreal(obj7797,"outer", &reader_ast_outer_7798);
  Object oldself7797 = self;
  struct StackFrameObject *oldstackframe7797 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7797);
  gc_frame_newslot((Object)stackframe);
  self = obj7797;
  Object *oldselfslot7797 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7797 = (*(struct UserObject *)self).data[0], lowerouter7797 = thisouter7797;
  if (inheritingObject7797) {
    struct UserObject *inho7797 = (struct UserObject *)inheritingObject7797;
    while (inho7797->super != GraceDefaultObject) inho7797 = (struct UserObject *)inho7797->super;
    inho7797->super = obj7797;
    self = inheritingObject7797;
    *selfslot = self;
    lowerouter7797 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7797;
  }
  block_savedest(obj7797);
  Object closure7799 = createclosure(2, "new");
setclosureframe(closure7799, stackframe);
  addtoclosure(closure7799, var_signaturePart);
  addtoclosure(closure7799, var_baseNode);
  struct UserObject *uo7799 = (struct UserObject*)obj7797;
  uo7799->data[1] = (Object)closure7799;
  Method *meth_meth_ast_new7799 = addmethod2pos(obj7797, "new", &meth_ast_new7799, 1);
int argcv_meth_ast_new7799[] = {0};
meth_meth_ast_new7799->type = alloc_MethodType(1, argcv_meth_ast_new7799);
  meth_meth_ast_new7799->definitionModule = modulename;
  meth_meth_ast_new7799->definitionLine = 1824;
  block_savedest(obj7797);
  Object closure7878 = createclosure(2, "new()object");
setclosureframe(closure7878, stackframe);
  addtoclosure(closure7878, var_signaturePart);
  addtoclosure(closure7878, var_baseNode);
  Method *meth_meth_ast_new7799_object = addmethod2pos(obj7797, "new()object", &meth_ast_new7799_object, 1);
  meth_meth_ast_new7799_object->definitionModule = modulename;
  meth_meth_ast_new7799_object->definitionLine = 1824;
  sourceObject = obj7797;
objclass7797 = obj7797->class;
  objclass7797->definitionModule = modulename;
  objclass7797->definitionLine = 1824;
  (*(struct UserObject *)self).data[0] = lowerouter7797;
  self = oldself7797;
  selfslot = oldselfslot7797;
  stackframe = oldstackframe7797;
// compilenode returning obj7797
  *var_signaturePart = obj7797;
  if (obj7797 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1847
  setline(1847);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 1875
  setline(1875);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 2023
  setline(2023);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2022
  setline(2022);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning self
  *var_ast = self;
  if (self == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure7879 = createclosure(1, "ast");
setclosureframe(closure7879, stackframe);
  addtoclosure(closure7879, var_ast);
  struct UserObject *uo7879 = (struct UserObject*)self;
  uo7879->data[40] = (Object)closure7879;
  Method *meth_meth_ast_ast7879 = addmethod2pos(self, "ast", &meth_ast_ast7879, 40);
int argcv_meth_ast_ast7879[] = {0};
meth_meth_ast_ast7879->type = alloc_MethodType(1, argcv_meth_ast_ast7879);
  meth_meth_ast_ast7879->definitionModule = modulename;
  meth_meth_ast_ast7879->definitionLine = 1860;
// compilenode returning 
// compilenode returning done
// Begin line 2023
  setline(2023);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject7880 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7880 = alloc_userobj2(2,4, objclass7880);
  gc_frame_newslot(obj7880);
// OBJECT OUTER DEC outer
  adddatum2(obj7880, self, 0);
  addmethodreal(obj7880,"outer", &reader_ast_outer_7881);
  Object oldself7880 = self;
  struct StackFrameObject *oldstackframe7880 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7880);
  gc_frame_newslot((Object)stackframe);
  self = obj7880;
  Object *oldselfslot7880 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7880 = (*(struct UserObject *)self).data[0], lowerouter7880 = thisouter7880;
  if (inheritingObject7880) {
    struct UserObject *inho7880 = (struct UserObject *)inheritingObject7880;
    while (inho7880->super != GraceDefaultObject) inho7880 = (struct UserObject *)inho7880->super;
    inho7880->super = obj7880;
    self = inheritingObject7880;
    *selfslot = self;
    lowerouter7880 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7880;
  }
  struct UserObject *uo7882 = (struct UserObject*)obj7880;
  uo7882->data[1] = emptyclosure;
  Method *meth_meth_ast_visitCall7882 = addmethod2pos(obj7880, "visitCall", &meth_ast_visitCall7882, 1);
int argcv_meth_ast_visitCall7882[] = {1};
meth_meth_ast_visitCall7882->type = alloc_MethodType(1, argcv_meth_ast_visitCall7882);
  meth_meth_ast_visitCall7882->definitionModule = modulename;
  meth_meth_ast_visitCall7882->definitionLine = 2025;
  sourceObject = obj7880;
// Begin line 2024
  setline(2024);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7887 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_ast
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7888 = callmethod(*var_ast, "baseVisitor()object",
    2, partcv, params);
  gc_frame_end(callframe7887);
// compilenode returning call7888
  struct UserObject *obj7880_uo = (struct UserObject *)obj7880;
  obj7880_uo->super = call7888;
  sourceObject = obj7880;
objclass7880 = obj7880->class;
  objclass7880->definitionModule = modulename;
  objclass7880->definitionLine = 2023;
  (*(struct UserObject *)self).data[0] = lowerouter7880;
  self = oldself7880;
  selfslot = oldselfslot7880;
  stackframe = oldstackframe7880;
// compilenode returning obj7880
  *var_patternMarkVisitor = obj7880;
  if (obj7880 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure7889 = createclosure(1, "patternMarkVisitor");
setclosureframe(closure7889, stackframe);
  addtoclosure(closure7889, var_patternMarkVisitor);
  struct UserObject *uo7889 = (struct UserObject*)self;
  uo7889->data[41] = (Object)closure7889;
  Method *meth_meth_ast_patternMarkVisitor7889 = addmethod2pos(self, "patternMarkVisitor", &meth_ast_patternMarkVisitor7889, 41);
int argcv_meth_ast_patternMarkVisitor7889[] = {0};
meth_meth_ast_patternMarkVisitor7889->type = alloc_MethodType(1, argcv_meth_ast_patternMarkVisitor7889);
  meth_meth_ast_patternMarkVisitor7889->definitionModule = modulename;
  meth_meth_ast_patternMarkVisitor7889->definitionLine = 1860;
// compilenode returning 
// compilenode returning done
// compilenode returning 
// Begin line 2031
  setline(2031);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 2044
  setline(2044);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
  gc_frame_end(frame);
  return self;
}
